package org.apache.torque.test;

import java.io.Serializable;
import java.sql.Connection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.apache.torque.TorqueException;
import org.apache.torque.map.TableMap;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.BooleanKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.om.ColumnAccessByName;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.util.Transaction;
import org.apache.commons.lang.ObjectUtils;


/**
 * B table
 *
 * This class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:38 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to B
 */
public abstract class BaseB 
    implements Persistent, Serializable, ColumnAccessByName
{
    /** Serial version */
    private static final long serialVersionUID = 1347503738198L;



    /** Defines the bId field. */
    private int bId = 0;

    /** Defines the name field. */
    private String name = null;

    /** Whether this object was modified after loading or after last save. */
    private boolean modified = true;

    /** 
     * Whether this object was loaded from the database or already saved 
     * (false) or whether it is not yet in the database(true).
     */
    private boolean isNew = true;

    /** Flag which indicates whether this object is currently saving. */
    private boolean saving = false;

    /** 
     * Flag which indicates whether this object is currently loaded
     * from the database. 
     */
    private boolean loading = false;

    /** 
     * Flag which indicates whether this object was deleted from the database.
     * Note that this flags does not always display the current database state,
     * there is no magical connection between this flag and the database.
     */
    private boolean deleted = false;



    /** Defines the collRAbs field. */
    protected List<RAb> collRAbs = null;

    /** Defines the collCs field. */
    protected List<C> collCs = null;



    /**
     * Get the value of bId.
     *
     * @return int
     */
    public int getBId() 
    {
        
        return bId;
    }

    /**
     * Set the value of bId.
     *
     * @param v new value
     */
    public void setBId(int v)
    {
        if (this.bId != v)
        {
            setModified(true);
        }

        this.bId = v;

        // update associated objects in collRAbs 
        if (collRAbs != null)
        {
            for (int i = 0; i < collRAbs.size(); i++)
            {
                ((RAb) collRAbs.get(i))
                        .setBId(v);
            }
        }
        // update associated objects in collCs 
        if (collCs != null)
        {
            for (int i = 0; i < collCs.size(); i++)
            {
                ((C) collCs.get(i))
                        .setBId(v);
            }
        }

    }
    
    /**
     * Get the value of name.
     *
     * @return String
     */
    public String getName() 
    {
        
        return name;
    }

    /**
     * Set the value of name.
     *
     * @param v new value
     */
    public void setName(String v)
    {
        if (!ObjectUtils.equals(this.name, v))
        {
            setModified(true);
        }

        this.name = v;


    }
    

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return true, if the object has never been persisted.
     */
    public boolean isNew()
    {
        return isNew;
    }

    /**
     * Sets whether the object has ever been saved.
     *
     * @param isNew true if the object has never been saved, false otherwise.
     */
    public void setNew(boolean isNew)
    {
        this.isNew = isNew;
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return True if the object has been modified.
     */
    public boolean isModified()
    {
        return modified;
    }

    /**
     * Sets whether the object has been modified.
     *
     * @param modified true if the object has been modified, false otherwise.
     */
    public void setModified(boolean modified)
    {
        this.modified = modified;
    }

    /**
     * Sets the modified state for the object to be false.
     */
    public void resetModified()
    {
        modified = false;
    }


    /**
     * Returns whether this object is currently saving.
     *
     * @return true if this object is currently saving, false otherwise.
     */
    public boolean isSaving()
    {
        return saving;
    }

    /**
     * Sets whether this object is currently saving.
     *
     * @param saving true if this object is currently saving, false otherwise.
     */
    public void setSaving(boolean saving)
    {
        this.saving = saving;
    }


    /**
     * Returns whether this object is currently being loaded from the database.
     *
     * @return true if this object is currently loading, false otherwise.
     */
    public boolean isLoading()
    {
        return loading;
    }

    /**
     * Sets whether this object is currently being loaded from the database.
     *
     * @param loading true if this object is currently loading, false otherwise.
     */
    public void setLoading(boolean loading)
    {
        this.loading = loading;
    }


    /**
     * Returns whether this object was deleted from the database.
     * Note that this getter does not automatically reflect database state,
     * it will be set to true by Torque if doDelete() was called with this 
     * object. Bulk deletes and deletes via primary key do not change
     * this flag. Also, if doDelete() was called on an object which does
     * not exist in the database, the deleted flag is set to true even if
     * it was not deleted.
     *
     * @return true if this object was deleted, false otherwise.
     */
    public boolean isDeleted()
    {
        return deleted;
    }

    /**
     * Sets whether this object was deleted from the database.
     *
     * @param deleted true if this object was deleted, false otherwise.
     */
    public void setDeleted(boolean deleted)
    {
        this.deleted = deleted;
    }




    /**
     * Initializes the cache collRAbs for referenced objects. 
     */
    public void initRAbs()
    {
        if (collRAbs == null)
        {
            collRAbs = new ArrayList<RAb>();
        }
    }

    /**
     * Checks whether the cache collRAbs for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isRAbsInitialized()
    {
        return (collRAbs != null);
    }


    /**
     * Method called to associate a RAb object to this object
     * through the collRAbs foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addRAb(RAb toAdd)
        throws TorqueException
    {
        toAdd.setB((B) this);
        getRAbs().add(toAdd);
    }

    /**
     * Method called to associate a RAb object to this object
     * through the collRAbs foreign key attribute using connection.
     *
     * @param l RAb
     * @throws TorqueException
     */
    public void addRAb(RAb l, Connection con) throws TorqueException
    {
        getRAbs(con).add(l);
        l.setB((B) this);
    }
    
    /**
     * The criteria used to select the current contents of collRAbs
     */
    private Criteria lastRAbCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getRAbs(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<RAb> getRAbs()
        throws TorqueException
    {
        if (collRAbs == null)
        {
            collRAbs = getRAbs(new Criteria());
        }
        return collRAbs;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseB has previously
     * been saved, it will retrieve related collRAbs from storage.
     * If this BaseB is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<RAb> getRAbs(Criteria criteria) throws TorqueException
    {
        if (collRAbs == null)
        {
            if (isNew())
            {
               initRAbs();
            }
            else
            {
                criteria.and(org.apache.torque.test.RAbPeer.B_ID, getBId() );
                collRAbs = org.apache.torque.test.RAbPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.RAbPeer.B_ID, getBId() );
                if (lastRAbCriteria == null 
                        || !lastRAbCriteria.equals(criteria))
                {
                    collRAbs = org.apache.torque.test.RAbPeer.doSelect(criteria);
                }
            }
        }
        lastRAbCriteria = criteria;

        return collRAbs;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getRAbs(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<RAb> getRAbs(Connection con) throws TorqueException
    {
        if (collRAbs == null)
        {
            collRAbs = getRAbs(new Criteria(), con);
        }
        return collRAbs;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseB has previously
     * been saved, it will retrieve the related RAb Objects 
     * from storage.
     * If this BaseB is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<RAb> getRAbs(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collRAbs == null)
        {
            if (isNew())
            {
               initRAbs();
            }
            else
            {
                criteria.and(org.apache.torque.test.RAbPeer.B_ID, getBId());
                collRAbs = org.apache.torque.test.RAbPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.RAbPeer.B_ID, getBId());
                if (!lastRAbCriteria.equals(criteria))
                {
                    collRAbs = org.apache.torque.test.RAbPeer.doSelect(criteria, con);
                }
            }
        }
        lastRAbCriteria = criteria;

        return collRAbs;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseB is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<RAb> getRAbsJoinB(Criteria criteria) throws TorqueException
    {
        return getRAbsJoinB(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseB is new, it will return
     * an empty collection; or if this BaseB has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<RAb> getRAbsJoinB(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collRAbs == null)
        {
            if (isNew())
            {
                initRAbs();
            }
            else
            {
                criteria.and(org.apache.torque.test.RAbPeer.B_ID, getBId() );
                collRAbs = org.apache.torque.test.RAbPeer.doSelectJoinB(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.RAbPeer.B_ID, getBId() );
            if (!lastRAbCriteria.equals(criteria))
            {
                collRAbs = org.apache.torque.test.RAbPeer.doSelectJoinB(criteria, connection);
            }
        }
        lastRAbCriteria = criteria;

        return collRAbs;
    }

    /**
     * Initializes the cache collCs for referenced objects. 
     */
    public void initCs()
    {
        if (collCs == null)
        {
            collCs = new ArrayList<C>();
        }
    }

    /**
     * Checks whether the cache collCs for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isCsInitialized()
    {
        return (collCs != null);
    }


    /**
     * Method called to associate a C object to this object
     * through the collCs foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addC(C toAdd)
        throws TorqueException
    {
        toAdd.setB((B) this);
        getCs().add(toAdd);
    }

    /**
     * Method called to associate a C object to this object
     * through the collCs foreign key attribute using connection.
     *
     * @param l C
     * @throws TorqueException
     */
    public void addC(C l, Connection con) throws TorqueException
    {
        getCs(con).add(l);
        l.setB((B) this);
    }
    
    /**
     * The criteria used to select the current contents of collCs
     */
    private Criteria lastCCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getCs(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<C> getCs()
        throws TorqueException
    {
        if (collCs == null)
        {
            collCs = getCs(new Criteria());
        }
        return collCs;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseB has previously
     * been saved, it will retrieve related collCs from storage.
     * If this BaseB is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<C> getCs(Criteria criteria) throws TorqueException
    {
        if (collCs == null)
        {
            if (isNew())
            {
               initCs();
            }
            else
            {
                criteria.and(org.apache.torque.test.CPeer.B_ID, getBId() );
                collCs = org.apache.torque.test.CPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.CPeer.B_ID, getBId() );
                if (lastCCriteria == null 
                        || !lastCCriteria.equals(criteria))
                {
                    collCs = org.apache.torque.test.CPeer.doSelect(criteria);
                }
            }
        }
        lastCCriteria = criteria;

        return collCs;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getCs(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<C> getCs(Connection con) throws TorqueException
    {
        if (collCs == null)
        {
            collCs = getCs(new Criteria(), con);
        }
        return collCs;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseB has previously
     * been saved, it will retrieve the related C Objects 
     * from storage.
     * If this BaseB is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<C> getCs(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collCs == null)
        {
            if (isNew())
            {
               initCs();
            }
            else
            {
                criteria.and(org.apache.torque.test.CPeer.B_ID, getBId());
                collCs = org.apache.torque.test.CPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.CPeer.B_ID, getBId());
                if (!lastCCriteria.equals(criteria))
                {
                    collCs = org.apache.torque.test.CPeer.doSelect(criteria, con);
                }
            }
        }
        lastCCriteria = criteria;

        return collCs;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseB is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<C> getCsJoinB(Criteria criteria) throws TorqueException
    {
        return getCsJoinB(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseB is new, it will return
     * an empty collection; or if this BaseB has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<C> getCsJoinB(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collCs == null)
        {
            if (isNew())
            {
                initCs();
            }
            else
            {
                criteria.and(org.apache.torque.test.CPeer.B_ID, getBId() );
                collCs = org.apache.torque.test.CPeer.doSelectJoinB(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.CPeer.B_ID, getBId() );
            if (!lastCCriteria.equals(criteria))
            {
                collCs = org.apache.torque.test.CPeer.doSelectJoinB(criteria, connection);
            }
        }
        lastCCriteria = criteria;

        return collCs;
    }




    private static final List<String> FIELD_NAMES;

    static
    {
        List<String> fieldNames
                = new ArrayList<String>();
        fieldNames.add("BId");
        fieldNames.add("Name");
        FIELD_NAMES = Collections.unmodifiableList(fieldNames);
    }

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static List<String> getFieldNames()
    {
        return FIELD_NAMES;
    }

    /**
     * Retrieves a field from the object by field (Java) name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
        if (name.equals("BId"))
        {
            return new Integer(getBId());
        }
        if (name.equals("Name"))
        {
            return getName();
        }
        return null;
    }

    /**
     * Set a field in the object by field (Java) name.
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (name.equals("BId"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setBId(((Integer) value).intValue());
            return true;
        }
        if (name.equals("Name"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setName((String) value);
            return true;
        }
        return false;
    }

    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
        if (name.equals(org.apache.torque.test.BPeer.B_ID))
        {
            return new Integer(getBId());
        }
        if (name.equals(org.apache.torque.test.BPeer.NAME))
        {
            return getName();
        }
        return null;
    }

    /**
     * Set field values by Peer Field Name
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPeerName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (org.apache.torque.test.BPeer.B_ID.getSqlExpression().equals(name))
        {
            return setByName("BId", value);
        }
        if (org.apache.torque.test.BPeer.NAME.getSqlExpression().equals(name))
        {
            return setByName("Name", value);
        }
        return false;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
        if (pos == 0)
        {
            return new Integer(getBId());
        }
        if (pos == 1)
        {
            return getName();
        }
        return null;
    }

    /**
     * Set field values by its position (zero based) in the XML schema.
     *
     * @param position The field position
     * @param value field value
     * @return True if value was set, false if not (invalid position / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPosition(int position, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (position == 0)
        {
            return setByName("BId", value);
        }
        if (position == 1)
        {
            return setByName("Name", value);
        }
        return false;
    }



    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save() throws TorqueException
    {
        save(BPeer.DATABASE_NAME);
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     * @param dbName the name of the database to which the object
     *        should be saved.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(String dbName) 
            throws TorqueException
    {
        Connection con = null;
        try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally.
     *
     * @param toSave the object to be saved, not null.
     * @param con the connection to use for saving the object, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(Connection con) 
            throws TorqueException
    {
        if (isSaving())
        {
            return;
        }
        try
        {
            setSaving(true);
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    BPeer.doInsert((B) this, con);
                    setNew(false);
                }
                else
                {
                    BPeer.doUpdate((B) this, con);
                }
            }

            if (isRAbsInitialized())
            {
                for (RAb collRAbs : getRAbs())
                {
                    collRAbs.save(con);
                }
            }
            if (isCsInitialized())
            {
                for (C collCs : getCs())
                {
                    collCs.save(con);
                }
            }
        }
        finally
        {
            setSaving(false);
        }
    }




    /**
     * Set the PrimaryKey using ObjectKey.
     *
     * @param key bId ObjectKey
     */
    public void setPrimaryKey(ObjectKey key)
        
    {
        setBId(((NumberKey) key).intValue());
    }

    /**
     * Set the PrimaryKey using a String.
     *
     * @param key
     */
    public void setPrimaryKey(String key) 
    {
        setBId(Integer.parseInt(key));
    }


    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        return SimpleKey.keyFor(getBId());
    }



    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public B copy() throws TorqueException
    {
        return copy(true);
    }

    /**
     * Makes a copy of this object using a connection.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     *
     * @param con the database connection to read associated objects.
     */
    public B copy(Connection con) throws TorqueException
    {
        return copy(true, con);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     */
    public B copy(boolean deepcopy) throws TorqueException
    {
        B b = new B();

        return copyInto(b, deepcopy);
    }

    /**
     * Makes a copy of this object using connection.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @param con the database connection to read associated objects.
     */
    public B copy(boolean deepcopy, Connection con) throws TorqueException
    {
        B b = new B();

        return copyInto(b, deepcopy, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     */
    protected B copyInto(B copyObj) throws TorqueException
    {
        return copyInto(copyObj, true);
    }

    /**
     * Fills the copyObj with the contents of this object using connection.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param con the database connection to read associated objects.
     */
    protected B copyInto(B copyObj, Connection con) throws TorqueException
    {
        return copyInto(copyObj, true, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     */
    protected B copyInto(B copyObj, boolean deepcopy) throws TorqueException
    {
        copyObj.setBId(0);
        copyObj.setName(name);

        if (deepcopy)
        {
            if (collRAbs != null)
            {
                for (int i = 0; i < collRAbs.size(); i++)
                {
                    RAb obj = collRAbs.get(i);
                    copyObj.addRAb(obj.copy());
                }
            }
            else
            {
                copyObj.collRAbs = null;
            }
            if (collCs != null)
            {
                for (int i = 0; i < collCs.size(); i++)
                {
                    C obj = collCs.get(i);
                    copyObj.addC(obj.copy());
                }
            }
            else
            {
                copyObj.collCs = null;
            }
        }
        return copyObj;
    }
        
    
    /**
     * Fills the copyObj with the contents of this object using connection.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @param con the database connection to read associated objects.
     */
    protected B copyInto(B copyObj, boolean deepcopy, Connection con) throws TorqueException
    {
        copyObj.setBId(0);
        copyObj.setName(name);

        if (deepcopy)
        {
            for (RAb obj : getRAbs(con))
            {
                copyObj.addRAb(obj.copy());
            }
            for (C obj : getCs(con))
            {
                copyObj.addC(obj.copy());
            }
        }
        return copyObj;
    }

    /** The Peer class */
    private static final org.apache.torque.test.BPeer peer
            = new org.apache.torque.test.BPeer();

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public org.apache.torque.test.BPeer getPeer()
    {
        return peer;
    }

    /**
     * Retrieves the TableMap object related to this Table data without
     * compiler warnings of using getPeer().getTableMap().
     *
     * @return The associated TableMap object.
     */
    public TableMap getTableMap() throws TorqueException
    {
        return org.apache.torque.test.BPeer.getTableMap();
    }



    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("B:\n");
        str.append("bId = ")
           .append(getBId())
           .append("\n");
        str.append("name = ")
           .append(getName())
           .append("\n");
        return(str.toString());
    }

    /**
     * Compares the primary key of this instance with the key of another.
     *
     * @param toCompare The object to compare to.
     * @return Whether the primary keys are equal and the object have the
     *         same class.
     */
    public boolean equals(Object toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!getClass().equals(toCompare.getClass()))
        {
            return false;
        }
        B other = (B) toCompare;
        if (getPrimaryKey() == null || other.getPrimaryKey() == null)
        {
            return false;
        }
        return getPrimaryKey().equals(other.getPrimaryKey());
    }

    /**
     * If the primary key is not <code>null</code>, return the hashcode of the
     * primary key.  Otherwise calls <code>Object.hashCode()</code>.
     *
     * @return an <code>int</code> value
     */
    public int hashCode()
    {
        ObjectKey ok = getPrimaryKey();
        if (ok == null)
        {
            return super.hashCode();
        }

        return ok.hashCode();
    }




}
