package org.apache.torque.test;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.torque.NoRowsException;
import org.apache.torque.TooManyRowsException;
import org.apache.torque.Column;
import org.apache.torque.Torque;
import org.apache.torque.TorqueException;
import org.apache.torque.TorqueRuntimeException;
import org.apache.torque.adapter.IDMethod;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.map.DatabaseMap;
import org.apache.torque.map.TableMap;
import org.apache.torque.map.ColumnMap;
import org.apache.torque.map.ForeignKeyMap;
import org.apache.torque.map.InheritanceMap;
import org.apache.torque.om.mapper.RecordMapper;
import org.apache.torque.om.mapper.CompositeMapper;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.util.BasePeer;
import org.apache.torque.util.Transaction;
import org.apache.torque.util.ColumnValues;
import org.apache.torque.util.JdbcTypedValue;



/**
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:44 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to BaseTablePeer
 */
@SuppressWarnings({"unused", "unchecked"})
public abstract class BaseBaseTablePeer
{
    /** The class log. */
    private static Log log = LogFactory.getLog(BaseBaseTablePeerImpl.class);
    /** Serial version */
    private static final long serialVersionUID = 1347503744251L;


    /** The default database name for this class. */
    public static final String DATABASE_NAME;

     /** The table name for this class. */
    public static final String TABLE_NAME;

     /** The table map for this class. */
    public static final TableMap TABLE;
    /** The column for the BASE_ID_CODE field */
    public static final ColumnMap BASE_ID_CODE;
    /** The column for the BASE_NAME field */
    public static final ColumnMap BASE_NAME;
    /** The column for the BASE_STATE_CODE field */
    public static final ColumnMap BASE_STATE_CODE;
    /** The column for the BASE_ZIP_CODE field */
    public static final ColumnMap BASE_ZIP_CODE;
    /** The column for the DATA_MODIFIED_ID_CODE field */
    public static final ColumnMap DATA_MODIFIED_ID_CODE;
    /** The column for the DATA_MODIFIED_DATE field */
    public static final ColumnMap DATA_MODIFIED_DATE;
    /** The column for the DATA_CREATOR_ID_CODE field */
    public static final ColumnMap DATA_CREATOR_ID_CODE;
    /** The column for the DATA_CREATOR_DATE field */
    public static final ColumnMap DATA_CREATOR_DATE;
    /** The column for the DATA_TRANSFER_CODE field */
    public static final ColumnMap DATA_TRANSFER_CODE;
    /** The column for the BASE_ADDRESS_TEXT field */
    public static final ColumnMap BASE_ADDRESS_TEXT;
    /** The column for the BASE_TYPE_TEXT field */
    public static final ColumnMap BASE_TYPE_TEXT;
    /** The column for the START_DATE field */
    public static final ColumnMap START_DATE;
    /** The column for the END_DATE field */
    public static final ColumnMap END_DATE;

    /** number of columns for this peer */
    public static final int numColumns = 13;


    /** The implementation of the peer. */
    private static BaseTablePeerImpl baseTablePeerImpl;


    static
    {
        DatabaseMap dbMap = Torque.getOrCreateDatabase("bookstore")
                .getDatabaseMap();
        if (dbMap.getTable("BASE") == null)
        {
            dbMap.addTable("BASE");
        }
        DATABASE_NAME = "bookstore";
        TABLE_NAME = "BASE";

        TABLE = dbMap.getTable("BASE");
        TABLE.setJavaName("BaseTable");
        TABLE.setOMClass(org.apache.torque.test.BaseTable.class);
        TABLE.setPeerClass(org.apache.torque.test.BaseTablePeer.class);
        TABLE.setPrimaryKeyMethod(IDMethod.NO_ID_METHOD);
        TABLE.setPrimaryKeyMethodInfo(IDMethod.ID_BROKER, TABLE.getName());
        TABLE.setPrimaryKeyMethodInfo(IDMethod.SEQUENCE, "$sequenceName");
        TABLE.setPrimaryKeyMethodInfo(IDMethod.AUTO_INCREMENT, "BASE");
        TABLE.setUseInheritance(true);


    // ------------- Column: BASE_ID_CODE --------------------
        BASE_ID_CODE = new ColumnMap("BASE_ID_CODE", TABLE);
        BASE_ID_CODE.setType(new java.math.BigDecimal((double) 0));
        BASE_ID_CODE.setTorqueType("DECIMAL");
        BASE_ID_CODE.setUsePrimitive(false);
        BASE_ID_CODE.setPrimaryKey(true);
        BASE_ID_CODE.setNotNull(true);
        BASE_ID_CODE.setJavaName("Id");
        BASE_ID_CODE.setAutoIncrement(false);
        BASE_ID_CODE.setProtected(false);
        BASE_ID_CODE.setJavaType( "java.math.BigDecimal" );
        BASE_ID_CODE.setSize(22);
        BASE_ID_CODE.setPosition(1);
        TABLE.addColumn(BASE_ID_CODE);
    // ------------- Column: BASE_NAME --------------------
        BASE_NAME = new ColumnMap("BASE_NAME", TABLE);
        BASE_NAME.setType("");
        BASE_NAME.setTorqueType("VARCHAR");
        BASE_NAME.setUsePrimitive(false);
        BASE_NAME.setPrimaryKey(false);
        BASE_NAME.setNotNull(false);
        BASE_NAME.setJavaName("Title");
        BASE_NAME.setAutoIncrement(false);
        BASE_NAME.setProtected(false);
        BASE_NAME.setJavaType( "String" );
        BASE_NAME.setSize(100);
        BASE_NAME.setPosition(2);
        TABLE.addColumn(BASE_NAME);
    // ------------- Column: BASE_STATE_CODE --------------------
        BASE_STATE_CODE = new ColumnMap("BASE_STATE_CODE", TABLE);
        BASE_STATE_CODE.setType("");
        BASE_STATE_CODE.setTorqueType("VARCHAR");
        BASE_STATE_CODE.setUsePrimitive(false);
        BASE_STATE_CODE.setPrimaryKey(false);
        BASE_STATE_CODE.setNotNull(false);
        BASE_STATE_CODE.setJavaName("BaseStateCode");
        BASE_STATE_CODE.setAutoIncrement(false);
        BASE_STATE_CODE.setProtected(false);
        BASE_STATE_CODE.setJavaType( "String" );
        BASE_STATE_CODE.setSize(2);
        BASE_STATE_CODE.setPosition(3);
        TABLE.addColumn(BASE_STATE_CODE);
    // ------------- Column: BASE_ZIP_CODE --------------------
        BASE_ZIP_CODE = new ColumnMap("BASE_ZIP_CODE", TABLE);
        BASE_ZIP_CODE.setType("");
        BASE_ZIP_CODE.setTorqueType("VARCHAR");
        BASE_ZIP_CODE.setUsePrimitive(false);
        BASE_ZIP_CODE.setPrimaryKey(false);
        BASE_ZIP_CODE.setNotNull(false);
        BASE_ZIP_CODE.setJavaName("BaseZipCode");
        BASE_ZIP_CODE.setAutoIncrement(false);
        BASE_ZIP_CODE.setProtected(false);
        BASE_ZIP_CODE.setJavaType( "String" );
        BASE_ZIP_CODE.setSize(10);
        BASE_ZIP_CODE.setPosition(4);
        TABLE.addColumn(BASE_ZIP_CODE);
    // ------------- Column: DATA_MODIFIED_ID_CODE --------------------
        DATA_MODIFIED_ID_CODE = new ColumnMap("DATA_MODIFIED_ID_CODE", TABLE);
        DATA_MODIFIED_ID_CODE.setType(new java.math.BigDecimal((double) 0));
        DATA_MODIFIED_ID_CODE.setTorqueType("DECIMAL");
        DATA_MODIFIED_ID_CODE.setUsePrimitive(false);
        DATA_MODIFIED_ID_CODE.setPrimaryKey(false);
        DATA_MODIFIED_ID_CODE.setNotNull(false);
        DATA_MODIFIED_ID_CODE.setJavaName("DataModifiedIdCode");
        DATA_MODIFIED_ID_CODE.setAutoIncrement(false);
        DATA_MODIFIED_ID_CODE.setProtected(false);
        DATA_MODIFIED_ID_CODE.setJavaType( "java.math.BigDecimal" );
        DATA_MODIFIED_ID_CODE.setSize(22);
        DATA_MODIFIED_ID_CODE.setPosition(5);
        TABLE.addColumn(DATA_MODIFIED_ID_CODE);
    // ------------- Column: DATA_MODIFIED_DATE --------------------
        DATA_MODIFIED_DATE = new ColumnMap("DATA_MODIFIED_DATE", TABLE);
        DATA_MODIFIED_DATE.setType(new Date());
        DATA_MODIFIED_DATE.setTorqueType("TIMESTAMP");
        DATA_MODIFIED_DATE.setUsePrimitive(false);
        DATA_MODIFIED_DATE.setPrimaryKey(false);
        DATA_MODIFIED_DATE.setNotNull(false);
        DATA_MODIFIED_DATE.setJavaName("DataModifiedDate");
        DATA_MODIFIED_DATE.setAutoIncrement(false);
        DATA_MODIFIED_DATE.setProtected(false);
        DATA_MODIFIED_DATE.setJavaType( "java.util.Date" );
        DATA_MODIFIED_DATE.setPosition(6);
        TABLE.addColumn(DATA_MODIFIED_DATE);
    // ------------- Column: DATA_CREATOR_ID_CODE --------------------
        DATA_CREATOR_ID_CODE = new ColumnMap("DATA_CREATOR_ID_CODE", TABLE);
        DATA_CREATOR_ID_CODE.setType(new java.math.BigDecimal((double) 0));
        DATA_CREATOR_ID_CODE.setTorqueType("DECIMAL");
        DATA_CREATOR_ID_CODE.setUsePrimitive(false);
        DATA_CREATOR_ID_CODE.setPrimaryKey(false);
        DATA_CREATOR_ID_CODE.setNotNull(false);
        DATA_CREATOR_ID_CODE.setJavaName("DataCreatorIdCode");
        DATA_CREATOR_ID_CODE.setAutoIncrement(false);
        DATA_CREATOR_ID_CODE.setProtected(false);
        DATA_CREATOR_ID_CODE.setJavaType( "java.math.BigDecimal" );
        DATA_CREATOR_ID_CODE.setSize(22);
        DATA_CREATOR_ID_CODE.setPosition(7);
        TABLE.addColumn(DATA_CREATOR_ID_CODE);
    // ------------- Column: DATA_CREATOR_DATE --------------------
        DATA_CREATOR_DATE = new ColumnMap("DATA_CREATOR_DATE", TABLE);
        DATA_CREATOR_DATE.setType(new Date());
        DATA_CREATOR_DATE.setTorqueType("TIMESTAMP");
        DATA_CREATOR_DATE.setUsePrimitive(false);
        DATA_CREATOR_DATE.setPrimaryKey(false);
        DATA_CREATOR_DATE.setNotNull(false);
        DATA_CREATOR_DATE.setJavaName("DataCreatorDate");
        DATA_CREATOR_DATE.setAutoIncrement(false);
        DATA_CREATOR_DATE.setProtected(false);
        DATA_CREATOR_DATE.setJavaType( "java.util.Date" );
        DATA_CREATOR_DATE.setPosition(8);
        TABLE.addColumn(DATA_CREATOR_DATE);
    // ------------- Column: DATA_TRANSFER_CODE --------------------
        DATA_TRANSFER_CODE = new ColumnMap("DATA_TRANSFER_CODE", TABLE);
        DATA_TRANSFER_CODE.setType("");
        DATA_TRANSFER_CODE.setTorqueType("VARCHAR");
        DATA_TRANSFER_CODE.setUsePrimitive(false);
        DATA_TRANSFER_CODE.setPrimaryKey(false);
        DATA_TRANSFER_CODE.setNotNull(false);
        DATA_TRANSFER_CODE.setJavaName("DataTransferCode");
        DATA_TRANSFER_CODE.setAutoIncrement(false);
        DATA_TRANSFER_CODE.setProtected(false);
        DATA_TRANSFER_CODE.setJavaType( "String" );
        DATA_TRANSFER_CODE.setSize(1);
        DATA_TRANSFER_CODE.setPosition(9);
        TABLE.addColumn(DATA_TRANSFER_CODE);
    // ------------- Column: BASE_ADDRESS_TEXT --------------------
        BASE_ADDRESS_TEXT = new ColumnMap("BASE_ADDRESS_TEXT", TABLE);
        BASE_ADDRESS_TEXT.setType("");
        BASE_ADDRESS_TEXT.setTorqueType("LONGVARCHAR");
        BASE_ADDRESS_TEXT.setUsePrimitive(false);
        BASE_ADDRESS_TEXT.setPrimaryKey(false);
        BASE_ADDRESS_TEXT.setNotNull(false);
        BASE_ADDRESS_TEXT.setJavaName("BaseAddressText");
        BASE_ADDRESS_TEXT.setAutoIncrement(false);
        BASE_ADDRESS_TEXT.setProtected(false);
        BASE_ADDRESS_TEXT.setJavaType( "String" );
        BASE_ADDRESS_TEXT.setSize(2000);
        BASE_ADDRESS_TEXT.setPosition(10);
        TABLE.addColumn(BASE_ADDRESS_TEXT);
    // ------------- Column: BASE_TYPE_TEXT --------------------
        BASE_TYPE_TEXT = new ColumnMap("BASE_TYPE_TEXT", TABLE);
        BASE_TYPE_TEXT.setType("");
        BASE_TYPE_TEXT.setTorqueType("VARCHAR");
        BASE_TYPE_TEXT.setUsePrimitive(false);
        BASE_TYPE_TEXT.setPrimaryKey(false);
        BASE_TYPE_TEXT.setNotNull(false);
        BASE_TYPE_TEXT.setJavaName("BaseTypeText");
        BASE_TYPE_TEXT.setAutoIncrement(false);
        BASE_TYPE_TEXT.setProtected(false);
        BASE_TYPE_TEXT.setJavaType( "String" );
        BASE_TYPE_TEXT.setSize(100);
        BASE_TYPE_TEXT.setPosition(11);
        TABLE.addColumn(BASE_TYPE_TEXT);
    // ------------- Column: START_DATE --------------------
        START_DATE = new ColumnMap("START_DATE", TABLE);
        START_DATE.setType(new Date());
        START_DATE.setTorqueType("TIMESTAMP");
        START_DATE.setUsePrimitive(false);
        START_DATE.setPrimaryKey(false);
        START_DATE.setNotNull(false);
        START_DATE.setJavaName("StartDate");
        START_DATE.setAutoIncrement(false);
        START_DATE.setProtected(false);
        START_DATE.setJavaType( "java.util.Date" );
        START_DATE.setPosition(12);
        TABLE.addColumn(START_DATE);
    // ------------- Column: END_DATE --------------------
        END_DATE = new ColumnMap("END_DATE", TABLE);
        END_DATE.setType(new Date());
        END_DATE.setTorqueType("TIMESTAMP");
        END_DATE.setUsePrimitive(false);
        END_DATE.setPrimaryKey(false);
        END_DATE.setNotNull(false);
        END_DATE.setJavaName("EndDate");
        END_DATE.setAutoIncrement(false);
        END_DATE.setProtected(false);
        END_DATE.setJavaType( "java.util.Date" );
        END_DATE.setPosition(13);
        TABLE.addColumn(END_DATE);



        initDatabaseMap();
    }

    /**
     * Creates a new instance of the  implementation of the peer.
     *
     * @return the new instance.
     */
    protected static BaseTablePeerImpl createBaseTablePeerImpl()
    {
        BaseTablePeerImpl instance = new BaseTablePeerImpl();
        return instance;
    }


    /**
     * Returns an instance of the implementation of the peer.
     * If no instance is currently cached, a new instance is created and cached.
     *
     * @return an instance of the implementation of the peer, not null.
     */
    public static BaseTablePeerImpl getBaseTablePeerImpl()
    {
        BaseTablePeerImpl peerImplInstance = baseTablePeerImpl;
        if (peerImplInstance == null)
        {
            peerImplInstance = BaseTablePeer.createBaseTablePeerImpl();
            baseTablePeerImpl = peerImplInstance;
        }
        return peerImplInstance;
    }



    /**
     * Sets the instance of the implementation of the peer.
     *
     * @param an instance of the implementation of the peer, or null
     *        if a new instance should be created automatically.
     */
    public static void setBaseTablePeerImpl(BaseTablePeerImpl peerImplInstance)
    {
        baseTablePeerImpl = peerImplInstance;
    }


    /**
     * Get the list of objects for a ResultSet.  Please not that your
     * resultset MUST return columns in the right order.  You can use
     * getFieldNames() in BaseObject to get the correct sequence.
     *
     * @param resultSet the ResultSet
     * @return the list of objects
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<BaseTable> resultSet2Objects(ResultSet resultSet)
            throws TorqueException
    {
        return getBaseTablePeerImpl().resultSet2Objects(resultSet);
    }

    /**
     * Add all the columns needed to create a new object.
     *
     * @param criteria object containing the columns to add.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void addSelectColumns(Criteria criteria)
            throws TorqueException
    {
        getBaseTablePeerImpl().addSelectColumns(criteria);
    }

    /**
     * changes the boolean values in the criteria to the appropriate type,
     * whenever a booleanchar or booleanint column is involved.
     * This enables the user to create criteria using Boolean values
     * for booleanchar or booleanint columns.
     *
     * @param criteria the criteria in which the boolean values
     *        should be corrected.
     *
     * @throws TorqueException if the database map for the criteria cannot be 
               obtained.
     */
    public static void correctBooleans(Criteria criteria) throws TorqueException
    {
        getBaseTablePeerImpl().correctBooleans(criteria);
    }

    /**
     * Checks all columns in the criteria to see whether
     * booleanchar and booleanint columns are queried with a boolean.
     * If yes, the query values are mapped onto values the database
     * does understand, i.e. 0 and 1 for booleanints and N and Y for
     * booleanchar columns.
     *
     * @param columnValues The value to be checked for booleanint
     *        and booleanchar columns.
     * @throws TorqueException if the database map for the criteria cannot be
     *         retrieved.
     */
    public static void correctBooleans(
            ColumnValues columnValues)
        throws TorqueException
    {
        getBaseTablePeerImpl().correctBooleans(columnValues);
    }
    
    /**
     * Selects BaseTable objects from a database.
     *
     * @param criteria object used to create the SELECT statement.
     *
     * @return the list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<BaseTable> doSelect(Criteria criteria)
            throws TorqueException
    {
        return getBaseTablePeerImpl().doSelect(criteria);
    }

    /**
     * Selects BaseTable objects from a database
     * within a transaction.
     *
     * @param criteria object used to create the SELECT statement.
     * @param connection the connection holding the transaction, not null.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<BaseTable> doSelect(
                Criteria criteria,
                Connection connection)
            throws TorqueException
    {
        return getBaseTablePeerImpl().doSelect(criteria, connection);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                Criteria criteria,
                RecordMapper<T> mapper)
            throws TorqueException
    {
        return getBaseTablePeerImpl().doSelect(criteria, mapper);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection for selecting records,
     *        not null.
     *
     * @return The results of the query, not null.
     * @throws TorqueException Error performing database query.
     */
    public static <T> List<T> doSelect(
            Criteria criteria,
            RecordMapper<T> mapper,
            Connection connection)
        throws TorqueException
    {
        return getBaseTablePeerImpl().doSelect(
                criteria,
                mapper,
                connection);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param query the sql query to execute, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param dbName The name of the database to create the connection for,
     *        or null for the default SDB.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                String query,
                RecordMapper<T> mapper,
                String dbName)
            throws TorqueException
    {
        return getBaseTablePeerImpl().doSelect(
                query,
                mapper,
                dbName);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param query the SQL Query to execute, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection, not null.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                String query,
                RecordMapper<T> mapper,
                Connection connection)
            throws TorqueException
    {
        return getBaseTablePeerImpl().doSelect(
                query,
                mapper,
                connection);
    }

    /**
     * Selects BaseTable objects from the database which have
     * the same content as the passed object.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<BaseTable> doSelect(BaseTable obj)
            throws TorqueException
    {
        return getBaseTablePeerImpl().doSelect(obj);
    }

    /**
     * Selects at most one BaseTable object from a database.
     *
     * @param criteria object used to create the SELECT statement.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static BaseTable doSelectSingleRecord(
                Criteria criteria)
            throws TorqueException
    {
        return getBaseTablePeerImpl().doSelectSingleRecord(criteria);
    }

    /**
     * Selects at most one BaseTable object from a database
     * within a transaction.
     *
     * @param criteria object used to create the SELECT statement.
     * @param connection the connection holding the transaction, not null.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static BaseTable doSelectSingleRecord(
                Criteria criteria,
                Connection connection)
            throws TorqueException
    {
        return getBaseTablePeerImpl().doSelectSingleRecord(criteria, connection);
    }

    /**
     * Selects at most a single row from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     *
     * @return The selected row, or null if no records was selected.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> T doSelectSingleRecord(
                org.apache.torque.criteria.Criteria criteria,
                RecordMapper<T> mapper)
            throws TorqueException
    {
        return getBaseTablePeerImpl().doSelectSingleRecord(
                criteria,
                mapper);
    }

    /**
     * Selects at most a single row from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection, not null.
     *
     * @return The selected row, or null if no records was selected.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> T doSelectSingleRecord(
                org.apache.torque.criteria.Criteria criteria,
                RecordMapper<T> mapper,
                Connection connection)
            throws TorqueException
    {
        return getBaseTablePeerImpl().doSelectSingleRecord(
                criteria,
                mapper,
                connection);
    }

    /**
     * Selects at most one BaseTable object from the database
     * which has the same content as the passed object.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static BaseTable doSelectSingleRecord(
                BaseTable obj)
            throws TorqueException
    {
        return getBaseTablePeerImpl().doSelectSingleRecord(obj);
    }


    /**
     * Returns a new instance of the Data object class
     */
    public static BaseTable getDbObjectInstance()
    {
        return getBaseTablePeerImpl().getDbObjectInstance();
    }


    /**
     * Method to do inserts.
     *
     * @param columnValues the values to insert.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static ObjectKey doInsert(ColumnValues columnValues) 
            throws TorqueException
    {
        return getBaseTablePeerImpl().doInsert(columnValues);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(Criteria) method.
     *
     * @param columnValues the values to insert.
     * @param con the connection to use, not null.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static ObjectKey doInsert(ColumnValues columnValues, Connection con)
            throws TorqueException
    {
        return getBaseTablePeerImpl().doInsert(columnValues, con);
    }
    /**
     * Method to do inserts
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void doInsert(BaseTable obj)
            throws TorqueException
    {
        getBaseTablePeerImpl().doInsert(obj);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(BaseTable) method.  It will take
     * care of the connection details internally.
     *
     * @param obj the data object to insert into the database.
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void doInsert(BaseTable obj, Connection con)
            throws TorqueException
    {
        getBaseTablePeerImpl().doInsert(obj, con);
    }

    /**
     * Method to do updates.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(ColumnValues columnValues) throws TorqueException
    {
        return getBaseTablePeerImpl().doUpdate(columnValues);
    }

    /**
     * Method to do updates.  This method is to be used during a transaction,
     * otherwise use the doUpdate(Criteria) method.  It will take care of
     * the connection details internally.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @param con the connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        return getBaseTablePeerImpl().doUpdate(columnValues, con);
    }

    /**
     * Executes an update against the database. The rows to be updated
     * are selected using <code>criteria</code> and updated using the values
     * in <code>updateValues</code>.
     *
     * @param criteria selects which rows of which table should be updated.
     * @param updateValues Which columns to update with which values, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException if updating fails.
     */
    public static int doUpdate(
                Criteria selectCriteria,
                ColumnValues updateValues)
            throws TorqueException
    {
        return getBaseTablePeerImpl().doUpdate(
            selectCriteria,
            updateValues);
    }

    /**
     * Executes an update against the database. The rows to be updated
     * are selected using <code>criteria</code> and updated using the values
     * in <code>updateValues</code>.
     *
     * @param criteria selects which rows of which table should be updated.
     * @param updateValues Which columns to update with which values, not null.
     * @param connection the database connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException if updating fails.
     */
    public static int doUpdate(
                Criteria criteria,
                ColumnValues updateValues,
                Connection connection)
            throws TorqueException
    {
        return getBaseTablePeerImpl().doUpdate(
            criteria,
             updateValues,
              connection);
    }

    /**
     * Updates an BaseTable in the database.
     * The primary key is used to identify the object to update.
     *
     * @param obj the data object to update in the database.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(BaseTable obj) throws TorqueException
    {
        return getBaseTablePeerImpl().doUpdate(obj);
    }

    /**
     * Updates a BaseTable in the database.
     * The primary key is used to identify the object to update.
     * This method is to be used during a transaction,
     * otherwise the doUpdate(BaseTable) method can be used.
     *
     * @param obj the data object to update in the database.
     * @param con the connection to use, not null.
     
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(BaseTable obj, Connection con)
        throws TorqueException
    {
        return getBaseTablePeerImpl().doUpdate(obj, con);
    }

    /**
     * Utility method which executes a given SQL statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the SQL statement to execute.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString)
            throws TorqueException
    {
        return getBaseTablePeerImpl().executeStatement(statementString);
    }

    /**
     * Utility method which executes a given sql statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the sql statement to execute.
     * @param dbName Name of database to connect to.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString, String dbName)
            throws TorqueException
    {
        return getBaseTablePeerImpl().executeStatement(statementString, dbName);
    }

    /**
     * Utility method which executes a given sql statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the sql statement to execute.
     * @param con A Connection.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString, Connection con)
            throws TorqueException
    {
        return getBaseTablePeerImpl().executeStatement(statementString, con);
    }

    /**
     * Deletes rows from a database table.
     *
     * @param criteria defines the rows to be deleted, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
     public static int doDelete(Criteria criteria) throws TorqueException
     {
        return getBaseTablePeerImpl().doDelete(criteria);
     }

    /**
     * Deletes rows from a table.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
    *
     * @param criteria defines the rows to be deleted, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
     public static int doDelete(Criteria criteria, Connection con)
        throws TorqueException
     {
        return getBaseTablePeerImpl().doDelete(criteria, con);
     }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     *
     * @param obj the data object to delete in the database, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(BaseTable obj) throws TorqueException
    {
        return getBaseTablePeerImpl().doDelete(obj);
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param obj the data object to delete in the database, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(BaseTable obj, Connection con)
        throws TorqueException
    {
        return getBaseTablePeerImpl().doDelete(obj, con);
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     *
     * @param objects the datas object to delete in the database, not null,
     *        may not contain null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(Collection<BaseTable> objects)
            throws TorqueException
    {
        return getBaseTablePeerImpl().doDelete(objects);
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param objects the datas object to delete in the database, not null,
     *        may not contain null.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(
            Collection<BaseTable> objects,
            Connection con)
        throws TorqueException
    {
        return getBaseTablePeerImpl().doDelete(objects, con);
    }

    /**
     * Deletes a row in the database.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(ObjectKey pk) throws TorqueException
    {
        return getBaseTablePeerImpl().doDelete(pk);
    }

    /**
     * Deletes a row in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(ObjectKey pk, Connection con)
        throws TorqueException
    {
        return getBaseTablePeerImpl().doDelete(pk, con);
    }

    /** 
     * Build a Criteria object which selects all objects which have a given
     * primary key.
     *
     * @param pk the primary key value to build the criteria from, not null.
     */
    public static Criteria buildCriteria(ObjectKey pk)
    {
        return getBaseTablePeerImpl().buildCriteria(pk);
    }

    /** 
     * Build a Criteria object which selects all objects which primary keys
     * are contained in the passed collection.
     *
     * @param pks the primary key values to build the criteria from, not null,
     *        may not contain null.
     */
    public static Criteria buildCriteria(Collection<ObjectKey> pks)
    {
        return getBaseTablePeerImpl().buildCriteria(pks);
    }

    /** 
     * Build a Criteria object which selects all passed objects using their
     * primary key. Objects which do not yet have a primary key are ignored.
     *
     * @param objects the objects to build the criteria from, not null,
     *        may not contain null.
     */
    public static Criteria buildPkCriteria(
            Collection<BaseTable> objects)
    {
        return getBaseTablePeerImpl().buildPkCriteria(objects);
    }

    /** 
     * Build a Criteria object from the data object for this peer.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public static Criteria buildCriteria(BaseTable obj)
    {
        return getBaseTablePeerImpl().buildCriteria(obj);
    }

    /** 
     * Build a Criteria object from the data object for this peer,
     * skipping all binary columns.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public static Criteria buildSelectCriteria(BaseTable obj)
    {
        return getBaseTablePeerImpl().buildSelectCriteria(obj);
    }

    /** 
     * Returns the contents of the object as ColumnValues object
     *
     * @throws TorqueException if the table map cannot be retrieved
     *         (should not happen).
     */
    public static ColumnValues buildColumnValues(BaseTable baseTable)
            throws TorqueException
    {
        
        return getBaseTablePeerImpl().buildColumnValues(baseTable);
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public static BaseTable retrieveByPK(java.math.BigDecimal pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return getBaseTablePeerImpl().retrieveByPK(pk);
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public static BaseTable retrieveByPK(java.math.BigDecimal pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return getBaseTablePeerImpl().retrieveByPK(pk, con);
    }
    
    
    

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public static BaseTable retrieveByPK(ObjectKey pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return getBaseTablePeerImpl().retrieveByPK(pk);
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public static BaseTable retrieveByPK(ObjectKey pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return getBaseTablePeerImpl().retrieveByPK(pk, con);
    }


    /**
     * Retrieve a multiple objects by pk
     *
     * @param pks List of primary keys
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<BaseTable> retrieveByPKs(Collection<ObjectKey> pks)
        throws TorqueException
    {
        return getBaseTablePeerImpl().retrieveByPKs(pks);
    }

    /**
     * Retrieve multiple objects by pk
     *
     * @param pks List of primary keys
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<BaseTable> retrieveByPKs(Collection<ObjectKey> pks, Connection con)
        throws TorqueException
    {
        return getBaseTablePeerImpl().retrieveByPKs(pks,con);
    }






    /** 
     * Returns the chunk size for the filler methods.
     *
     * @return the chunk size for the filler methods.
     */
    protected static int getFillerChunkSize()
    {
        return getBaseTablePeerImpl().getFillerChunkSize();
    }

    /**
     * Returns the TableMap related to this peer.
     *
     * @return the table map, not null.
     *
     * @throws TorqueException if the Peer instance does not hold a Table map.
     */
    public static TableMap getTableMap()
        throws TorqueException
    {
        return getBaseTablePeerImpl().getTableMap();
    }

    public static void initDatabaseMap()
    {
        BaseBookstoreDatabaseMapInit.init();
    }


}
