package org.apache.torque.test;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.apache.torque.TorqueException;
import org.apache.torque.om.mapper.RecordMapper;

    
/**
 * Maps ResultSet rows into BintBcharValue objects.
 *
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:47 CEST 2012]
 *
 */
public class BaseBintBcharValueRecordMapper implements RecordMapper<BintBcharValue>
{
    /**
     * Constructs the object from the current row in the resultSet.
     *
     * @param resultSet the resultSet to operate on, already pointing
     *        to the correct row. Not null.
     * @param a possible offset in the rows to be considered
     *        (if previous rows contain other objects).
     *
     * @return the mapped object, not null.
     *
     * @throws TorqueException when reading fields from the RecordSet fails.
     */
    public BintBcharValue processRow(ResultSet resultSet, int offset)
            throws TorqueException
    {
        BintBcharValue bintBcharValue = new BintBcharValue();

        try 
        {
            bintBcharValue.setLoading(true);
            bintBcharValue.setId(
                    getId(resultSet, offset + 1));
            bintBcharValue.setBintValue(
                    getBintValue(resultSet, offset + 2));
            bintBcharValue.setBcharValue(
                    getBcharValue(resultSet, offset + 3));
            bintBcharValue.setBintObjectValue(
                    getBintObjectValue(resultSet, offset + 4));
            bintBcharValue.setBcharObjectValue(
                    getBcharObjectValue(resultSet, offset + 5));
            bintBcharValue.setNew(false);
            bintBcharValue.setModified(false);
        }
        finally
        {
            bintBcharValue.setLoading(false);
        }
        return bintBcharValue;
    }

        /**
         * Reads the value of the <code>columnIndex</code>'th column
         * in the <code>resultSet</code> so that it can be used to set
         * the field id in BintBcharValue.
         *
         * @param dbObject the database object to fill, not null.
         * @param resultSet the ResultSet to read from, not null.
         * @param columnIndex the index in the resultSet which should be read.
         *
         * @return the content of the column.
         *
         * @throws SQLException if a problem occurs when reading
         *         from the resultSet.
         */
        protected String getId(
                    ResultSet resultSet,
                    int columnIndex)
                throws TorqueException
        {
            try
            {
                return resultSet.getString(columnIndex);
            }
            catch (SQLException e)
            {
                throw new TorqueException(e);
            }
        }

        /**
         * Reads the value of the <code>columnIndex</code>'th column
         * in the <code>resultSet</code> so that it can be used to set
         * the field bintValue in BintBcharValue.
         *
         * @param dbObject the database object to fill, not null.
         * @param resultSet the ResultSet to read from, not null.
         * @param columnIndex the index in the resultSet which should be read.
         *
         * @return the content of the column.
         *
         * @throws SQLException if a problem occurs when reading
         *         from the resultSet.
         */
        protected boolean getBintValue(
                    ResultSet resultSet,
                    int columnIndex)
                throws TorqueException
        {
            try
            {
                int intValue = resultSet.getInt(columnIndex);
                if (1 == intValue)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
            catch (SQLException e)
            {
                throw new TorqueException(e);
            }
        }

        /**
         * Reads the value of the <code>columnIndex</code>'th column
         * in the <code>resultSet</code> so that it can be used to set
         * the field bcharValue in BintBcharValue.
         *
         * @param dbObject the database object to fill, not null.
         * @param resultSet the ResultSet to read from, not null.
         * @param columnIndex the index in the resultSet which should be read.
         *
         * @return the content of the column.
         *
         * @throws SQLException if a problem occurs when reading
         *         from the resultSet.
         */
        protected boolean getBcharValue(
                    ResultSet resultSet,
                    int columnIndex)
                throws TorqueException
        {
            try
            {
                String stringValue = resultSet.getString(columnIndex);
                if ("Y".equals(stringValue))
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
            catch (SQLException e)
            {
                throw new TorqueException(e);
            }
        }

        /**
         * Reads the value of the <code>columnIndex</code>'th column
         * in the <code>resultSet</code> so that it can be used to set
         * the field bintObjectValue in BintBcharValue.
         *
         * @param dbObject the database object to fill, not null.
         * @param resultSet the ResultSet to read from, not null.
         * @param columnIndex the index in the resultSet which should be read.
         *
         * @return the content of the column.
         *
         * @throws SQLException if a problem occurs when reading
         *         from the resultSet.
         */
        protected Boolean getBintObjectValue(
                    ResultSet resultSet,
                    int columnIndex)
                throws TorqueException
        {
            try
            {
                int intValue = resultSet.getInt(columnIndex);
                if (1 == intValue)
                {
                    return true;
                }
                else if (0 == intValue && resultSet.wasNull())
                {
                    return null;
                }
                else
                {
                    return false;
                }
            }
            catch (SQLException e)
            {
                throw new TorqueException(e);
            }
        }

        /**
         * Reads the value of the <code>columnIndex</code>'th column
         * in the <code>resultSet</code> so that it can be used to set
         * the field bcharObjectValue in BintBcharValue.
         *
         * @param dbObject the database object to fill, not null.
         * @param resultSet the ResultSet to read from, not null.
         * @param columnIndex the index in the resultSet which should be read.
         *
         * @return the content of the column.
         *
         * @throws SQLException if a problem occurs when reading
         *         from the resultSet.
         */
        protected Boolean getBcharObjectValue(
                    ResultSet resultSet,
                    int columnIndex)
                throws TorqueException
        {
            try
            {
                String stringValue = resultSet.getString(columnIndex);
                if ("Y".equals(stringValue))
                {
                    return true;
                }
                else if (null == stringValue)
                {
                    return null;
                }
                else
                {
                    return false;
                }
            }
            catch (SQLException e)
            {
                throw new TorqueException(e);
            }
        }


}
