package org.apache.torque.test;

import java.io.Serializable;
import java.sql.Connection;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.List;

import org.apache.torque.TorqueException;
import org.apache.torque.map.TableMap;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.BooleanKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.om.ColumnAccessByName;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.util.Transaction;
import org.apache.commons.lang.ObjectUtils;


/**
 * This class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:41 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to BookAuthors
 */

public abstract class BaseBookAuthors 
    implements Serializable, ColumnAccessByName
{
    /** Serial version */
    private static final long serialVersionUID = 1347503741576L;



    /** Defines the bookId field. */
    private int bookId = 0;

    /** Defines the authorId field. */
    private int authorId = 0;

    /** Defines the bookTitle field. */
    private String bookTitle = null;

    /** Defines the authorName field. */
    private String authorName = null;

    /** Whether this object was modified after loading or after last save. */
    private boolean modified = true;

    /** 
     * Whether this object was loaded from the database or already saved 
     * (false) or whether it is not yet in the database(true).
     */
    private boolean isNew = true;

    /** 
     * Flag which indicates whether this object is currently loaded
     * from the database. 
     */
    private boolean loading = false;


    /**
     * Get the value of bookId.
     *
     * @return int
     */
    public int getBookId() 
    {
        
        return bookId;
    }

    /**
     * Set the value of bookId.
     *
     * @param v new value
     */
    public void setBookId(int v)
    {
        if (this.bookId != v)
        {
            setModified(true);
        }

        this.bookId = v;


    }
    
    /**
     * Get the value of authorId.
     *
     * @return int
     */
    public int getAuthorId() 
    {
        
        return authorId;
    }

    /**
     * Set the value of authorId.
     *
     * @param v new value
     */
    public void setAuthorId(int v)
    {
        if (this.authorId != v)
        {
            setModified(true);
        }

        this.authorId = v;


    }
    
    /**
     * Get the value of bookTitle.
     *
     * @return String
     */
    public String getBookTitle() 
    {
        
        return bookTitle;
    }

    /**
     * Set the value of bookTitle.
     *
     * @param v new value
     */
    public void setBookTitle(String v)
    {
        if (!ObjectUtils.equals(this.bookTitle, v))
        {
            setModified(true);
        }

        this.bookTitle = v;


    }
    
    /**
     * Get the value of authorName.
     *
     * @return String
     */
    public String getAuthorName() 
    {
        
        return authorName;
    }

    /**
     * Set the value of authorName.
     *
     * @param v new value
     */
    public void setAuthorName(String v)
    {
        if (!ObjectUtils.equals(this.authorName, v))
        {
            setModified(true);
        }

        this.authorName = v;


    }
    

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return true, if the object has never been persisted.
     */
    public boolean isNew()
    {
        return isNew;
    }

    /**
     * Sets whether the object has ever been saved.
     *
     * @param isNew true if the object has never been saved, false otherwise.
     */
    public void setNew(boolean isNew)
    {
        this.isNew = isNew;
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return True if the object has been modified.
     */
    public boolean isModified()
    {
        return modified;
    }

    /**
     * Sets whether the object has been modified.
     *
     * @param modified true if the object has been modified, false otherwise.
     */
    public void setModified(boolean modified)
    {
        this.modified = modified;
    }

    /**
     * Sets the modified state for the object to be false.
     */
    public void resetModified()
    {
        modified = false;
    }


    /**
     * Returns whether this object is currently being loaded from the database.
     *
     * @return true if this object is currently loading, false otherwise.
     */
    public boolean isLoading()
    {
        return loading;
    }

    /**
     * Sets whether this object is currently being loaded from the database.
     *
     * @param loading true if this object is currently loading, false otherwise.
     */
    public void setLoading(boolean loading)
    {
        this.loading = loading;
    }



    private static final List<String> FIELD_NAMES;

    static
    {
        List<String> fieldNames
                = new ArrayList<String>();
        fieldNames.add("BookId");
        fieldNames.add("AuthorId");
        fieldNames.add("BookTitle");
        fieldNames.add("AuthorName");
        FIELD_NAMES = Collections.unmodifiableList(fieldNames);
    }

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static List<String> getFieldNames()
    {
        return FIELD_NAMES;
    }

    /**
     * Retrieves a field from the object by field (Java) name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
        if (name.equals("BookId"))
        {
            return new Integer(getBookId());
        }
        if (name.equals("AuthorId"))
        {
            return new Integer(getAuthorId());
        }
        if (name.equals("BookTitle"))
        {
            return getBookTitle();
        }
        if (name.equals("AuthorName"))
        {
            return getAuthorName();
        }
        return null;
    }

    /**
     * Set a field in the object by field (Java) name.
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (name.equals("BookId"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setBookId(((Integer) value).intValue());
            return true;
        }
        if (name.equals("AuthorId"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setAuthorId(((Integer) value).intValue());
            return true;
        }
        if (name.equals("BookTitle"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setBookTitle((String) value);
            return true;
        }
        if (name.equals("AuthorName"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setAuthorName((String) value);
            return true;
        }
        return false;
    }

    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
        if (name.equals(org.apache.torque.test.BookAuthorsPeer.BOOK_ID))
        {
            return new Integer(getBookId());
        }
        if (name.equals(org.apache.torque.test.BookAuthorsPeer.AUTHOR_ID))
        {
            return new Integer(getAuthorId());
        }
        if (name.equals(org.apache.torque.test.BookAuthorsPeer.BOOK_TITLE))
        {
            return getBookTitle();
        }
        if (name.equals(org.apache.torque.test.BookAuthorsPeer.AUTHOR_NAME))
        {
            return getAuthorName();
        }
        return null;
    }

    /**
     * Set field values by Peer Field Name
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPeerName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (org.apache.torque.test.BookAuthorsPeer.BOOK_ID.getSqlExpression().equals(name))
        {
            return setByName("BookId", value);
        }
        if (org.apache.torque.test.BookAuthorsPeer.AUTHOR_ID.getSqlExpression().equals(name))
        {
            return setByName("AuthorId", value);
        }
        if (org.apache.torque.test.BookAuthorsPeer.BOOK_TITLE.getSqlExpression().equals(name))
        {
            return setByName("BookTitle", value);
        }
        if (org.apache.torque.test.BookAuthorsPeer.AUTHOR_NAME.getSqlExpression().equals(name))
        {
            return setByName("AuthorName", value);
        }
        return false;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
        if (pos == 0)
        {
            return new Integer(getBookId());
        }
        if (pos == 1)
        {
            return new Integer(getAuthorId());
        }
        if (pos == 2)
        {
            return getBookTitle();
        }
        if (pos == 3)
        {
            return getAuthorName();
        }
        return null;
    }

    /**
     * Set field values by its position (zero based) in the XML schema.
     *
     * @param position The field position
     * @param value field value
     * @return True if value was set, false if not (invalid position / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPosition(int position, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (position == 0)
        {
            return setByName("BookId", value);
        }
        if (position == 1)
        {
            return setByName("AuthorId", value);
        }
        if (position == 2)
        {
            return setByName("BookTitle", value);
        }
        if (position == 3)
        {
            return setByName("AuthorName", value);
        }
        return false;
    }



    
    /**
     * Set the PrimaryKey with an ObjectKey
     *
     * @param key the primary key to set.
     *
     * @throws NoSuchOperationException always.
     */
    public void setPrimaryKey(ObjectKey key) throws TorqueException
    {
        throw new UnsupportedOperationException(
                "This table has no primary key");
    }

    /**
     * Set the PrimaryKey using a String.
     *
     * @param key the primary key to set.
     *
     * @throws NoSuchOperationException always.
     */
    public void setPrimaryKey(String key) throws TorqueException
    {
        throw new UnsupportedOperationException(
                "This table has no primary key");
    }

    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        return null;
    }



    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public BookAuthors copy() throws TorqueException
    {
        return copy(true);
    }

    /**
     * Makes a copy of this object using a connection.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     *
     * @param con the database connection to read associated objects.
     */
    public BookAuthors copy(Connection con) throws TorqueException
    {
        return copy(true, con);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     */
    public BookAuthors copy(boolean deepcopy) throws TorqueException
    {
        BookAuthors bookAuthors = new BookAuthors();

        return copyInto(bookAuthors, deepcopy);
    }

    /**
     * Makes a copy of this object using connection.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @param con the database connection to read associated objects.
     */
    public BookAuthors copy(boolean deepcopy, Connection con) throws TorqueException
    {
        BookAuthors bookAuthors = new BookAuthors();

        return copyInto(bookAuthors, deepcopy, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     */
    protected BookAuthors copyInto(BookAuthors copyObj) throws TorqueException
    {
        return copyInto(copyObj, true);
    }

    /**
     * Fills the copyObj with the contents of this object using connection.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param con the database connection to read associated objects.
     */
    protected BookAuthors copyInto(BookAuthors copyObj, Connection con) throws TorqueException
    {
        return copyInto(copyObj, true, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     */
    protected BookAuthors copyInto(BookAuthors copyObj, boolean deepcopy) throws TorqueException
    {
        copyObj.setBookId(bookId);
        copyObj.setAuthorId(authorId);
        copyObj.setBookTitle(bookTitle);
        copyObj.setAuthorName(authorName);

        if (deepcopy)
        {
        }
        return copyObj;
    }
        
    
    /**
     * Fills the copyObj with the contents of this object using connection.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @param con the database connection to read associated objects.
     */
    protected BookAuthors copyInto(BookAuthors copyObj, boolean deepcopy, Connection con) throws TorqueException
    {
        copyObj.setBookId(bookId);
        copyObj.setAuthorId(authorId);
        copyObj.setBookTitle(bookTitle);
        copyObj.setAuthorName(authorName);

        if (deepcopy)
        {
        }
        return copyObj;
    }

    /** The Peer class */
    private static final org.apache.torque.test.BookAuthorsPeer peer
            = new org.apache.torque.test.BookAuthorsPeer();

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public org.apache.torque.test.BookAuthorsPeer getPeer()
    {
        return peer;
    }

    /**
     * Retrieves the TableMap object related to this Table data without
     * compiler warnings of using getPeer().getTableMap().
     *
     * @return The associated TableMap object.
     */
    public TableMap getTableMap() throws TorqueException
    {
        return org.apache.torque.test.BookAuthorsPeer.getTableMap();
    }



    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("BookAuthors:\n");
        str.append("bookId = ")
           .append(getBookId())
           .append("\n");
        str.append("authorId = ")
           .append(getAuthorId())
           .append("\n");
        str.append("bookTitle = ")
           .append(getBookTitle())
           .append("\n");
        str.append("authorName = ")
           .append(getAuthorName())
           .append("\n");
        return(str.toString());
    }

    /**
     * Compares the primary key of this instance with the key of another.
     *
     * @param toCompare The object to compare to.
     * @return Whether the primary keys are equal and the object have the
     *         same class.
     */
    public boolean equals(Object toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!getClass().equals(toCompare.getClass()))
        {
            return false;
        }
        BookAuthors other = (BookAuthors) toCompare;
        if (getPrimaryKey() == null || other.getPrimaryKey() == null)
        {
            return false;
        }
        return getPrimaryKey().equals(other.getPrimaryKey());
    }

    /**
     * If the primary key is not <code>null</code>, return the hashcode of the
     * primary key.  Otherwise calls <code>Object.hashCode()</code>.
     *
     * @return an <code>int</code> value
     */
    public int hashCode()
    {
        ObjectKey ok = getPrimaryKey();
        if (ok == null)
        {
            return super.hashCode();
        }

        return ok.hashCode();
    }




}
