package org.apache.torque.test;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.torque.NoRowsException;
import org.apache.torque.TooManyRowsException;
import org.apache.torque.Column;
import org.apache.torque.Torque;
import org.apache.torque.TorqueException;
import org.apache.torque.TorqueRuntimeException;
import org.apache.torque.adapter.IDMethod;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.map.DatabaseMap;
import org.apache.torque.map.TableMap;
import org.apache.torque.map.ColumnMap;
import org.apache.torque.map.ForeignKeyMap;
import org.apache.torque.map.InheritanceMap;
import org.apache.torque.om.mapper.RecordMapper;
import org.apache.torque.om.mapper.CompositeMapper;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.util.BasePeer;
import org.apache.torque.util.Transaction;
import org.apache.torque.util.ColumnValues;
import org.apache.torque.util.JdbcTypedValue;



/**
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:45 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to BookAuthorsPeer
 */

public abstract class BaseBookAuthorsPeer
{
    /** The class log. */
    private static Log log = LogFactory.getLog(BaseBookAuthorsPeerImpl.class);
    /** Serial version */
    private static final long serialVersionUID = 1347503745079L;


    /** The default database name for this class. */
    public static final String DATABASE_NAME;

     /** The table name for this class. */
    public static final String TABLE_NAME;

     /** The table map for this class. */
    public static final TableMap TABLE;

    /** The column for the book_id field */
    public static final ColumnMap BOOK_ID;
    /** The column for the author_id field */
    public static final ColumnMap AUTHOR_ID;
    /** The column for the book_title field */
    public static final ColumnMap BOOK_TITLE;
    /** The column for the author_name field */
    public static final ColumnMap AUTHOR_NAME;

    /** number of columns for this peer */
    public static final int numColumns = 4;


    /** The implementation of the peer. */
    private static BookAuthorsPeerImpl bookAuthorsPeerImpl;


    static
    {
        DatabaseMap dbMap = Torque.getOrCreateDatabase("bookstore")
                .getDatabaseMap();
        if (dbMap.getTable("BOOK_AUTHORS") == null)
        {
            dbMap.addTable("BOOK_AUTHORS");
        }
        DATABASE_NAME = "bookstore";
        TABLE_NAME = "BOOK_AUTHORS";

        TABLE = dbMap.getTable("BOOK_AUTHORS");
        TABLE.setJavaName("BookAuthors");
        TABLE.setOMClass(org.apache.torque.test.BookAuthors.class);
        TABLE.setPeerClass(org.apache.torque.test.BookAuthorsPeer.class);
        TABLE.setPrimaryKeyMethod(IDMethod.NATIVE);
        TABLE.setPrimaryKeyMethodInfo(IDMethod.ID_BROKER, TABLE.getName());
        TABLE.setPrimaryKeyMethodInfo(IDMethod.SEQUENCE, "BOOK_AUTHORS_SEQ");
        TABLE.setPrimaryKeyMethodInfo(IDMethod.AUTO_INCREMENT, "BOOK_AUTHORS");
        TABLE.setUseInheritance(true);


    // ------------- Column: book_id --------------------
        BOOK_ID = new ColumnMap("book_id", TABLE);
        BOOK_ID.setType(Integer.valueOf(0));
        BOOK_ID.setTorqueType("INTEGER");
        BOOK_ID.setUsePrimitive(true);
        BOOK_ID.setPrimaryKey(false);
        BOOK_ID.setNotNull(false);
        BOOK_ID.setJavaName("BookId");
        BOOK_ID.setAutoIncrement(true);
        BOOK_ID.setProtected(false);
        BOOK_ID.setJavaType( "int" );
        BOOK_ID.setPosition(1);
        TABLE.addColumn(BOOK_ID);
    // ------------- Column: author_id --------------------
        AUTHOR_ID = new ColumnMap("author_id", TABLE);
        AUTHOR_ID.setType(Integer.valueOf(0));
        AUTHOR_ID.setTorqueType("INTEGER");
        AUTHOR_ID.setUsePrimitive(true);
        AUTHOR_ID.setPrimaryKey(false);
        AUTHOR_ID.setNotNull(false);
        AUTHOR_ID.setJavaName("AuthorId");
        AUTHOR_ID.setAutoIncrement(true);
        AUTHOR_ID.setProtected(false);
        AUTHOR_ID.setJavaType( "int" );
        AUTHOR_ID.setPosition(2);
        TABLE.addColumn(AUTHOR_ID);
    // ------------- Column: book_title --------------------
        BOOK_TITLE = new ColumnMap("book_title", TABLE);
        BOOK_TITLE.setType("");
        BOOK_TITLE.setTorqueType("VARCHAR");
        BOOK_TITLE.setUsePrimitive(false);
        BOOK_TITLE.setPrimaryKey(false);
        BOOK_TITLE.setNotNull(false);
        BOOK_TITLE.setJavaName("BookTitle");
        BOOK_TITLE.setAutoIncrement(true);
        BOOK_TITLE.setProtected(false);
        BOOK_TITLE.setJavaType( "String" );
        BOOK_TITLE.setPosition(3);
        TABLE.addColumn(BOOK_TITLE);
    // ------------- Column: author_name --------------------
        AUTHOR_NAME = new ColumnMap("author_name", TABLE);
        AUTHOR_NAME.setType("");
        AUTHOR_NAME.setTorqueType("VARCHAR");
        AUTHOR_NAME.setUsePrimitive(false);
        AUTHOR_NAME.setPrimaryKey(false);
        AUTHOR_NAME.setNotNull(false);
        AUTHOR_NAME.setJavaName("AuthorName");
        AUTHOR_NAME.setAutoIncrement(true);
        AUTHOR_NAME.setProtected(false);
        AUTHOR_NAME.setJavaType( "String" );
        AUTHOR_NAME.setPosition(4);
        TABLE.addColumn(AUTHOR_NAME);



        initDatabaseMap();
    }

    /**
     * Creates a new instance of the  implementation of the peer.
     *
     * @return the new instance.
     */
    protected static BookAuthorsPeerImpl createBookAuthorsPeerImpl()
    {
        BookAuthorsPeerImpl instance = new BookAuthorsPeerImpl();
        return instance;
    }


    /**
     * Returns an instance of the implementation of the peer.
     * If no instance is currently cached, a new instance is created and cached.
     *
     * @return an instance of the implementation of the peer, not null.
     */
    public static BookAuthorsPeerImpl getBookAuthorsPeerImpl()
    {
        BookAuthorsPeerImpl peerImplInstance = bookAuthorsPeerImpl;
        if (peerImplInstance == null)
        {
            peerImplInstance = BookAuthorsPeer.createBookAuthorsPeerImpl();
            bookAuthorsPeerImpl = peerImplInstance;
        }
        return peerImplInstance;
    }



    /**
     * Sets the instance of the implementation of the peer.
     *
     * @param an instance of the implementation of the peer, or null
     *        if a new instance should be created automatically.
     */
    public static void setBookAuthorsPeerImpl(BookAuthorsPeerImpl peerImplInstance)
    {
        bookAuthorsPeerImpl = peerImplInstance;
    }


    /**
     * Get the list of objects for a ResultSet.  Please not that your
     * resultset MUST return columns in the right order.  You can use
     * getFieldNames() in BaseObject to get the correct sequence.
     *
     * @param resultSet the ResultSet
     * @return the list of objects
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<BookAuthors> resultSet2Objects(ResultSet resultSet)
            throws TorqueException
    {
        return getBookAuthorsPeerImpl().resultSet2Objects(resultSet);
    }

    /**
     * Add all the columns needed to create a new object.
     *
     * @param criteria object containing the columns to add.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void addSelectColumns(Criteria criteria)
            throws TorqueException
    {
        getBookAuthorsPeerImpl().addSelectColumns(criteria);
    }

    /**
     * changes the boolean values in the criteria to the appropriate type,
     * whenever a booleanchar or booleanint column is involved.
     * This enables the user to create criteria using Boolean values
     * for booleanchar or booleanint columns.
     *
     * @param criteria the criteria in which the boolean values
     *        should be corrected.
     *
     * @throws TorqueException if the database map for the criteria cannot be 
               obtained.
     */
    public static void correctBooleans(Criteria criteria) throws TorqueException
    {
        getBookAuthorsPeerImpl().correctBooleans(criteria);
    }

    /**
     * Checks all columns in the criteria to see whether
     * booleanchar and booleanint columns are queried with a boolean.
     * If yes, the query values are mapped onto values the database
     * does understand, i.e. 0 and 1 for booleanints and N and Y for
     * booleanchar columns.
     *
     * @param columnValues The value to be checked for booleanint
     *        and booleanchar columns.
     * @throws TorqueException if the database map for the criteria cannot be
     *         retrieved.
     */
    public static void correctBooleans(
            ColumnValues columnValues)
        throws TorqueException
    {
        getBookAuthorsPeerImpl().correctBooleans(columnValues);
    }
    
    /**
     * Selects BookAuthors objects from a database.
     *
     * @param criteria object used to create the SELECT statement.
     *
     * @return the list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<BookAuthors> doSelect(Criteria criteria)
            throws TorqueException
    {
        return getBookAuthorsPeerImpl().doSelect(criteria);
    }

    /**
     * Selects BookAuthors objects from a database
     * within a transaction.
     *
     * @param criteria object used to create the SELECT statement.
     * @param connection the connection holding the transaction, not null.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<BookAuthors> doSelect(
                Criteria criteria,
                Connection connection)
            throws TorqueException
    {
        return getBookAuthorsPeerImpl().doSelect(criteria, connection);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                Criteria criteria,
                RecordMapper<T> mapper)
            throws TorqueException
    {
        return getBookAuthorsPeerImpl().doSelect(criteria, mapper);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection for selecting records,
     *        not null.
     *
     * @return The results of the query, not null.
     * @throws TorqueException Error performing database query.
     */
    public static <T> List<T> doSelect(
            Criteria criteria,
            RecordMapper<T> mapper,
            Connection connection)
        throws TorqueException
    {
        return getBookAuthorsPeerImpl().doSelect(
                criteria,
                mapper,
                connection);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param query the sql query to execute, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param dbName The name of the database to create the connection for,
     *        or null for the default SDB.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                String query,
                RecordMapper<T> mapper,
                String dbName)
            throws TorqueException
    {
        return getBookAuthorsPeerImpl().doSelect(
                query,
                mapper,
                dbName);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param query the SQL Query to execute, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection, not null.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                String query,
                RecordMapper<T> mapper,
                Connection connection)
            throws TorqueException
    {
        return getBookAuthorsPeerImpl().doSelect(
                query,
                mapper,
                connection);
    }

    /**
     * Selects BookAuthors objects from the database which have
     * the same content as the passed object.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<BookAuthors> doSelect(BookAuthors obj)
            throws TorqueException
    {
        return getBookAuthorsPeerImpl().doSelect(obj);
    }

    /**
     * Selects at most one BookAuthors object from a database.
     *
     * @param criteria object used to create the SELECT statement.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static BookAuthors doSelectSingleRecord(
                Criteria criteria)
            throws TorqueException
    {
        return getBookAuthorsPeerImpl().doSelectSingleRecord(criteria);
    }

    /**
     * Selects at most one BookAuthors object from a database
     * within a transaction.
     *
     * @param criteria object used to create the SELECT statement.
     * @param connection the connection holding the transaction, not null.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static BookAuthors doSelectSingleRecord(
                Criteria criteria,
                Connection connection)
            throws TorqueException
    {
        return getBookAuthorsPeerImpl().doSelectSingleRecord(criteria, connection);
    }

    /**
     * Selects at most a single row from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     *
     * @return The selected row, or null if no records was selected.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> T doSelectSingleRecord(
                org.apache.torque.criteria.Criteria criteria,
                RecordMapper<T> mapper)
            throws TorqueException
    {
        return getBookAuthorsPeerImpl().doSelectSingleRecord(
                criteria,
                mapper);
    }

    /**
     * Selects at most a single row from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection, not null.
     *
     * @return The selected row, or null if no records was selected.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> T doSelectSingleRecord(
                org.apache.torque.criteria.Criteria criteria,
                RecordMapper<T> mapper,
                Connection connection)
            throws TorqueException
    {
        return getBookAuthorsPeerImpl().doSelectSingleRecord(
                criteria,
                mapper,
                connection);
    }

    /**
     * Selects at most one BookAuthors object from the database
     * which has the same content as the passed object.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static BookAuthors doSelectSingleRecord(
                BookAuthors obj)
            throws TorqueException
    {
        return getBookAuthorsPeerImpl().doSelectSingleRecord(obj);
    }


    /**
     * Returns a new instance of the Data object class
     */
    public static BookAuthors getDbObjectInstance()
    {
        return getBookAuthorsPeerImpl().getDbObjectInstance();
    }


    /** 
     * Build a Criteria object from the data object for this peer.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public static Criteria buildCriteria(BookAuthors obj)
    {
        return getBookAuthorsPeerImpl().buildCriteria(obj);
    }

    /** 
     * Build a Criteria object from the data object for this peer,
     * skipping all binary columns.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public static Criteria buildSelectCriteria(BookAuthors obj)
    {
        return getBookAuthorsPeerImpl().buildSelectCriteria(obj);
    }




    /**
     * Returns the TableMap related to this peer.
     *
     * @return the table map, not null.
     *
     * @throws TorqueException if the Peer instance does not hold a Table map.
     */
    public static TableMap getTableMap()
        throws TorqueException
    {
        return getBookAuthorsPeerImpl().getTableMap();
    }

    public static void initDatabaseMap()
    {
        BaseBookstoreDatabaseMapInit.init();
    }


}
