package org.apache.torque.test;

import java.sql.Blob;
import java.sql.Clob;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.sql.PreparedStatement;
import java.sql.Types;
import java.io.IOException;
import java.io.InputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.Reader;
import java.io.StringReader;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.torque.NoRowsException;
import org.apache.torque.TooManyRowsException;
import org.apache.torque.Torque;
import org.apache.torque.TorqueException;
import org.apache.torque.TorqueRuntimeException;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.criteria.Criterion;
import org.apache.torque.om.mapper.RecordMapper;
import org.apache.torque.om.mapper.CompositeMapper;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.ComboKey;
import org.apache.torque.map.TableMap;
import org.apache.torque.util.BasePeer;
import org.apache.torque.util.Transaction;
import org.apache.torque.util.ColumnValues;
import org.apache.torque.util.JdbcTypedValue;



/**
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:46 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to BookAuthorsPeer
 */

public abstract class BaseBookAuthorsPeerImpl
    extends org.apache.torque.util.BasePeerImpl<BookAuthors>
{
    /** The class log. */
    private static Log log = LogFactory.getLog(BaseBookAuthorsPeerImpl.class);

    /** Serial version */
    private static final long serialVersionUID = 1347503746962L;



    /**
     * Constructor.
     * The recordMapper, tableMap and databaseName fields are correctly
     * initialized.
     */
    public BaseBookAuthorsPeerImpl()
    {
        this(new BookAuthorsRecordMapper(),
            BookAuthorsPeer.TABLE,
            BookAuthorsPeer.DATABASE_NAME);
    }

    /**
     * Constructor providing the objects to be injected as parameters.
     *
     * @param recordMapper a record mapper to map JDBC result sets to objects
     * @param tableMap the default table map
     * @param databaseName the name of the database
     */
    public BaseBookAuthorsPeerImpl(
            RecordMapper<BookAuthors> recordMapper, 
            TableMap tableMap,
            String databaseName)
    {
        super(recordMapper, tableMap, databaseName);
    }


    /**
     * Selects BookAuthors objects from the database which have
     * the same content as the passed object.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<BookAuthors> doSelect(BookAuthors obj)
            throws TorqueException
    {
        return doSelect(buildSelectCriteria(obj));
    }

    /**
     * Selects at most one BookAuthors object from the database
     * which has the same content as the passed object.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public BookAuthors doSelectSingleRecord(
                BookAuthors obj)
            throws TorqueException
    {
        List<BookAuthors> bookAuthorsList = doSelect(obj);
        BookAuthors bookAuthors = null;
        if (bookAuthorsList.size() > 1)
        {
            throw new TooManyRowsException("Object " + obj 
                + " matched more than one record");
        }
        if (!bookAuthorsList.isEmpty())
        {
            bookAuthors = bookAuthorsList.get(0);
        }
        return bookAuthors;
    }

    /**
     * Returns a new instance of the Data object class
     */
    public BookAuthors getDbObjectInstance()
    {
        return new BookAuthors();
    }





    /** 
     * Build a Criteria object from the data object for this peer.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public Criteria buildCriteria(BookAuthors obj)
    {
        Criteria criteria = new Criteria(BookAuthorsPeer.DATABASE_NAME);
        criteria.and(BookAuthorsPeer.BOOK_ID, obj.getBookId());
        criteria.and(BookAuthorsPeer.AUTHOR_ID, obj.getAuthorId());
        criteria.and(BookAuthorsPeer.BOOK_TITLE, obj.getBookTitle());
        criteria.and(BookAuthorsPeer.AUTHOR_NAME, obj.getAuthorName());
        return criteria;
    }

    /** 
     * Build a Criteria object from the data object for this peer,
     * skipping all binary columns.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public Criteria buildSelectCriteria(BookAuthors obj)
    {
        Criteria criteria = new Criteria(BookAuthorsPeer.DATABASE_NAME);
        criteria.and(BookAuthorsPeer.BOOK_ID, obj.getBookId());
        criteria.and(BookAuthorsPeer.AUTHOR_ID, obj.getAuthorId());
        criteria.and(BookAuthorsPeer.BOOK_TITLE, obj.getBookTitle());
        criteria.and(BookAuthorsPeer.AUTHOR_NAME, obj.getAuthorName());
        return criteria;
    }










}
