package org.apache.torque.test;

import java.io.Serializable;
import java.sql.Connection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.apache.torque.TorqueException;
import org.apache.torque.map.TableMap;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.BooleanKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.om.ColumnAccessByName;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.util.Transaction;
import org.apache.commons.lang.ObjectUtils;


/**
 * c table contains fk to ar_ab, a and b
 *
 * This class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:38 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to C
 */
public abstract class BaseC 
    implements Persistent, Serializable, ColumnAccessByName
{
    /** Serial version */
    private static final long serialVersionUID = 1347503738298L;



    /** Defines the cId field. */
    private int cId = 0;

    /** Defines the aId field. */
    private int aId = 0;

    /** Defines the bId field. */
    private int bId = 0;

    /** Defines the name field. */
    private String name = null;

    /** Whether this object was modified after loading or after last save. */
    private boolean modified = true;

    /** 
     * Whether this object was loaded from the database or already saved 
     * (false) or whether it is not yet in the database(true).
     */
    private boolean isNew = true;

    /** Flag which indicates whether this object is currently saving. */
    private boolean saving = false;

    /** 
     * Flag which indicates whether this object is currently loaded
     * from the database. 
     */
    private boolean loading = false;

    /** 
     * Flag which indicates whether this object was deleted from the database.
     * Note that this flags does not always display the current database state,
     * there is no magical connection between this flag and the database.
     */
    private boolean deleted = false;

    /** Defines the aRAb field. */
    private RAb aRAb = null;

    /** Defines the aA field. */
    private A aA = null;

    /** Defines the aB field. */
    private B aB = null;





    /**
     * Get the value of cId.
     *
     * @return int
     */
    public int getCId() 
    {
        
        return cId;
    }

    /**
     * Set the value of cId.
     *
     * @param v new value
     */
    public void setCId(int v)
    {
        if (this.cId != v)
        {
            setModified(true);
        }

        this.cId = v;


    }
    
    /**
     * Get the value of aId.
     *
     * @return int
     */
    public int getAId() 
    {
        
        return aId;
    }

    /**
     * Set the value of aId.
     *
     * @param v new value
     */
    public void setAId(int v)
    {
        if (this.aId != v)
        {
            setModified(true);
        }

        this.aId = v;
        if (aRAb != null && aRAb.getAId() != v)
        {
            aRAb = null;
        }
        if (aA != null && aA.getAId() != v)
        {
            aA = null;
        }


    }
    
    /**
     * Get the value of bId.
     *
     * @return int
     */
    public int getBId() 
    {
        
        return bId;
    }

    /**
     * Set the value of bId.
     *
     * @param v new value
     */
    public void setBId(int v)
    {
        if (this.bId != v)
        {
            setModified(true);
        }

        this.bId = v;
        if (aRAb != null && aRAb.getBId() != v)
        {
            aRAb = null;
        }
        if (aB != null && aB.getBId() != v)
        {
            aB = null;
        }


    }
    
    /**
     * Get the value of name.
     *
     * @return String
     */
    public String getName() 
    {
        
        return name;
    }

    /**
     * Set the value of name.
     *
     * @param v new value
     */
    public void setName(String v)
    {
        if (!ObjectUtils.equals(this.name, v))
        {
            setModified(true);
        }

        this.name = v;


    }
    

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return true, if the object has never been persisted.
     */
    public boolean isNew()
    {
        return isNew;
    }

    /**
     * Sets whether the object has ever been saved.
     *
     * @param isNew true if the object has never been saved, false otherwise.
     */
    public void setNew(boolean isNew)
    {
        this.isNew = isNew;
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return True if the object has been modified.
     */
    public boolean isModified()
    {
        return modified;
    }

    /**
     * Sets whether the object has been modified.
     *
     * @param modified true if the object has been modified, false otherwise.
     */
    public void setModified(boolean modified)
    {
        this.modified = modified;
    }

    /**
     * Sets the modified state for the object to be false.
     */
    public void resetModified()
    {
        modified = false;
    }


    /**
     * Returns whether this object is currently saving.
     *
     * @return true if this object is currently saving, false otherwise.
     */
    public boolean isSaving()
    {
        return saving;
    }

    /**
     * Sets whether this object is currently saving.
     *
     * @param saving true if this object is currently saving, false otherwise.
     */
    public void setSaving(boolean saving)
    {
        this.saving = saving;
    }


    /**
     * Returns whether this object is currently being loaded from the database.
     *
     * @return true if this object is currently loading, false otherwise.
     */
    public boolean isLoading()
    {
        return loading;
    }

    /**
     * Sets whether this object is currently being loaded from the database.
     *
     * @param loading true if this object is currently loading, false otherwise.
     */
    public void setLoading(boolean loading)
    {
        this.loading = loading;
    }


    /**
     * Returns whether this object was deleted from the database.
     * Note that this getter does not automatically reflect database state,
     * it will be set to true by Torque if doDelete() was called with this 
     * object. Bulk deletes and deletes via primary key do not change
     * this flag. Also, if doDelete() was called on an object which does
     * not exist in the database, the deleted flag is set to true even if
     * it was not deleted.
     *
     * @return true if this object was deleted, false otherwise.
     */
    public boolean isDeleted()
    {
        return deleted;
    }

    /**
     * Sets whether this object was deleted from the database.
     *
     * @param deleted true if this object was deleted, false otherwise.
     */
    public void setDeleted(boolean deleted)
    {
        this.deleted = deleted;
    }


    /**
     * Returns the associated RAb object.
     * If it was not retrieved before, the object is retrieved from
     * the database
     *
     * @return the associated RAb object
     * @throws TorqueException when reading from the database fails.
     */
    public RAb getRAb()
        throws TorqueException
    {
        if (aRAb == null && this.aId != 0 && this.bId != 0)
        {
            aRAb = org.apache.torque.test.RAbPeer.retrieveByPK(this.aId, this.bId);
        }
        return aRAb;
    }

    /**
     * Return the associated RAb object
     * If it was not retrieved before, the object is retrieved from
     * the database using the passed connection
     *
     * @param connection the connection used to retrieve the associated object
     *        from the database, if it was not retrieved before
     * @return the associated RAb object
     * @throws TorqueException
     */
    public RAb getRAb(Connection connection)
        throws TorqueException
    {
        if (aRAb == null && this.aId != 0 && this.bId != 0)
        {
            aRAb = org.apache.torque.test.RAbPeer.retrieveByPK(this.aId, this.bId, connection);
        }
        return aRAb;
    }


    /**
     * Declares an association between this object and a RAb object
     *
     * @param v RAb
     */
    public void setRAb(RAb v)
    {
        if (v == null)
        {
            setAId(0);
        }
        else
        {
            setAId(v.getAId());
        }
        if (v == null)
        {
            setBId(0);
        }
        else
        {
            setBId(v.getBId());
        }
        aRAb = v;
    }
    /**
     * Provides convenient way to set a relationship based on a
     * ObjectKey, for example
     * <code>bar.setFooKey(foo.getPrimaryKey())</code>
     *
     * Note: It is important that the xml schema used to create this class
     * maintains consistency in the order of related columns between
     * c and r_ab.
     * If for some reason this is impossible, this method should be
     * overridden in <code>C</code>.
     */
    public void setRAbKey(ObjectKey key) throws TorqueException
    {
        SimpleKey[] keys = (SimpleKey[]) key.getValue();
       
        setAId(((NumberKey) keys[0]).intValue());
        setBId(((NumberKey) keys[1]).intValue());
     }

    /**
     * Returns the associated A object.
     * If it was not retrieved before, the object is retrieved from
     * the database
     *
     * @return the associated A object
     * @throws TorqueException when reading from the database fails.
     */
    public A getA()
        throws TorqueException
    {
        if (aA == null && this.aId != 0)
        {
            aA = org.apache.torque.test.APeer.retrieveByPK(SimpleKey.keyFor(this.aId));
        }
        return aA;
    }

    /**
     * Return the associated A object
     * If it was not retrieved before, the object is retrieved from
     * the database using the passed connection
     *
     * @param connection the connection used to retrieve the associated object
     *        from the database, if it was not retrieved before
     * @return the associated A object
     * @throws TorqueException
     */
    public A getA(Connection connection)
        throws TorqueException
    {
        if (aA == null && this.aId != 0)
        {
            aA = org.apache.torque.test.APeer.retrieveByPK(SimpleKey.keyFor(this.aId), connection);
        }
        return aA;
    }


    /**
     * Declares an association between this object and a A object
     *
     * @param v A
     */
    public void setA(A v)
    {
        if (v == null)
        {
            setAId(0);
        }
        else
        {
            setAId(v.getAId());
        }
        aA = v;
    }
    /**
     * Provides convenient way to set a relationship based on a
     * ObjectKey, for example
     * <code>bar.setFooKey(foo.getPrimaryKey())</code>
     *
     */
    public void setAKey(ObjectKey key) throws TorqueException
    {
       
        setAId(((NumberKey) key).intValue());
     }

    /**
     * Returns the associated B object.
     * If it was not retrieved before, the object is retrieved from
     * the database
     *
     * @return the associated B object
     * @throws TorqueException when reading from the database fails.
     */
    public B getB()
        throws TorqueException
    {
        if (aB == null && this.bId != 0)
        {
            aB = org.apache.torque.test.BPeer.retrieveByPK(SimpleKey.keyFor(this.bId));
        }
        return aB;
    }

    /**
     * Return the associated B object
     * If it was not retrieved before, the object is retrieved from
     * the database using the passed connection
     *
     * @param connection the connection used to retrieve the associated object
     *        from the database, if it was not retrieved before
     * @return the associated B object
     * @throws TorqueException
     */
    public B getB(Connection connection)
        throws TorqueException
    {
        if (aB == null && this.bId != 0)
        {
            aB = org.apache.torque.test.BPeer.retrieveByPK(SimpleKey.keyFor(this.bId), connection);
        }
        return aB;
    }


    /**
     * Declares an association between this object and a B object
     *
     * @param v B
     */
    public void setB(B v)
    {
        if (v == null)
        {
            setBId(0);
        }
        else
        {
            setBId(v.getBId());
        }
        aB = v;
    }
    /**
     * Provides convenient way to set a relationship based on a
     * ObjectKey, for example
     * <code>bar.setFooKey(foo.getPrimaryKey())</code>
     *
     */
    public void setBKey(ObjectKey key) throws TorqueException
    {
       
        setBId(((NumberKey) key).intValue());
     }






    private static final List<String> FIELD_NAMES;

    static
    {
        List<String> fieldNames
                = new ArrayList<String>();
        fieldNames.add("CId");
        fieldNames.add("AId");
        fieldNames.add("BId");
        fieldNames.add("Name");
        FIELD_NAMES = Collections.unmodifiableList(fieldNames);
    }

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static List<String> getFieldNames()
    {
        return FIELD_NAMES;
    }

    /**
     * Retrieves a field from the object by field (Java) name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
        if (name.equals("CId"))
        {
            return new Integer(getCId());
        }
        if (name.equals("AId"))
        {
            return new Integer(getAId());
        }
        if (name.equals("BId"))
        {
            return new Integer(getBId());
        }
        if (name.equals("Name"))
        {
            return getName();
        }
        return null;
    }

    /**
     * Set a field in the object by field (Java) name.
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (name.equals("CId"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setCId(((Integer) value).intValue());
            return true;
        }
        if (name.equals("AId"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setAId(((Integer) value).intValue());
            return true;
        }
        if (name.equals("BId"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setBId(((Integer) value).intValue());
            return true;
        }
        if (name.equals("Name"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setName((String) value);
            return true;
        }
        return false;
    }

    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
        if (name.equals(org.apache.torque.test.CPeer.C_ID))
        {
            return new Integer(getCId());
        }
        if (name.equals(org.apache.torque.test.CPeer.A_ID))
        {
            return new Integer(getAId());
        }
        if (name.equals(org.apache.torque.test.CPeer.B_ID))
        {
            return new Integer(getBId());
        }
        if (name.equals(org.apache.torque.test.CPeer.NAME))
        {
            return getName();
        }
        return null;
    }

    /**
     * Set field values by Peer Field Name
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPeerName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (org.apache.torque.test.CPeer.C_ID.getSqlExpression().equals(name))
        {
            return setByName("CId", value);
        }
        if (org.apache.torque.test.CPeer.A_ID.getSqlExpression().equals(name))
        {
            return setByName("AId", value);
        }
        if (org.apache.torque.test.CPeer.B_ID.getSqlExpression().equals(name))
        {
            return setByName("BId", value);
        }
        if (org.apache.torque.test.CPeer.NAME.getSqlExpression().equals(name))
        {
            return setByName("Name", value);
        }
        return false;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
        if (pos == 0)
        {
            return new Integer(getCId());
        }
        if (pos == 1)
        {
            return new Integer(getAId());
        }
        if (pos == 2)
        {
            return new Integer(getBId());
        }
        if (pos == 3)
        {
            return getName();
        }
        return null;
    }

    /**
     * Set field values by its position (zero based) in the XML schema.
     *
     * @param position The field position
     * @param value field value
     * @return True if value was set, false if not (invalid position / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPosition(int position, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (position == 0)
        {
            return setByName("CId", value);
        }
        if (position == 1)
        {
            return setByName("AId", value);
        }
        if (position == 2)
        {
            return setByName("BId", value);
        }
        if (position == 3)
        {
            return setByName("Name", value);
        }
        return false;
    }



    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save() throws TorqueException
    {
        save(CPeer.DATABASE_NAME);
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     * @param dbName the name of the database to which the object
     *        should be saved.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(String dbName) 
            throws TorqueException
    {
        Connection con = null;
        try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally.
     *
     * @param toSave the object to be saved, not null.
     * @param con the connection to use for saving the object, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(Connection con) 
            throws TorqueException
    {
        if (isSaving())
        {
            return;
        }
        try
        {
            setSaving(true);
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    CPeer.doInsert((C) this, con);
                    setNew(false);
                }
                else
                {
                    CPeer.doUpdate((C) this, con);
                }
            }

        }
        finally
        {
            setSaving(false);
        }
    }




    /**
     * Set the PrimaryKey using ObjectKey.
     *
     * @param key cId ObjectKey
     */
    public void setPrimaryKey(ObjectKey key)
        
    {
        setCId(((NumberKey) key).intValue());
    }

    /**
     * Set the PrimaryKey using a String.
     *
     * @param key
     */
    public void setPrimaryKey(String key) 
    {
        setCId(Integer.parseInt(key));
    }


    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        return SimpleKey.keyFor(getCId());
    }


    /**
     * Returns an id that differentiates the referenced RAb object
     * from all other RAb objects.
     *
     * @return an ObjectKey.
     */
    public ObjectKey getForeignKeyForRAb()
    {
        SimpleKey[] pks = new SimpleKey[2];
        pks[0] = SimpleKey.keyFor(getAId());
        pks[1] = SimpleKey.keyFor(getBId());
        return new ComboKey(pks);
    }
    /**
     * Returns an id that differentiates the referenced A object
     * from all other A objects.
     *
     * @return an ObjectKey.
     */
    public ObjectKey getForeignKeyForA()
    {
        int foreignKey = getAId();
        if (foreignKey == 0)
        {
            return SimpleKey.keyFor((Number) null);
        }
        return SimpleKey.keyFor(foreignKey);
    }
    /**
     * Returns an id that differentiates the referenced B object
     * from all other B objects.
     *
     * @return an ObjectKey.
     */
    public ObjectKey getForeignKeyForB()
    {
        int foreignKey = getBId();
        if (foreignKey == 0)
        {
            return SimpleKey.keyFor((Number) null);
        }
        return SimpleKey.keyFor(foreignKey);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public C copy() throws TorqueException
    {
        return copy(true);
    }

    /**
     * Makes a copy of this object using a connection.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     *
     * @param con the database connection to read associated objects.
     */
    public C copy(Connection con) throws TorqueException
    {
        return copy(true, con);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     */
    public C copy(boolean deepcopy) throws TorqueException
    {
        C c = new C();

        return copyInto(c, deepcopy);
    }

    /**
     * Makes a copy of this object using connection.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @param con the database connection to read associated objects.
     */
    public C copy(boolean deepcopy, Connection con) throws TorqueException
    {
        C c = new C();

        return copyInto(c, deepcopy, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     */
    protected C copyInto(C copyObj) throws TorqueException
    {
        return copyInto(copyObj, true);
    }

    /**
     * Fills the copyObj with the contents of this object using connection.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param con the database connection to read associated objects.
     */
    protected C copyInto(C copyObj, Connection con) throws TorqueException
    {
        return copyInto(copyObj, true, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     */
    protected C copyInto(C copyObj, boolean deepcopy) throws TorqueException
    {
        copyObj.setCId(0);
        copyObj.setAId(aId);
        copyObj.setBId(bId);
        copyObj.setName(name);

        if (deepcopy)
        {
        }
        return copyObj;
    }
        
    
    /**
     * Fills the copyObj with the contents of this object using connection.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @param con the database connection to read associated objects.
     */
    protected C copyInto(C copyObj, boolean deepcopy, Connection con) throws TorqueException
    {
        copyObj.setCId(0);
        copyObj.setAId(aId);
        copyObj.setBId(bId);
        copyObj.setName(name);

        if (deepcopy)
        {
        }
        return copyObj;
    }

    /** The Peer class */
    private static final org.apache.torque.test.CPeer peer
            = new org.apache.torque.test.CPeer();

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public org.apache.torque.test.CPeer getPeer()
    {
        return peer;
    }

    /**
     * Retrieves the TableMap object related to this Table data without
     * compiler warnings of using getPeer().getTableMap().
     *
     * @return The associated TableMap object.
     */
    public TableMap getTableMap() throws TorqueException
    {
        return org.apache.torque.test.CPeer.getTableMap();
    }



    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("C:\n");
        str.append("cId = ")
           .append(getCId())
           .append("\n");
        str.append("aId = ")
           .append(getAId())
           .append("\n");
        str.append("bId = ")
           .append(getBId())
           .append("\n");
        str.append("name = ")
           .append(getName())
           .append("\n");
        return(str.toString());
    }

    /**
     * Compares the primary key of this instance with the key of another.
     *
     * @param toCompare The object to compare to.
     * @return Whether the primary keys are equal and the object have the
     *         same class.
     */
    public boolean equals(Object toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!getClass().equals(toCompare.getClass()))
        {
            return false;
        }
        C other = (C) toCompare;
        if (getPrimaryKey() == null || other.getPrimaryKey() == null)
        {
            return false;
        }
        return getPrimaryKey().equals(other.getPrimaryKey());
    }

    /**
     * If the primary key is not <code>null</code>, return the hashcode of the
     * primary key.  Otherwise calls <code>Object.hashCode()</code>.
     *
     * @return an <code>int</code> value
     */
    public int hashCode()
    {
        ObjectKey ok = getPrimaryKey();
        if (ok == null)
        {
            return super.hashCode();
        }

        return ok.hashCode();
    }




}
