package org.apache.torque.test;

import java.io.Serializable;
import java.sql.Connection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.apache.torque.TorqueException;
import org.apache.torque.map.TableMap;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.BooleanKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.om.ColumnAccessByName;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.util.Transaction;
import org.apache.commons.lang.ObjectUtils;


/**
 * Table to test circular references
 *
 * This class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:40 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to CircularReferenceA
 */
public abstract class BaseCircularReferenceA 
    implements Persistent, Serializable, ColumnAccessByName
{
    /** Serial version */
    private static final long serialVersionUID = 1347503740845L;



    /** Defines the circularReferenceAId field. */
    private int circularReferenceAId = 0;

    /** Defines the circularReferenceBId field. */
    private int circularReferenceBId = 0;

    /** Whether this object was modified after loading or after last save. */
    private boolean modified = true;

    /** 
     * Whether this object was loaded from the database or already saved 
     * (false) or whether it is not yet in the database(true).
     */
    private boolean isNew = true;

    /** Flag which indicates whether this object is currently saving. */
    private boolean saving = false;

    /** 
     * Flag which indicates whether this object is currently loaded
     * from the database. 
     */
    private boolean loading = false;

    /** 
     * Flag which indicates whether this object was deleted from the database.
     * Note that this flags does not always display the current database state,
     * there is no magical connection between this flag and the database.
     */
    private boolean deleted = false;

    /** Defines the aCircularReferenceB field. */
    private CircularReferenceB aCircularReferenceB = null;



    /** Defines the collCircularReferenceBs field. */
    protected List<CircularReferenceB> collCircularReferenceBs = null;



    /**
     * Get the value of circularReferenceAId.
     *
     * @return int
     */
    public int getCircularReferenceAId() 
    {
        
        return circularReferenceAId;
    }

    /**
     * Set the value of circularReferenceAId.
     *
     * @param v new value
     */
    public void setCircularReferenceAId(int v)
    {
        if (this.circularReferenceAId != v)
        {
            setModified(true);
        }

        this.circularReferenceAId = v;

        // update associated objects in collCircularReferenceBs 
        if (collCircularReferenceBs != null)
        {
            for (int i = 0; i < collCircularReferenceBs.size(); i++)
            {
                ((CircularReferenceB) collCircularReferenceBs.get(i))
                        .setCircularReferenceAId(v);
            }
        }

    }
    
    /**
     * Get the value of circularReferenceBId.
     *
     * @return int
     */
    public int getCircularReferenceBId() 
    {
        
        return circularReferenceBId;
    }

    /**
     * Set the value of circularReferenceBId.
     *
     * @param v new value
     */
    public void setCircularReferenceBId(int v)
    {
        if (this.circularReferenceBId != v)
        {
            setModified(true);
        }

        this.circularReferenceBId = v;
        if (aCircularReferenceB != null && aCircularReferenceB.getCircularReferenceBId() != v)
        {
            aCircularReferenceB = null;
        }


    }
    

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return true, if the object has never been persisted.
     */
    public boolean isNew()
    {
        return isNew;
    }

    /**
     * Sets whether the object has ever been saved.
     *
     * @param isNew true if the object has never been saved, false otherwise.
     */
    public void setNew(boolean isNew)
    {
        this.isNew = isNew;
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return True if the object has been modified.
     */
    public boolean isModified()
    {
        return modified;
    }

    /**
     * Sets whether the object has been modified.
     *
     * @param modified true if the object has been modified, false otherwise.
     */
    public void setModified(boolean modified)
    {
        this.modified = modified;
    }

    /**
     * Sets the modified state for the object to be false.
     */
    public void resetModified()
    {
        modified = false;
    }


    /**
     * Returns whether this object is currently saving.
     *
     * @return true if this object is currently saving, false otherwise.
     */
    public boolean isSaving()
    {
        return saving;
    }

    /**
     * Sets whether this object is currently saving.
     *
     * @param saving true if this object is currently saving, false otherwise.
     */
    public void setSaving(boolean saving)
    {
        this.saving = saving;
    }


    /**
     * Returns whether this object is currently being loaded from the database.
     *
     * @return true if this object is currently loading, false otherwise.
     */
    public boolean isLoading()
    {
        return loading;
    }

    /**
     * Sets whether this object is currently being loaded from the database.
     *
     * @param loading true if this object is currently loading, false otherwise.
     */
    public void setLoading(boolean loading)
    {
        this.loading = loading;
    }


    /**
     * Returns whether this object was deleted from the database.
     * Note that this getter does not automatically reflect database state,
     * it will be set to true by Torque if doDelete() was called with this 
     * object. Bulk deletes and deletes via primary key do not change
     * this flag. Also, if doDelete() was called on an object which does
     * not exist in the database, the deleted flag is set to true even if
     * it was not deleted.
     *
     * @return true if this object was deleted, false otherwise.
     */
    public boolean isDeleted()
    {
        return deleted;
    }

    /**
     * Sets whether this object was deleted from the database.
     *
     * @param deleted true if this object was deleted, false otherwise.
     */
    public void setDeleted(boolean deleted)
    {
        this.deleted = deleted;
    }


    /**
     * Returns the associated CircularReferenceB object.
     * If it was not retrieved before, the object is retrieved from
     * the database
     *
     * @return the associated CircularReferenceB object
     * @throws TorqueException when reading from the database fails.
     */
    public CircularReferenceB getCircularReferenceB()
        throws TorqueException
    {
        if (aCircularReferenceB == null && this.circularReferenceBId != 0)
        {
            aCircularReferenceB = org.apache.torque.test.CircularReferenceBPeer.retrieveByPK(SimpleKey.keyFor(this.circularReferenceBId));
        }
        return aCircularReferenceB;
    }

    /**
     * Return the associated CircularReferenceB object
     * If it was not retrieved before, the object is retrieved from
     * the database using the passed connection
     *
     * @param connection the connection used to retrieve the associated object
     *        from the database, if it was not retrieved before
     * @return the associated CircularReferenceB object
     * @throws TorqueException
     */
    public CircularReferenceB getCircularReferenceB(Connection connection)
        throws TorqueException
    {
        if (aCircularReferenceB == null && this.circularReferenceBId != 0)
        {
            aCircularReferenceB = org.apache.torque.test.CircularReferenceBPeer.retrieveByPK(SimpleKey.keyFor(this.circularReferenceBId), connection);
        }
        return aCircularReferenceB;
    }


    /**
     * Declares an association between this object and a CircularReferenceB object
     *
     * @param v CircularReferenceB
     */
    public void setCircularReferenceB(CircularReferenceB v)
    {
        if (v == null)
        {
            setCircularReferenceBId(0);
        }
        else
        {
            setCircularReferenceBId(v.getCircularReferenceBId());
        }
        aCircularReferenceB = v;
    }
    /**
     * Provides convenient way to set a relationship based on a
     * ObjectKey, for example
     * <code>bar.setFooKey(foo.getPrimaryKey())</code>
     *
     */
    public void setCircularReferenceBKey(ObjectKey key) throws TorqueException
    {
       
        setCircularReferenceBId(((NumberKey) key).intValue());
     }



    /**
     * Initializes the cache collCircularReferenceBs for referenced objects. 
     */
    public void initCircularReferenceBs()
    {
        if (collCircularReferenceBs == null)
        {
            collCircularReferenceBs = new ArrayList<CircularReferenceB>();
        }
    }

    /**
     * Checks whether the cache collCircularReferenceBs for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isCircularReferenceBsInitialized()
    {
        return (collCircularReferenceBs != null);
    }


    /**
     * Method called to associate a CircularReferenceB object to this object
     * through the collCircularReferenceBs foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addCircularReferenceB(CircularReferenceB toAdd)
        throws TorqueException
    {
        toAdd.setCircularReferenceA((CircularReferenceA) this);
        getCircularReferenceBs().add(toAdd);
    }

    /**
     * Method called to associate a CircularReferenceB object to this object
     * through the collCircularReferenceBs foreign key attribute using connection.
     *
     * @param l CircularReferenceB
     * @throws TorqueException
     */
    public void addCircularReferenceB(CircularReferenceB l, Connection con) throws TorqueException
    {
        getCircularReferenceBs(con).add(l);
        l.setCircularReferenceA((CircularReferenceA) this);
    }
    
    /**
     * The criteria used to select the current contents of collCircularReferenceBs
     */
    private Criteria lastCircularReferenceBCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getCircularReferenceBs(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<CircularReferenceB> getCircularReferenceBs()
        throws TorqueException
    {
        if (collCircularReferenceBs == null)
        {
            collCircularReferenceBs = getCircularReferenceBs(new Criteria());
        }
        return collCircularReferenceBs;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseCircularReferenceA has previously
     * been saved, it will retrieve related collCircularReferenceBs from storage.
     * If this BaseCircularReferenceA is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<CircularReferenceB> getCircularReferenceBs(Criteria criteria) throws TorqueException
    {
        if (collCircularReferenceBs == null)
        {
            if (isNew())
            {
               initCircularReferenceBs();
            }
            else
            {
                criteria.and(org.apache.torque.test.CircularReferenceBPeer.CIRCULAR_REFERENCE_A_ID, getCircularReferenceAId() );
                collCircularReferenceBs = org.apache.torque.test.CircularReferenceBPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.CircularReferenceBPeer.CIRCULAR_REFERENCE_A_ID, getCircularReferenceAId() );
                if (lastCircularReferenceBCriteria == null 
                        || !lastCircularReferenceBCriteria.equals(criteria))
                {
                    collCircularReferenceBs = org.apache.torque.test.CircularReferenceBPeer.doSelect(criteria);
                }
            }
        }
        lastCircularReferenceBCriteria = criteria;

        return collCircularReferenceBs;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getCircularReferenceBs(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<CircularReferenceB> getCircularReferenceBs(Connection con) throws TorqueException
    {
        if (collCircularReferenceBs == null)
        {
            collCircularReferenceBs = getCircularReferenceBs(new Criteria(), con);
        }
        return collCircularReferenceBs;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseCircularReferenceA has previously
     * been saved, it will retrieve the related CircularReferenceB Objects 
     * from storage.
     * If this BaseCircularReferenceA is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<CircularReferenceB> getCircularReferenceBs(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collCircularReferenceBs == null)
        {
            if (isNew())
            {
               initCircularReferenceBs();
            }
            else
            {
                criteria.and(org.apache.torque.test.CircularReferenceBPeer.CIRCULAR_REFERENCE_A_ID, getCircularReferenceAId());
                collCircularReferenceBs = org.apache.torque.test.CircularReferenceBPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.CircularReferenceBPeer.CIRCULAR_REFERENCE_A_ID, getCircularReferenceAId());
                if (!lastCircularReferenceBCriteria.equals(criteria))
                {
                    collCircularReferenceBs = org.apache.torque.test.CircularReferenceBPeer.doSelect(criteria, con);
                }
            }
        }
        lastCircularReferenceBCriteria = criteria;

        return collCircularReferenceBs;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseCircularReferenceA is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<CircularReferenceB> getCircularReferenceBsJoinCircularReferenceA(Criteria criteria) throws TorqueException
    {
        return getCircularReferenceBsJoinCircularReferenceA(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseCircularReferenceA is new, it will return
     * an empty collection; or if this BaseCircularReferenceA has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<CircularReferenceB> getCircularReferenceBsJoinCircularReferenceA(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collCircularReferenceBs == null)
        {
            if (isNew())
            {
                initCircularReferenceBs();
            }
            else
            {
                criteria.and(org.apache.torque.test.CircularReferenceBPeer.CIRCULAR_REFERENCE_A_ID, getCircularReferenceAId() );
                collCircularReferenceBs = org.apache.torque.test.CircularReferenceBPeer.doSelectJoinCircularReferenceA(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.CircularReferenceBPeer.CIRCULAR_REFERENCE_A_ID, getCircularReferenceAId() );
            if (!lastCircularReferenceBCriteria.equals(criteria))
            {
                collCircularReferenceBs = org.apache.torque.test.CircularReferenceBPeer.doSelectJoinCircularReferenceA(criteria, connection);
            }
        }
        lastCircularReferenceBCriteria = criteria;

        return collCircularReferenceBs;
    }




    private static final List<String> FIELD_NAMES;

    static
    {
        List<String> fieldNames
                = new ArrayList<String>();
        fieldNames.add("CircularReferenceAId");
        fieldNames.add("CircularReferenceBId");
        FIELD_NAMES = Collections.unmodifiableList(fieldNames);
    }

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static List<String> getFieldNames()
    {
        return FIELD_NAMES;
    }

    /**
     * Retrieves a field from the object by field (Java) name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
        if (name.equals("CircularReferenceAId"))
        {
            return new Integer(getCircularReferenceAId());
        }
        if (name.equals("CircularReferenceBId"))
        {
            return new Integer(getCircularReferenceBId());
        }
        return null;
    }

    /**
     * Set a field in the object by field (Java) name.
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (name.equals("CircularReferenceAId"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setCircularReferenceAId(((Integer) value).intValue());
            return true;
        }
        if (name.equals("CircularReferenceBId"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setCircularReferenceBId(((Integer) value).intValue());
            return true;
        }
        return false;
    }

    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
        if (name.equals(org.apache.torque.test.CircularReferenceAPeer.CIRCULAR_REFERENCE_A_ID))
        {
            return new Integer(getCircularReferenceAId());
        }
        if (name.equals(org.apache.torque.test.CircularReferenceAPeer.CIRCULAR_REFERENCE_B_ID))
        {
            return new Integer(getCircularReferenceBId());
        }
        return null;
    }

    /**
     * Set field values by Peer Field Name
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPeerName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (org.apache.torque.test.CircularReferenceAPeer.CIRCULAR_REFERENCE_A_ID.getSqlExpression().equals(name))
        {
            return setByName("CircularReferenceAId", value);
        }
        if (org.apache.torque.test.CircularReferenceAPeer.CIRCULAR_REFERENCE_B_ID.getSqlExpression().equals(name))
        {
            return setByName("CircularReferenceBId", value);
        }
        return false;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
        if (pos == 0)
        {
            return new Integer(getCircularReferenceAId());
        }
        if (pos == 1)
        {
            return new Integer(getCircularReferenceBId());
        }
        return null;
    }

    /**
     * Set field values by its position (zero based) in the XML schema.
     *
     * @param position The field position
     * @param value field value
     * @return True if value was set, false if not (invalid position / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPosition(int position, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (position == 0)
        {
            return setByName("CircularReferenceAId", value);
        }
        if (position == 1)
        {
            return setByName("CircularReferenceBId", value);
        }
        return false;
    }



    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save() throws TorqueException
    {
        save(CircularReferenceAPeer.DATABASE_NAME);
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     * @param dbName the name of the database to which the object
     *        should be saved.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(String dbName) 
            throws TorqueException
    {
        Connection con = null;
        try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally.
     *
     * @param toSave the object to be saved, not null.
     * @param con the connection to use for saving the object, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(Connection con) 
            throws TorqueException
    {
        if (isSaving())
        {
            return;
        }
        try
        {
            setSaving(true);
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    CircularReferenceAPeer.doInsert((CircularReferenceA) this, con);
                    setNew(false);
                }
                else
                {
                    CircularReferenceAPeer.doUpdate((CircularReferenceA) this, con);
                }
            }

            if (isCircularReferenceBsInitialized())
            {
                for (CircularReferenceB collCircularReferenceBs : getCircularReferenceBs())
                {
                    collCircularReferenceBs.save(con);
                }
            }
        }
        finally
        {
            setSaving(false);
        }
    }




    /**
     * Set the PrimaryKey using ObjectKey.
     *
     * @param key circularReferenceAId ObjectKey
     */
    public void setPrimaryKey(ObjectKey key)
        
    {
        setCircularReferenceAId(((NumberKey) key).intValue());
    }

    /**
     * Set the PrimaryKey using a String.
     *
     * @param key
     */
    public void setPrimaryKey(String key) 
    {
        setCircularReferenceAId(Integer.parseInt(key));
    }


    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        return SimpleKey.keyFor(getCircularReferenceAId());
    }


    /**
     * Returns an id that differentiates the referenced CircularReferenceB object
     * from all other CircularReferenceB objects.
     *
     * @return an ObjectKey.
     */
    public ObjectKey getForeignKeyForCircularReferenceB()
    {
        int foreignKey = getCircularReferenceBId();
        if (foreignKey == 0)
        {
            return SimpleKey.keyFor((Number) null);
        }
        return SimpleKey.keyFor(foreignKey);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public CircularReferenceA copy() throws TorqueException
    {
        return copy(true);
    }

    /**
     * Makes a copy of this object using a connection.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     *
     * @param con the database connection to read associated objects.
     */
    public CircularReferenceA copy(Connection con) throws TorqueException
    {
        return copy(true, con);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     */
    public CircularReferenceA copy(boolean deepcopy) throws TorqueException
    {
        CircularReferenceA circularReferenceA = new CircularReferenceA();

        return copyInto(circularReferenceA, deepcopy);
    }

    /**
     * Makes a copy of this object using connection.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @param con the database connection to read associated objects.
     */
    public CircularReferenceA copy(boolean deepcopy, Connection con) throws TorqueException
    {
        CircularReferenceA circularReferenceA = new CircularReferenceA();

        return copyInto(circularReferenceA, deepcopy, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     */
    protected CircularReferenceA copyInto(CircularReferenceA copyObj) throws TorqueException
    {
        return copyInto(copyObj, true);
    }

    /**
     * Fills the copyObj with the contents of this object using connection.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param con the database connection to read associated objects.
     */
    protected CircularReferenceA copyInto(CircularReferenceA copyObj, Connection con) throws TorqueException
    {
        return copyInto(copyObj, true, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     */
    protected CircularReferenceA copyInto(CircularReferenceA copyObj, boolean deepcopy) throws TorqueException
    {
        copyObj.setCircularReferenceAId(0);
        copyObj.setCircularReferenceBId(circularReferenceBId);

        if (deepcopy)
        {
            if (collCircularReferenceBs != null)
            {
                for (int i = 0; i < collCircularReferenceBs.size(); i++)
                {
                    CircularReferenceB obj = collCircularReferenceBs.get(i);
                    copyObj.addCircularReferenceB(obj.copy());
                }
            }
            else
            {
                copyObj.collCircularReferenceBs = null;
            }
        }
        return copyObj;
    }
        
    
    /**
     * Fills the copyObj with the contents of this object using connection.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @param con the database connection to read associated objects.
     */
    protected CircularReferenceA copyInto(CircularReferenceA copyObj, boolean deepcopy, Connection con) throws TorqueException
    {
        copyObj.setCircularReferenceAId(0);
        copyObj.setCircularReferenceBId(circularReferenceBId);

        if (deepcopy)
        {
            for (CircularReferenceB obj : getCircularReferenceBs(con))
            {
                copyObj.addCircularReferenceB(obj.copy());
            }
        }
        return copyObj;
    }

    /** The Peer class */
    private static final org.apache.torque.test.CircularReferenceAPeer peer
            = new org.apache.torque.test.CircularReferenceAPeer();

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public org.apache.torque.test.CircularReferenceAPeer getPeer()
    {
        return peer;
    }

    /**
     * Retrieves the TableMap object related to this Table data without
     * compiler warnings of using getPeer().getTableMap().
     *
     * @return The associated TableMap object.
     */
    public TableMap getTableMap() throws TorqueException
    {
        return org.apache.torque.test.CircularReferenceAPeer.getTableMap();
    }



    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("CircularReferenceA:\n");
        str.append("circularReferenceAId = ")
           .append(getCircularReferenceAId())
           .append("\n");
        str.append("circularReferenceBId = ")
           .append(getCircularReferenceBId())
           .append("\n");
        return(str.toString());
    }

    /**
     * Compares the primary key of this instance with the key of another.
     *
     * @param toCompare The object to compare to.
     * @return Whether the primary keys are equal and the object have the
     *         same class.
     */
    public boolean equals(Object toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!getClass().equals(toCompare.getClass()))
        {
            return false;
        }
        CircularReferenceA other = (CircularReferenceA) toCompare;
        if (getPrimaryKey() == null || other.getPrimaryKey() == null)
        {
            return false;
        }
        return getPrimaryKey().equals(other.getPrimaryKey());
    }

    /**
     * If the primary key is not <code>null</code>, return the hashcode of the
     * primary key.  Otherwise calls <code>Object.hashCode()</code>.
     *
     * @return an <code>int</code> value
     */
    public int hashCode()
    {
        ObjectKey ok = getPrimaryKey();
        if (ok == null)
        {
            return super.hashCode();
        }

        return ok.hashCode();
    }




}
