package org.apache.torque.test;

import java.io.Serializable;
import java.sql.Connection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.apache.torque.TorqueException;
import org.apache.torque.map.TableMap;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.BooleanKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.om.ColumnAccessByName;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.util.Transaction;
import org.apache.commons.lang.ObjectUtils;


/**
 * table with a composite foreign key consisting of an integer           and a varchar column
 *
 * This class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:39 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to CompIntegerVarcharFk
 */
public abstract class BaseCompIntegerVarcharFk 
    implements Persistent, Serializable, ColumnAccessByName
{
    /** Serial version */
    private static final long serialVersionUID = 1347503739366L;



    /** Defines the id field. */
    private Integer id = null;

    /** Defines the fk1 field. */
    private Integer fk1 = null;

    /** Defines the fk2 field. */
    private String fk2 = null;

    /** Defines the name field. */
    private String name = null;

    /** Whether this object was modified after loading or after last save. */
    private boolean modified = true;

    /** 
     * Whether this object was loaded from the database or already saved 
     * (false) or whether it is not yet in the database(true).
     */
    private boolean isNew = true;

    /** Flag which indicates whether this object is currently saving. */
    private boolean saving = false;

    /** 
     * Flag which indicates whether this object is currently loaded
     * from the database. 
     */
    private boolean loading = false;

    /** 
     * Flag which indicates whether this object was deleted from the database.
     * Note that this flags does not always display the current database state,
     * there is no magical connection between this flag and the database.
     */
    private boolean deleted = false;

    /** Defines the aCompIntegerVarcharPk field. */
    private CompIntegerVarcharPk aCompIntegerVarcharPk = null;





    /**
     * Get the value of id.
     *
     * @return Integer
     */
    public Integer getId() 
    {
        
        return id;
    }

    /**
     * Set the value of id.
     *
     * @param v new value
     */
    public void setId(Integer v)
    {
        if (!ObjectUtils.equals(this.id, v))
        {
            setModified(true);
        }

        this.id = v;


    }
    
    /**
     * Get the value of fk1.
     *
     * @return Integer
     */
    public Integer getFk1() 
    {
        
        return fk1;
    }

    /**
     * Set the value of fk1.
     *
     * @param v new value
     */
    public void setFk1(Integer v)
    {
        if (!ObjectUtils.equals(this.fk1, v))
        {
            setModified(true);
        }

        this.fk1 = v;
        if (aCompIntegerVarcharPk != null && !ObjectUtils.equals(aCompIntegerVarcharPk.getId1(), v))
        {
            aCompIntegerVarcharPk = null;
        }


    }
    
    /**
     * Get the value of fk2.
     *
     * @return String
     */
    public String getFk2() 
    {
        
        return fk2;
    }

    /**
     * Set the value of fk2.
     *
     * @param v new value
     */
    public void setFk2(String v)
    {
        if (!ObjectUtils.equals(this.fk2, v))
        {
            setModified(true);
        }

        this.fk2 = v;
        if (aCompIntegerVarcharPk != null && !ObjectUtils.equals(aCompIntegerVarcharPk.getId2(), v))
        {
            aCompIntegerVarcharPk = null;
        }


    }
    
    /**
     * Get the value of name.
     *
     * @return String
     */
    public String getName() 
    {
        
        return name;
    }

    /**
     * Set the value of name.
     *
     * @param v new value
     */
    public void setName(String v)
    {
        if (!ObjectUtils.equals(this.name, v))
        {
            setModified(true);
        }

        this.name = v;


    }
    

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return true, if the object has never been persisted.
     */
    public boolean isNew()
    {
        return isNew;
    }

    /**
     * Sets whether the object has ever been saved.
     *
     * @param isNew true if the object has never been saved, false otherwise.
     */
    public void setNew(boolean isNew)
    {
        this.isNew = isNew;
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return True if the object has been modified.
     */
    public boolean isModified()
    {
        return modified;
    }

    /**
     * Sets whether the object has been modified.
     *
     * @param modified true if the object has been modified, false otherwise.
     */
    public void setModified(boolean modified)
    {
        this.modified = modified;
    }

    /**
     * Sets the modified state for the object to be false.
     */
    public void resetModified()
    {
        modified = false;
    }


    /**
     * Returns whether this object is currently saving.
     *
     * @return true if this object is currently saving, false otherwise.
     */
    public boolean isSaving()
    {
        return saving;
    }

    /**
     * Sets whether this object is currently saving.
     *
     * @param saving true if this object is currently saving, false otherwise.
     */
    public void setSaving(boolean saving)
    {
        this.saving = saving;
    }


    /**
     * Returns whether this object is currently being loaded from the database.
     *
     * @return true if this object is currently loading, false otherwise.
     */
    public boolean isLoading()
    {
        return loading;
    }

    /**
     * Sets whether this object is currently being loaded from the database.
     *
     * @param loading true if this object is currently loading, false otherwise.
     */
    public void setLoading(boolean loading)
    {
        this.loading = loading;
    }


    /**
     * Returns whether this object was deleted from the database.
     * Note that this getter does not automatically reflect database state,
     * it will be set to true by Torque if doDelete() was called with this 
     * object. Bulk deletes and deletes via primary key do not change
     * this flag. Also, if doDelete() was called on an object which does
     * not exist in the database, the deleted flag is set to true even if
     * it was not deleted.
     *
     * @return true if this object was deleted, false otherwise.
     */
    public boolean isDeleted()
    {
        return deleted;
    }

    /**
     * Sets whether this object was deleted from the database.
     *
     * @param deleted true if this object was deleted, false otherwise.
     */
    public void setDeleted(boolean deleted)
    {
        this.deleted = deleted;
    }


    /**
     * Returns the associated CompIntegerVarcharPk object.
     * If it was not retrieved before, the object is retrieved from
     * the database
     *
     * @return the associated CompIntegerVarcharPk object
     * @throws TorqueException when reading from the database fails.
     */
    public CompIntegerVarcharPk getCompIntegerVarcharPk()
        throws TorqueException
    {
        if (aCompIntegerVarcharPk == null && !org.apache.commons.lang.ObjectUtils.equals(this.fk1, null) && !org.apache.commons.lang.ObjectUtils.equals(this.fk2, null))
        {
            aCompIntegerVarcharPk = org.apache.torque.test.CompIntegerVarcharPkPeer.retrieveByPK(this.fk1, this.fk2);
        }
        return aCompIntegerVarcharPk;
    }

    /**
     * Return the associated CompIntegerVarcharPk object
     * If it was not retrieved before, the object is retrieved from
     * the database using the passed connection
     *
     * @param connection the connection used to retrieve the associated object
     *        from the database, if it was not retrieved before
     * @return the associated CompIntegerVarcharPk object
     * @throws TorqueException
     */
    public CompIntegerVarcharPk getCompIntegerVarcharPk(Connection connection)
        throws TorqueException
    {
        if (aCompIntegerVarcharPk == null && !org.apache.commons.lang.ObjectUtils.equals(this.fk1, null) && !org.apache.commons.lang.ObjectUtils.equals(this.fk2, null))
        {
            aCompIntegerVarcharPk = org.apache.torque.test.CompIntegerVarcharPkPeer.retrieveByPK(this.fk1, this.fk2, connection);
        }
        return aCompIntegerVarcharPk;
    }


    /**
     * Declares an association between this object and a CompIntegerVarcharPk object
     *
     * @param v CompIntegerVarcharPk
     */
    public void setCompIntegerVarcharPk(CompIntegerVarcharPk v)
    {
        if (v == null)
        {
            setFk1(null);
        }
        else
        {
            setFk1(v.getId1());
        }
        if (v == null)
        {
            setFk2(null);
        }
        else
        {
            setFk2(v.getId2());
        }
        aCompIntegerVarcharPk = v;
    }
    /**
     * Provides convenient way to set a relationship based on a
     * ObjectKey, for example
     * <code>bar.setFooKey(foo.getPrimaryKey())</code>
     *
     * Note: It is important that the xml schema used to create this class
     * maintains consistency in the order of related columns between
     * COMP_INTEGER_VARCHAR_FK and COMP_INTEGER_VARCHAR_PK.
     * If for some reason this is impossible, this method should be
     * overridden in <code>CompIntegerVarcharFk</code>.
     */
    public void setCompIntegerVarcharPkKey(ObjectKey key) throws TorqueException
    {
        SimpleKey[] keys = (SimpleKey[]) key.getValue();
       
        setFk1(Integer.valueOf(((NumberKey) keys[0]).intValue()));
        setFk2(keys[1].toString());
     }






    private static final List<String> FIELD_NAMES;

    static
    {
        List<String> fieldNames
                = new ArrayList<String>();
        fieldNames.add("Id");
        fieldNames.add("Fk1");
        fieldNames.add("Fk2");
        fieldNames.add("Name");
        FIELD_NAMES = Collections.unmodifiableList(fieldNames);
    }

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static List<String> getFieldNames()
    {
        return FIELD_NAMES;
    }

    /**
     * Retrieves a field from the object by field (Java) name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
        if (name.equals("Id"))
        {
            return getId();
        }
        if (name.equals("Fk1"))
        {
            return getFk1();
        }
        if (name.equals("Fk2"))
        {
            return getFk2();
        }
        if (name.equals("Name"))
        {
            return getName();
        }
        return null;
    }

    /**
     * Set a field in the object by field (Java) name.
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (name.equals("Id"))
        {
            // Object fields can be null
            if (value != null && ! Integer.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setId((Integer) value);
            return true;
        }
        if (name.equals("Fk1"))
        {
            // Object fields can be null
            if (value != null && ! Integer.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setFk1((Integer) value);
            return true;
        }
        if (name.equals("Fk2"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setFk2((String) value);
            return true;
        }
        if (name.equals("Name"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setName((String) value);
            return true;
        }
        return false;
    }

    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
        if (name.equals(org.apache.torque.test.CompIntegerVarcharFkPeer.ID))
        {
            return getId();
        }
        if (name.equals(org.apache.torque.test.CompIntegerVarcharFkPeer.FK1))
        {
            return getFk1();
        }
        if (name.equals(org.apache.torque.test.CompIntegerVarcharFkPeer.FK2))
        {
            return getFk2();
        }
        if (name.equals(org.apache.torque.test.CompIntegerVarcharFkPeer.NAME))
        {
            return getName();
        }
        return null;
    }

    /**
     * Set field values by Peer Field Name
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPeerName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (org.apache.torque.test.CompIntegerVarcharFkPeer.ID.getSqlExpression().equals(name))
        {
            return setByName("Id", value);
        }
        if (org.apache.torque.test.CompIntegerVarcharFkPeer.FK1.getSqlExpression().equals(name))
        {
            return setByName("Fk1", value);
        }
        if (org.apache.torque.test.CompIntegerVarcharFkPeer.FK2.getSqlExpression().equals(name))
        {
            return setByName("Fk2", value);
        }
        if (org.apache.torque.test.CompIntegerVarcharFkPeer.NAME.getSqlExpression().equals(name))
        {
            return setByName("Name", value);
        }
        return false;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
        if (pos == 0)
        {
            return getId();
        }
        if (pos == 1)
        {
            return getFk1();
        }
        if (pos == 2)
        {
            return getFk2();
        }
        if (pos == 3)
        {
            return getName();
        }
        return null;
    }

    /**
     * Set field values by its position (zero based) in the XML schema.
     *
     * @param position The field position
     * @param value field value
     * @return True if value was set, false if not (invalid position / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPosition(int position, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (position == 0)
        {
            return setByName("Id", value);
        }
        if (position == 1)
        {
            return setByName("Fk1", value);
        }
        if (position == 2)
        {
            return setByName("Fk2", value);
        }
        if (position == 3)
        {
            return setByName("Name", value);
        }
        return false;
    }



    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save() throws TorqueException
    {
        save(CompIntegerVarcharFkPeer.DATABASE_NAME);
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     * @param dbName the name of the database to which the object
     *        should be saved.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(String dbName) 
            throws TorqueException
    {
        Connection con = null;
        try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally.
     *
     * @param toSave the object to be saved, not null.
     * @param con the connection to use for saving the object, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(Connection con) 
            throws TorqueException
    {
        if (isSaving())
        {
            return;
        }
        try
        {
            setSaving(true);
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    CompIntegerVarcharFkPeer.doInsert((CompIntegerVarcharFk) this, con);
                    setNew(false);
                }
                else
                {
                    CompIntegerVarcharFkPeer.doUpdate((CompIntegerVarcharFk) this, con);
                }
            }

        }
        finally
        {
            setSaving(false);
        }
    }




    /**
     * Set the PrimaryKey using ObjectKey.
     *
     * @param key id ObjectKey
     */
    public void setPrimaryKey(ObjectKey key)
        
    {
        setId(Integer.valueOf(((NumberKey) key).intValue()));
    }

    /**
     * Set the PrimaryKey using a String.
     *
     * @param key
     */
    public void setPrimaryKey(String key) 
    {
        setId(new Integer(key));
    }


    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        return SimpleKey.keyFor(getId());
    }


    /**
     * Returns an id that differentiates the referenced CompIntegerVarcharPk object
     * from all other CompIntegerVarcharPk objects.
     *
     * @return an ObjectKey.
     */
    public ObjectKey getForeignKeyForCompIntegerVarcharPk()
    {
        SimpleKey[] pks = new SimpleKey[2];
        pks[0] = SimpleKey.keyFor(getFk1());
        pks[1] = SimpleKey.keyFor(getFk2());
        return new ComboKey(pks);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public CompIntegerVarcharFk copy() throws TorqueException
    {
        return copy(true);
    }

    /**
     * Makes a copy of this object using a connection.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     *
     * @param con the database connection to read associated objects.
     */
    public CompIntegerVarcharFk copy(Connection con) throws TorqueException
    {
        return copy(true, con);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     */
    public CompIntegerVarcharFk copy(boolean deepcopy) throws TorqueException
    {
        CompIntegerVarcharFk compIntegerVarcharFk = new CompIntegerVarcharFk();

        return copyInto(compIntegerVarcharFk, deepcopy);
    }

    /**
     * Makes a copy of this object using connection.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @param con the database connection to read associated objects.
     */
    public CompIntegerVarcharFk copy(boolean deepcopy, Connection con) throws TorqueException
    {
        CompIntegerVarcharFk compIntegerVarcharFk = new CompIntegerVarcharFk();

        return copyInto(compIntegerVarcharFk, deepcopy, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     */
    protected CompIntegerVarcharFk copyInto(CompIntegerVarcharFk copyObj) throws TorqueException
    {
        return copyInto(copyObj, true);
    }

    /**
     * Fills the copyObj with the contents of this object using connection.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param con the database connection to read associated objects.
     */
    protected CompIntegerVarcharFk copyInto(CompIntegerVarcharFk copyObj, Connection con) throws TorqueException
    {
        return copyInto(copyObj, true, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     */
    protected CompIntegerVarcharFk copyInto(CompIntegerVarcharFk copyObj, boolean deepcopy) throws TorqueException
    {
        copyObj.setId((Integer) null);
        copyObj.setFk1(fk1);
        copyObj.setFk2(fk2);
        copyObj.setName(name);

        if (deepcopy)
        {
        }
        return copyObj;
    }
        
    
    /**
     * Fills the copyObj with the contents of this object using connection.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @param con the database connection to read associated objects.
     */
    protected CompIntegerVarcharFk copyInto(CompIntegerVarcharFk copyObj, boolean deepcopy, Connection con) throws TorqueException
    {
        copyObj.setId((Integer) null);
        copyObj.setFk1(fk1);
        copyObj.setFk2(fk2);
        copyObj.setName(name);

        if (deepcopy)
        {
        }
        return copyObj;
    }

    /** The Peer class */
    private static final org.apache.torque.test.CompIntegerVarcharFkPeer peer
            = new org.apache.torque.test.CompIntegerVarcharFkPeer();

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public org.apache.torque.test.CompIntegerVarcharFkPeer getPeer()
    {
        return peer;
    }

    /**
     * Retrieves the TableMap object related to this Table data without
     * compiler warnings of using getPeer().getTableMap().
     *
     * @return The associated TableMap object.
     */
    public TableMap getTableMap() throws TorqueException
    {
        return org.apache.torque.test.CompIntegerVarcharFkPeer.getTableMap();
    }



    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("CompIntegerVarcharFk:\n");
        str.append("id = ")
           .append(getId())
           .append("\n");
        str.append("fk1 = ")
           .append(getFk1())
           .append("\n");
        str.append("fk2 = ")
           .append(getFk2())
           .append("\n");
        str.append("name = ")
           .append(getName())
           .append("\n");
        return(str.toString());
    }

    /**
     * Compares the primary key of this instance with the key of another.
     *
     * @param toCompare The object to compare to.
     * @return Whether the primary keys are equal and the object have the
     *         same class.
     */
    public boolean equals(Object toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!getClass().equals(toCompare.getClass()))
        {
            return false;
        }
        CompIntegerVarcharFk other = (CompIntegerVarcharFk) toCompare;
        if (getPrimaryKey() == null || other.getPrimaryKey() == null)
        {
            return false;
        }
        return getPrimaryKey().equals(other.getPrimaryKey());
    }

    /**
     * If the primary key is not <code>null</code>, return the hashcode of the
     * primary key.  Otherwise calls <code>Object.hashCode()</code>.
     *
     * @return an <code>int</code> value
     */
    public int hashCode()
    {
        ObjectKey ok = getPrimaryKey();
        if (ok == null)
        {
            return super.hashCode();
        }

        return ok.hashCode();
    }




}
