package org.apache.torque.test;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.apache.torque.TorqueException;
import org.apache.torque.om.mapper.RecordMapper;

    
/**
 * Maps ResultSet rows into CompIntegerVarcharFk objects.
 *
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:47 CEST 2012]
 *
 */
public class BaseCompIntegerVarcharFkRecordMapper implements RecordMapper<CompIntegerVarcharFk>
{
    /**
     * Constructs the object from the current row in the resultSet.
     *
     * @param resultSet the resultSet to operate on, already pointing
     *        to the correct row. Not null.
     * @param a possible offset in the rows to be considered
     *        (if previous rows contain other objects).
     *
     * @return the mapped object, not null.
     *
     * @throws TorqueException when reading fields from the RecordSet fails.
     */
    public CompIntegerVarcharFk processRow(ResultSet resultSet, int offset)
            throws TorqueException
    {
        CompIntegerVarcharFk compIntegerVarcharFk = new CompIntegerVarcharFk();

        try 
        {
            compIntegerVarcharFk.setLoading(true);
            compIntegerVarcharFk.setId(
                    getId(resultSet, offset + 1));
            compIntegerVarcharFk.setFk1(
                    getFk1(resultSet, offset + 2));
            compIntegerVarcharFk.setFk2(
                    getFk2(resultSet, offset + 3));
            compIntegerVarcharFk.setName(
                    getName(resultSet, offset + 4));
            compIntegerVarcharFk.setNew(false);
            compIntegerVarcharFk.setModified(false);
        }
        finally
        {
            compIntegerVarcharFk.setLoading(false);
        }
        return compIntegerVarcharFk;
    }

        /**
         * Reads the value of the <code>columnIndex</code>'th column
         * in the <code>resultSet</code> so that it can be used to set
         * the field id in CompIntegerVarcharFk.
         *
         * @param dbObject the database object to fill, not null.
         * @param resultSet the ResultSet to read from, not null.
         * @param columnIndex the index in the resultSet which should be read.
         *
         * @return the content of the column.
         *
         * @throws SQLException if a problem occurs when reading
         *         from the resultSet.
         */
        protected Integer getId(
                    ResultSet resultSet,
                    int columnIndex)
                throws TorqueException
        {
            try
            {
                Integer value = resultSet.getInt(columnIndex);
                if (resultSet.wasNull())
                {
                    value = null;
                }
                return value;
            }
            catch (SQLException e)
            {
                throw new TorqueException(e);
            }
        }

        /**
         * Reads the value of the <code>columnIndex</code>'th column
         * in the <code>resultSet</code> so that it can be used to set
         * the field fk1 in CompIntegerVarcharFk.
         *
         * @param dbObject the database object to fill, not null.
         * @param resultSet the ResultSet to read from, not null.
         * @param columnIndex the index in the resultSet which should be read.
         *
         * @return the content of the column.
         *
         * @throws SQLException if a problem occurs when reading
         *         from the resultSet.
         */
        protected Integer getFk1(
                    ResultSet resultSet,
                    int columnIndex)
                throws TorqueException
        {
            try
            {
                Integer value = resultSet.getInt(columnIndex);
                if (resultSet.wasNull())
                {
                    value = null;
                }
                return value;
            }
            catch (SQLException e)
            {
                throw new TorqueException(e);
            }
        }

        /**
         * Reads the value of the <code>columnIndex</code>'th column
         * in the <code>resultSet</code> so that it can be used to set
         * the field fk2 in CompIntegerVarcharFk.
         *
         * @param dbObject the database object to fill, not null.
         * @param resultSet the ResultSet to read from, not null.
         * @param columnIndex the index in the resultSet which should be read.
         *
         * @return the content of the column.
         *
         * @throws SQLException if a problem occurs when reading
         *         from the resultSet.
         */
        protected String getFk2(
                    ResultSet resultSet,
                    int columnIndex)
                throws TorqueException
        {
            try
            {
                return resultSet.getString(columnIndex);
            }
            catch (SQLException e)
            {
                throw new TorqueException(e);
            }
        }

        /**
         * Reads the value of the <code>columnIndex</code>'th column
         * in the <code>resultSet</code> so that it can be used to set
         * the field name in CompIntegerVarcharFk.
         *
         * @param dbObject the database object to fill, not null.
         * @param resultSet the ResultSet to read from, not null.
         * @param columnIndex the index in the resultSet which should be read.
         *
         * @return the content of the column.
         *
         * @throws SQLException if a problem occurs when reading
         *         from the resultSet.
         */
        protected String getName(
                    ResultSet resultSet,
                    int columnIndex)
                throws TorqueException
        {
            try
            {
                return resultSet.getString(columnIndex);
            }
            catch (SQLException e)
            {
                throw new TorqueException(e);
            }
        }


}
