package org.apache.torque.test;

import java.io.Serializable;
import java.sql.Connection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.apache.torque.TorqueException;
import org.apache.torque.map.TableMap;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.BooleanKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.om.ColumnAccessByName;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.util.Transaction;
import org.apache.commons.lang.ObjectUtils;


/**
 * table with a composite primary key consisting of an integer           and a varchar column
 *
 * This class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:39 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to CompIntegerVarcharPk
 */
public abstract class BaseCompIntegerVarcharPk 
    implements Persistent, Serializable, ColumnAccessByName
{
    /** Serial version */
    private static final long serialVersionUID = 1347503739319L;



    /** Defines the id1 field. */
    private Integer id1 = null;

    /** Defines the id2 field. */
    private String id2 = null;

    /** Defines the integerColumn field. */
    private Integer integerColumn = null;

    /** Defines the varcharColumn field. */
    private String varcharColumn = null;

    /** Defines the name field. */
    private String name = null;

    /** Whether this object was modified after loading or after last save. */
    private boolean modified = true;

    /** 
     * Whether this object was loaded from the database or already saved 
     * (false) or whether it is not yet in the database(true).
     */
    private boolean isNew = true;

    /** Flag which indicates whether this object is currently saving. */
    private boolean saving = false;

    /** 
     * Flag which indicates whether this object is currently loaded
     * from the database. 
     */
    private boolean loading = false;

    /** 
     * Flag which indicates whether this object was deleted from the database.
     * Note that this flags does not always display the current database state,
     * there is no magical connection between this flag and the database.
     */
    private boolean deleted = false;



    /** Defines the collCompIntegerVarcharFks field. */
    protected List<CompIntegerVarcharFk> collCompIntegerVarcharFks = null;

    /** Defines the collCompNonpkFks field. */
    protected List<CompNonpkFk> collCompNonpkFks = null;



    /**
     * Get the value of id1.
     *
     * @return Integer
     */
    public Integer getId1() 
    {
        
        return id1;
    }

    /**
     * Set the value of id1.
     *
     * @param v new value
     */
    public void setId1(Integer v)
    {
        if (!ObjectUtils.equals(this.id1, v))
        {
            setModified(true);
        }

        this.id1 = v;

        // update associated objects in collCompIntegerVarcharFks 
        if (collCompIntegerVarcharFks != null)
        {
            for (int i = 0; i < collCompIntegerVarcharFks.size(); i++)
            {
                ((CompIntegerVarcharFk) collCompIntegerVarcharFks.get(i))
                        .setFk1(v);
            }
        }

    }
    
    /**
     * Get the value of id2.
     *
     * @return String
     */
    public String getId2() 
    {
        
        return id2;
    }

    /**
     * Set the value of id2.
     *
     * @param v new value
     */
    public void setId2(String v)
    {
        if (!ObjectUtils.equals(this.id2, v))
        {
            setModified(true);
        }

        this.id2 = v;

        // update associated objects in collCompIntegerVarcharFks 
        if (collCompIntegerVarcharFks != null)
        {
            for (int i = 0; i < collCompIntegerVarcharFks.size(); i++)
            {
                ((CompIntegerVarcharFk) collCompIntegerVarcharFks.get(i))
                        .setFk2(v);
            }
        }

    }
    
    /**
     * Get the value of integerColumn.
     *
     * @return Integer
     */
    public Integer getIntegerColumn() 
    {
        
        return integerColumn;
    }

    /**
     * Set the value of integerColumn.
     *
     * @param v new value
     */
    public void setIntegerColumn(Integer v)
    {
        if (!ObjectUtils.equals(this.integerColumn, v))
        {
            setModified(true);
        }

        this.integerColumn = v;

        // update associated objects in collCompNonpkFks 
        if (collCompNonpkFks != null)
        {
            for (int i = 0; i < collCompNonpkFks.size(); i++)
            {
                ((CompNonpkFk) collCompNonpkFks.get(i))
                        .setFk1(v);
            }
        }

    }
    
    /**
     * Get the value of varcharColumn.
     *
     * @return String
     */
    public String getVarcharColumn() 
    {
        
        return varcharColumn;
    }

    /**
     * Set the value of varcharColumn.
     *
     * @param v new value
     */
    public void setVarcharColumn(String v)
    {
        if (!ObjectUtils.equals(this.varcharColumn, v))
        {
            setModified(true);
        }

        this.varcharColumn = v;

        // update associated objects in collCompNonpkFks 
        if (collCompNonpkFks != null)
        {
            for (int i = 0; i < collCompNonpkFks.size(); i++)
            {
                ((CompNonpkFk) collCompNonpkFks.get(i))
                        .setFk2(v);
            }
        }

    }
    
    /**
     * Get the value of name.
     *
     * @return String
     */
    public String getName() 
    {
        
        return name;
    }

    /**
     * Set the value of name.
     *
     * @param v new value
     */
    public void setName(String v)
    {
        if (!ObjectUtils.equals(this.name, v))
        {
            setModified(true);
        }

        this.name = v;


    }
    

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return true, if the object has never been persisted.
     */
    public boolean isNew()
    {
        return isNew;
    }

    /**
     * Sets whether the object has ever been saved.
     *
     * @param isNew true if the object has never been saved, false otherwise.
     */
    public void setNew(boolean isNew)
    {
        this.isNew = isNew;
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return True if the object has been modified.
     */
    public boolean isModified()
    {
        return modified;
    }

    /**
     * Sets whether the object has been modified.
     *
     * @param modified true if the object has been modified, false otherwise.
     */
    public void setModified(boolean modified)
    {
        this.modified = modified;
    }

    /**
     * Sets the modified state for the object to be false.
     */
    public void resetModified()
    {
        modified = false;
    }


    /**
     * Returns whether this object is currently saving.
     *
     * @return true if this object is currently saving, false otherwise.
     */
    public boolean isSaving()
    {
        return saving;
    }

    /**
     * Sets whether this object is currently saving.
     *
     * @param saving true if this object is currently saving, false otherwise.
     */
    public void setSaving(boolean saving)
    {
        this.saving = saving;
    }


    /**
     * Returns whether this object is currently being loaded from the database.
     *
     * @return true if this object is currently loading, false otherwise.
     */
    public boolean isLoading()
    {
        return loading;
    }

    /**
     * Sets whether this object is currently being loaded from the database.
     *
     * @param loading true if this object is currently loading, false otherwise.
     */
    public void setLoading(boolean loading)
    {
        this.loading = loading;
    }


    /**
     * Returns whether this object was deleted from the database.
     * Note that this getter does not automatically reflect database state,
     * it will be set to true by Torque if doDelete() was called with this 
     * object. Bulk deletes and deletes via primary key do not change
     * this flag. Also, if doDelete() was called on an object which does
     * not exist in the database, the deleted flag is set to true even if
     * it was not deleted.
     *
     * @return true if this object was deleted, false otherwise.
     */
    public boolean isDeleted()
    {
        return deleted;
    }

    /**
     * Sets whether this object was deleted from the database.
     *
     * @param deleted true if this object was deleted, false otherwise.
     */
    public void setDeleted(boolean deleted)
    {
        this.deleted = deleted;
    }




    /**
     * Initializes the cache collCompIntegerVarcharFks for referenced objects. 
     */
    public void initCompIntegerVarcharFks()
    {
        if (collCompIntegerVarcharFks == null)
        {
            collCompIntegerVarcharFks = new ArrayList<CompIntegerVarcharFk>();
        }
    }

    /**
     * Checks whether the cache collCompIntegerVarcharFks for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isCompIntegerVarcharFksInitialized()
    {
        return (collCompIntegerVarcharFks != null);
    }


    /**
     * Method called to associate a CompIntegerVarcharFk object to this object
     * through the collCompIntegerVarcharFks foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addCompIntegerVarcharFk(CompIntegerVarcharFk toAdd)
        throws TorqueException
    {
        toAdd.setCompIntegerVarcharPk((CompIntegerVarcharPk) this);
        getCompIntegerVarcharFks().add(toAdd);
    }

    /**
     * Method called to associate a CompIntegerVarcharFk object to this object
     * through the collCompIntegerVarcharFks foreign key attribute using connection.
     *
     * @param l CompIntegerVarcharFk
     * @throws TorqueException
     */
    public void addCompIntegerVarcharFk(CompIntegerVarcharFk l, Connection con) throws TorqueException
    {
        getCompIntegerVarcharFks(con).add(l);
        l.setCompIntegerVarcharPk((CompIntegerVarcharPk) this);
    }
    
    /**
     * The criteria used to select the current contents of collCompIntegerVarcharFks
     */
    private Criteria lastCompIntegerVarcharFkCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getCompIntegerVarcharFks(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<CompIntegerVarcharFk> getCompIntegerVarcharFks()
        throws TorqueException
    {
        if (collCompIntegerVarcharFks == null)
        {
            collCompIntegerVarcharFks = getCompIntegerVarcharFks(new Criteria());
        }
        return collCompIntegerVarcharFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseCompIntegerVarcharPk has previously
     * been saved, it will retrieve related collCompIntegerVarcharFks from storage.
     * If this BaseCompIntegerVarcharPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<CompIntegerVarcharFk> getCompIntegerVarcharFks(Criteria criteria) throws TorqueException
    {
        if (collCompIntegerVarcharFks == null)
        {
            if (isNew())
            {
               initCompIntegerVarcharFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.CompIntegerVarcharFkPeer.FK1, getId1() );
                criteria.and(org.apache.torque.test.CompIntegerVarcharFkPeer.FK2, getId2() );
                collCompIntegerVarcharFks = org.apache.torque.test.CompIntegerVarcharFkPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.CompIntegerVarcharFkPeer.FK1, getId1() );
                criteria.and(org.apache.torque.test.CompIntegerVarcharFkPeer.FK2, getId2() );
                if (lastCompIntegerVarcharFkCriteria == null 
                        || !lastCompIntegerVarcharFkCriteria.equals(criteria))
                {
                    collCompIntegerVarcharFks = org.apache.torque.test.CompIntegerVarcharFkPeer.doSelect(criteria);
                }
            }
        }
        lastCompIntegerVarcharFkCriteria = criteria;

        return collCompIntegerVarcharFks;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getCompIntegerVarcharFks(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<CompIntegerVarcharFk> getCompIntegerVarcharFks(Connection con) throws TorqueException
    {
        if (collCompIntegerVarcharFks == null)
        {
            collCompIntegerVarcharFks = getCompIntegerVarcharFks(new Criteria(), con);
        }
        return collCompIntegerVarcharFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseCompIntegerVarcharPk has previously
     * been saved, it will retrieve the related CompIntegerVarcharFk Objects 
     * from storage.
     * If this BaseCompIntegerVarcharPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<CompIntegerVarcharFk> getCompIntegerVarcharFks(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collCompIntegerVarcharFks == null)
        {
            if (isNew())
            {
               initCompIntegerVarcharFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.CompIntegerVarcharFkPeer.FK1, getId1());
                criteria.and(org.apache.torque.test.CompIntegerVarcharFkPeer.FK2, getId2());
                collCompIntegerVarcharFks = org.apache.torque.test.CompIntegerVarcharFkPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.CompIntegerVarcharFkPeer.FK1, getId1());
                criteria.and(org.apache.torque.test.CompIntegerVarcharFkPeer.FK2, getId2());
                if (!lastCompIntegerVarcharFkCriteria.equals(criteria))
                {
                    collCompIntegerVarcharFks = org.apache.torque.test.CompIntegerVarcharFkPeer.doSelect(criteria, con);
                }
            }
        }
        lastCompIntegerVarcharFkCriteria = criteria;

        return collCompIntegerVarcharFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseCompIntegerVarcharPk is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<CompIntegerVarcharFk> getCompIntegerVarcharFksJoinCompIntegerVarcharPk(Criteria criteria) throws TorqueException
    {
        return getCompIntegerVarcharFksJoinCompIntegerVarcharPk(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseCompIntegerVarcharPk is new, it will return
     * an empty collection; or if this BaseCompIntegerVarcharPk has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<CompIntegerVarcharFk> getCompIntegerVarcharFksJoinCompIntegerVarcharPk(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collCompIntegerVarcharFks == null)
        {
            if (isNew())
            {
                initCompIntegerVarcharFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.CompIntegerVarcharFkPeer.FK1, getId1() );
                criteria.and(org.apache.torque.test.CompIntegerVarcharFkPeer.FK2, getId2() );
                collCompIntegerVarcharFks = org.apache.torque.test.CompIntegerVarcharFkPeer.doSelectJoinCompIntegerVarcharPk(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.CompIntegerVarcharFkPeer.FK1, getId1() );
            criteria.and(org.apache.torque.test.CompIntegerVarcharFkPeer.FK2, getId2() );
            if (!lastCompIntegerVarcharFkCriteria.equals(criteria))
            {
                collCompIntegerVarcharFks = org.apache.torque.test.CompIntegerVarcharFkPeer.doSelectJoinCompIntegerVarcharPk(criteria, connection);
            }
        }
        lastCompIntegerVarcharFkCriteria = criteria;

        return collCompIntegerVarcharFks;
    }

    /**
     * Initializes the cache collCompNonpkFks for referenced objects. 
     */
    public void initCompNonpkFks()
    {
        if (collCompNonpkFks == null)
        {
            collCompNonpkFks = new ArrayList<CompNonpkFk>();
        }
    }

    /**
     * Checks whether the cache collCompNonpkFks for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isCompNonpkFksInitialized()
    {
        return (collCompNonpkFks != null);
    }


    /**
     * Method called to associate a CompNonpkFk object to this object
     * through the collCompNonpkFks foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addCompNonpkFk(CompNonpkFk toAdd)
        throws TorqueException
    {
        toAdd.setCompIntegerVarcharPk((CompIntegerVarcharPk) this);
        getCompNonpkFks().add(toAdd);
    }

    /**
     * Method called to associate a CompNonpkFk object to this object
     * through the collCompNonpkFks foreign key attribute using connection.
     *
     * @param l CompNonpkFk
     * @throws TorqueException
     */
    public void addCompNonpkFk(CompNonpkFk l, Connection con) throws TorqueException
    {
        getCompNonpkFks(con).add(l);
        l.setCompIntegerVarcharPk((CompIntegerVarcharPk) this);
    }
    
    /**
     * The criteria used to select the current contents of collCompNonpkFks
     */
    private Criteria lastCompNonpkFkCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getCompNonpkFks(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<CompNonpkFk> getCompNonpkFks()
        throws TorqueException
    {
        if (collCompNonpkFks == null)
        {
            collCompNonpkFks = getCompNonpkFks(new Criteria());
        }
        return collCompNonpkFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseCompIntegerVarcharPk has previously
     * been saved, it will retrieve related collCompNonpkFks from storage.
     * If this BaseCompIntegerVarcharPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<CompNonpkFk> getCompNonpkFks(Criteria criteria) throws TorqueException
    {
        if (collCompNonpkFks == null)
        {
            if (isNew())
            {
               initCompNonpkFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.CompNonpkFkPeer.FK1, getIntegerColumn() );
                criteria.and(org.apache.torque.test.CompNonpkFkPeer.FK2, getVarcharColumn() );
                collCompNonpkFks = org.apache.torque.test.CompNonpkFkPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.CompNonpkFkPeer.FK1, getIntegerColumn() );
                criteria.and(org.apache.torque.test.CompNonpkFkPeer.FK2, getVarcharColumn() );
                if (lastCompNonpkFkCriteria == null 
                        || !lastCompNonpkFkCriteria.equals(criteria))
                {
                    collCompNonpkFks = org.apache.torque.test.CompNonpkFkPeer.doSelect(criteria);
                }
            }
        }
        lastCompNonpkFkCriteria = criteria;

        return collCompNonpkFks;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getCompNonpkFks(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<CompNonpkFk> getCompNonpkFks(Connection con) throws TorqueException
    {
        if (collCompNonpkFks == null)
        {
            collCompNonpkFks = getCompNonpkFks(new Criteria(), con);
        }
        return collCompNonpkFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseCompIntegerVarcharPk has previously
     * been saved, it will retrieve the related CompNonpkFk Objects 
     * from storage.
     * If this BaseCompIntegerVarcharPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<CompNonpkFk> getCompNonpkFks(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collCompNonpkFks == null)
        {
            if (isNew())
            {
               initCompNonpkFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.CompNonpkFkPeer.FK1, getIntegerColumn());
                criteria.and(org.apache.torque.test.CompNonpkFkPeer.FK2, getVarcharColumn());
                collCompNonpkFks = org.apache.torque.test.CompNonpkFkPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.CompNonpkFkPeer.FK1, getIntegerColumn());
                criteria.and(org.apache.torque.test.CompNonpkFkPeer.FK2, getVarcharColumn());
                if (!lastCompNonpkFkCriteria.equals(criteria))
                {
                    collCompNonpkFks = org.apache.torque.test.CompNonpkFkPeer.doSelect(criteria, con);
                }
            }
        }
        lastCompNonpkFkCriteria = criteria;

        return collCompNonpkFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseCompIntegerVarcharPk is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<CompNonpkFk> getCompNonpkFksJoinCompIntegerVarcharPk(Criteria criteria) throws TorqueException
    {
        return getCompNonpkFksJoinCompIntegerVarcharPk(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseCompIntegerVarcharPk is new, it will return
     * an empty collection; or if this BaseCompIntegerVarcharPk has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<CompNonpkFk> getCompNonpkFksJoinCompIntegerVarcharPk(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collCompNonpkFks == null)
        {
            if (isNew())
            {
                initCompNonpkFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.CompNonpkFkPeer.FK1, getIntegerColumn() );
                criteria.and(org.apache.torque.test.CompNonpkFkPeer.FK2, getVarcharColumn() );
                collCompNonpkFks = org.apache.torque.test.CompNonpkFkPeer.doSelectJoinCompIntegerVarcharPk(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.CompNonpkFkPeer.FK1, getIntegerColumn() );
            criteria.and(org.apache.torque.test.CompNonpkFkPeer.FK2, getVarcharColumn() );
            if (!lastCompNonpkFkCriteria.equals(criteria))
            {
                collCompNonpkFks = org.apache.torque.test.CompNonpkFkPeer.doSelectJoinCompIntegerVarcharPk(criteria, connection);
            }
        }
        lastCompNonpkFkCriteria = criteria;

        return collCompNonpkFks;
    }




    private static final List<String> FIELD_NAMES;

    static
    {
        List<String> fieldNames
                = new ArrayList<String>();
        fieldNames.add("Id1");
        fieldNames.add("Id2");
        fieldNames.add("IntegerColumn");
        fieldNames.add("VarcharColumn");
        fieldNames.add("Name");
        FIELD_NAMES = Collections.unmodifiableList(fieldNames);
    }

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static List<String> getFieldNames()
    {
        return FIELD_NAMES;
    }

    /**
     * Retrieves a field from the object by field (Java) name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
        if (name.equals("Id1"))
        {
            return getId1();
        }
        if (name.equals("Id2"))
        {
            return getId2();
        }
        if (name.equals("IntegerColumn"))
        {
            return getIntegerColumn();
        }
        if (name.equals("VarcharColumn"))
        {
            return getVarcharColumn();
        }
        if (name.equals("Name"))
        {
            return getName();
        }
        return null;
    }

    /**
     * Set a field in the object by field (Java) name.
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (name.equals("Id1"))
        {
            // Object fields can be null
            if (value != null && ! Integer.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setId1((Integer) value);
            return true;
        }
        if (name.equals("Id2"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setId2((String) value);
            return true;
        }
        if (name.equals("IntegerColumn"))
        {
            // Object fields can be null
            if (value != null && ! Integer.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setIntegerColumn((Integer) value);
            return true;
        }
        if (name.equals("VarcharColumn"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setVarcharColumn((String) value);
            return true;
        }
        if (name.equals("Name"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setName((String) value);
            return true;
        }
        return false;
    }

    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
        if (name.equals(org.apache.torque.test.CompIntegerVarcharPkPeer.ID1))
        {
            return getId1();
        }
        if (name.equals(org.apache.torque.test.CompIntegerVarcharPkPeer.ID2))
        {
            return getId2();
        }
        if (name.equals(org.apache.torque.test.CompIntegerVarcharPkPeer.INTEGER_COLUMN))
        {
            return getIntegerColumn();
        }
        if (name.equals(org.apache.torque.test.CompIntegerVarcharPkPeer.VARCHAR_COLUMN))
        {
            return getVarcharColumn();
        }
        if (name.equals(org.apache.torque.test.CompIntegerVarcharPkPeer.NAME))
        {
            return getName();
        }
        return null;
    }

    /**
     * Set field values by Peer Field Name
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPeerName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (org.apache.torque.test.CompIntegerVarcharPkPeer.ID1.getSqlExpression().equals(name))
        {
            return setByName("Id1", value);
        }
        if (org.apache.torque.test.CompIntegerVarcharPkPeer.ID2.getSqlExpression().equals(name))
        {
            return setByName("Id2", value);
        }
        if (org.apache.torque.test.CompIntegerVarcharPkPeer.INTEGER_COLUMN.getSqlExpression().equals(name))
        {
            return setByName("IntegerColumn", value);
        }
        if (org.apache.torque.test.CompIntegerVarcharPkPeer.VARCHAR_COLUMN.getSqlExpression().equals(name))
        {
            return setByName("VarcharColumn", value);
        }
        if (org.apache.torque.test.CompIntegerVarcharPkPeer.NAME.getSqlExpression().equals(name))
        {
            return setByName("Name", value);
        }
        return false;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
        if (pos == 0)
        {
            return getId1();
        }
        if (pos == 1)
        {
            return getId2();
        }
        if (pos == 2)
        {
            return getIntegerColumn();
        }
        if (pos == 3)
        {
            return getVarcharColumn();
        }
        if (pos == 4)
        {
            return getName();
        }
        return null;
    }

    /**
     * Set field values by its position (zero based) in the XML schema.
     *
     * @param position The field position
     * @param value field value
     * @return True if value was set, false if not (invalid position / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPosition(int position, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (position == 0)
        {
            return setByName("Id1", value);
        }
        if (position == 1)
        {
            return setByName("Id2", value);
        }
        if (position == 2)
        {
            return setByName("IntegerColumn", value);
        }
        if (position == 3)
        {
            return setByName("VarcharColumn", value);
        }
        if (position == 4)
        {
            return setByName("Name", value);
        }
        return false;
    }



    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save() throws TorqueException
    {
        save(CompIntegerVarcharPkPeer.DATABASE_NAME);
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     * @param dbName the name of the database to which the object
     *        should be saved.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(String dbName) 
            throws TorqueException
    {
        Connection con = null;
        try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally.
     *
     * @param toSave the object to be saved, not null.
     * @param con the connection to use for saving the object, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(Connection con) 
            throws TorqueException
    {
        if (isSaving())
        {
            return;
        }
        try
        {
            setSaving(true);
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    CompIntegerVarcharPkPeer.doInsert((CompIntegerVarcharPk) this, con);
                    setNew(false);
                }
                else
                {
                    CompIntegerVarcharPkPeer.doUpdate((CompIntegerVarcharPk) this, con);
                }
            }

            if (isCompIntegerVarcharFksInitialized())
            {
                for (CompIntegerVarcharFk collCompIntegerVarcharFks : getCompIntegerVarcharFks())
                {
                    collCompIntegerVarcharFks.save(con);
                }
            }
            if (isCompNonpkFksInitialized())
            {
                for (CompNonpkFk collCompNonpkFks : getCompNonpkFks())
                {
                    collCompNonpkFks.save(con);
                }
            }
        }
        finally
        {
            setSaving(false);
        }
    }





    private final SimpleKey[] pks = new SimpleKey[2];
    private final ComboKey comboPK = new ComboKey(pks);

    /**
     * Set the PrimaryKey with an ObjectKey
     *
     * @param key
     */
    public void setPrimaryKey(ObjectKey key) throws TorqueException
    {
        SimpleKey[] keys = (SimpleKey[]) key.getValue();
        setId1(((NumberKey) keys[0]).intValue());
        setId2(keys[1].toString());
    }

    /**
     * Set the PrimaryKey using SimpleKeys.
     *
     * @param Integer id1
     * @param String id2
     */
    public void setPrimaryKey(Integer id1, String id2)
        
    {
        setId1(id1);
        setId2(id2);
    }

    /**
     * Set the PrimaryKey using a String.
     */
    public void setPrimaryKey(String key) throws TorqueException
    {
        setPrimaryKey(new ComboKey(key));
    }

    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        SimpleKey[] pks = new SimpleKey[2];
        pks[0] = SimpleKey.keyFor(getId1());
        pks[1] = SimpleKey.keyFor(getId2());
        return new ComboKey(pks);
    }



    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public CompIntegerVarcharPk copy() throws TorqueException
    {
        return copy(true);
    }

    /**
     * Makes a copy of this object using a connection.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     *
     * @param con the database connection to read associated objects.
     */
    public CompIntegerVarcharPk copy(Connection con) throws TorqueException
    {
        return copy(true, con);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     */
    public CompIntegerVarcharPk copy(boolean deepcopy) throws TorqueException
    {
        CompIntegerVarcharPk compIntegerVarcharPk = new CompIntegerVarcharPk();

        return copyInto(compIntegerVarcharPk, deepcopy);
    }

    /**
     * Makes a copy of this object using connection.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @param con the database connection to read associated objects.
     */
    public CompIntegerVarcharPk copy(boolean deepcopy, Connection con) throws TorqueException
    {
        CompIntegerVarcharPk compIntegerVarcharPk = new CompIntegerVarcharPk();

        return copyInto(compIntegerVarcharPk, deepcopy, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     */
    protected CompIntegerVarcharPk copyInto(CompIntegerVarcharPk copyObj) throws TorqueException
    {
        return copyInto(copyObj, true);
    }

    /**
     * Fills the copyObj with the contents of this object using connection.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param con the database connection to read associated objects.
     */
    protected CompIntegerVarcharPk copyInto(CompIntegerVarcharPk copyObj, Connection con) throws TorqueException
    {
        return copyInto(copyObj, true, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     */
    protected CompIntegerVarcharPk copyInto(CompIntegerVarcharPk copyObj, boolean deepcopy) throws TorqueException
    {
        copyObj.setId1((Integer) null);
        copyObj.setId2((String) null);
        copyObj.setIntegerColumn(integerColumn);
        copyObj.setVarcharColumn(varcharColumn);
        copyObj.setName(name);

        if (deepcopy)
        {
            if (collCompIntegerVarcharFks != null)
            {
                for (int i = 0; i < collCompIntegerVarcharFks.size(); i++)
                {
                    CompIntegerVarcharFk obj = collCompIntegerVarcharFks.get(i);
                    copyObj.addCompIntegerVarcharFk(obj.copy());
                }
            }
            else
            {
                copyObj.collCompIntegerVarcharFks = null;
            }
            if (collCompNonpkFks != null)
            {
                for (int i = 0; i < collCompNonpkFks.size(); i++)
                {
                    CompNonpkFk obj = collCompNonpkFks.get(i);
                    copyObj.addCompNonpkFk(obj.copy());
                }
            }
            else
            {
                copyObj.collCompNonpkFks = null;
            }
        }
        return copyObj;
    }
        
    
    /**
     * Fills the copyObj with the contents of this object using connection.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @param con the database connection to read associated objects.
     */
    protected CompIntegerVarcharPk copyInto(CompIntegerVarcharPk copyObj, boolean deepcopy, Connection con) throws TorqueException
    {
        copyObj.setId1((Integer) null);
        copyObj.setId2((String) null);
        copyObj.setIntegerColumn(integerColumn);
        copyObj.setVarcharColumn(varcharColumn);
        copyObj.setName(name);

        if (deepcopy)
        {
            for (CompIntegerVarcharFk obj : getCompIntegerVarcharFks(con))
            {
                copyObj.addCompIntegerVarcharFk(obj.copy());
            }
            for (CompNonpkFk obj : getCompNonpkFks(con))
            {
                copyObj.addCompNonpkFk(obj.copy());
            }
        }
        return copyObj;
    }

    /** The Peer class */
    private static final org.apache.torque.test.CompIntegerVarcharPkPeer peer
            = new org.apache.torque.test.CompIntegerVarcharPkPeer();

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public org.apache.torque.test.CompIntegerVarcharPkPeer getPeer()
    {
        return peer;
    }

    /**
     * Retrieves the TableMap object related to this Table data without
     * compiler warnings of using getPeer().getTableMap().
     *
     * @return The associated TableMap object.
     */
    public TableMap getTableMap() throws TorqueException
    {
        return org.apache.torque.test.CompIntegerVarcharPkPeer.getTableMap();
    }



    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("CompIntegerVarcharPk:\n");
        str.append("id1 = ")
           .append(getId1())
           .append("\n");
        str.append("id2 = ")
           .append(getId2())
           .append("\n");
        str.append("integerColumn = ")
           .append(getIntegerColumn())
           .append("\n");
        str.append("varcharColumn = ")
           .append(getVarcharColumn())
           .append("\n");
        str.append("name = ")
           .append(getName())
           .append("\n");
        return(str.toString());
    }

    /**
     * Compares the primary key of this instance with the key of another.
     *
     * @param toCompare The object to compare to.
     * @return Whether the primary keys are equal and the object have the
     *         same class.
     */
    public boolean equals(Object toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!getClass().equals(toCompare.getClass()))
        {
            return false;
        }
        CompIntegerVarcharPk other = (CompIntegerVarcharPk) toCompare;
        if (getPrimaryKey() == null || other.getPrimaryKey() == null)
        {
            return false;
        }
        return getPrimaryKey().equals(other.getPrimaryKey());
    }

    /**
     * If the primary key is not <code>null</code>, return the hashcode of the
     * primary key.  Otherwise calls <code>Object.hashCode()</code>.
     *
     * @return an <code>int</code> value
     */
    public int hashCode()
    {
        ObjectKey ok = getPrimaryKey();
        if (ok == null)
        {
            return super.hashCode();
        }

        return ok.hashCode();
    }




}
