package org.apache.torque.test;

import java.sql.Blob;
import java.sql.Clob;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.sql.PreparedStatement;
import java.sql.Types;
import java.io.IOException;
import java.io.InputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.Reader;
import java.io.StringReader;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.torque.NoRowsException;
import org.apache.torque.TooManyRowsException;
import org.apache.torque.Torque;
import org.apache.torque.TorqueException;
import org.apache.torque.TorqueRuntimeException;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.criteria.Criterion;
import org.apache.torque.om.mapper.RecordMapper;
import org.apache.torque.om.mapper.CompositeMapper;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.ComboKey;
import org.apache.torque.map.TableMap;
import org.apache.torque.util.BasePeer;
import org.apache.torque.util.Transaction;
import org.apache.torque.util.ColumnValues;
import org.apache.torque.util.JdbcTypedValue;



/**
 * table with a composite primary key consisting of an integer           and a varchar column
 *
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:45 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to CompIntegerVarcharPkPeer
 */

public abstract class BaseCompIntegerVarcharPkPeerImpl
    extends org.apache.torque.util.BasePeerImpl<CompIntegerVarcharPk>
{
    /** The class log. */
    private static Log log = LogFactory.getLog(BaseCompIntegerVarcharPkPeerImpl.class);

    /** Serial version */
    private static final long serialVersionUID = 1347503745841L;



    /**
     * Constructor.
     * The recordMapper, tableMap and databaseName fields are correctly
     * initialized.
     */
    public BaseCompIntegerVarcharPkPeerImpl()
    {
        this(new CompIntegerVarcharPkRecordMapper(),
            CompIntegerVarcharPkPeer.TABLE,
            CompIntegerVarcharPkPeer.DATABASE_NAME);
    }

    /**
     * Constructor providing the objects to be injected as parameters.
     *
     * @param recordMapper a record mapper to map JDBC result sets to objects
     * @param tableMap the default table map
     * @param databaseName the name of the database
     */
    public BaseCompIntegerVarcharPkPeerImpl(
            RecordMapper<CompIntegerVarcharPk> recordMapper, 
            TableMap tableMap,
            String databaseName)
    {
        super(recordMapper, tableMap, databaseName);
    }


    /**
     * Selects CompIntegerVarcharPk objects from the database which have
     * the same content as the passed object.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<CompIntegerVarcharPk> doSelect(CompIntegerVarcharPk obj)
            throws TorqueException
    {
        return doSelect(buildSelectCriteria(obj));
    }

    /**
     * Selects at most one CompIntegerVarcharPk object from the database
     * which has the same content as the passed object.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public CompIntegerVarcharPk doSelectSingleRecord(
                CompIntegerVarcharPk obj)
            throws TorqueException
    {
        List<CompIntegerVarcharPk> compIntegerVarcharPkList = doSelect(obj);
        CompIntegerVarcharPk compIntegerVarcharPk = null;
        if (compIntegerVarcharPkList.size() > 1)
        {
            throw new TooManyRowsException("Object " + obj 
                + " matched more than one record");
        }
        if (!compIntegerVarcharPkList.isEmpty())
        {
            compIntegerVarcharPk = compIntegerVarcharPkList.get(0);
        }
        return compIntegerVarcharPk;
    }

    /**
     * Returns a new instance of the Data object class
     */
    public CompIntegerVarcharPk getDbObjectInstance()
    {
        return new CompIntegerVarcharPk();
    }


    /**
     * Method to do inserts.
     *
     * @param columnValues the values to insert.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public ObjectKey doInsert(ColumnValues columnValues) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    CompIntegerVarcharPkPeer.DATABASE_NAME);
            ObjectKey result = doInsert(columnValues, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(Criteria) method.
     *
     * @param columnValues the values to insert.
     * @param con the connection to use, not null.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public ObjectKey doInsert(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        correctBooleans(columnValues);
        return super.doInsert(columnValues, con);
    }

    /**
     * Method to do inserts
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public void doInsert(CompIntegerVarcharPk obj) throws TorqueException
    {
        doInsert(buildColumnValues(obj));
        obj.setNew(false);
        obj.setModified(false);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(CompIntegerVarcharPk) method.  It will take
     * care of the connection details internally.
     *
     * @param obj the data object to insert into the database.
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public void doInsert(CompIntegerVarcharPk obj, Connection con)
        throws TorqueException
    {
        doInsert(buildColumnValues(obj), con);
        obj.setNew(false);
        obj.setModified(false);
    }

    /**
     * Method to do updates.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(ColumnValues columnValues) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    CompIntegerVarcharPkPeer.DATABASE_NAME);
            int result = doUpdate(columnValues, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Method to do updates.  This method is to be used during a transaction,
     * otherwise use the doUpdate(Criteria) method.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @param con the connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        Criteria selectCriteria 
                = new Criteria(CompIntegerVarcharPkPeer.DATABASE_NAME);
        correctBooleans(columnValues);


    
        selectCriteria.where(
                CompIntegerVarcharPkPeer.ID1,
                columnValues.remove(CompIntegerVarcharPkPeer.ID1).getValue());

    
        selectCriteria.where(
                CompIntegerVarcharPkPeer.ID2,
                columnValues.remove(CompIntegerVarcharPkPeer.ID2).getValue());



        return doUpdate(selectCriteria, columnValues, con);
    }

    /**
     * Updates an CompIntegerVarcharPk in the database.
     * The primary key is used to identify the object to update.
     *
     * @param obj the data object to update in the database.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(CompIntegerVarcharPk obj) throws TorqueException
    {
        ColumnValues columnValues = buildColumnValues(obj);
        int result = doUpdate(columnValues);
        obj.setModified(false);
        return result;
    }

    /**
     * Updates a CompIntegerVarcharPk in the database.
     * The primary key is used to identify the object to update.
     * This method is to be used during a transaction,
     * otherwise the doUpdate(CompIntegerVarcharPk) method can be used.
     *
     * @param obj the data object to update in the database.
     * @param con the connection to use, not null.
     
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(CompIntegerVarcharPk obj, Connection con)
        throws TorqueException
    {
        ColumnValues columnValues = buildColumnValues(obj);
        int result = doUpdate(columnValues, con);
        obj.setModified(false);
        return result;
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     *
     * @param obj the data object to delete in the database, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(CompIntegerVarcharPk obj) throws TorqueException
    {
        int result = doDelete(buildCriteria(obj.getPrimaryKey()));
        obj.setDeleted(true);
        return result;
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     * This method is to be used during a transaction, otherwise use the
     * doDelete(CompIntegerVarcharPk) method.
     *
     * @param obj the data object to delete in the database, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(CompIntegerVarcharPk obj, Connection con)
        throws TorqueException
    {
        int result = doDelete(buildCriteria(obj.getPrimaryKey()), con);
        obj.setDeleted(true);
        return result;
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     *
     * @param objects the data object to delete in the database, not null,
     *        may not contain null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(Collection<CompIntegerVarcharPk> objects)
            throws TorqueException
    {
        int result = doDelete(buildPkCriteria(objects));
        for (CompIntegerVarcharPk object : objects)
        {
            object.setDeleted(true);
        }
        return result;
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param objects the data objects to delete in the database, not null,
     *        may not contain null.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(
            Collection<CompIntegerVarcharPk> objects,
            Connection con)
        throws TorqueException
    {
        int result = doDelete(buildPkCriteria(objects), con);
        for (CompIntegerVarcharPk object : objects)
        {
            object.setDeleted(true);
        }
        return result;
    }

    /**
     * Deletes a row in the database.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(ObjectKey pk) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    CompIntegerVarcharPkPeer.DATABASE_NAME);
            int deletedRows = doDelete(pk, connection);
            Transaction.commit(connection);
            connection = null;
            return deletedRows;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Deletes a row in the database.
     * This method is to be used during a transaction,
     * otherwise use the doDelete(ObjectKey) method.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(ObjectKey pk, Connection con)
        throws TorqueException
    {
        return doDelete(buildCriteria(pk), con);
    }

    /** 
     * Build a Criteria object which selects all objects which have a given
     * primary key.
     *
     * @param pk the primary key value to build the criteria from, not null.
     */
    public Criteria buildCriteria(ObjectKey pk)
    {
        Criteria criteria = new Criteria();
        SimpleKey[] keys = (SimpleKey[])pk.getValue();
        criteria.and(CompIntegerVarcharPkPeer.ID1, keys[0]);
        criteria.and(CompIntegerVarcharPkPeer.ID2, keys[1]);
        return criteria;
     }

    /** 
     * Build a Criteria object which selects all objects which primary keys
     * are contained in the passed collection.
     *
     * @param pks the primary key values to build the criteria from, not null,
     *        may not contain null.
     */
    public Criteria buildCriteria(Collection<ObjectKey> pks)
    {
        Criteria criteria = new Criteria();
        for (ObjectKey pk : pks)
        {
            SimpleKey[] keys = (SimpleKey[])pk.getValue();
                Criterion c0 = new Criterion(
                    CompIntegerVarcharPkPeer.ID1, keys[0], Criteria.EQUAL);
                Criterion c1 = new Criterion(
                    CompIntegerVarcharPkPeer.ID2, keys[1], Criteria.EQUAL);
                    c0.and(c1);
            criteria.or(c0);
        }
        return criteria;
     }


    /** 
     * Build a Criteria object which selects all passed objects using their
     * primary key. Objects which do not yet have a primary key are ignored.
     *
     * @param objects the objects to build the criteria from, not null,
     *        may not contain null.
     */
    public Criteria buildPkCriteria(
            Collection<CompIntegerVarcharPk> objects)
    {
        List<ObjectKey> pks = new ArrayList<ObjectKey>(objects.size());
        for (CompIntegerVarcharPk object : objects)
        {
            ObjectKey pk = object.getPrimaryKey();
            if (pk != null)
            {
                pks.add(pk);
            }
        }
        return buildCriteria(pks);
    }

    /** 
     * Build a Criteria object from the data object for this peer.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public Criteria buildCriteria(CompIntegerVarcharPk obj)
    {
        Criteria criteria = new Criteria(CompIntegerVarcharPkPeer.DATABASE_NAME);
        criteria.and(CompIntegerVarcharPkPeer.ID1, obj.getId1());
        criteria.and(CompIntegerVarcharPkPeer.ID2, obj.getId2());
        criteria.and(CompIntegerVarcharPkPeer.INTEGER_COLUMN, obj.getIntegerColumn());
        criteria.and(CompIntegerVarcharPkPeer.VARCHAR_COLUMN, obj.getVarcharColumn());
        criteria.and(CompIntegerVarcharPkPeer.NAME, obj.getName());
        return criteria;
    }

    /** 
     * Build a Criteria object from the data object for this peer,
     * skipping all binary columns.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public Criteria buildSelectCriteria(CompIntegerVarcharPk obj)
    {
        Criteria criteria = new Criteria(CompIntegerVarcharPkPeer.DATABASE_NAME);
        criteria.and(CompIntegerVarcharPkPeer.ID1, obj.getId1());
        criteria.and(CompIntegerVarcharPkPeer.ID2, obj.getId2());
        criteria.and(CompIntegerVarcharPkPeer.INTEGER_COLUMN, obj.getIntegerColumn());
        criteria.and(CompIntegerVarcharPkPeer.VARCHAR_COLUMN, obj.getVarcharColumn());
        criteria.and(CompIntegerVarcharPkPeer.NAME, obj.getName());
        return criteria;
    }

    /** 
     * Returns the contents of the object as ColumnValues object.
     * Primary key columns which are generated on insertion are not
     * added to the returned object if they still have their initial
     * value. Also, columns which have the useDatabaseDefaultValue
     * flag set to true are also not added to the returned object
     * if they still have their initial value.
     *
     * @throws TorqueException if the table map cannot be retrieved
     *         (should not happen).
     */
    public ColumnValues buildColumnValues(CompIntegerVarcharPk compIntegerVarcharPk)
            throws TorqueException
    {
        ColumnValues columnValues = new ColumnValues();
        columnValues.put(
                CompIntegerVarcharPkPeer.ID1,
                new JdbcTypedValue(
                    compIntegerVarcharPk.getId1(),
                    4));
        columnValues.put(
                CompIntegerVarcharPkPeer.ID2,
                new JdbcTypedValue(
                    compIntegerVarcharPk.getId2(),
                    12));
        columnValues.put(
                CompIntegerVarcharPkPeer.INTEGER_COLUMN,
                new JdbcTypedValue(
                    compIntegerVarcharPk.getIntegerColumn(),
                    4));
        columnValues.put(
                CompIntegerVarcharPkPeer.VARCHAR_COLUMN,
                new JdbcTypedValue(
                    compIntegerVarcharPk.getVarcharColumn(),
                    12));
        columnValues.put(
                CompIntegerVarcharPkPeer.NAME,
                new JdbcTypedValue(
                    compIntegerVarcharPk.getName(),
                    12));
        return columnValues;
    }

    /**
     * retrieve object using using pk values.
     *
     * @param id1 Integer
     * @param id2 String
     */
    public CompIntegerVarcharPk retrieveByPK(
            Integer id1,
            String id2)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(CompIntegerVarcharPkPeer.DATABASE_NAME);
            CompIntegerVarcharPk result = retrieveByPK(
               id1,
               id2,
               connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * retrieve object using using pk values.
     *
     * @param id1 Integer
     * @param id2 String
     * @param con Connection
     */
    public CompIntegerVarcharPk retrieveByPK(
            Integer id1,
            String id2,
            Connection con) throws TorqueException
    {

        Criteria criteria = new Criteria();
        criteria.and(CompIntegerVarcharPkPeer.ID1, id1);
        criteria.and(CompIntegerVarcharPkPeer.ID2, id2);
        List<CompIntegerVarcharPk> v = doSelect(criteria, con);
        if (v.size() == 1)
        {
            return v.get(0);
        }
        else
        {
            throw new TorqueException("Failed to select one and only one row.");
        }
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public CompIntegerVarcharPk retrieveByPK(ObjectKey pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(CompIntegerVarcharPkPeer.DATABASE_NAME);
            CompIntegerVarcharPk result = retrieveByPK(pk, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public CompIntegerVarcharPk retrieveByPK(ObjectKey pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        Criteria criteria = buildCriteria(pk);
        List<CompIntegerVarcharPk> v = doSelect(criteria, con);
        if (v.size() == 0)
        {
            throw new NoRowsException("Failed to select a row.");
        }
        else if (v.size() > 1)
        {
            throw new TooManyRowsException("Failed to select only one row.");
        }
        else
        {
            return (CompIntegerVarcharPk)v.get(0);
        }
    }


    /**
     * Retrieve a multiple objects by pk
     *
     * @param pks List of primary keys
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<CompIntegerVarcharPk> retrieveByPKs(Collection<ObjectKey> pks)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(CompIntegerVarcharPkPeer.DATABASE_NAME);
            List<CompIntegerVarcharPk> result = retrieveByPKs(pks, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Retrieve multiple objects by pk
     *
     * @param pks List of primary keys
     * @param dbcon the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<CompIntegerVarcharPk> retrieveByPKs(
                Collection<ObjectKey> pks,
                Connection dbcon)
            throws TorqueException
    {
        if (pks == null || pks.size() == 0)
        {
            return new ArrayList<CompIntegerVarcharPk>();
        }
        Criteria criteria = buildCriteria(pks);
        List<CompIntegerVarcharPk> result = doSelect(criteria, dbcon);
        return result;
    }





    /** 
     * Fills the referenced CompIntegerVarcharFk objects in the collCompIntegerVarcharFks fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     *
     * @return all read List<CompIntegerVarcharFk> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<CompIntegerVarcharFk> fillCompIntegerVarcharFks(
            Collection<CompIntegerVarcharPk> toFill)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    CompIntegerVarcharPkPeer.DATABASE_NAME);
            List<CompIntegerVarcharFk> result = fillCompIntegerVarcharFks(toFill, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /** 
     * Fills the referenced CompIntegerVarcharFk objects in the collCompIntegerVarcharFks fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read List<CompIntegerVarcharFk> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<CompIntegerVarcharFk> fillCompIntegerVarcharFks(
            Collection<CompIntegerVarcharPk> toFill,
            Connection connection)
        throws TorqueException
    {
        Set<ObjectKey> localKeySet = new HashSet<ObjectKey>();
        for (CompIntegerVarcharPk currentCompIntegerVarcharPk : toFill)
        {
            ObjectKey localKey = currentCompIntegerVarcharPk.getPrimaryKey();
            localKeySet.add(localKey);
        }

        int fillerChunkSize = getFillerChunkSize();
        Iterator<ObjectKey> localKeyIt = localKeySet.iterator();
        List<ObjectKey> localKeyListChunk
                = new ArrayList<ObjectKey>(fillerChunkSize);
        Map<ObjectKey, List<CompIntegerVarcharFk>> fkToCompIntegerVarcharFkMap
                = new HashMap<ObjectKey, List<CompIntegerVarcharFk>>();
        while (localKeyIt.hasNext())
        {
            ObjectKey currentKey = localKeyIt.next();
            localKeyListChunk.add(currentKey);
            if (localKeyListChunk.size() < fillerChunkSize
                && localKeyIt.hasNext())
            {
                continue;
            }

            Criteria criteria = new Criteria();
            for (ObjectKey localKey : localKeyListChunk)
            {
                SimpleKey[] keys = (SimpleKey[]) localKey.getValue();
                    Criterion c0 = new Criterion(
                        CompIntegerVarcharFkPeer.FK1, keys[0], Criteria.EQUAL);
                    Criterion c1 = new Criterion(
                        CompIntegerVarcharFkPeer.FK2, keys[1], Criteria.EQUAL);
                        c0.and(c1);
                criteria.or(c0);
            }
            List<CompIntegerVarcharFk> referencedCompIntegerVarcharFkList
                 = CompIntegerVarcharFkPeer.doSelect(
                     criteria,
                     connection);
            for (CompIntegerVarcharFk referencedObject : referencedCompIntegerVarcharFkList)
            {
                ObjectKey foreignKey = referencedObject.getForeignKeyForCompIntegerVarcharPk();
                List<CompIntegerVarcharFk> objectsWithForeignKey 
                    = fkToCompIntegerVarcharFkMap.get(foreignKey);
                if (objectsWithForeignKey == null)
                {
                    objectsWithForeignKey = new ArrayList<CompIntegerVarcharFk>();
                    fkToCompIntegerVarcharFkMap.put(
                        foreignKey,
                        objectsWithForeignKey);
                }
                objectsWithForeignKey.add(referencedObject);
            }
            localKeyListChunk.clear();
        }

        List<CompIntegerVarcharFk> result = new ArrayList<CompIntegerVarcharFk>();
        for (CompIntegerVarcharPk objectToFill : toFill)
        {
            objectToFill.initCompIntegerVarcharFks();
            objectToFill.getCompIntegerVarcharFks().clear();
            ObjectKey localKey = objectToFill.getPrimaryKey();
            List<CompIntegerVarcharFk> referencingList
                = fkToCompIntegerVarcharFkMap.get(localKey);
            if (referencingList == null)
            {
                continue;
            }
            for (CompIntegerVarcharFk referencing : referencingList)
            {
                // copy the referencing object for the case that more than one
                // toFill object references the same object; in this case
                // every toFillObject should have its own instance 
                // of the referencing object to remain consistent
                // with other Torque referencing object treatment
                CompIntegerVarcharFk referencingCopy = referencing.copy(false);
                // copy does not set primary key
                referencingCopy.setPrimaryKey(referencing.getPrimaryKey());
                objectToFill.addCompIntegerVarcharFk(referencingCopy);
                result.add(referencingCopy);
            }
        }
        return result;
    }
    /** 
     * Fills the referenced CompNonpkFk objects in the collCompNonpkFks fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     *
     * @return all read List<CompNonpkFk> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<CompNonpkFk> fillCompNonpkFks(
            Collection<CompIntegerVarcharPk> toFill)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    CompIntegerVarcharPkPeer.DATABASE_NAME);
            List<CompNonpkFk> result = fillCompNonpkFks(toFill, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /** 
     * Fills the referenced CompNonpkFk objects in the collCompNonpkFks fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read List<CompNonpkFk> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<CompNonpkFk> fillCompNonpkFks(
            Collection<CompIntegerVarcharPk> toFill,
            Connection connection)
        throws TorqueException
    {
        Set<ObjectKey> localKeySet = new HashSet<ObjectKey>();
        for (CompIntegerVarcharPk currentCompIntegerVarcharPk : toFill)
        {
            SimpleKey[] keyElementArray = new SimpleKey[2];
            keyElementArray[0] = SimpleKey.keyFor(
                    currentCompIntegerVarcharPk.getIntegerColumn());
            keyElementArray[1] = SimpleKey.keyFor(
                    currentCompIntegerVarcharPk.getVarcharColumn());
            ObjectKey localKey = new ComboKey(keyElementArray);
            localKeySet.add(localKey);
        }

        int fillerChunkSize = getFillerChunkSize();
        Iterator<ObjectKey> localKeyIt = localKeySet.iterator();
        List<ObjectKey> localKeyListChunk
                = new ArrayList<ObjectKey>(fillerChunkSize);
        Map<ObjectKey, List<CompNonpkFk>> fkToCompNonpkFkMap
                = new HashMap<ObjectKey, List<CompNonpkFk>>();
        while (localKeyIt.hasNext())
        {
            ObjectKey currentKey = localKeyIt.next();
            localKeyListChunk.add(currentKey);
            if (localKeyListChunk.size() < fillerChunkSize
                && localKeyIt.hasNext())
            {
                continue;
            }

            Criteria criteria = new Criteria();
            for (ObjectKey localKey : localKeyListChunk)
            {
                SimpleKey[] keys = (SimpleKey[]) localKey.getValue();
                    Criterion c0 = new Criterion(
                        CompNonpkFkPeer.FK1, keys[0], Criteria.EQUAL);
                    Criterion c1 = new Criterion(
                        CompNonpkFkPeer.FK2, keys[1], Criteria.EQUAL);
                        c0.and(c1);
                criteria.or(c0);
            }
            List<CompNonpkFk> referencedCompNonpkFkList
                 = CompNonpkFkPeer.doSelect(
                     criteria,
                     connection);
            for (CompNonpkFk referencedObject : referencedCompNonpkFkList)
            {
                ObjectKey foreignKey = referencedObject.getForeignKeyForCompIntegerVarcharPk();
                List<CompNonpkFk> objectsWithForeignKey 
                    = fkToCompNonpkFkMap.get(foreignKey);
                if (objectsWithForeignKey == null)
                {
                    objectsWithForeignKey = new ArrayList<CompNonpkFk>();
                    fkToCompNonpkFkMap.put(
                        foreignKey,
                        objectsWithForeignKey);
                }
                objectsWithForeignKey.add(referencedObject);
            }
            localKeyListChunk.clear();
        }

        List<CompNonpkFk> result = new ArrayList<CompNonpkFk>();
        for (CompIntegerVarcharPk objectToFill : toFill)
        {
            objectToFill.initCompNonpkFks();
            objectToFill.getCompNonpkFks().clear();
            SimpleKey[] keyElementArray = new SimpleKey[2];
            keyElementArray[0] = SimpleKey.keyFor(
                    objectToFill.getIntegerColumn());
            keyElementArray[1] = SimpleKey.keyFor(
                    objectToFill.getVarcharColumn());
            ObjectKey localKey = new ComboKey(keyElementArray);
            List<CompNonpkFk> referencingList
                = fkToCompNonpkFkMap.get(localKey);
            if (referencingList == null)
            {
                continue;
            }
            for (CompNonpkFk referencing : referencingList)
            {
                // copy the referencing object for the case that more than one
                // toFill object references the same object; in this case
                // every toFillObject should have its own instance 
                // of the referencing object to remain consistent
                // with other Torque referencing object treatment
                CompNonpkFk referencingCopy = referencing.copy(false);
                // copy does not set primary key
                referencingCopy.setPrimaryKey(referencing.getPrimaryKey());
                objectToFill.addCompNonpkFk(referencingCopy);
                result.add(referencingCopy);
            }
        }
        return result;
    }

    /** 
     * Returns the chunk size for the filler methods.
     *
     * @return the chunk size for the filler methods.
     */
    protected int getFillerChunkSize()
    {
        return 999;
    }


}
