package org.apache.torque.test;

import java.sql.Blob;
import java.sql.Clob;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.sql.PreparedStatement;
import java.sql.Types;
import java.io.IOException;
import java.io.InputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.Reader;
import java.io.StringReader;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.torque.NoRowsException;
import org.apache.torque.TooManyRowsException;
import org.apache.torque.Torque;
import org.apache.torque.TorqueException;
import org.apache.torque.TorqueRuntimeException;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.criteria.Criterion;
import org.apache.torque.om.mapper.RecordMapper;
import org.apache.torque.om.mapper.CompositeMapper;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.ComboKey;
import org.apache.torque.map.TableMap;
import org.apache.torque.util.BasePeer;
import org.apache.torque.util.Transaction;
import org.apache.torque.util.ColumnValues;
import org.apache.torque.util.JdbcTypedValue;



/**
 * table with a composite foreign key consisting of an integer           and a varchar column, not pointing to the primary key            of the referenced table
 *
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:45 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to CompNonpkFkPeer
 */

public abstract class BaseCompNonpkFkPeerImpl
    extends org.apache.torque.util.BasePeerImpl<CompNonpkFk>
{
    /** The class log. */
    private static Log log = LogFactory.getLog(BaseCompNonpkFkPeerImpl.class);

    /** Serial version */
    private static final long serialVersionUID = 1347503745880L;



    /**
     * Constructor.
     * The recordMapper, tableMap and databaseName fields are correctly
     * initialized.
     */
    public BaseCompNonpkFkPeerImpl()
    {
        this(new CompNonpkFkRecordMapper(),
            CompNonpkFkPeer.TABLE,
            CompNonpkFkPeer.DATABASE_NAME);
    }

    /**
     * Constructor providing the objects to be injected as parameters.
     *
     * @param recordMapper a record mapper to map JDBC result sets to objects
     * @param tableMap the default table map
     * @param databaseName the name of the database
     */
    public BaseCompNonpkFkPeerImpl(
            RecordMapper<CompNonpkFk> recordMapper, 
            TableMap tableMap,
            String databaseName)
    {
        super(recordMapper, tableMap, databaseName);
    }


    /**
     * Selects CompNonpkFk objects from the database which have
     * the same content as the passed object.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<CompNonpkFk> doSelect(CompNonpkFk obj)
            throws TorqueException
    {
        return doSelect(buildSelectCriteria(obj));
    }

    /**
     * Selects at most one CompNonpkFk object from the database
     * which has the same content as the passed object.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public CompNonpkFk doSelectSingleRecord(
                CompNonpkFk obj)
            throws TorqueException
    {
        List<CompNonpkFk> compNonpkFkList = doSelect(obj);
        CompNonpkFk compNonpkFk = null;
        if (compNonpkFkList.size() > 1)
        {
            throw new TooManyRowsException("Object " + obj 
                + " matched more than one record");
        }
        if (!compNonpkFkList.isEmpty())
        {
            compNonpkFk = compNonpkFkList.get(0);
        }
        return compNonpkFk;
    }

    /**
     * Returns a new instance of the Data object class
     */
    public CompNonpkFk getDbObjectInstance()
    {
        return new CompNonpkFk();
    }


    /**
     * Method to do inserts.
     *
     * @param columnValues the values to insert.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public ObjectKey doInsert(ColumnValues columnValues) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    CompNonpkFkPeer.DATABASE_NAME);
            ObjectKey result = doInsert(columnValues, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(Criteria) method.
     *
     * @param columnValues the values to insert.
     * @param con the connection to use, not null.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public ObjectKey doInsert(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        correctBooleans(columnValues);
        return super.doInsert(columnValues, con);
    }

    /**
     * Method to do inserts
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public void doInsert(CompNonpkFk obj) throws TorqueException
    {
        obj.setPrimaryKey(doInsert(buildColumnValues(obj)));
        obj.setNew(false);
        obj.setModified(false);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(CompNonpkFk) method.  It will take
     * care of the connection details internally.
     *
     * @param obj the data object to insert into the database.
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public void doInsert(CompNonpkFk obj, Connection con)
        throws TorqueException
    {
        ObjectKey primaryKey = doInsert(buildColumnValues(obj), con);
        if (primaryKey != null)
        {
            obj.setPrimaryKey(primaryKey);
        }
        obj.setNew(false);
        obj.setModified(false);
    }

    /**
     * Method to do updates.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(ColumnValues columnValues) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    CompNonpkFkPeer.DATABASE_NAME);
            int result = doUpdate(columnValues, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Method to do updates.  This method is to be used during a transaction,
     * otherwise use the doUpdate(Criteria) method.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @param con the connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        Criteria selectCriteria 
                = new Criteria(CompNonpkFkPeer.DATABASE_NAME);
        correctBooleans(columnValues);


    
        selectCriteria.where(
                CompNonpkFkPeer.ID,
                columnValues.remove(CompNonpkFkPeer.ID).getValue());



        return doUpdate(selectCriteria, columnValues, con);
    }

    /**
     * Updates an CompNonpkFk in the database.
     * The primary key is used to identify the object to update.
     *
     * @param obj the data object to update in the database.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(CompNonpkFk obj) throws TorqueException
    {
        ColumnValues columnValues = buildColumnValues(obj);
        int result = doUpdate(columnValues);
        obj.setModified(false);
        return result;
    }

    /**
     * Updates a CompNonpkFk in the database.
     * The primary key is used to identify the object to update.
     * This method is to be used during a transaction,
     * otherwise the doUpdate(CompNonpkFk) method can be used.
     *
     * @param obj the data object to update in the database.
     * @param con the connection to use, not null.
     
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(CompNonpkFk obj, Connection con)
        throws TorqueException
    {
        ColumnValues columnValues = buildColumnValues(obj);
        int result = doUpdate(columnValues, con);
        obj.setModified(false);
        return result;
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     *
     * @param obj the data object to delete in the database, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(CompNonpkFk obj) throws TorqueException
    {
        int result = doDelete(buildCriteria(obj.getPrimaryKey()));
        obj.setDeleted(true);
        return result;
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     * This method is to be used during a transaction, otherwise use the
     * doDelete(CompNonpkFk) method.
     *
     * @param obj the data object to delete in the database, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(CompNonpkFk obj, Connection con)
        throws TorqueException
    {
        int result = doDelete(buildCriteria(obj.getPrimaryKey()), con);
        obj.setDeleted(true);
        return result;
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     *
     * @param objects the data object to delete in the database, not null,
     *        may not contain null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(Collection<CompNonpkFk> objects)
            throws TorqueException
    {
        int result = doDelete(buildPkCriteria(objects));
        for (CompNonpkFk object : objects)
        {
            object.setDeleted(true);
        }
        return result;
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param objects the data objects to delete in the database, not null,
     *        may not contain null.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(
            Collection<CompNonpkFk> objects,
            Connection con)
        throws TorqueException
    {
        int result = doDelete(buildPkCriteria(objects), con);
        for (CompNonpkFk object : objects)
        {
            object.setDeleted(true);
        }
        return result;
    }

    /**
     * Deletes a row in the database.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(ObjectKey pk) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    CompNonpkFkPeer.DATABASE_NAME);
            int deletedRows = doDelete(pk, connection);
            Transaction.commit(connection);
            connection = null;
            return deletedRows;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Deletes a row in the database.
     * This method is to be used during a transaction,
     * otherwise use the doDelete(ObjectKey) method.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(ObjectKey pk, Connection con)
        throws TorqueException
    {
        return doDelete(buildCriteria(pk), con);
    }

    /** 
     * Build a Criteria object which selects all objects which have a given
     * primary key.
     *
     * @param pk the primary key value to build the criteria from, not null.
     */
    public Criteria buildCriteria(ObjectKey pk)
    {
        Criteria criteria = new Criteria();
        criteria.and(CompNonpkFkPeer.ID, pk);
        return criteria;
     }

    /** 
     * Build a Criteria object which selects all objects which primary keys
     * are contained in the passed collection.
     *
     * @param pks the primary key values to build the criteria from, not null,
     *        may not contain null.
     */
    public Criteria buildCriteria(Collection<ObjectKey> pks)
    {
        Criteria criteria = new Criteria();
        criteria.andIn(CompNonpkFkPeer.ID, pks);
        return criteria;
     }


    /** 
     * Build a Criteria object which selects all passed objects using their
     * primary key. Objects which do not yet have a primary key are ignored.
     *
     * @param objects the objects to build the criteria from, not null,
     *        may not contain null.
     */
    public Criteria buildPkCriteria(
            Collection<CompNonpkFk> objects)
    {
        List<ObjectKey> pks = new ArrayList<ObjectKey>(objects.size());
        for (CompNonpkFk object : objects)
        {
            ObjectKey pk = object.getPrimaryKey();
            if (pk != null)
            {
                pks.add(pk);
            }
        }
        return buildCriteria(pks);
    }

    /** 
     * Build a Criteria object from the data object for this peer.
     * The primary key columns are only added if the object is not new.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public Criteria buildCriteria(CompNonpkFk obj)
    {
        Criteria criteria = new Criteria(CompNonpkFkPeer.DATABASE_NAME);
        if (!obj.isNew())
        {
            criteria.and(CompNonpkFkPeer.ID, obj.getId());
        }
        criteria.and(CompNonpkFkPeer.FK1, obj.getFk1());
        criteria.and(CompNonpkFkPeer.FK2, obj.getFk2());
        criteria.and(CompNonpkFkPeer.NAME, obj.getName());
        return criteria;
    }

    /** 
     * Build a Criteria object from the data object for this peer,
     * skipping all binary columns.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public Criteria buildSelectCriteria(CompNonpkFk obj)
    {
        Criteria criteria = new Criteria(CompNonpkFkPeer.DATABASE_NAME);
        if (!obj.isNew())
        {
            criteria.and(CompNonpkFkPeer.ID, obj.getId());
        }
        criteria.and(CompNonpkFkPeer.FK1, obj.getFk1());
        criteria.and(CompNonpkFkPeer.FK2, obj.getFk2());
        criteria.and(CompNonpkFkPeer.NAME, obj.getName());
        return criteria;
    }

    /** 
     * Returns the contents of the object as ColumnValues object.
     * Primary key columns which are generated on insertion are not
     * added to the returned object if they still have their initial
     * value. Also, columns which have the useDatabaseDefaultValue
     * flag set to true are also not added to the returned object
     * if they still have their initial value.
     *
     * @throws TorqueException if the table map cannot be retrieved
     *         (should not happen).
     */
    public ColumnValues buildColumnValues(CompNonpkFk compNonpkFk)
            throws TorqueException
    {
        ColumnValues columnValues = new ColumnValues();
        if (!compNonpkFk.isNew() 
            || compNonpkFk.getId() != null)
        {
            columnValues.put(
                    CompNonpkFkPeer.ID,
                    new JdbcTypedValue(
                        compNonpkFk.getId(),
                        4));
        }
        columnValues.put(
                CompNonpkFkPeer.FK1,
                new JdbcTypedValue(
                    compNonpkFk.getFk1(),
                    4));
        columnValues.put(
                CompNonpkFkPeer.FK2,
                new JdbcTypedValue(
                    compNonpkFk.getFk2(),
                    12));
        columnValues.put(
                CompNonpkFkPeer.NAME,
                new JdbcTypedValue(
                    compNonpkFk.getName(),
                    12));
        return columnValues;
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public CompNonpkFk retrieveByPK(Integer pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return retrieveByPK(SimpleKey.keyFor(pk));
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public CompNonpkFk retrieveByPK(Integer pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return retrieveByPK(SimpleKey.keyFor(pk), con);
    }
    
    
    

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public CompNonpkFk retrieveByPK(ObjectKey pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(CompNonpkFkPeer.DATABASE_NAME);
            CompNonpkFk result = retrieveByPK(pk, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public CompNonpkFk retrieveByPK(ObjectKey pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        Criteria criteria = buildCriteria(pk);
        List<CompNonpkFk> v = doSelect(criteria, con);
        if (v.size() == 0)
        {
            throw new NoRowsException("Failed to select a row.");
        }
        else if (v.size() > 1)
        {
            throw new TooManyRowsException("Failed to select only one row.");
        }
        else
        {
            return (CompNonpkFk)v.get(0);
        }
    }


    /**
     * Retrieve a multiple objects by pk
     *
     * @param pks List of primary keys
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<CompNonpkFk> retrieveByPKs(Collection<ObjectKey> pks)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(CompNonpkFkPeer.DATABASE_NAME);
            List<CompNonpkFk> result = retrieveByPKs(pks, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Retrieve multiple objects by pk
     *
     * @param pks List of primary keys
     * @param dbcon the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<CompNonpkFk> retrieveByPKs(
                Collection<ObjectKey> pks,
                Connection dbcon)
            throws TorqueException
    {
        if (pks == null || pks.size() == 0)
        {
            return new ArrayList<CompNonpkFk>();
        }
        Criteria criteria = buildCriteria(pks);
        List<CompNonpkFk> result = doSelect(criteria, dbcon);
        return result;
    }


    /**
     * Selects a collection of dbObjectClassName objects pre-filled with their
     * CompIntegerVarcharPk objects.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<CompNonpkFk> doSelectJoinCompIntegerVarcharPk(Criteria criteria)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    CompNonpkFkPeer.DATABASE_NAME);
            List<CompNonpkFk> result
                    = CompNonpkFkPeer.doSelectJoinCompIntegerVarcharPk(criteria, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Selects a collection of CompNonpkFk objects pre-filled with their
     * CompIntegerVarcharPk objects.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<CompNonpkFk> doSelectJoinCompIntegerVarcharPk(
            Criteria criteria, Connection conn)
        throws TorqueException
    {
        setDbName(criteria);

        addSelectColumns(criteria);
        org.apache.torque.test.CompIntegerVarcharPkPeer.addSelectColumns(criteria);

        CompositeMapper compositeMapper = new CompositeMapper();
        compositeMapper.addMapper(
                new CompNonpkFkRecordMapper(),
                0);
        compositeMapper.addMapper(
                new CompIntegerVarcharPkRecordMapper(),
                CompNonpkFkPeer.numColumns);
        criteria.addJoin(CompNonpkFkPeer.FK1,
            org.apache.torque.test.CompIntegerVarcharPkPeer.INTEGER_COLUMN);
        criteria.addJoin(CompNonpkFkPeer.FK2,
            org.apache.torque.test.CompIntegerVarcharPkPeer.VARCHAR_COLUMN);

        correctBooleans(criteria);

        List<CompNonpkFk> result = new ArrayList<CompNonpkFk>();
        List<List<Object>> rawResult = doSelect(
                criteria, compositeMapper, conn);
        for (List<Object> rawResultRow : rawResult)
        {
            CompNonpkFk obj1 = (CompNonpkFk) rawResultRow.get(0);
            CompIntegerVarcharPk obj2 = (CompIntegerVarcharPk) rawResultRow.get(1);

            boolean newObject = true;
            for (int j = 0; j < result.size(); j++)
            {
                CompNonpkFk temp_obj1 = result.get(j);
                org.apache.torque.test.CompIntegerVarcharPk temp_obj2 = temp_obj1.getCompIntegerVarcharPk();
                if (temp_obj2.getPrimaryKey().equals(obj2.getPrimaryKey()))
                {
                    newObject = false;
                    temp_obj2.addCompNonpkFk(obj1);
                    break;
                }
            }
            if (newObject)
            {
                obj2.initCompNonpkFks();
                obj2.addCompNonpkFk(obj1);
            }
            result.add(obj1);
        }
        return result;
    }


    /** 
     * Fills the referenced CompIntegerVarcharPk objects in the aCompIntegerVarcharPk fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     *
     * @return all read CompIntegerVarcharPk objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<CompIntegerVarcharPk> fillCompIntegerVarcharPks(
            Collection<CompNonpkFk> toFill) 
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    CompNonpkFkPeer.DATABASE_NAME);
            List<CompIntegerVarcharPk> result = fillCompIntegerVarcharPks(toFill, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /** 
     * Fills the referenced CompIntegerVarcharPk objects in the aCompIntegerVarcharPk fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read CompIntegerVarcharPk objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<CompIntegerVarcharPk> fillCompIntegerVarcharPks(
            Collection<CompNonpkFk> toFill,
            Connection connection) 
        throws TorqueException
    {
        Set<ObjectKey> foreignKeySet = new HashSet<ObjectKey>();
        for (CompNonpkFk currentCompNonpkFk : toFill)
        {
            ObjectKey foreignKey = currentCompNonpkFk.getForeignKeyForCompIntegerVarcharPk();
            if (foreignKey != null)
            {
                foreignKeySet.add(foreignKey);
            }
        }

        int fillerChunkSize = getFillerChunkSize();
        Iterator<ObjectKey> foreignKeyIt = foreignKeySet.iterator();
        List<ObjectKey> foreignKeyListChunk
                = new ArrayList<ObjectKey>(fillerChunkSize);;
        Map<ObjectKey, CompIntegerVarcharPk> referencedKeyToCompIntegerVarcharPkMap 
                = new HashMap<ObjectKey, CompIntegerVarcharPk>();
        while (foreignKeyIt.hasNext())
        {
            ObjectKey currentKey = foreignKeyIt.next();
            foreignKeyListChunk.add(currentKey);
            if (foreignKeyListChunk.size() < fillerChunkSize 
                && foreignKeyIt.hasNext())
            {
                continue;
            }

            Criteria criteria = new Criteria();
            for (ObjectKey foreignKey : foreignKeyListChunk)
            {
                SimpleKey[] keys = (SimpleKey[]) foreignKey.getValue();
                    Criterion c0 = new Criterion(
                        CompIntegerVarcharPkPeer.INTEGER_COLUMN, keys[0], Criteria.EQUAL);
                    Criterion c1 = new Criterion(
                        CompIntegerVarcharPkPeer.VARCHAR_COLUMN, keys[1], Criteria.EQUAL);
                        c0.and(c1);
                criteria.or(c0);
            }
            List<CompIntegerVarcharPk> referencedCompIntegerVarcharPkList
                 = CompIntegerVarcharPkPeer.doSelect(
                     criteria,
                     connection);

            for (CompIntegerVarcharPk referencedObject : referencedCompIntegerVarcharPkList)
            {
                SimpleKey[] keyElementArray = new SimpleKey[2];
                keyElementArray[0] = SimpleKey.keyFor(
                        referencedObject.getIntegerColumn());
                keyElementArray[1] = SimpleKey.keyFor(
                        referencedObject.getVarcharColumn());
                ObjectKey foreignKey = new ComboKey(keyElementArray);
                referencedKeyToCompIntegerVarcharPkMap.put(
                        foreignKey,
                        referencedObject);
            }
            foreignKeyListChunk.clear();
        }

        List<CompIntegerVarcharPk> result = new ArrayList<CompIntegerVarcharPk>();
        for (CompNonpkFk objectToFill : toFill)
        {
            ObjectKey foreignKey = objectToFill.getForeignKeyForCompIntegerVarcharPk();
            if (foreignKey == null || foreignKey.getValue() == null)
            {
                continue;
            }
            CompIntegerVarcharPk referenced = referencedKeyToCompIntegerVarcharPkMap.get(
                    foreignKey);
            if (referenced == null)
            {
                throw new NoRowsException("No result found for key " 
                    + foreignKey + " in table COMP_INTEGER_VARCHAR_PK");
            }
            // copy the referenced object for the case that more than one
            // toFill object references the same object; in this case
            // every toFillObject should have its own instance of the referenced
            // object to remain consistent with the other Torque reference
            // treatment
            CompIntegerVarcharPk referencedCopy = referenced.copy(false);
            // copy does not set primary key
            referencedCopy.setPrimaryKey(referenced.getPrimaryKey());
            objectToFill.setCompIntegerVarcharPk(referencedCopy);
            result.add(referencedCopy);
        }
        return result;
    }


    /** 
     * Returns the chunk size for the filler methods.
     *
     * @return the chunk size for the filler methods.
     */
    protected int getFillerChunkSize()
    {
        return 999;
    }


}
