package org.apache.torque.test;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.torque.NoRowsException;
import org.apache.torque.TooManyRowsException;
import org.apache.torque.Column;
import org.apache.torque.Torque;
import org.apache.torque.TorqueException;
import org.apache.torque.TorqueRuntimeException;
import org.apache.torque.adapter.IDMethod;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.map.DatabaseMap;
import org.apache.torque.map.TableMap;
import org.apache.torque.map.ColumnMap;
import org.apache.torque.map.ForeignKeyMap;
import org.apache.torque.map.InheritanceMap;
import org.apache.torque.om.mapper.RecordMapper;
import org.apache.torque.om.mapper.CompositeMapper;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.util.BasePeer;
import org.apache.torque.util.Transaction;
import org.apache.torque.util.ColumnValues;
import org.apache.torque.util.JdbcTypedValue;



/**
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:42 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to DatabaseDefaultValuesPeer
 */
@SuppressWarnings({"unused", "unchecked"})
public abstract class BaseDatabaseDefaultValuesPeer
{
    /** The class log. */
    private static Log log = LogFactory.getLog(BaseDatabaseDefaultValuesPeerImpl.class);
    /** Serial version */
    private static final long serialVersionUID = 1347503742752L;


    /** The default database name for this class. */
    public static final String DATABASE_NAME;

     /** The table name for this class. */
    public static final String TABLE_NAME;

     /** The table map for this class. */
    public static final TableMap TABLE;
    /** The column for the id field */
    public static final ColumnMap ID;
    /** The column for the normal_payload field */
    public static final ColumnMap NORMAL_PAYLOAD;
    /** The column for the o_integer field */
    public static final ColumnMap O_INTEGER;
    /** The column for the p_int field */
    public static final ColumnMap P_INT;
    /** The column for the varchar_field field */
    public static final ColumnMap VARCHAR_FIELD;
    /** The column for the date_field field */
    public static final ColumnMap DATE_FIELD;
    /** The column for the time_field field */
    public static final ColumnMap TIME_FIELD;
    /** The column for the timestamp_field field */
    public static final ColumnMap TIMESTAMP_FIELD;

    /** number of columns for this peer */
    public static final int numColumns = 8;


    /** The implementation of the peer. */
    private static DatabaseDefaultValuesPeerImpl databaseDefaultValuesPeerImpl;


    static
    {
        DatabaseMap dbMap = Torque.getOrCreateDatabase("bookstore")
                .getDatabaseMap();
        if (dbMap.getTable("database_default_values") == null)
        {
            dbMap.addTable("database_default_values");
        }
        DATABASE_NAME = "bookstore";
        TABLE_NAME = "database_default_values";

        TABLE = dbMap.getTable("database_default_values");
        TABLE.setJavaName("DatabaseDefaultValues");
        TABLE.setOMClass(org.apache.torque.test.DatabaseDefaultValues.class);
        TABLE.setPeerClass(org.apache.torque.test.DatabaseDefaultValuesPeer.class);
        TABLE.setPrimaryKeyMethod(IDMethod.NATIVE);
        TABLE.setPrimaryKeyMethodInfo(IDMethod.ID_BROKER, TABLE.getName());
        TABLE.setPrimaryKeyMethodInfo(IDMethod.SEQUENCE, "database_default_values_SEQ");
        TABLE.setPrimaryKeyMethodInfo(IDMethod.AUTO_INCREMENT, "database_default_values");
        TABLE.setUseInheritance(true);


    // ------------- Column: id --------------------
        ID = new ColumnMap("id", TABLE);
        ID.setType(Integer.valueOf(0));
        ID.setTorqueType("INTEGER");
        ID.setUsePrimitive(true);
        ID.setPrimaryKey(true);
        ID.setNotNull(true);
        ID.setJavaName("Id");
        ID.setAutoIncrement(true);
        ID.setProtected(false);
        ID.setJavaType( "int" );
        ID.setPosition(1);
        TABLE.addColumn(ID);
    // ------------- Column: normal_payload --------------------
        NORMAL_PAYLOAD = new ColumnMap("normal_payload", TABLE);
        NORMAL_PAYLOAD.setType(Integer.valueOf(0));
        NORMAL_PAYLOAD.setTorqueType("INTEGER");
        NORMAL_PAYLOAD.setUsePrimitive(true);
        NORMAL_PAYLOAD.setPrimaryKey(false);
        NORMAL_PAYLOAD.setNotNull(false);
        NORMAL_PAYLOAD.setJavaName("NormalPayload");
        NORMAL_PAYLOAD.setAutoIncrement(true);
        NORMAL_PAYLOAD.setProtected(false);
        NORMAL_PAYLOAD.setJavaType( "int" );
        NORMAL_PAYLOAD.setPosition(2);
        TABLE.addColumn(NORMAL_PAYLOAD);
    // ------------- Column: o_integer --------------------
        O_INTEGER = new ColumnMap("o_integer", TABLE);
        O_INTEGER.setType(Integer.valueOf(0));
        O_INTEGER.setTorqueType("INTEGER");
        O_INTEGER.setUsePrimitive(false);
        O_INTEGER.setPrimaryKey(false);
        O_INTEGER.setNotNull(true);
        O_INTEGER.setJavaName("OInteger");
        O_INTEGER.setAutoIncrement(true);
        O_INTEGER.setProtected(false);
        O_INTEGER.setJavaType( "Integer" );
        O_INTEGER.setDefault("2");
        O_INTEGER.setPosition(3);
        TABLE.addColumn(O_INTEGER);
    // ------------- Column: p_int --------------------
        P_INT = new ColumnMap("p_int", TABLE);
        P_INT.setType(Integer.valueOf(0));
        P_INT.setTorqueType("INTEGER");
        P_INT.setUsePrimitive(true);
        P_INT.setPrimaryKey(false);
        P_INT.setNotNull(true);
        P_INT.setJavaName("PInt");
        P_INT.setAutoIncrement(true);
        P_INT.setProtected(false);
        P_INT.setJavaType( "int" );
        P_INT.setDefault("4");
        P_INT.setPosition(4);
        TABLE.addColumn(P_INT);
    // ------------- Column: varchar_field --------------------
        VARCHAR_FIELD = new ColumnMap("varchar_field", TABLE);
        VARCHAR_FIELD.setType("");
        VARCHAR_FIELD.setTorqueType("VARCHAR");
        VARCHAR_FIELD.setUsePrimitive(false);
        VARCHAR_FIELD.setPrimaryKey(false);
        VARCHAR_FIELD.setNotNull(true);
        VARCHAR_FIELD.setJavaName("VarcharField");
        VARCHAR_FIELD.setAutoIncrement(true);
        VARCHAR_FIELD.setProtected(false);
        VARCHAR_FIELD.setJavaType( "String" );
        VARCHAR_FIELD.setDefault("Default!");
        VARCHAR_FIELD.setSize(100);
        VARCHAR_FIELD.setPosition(5);
        TABLE.addColumn(VARCHAR_FIELD);
    // ------------- Column: date_field --------------------
        DATE_FIELD = new ColumnMap("date_field", TABLE);
        DATE_FIELD.setType(new Date());
        DATE_FIELD.setTorqueType("DATE");
        DATE_FIELD.setUsePrimitive(false);
        DATE_FIELD.setPrimaryKey(false);
        DATE_FIELD.setNotNull(false);
        DATE_FIELD.setJavaName("DateField");
        DATE_FIELD.setAutoIncrement(true);
        DATE_FIELD.setProtected(false);
        DATE_FIELD.setJavaType( "java.util.Date" );
        DATE_FIELD.setDefault("2010-09-08 00:00:00.0 GMT");
        DATE_FIELD.setPosition(6);
        TABLE.addColumn(DATE_FIELD);
    // ------------- Column: time_field --------------------
        TIME_FIELD = new ColumnMap("time_field", TABLE);
        TIME_FIELD.setType(new Date());
        TIME_FIELD.setTorqueType("TIME");
        TIME_FIELD.setUsePrimitive(false);
        TIME_FIELD.setPrimaryKey(false);
        TIME_FIELD.setNotNull(false);
        TIME_FIELD.setJavaName("TimeField");
        TIME_FIELD.setAutoIncrement(true);
        TIME_FIELD.setProtected(false);
        TIME_FIELD.setJavaType( "java.util.Date" );
        TIME_FIELD.setDefault("1970-01-01 10:20:30.0");
        TIME_FIELD.setPosition(7);
        TABLE.addColumn(TIME_FIELD);
    // ------------- Column: timestamp_field --------------------
        TIMESTAMP_FIELD = new ColumnMap("timestamp_field", TABLE);
        TIMESTAMP_FIELD.setType(new Date());
        TIMESTAMP_FIELD.setTorqueType("TIMESTAMP");
        TIMESTAMP_FIELD.setUsePrimitive(false);
        TIMESTAMP_FIELD.setPrimaryKey(false);
        TIMESTAMP_FIELD.setNotNull(false);
        TIMESTAMP_FIELD.setJavaName("TimestampField");
        TIMESTAMP_FIELD.setAutoIncrement(true);
        TIMESTAMP_FIELD.setProtected(false);
        TIMESTAMP_FIELD.setJavaType( "java.util.Date" );
        TIMESTAMP_FIELD.setDefault("2010-09-08 11:12:13.0");
        TIMESTAMP_FIELD.setPosition(8);
        TABLE.addColumn(TIMESTAMP_FIELD);



        initDatabaseMap();
    }

    /**
     * Creates a new instance of the  implementation of the peer.
     *
     * @return the new instance.
     */
    protected static DatabaseDefaultValuesPeerImpl createDatabaseDefaultValuesPeerImpl()
    {
        DatabaseDefaultValuesPeerImpl instance = new DatabaseDefaultValuesPeerImpl();
        return instance;
    }


    /**
     * Returns an instance of the implementation of the peer.
     * If no instance is currently cached, a new instance is created and cached.
     *
     * @return an instance of the implementation of the peer, not null.
     */
    public static DatabaseDefaultValuesPeerImpl getDatabaseDefaultValuesPeerImpl()
    {
        DatabaseDefaultValuesPeerImpl peerImplInstance = databaseDefaultValuesPeerImpl;
        if (peerImplInstance == null)
        {
            peerImplInstance = DatabaseDefaultValuesPeer.createDatabaseDefaultValuesPeerImpl();
            databaseDefaultValuesPeerImpl = peerImplInstance;
        }
        return peerImplInstance;
    }



    /**
     * Sets the instance of the implementation of the peer.
     *
     * @param an instance of the implementation of the peer, or null
     *        if a new instance should be created automatically.
     */
    public static void setDatabaseDefaultValuesPeerImpl(DatabaseDefaultValuesPeerImpl peerImplInstance)
    {
        databaseDefaultValuesPeerImpl = peerImplInstance;
    }


    /**
     * Get the list of objects for a ResultSet.  Please not that your
     * resultset MUST return columns in the right order.  You can use
     * getFieldNames() in BaseObject to get the correct sequence.
     *
     * @param resultSet the ResultSet
     * @return the list of objects
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<DatabaseDefaultValues> resultSet2Objects(ResultSet resultSet)
            throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().resultSet2Objects(resultSet);
    }

    /**
     * Add all the columns needed to create a new object.
     *
     * @param criteria object containing the columns to add.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void addSelectColumns(Criteria criteria)
            throws TorqueException
    {
        getDatabaseDefaultValuesPeerImpl().addSelectColumns(criteria);
    }

    /**
     * changes the boolean values in the criteria to the appropriate type,
     * whenever a booleanchar or booleanint column is involved.
     * This enables the user to create criteria using Boolean values
     * for booleanchar or booleanint columns.
     *
     * @param criteria the criteria in which the boolean values
     *        should be corrected.
     *
     * @throws TorqueException if the database map for the criteria cannot be 
               obtained.
     */
    public static void correctBooleans(Criteria criteria) throws TorqueException
    {
        getDatabaseDefaultValuesPeerImpl().correctBooleans(criteria);
    }

    /**
     * Checks all columns in the criteria to see whether
     * booleanchar and booleanint columns are queried with a boolean.
     * If yes, the query values are mapped onto values the database
     * does understand, i.e. 0 and 1 for booleanints and N and Y for
     * booleanchar columns.
     *
     * @param columnValues The value to be checked for booleanint
     *        and booleanchar columns.
     * @throws TorqueException if the database map for the criteria cannot be
     *         retrieved.
     */
    public static void correctBooleans(
            ColumnValues columnValues)
        throws TorqueException
    {
        getDatabaseDefaultValuesPeerImpl().correctBooleans(columnValues);
    }
    
    /**
     * Selects DatabaseDefaultValues objects from a database.
     *
     * @param criteria object used to create the SELECT statement.
     *
     * @return the list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<DatabaseDefaultValues> doSelect(Criteria criteria)
            throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doSelect(criteria);
    }

    /**
     * Selects DatabaseDefaultValues objects from a database
     * within a transaction.
     *
     * @param criteria object used to create the SELECT statement.
     * @param connection the connection holding the transaction, not null.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<DatabaseDefaultValues> doSelect(
                Criteria criteria,
                Connection connection)
            throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doSelect(criteria, connection);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                Criteria criteria,
                RecordMapper<T> mapper)
            throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doSelect(criteria, mapper);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection for selecting records,
     *        not null.
     *
     * @return The results of the query, not null.
     * @throws TorqueException Error performing database query.
     */
    public static <T> List<T> doSelect(
            Criteria criteria,
            RecordMapper<T> mapper,
            Connection connection)
        throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doSelect(
                criteria,
                mapper,
                connection);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param query the sql query to execute, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param dbName The name of the database to create the connection for,
     *        or null for the default SDB.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                String query,
                RecordMapper<T> mapper,
                String dbName)
            throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doSelect(
                query,
                mapper,
                dbName);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param query the SQL Query to execute, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection, not null.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                String query,
                RecordMapper<T> mapper,
                Connection connection)
            throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doSelect(
                query,
                mapper,
                connection);
    }

    /**
     * Selects DatabaseDefaultValues objects from the database which have
     * the same content as the passed object.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<DatabaseDefaultValues> doSelect(DatabaseDefaultValues obj)
            throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doSelect(obj);
    }

    /**
     * Selects at most one DatabaseDefaultValues object from a database.
     *
     * @param criteria object used to create the SELECT statement.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static DatabaseDefaultValues doSelectSingleRecord(
                Criteria criteria)
            throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doSelectSingleRecord(criteria);
    }

    /**
     * Selects at most one DatabaseDefaultValues object from a database
     * within a transaction.
     *
     * @param criteria object used to create the SELECT statement.
     * @param connection the connection holding the transaction, not null.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static DatabaseDefaultValues doSelectSingleRecord(
                Criteria criteria,
                Connection connection)
            throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doSelectSingleRecord(criteria, connection);
    }

    /**
     * Selects at most a single row from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     *
     * @return The selected row, or null if no records was selected.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> T doSelectSingleRecord(
                org.apache.torque.criteria.Criteria criteria,
                RecordMapper<T> mapper)
            throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doSelectSingleRecord(
                criteria,
                mapper);
    }

    /**
     * Selects at most a single row from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection, not null.
     *
     * @return The selected row, or null if no records was selected.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> T doSelectSingleRecord(
                org.apache.torque.criteria.Criteria criteria,
                RecordMapper<T> mapper,
                Connection connection)
            throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doSelectSingleRecord(
                criteria,
                mapper,
                connection);
    }

    /**
     * Selects at most one DatabaseDefaultValues object from the database
     * which has the same content as the passed object.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static DatabaseDefaultValues doSelectSingleRecord(
                DatabaseDefaultValues obj)
            throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doSelectSingleRecord(obj);
    }


    /**
     * Returns a new instance of the Data object class
     */
    public static DatabaseDefaultValues getDbObjectInstance()
    {
        return getDatabaseDefaultValuesPeerImpl().getDbObjectInstance();
    }


    /**
     * Method to do inserts.
     *
     * @param columnValues the values to insert.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static ObjectKey doInsert(ColumnValues columnValues) 
            throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doInsert(columnValues);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(Criteria) method.
     *
     * @param columnValues the values to insert.
     * @param con the connection to use, not null.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static ObjectKey doInsert(ColumnValues columnValues, Connection con)
            throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doInsert(columnValues, con);
    }
    /**
     * Method to do inserts
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void doInsert(DatabaseDefaultValues obj)
            throws TorqueException
    {
        getDatabaseDefaultValuesPeerImpl().doInsert(obj);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(DatabaseDefaultValues) method.  It will take
     * care of the connection details internally.
     *
     * @param obj the data object to insert into the database.
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void doInsert(DatabaseDefaultValues obj, Connection con)
            throws TorqueException
    {
        getDatabaseDefaultValuesPeerImpl().doInsert(obj, con);
    }

    /**
     * Method to do updates.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(ColumnValues columnValues) throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doUpdate(columnValues);
    }

    /**
     * Method to do updates.  This method is to be used during a transaction,
     * otherwise use the doUpdate(Criteria) method.  It will take care of
     * the connection details internally.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @param con the connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doUpdate(columnValues, con);
    }

    /**
     * Executes an update against the database. The rows to be updated
     * are selected using <code>criteria</code> and updated using the values
     * in <code>updateValues</code>.
     *
     * @param criteria selects which rows of which table should be updated.
     * @param updateValues Which columns to update with which values, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException if updating fails.
     */
    public static int doUpdate(
                Criteria selectCriteria,
                ColumnValues updateValues)
            throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doUpdate(
            selectCriteria,
            updateValues);
    }

    /**
     * Executes an update against the database. The rows to be updated
     * are selected using <code>criteria</code> and updated using the values
     * in <code>updateValues</code>.
     *
     * @param criteria selects which rows of which table should be updated.
     * @param updateValues Which columns to update with which values, not null.
     * @param connection the database connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException if updating fails.
     */
    public static int doUpdate(
                Criteria criteria,
                ColumnValues updateValues,
                Connection connection)
            throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doUpdate(
            criteria,
             updateValues,
              connection);
    }

    /**
     * Updates an DatabaseDefaultValues in the database.
     * The primary key is used to identify the object to update.
     *
     * @param obj the data object to update in the database.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(DatabaseDefaultValues obj) throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doUpdate(obj);
    }

    /**
     * Updates a DatabaseDefaultValues in the database.
     * The primary key is used to identify the object to update.
     * This method is to be used during a transaction,
     * otherwise the doUpdate(DatabaseDefaultValues) method can be used.
     *
     * @param obj the data object to update in the database.
     * @param con the connection to use, not null.
     
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(DatabaseDefaultValues obj, Connection con)
        throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doUpdate(obj, con);
    }

    /**
     * Utility method which executes a given SQL statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the SQL statement to execute.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString)
            throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().executeStatement(statementString);
    }

    /**
     * Utility method which executes a given sql statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the sql statement to execute.
     * @param dbName Name of database to connect to.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString, String dbName)
            throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().executeStatement(statementString, dbName);
    }

    /**
     * Utility method which executes a given sql statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the sql statement to execute.
     * @param con A Connection.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString, Connection con)
            throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().executeStatement(statementString, con);
    }

    /**
     * Deletes rows from a database table.
     *
     * @param criteria defines the rows to be deleted, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
     public static int doDelete(Criteria criteria) throws TorqueException
     {
        return getDatabaseDefaultValuesPeerImpl().doDelete(criteria);
     }

    /**
     * Deletes rows from a table.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
    *
     * @param criteria defines the rows to be deleted, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
     public static int doDelete(Criteria criteria, Connection con)
        throws TorqueException
     {
        return getDatabaseDefaultValuesPeerImpl().doDelete(criteria, con);
     }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     *
     * @param obj the data object to delete in the database, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(DatabaseDefaultValues obj) throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doDelete(obj);
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param obj the data object to delete in the database, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(DatabaseDefaultValues obj, Connection con)
        throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doDelete(obj, con);
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     *
     * @param objects the datas object to delete in the database, not null,
     *        may not contain null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(Collection<DatabaseDefaultValues> objects)
            throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doDelete(objects);
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param objects the datas object to delete in the database, not null,
     *        may not contain null.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(
            Collection<DatabaseDefaultValues> objects,
            Connection con)
        throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doDelete(objects, con);
    }

    /**
     * Deletes a row in the database.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(ObjectKey pk) throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doDelete(pk);
    }

    /**
     * Deletes a row in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(ObjectKey pk, Connection con)
        throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().doDelete(pk, con);
    }

    /** 
     * Build a Criteria object which selects all objects which have a given
     * primary key.
     *
     * @param pk the primary key value to build the criteria from, not null.
     */
    public static Criteria buildCriteria(ObjectKey pk)
    {
        return getDatabaseDefaultValuesPeerImpl().buildCriteria(pk);
    }

    /** 
     * Build a Criteria object which selects all objects which primary keys
     * are contained in the passed collection.
     *
     * @param pks the primary key values to build the criteria from, not null,
     *        may not contain null.
     */
    public static Criteria buildCriteria(Collection<ObjectKey> pks)
    {
        return getDatabaseDefaultValuesPeerImpl().buildCriteria(pks);
    }

    /** 
     * Build a Criteria object which selects all passed objects using their
     * primary key. Objects which do not yet have a primary key are ignored.
     *
     * @param objects the objects to build the criteria from, not null,
     *        may not contain null.
     */
    public static Criteria buildPkCriteria(
            Collection<DatabaseDefaultValues> objects)
    {
        return getDatabaseDefaultValuesPeerImpl().buildPkCriteria(objects);
    }

    /** 
     * Build a Criteria object from the data object for this peer.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public static Criteria buildCriteria(DatabaseDefaultValues obj)
    {
        return getDatabaseDefaultValuesPeerImpl().buildCriteria(obj);
    }

    /** 
     * Build a Criteria object from the data object for this peer,
     * skipping all binary columns.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public static Criteria buildSelectCriteria(DatabaseDefaultValues obj)
    {
        return getDatabaseDefaultValuesPeerImpl().buildSelectCriteria(obj);
    }

    /** 
     * Returns the contents of the object as ColumnValues object
     *
     * @throws TorqueException if the table map cannot be retrieved
     *         (should not happen).
     */
    public static ColumnValues buildColumnValues(DatabaseDefaultValues databaseDefaultValues)
            throws TorqueException
    {
        
        return getDatabaseDefaultValuesPeerImpl().buildColumnValues(databaseDefaultValues);
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public static DatabaseDefaultValues retrieveByPK(int pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return getDatabaseDefaultValuesPeerImpl().retrieveByPK(pk);
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public static DatabaseDefaultValues retrieveByPK(int pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return getDatabaseDefaultValuesPeerImpl().retrieveByPK(pk, con);
    }
    
    
    

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public static DatabaseDefaultValues retrieveByPK(ObjectKey pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return getDatabaseDefaultValuesPeerImpl().retrieveByPK(pk);
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public static DatabaseDefaultValues retrieveByPK(ObjectKey pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return getDatabaseDefaultValuesPeerImpl().retrieveByPK(pk, con);
    }


    /**
     * Retrieve a multiple objects by pk
     *
     * @param pks List of primary keys
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<DatabaseDefaultValues> retrieveByPKs(Collection<ObjectKey> pks)
        throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().retrieveByPKs(pks);
    }

    /**
     * Retrieve multiple objects by pk
     *
     * @param pks List of primary keys
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<DatabaseDefaultValues> retrieveByPKs(Collection<ObjectKey> pks, Connection con)
        throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().retrieveByPKs(pks,con);
    }






    /** 
     * Returns the chunk size for the filler methods.
     *
     * @return the chunk size for the filler methods.
     */
    protected static int getFillerChunkSize()
    {
        return getDatabaseDefaultValuesPeerImpl().getFillerChunkSize();
    }

    /**
     * Returns the TableMap related to this peer.
     *
     * @return the table map, not null.
     *
     * @throws TorqueException if the Peer instance does not hold a Table map.
     */
    public static TableMap getTableMap()
        throws TorqueException
    {
        return getDatabaseDefaultValuesPeerImpl().getTableMap();
    }

    public static void initDatabaseMap()
    {
        BaseBookstoreDatabaseMapInit.init();
    }


}
