package org.apache.torque.test;

import java.sql.Blob;
import java.sql.Clob;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.sql.PreparedStatement;
import java.sql.Types;
import java.io.IOException;
import java.io.InputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.Reader;
import java.io.StringReader;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.torque.NoRowsException;
import org.apache.torque.TooManyRowsException;
import org.apache.torque.Torque;
import org.apache.torque.TorqueException;
import org.apache.torque.TorqueRuntimeException;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.criteria.Criterion;
import org.apache.torque.om.mapper.RecordMapper;
import org.apache.torque.om.mapper.CompositeMapper;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.ComboKey;
import org.apache.torque.map.TableMap;
import org.apache.torque.util.BasePeer;
import org.apache.torque.util.Transaction;
import org.apache.torque.util.ColumnValues;
import org.apache.torque.util.JdbcTypedValue;



/**
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:46 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to IncludedFromIncludedPeer
 */

public abstract class BaseIncludedFromIncludedPeerImpl
    extends org.apache.torque.util.BasePeerImpl<IncludedFromIncluded>
{
    /** The class log. */
    private static Log log = LogFactory.getLog(BaseIncludedFromIncludedPeerImpl.class);

    /** Serial version */
    private static final long serialVersionUID = 1347503746846L;



    /**
     * Constructor.
     * The recordMapper, tableMap and databaseName fields are correctly
     * initialized.
     */
    public BaseIncludedFromIncludedPeerImpl()
    {
        this(new IncludedFromIncludedRecordMapper(),
            IncludedFromIncludedPeer.TABLE,
            IncludedFromIncludedPeer.DATABASE_NAME);
    }

    /**
     * Constructor providing the objects to be injected as parameters.
     *
     * @param recordMapper a record mapper to map JDBC result sets to objects
     * @param tableMap the default table map
     * @param databaseName the name of the database
     */
    public BaseIncludedFromIncludedPeerImpl(
            RecordMapper<IncludedFromIncluded> recordMapper, 
            TableMap tableMap,
            String databaseName)
    {
        super(recordMapper, tableMap, databaseName);
    }


    /**
     * Selects IncludedFromIncluded objects from the database which have
     * the same content as the passed object.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<IncludedFromIncluded> doSelect(IncludedFromIncluded obj)
            throws TorqueException
    {
        return doSelect(buildSelectCriteria(obj));
    }

    /**
     * Selects at most one IncludedFromIncluded object from the database
     * which has the same content as the passed object.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public IncludedFromIncluded doSelectSingleRecord(
                IncludedFromIncluded obj)
            throws TorqueException
    {
        List<IncludedFromIncluded> includedFromIncludedList = doSelect(obj);
        IncludedFromIncluded includedFromIncluded = null;
        if (includedFromIncludedList.size() > 1)
        {
            throw new TooManyRowsException("Object " + obj 
                + " matched more than one record");
        }
        if (!includedFromIncludedList.isEmpty())
        {
            includedFromIncluded = includedFromIncludedList.get(0);
        }
        return includedFromIncluded;
    }

    /**
     * Returns a new instance of the Data object class
     */
    public IncludedFromIncluded getDbObjectInstance()
    {
        return new IncludedFromIncluded();
    }


    /**
     * Method to do inserts.
     *
     * @param columnValues the values to insert.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public ObjectKey doInsert(ColumnValues columnValues) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    IncludedFromIncludedPeer.DATABASE_NAME);
            ObjectKey result = doInsert(columnValues, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(Criteria) method.
     *
     * @param columnValues the values to insert.
     * @param con the connection to use, not null.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public ObjectKey doInsert(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        correctBooleans(columnValues);
        return super.doInsert(columnValues, con);
    }

    /**
     * Method to do inserts
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public void doInsert(IncludedFromIncluded obj) throws TorqueException
    {
        obj.setPrimaryKey(doInsert(buildColumnValues(obj)));
        obj.setNew(false);
        obj.setModified(false);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(IncludedFromIncluded) method.  It will take
     * care of the connection details internally.
     *
     * @param obj the data object to insert into the database.
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public void doInsert(IncludedFromIncluded obj, Connection con)
        throws TorqueException
    {
        ObjectKey primaryKey = doInsert(buildColumnValues(obj), con);
        if (primaryKey != null)
        {
            obj.setPrimaryKey(primaryKey);
        }
        obj.setNew(false);
        obj.setModified(false);
    }

    /**
     * Method to do updates.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(ColumnValues columnValues) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    IncludedFromIncludedPeer.DATABASE_NAME);
            int result = doUpdate(columnValues, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Method to do updates.  This method is to be used during a transaction,
     * otherwise use the doUpdate(Criteria) method.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @param con the connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        Criteria selectCriteria 
                = new Criteria(IncludedFromIncludedPeer.DATABASE_NAME);
        correctBooleans(columnValues);


    
        selectCriteria.where(
                IncludedFromIncludedPeer.ID,
                columnValues.remove(IncludedFromIncludedPeer.ID).getValue());


        return doUpdate(selectCriteria, columnValues, con);
    }

    /**
     * Updates an IncludedFromIncluded in the database.
     * The primary key is used to identify the object to update.
     *
     * @param obj the data object to update in the database.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(IncludedFromIncluded obj) throws TorqueException
    {
        ColumnValues columnValues = buildColumnValues(obj);
        int result = doUpdate(columnValues);
        obj.setModified(false);
        return result;
    }

    /**
     * Updates a IncludedFromIncluded in the database.
     * The primary key is used to identify the object to update.
     * This method is to be used during a transaction,
     * otherwise the doUpdate(IncludedFromIncluded) method can be used.
     *
     * @param obj the data object to update in the database.
     * @param con the connection to use, not null.
     
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(IncludedFromIncluded obj, Connection con)
        throws TorqueException
    {
        ColumnValues columnValues = buildColumnValues(obj);
        int result = doUpdate(columnValues, con);
        obj.setModified(false);
        return result;
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     *
     * @param obj the data object to delete in the database, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(IncludedFromIncluded obj) throws TorqueException
    {
        int result = doDelete(buildCriteria(obj.getPrimaryKey()));
        obj.setDeleted(true);
        return result;
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     * This method is to be used during a transaction, otherwise use the
     * doDelete(IncludedFromIncluded) method.
     *
     * @param obj the data object to delete in the database, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(IncludedFromIncluded obj, Connection con)
        throws TorqueException
    {
        int result = doDelete(buildCriteria(obj.getPrimaryKey()), con);
        obj.setDeleted(true);
        return result;
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     *
     * @param objects the data object to delete in the database, not null,
     *        may not contain null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(Collection<IncludedFromIncluded> objects)
            throws TorqueException
    {
        int result = doDelete(buildPkCriteria(objects));
        for (IncludedFromIncluded object : objects)
        {
            object.setDeleted(true);
        }
        return result;
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param objects the data objects to delete in the database, not null,
     *        may not contain null.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(
            Collection<IncludedFromIncluded> objects,
            Connection con)
        throws TorqueException
    {
        int result = doDelete(buildPkCriteria(objects), con);
        for (IncludedFromIncluded object : objects)
        {
            object.setDeleted(true);
        }
        return result;
    }

    /**
     * Deletes a row in the database.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(ObjectKey pk) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    IncludedFromIncludedPeer.DATABASE_NAME);
            int deletedRows = doDelete(pk, connection);
            Transaction.commit(connection);
            connection = null;
            return deletedRows;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Deletes a row in the database.
     * This method is to be used during a transaction,
     * otherwise use the doDelete(ObjectKey) method.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(ObjectKey pk, Connection con)
        throws TorqueException
    {
        return doDelete(buildCriteria(pk), con);
    }

    /** 
     * Build a Criteria object which selects all objects which have a given
     * primary key.
     *
     * @param pk the primary key value to build the criteria from, not null.
     */
    public Criteria buildCriteria(ObjectKey pk)
    {
        Criteria criteria = new Criteria();
        criteria.and(IncludedFromIncludedPeer.ID, pk);
        return criteria;
     }

    /** 
     * Build a Criteria object which selects all objects which primary keys
     * are contained in the passed collection.
     *
     * @param pks the primary key values to build the criteria from, not null,
     *        may not contain null.
     */
    public Criteria buildCriteria(Collection<ObjectKey> pks)
    {
        Criteria criteria = new Criteria();
        criteria.andIn(IncludedFromIncludedPeer.ID, pks);
        return criteria;
     }


    /** 
     * Build a Criteria object which selects all passed objects using their
     * primary key. Objects which do not yet have a primary key are ignored.
     *
     * @param objects the objects to build the criteria from, not null,
     *        may not contain null.
     */
    public Criteria buildPkCriteria(
            Collection<IncludedFromIncluded> objects)
    {
        List<ObjectKey> pks = new ArrayList<ObjectKey>(objects.size());
        for (IncludedFromIncluded object : objects)
        {
            ObjectKey pk = object.getPrimaryKey();
            if (pk != null)
            {
                pks.add(pk);
            }
        }
        return buildCriteria(pks);
    }

    /** 
     * Build a Criteria object from the data object for this peer.
     * The primary key columns are only added if the object is not new.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public Criteria buildCriteria(IncludedFromIncluded obj)
    {
        Criteria criteria = new Criteria(IncludedFromIncludedPeer.DATABASE_NAME);
        if (!obj.isNew())
        {
            criteria.and(IncludedFromIncludedPeer.ID, obj.getId());
        }
        criteria.and(IncludedFromIncludedPeer.INCLUDED_ID, obj.getIncludedId());
        criteria.and(IncludedFromIncludedPeer.REFERENCE_TO_INCLUDED_ID, obj.getReferenceToIncludedId());
        return criteria;
    }

    /** 
     * Build a Criteria object from the data object for this peer,
     * skipping all binary columns.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public Criteria buildSelectCriteria(IncludedFromIncluded obj)
    {
        Criteria criteria = new Criteria(IncludedFromIncludedPeer.DATABASE_NAME);
        if (!obj.isNew())
        {
            criteria.and(IncludedFromIncludedPeer.ID, obj.getId());
        }
        criteria.and(IncludedFromIncludedPeer.INCLUDED_ID, obj.getIncludedId());
        criteria.and(IncludedFromIncludedPeer.REFERENCE_TO_INCLUDED_ID, obj.getReferenceToIncludedId());
        return criteria;
    }

    /** 
     * Returns the contents of the object as ColumnValues object.
     * Primary key columns which are generated on insertion are not
     * added to the returned object if they still have their initial
     * value. Also, columns which have the useDatabaseDefaultValue
     * flag set to true are also not added to the returned object
     * if they still have their initial value.
     *
     * @throws TorqueException if the table map cannot be retrieved
     *         (should not happen).
     */
    public ColumnValues buildColumnValues(IncludedFromIncluded includedFromIncluded)
            throws TorqueException
    {
        ColumnValues columnValues = new ColumnValues();
        if (!includedFromIncluded.isNew() 
            || includedFromIncluded.getId() != 0)
        {
            columnValues.put(
                    IncludedFromIncludedPeer.ID,
                    new JdbcTypedValue(
                        includedFromIncluded.getId(),
                        4));
        }
        columnValues.put(
                IncludedFromIncludedPeer.INCLUDED_ID,
                new JdbcTypedValue(
                    includedFromIncluded.getIncludedId(),
                    4));
        columnValues.put(
                IncludedFromIncludedPeer.REFERENCE_TO_INCLUDED_ID,
                new JdbcTypedValue(
                    includedFromIncluded.getReferenceToIncludedId(),
                    4));
        return columnValues;
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public IncludedFromIncluded retrieveByPK(int pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return retrieveByPK(SimpleKey.keyFor(pk));
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public IncludedFromIncluded retrieveByPK(int pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return retrieveByPK(SimpleKey.keyFor(pk), con);
    }
    
    
    

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public IncludedFromIncluded retrieveByPK(ObjectKey pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(IncludedFromIncludedPeer.DATABASE_NAME);
            IncludedFromIncluded result = retrieveByPK(pk, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public IncludedFromIncluded retrieveByPK(ObjectKey pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        Criteria criteria = buildCriteria(pk);
        List<IncludedFromIncluded> v = doSelect(criteria, con);
        if (v.size() == 0)
        {
            throw new NoRowsException("Failed to select a row.");
        }
        else if (v.size() > 1)
        {
            throw new TooManyRowsException("Failed to select only one row.");
        }
        else
        {
            return (IncludedFromIncluded)v.get(0);
        }
    }


    /**
     * Retrieve a multiple objects by pk
     *
     * @param pks List of primary keys
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<IncludedFromIncluded> retrieveByPKs(Collection<ObjectKey> pks)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(IncludedFromIncludedPeer.DATABASE_NAME);
            List<IncludedFromIncluded> result = retrieveByPKs(pks, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Retrieve multiple objects by pk
     *
     * @param pks List of primary keys
     * @param dbcon the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<IncludedFromIncluded> retrieveByPKs(
                Collection<ObjectKey> pks,
                Connection dbcon)
            throws TorqueException
    {
        if (pks == null || pks.size() == 0)
        {
            return new ArrayList<IncludedFromIncluded>();
        }
        Criteria criteria = buildCriteria(pks);
        List<IncludedFromIncluded> result = doSelect(criteria, dbcon);
        return result;
    }


    /**
     * Selects a collection of dbObjectClassName objects pre-filled with their
     * Included objects.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<IncludedFromIncluded> doSelectJoinIncluded(Criteria criteria)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    IncludedFromIncludedPeer.DATABASE_NAME);
            List<IncludedFromIncluded> result
                    = IncludedFromIncludedPeer.doSelectJoinIncluded(criteria, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Selects a collection of IncludedFromIncluded objects pre-filled with their
     * Included objects.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<IncludedFromIncluded> doSelectJoinIncluded(
            Criteria criteria, Connection conn)
        throws TorqueException
    {
        setDbName(criteria);

        addSelectColumns(criteria);
        org.apache.torque.test.IncludedPeer.addSelectColumns(criteria);

        CompositeMapper compositeMapper = new CompositeMapper();
        compositeMapper.addMapper(
                new IncludedFromIncludedRecordMapper(),
                0);
        compositeMapper.addMapper(
                new IncludedRecordMapper(),
                IncludedFromIncludedPeer.numColumns);
        criteria.addJoin(IncludedFromIncludedPeer.INCLUDED_ID,
            org.apache.torque.test.IncludedPeer.ID);

        correctBooleans(criteria);

        List<IncludedFromIncluded> result = new ArrayList<IncludedFromIncluded>();
        List<List<Object>> rawResult = doSelect(
                criteria, compositeMapper, conn);
        for (List<Object> rawResultRow : rawResult)
        {
            IncludedFromIncluded obj1 = (IncludedFromIncluded) rawResultRow.get(0);
            Included obj2 = (Included) rawResultRow.get(1);

            boolean newObject = true;
            for (int j = 0; j < result.size(); j++)
            {
                IncludedFromIncluded temp_obj1 = result.get(j);
                org.apache.torque.test.Included temp_obj2 = temp_obj1.getIncluded();
                if (temp_obj2.getPrimaryKey().equals(obj2.getPrimaryKey()))
                {
                    newObject = false;
                    temp_obj2.addIncludedFromIncluded(obj1);
                    break;
                }
            }
            if (newObject)
            {
                obj2.initIncludedFromIncludeds();
                obj2.addIncludedFromIncluded(obj1);
            }
            result.add(obj1);
        }
        return result;
    }
    /**
     * Selects a collection of dbObjectClassName objects pre-filled with their
     * ReferenceToIncluded objects.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<IncludedFromIncluded> doSelectJoinReferenceToIncluded(Criteria criteria)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    IncludedFromIncludedPeer.DATABASE_NAME);
            List<IncludedFromIncluded> result
                    = IncludedFromIncludedPeer.doSelectJoinReferenceToIncluded(criteria, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Selects a collection of IncludedFromIncluded objects pre-filled with their
     * ReferenceToIncluded objects.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<IncludedFromIncluded> doSelectJoinReferenceToIncluded(
            Criteria criteria, Connection conn)
        throws TorqueException
    {
        setDbName(criteria);

        addSelectColumns(criteria);
        org.apache.torque.test.ReferenceToIncludedPeer.addSelectColumns(criteria);

        CompositeMapper compositeMapper = new CompositeMapper();
        compositeMapper.addMapper(
                new IncludedFromIncludedRecordMapper(),
                0);
        compositeMapper.addMapper(
                new ReferenceToIncludedRecordMapper(),
                IncludedFromIncludedPeer.numColumns);
        criteria.addJoin(IncludedFromIncludedPeer.REFERENCE_TO_INCLUDED_ID,
            org.apache.torque.test.ReferenceToIncludedPeer.ID);

        correctBooleans(criteria);

        List<IncludedFromIncluded> result = new ArrayList<IncludedFromIncluded>();
        List<List<Object>> rawResult = doSelect(
                criteria, compositeMapper, conn);
        for (List<Object> rawResultRow : rawResult)
        {
            IncludedFromIncluded obj1 = (IncludedFromIncluded) rawResultRow.get(0);
            ReferenceToIncluded obj2 = (ReferenceToIncluded) rawResultRow.get(1);

            boolean newObject = true;
            for (int j = 0; j < result.size(); j++)
            {
                IncludedFromIncluded temp_obj1 = result.get(j);
                org.apache.torque.test.ReferenceToIncluded temp_obj2 = temp_obj1.getReferenceToIncluded();
                if (temp_obj2.getPrimaryKey().equals(obj2.getPrimaryKey()))
                {
                    newObject = false;
                    temp_obj2.addIncludedFromIncluded(obj1);
                    break;
                }
            }
            if (newObject)
            {
                obj2.initIncludedFromIncludeds();
                obj2.addIncludedFromIncluded(obj1);
            }
            result.add(obj1);
        }
        return result;
    }


    /** 
     * Fills the referenced Included objects in the aIncluded fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     *
     * @return all read Included objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<Included> fillIncludeds(
            Collection<IncludedFromIncluded> toFill) 
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    IncludedFromIncludedPeer.DATABASE_NAME);
            List<Included> result = fillIncludeds(toFill, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /** 
     * Fills the referenced Included objects in the aIncluded fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read Included objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<Included> fillIncludeds(
            Collection<IncludedFromIncluded> toFill,
            Connection connection) 
        throws TorqueException
    {
        Set<ObjectKey> foreignKeySet = new HashSet<ObjectKey>();
        for (IncludedFromIncluded currentIncludedFromIncluded : toFill)
        {
            ObjectKey foreignKey = currentIncludedFromIncluded.getForeignKeyForIncluded();
            if (foreignKey != null)
            {
                foreignKeySet.add(foreignKey);
            }
        }

        int fillerChunkSize = getFillerChunkSize();
        Iterator<ObjectKey> foreignKeyIt = foreignKeySet.iterator();
        List<ObjectKey> foreignKeyListChunk
                = new ArrayList<ObjectKey>(fillerChunkSize);;
        Map<ObjectKey, Included> referencedKeyToIncludedMap 
                = new HashMap<ObjectKey, Included>();
        while (foreignKeyIt.hasNext())
        {
            ObjectKey currentKey = foreignKeyIt.next();
            foreignKeyListChunk.add(currentKey);
            if (foreignKeyListChunk.size() < fillerChunkSize 
                && foreignKeyIt.hasNext())
            {
                continue;
            }

            List<Included> referencedIncludedList
                 = IncludedPeer.retrieveByPKs(
                     foreignKeyListChunk,
                     connection);

            for (Included referencedObject : referencedIncludedList)
            {
                referencedKeyToIncludedMap.put(
                        referencedObject.getPrimaryKey(),
                        referencedObject);
            }
            foreignKeyListChunk.clear();
        }

        List<Included> result = new ArrayList<Included>();
        for (IncludedFromIncluded objectToFill : toFill)
        {
            ObjectKey foreignKey = objectToFill.getForeignKeyForIncluded();
            if (foreignKey == null || foreignKey.getValue() == null)
            {
                continue;
            }
            Included referenced = referencedKeyToIncludedMap.get(
                    foreignKey);
            if (referenced == null)
            {
                throw new NoRowsException("No result found for key " 
                    + foreignKey + " in table included");
            }
            // copy the referenced object for the case that more than one
            // toFill object references the same object; in this case
            // every toFillObject should have its own instance of the referenced
            // object to remain consistent with the other Torque reference
            // treatment
            Included referencedCopy = referenced.copy(false);
            // copy does not set primary key
            referencedCopy.setPrimaryKey(referenced.getPrimaryKey());
            objectToFill.setIncluded(referencedCopy);
            result.add(referencedCopy);
        }
        return result;
    }
    /** 
     * Fills the referenced ReferenceToIncluded objects in the aReferenceToIncluded fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     *
     * @return all read ReferenceToIncluded objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<ReferenceToIncluded> fillReferenceToIncludeds(
            Collection<IncludedFromIncluded> toFill) 
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    IncludedFromIncludedPeer.DATABASE_NAME);
            List<ReferenceToIncluded> result = fillReferenceToIncludeds(toFill, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /** 
     * Fills the referenced ReferenceToIncluded objects in the aReferenceToIncluded fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read ReferenceToIncluded objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<ReferenceToIncluded> fillReferenceToIncludeds(
            Collection<IncludedFromIncluded> toFill,
            Connection connection) 
        throws TorqueException
    {
        Set<ObjectKey> foreignKeySet = new HashSet<ObjectKey>();
        for (IncludedFromIncluded currentIncludedFromIncluded : toFill)
        {
            ObjectKey foreignKey = currentIncludedFromIncluded.getForeignKeyForReferenceToIncluded();
            if (foreignKey != null)
            {
                foreignKeySet.add(foreignKey);
            }
        }

        int fillerChunkSize = getFillerChunkSize();
        Iterator<ObjectKey> foreignKeyIt = foreignKeySet.iterator();
        List<ObjectKey> foreignKeyListChunk
                = new ArrayList<ObjectKey>(fillerChunkSize);;
        Map<ObjectKey, ReferenceToIncluded> referencedKeyToReferenceToIncludedMap 
                = new HashMap<ObjectKey, ReferenceToIncluded>();
        while (foreignKeyIt.hasNext())
        {
            ObjectKey currentKey = foreignKeyIt.next();
            foreignKeyListChunk.add(currentKey);
            if (foreignKeyListChunk.size() < fillerChunkSize 
                && foreignKeyIt.hasNext())
            {
                continue;
            }

            List<ReferenceToIncluded> referencedReferenceToIncludedList
                 = ReferenceToIncludedPeer.retrieveByPKs(
                     foreignKeyListChunk,
                     connection);

            for (ReferenceToIncluded referencedObject : referencedReferenceToIncludedList)
            {
                referencedKeyToReferenceToIncludedMap.put(
                        referencedObject.getPrimaryKey(),
                        referencedObject);
            }
            foreignKeyListChunk.clear();
        }

        List<ReferenceToIncluded> result = new ArrayList<ReferenceToIncluded>();
        for (IncludedFromIncluded objectToFill : toFill)
        {
            ObjectKey foreignKey = objectToFill.getForeignKeyForReferenceToIncluded();
            if (foreignKey == null || foreignKey.getValue() == null)
            {
                continue;
            }
            ReferenceToIncluded referenced = referencedKeyToReferenceToIncludedMap.get(
                    foreignKey);
            if (referenced == null)
            {
                throw new NoRowsException("No result found for key " 
                    + foreignKey + " in table reference_to_included");
            }
            // copy the referenced object for the case that more than one
            // toFill object references the same object; in this case
            // every toFillObject should have its own instance of the referenced
            // object to remain consistent with the other Torque reference
            // treatment
            ReferenceToIncluded referencedCopy = referenced.copy(false);
            // copy does not set primary key
            referencedCopy.setPrimaryKey(referenced.getPrimaryKey());
            objectToFill.setReferenceToIncluded(referencedCopy);
            result.add(referencedCopy);
        }
        return result;
    }

    /** 
     * Fills the referenced ReferenceToIncluded objects in the collReferenceToIncludeds fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     *
     * @return all read List<ReferenceToIncluded> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<ReferenceToIncluded> fillReferencingReferenceToIncludeds(
            Collection<IncludedFromIncluded> toFill)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    IncludedFromIncludedPeer.DATABASE_NAME);
            List<ReferenceToIncluded> result = fillReferencingReferenceToIncludeds(toFill, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /** 
     * Fills the referenced ReferenceToIncluded objects in the collReferenceToIncludeds fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read List<ReferenceToIncluded> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<ReferenceToIncluded> fillReferencingReferenceToIncludeds(
            Collection<IncludedFromIncluded> toFill,
            Connection connection)
        throws TorqueException
    {
        Set<ObjectKey> localKeySet = new HashSet<ObjectKey>();
        for (IncludedFromIncluded currentIncludedFromIncluded : toFill)
        {
            ObjectKey localKey = currentIncludedFromIncluded.getPrimaryKey();
            localKeySet.add(localKey);
        }

        int fillerChunkSize = getFillerChunkSize();
        Iterator<ObjectKey> localKeyIt = localKeySet.iterator();
        List<ObjectKey> localKeyListChunk
                = new ArrayList<ObjectKey>(fillerChunkSize);
        Map<ObjectKey, List<ReferenceToIncluded>> fkToReferenceToIncludedMap
                = new HashMap<ObjectKey, List<ReferenceToIncluded>>();
        while (localKeyIt.hasNext())
        {
            ObjectKey currentKey = localKeyIt.next();
            localKeyListChunk.add(currentKey);
            if (localKeyListChunk.size() < fillerChunkSize
                && localKeyIt.hasNext())
            {
                continue;
            }

            Criteria criteria = new Criteria();
            criteria.andIn(ReferenceToIncludedPeer.INCLUDED_FROM_INCLUDED_ID, localKeyListChunk);
            List<ReferenceToIncluded> referencedReferenceToIncludedList
                 = ReferenceToIncludedPeer.doSelect(
                     criteria,
                     connection);
            for (ReferenceToIncluded referencedObject : referencedReferenceToIncludedList)
            {
                ObjectKey foreignKey = referencedObject.getForeignKeyForIncludedFromIncluded();
                List<ReferenceToIncluded> objectsWithForeignKey 
                    = fkToReferenceToIncludedMap.get(foreignKey);
                if (objectsWithForeignKey == null)
                {
                    objectsWithForeignKey = new ArrayList<ReferenceToIncluded>();
                    fkToReferenceToIncludedMap.put(
                        foreignKey,
                        objectsWithForeignKey);
                }
                objectsWithForeignKey.add(referencedObject);
            }
            localKeyListChunk.clear();
        }

        List<ReferenceToIncluded> result = new ArrayList<ReferenceToIncluded>();
        for (IncludedFromIncluded objectToFill : toFill)
        {
            objectToFill.initReferenceToIncludeds();
            objectToFill.getReferenceToIncludeds().clear();
            ObjectKey localKey = objectToFill.getPrimaryKey();
            List<ReferenceToIncluded> referencingList
                = fkToReferenceToIncludedMap.get(localKey);
            if (referencingList == null)
            {
                continue;
            }
            for (ReferenceToIncluded referencing : referencingList)
            {
                // copy the referencing object for the case that more than one
                // toFill object references the same object; in this case
                // every toFillObject should have its own instance 
                // of the referencing object to remain consistent
                // with other Torque referencing object treatment
                ReferenceToIncluded referencingCopy = referencing.copy(false);
                // copy does not set primary key
                referencingCopy.setPrimaryKey(referencing.getPrimaryKey());
                objectToFill.addReferenceToIncluded(referencingCopy);
                result.add(referencingCopy);
            }
        }
        return result;
    }
    /** 
     * Fills the referenced Included objects in the collIncludeds fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     *
     * @return all read List<Included> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<Included> fillReferencingIncludeds(
            Collection<IncludedFromIncluded> toFill)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    IncludedFromIncludedPeer.DATABASE_NAME);
            List<Included> result = fillReferencingIncludeds(toFill, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /** 
     * Fills the referenced Included objects in the collIncludeds fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read List<Included> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<Included> fillReferencingIncludeds(
            Collection<IncludedFromIncluded> toFill,
            Connection connection)
        throws TorqueException
    {
        Set<ObjectKey> localKeySet = new HashSet<ObjectKey>();
        for (IncludedFromIncluded currentIncludedFromIncluded : toFill)
        {
            ObjectKey localKey = currentIncludedFromIncluded.getPrimaryKey();
            localKeySet.add(localKey);
        }

        int fillerChunkSize = getFillerChunkSize();
        Iterator<ObjectKey> localKeyIt = localKeySet.iterator();
        List<ObjectKey> localKeyListChunk
                = new ArrayList<ObjectKey>(fillerChunkSize);
        Map<ObjectKey, List<Included>> fkToIncludedMap
                = new HashMap<ObjectKey, List<Included>>();
        while (localKeyIt.hasNext())
        {
            ObjectKey currentKey = localKeyIt.next();
            localKeyListChunk.add(currentKey);
            if (localKeyListChunk.size() < fillerChunkSize
                && localKeyIt.hasNext())
            {
                continue;
            }

            Criteria criteria = new Criteria();
            criteria.andIn(IncludedPeer.INCLUDED_FROM_INCLUDED_ID, localKeyListChunk);
            List<Included> referencedIncludedList
                 = IncludedPeer.doSelect(
                     criteria,
                     connection);
            for (Included referencedObject : referencedIncludedList)
            {
                ObjectKey foreignKey = referencedObject.getForeignKeyForIncludedFromIncluded();
                List<Included> objectsWithForeignKey 
                    = fkToIncludedMap.get(foreignKey);
                if (objectsWithForeignKey == null)
                {
                    objectsWithForeignKey = new ArrayList<Included>();
                    fkToIncludedMap.put(
                        foreignKey,
                        objectsWithForeignKey);
                }
                objectsWithForeignKey.add(referencedObject);
            }
            localKeyListChunk.clear();
        }

        List<Included> result = new ArrayList<Included>();
        for (IncludedFromIncluded objectToFill : toFill)
        {
            objectToFill.initIncludeds();
            objectToFill.getIncludeds().clear();
            ObjectKey localKey = objectToFill.getPrimaryKey();
            List<Included> referencingList
                = fkToIncludedMap.get(localKey);
            if (referencingList == null)
            {
                continue;
            }
            for (Included referencing : referencingList)
            {
                // copy the referencing object for the case that more than one
                // toFill object references the same object; in this case
                // every toFillObject should have its own instance 
                // of the referencing object to remain consistent
                // with other Torque referencing object treatment
                Included referencingCopy = referencing.copy(false);
                // copy does not set primary key
                referencingCopy.setPrimaryKey(referencing.getPrimaryKey());
                objectToFill.addIncluded(referencingCopy);
                result.add(referencingCopy);
            }
        }
        return result;
    }

    /** 
     * Returns the chunk size for the filler methods.
     *
     * @return the chunk size for the filler methods.
     */
    protected int getFillerChunkSize()
    {
        return 999;
    }


}
