package org.apache.torque.test;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.apache.torque.TorqueException;
import org.apache.torque.om.mapper.RecordMapper;

    
/**
 * Maps ResultSet rows into InheritanceClassnameTest objects.
 *
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:47 CEST 2012]
 *
 */
public class BaseInheritanceClassnameTestRecordMapper implements RecordMapper<InheritanceClassnameTest>
{
    /**
     * Constructs the object from the current row in the resultSet.
     *
     * @param resultSet the resultSet to operate on, already pointing
     *        to the correct row. Not null.
     * @param a possible offset in the rows to be considered
     *        (if previous rows contain other objects).
     *
     * @return the mapped object, not null.
     *
     * @throws TorqueException when reading fields from the RecordSet fails.
     */
    public InheritanceClassnameTest processRow(ResultSet resultSet, int offset)
            throws TorqueException
    {
            String classKey =
                getClassName(resultSet, offset + 2);
            InheritanceClassnameTest inheritanceClassnameTest;
            try
            {
                Class<?> omClass = Class.forName(classKey.toString());
                inheritanceClassnameTest = (InheritanceClassnameTest) omClass.newInstance();
            }
            catch (InstantiationException e)
            {
                throw new TorqueException(e);
            }
            catch (IllegalAccessException e)
            {
                throw new TorqueException(e);
            }
            catch (ClassNotFoundException e)
            {
                throw new TorqueException(e);
            }

        try 
        {
            inheritanceClassnameTest.setLoading(true);
            inheritanceClassnameTest.setInheritanceTest(
                    getInheritanceTest(resultSet, offset + 1));
            inheritanceClassnameTest.setClassName(
                    getClassName(resultSet, offset + 2));
            inheritanceClassnameTest.setPayload(
                    getPayload(resultSet, offset + 3));
            inheritanceClassnameTest.setNew(false);
            inheritanceClassnameTest.setModified(false);
        }
        finally
        {
            inheritanceClassnameTest.setLoading(false);
        }
        return inheritanceClassnameTest;
    }

        /**
         * Reads the value of the <code>columnIndex</code>'th column
         * in the <code>resultSet</code> so that it can be used to set
         * the field inheritanceTest in InheritanceClassnameTest.
         *
         * @param dbObject the database object to fill, not null.
         * @param resultSet the ResultSet to read from, not null.
         * @param columnIndex the index in the resultSet which should be read.
         *
         * @return the content of the column.
         *
         * @throws SQLException if a problem occurs when reading
         *         from the resultSet.
         */
        protected int getInheritanceTest(
                    ResultSet resultSet,
                    int columnIndex)
                throws TorqueException
        {
            try
            {
                return resultSet.getInt(columnIndex);
            }
            catch (SQLException e)
            {
                throw new TorqueException(e);
            }
        }

        /**
         * Reads the value of the <code>columnIndex</code>'th column
         * in the <code>resultSet</code> so that it can be used to set
         * the field className in InheritanceClassnameTest.
         *
         * @param dbObject the database object to fill, not null.
         * @param resultSet the ResultSet to read from, not null.
         * @param columnIndex the index in the resultSet which should be read.
         *
         * @return the content of the column.
         *
         * @throws SQLException if a problem occurs when reading
         *         from the resultSet.
         */
        protected String getClassName(
                    ResultSet resultSet,
                    int columnIndex)
                throws TorqueException
        {
            try
            {
                return resultSet.getString(columnIndex);
            }
            catch (SQLException e)
            {
                throw new TorqueException(e);
            }
        }

        /**
         * Reads the value of the <code>columnIndex</code>'th column
         * in the <code>resultSet</code> so that it can be used to set
         * the field payload in InheritanceClassnameTest.
         *
         * @param dbObject the database object to fill, not null.
         * @param resultSet the ResultSet to read from, not null.
         * @param columnIndex the index in the resultSet which should be read.
         *
         * @return the content of the column.
         *
         * @throws SQLException if a problem occurs when reading
         *         from the resultSet.
         */
        protected String getPayload(
                    ResultSet resultSet,
                    int columnIndex)
                throws TorqueException
        {
            try
            {
                return resultSet.getString(columnIndex);
            }
            catch (SQLException e)
            {
                throw new TorqueException(e);
            }
        }


}
