package org.apache.torque.test;

import java.io.Serializable;
import java.sql.Connection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.apache.torque.TorqueException;
import org.apache.torque.map.TableMap;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.BooleanKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.om.ColumnAccessByName;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.util.Transaction;
import org.apache.commons.lang.ObjectUtils;


/**
 * This class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:38 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to JavaDefaultValues
 */
public abstract class BaseJavaDefaultValues 
    implements Persistent, Serializable, ColumnAccessByName
{
    /** Serial version */
    private static final long serialVersionUID = 1347503738675L;



    /** Defines the id field. */
    private int id = 0;

    /** Defines the oInteger field. */
    private Integer oInteger = Integer.valueOf(2);

    /** Defines the pInt field. */
    private int pInt = 4;

    /** Defines the varcharField field. */
    private String varcharField = "Default!";

    /** Defines the dateField field. */
    private java.util.Date dateField = new Date(1283904000000L);

    /** Defines the timeField field. */
    private java.util.Date timeField = new Date(37230000L);

    /** Defines the timestampField field. */
    private java.util.Date timestampField = new Date(1283944333123L);

    /** Defines the currentDateValue field. */
    private java.util.Date currentDateValue = getCurrentDate();

    /** Defines the currentTimeValue field. */
    private java.util.Date currentTimeValue = getCurrentTime();

    /** Defines the currentTimestampValue field. */
    private java.util.Date currentTimestampValue = getCurrentTimestamp();

    /** Whether this object was modified after loading or after last save. */
    private boolean modified = true;

    /** 
     * Whether this object was loaded from the database or already saved 
     * (false) or whether it is not yet in the database(true).
     */
    private boolean isNew = true;

    /** Flag which indicates whether this object is currently saving. */
    private boolean saving = false;

    /** 
     * Flag which indicates whether this object is currently loaded
     * from the database. 
     */
    private boolean loading = false;

    /** 
     * Flag which indicates whether this object was deleted from the database.
     * Note that this flags does not always display the current database state,
     * there is no magical connection between this flag and the database.
     */
    private boolean deleted = false;





    /**
     * Get the value of id.
     *
     * @return int
     */
    public int getId() 
    {
        
        return id;
    }

    /**
     * Set the value of id.
     *
     * @param v new value
     */
    public void setId(int v)
    {
        if (this.id != v)
        {
            setModified(true);
        }

        this.id = v;


    }
    
    /**
     * Get the value of oInteger.
     *
     * @return Integer
     */
    public Integer getOInteger() 
    {
        
        return oInteger;
    }

    /**
     * Set the value of oInteger.
     *
     * @param v new value
     */
    public void setOInteger(Integer v)
    {
        if (!ObjectUtils.equals(this.oInteger, v))
        {
            setModified(true);
        }

        this.oInteger = v;


    }
    
    /**
     * Get the value of pInt.
     *
     * @return int
     */
    public int getPInt() 
    {
        
        return pInt;
    }

    /**
     * Set the value of pInt.
     *
     * @param v new value
     */
    public void setPInt(int v)
    {
        if (this.pInt != v)
        {
            setModified(true);
        }

        this.pInt = v;


    }
    
    /**
     * Get the value of varcharField.
     *
     * @return String
     */
    public String getVarcharField() 
    {
        
        return varcharField;
    }

    /**
     * Set the value of varcharField.
     *
     * @param v new value
     */
    public void setVarcharField(String v)
    {
        if (!ObjectUtils.equals(this.varcharField, v))
        {
            setModified(true);
        }

        this.varcharField = v;


    }
    
    /**
     * Get the value of dateField.
     *
     * @return java.util.Date
     */
    public java.util.Date getDateField() 
    {
        
        return dateField;
    }

    /**
     * Set the value of dateField.
     *
     * @param v new value
     */
    public void setDateField(java.util.Date v)
    {
        if (!ObjectUtils.equals(this.dateField, v))
        {
            setModified(true);
        }

        this.dateField = v;


    }
    
    /**
     * Get the value of timeField.
     *
     * @return java.util.Date
     */
    public java.util.Date getTimeField() 
    {
        
        return timeField;
    }

    /**
     * Set the value of timeField.
     *
     * @param v new value
     */
    public void setTimeField(java.util.Date v)
    {
        if (!ObjectUtils.equals(this.timeField, v))
        {
            setModified(true);
        }

        this.timeField = v;


    }
    
    /**
     * Get the value of timestampField.
     *
     * @return java.util.Date
     */
    public java.util.Date getTimestampField() 
    {
        
        return timestampField;
    }

    /**
     * Set the value of timestampField.
     *
     * @param v new value
     */
    public void setTimestampField(java.util.Date v)
    {
        if (!ObjectUtils.equals(this.timestampField, v))
        {
            setModified(true);
        }

        this.timestampField = v;


    }
    
    /**
     * Get the value of currentDateValue.
     *
     * @return java.util.Date
     */
    public java.util.Date getCurrentDateValue() 
    {
        
        return currentDateValue;
    }

    /**
     * Set the value of currentDateValue.
     *
     * @param v new value
     */
    public void setCurrentDateValue(java.util.Date v)
    {
        if (!ObjectUtils.equals(this.currentDateValue, v))
        {
            setModified(true);
        }

        this.currentDateValue = v;


    }
    
    /**
     * Get the value of currentTimeValue.
     *
     * @return java.util.Date
     */
    public java.util.Date getCurrentTimeValue() 
    {
        
        return currentTimeValue;
    }

    /**
     * Set the value of currentTimeValue.
     *
     * @param v new value
     */
    public void setCurrentTimeValue(java.util.Date v)
    {
        if (!ObjectUtils.equals(this.currentTimeValue, v))
        {
            setModified(true);
        }

        this.currentTimeValue = v;


    }
    
    /**
     * Get the value of currentTimestampValue.
     *
     * @return java.util.Date
     */
    public java.util.Date getCurrentTimestampValue() 
    {
        
        return currentTimestampValue;
    }

    /**
     * Set the value of currentTimestampValue.
     *
     * @param v new value
     */
    public void setCurrentTimestampValue(java.util.Date v)
    {
        if (!ObjectUtils.equals(this.currentTimestampValue, v))
        {
            setModified(true);
        }

        this.currentTimestampValue = v;


    }
    

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return true, if the object has never been persisted.
     */
    public boolean isNew()
    {
        return isNew;
    }

    /**
     * Sets whether the object has ever been saved.
     *
     * @param isNew true if the object has never been saved, false otherwise.
     */
    public void setNew(boolean isNew)
    {
        this.isNew = isNew;
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return True if the object has been modified.
     */
    public boolean isModified()
    {
        return modified;
    }

    /**
     * Sets whether the object has been modified.
     *
     * @param modified true if the object has been modified, false otherwise.
     */
    public void setModified(boolean modified)
    {
        this.modified = modified;
    }

    /**
     * Sets the modified state for the object to be false.
     */
    public void resetModified()
    {
        modified = false;
    }


    /**
     * Returns whether this object is currently saving.
     *
     * @return true if this object is currently saving, false otherwise.
     */
    public boolean isSaving()
    {
        return saving;
    }

    /**
     * Sets whether this object is currently saving.
     *
     * @param saving true if this object is currently saving, false otherwise.
     */
    public void setSaving(boolean saving)
    {
        this.saving = saving;
    }


    /**
     * Returns whether this object is currently being loaded from the database.
     *
     * @return true if this object is currently loading, false otherwise.
     */
    public boolean isLoading()
    {
        return loading;
    }

    /**
     * Sets whether this object is currently being loaded from the database.
     *
     * @param loading true if this object is currently loading, false otherwise.
     */
    public void setLoading(boolean loading)
    {
        this.loading = loading;
    }


    /**
     * Returns whether this object was deleted from the database.
     * Note that this getter does not automatically reflect database state,
     * it will be set to true by Torque if doDelete() was called with this 
     * object. Bulk deletes and deletes via primary key do not change
     * this flag. Also, if doDelete() was called on an object which does
     * not exist in the database, the deleted flag is set to true even if
     * it was not deleted.
     *
     * @return true if this object was deleted, false otherwise.
     */
    public boolean isDeleted()
    {
        return deleted;
    }

    /**
     * Sets whether this object was deleted from the database.
     *
     * @param deleted true if this object was deleted, false otherwise.
     */
    public void setDeleted(boolean deleted)
    {
        this.deleted = deleted;
    }







    private static final List<String> FIELD_NAMES;

    static
    {
        List<String> fieldNames
                = new ArrayList<String>();
        fieldNames.add("Id");
        fieldNames.add("OInteger");
        fieldNames.add("PInt");
        fieldNames.add("VarcharField");
        fieldNames.add("DateField");
        fieldNames.add("TimeField");
        fieldNames.add("TimestampField");
        fieldNames.add("CurrentDateValue");
        fieldNames.add("CurrentTimeValue");
        fieldNames.add("CurrentTimestampValue");
        FIELD_NAMES = Collections.unmodifiableList(fieldNames);
    }

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static List<String> getFieldNames()
    {
        return FIELD_NAMES;
    }

    /**
     * Retrieves a field from the object by field (Java) name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
        if (name.equals("Id"))
        {
            return new Integer(getId());
        }
        if (name.equals("OInteger"))
        {
            return getOInteger();
        }
        if (name.equals("PInt"))
        {
            return new Integer(getPInt());
        }
        if (name.equals("VarcharField"))
        {
            return getVarcharField();
        }
        if (name.equals("DateField"))
        {
            return getDateField();
        }
        if (name.equals("TimeField"))
        {
            return getTimeField();
        }
        if (name.equals("TimestampField"))
        {
            return getTimestampField();
        }
        if (name.equals("CurrentDateValue"))
        {
            return getCurrentDateValue();
        }
        if (name.equals("CurrentTimeValue"))
        {
            return getCurrentTimeValue();
        }
        if (name.equals("CurrentTimestampValue"))
        {
            return getCurrentTimestampValue();
        }
        return null;
    }

    /**
     * Set a field in the object by field (Java) name.
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (name.equals("Id"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setId(((Integer) value).intValue());
            return true;
        }
        if (name.equals("OInteger"))
        {
            // Object fields can be null
            if (value != null && ! Integer.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOInteger((Integer) value);
            return true;
        }
        if (name.equals("PInt"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setPInt(((Integer) value).intValue());
            return true;
        }
        if (name.equals("VarcharField"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setVarcharField((String) value);
            return true;
        }
        if (name.equals("DateField"))
        {
            // Object fields can be null
            if (value != null && ! java.util.Date.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setDateField((java.util.Date) value);
            return true;
        }
        if (name.equals("TimeField"))
        {
            // Object fields can be null
            if (value != null && ! java.util.Date.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setTimeField((java.util.Date) value);
            return true;
        }
        if (name.equals("TimestampField"))
        {
            // Object fields can be null
            if (value != null && ! java.util.Date.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setTimestampField((java.util.Date) value);
            return true;
        }
        if (name.equals("CurrentDateValue"))
        {
            // Object fields can be null
            if (value != null && ! java.util.Date.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setCurrentDateValue((java.util.Date) value);
            return true;
        }
        if (name.equals("CurrentTimeValue"))
        {
            // Object fields can be null
            if (value != null && ! java.util.Date.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setCurrentTimeValue((java.util.Date) value);
            return true;
        }
        if (name.equals("CurrentTimestampValue"))
        {
            // Object fields can be null
            if (value != null && ! java.util.Date.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setCurrentTimestampValue((java.util.Date) value);
            return true;
        }
        return false;
    }

    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
        if (name.equals(org.apache.torque.test.JavaDefaultValuesPeer.ID))
        {
            return new Integer(getId());
        }
        if (name.equals(org.apache.torque.test.JavaDefaultValuesPeer.O_INTEGER))
        {
            return getOInteger();
        }
        if (name.equals(org.apache.torque.test.JavaDefaultValuesPeer.P_INT))
        {
            return new Integer(getPInt());
        }
        if (name.equals(org.apache.torque.test.JavaDefaultValuesPeer.VARCHAR_FIELD))
        {
            return getVarcharField();
        }
        if (name.equals(org.apache.torque.test.JavaDefaultValuesPeer.DATE_FIELD))
        {
            return getDateField();
        }
        if (name.equals(org.apache.torque.test.JavaDefaultValuesPeer.TIME_FIELD))
        {
            return getTimeField();
        }
        if (name.equals(org.apache.torque.test.JavaDefaultValuesPeer.TIMESTAMP_FIELD))
        {
            return getTimestampField();
        }
        if (name.equals(org.apache.torque.test.JavaDefaultValuesPeer.CURRENT_DATE_VALUE))
        {
            return getCurrentDateValue();
        }
        if (name.equals(org.apache.torque.test.JavaDefaultValuesPeer.CURRENT_TIME_VALUE))
        {
            return getCurrentTimeValue();
        }
        if (name.equals(org.apache.torque.test.JavaDefaultValuesPeer.CURRENT_TIMESTAMP_VALUE))
        {
            return getCurrentTimestampValue();
        }
        return null;
    }

    /**
     * Set field values by Peer Field Name
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPeerName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (org.apache.torque.test.JavaDefaultValuesPeer.ID.getSqlExpression().equals(name))
        {
            return setByName("Id", value);
        }
        if (org.apache.torque.test.JavaDefaultValuesPeer.O_INTEGER.getSqlExpression().equals(name))
        {
            return setByName("OInteger", value);
        }
        if (org.apache.torque.test.JavaDefaultValuesPeer.P_INT.getSqlExpression().equals(name))
        {
            return setByName("PInt", value);
        }
        if (org.apache.torque.test.JavaDefaultValuesPeer.VARCHAR_FIELD.getSqlExpression().equals(name))
        {
            return setByName("VarcharField", value);
        }
        if (org.apache.torque.test.JavaDefaultValuesPeer.DATE_FIELD.getSqlExpression().equals(name))
        {
            return setByName("DateField", value);
        }
        if (org.apache.torque.test.JavaDefaultValuesPeer.TIME_FIELD.getSqlExpression().equals(name))
        {
            return setByName("TimeField", value);
        }
        if (org.apache.torque.test.JavaDefaultValuesPeer.TIMESTAMP_FIELD.getSqlExpression().equals(name))
        {
            return setByName("TimestampField", value);
        }
        if (org.apache.torque.test.JavaDefaultValuesPeer.CURRENT_DATE_VALUE.getSqlExpression().equals(name))
        {
            return setByName("CurrentDateValue", value);
        }
        if (org.apache.torque.test.JavaDefaultValuesPeer.CURRENT_TIME_VALUE.getSqlExpression().equals(name))
        {
            return setByName("CurrentTimeValue", value);
        }
        if (org.apache.torque.test.JavaDefaultValuesPeer.CURRENT_TIMESTAMP_VALUE.getSqlExpression().equals(name))
        {
            return setByName("CurrentTimestampValue", value);
        }
        return false;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
        if (pos == 0)
        {
            return new Integer(getId());
        }
        if (pos == 1)
        {
            return getOInteger();
        }
        if (pos == 2)
        {
            return new Integer(getPInt());
        }
        if (pos == 3)
        {
            return getVarcharField();
        }
        if (pos == 4)
        {
            return getDateField();
        }
        if (pos == 5)
        {
            return getTimeField();
        }
        if (pos == 6)
        {
            return getTimestampField();
        }
        if (pos == 7)
        {
            return getCurrentDateValue();
        }
        if (pos == 8)
        {
            return getCurrentTimeValue();
        }
        if (pos == 9)
        {
            return getCurrentTimestampValue();
        }
        return null;
    }

    /**
     * Set field values by its position (zero based) in the XML schema.
     *
     * @param position The field position
     * @param value field value
     * @return True if value was set, false if not (invalid position / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPosition(int position, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (position == 0)
        {
            return setByName("Id", value);
        }
        if (position == 1)
        {
            return setByName("OInteger", value);
        }
        if (position == 2)
        {
            return setByName("PInt", value);
        }
        if (position == 3)
        {
            return setByName("VarcharField", value);
        }
        if (position == 4)
        {
            return setByName("DateField", value);
        }
        if (position == 5)
        {
            return setByName("TimeField", value);
        }
        if (position == 6)
        {
            return setByName("TimestampField", value);
        }
        if (position == 7)
        {
            return setByName("CurrentDateValue", value);
        }
        if (position == 8)
        {
            return setByName("CurrentTimeValue", value);
        }
        if (position == 9)
        {
            return setByName("CurrentTimestampValue", value);
        }
        return false;
    }



    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save() throws TorqueException
    {
        save(JavaDefaultValuesPeer.DATABASE_NAME);
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     * @param dbName the name of the database to which the object
     *        should be saved.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(String dbName) 
            throws TorqueException
    {
        Connection con = null;
        try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally.
     *
     * @param toSave the object to be saved, not null.
     * @param con the connection to use for saving the object, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(Connection con) 
            throws TorqueException
    {
        if (isSaving())
        {
            return;
        }
        try
        {
            setSaving(true);
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    JavaDefaultValuesPeer.doInsert((JavaDefaultValues) this, con);
                    setNew(false);
                }
                else
                {
                    JavaDefaultValuesPeer.doUpdate((JavaDefaultValues) this, con);
                }
            }

        }
        finally
        {
            setSaving(false);
        }
    }




    /**
     * Set the PrimaryKey using ObjectKey.
     *
     * @param key id ObjectKey
     */
    public void setPrimaryKey(ObjectKey key)
        
    {
        setId(((NumberKey) key).intValue());
    }

    /**
     * Set the PrimaryKey using a String.
     *
     * @param key
     */
    public void setPrimaryKey(String key) 
    {
        setId(Integer.parseInt(key));
    }


    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        return SimpleKey.keyFor(getId());
    }



    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public JavaDefaultValues copy() throws TorqueException
    {
        return copy(true);
    }

    /**
     * Makes a copy of this object using a connection.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     *
     * @param con the database connection to read associated objects.
     */
    public JavaDefaultValues copy(Connection con) throws TorqueException
    {
        return copy(true, con);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     */
    public JavaDefaultValues copy(boolean deepcopy) throws TorqueException
    {
        JavaDefaultValues javaDefaultValues = new JavaDefaultValues();

        return copyInto(javaDefaultValues, deepcopy);
    }

    /**
     * Makes a copy of this object using connection.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @param con the database connection to read associated objects.
     */
    public JavaDefaultValues copy(boolean deepcopy, Connection con) throws TorqueException
    {
        JavaDefaultValues javaDefaultValues = new JavaDefaultValues();

        return copyInto(javaDefaultValues, deepcopy, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     */
    protected JavaDefaultValues copyInto(JavaDefaultValues copyObj) throws TorqueException
    {
        return copyInto(copyObj, true);
    }

    /**
     * Fills the copyObj with the contents of this object using connection.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param con the database connection to read associated objects.
     */
    protected JavaDefaultValues copyInto(JavaDefaultValues copyObj, Connection con) throws TorqueException
    {
        return copyInto(copyObj, true, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     */
    protected JavaDefaultValues copyInto(JavaDefaultValues copyObj, boolean deepcopy) throws TorqueException
    {
        copyObj.setId(0);
        copyObj.setOInteger(oInteger);
        copyObj.setPInt(pInt);
        copyObj.setVarcharField(varcharField);
        copyObj.setDateField(dateField);
        copyObj.setTimeField(timeField);
        copyObj.setTimestampField(timestampField);
        copyObj.setCurrentDateValue(currentDateValue);
        copyObj.setCurrentTimeValue(currentTimeValue);
        copyObj.setCurrentTimestampValue(currentTimestampValue);

        if (deepcopy)
        {
        }
        return copyObj;
    }
        
    
    /**
     * Fills the copyObj with the contents of this object using connection.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @param con the database connection to read associated objects.
     */
    protected JavaDefaultValues copyInto(JavaDefaultValues copyObj, boolean deepcopy, Connection con) throws TorqueException
    {
        copyObj.setId(0);
        copyObj.setOInteger(oInteger);
        copyObj.setPInt(pInt);
        copyObj.setVarcharField(varcharField);
        copyObj.setDateField(dateField);
        copyObj.setTimeField(timeField);
        copyObj.setTimestampField(timestampField);
        copyObj.setCurrentDateValue(currentDateValue);
        copyObj.setCurrentTimeValue(currentTimeValue);
        copyObj.setCurrentTimestampValue(currentTimestampValue);

        if (deepcopy)
        {
        }
        return copyObj;
    }

    /** The Peer class */
    private static final org.apache.torque.test.JavaDefaultValuesPeer peer
            = new org.apache.torque.test.JavaDefaultValuesPeer();

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public org.apache.torque.test.JavaDefaultValuesPeer getPeer()
    {
        return peer;
    }

    /**
     * Retrieves the TableMap object related to this Table data without
     * compiler warnings of using getPeer().getTableMap().
     *
     * @return The associated TableMap object.
     */
    public TableMap getTableMap() throws TorqueException
    {
        return org.apache.torque.test.JavaDefaultValuesPeer.getTableMap();
    }


    /**
     * Returns the current java date for use as default value.
     *
     * @return the current java date.
     */
    protected Date getCurrentDate()
    {
        GregorianCalendar calendar = new GregorianCalendar();
        calendar.set(GregorianCalendar.HOUR_OF_DAY, 0);
        calendar.set(GregorianCalendar.MINUTE, 0);
        calendar.set(GregorianCalendar.SECOND, 0);
        calendar.set(GregorianCalendar.MILLISECOND, 0);
        return calendar.getTime();
    }

    /**
     * Returns the current java time for use as default value.
     *
     * @return the current java time.
     */
    protected Date getCurrentTime()
    {
        GregorianCalendar calendar = new GregorianCalendar();
        calendar.set(1970,01,01);
        return calendar.getTime();
    }

    /**
     * Returns the current java timestamp for use as default value.
     *
     * @return the current java timestamp.
     */
    protected Date getCurrentTimestamp()
    {
        return new Date();
    }


    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("JavaDefaultValues:\n");
        str.append("id = ")
           .append(getId())
           .append("\n");
        str.append("oInteger = ")
           .append(getOInteger())
           .append("\n");
        str.append("pInt = ")
           .append(getPInt())
           .append("\n");
        str.append("varcharField = ")
           .append(getVarcharField())
           .append("\n");
        str.append("dateField = ")
           .append(getDateField())
           .append("\n");
        str.append("timeField = ")
           .append(getTimeField())
           .append("\n");
        str.append("timestampField = ")
           .append(getTimestampField())
           .append("\n");
        str.append("currentDateValue = ")
           .append(getCurrentDateValue())
           .append("\n");
        str.append("currentTimeValue = ")
           .append(getCurrentTimeValue())
           .append("\n");
        str.append("currentTimestampValue = ")
           .append(getCurrentTimestampValue())
           .append("\n");
        return(str.toString());
    }

    /**
     * Compares the primary key of this instance with the key of another.
     *
     * @param toCompare The object to compare to.
     * @return Whether the primary keys are equal and the object have the
     *         same class.
     */
    public boolean equals(Object toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!getClass().equals(toCompare.getClass()))
        {
            return false;
        }
        JavaDefaultValues other = (JavaDefaultValues) toCompare;
        if (getPrimaryKey() == null || other.getPrimaryKey() == null)
        {
            return false;
        }
        return getPrimaryKey().equals(other.getPrimaryKey());
    }

    /**
     * If the primary key is not <code>null</code>, return the hashcode of the
     * primary key.  Otherwise calls <code>Object.hashCode()</code>.
     *
     * @return an <code>int</code> value
     */
    public int hashCode()
    {
        ObjectKey ok = getPrimaryKey();
        if (ok == null)
        {
            return super.hashCode();
        }

        return ok.hashCode();
    }




}
