package org.apache.torque.test;

import java.io.Serializable;
import java.sql.Connection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.apache.torque.TorqueException;
import org.apache.torque.map.TableMap;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.BooleanKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.om.ColumnAccessByName;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.util.Transaction;
import org.apache.commons.lang.ObjectUtils;


/**
 * This class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:39 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to MultiPk
 */
public abstract class BaseMultiPk 
    implements Persistent, Serializable, ColumnAccessByName
{
    /** Serial version */
    private static final long serialVersionUID = 1347503739902L;



    /** Defines the pk1 field. */
    private String pk1 = null;

    /** Defines the pk2 field. */
    private int pk2 = 0;

    /** Defines the pk3 field. */
    private String pk3 = null;

    /** Defines the pk4 field. */
    private Integer pk4 = null;

    /** Defines the pk5 field. */
    private Byte pk5 = null;

    /** Defines the pk6 field. */
    private Short pk6 = null;

    /** Defines the pk7 field. */
    private Long pk7 = null;

    /** Defines the pk8 field. */
    private Double pk8 = null;

    /** Defines the pk9 field. */
    private Double pk9 = null;

    /** Defines the pk10 field. */
    private java.util.Date pk10 = null;

    /** Defines the colA field. */
    private boolean colA = false;

    /** Defines the colB field. */
    private Boolean colB = null;

    /** Whether this object was modified after loading or after last save. */
    private boolean modified = true;

    /** 
     * Whether this object was loaded from the database or already saved 
     * (false) or whether it is not yet in the database(true).
     */
    private boolean isNew = true;

    /** Flag which indicates whether this object is currently saving. */
    private boolean saving = false;

    /** 
     * Flag which indicates whether this object is currently loaded
     * from the database. 
     */
    private boolean loading = false;

    /** 
     * Flag which indicates whether this object was deleted from the database.
     * Note that this flags does not always display the current database state,
     * there is no magical connection between this flag and the database.
     */
    private boolean deleted = false;





    /**
     * Get the value of pk1.
     *
     * @return String
     */
    public String getPk1() 
    {
        
        return pk1;
    }

    /**
     * Set the value of pk1.
     *
     * @param v new value
     */
    public void setPk1(String v)
    {
        if (!ObjectUtils.equals(this.pk1, v))
        {
            setModified(true);
        }

        this.pk1 = v;


    }
    
    /**
     * Get the value of pk2.
     *
     * @return int
     */
    public int getPk2() 
    {
        
        return pk2;
    }

    /**
     * Set the value of pk2.
     *
     * @param v new value
     */
    public void setPk2(int v)
    {
        if (this.pk2 != v)
        {
            setModified(true);
        }

        this.pk2 = v;


    }
    
    /**
     * Get the value of pk3.
     *
     * @return String
     */
    public String getPk3() 
    {
        
        return pk3;
    }

    /**
     * Set the value of pk3.
     *
     * @param v new value
     */
    public void setPk3(String v)
    {
        if (!ObjectUtils.equals(this.pk3, v))
        {
            setModified(true);
        }

        this.pk3 = v;


    }
    
    /**
     * Get the value of pk4.
     *
     * @return Integer
     */
    public Integer getPk4() 
    {
        
        return pk4;
    }

    /**
     * Set the value of pk4.
     *
     * @param v new value
     */
    public void setPk4(Integer v)
    {
        if (!ObjectUtils.equals(this.pk4, v))
        {
            setModified(true);
        }

        this.pk4 = v;


    }
    
    /**
     * Get the value of pk5.
     *
     * @return Byte
     */
    public Byte getPk5() 
    {
        
        return pk5;
    }

    /**
     * Set the value of pk5.
     *
     * @param v new value
     */
    public void setPk5(Byte v)
    {
        if (!ObjectUtils.equals(this.pk5, v))
        {
            setModified(true);
        }

        this.pk5 = v;


    }
    
    /**
     * Get the value of pk6.
     *
     * @return Short
     */
    public Short getPk6() 
    {
        
        return pk6;
    }

    /**
     * Set the value of pk6.
     *
     * @param v new value
     */
    public void setPk6(Short v)
    {
        if (!ObjectUtils.equals(this.pk6, v))
        {
            setModified(true);
        }

        this.pk6 = v;


    }
    
    /**
     * Get the value of pk7.
     *
     * @return Long
     */
    public Long getPk7() 
    {
        
        return pk7;
    }

    /**
     * Set the value of pk7.
     *
     * @param v new value
     */
    public void setPk7(Long v)
    {
        if (!ObjectUtils.equals(this.pk7, v))
        {
            setModified(true);
        }

        this.pk7 = v;


    }
    
    /**
     * Get the value of pk8.
     *
     * @return Double
     */
    public Double getPk8() 
    {
        
        return pk8;
    }

    /**
     * Set the value of pk8.
     *
     * @param v new value
     */
    public void setPk8(Double v)
    {
        if (!ObjectUtils.equals(this.pk8, v))
        {
            setModified(true);
        }

        this.pk8 = v;


    }
    
    /**
     * Get the value of pk9.
     *
     * @return Double
     */
    public Double getPk9() 
    {
        
        return pk9;
    }

    /**
     * Set the value of pk9.
     *
     * @param v new value
     */
    public void setPk9(Double v)
    {
        if (!ObjectUtils.equals(this.pk9, v))
        {
            setModified(true);
        }

        this.pk9 = v;


    }
    
    /**
     * Get the value of pk10.
     *
     * @return java.util.Date
     */
    public java.util.Date getPk10() 
    {
        
        return pk10;
    }

    /**
     * Set the value of pk10.
     *
     * @param v new value
     */
    public void setPk10(java.util.Date v)
    {
        if (!ObjectUtils.equals(this.pk10, v))
        {
            setModified(true);
        }

        this.pk10 = v;


    }
    
    /**
     * Get the value of colA.
     *
     * @return boolean
     */
    public boolean getColA() 
    {
        
        return colA;
    }

    /**
     * Set the value of colA.
     *
     * @param v new value
     */
    public void setColA(boolean v)
    {
        if (this.colA != v)
        {
            setModified(true);
        }

        this.colA = v;


    }
    
    /**
     * Get the value of colB.
     *
     * @return Boolean
     */
    public Boolean getColB() 
    {
        
        return colB;
    }

    /**
     * Set the value of colB.
     *
     * @param v new value
     */
    public void setColB(Boolean v)
    {
        if (!ObjectUtils.equals(this.colB, v))
        {
            setModified(true);
        }

        this.colB = v;


    }
    

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return true, if the object has never been persisted.
     */
    public boolean isNew()
    {
        return isNew;
    }

    /**
     * Sets whether the object has ever been saved.
     *
     * @param isNew true if the object has never been saved, false otherwise.
     */
    public void setNew(boolean isNew)
    {
        this.isNew = isNew;
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return True if the object has been modified.
     */
    public boolean isModified()
    {
        return modified;
    }

    /**
     * Sets whether the object has been modified.
     *
     * @param modified true if the object has been modified, false otherwise.
     */
    public void setModified(boolean modified)
    {
        this.modified = modified;
    }

    /**
     * Sets the modified state for the object to be false.
     */
    public void resetModified()
    {
        modified = false;
    }


    /**
     * Returns whether this object is currently saving.
     *
     * @return true if this object is currently saving, false otherwise.
     */
    public boolean isSaving()
    {
        return saving;
    }

    /**
     * Sets whether this object is currently saving.
     *
     * @param saving true if this object is currently saving, false otherwise.
     */
    public void setSaving(boolean saving)
    {
        this.saving = saving;
    }


    /**
     * Returns whether this object is currently being loaded from the database.
     *
     * @return true if this object is currently loading, false otherwise.
     */
    public boolean isLoading()
    {
        return loading;
    }

    /**
     * Sets whether this object is currently being loaded from the database.
     *
     * @param loading true if this object is currently loading, false otherwise.
     */
    public void setLoading(boolean loading)
    {
        this.loading = loading;
    }


    /**
     * Returns whether this object was deleted from the database.
     * Note that this getter does not automatically reflect database state,
     * it will be set to true by Torque if doDelete() was called with this 
     * object. Bulk deletes and deletes via primary key do not change
     * this flag. Also, if doDelete() was called on an object which does
     * not exist in the database, the deleted flag is set to true even if
     * it was not deleted.
     *
     * @return true if this object was deleted, false otherwise.
     */
    public boolean isDeleted()
    {
        return deleted;
    }

    /**
     * Sets whether this object was deleted from the database.
     *
     * @param deleted true if this object was deleted, false otherwise.
     */
    public void setDeleted(boolean deleted)
    {
        this.deleted = deleted;
    }







    private static final List<String> FIELD_NAMES;

    static
    {
        List<String> fieldNames
                = new ArrayList<String>();
        fieldNames.add("Pk1");
        fieldNames.add("Pk2");
        fieldNames.add("Pk3");
        fieldNames.add("Pk4");
        fieldNames.add("Pk5");
        fieldNames.add("Pk6");
        fieldNames.add("Pk7");
        fieldNames.add("Pk8");
        fieldNames.add("Pk9");
        fieldNames.add("Pk10");
        fieldNames.add("ColA");
        fieldNames.add("ColB");
        FIELD_NAMES = Collections.unmodifiableList(fieldNames);
    }

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static List<String> getFieldNames()
    {
        return FIELD_NAMES;
    }

    /**
     * Retrieves a field from the object by field (Java) name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
        if (name.equals("Pk1"))
        {
            return getPk1();
        }
        if (name.equals("Pk2"))
        {
            return new Integer(getPk2());
        }
        if (name.equals("Pk3"))
        {
            return getPk3();
        }
        if (name.equals("Pk4"))
        {
            return getPk4();
        }
        if (name.equals("Pk5"))
        {
            return getPk5();
        }
        if (name.equals("Pk6"))
        {
            return getPk6();
        }
        if (name.equals("Pk7"))
        {
            return getPk7();
        }
        if (name.equals("Pk8"))
        {
            return getPk8();
        }
        if (name.equals("Pk9"))
        {
            return getPk9();
        }
        if (name.equals("Pk10"))
        {
            return getPk10();
        }
        if (name.equals("ColA"))
        {
            return new Boolean(getColA());
        }
        if (name.equals("ColB"))
        {
            return getColB();
        }
        return null;
    }

    /**
     * Set a field in the object by field (Java) name.
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (name.equals("Pk1"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPk1((String) value);
            return true;
        }
        if (name.equals("Pk2"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setPk2(((Integer) value).intValue());
            return true;
        }
        if (name.equals("Pk3"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPk3((String) value);
            return true;
        }
        if (name.equals("Pk4"))
        {
            // Object fields can be null
            if (value != null && ! Integer.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPk4((Integer) value);
            return true;
        }
        if (name.equals("Pk5"))
        {
            // Object fields can be null
            if (value != null && ! Byte.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPk5((Byte) value);
            return true;
        }
        if (name.equals("Pk6"))
        {
            // Object fields can be null
            if (value != null && ! Short.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPk6((Short) value);
            return true;
        }
        if (name.equals("Pk7"))
        {
            // Object fields can be null
            if (value != null && ! Long.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPk7((Long) value);
            return true;
        }
        if (name.equals("Pk8"))
        {
            // Object fields can be null
            if (value != null && ! Double.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPk8((Double) value);
            return true;
        }
        if (name.equals("Pk9"))
        {
            // Object fields can be null
            if (value != null && ! Double.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPk9((Double) value);
            return true;
        }
        if (name.equals("Pk10"))
        {
            // Object fields can be null
            if (value != null && ! java.util.Date.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPk10((java.util.Date) value);
            return true;
        }
        if (name.equals("ColA"))
        {
            if (value == null || ! (Boolean.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not a Boolean object.");
            }
            setColA(((Boolean)value).booleanValue());
            return true;
        }
        if (name.equals("ColB"))
        {
            // Object fields can be null
            if (value != null && ! Boolean.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setColB((Boolean) value);
            return true;
        }
        return false;
    }

    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
        if (name.equals(org.apache.torque.test.MultiPkPeer.PK1))
        {
            return getPk1();
        }
        if (name.equals(org.apache.torque.test.MultiPkPeer.PK2))
        {
            return new Integer(getPk2());
        }
        if (name.equals(org.apache.torque.test.MultiPkPeer.PK3))
        {
            return getPk3();
        }
        if (name.equals(org.apache.torque.test.MultiPkPeer.PK4))
        {
            return getPk4();
        }
        if (name.equals(org.apache.torque.test.MultiPkPeer.PK5))
        {
            return getPk5();
        }
        if (name.equals(org.apache.torque.test.MultiPkPeer.PK6))
        {
            return getPk6();
        }
        if (name.equals(org.apache.torque.test.MultiPkPeer.PK7))
        {
            return getPk7();
        }
        if (name.equals(org.apache.torque.test.MultiPkPeer.PK8))
        {
            return getPk8();
        }
        if (name.equals(org.apache.torque.test.MultiPkPeer.PK9))
        {
            return getPk9();
        }
        if (name.equals(org.apache.torque.test.MultiPkPeer.PK10))
        {
            return getPk10();
        }
        if (name.equals(org.apache.torque.test.MultiPkPeer.COL_A))
        {
            return new Boolean(getColA());
        }
        if (name.equals(org.apache.torque.test.MultiPkPeer.COL_B))
        {
            return getColB();
        }
        return null;
    }

    /**
     * Set field values by Peer Field Name
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPeerName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (org.apache.torque.test.MultiPkPeer.PK1.getSqlExpression().equals(name))
        {
            return setByName("Pk1", value);
        }
        if (org.apache.torque.test.MultiPkPeer.PK2.getSqlExpression().equals(name))
        {
            return setByName("Pk2", value);
        }
        if (org.apache.torque.test.MultiPkPeer.PK3.getSqlExpression().equals(name))
        {
            return setByName("Pk3", value);
        }
        if (org.apache.torque.test.MultiPkPeer.PK4.getSqlExpression().equals(name))
        {
            return setByName("Pk4", value);
        }
        if (org.apache.torque.test.MultiPkPeer.PK5.getSqlExpression().equals(name))
        {
            return setByName("Pk5", value);
        }
        if (org.apache.torque.test.MultiPkPeer.PK6.getSqlExpression().equals(name))
        {
            return setByName("Pk6", value);
        }
        if (org.apache.torque.test.MultiPkPeer.PK7.getSqlExpression().equals(name))
        {
            return setByName("Pk7", value);
        }
        if (org.apache.torque.test.MultiPkPeer.PK8.getSqlExpression().equals(name))
        {
            return setByName("Pk8", value);
        }
        if (org.apache.torque.test.MultiPkPeer.PK9.getSqlExpression().equals(name))
        {
            return setByName("Pk9", value);
        }
        if (org.apache.torque.test.MultiPkPeer.PK10.getSqlExpression().equals(name))
        {
            return setByName("Pk10", value);
        }
        if (org.apache.torque.test.MultiPkPeer.COL_A.getSqlExpression().equals(name))
        {
            return setByName("ColA", value);
        }
        if (org.apache.torque.test.MultiPkPeer.COL_B.getSqlExpression().equals(name))
        {
            return setByName("ColB", value);
        }
        return false;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
        if (pos == 0)
        {
            return getPk1();
        }
        if (pos == 1)
        {
            return new Integer(getPk2());
        }
        if (pos == 2)
        {
            return getPk3();
        }
        if (pos == 3)
        {
            return getPk4();
        }
        if (pos == 4)
        {
            return getPk5();
        }
        if (pos == 5)
        {
            return getPk6();
        }
        if (pos == 6)
        {
            return getPk7();
        }
        if (pos == 7)
        {
            return getPk8();
        }
        if (pos == 8)
        {
            return getPk9();
        }
        if (pos == 9)
        {
            return getPk10();
        }
        if (pos == 10)
        {
            return new Boolean(getColA());
        }
        if (pos == 11)
        {
            return getColB();
        }
        return null;
    }

    /**
     * Set field values by its position (zero based) in the XML schema.
     *
     * @param position The field position
     * @param value field value
     * @return True if value was set, false if not (invalid position / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPosition(int position, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (position == 0)
        {
            return setByName("Pk1", value);
        }
        if (position == 1)
        {
            return setByName("Pk2", value);
        }
        if (position == 2)
        {
            return setByName("Pk3", value);
        }
        if (position == 3)
        {
            return setByName("Pk4", value);
        }
        if (position == 4)
        {
            return setByName("Pk5", value);
        }
        if (position == 5)
        {
            return setByName("Pk6", value);
        }
        if (position == 6)
        {
            return setByName("Pk7", value);
        }
        if (position == 7)
        {
            return setByName("Pk8", value);
        }
        if (position == 8)
        {
            return setByName("Pk9", value);
        }
        if (position == 9)
        {
            return setByName("Pk10", value);
        }
        if (position == 10)
        {
            return setByName("ColA", value);
        }
        if (position == 11)
        {
            return setByName("ColB", value);
        }
        return false;
    }



    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save() throws TorqueException
    {
        save(MultiPkPeer.DATABASE_NAME);
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     * @param dbName the name of the database to which the object
     *        should be saved.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(String dbName) 
            throws TorqueException
    {
        Connection con = null;
        try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally.
     *
     * @param toSave the object to be saved, not null.
     * @param con the connection to use for saving the object, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(Connection con) 
            throws TorqueException
    {
        if (isSaving())
        {
            return;
        }
        try
        {
            setSaving(true);
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    MultiPkPeer.doInsert((MultiPk) this, con);
                    setNew(false);
                }
                else
                {
                    MultiPkPeer.doUpdate((MultiPk) this, con);
                }
            }

        }
        finally
        {
            setSaving(false);
        }
    }





    private final SimpleKey[] pks = new SimpleKey[10];
    private final ComboKey comboPK = new ComboKey(pks);

    /**
     * Set the PrimaryKey with an ObjectKey
     *
     * @param key
     */
    public void setPrimaryKey(ObjectKey key) throws TorqueException
    {
        SimpleKey[] keys = (SimpleKey[]) key.getValue();
        setPk1(keys[0].toString());
        setPk2(((NumberKey) keys[1]).intValue());
        setPk3(keys[2].toString());
        setPk4(((NumberKey) keys[3]).intValue());
        setPk5(((NumberKey) keys[4]).byteValue());
        setPk6(((NumberKey) keys[5]).shortValue());
        setPk7(((NumberKey) keys[6]).longValue());
        setPk8(((NumberKey) keys[7]).doubleValue());
        setPk9(((NumberKey) keys[8]).doubleValue());
        setPk10(((DateKey) keys[9]).getDate());
    }

    /**
     * Set the PrimaryKey using SimpleKeys.
     *
     * @param String pk1
     * @param int pk2
     * @param String pk3
     * @param Integer pk4
     * @param Byte pk5
     * @param Short pk6
     * @param Long pk7
     * @param Double pk8
     * @param Double pk9
     * @param java.util.Date pk10
     */
    public void setPrimaryKey(String pk1, int pk2, String pk3, Integer pk4, Byte pk5, Short pk6, Long pk7, Double pk8, Double pk9, java.util.Date pk10)
        
    {
        setPk1(pk1);
        setPk2(pk2);
        setPk3(pk3);
        setPk4(pk4);
        setPk5(pk5);
        setPk6(pk6);
        setPk7(pk7);
        setPk8(pk8);
        setPk9(pk9);
        setPk10(pk10);
    }

    /**
     * Set the PrimaryKey using a String.
     */
    public void setPrimaryKey(String key) throws TorqueException
    {
        setPrimaryKey(new ComboKey(key));
    }

    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        SimpleKey[] pks = new SimpleKey[10];
        pks[0] = SimpleKey.keyFor(getPk1());
        pks[1] = SimpleKey.keyFor(getPk2());
        pks[2] = SimpleKey.keyFor(getPk3());
        pks[3] = SimpleKey.keyFor(getPk4());
        pks[4] = SimpleKey.keyFor(getPk5());
        pks[5] = SimpleKey.keyFor(getPk6());
        pks[6] = SimpleKey.keyFor(getPk7());
        pks[7] = SimpleKey.keyFor(getPk8());
        pks[8] = SimpleKey.keyFor(getPk9());
        pks[9] = SimpleKey.keyFor(getPk10());
        return new ComboKey(pks);
    }



    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public MultiPk copy() throws TorqueException
    {
        return copy(true);
    }

    /**
     * Makes a copy of this object using a connection.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     *
     * @param con the database connection to read associated objects.
     */
    public MultiPk copy(Connection con) throws TorqueException
    {
        return copy(true, con);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     */
    public MultiPk copy(boolean deepcopy) throws TorqueException
    {
        MultiPk multiPk = new MultiPk();

        return copyInto(multiPk, deepcopy);
    }

    /**
     * Makes a copy of this object using connection.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @param con the database connection to read associated objects.
     */
    public MultiPk copy(boolean deepcopy, Connection con) throws TorqueException
    {
        MultiPk multiPk = new MultiPk();

        return copyInto(multiPk, deepcopy, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     */
    protected MultiPk copyInto(MultiPk copyObj) throws TorqueException
    {
        return copyInto(copyObj, true);
    }

    /**
     * Fills the copyObj with the contents of this object using connection.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param con the database connection to read associated objects.
     */
    protected MultiPk copyInto(MultiPk copyObj, Connection con) throws TorqueException
    {
        return copyInto(copyObj, true, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     */
    protected MultiPk copyInto(MultiPk copyObj, boolean deepcopy) throws TorqueException
    {
        copyObj.setPk1((String) null);
        copyObj.setPk2(0);
        copyObj.setPk3((String) null);
        copyObj.setPk4((Integer) null);
        copyObj.setPk5((Byte) null);
        copyObj.setPk6((Short) null);
        copyObj.setPk7((Long) null);
        copyObj.setPk8((Double) null);
        copyObj.setPk9((Double) null);
        copyObj.setPk10((java.util.Date) null);
        copyObj.setColA(colA);
        copyObj.setColB(colB);

        if (deepcopy)
        {
        }
        return copyObj;
    }
        
    
    /**
     * Fills the copyObj with the contents of this object using connection.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @param con the database connection to read associated objects.
     */
    protected MultiPk copyInto(MultiPk copyObj, boolean deepcopy, Connection con) throws TorqueException
    {
        copyObj.setPk1((String) null);
        copyObj.setPk2(0);
        copyObj.setPk3((String) null);
        copyObj.setPk4((Integer) null);
        copyObj.setPk5((Byte) null);
        copyObj.setPk6((Short) null);
        copyObj.setPk7((Long) null);
        copyObj.setPk8((Double) null);
        copyObj.setPk9((Double) null);
        copyObj.setPk10((java.util.Date) null);
        copyObj.setColA(colA);
        copyObj.setColB(colB);

        if (deepcopy)
        {
        }
        return copyObj;
    }

    /** The Peer class */
    private static final org.apache.torque.test.MultiPkPeer peer
            = new org.apache.torque.test.MultiPkPeer();

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public org.apache.torque.test.MultiPkPeer getPeer()
    {
        return peer;
    }

    /**
     * Retrieves the TableMap object related to this Table data without
     * compiler warnings of using getPeer().getTableMap().
     *
     * @return The associated TableMap object.
     */
    public TableMap getTableMap() throws TorqueException
    {
        return org.apache.torque.test.MultiPkPeer.getTableMap();
    }



    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("MultiPk:\n");
        str.append("pk1 = ")
           .append(getPk1())
           .append("\n");
        str.append("pk2 = ")
           .append(getPk2())
           .append("\n");
        str.append("pk3 = ")
           .append(getPk3())
           .append("\n");
        str.append("pk4 = ")
           .append(getPk4())
           .append("\n");
        str.append("pk5 = ")
           .append(getPk5())
           .append("\n");
        str.append("pk6 = ")
           .append(getPk6())
           .append("\n");
        str.append("pk7 = ")
           .append(getPk7())
           .append("\n");
        str.append("pk8 = ")
           .append(getPk8())
           .append("\n");
        str.append("pk9 = ")
           .append(getPk9())
           .append("\n");
        str.append("pk10 = ")
           .append(getPk10())
           .append("\n");
        str.append("colA = ")
           .append(getColA())
           .append("\n");
        str.append("colB = ")
           .append(getColB())
           .append("\n");
        return(str.toString());
    }

    /**
     * Compares the primary key of this instance with the key of another.
     *
     * @param toCompare The object to compare to.
     * @return Whether the primary keys are equal and the object have the
     *         same class.
     */
    public boolean equals(Object toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!getClass().equals(toCompare.getClass()))
        {
            return false;
        }
        MultiPk other = (MultiPk) toCompare;
        if (getPrimaryKey() == null || other.getPrimaryKey() == null)
        {
            return false;
        }
        return getPrimaryKey().equals(other.getPrimaryKey());
    }

    /**
     * If the primary key is not <code>null</code>, return the hashcode of the
     * primary key.  Otherwise calls <code>Object.hashCode()</code>.
     *
     * @return an <code>int</code> value
     */
    public int hashCode()
    {
        ObjectKey ok = getPrimaryKey();
        if (ok == null)
        {
            return super.hashCode();
        }

        return ok.hashCode();
    }




}
