package org.apache.torque.test;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.torque.NoRowsException;
import org.apache.torque.TooManyRowsException;
import org.apache.torque.Column;
import org.apache.torque.Torque;
import org.apache.torque.TorqueException;
import org.apache.torque.TorqueRuntimeException;
import org.apache.torque.adapter.IDMethod;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.map.DatabaseMap;
import org.apache.torque.map.TableMap;
import org.apache.torque.map.ColumnMap;
import org.apache.torque.map.ForeignKeyMap;
import org.apache.torque.map.InheritanceMap;
import org.apache.torque.om.mapper.RecordMapper;
import org.apache.torque.om.mapper.CompositeMapper;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.util.BasePeer;
import org.apache.torque.util.Transaction;
import org.apache.torque.util.ColumnValues;
import org.apache.torque.util.JdbcTypedValue;



/**
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:43 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to MultiPkPeer
 */
@SuppressWarnings({"unused", "unchecked"})
public abstract class BaseMultiPkPeer
{
    /** The class log. */
    private static Log log = LogFactory.getLog(BaseMultiPkPeerImpl.class);
    /** Serial version */
    private static final long serialVersionUID = 1347503743927L;


    /** The default database name for this class. */
    public static final String DATABASE_NAME;

     /** The table name for this class. */
    public static final String TABLE_NAME;

     /** The table map for this class. */
    public static final TableMap TABLE;
    /** The column for the pk1 field */
    public static final ColumnMap PK1;
    /** The column for the pk2 field */
    public static final ColumnMap PK2;
    /** The column for the pk3 field */
    public static final ColumnMap PK3;
    /** The column for the pk4 field */
    public static final ColumnMap PK4;
    /** The column for the pk5 field */
    public static final ColumnMap PK5;
    /** The column for the pk6 field */
    public static final ColumnMap PK6;
    /** The column for the pk7 field */
    public static final ColumnMap PK7;
    /** The column for the pk8 field */
    public static final ColumnMap PK8;
    /** The column for the pk9 field */
    public static final ColumnMap PK9;
    /** The column for the pk10 field */
    public static final ColumnMap PK10;
    /** The column for the col_a field */
    public static final ColumnMap COL_A;
    /** The column for the col_b field */
    public static final ColumnMap COL_B;

    /** number of columns for this peer */
    public static final int numColumns = 12;


    /** The implementation of the peer. */
    private static MultiPkPeerImpl multiPkPeerImpl;


    static
    {
        DatabaseMap dbMap = Torque.getOrCreateDatabase("bookstore")
                .getDatabaseMap();
        if (dbMap.getTable("MULTI_PK") == null)
        {
            dbMap.addTable("MULTI_PK");
        }
        DATABASE_NAME = "bookstore";
        TABLE_NAME = "MULTI_PK";

        TABLE = dbMap.getTable("MULTI_PK");
        TABLE.setJavaName("MultiPk");
        TABLE.setOMClass(org.apache.torque.test.MultiPk.class);
        TABLE.setPeerClass(org.apache.torque.test.MultiPkPeer.class);
        TABLE.setPrimaryKeyMethod(IDMethod.NO_ID_METHOD);
        TABLE.setPrimaryKeyMethodInfo(IDMethod.ID_BROKER, TABLE.getName());
        TABLE.setPrimaryKeyMethodInfo(IDMethod.SEQUENCE, "$sequenceName");
        TABLE.setPrimaryKeyMethodInfo(IDMethod.AUTO_INCREMENT, "MULTI_PK");
        TABLE.setUseInheritance(true);


    // ------------- Column: pk1 --------------------
        PK1 = new ColumnMap("pk1", TABLE);
        PK1.setType("");
        PK1.setTorqueType("VARCHAR");
        PK1.setUsePrimitive(false);
        PK1.setPrimaryKey(true);
        PK1.setNotNull(true);
        PK1.setJavaName("Pk1");
        PK1.setAutoIncrement(false);
        PK1.setProtected(false);
        PK1.setJavaType( "String" );
        PK1.setSize(30);
        PK1.setPosition(1);
        TABLE.addColumn(PK1);
    // ------------- Column: pk2 --------------------
        PK2 = new ColumnMap("pk2", TABLE);
        PK2.setType(Integer.valueOf(0));
        PK2.setTorqueType("INTEGER");
        PK2.setUsePrimitive(true);
        PK2.setPrimaryKey(true);
        PK2.setNotNull(true);
        PK2.setJavaName("Pk2");
        PK2.setAutoIncrement(false);
        PK2.setProtected(false);
        PK2.setJavaType( "int" );
        PK2.setPosition(2);
        TABLE.addColumn(PK2);
    // ------------- Column: pk3 --------------------
        PK3 = new ColumnMap("pk3", TABLE);
        PK3.setType("");
        PK3.setTorqueType("CHAR");
        PK3.setUsePrimitive(false);
        PK3.setPrimaryKey(true);
        PK3.setNotNull(true);
        PK3.setJavaName("Pk3");
        PK3.setAutoIncrement(false);
        PK3.setProtected(false);
        PK3.setJavaType( "String" );
        PK3.setSize(5);
        PK3.setPosition(3);
        TABLE.addColumn(PK3);
    // ------------- Column: pk4 --------------------
        PK4 = new ColumnMap("pk4", TABLE);
        PK4.setType(Integer.valueOf(0));
        PK4.setTorqueType("INTEGER");
        PK4.setUsePrimitive(false);
        PK4.setPrimaryKey(true);
        PK4.setNotNull(true);
        PK4.setJavaName("Pk4");
        PK4.setAutoIncrement(false);
        PK4.setProtected(false);
        PK4.setJavaType( "Integer" );
        PK4.setPosition(4);
        TABLE.addColumn(PK4);
    // ------------- Column: pk5 --------------------
        PK5 = new ColumnMap("pk5", TABLE);
        PK5.setType(Byte.valueOf((byte) 0));
        PK5.setTorqueType("TINYINT");
        PK5.setUsePrimitive(false);
        PK5.setPrimaryKey(true);
        PK5.setNotNull(true);
        PK5.setJavaName("Pk5");
        PK5.setAutoIncrement(false);
        PK5.setProtected(false);
        PK5.setJavaType( "Byte" );
        PK5.setPosition(5);
        TABLE.addColumn(PK5);
    // ------------- Column: pk6 --------------------
        PK6 = new ColumnMap("pk6", TABLE);
        PK6.setType(Short.valueOf((short) 0));
        PK6.setTorqueType("SMALLINT");
        PK6.setUsePrimitive(false);
        PK6.setPrimaryKey(true);
        PK6.setNotNull(true);
        PK6.setJavaName("Pk6");
        PK6.setAutoIncrement(false);
        PK6.setProtected(false);
        PK6.setJavaType( "Short" );
        PK6.setPosition(6);
        TABLE.addColumn(PK6);
    // ------------- Column: pk7 --------------------
        PK7 = new ColumnMap("pk7", TABLE);
        PK7.setType(Long.valueOf(0));
        PK7.setTorqueType("BIGINT");
        PK7.setUsePrimitive(false);
        PK7.setPrimaryKey(true);
        PK7.setNotNull(true);
        PK7.setJavaName("Pk7");
        PK7.setAutoIncrement(false);
        PK7.setProtected(false);
        PK7.setJavaType( "Long" );
        PK7.setPosition(7);
        TABLE.addColumn(PK7);
    // ------------- Column: pk8 --------------------
        PK8 = new ColumnMap("pk8", TABLE);
        PK8.setType(new Double(0));
        PK8.setTorqueType("FLOAT");
        PK8.setUsePrimitive(false);
        PK8.setPrimaryKey(true);
        PK8.setNotNull(true);
        PK8.setJavaName("Pk8");
        PK8.setAutoIncrement(false);
        PK8.setProtected(false);
        PK8.setJavaType( "Double" );
        PK8.setPosition(8);
        TABLE.addColumn(PK8);
    // ------------- Column: pk9 --------------------
        PK9 = new ColumnMap("pk9", TABLE);
        PK9.setType(new Double(0));
        PK9.setTorqueType("DOUBLE");
        PK9.setUsePrimitive(false);
        PK9.setPrimaryKey(true);
        PK9.setNotNull(true);
        PK9.setJavaName("Pk9");
        PK9.setAutoIncrement(false);
        PK9.setProtected(false);
        PK9.setJavaType( "Double" );
        PK9.setPosition(9);
        TABLE.addColumn(PK9);
    // ------------- Column: pk10 --------------------
        PK10 = new ColumnMap("pk10", TABLE);
        PK10.setType(new Date());
        PK10.setTorqueType("TIMESTAMP");
        PK10.setUsePrimitive(false);
        PK10.setPrimaryKey(true);
        PK10.setNotNull(true);
        PK10.setJavaName("Pk10");
        PK10.setAutoIncrement(false);
        PK10.setProtected(false);
        PK10.setJavaType( "java.util.Date" );
        PK10.setPosition(10);
        TABLE.addColumn(PK10);
    // ------------- Column: col_a --------------------
        COL_A = new ColumnMap("col_a", TABLE);
        COL_A.setType(new Integer(0));
        COL_A.setTorqueType("BOOLEANINT");
        COL_A.setUsePrimitive(true);
        COL_A.setPrimaryKey(false);
        COL_A.setNotNull(false);
        COL_A.setJavaName("ColA");
        COL_A.setAutoIncrement(false);
        COL_A.setProtected(false);
        COL_A.setJavaType( "boolean" );
        COL_A.setPosition(11);
        TABLE.addColumn(COL_A);
    // ------------- Column: col_b --------------------
        COL_B = new ColumnMap("col_b", TABLE);
        COL_B.setType(new Integer(0));
        COL_B.setTorqueType("BOOLEANINT");
        COL_B.setUsePrimitive(false);
        COL_B.setPrimaryKey(false);
        COL_B.setNotNull(false);
        COL_B.setJavaName("ColB");
        COL_B.setAutoIncrement(false);
        COL_B.setProtected(false);
        COL_B.setJavaType( "Boolean" );
        COL_B.setPosition(12);
        TABLE.addColumn(COL_B);



        initDatabaseMap();
    }

    /**
     * Creates a new instance of the  implementation of the peer.
     *
     * @return the new instance.
     */
    protected static MultiPkPeerImpl createMultiPkPeerImpl()
    {
        MultiPkPeerImpl instance = new MultiPkPeerImpl();
        return instance;
    }


    /**
     * Returns an instance of the implementation of the peer.
     * If no instance is currently cached, a new instance is created and cached.
     *
     * @return an instance of the implementation of the peer, not null.
     */
    public static MultiPkPeerImpl getMultiPkPeerImpl()
    {
        MultiPkPeerImpl peerImplInstance = multiPkPeerImpl;
        if (peerImplInstance == null)
        {
            peerImplInstance = MultiPkPeer.createMultiPkPeerImpl();
            multiPkPeerImpl = peerImplInstance;
        }
        return peerImplInstance;
    }



    /**
     * Sets the instance of the implementation of the peer.
     *
     * @param an instance of the implementation of the peer, or null
     *        if a new instance should be created automatically.
     */
    public static void setMultiPkPeerImpl(MultiPkPeerImpl peerImplInstance)
    {
        multiPkPeerImpl = peerImplInstance;
    }


    /**
     * Get the list of objects for a ResultSet.  Please not that your
     * resultset MUST return columns in the right order.  You can use
     * getFieldNames() in BaseObject to get the correct sequence.
     *
     * @param resultSet the ResultSet
     * @return the list of objects
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultiPk> resultSet2Objects(ResultSet resultSet)
            throws TorqueException
    {
        return getMultiPkPeerImpl().resultSet2Objects(resultSet);
    }

    /**
     * Add all the columns needed to create a new object.
     *
     * @param criteria object containing the columns to add.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void addSelectColumns(Criteria criteria)
            throws TorqueException
    {
        getMultiPkPeerImpl().addSelectColumns(criteria);
    }

    /**
     * changes the boolean values in the criteria to the appropriate type,
     * whenever a booleanchar or booleanint column is involved.
     * This enables the user to create criteria using Boolean values
     * for booleanchar or booleanint columns.
     *
     * @param criteria the criteria in which the boolean values
     *        should be corrected.
     *
     * @throws TorqueException if the database map for the criteria cannot be 
               obtained.
     */
    public static void correctBooleans(Criteria criteria) throws TorqueException
    {
        getMultiPkPeerImpl().correctBooleans(criteria);
    }

    /**
     * Checks all columns in the criteria to see whether
     * booleanchar and booleanint columns are queried with a boolean.
     * If yes, the query values are mapped onto values the database
     * does understand, i.e. 0 and 1 for booleanints and N and Y for
     * booleanchar columns.
     *
     * @param columnValues The value to be checked for booleanint
     *        and booleanchar columns.
     * @throws TorqueException if the database map for the criteria cannot be
     *         retrieved.
     */
    public static void correctBooleans(
            ColumnValues columnValues)
        throws TorqueException
    {
        getMultiPkPeerImpl().correctBooleans(columnValues);
    }
    
    /**
     * Selects MultiPk objects from a database.
     *
     * @param criteria object used to create the SELECT statement.
     *
     * @return the list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultiPk> doSelect(Criteria criteria)
            throws TorqueException
    {
        return getMultiPkPeerImpl().doSelect(criteria);
    }

    /**
     * Selects MultiPk objects from a database
     * within a transaction.
     *
     * @param criteria object used to create the SELECT statement.
     * @param connection the connection holding the transaction, not null.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultiPk> doSelect(
                Criteria criteria,
                Connection connection)
            throws TorqueException
    {
        return getMultiPkPeerImpl().doSelect(criteria, connection);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                Criteria criteria,
                RecordMapper<T> mapper)
            throws TorqueException
    {
        return getMultiPkPeerImpl().doSelect(criteria, mapper);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection for selecting records,
     *        not null.
     *
     * @return The results of the query, not null.
     * @throws TorqueException Error performing database query.
     */
    public static <T> List<T> doSelect(
            Criteria criteria,
            RecordMapper<T> mapper,
            Connection connection)
        throws TorqueException
    {
        return getMultiPkPeerImpl().doSelect(
                criteria,
                mapper,
                connection);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param query the sql query to execute, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param dbName The name of the database to create the connection for,
     *        or null for the default SDB.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                String query,
                RecordMapper<T> mapper,
                String dbName)
            throws TorqueException
    {
        return getMultiPkPeerImpl().doSelect(
                query,
                mapper,
                dbName);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param query the SQL Query to execute, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection, not null.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                String query,
                RecordMapper<T> mapper,
                Connection connection)
            throws TorqueException
    {
        return getMultiPkPeerImpl().doSelect(
                query,
                mapper,
                connection);
    }

    /**
     * Selects MultiPk objects from the database which have
     * the same content as the passed object.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultiPk> doSelect(MultiPk obj)
            throws TorqueException
    {
        return getMultiPkPeerImpl().doSelect(obj);
    }

    /**
     * Selects at most one MultiPk object from a database.
     *
     * @param criteria object used to create the SELECT statement.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static MultiPk doSelectSingleRecord(
                Criteria criteria)
            throws TorqueException
    {
        return getMultiPkPeerImpl().doSelectSingleRecord(criteria);
    }

    /**
     * Selects at most one MultiPk object from a database
     * within a transaction.
     *
     * @param criteria object used to create the SELECT statement.
     * @param connection the connection holding the transaction, not null.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static MultiPk doSelectSingleRecord(
                Criteria criteria,
                Connection connection)
            throws TorqueException
    {
        return getMultiPkPeerImpl().doSelectSingleRecord(criteria, connection);
    }

    /**
     * Selects at most a single row from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     *
     * @return The selected row, or null if no records was selected.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> T doSelectSingleRecord(
                org.apache.torque.criteria.Criteria criteria,
                RecordMapper<T> mapper)
            throws TorqueException
    {
        return getMultiPkPeerImpl().doSelectSingleRecord(
                criteria,
                mapper);
    }

    /**
     * Selects at most a single row from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection, not null.
     *
     * @return The selected row, or null if no records was selected.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> T doSelectSingleRecord(
                org.apache.torque.criteria.Criteria criteria,
                RecordMapper<T> mapper,
                Connection connection)
            throws TorqueException
    {
        return getMultiPkPeerImpl().doSelectSingleRecord(
                criteria,
                mapper,
                connection);
    }

    /**
     * Selects at most one MultiPk object from the database
     * which has the same content as the passed object.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static MultiPk doSelectSingleRecord(
                MultiPk obj)
            throws TorqueException
    {
        return getMultiPkPeerImpl().doSelectSingleRecord(obj);
    }


    /**
     * Returns a new instance of the Data object class
     */
    public static MultiPk getDbObjectInstance()
    {
        return getMultiPkPeerImpl().getDbObjectInstance();
    }


    /**
     * Method to do inserts.
     *
     * @param columnValues the values to insert.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static ObjectKey doInsert(ColumnValues columnValues) 
            throws TorqueException
    {
        return getMultiPkPeerImpl().doInsert(columnValues);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(Criteria) method.
     *
     * @param columnValues the values to insert.
     * @param con the connection to use, not null.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static ObjectKey doInsert(ColumnValues columnValues, Connection con)
            throws TorqueException
    {
        return getMultiPkPeerImpl().doInsert(columnValues, con);
    }
    /**
     * Method to do inserts
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void doInsert(MultiPk obj)
            throws TorqueException
    {
        getMultiPkPeerImpl().doInsert(obj);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(MultiPk) method.  It will take
     * care of the connection details internally.
     *
     * @param obj the data object to insert into the database.
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void doInsert(MultiPk obj, Connection con)
            throws TorqueException
    {
        getMultiPkPeerImpl().doInsert(obj, con);
    }

    /**
     * Method to do updates.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(ColumnValues columnValues) throws TorqueException
    {
        return getMultiPkPeerImpl().doUpdate(columnValues);
    }

    /**
     * Method to do updates.  This method is to be used during a transaction,
     * otherwise use the doUpdate(Criteria) method.  It will take care of
     * the connection details internally.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @param con the connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        return getMultiPkPeerImpl().doUpdate(columnValues, con);
    }

    /**
     * Executes an update against the database. The rows to be updated
     * are selected using <code>criteria</code> and updated using the values
     * in <code>updateValues</code>.
     *
     * @param criteria selects which rows of which table should be updated.
     * @param updateValues Which columns to update with which values, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException if updating fails.
     */
    public static int doUpdate(
                Criteria selectCriteria,
                ColumnValues updateValues)
            throws TorqueException
    {
        return getMultiPkPeerImpl().doUpdate(
            selectCriteria,
            updateValues);
    }

    /**
     * Executes an update against the database. The rows to be updated
     * are selected using <code>criteria</code> and updated using the values
     * in <code>updateValues</code>.
     *
     * @param criteria selects which rows of which table should be updated.
     * @param updateValues Which columns to update with which values, not null.
     * @param connection the database connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException if updating fails.
     */
    public static int doUpdate(
                Criteria criteria,
                ColumnValues updateValues,
                Connection connection)
            throws TorqueException
    {
        return getMultiPkPeerImpl().doUpdate(
            criteria,
             updateValues,
              connection);
    }

    /**
     * Updates an MultiPk in the database.
     * The primary key is used to identify the object to update.
     *
     * @param obj the data object to update in the database.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(MultiPk obj) throws TorqueException
    {
        return getMultiPkPeerImpl().doUpdate(obj);
    }

    /**
     * Updates a MultiPk in the database.
     * The primary key is used to identify the object to update.
     * This method is to be used during a transaction,
     * otherwise the doUpdate(MultiPk) method can be used.
     *
     * @param obj the data object to update in the database.
     * @param con the connection to use, not null.
     
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(MultiPk obj, Connection con)
        throws TorqueException
    {
        return getMultiPkPeerImpl().doUpdate(obj, con);
    }

    /**
     * Utility method which executes a given SQL statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the SQL statement to execute.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString)
            throws TorqueException
    {
        return getMultiPkPeerImpl().executeStatement(statementString);
    }

    /**
     * Utility method which executes a given sql statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the sql statement to execute.
     * @param dbName Name of database to connect to.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString, String dbName)
            throws TorqueException
    {
        return getMultiPkPeerImpl().executeStatement(statementString, dbName);
    }

    /**
     * Utility method which executes a given sql statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the sql statement to execute.
     * @param con A Connection.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString, Connection con)
            throws TorqueException
    {
        return getMultiPkPeerImpl().executeStatement(statementString, con);
    }

    /**
     * Deletes rows from a database table.
     *
     * @param criteria defines the rows to be deleted, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
     public static int doDelete(Criteria criteria) throws TorqueException
     {
        return getMultiPkPeerImpl().doDelete(criteria);
     }

    /**
     * Deletes rows from a table.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
    *
     * @param criteria defines the rows to be deleted, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
     public static int doDelete(Criteria criteria, Connection con)
        throws TorqueException
     {
        return getMultiPkPeerImpl().doDelete(criteria, con);
     }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     *
     * @param obj the data object to delete in the database, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(MultiPk obj) throws TorqueException
    {
        return getMultiPkPeerImpl().doDelete(obj);
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param obj the data object to delete in the database, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(MultiPk obj, Connection con)
        throws TorqueException
    {
        return getMultiPkPeerImpl().doDelete(obj, con);
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     *
     * @param objects the datas object to delete in the database, not null,
     *        may not contain null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(Collection<MultiPk> objects)
            throws TorqueException
    {
        return getMultiPkPeerImpl().doDelete(objects);
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param objects the datas object to delete in the database, not null,
     *        may not contain null.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(
            Collection<MultiPk> objects,
            Connection con)
        throws TorqueException
    {
        return getMultiPkPeerImpl().doDelete(objects, con);
    }

    /**
     * Deletes a row in the database.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(ObjectKey pk) throws TorqueException
    {
        return getMultiPkPeerImpl().doDelete(pk);
    }

    /**
     * Deletes a row in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(ObjectKey pk, Connection con)
        throws TorqueException
    {
        return getMultiPkPeerImpl().doDelete(pk, con);
    }

    /** 
     * Build a Criteria object which selects all objects which have a given
     * primary key.
     *
     * @param pk the primary key value to build the criteria from, not null.
     */
    public static Criteria buildCriteria(ObjectKey pk)
    {
        return getMultiPkPeerImpl().buildCriteria(pk);
    }

    /** 
     * Build a Criteria object which selects all objects which primary keys
     * are contained in the passed collection.
     *
     * @param pks the primary key values to build the criteria from, not null,
     *        may not contain null.
     */
    public static Criteria buildCriteria(Collection<ObjectKey> pks)
    {
        return getMultiPkPeerImpl().buildCriteria(pks);
    }

    /** 
     * Build a Criteria object which selects all passed objects using their
     * primary key. Objects which do not yet have a primary key are ignored.
     *
     * @param objects the objects to build the criteria from, not null,
     *        may not contain null.
     */
    public static Criteria buildPkCriteria(
            Collection<MultiPk> objects)
    {
        return getMultiPkPeerImpl().buildPkCriteria(objects);
    }

    /** 
     * Build a Criteria object from the data object for this peer.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public static Criteria buildCriteria(MultiPk obj)
    {
        return getMultiPkPeerImpl().buildCriteria(obj);
    }

    /** 
     * Build a Criteria object from the data object for this peer,
     * skipping all binary columns.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public static Criteria buildSelectCriteria(MultiPk obj)
    {
        return getMultiPkPeerImpl().buildSelectCriteria(obj);
    }

    /** 
     * Returns the contents of the object as ColumnValues object
     *
     * @throws TorqueException if the table map cannot be retrieved
     *         (should not happen).
     */
    public static ColumnValues buildColumnValues(MultiPk multiPk)
            throws TorqueException
    {
        
        return getMultiPkPeerImpl().buildColumnValues(multiPk);
    }

    /**
     * retrieve object using using pk values.
     *
     * @param pk1 String
     * @param pk2 int
     * @param pk3 String
     * @param pk4 Integer
     * @param pk5 Byte
     * @param pk6 Short
     * @param pk7 Long
     * @param pk8 Double
     * @param pk9 Double
     * @param pk10 java.util.Date
     */
    public static MultiPk retrieveByPK(
            String pk1,
            int pk2,
            String pk3,
            Integer pk4,
            Byte pk5,
            Short pk6,
            Long pk7,
            Double pk8,
            Double pk9,
            java.util.Date pk10)
        throws TorqueException
    {
        return getMultiPkPeerImpl().retrieveByPK(
                pk1,
                pk2,
                pk3,
                pk4,
                pk5,
                pk6,
                pk7,
                pk8,
                pk9,
                pk10);
    }

    /**
     * retrieve object using using pk values.
     *
     * @param pk1 String
     * @param pk2 int
     * @param pk3 String
     * @param pk4 Integer
     * @param pk5 Byte
     * @param pk6 Short
     * @param pk7 Long
     * @param pk8 Double
     * @param pk9 Double
     * @param pk10 java.util.Date
     * @param con Connection
     */
    public static MultiPk retrieveByPK(
            String pk1,
            int pk2,
            String pk3,
            Integer pk4,
            Byte pk5,
            Short pk6,
            Long pk7,
            Double pk8,
            Double pk9,
            java.util.Date pk10,
            Connection con) throws TorqueException
    {
        return getMultiPkPeerImpl().retrieveByPK(
                pk1,
                pk2,
                pk3,
                pk4,
                pk5,
                pk6,
                pk7,
                pk8,
                pk9,
                pk10,
                con);
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public static MultiPk retrieveByPK(ObjectKey pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return getMultiPkPeerImpl().retrieveByPK(pk);
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public static MultiPk retrieveByPK(ObjectKey pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return getMultiPkPeerImpl().retrieveByPK(pk, con);
    }


    /**
     * Retrieve a multiple objects by pk
     *
     * @param pks List of primary keys
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultiPk> retrieveByPKs(Collection<ObjectKey> pks)
        throws TorqueException
    {
        return getMultiPkPeerImpl().retrieveByPKs(pks);
    }

    /**
     * Retrieve multiple objects by pk
     *
     * @param pks List of primary keys
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultiPk> retrieveByPKs(Collection<ObjectKey> pks, Connection con)
        throws TorqueException
    {
        return getMultiPkPeerImpl().retrieveByPKs(pks,con);
    }






    /** 
     * Returns the chunk size for the filler methods.
     *
     * @return the chunk size for the filler methods.
     */
    protected static int getFillerChunkSize()
    {
        return getMultiPkPeerImpl().getFillerChunkSize();
    }

    /**
     * Returns the TableMap related to this peer.
     *
     * @return the table map, not null.
     *
     * @throws TorqueException if the Peer instance does not hold a Table map.
     */
    public static TableMap getTableMap()
        throws TorqueException
    {
        return getMultiPkPeerImpl().getTableMap();
    }

    public static void initDatabaseMap()
    {
        BaseBookstoreDatabaseMapInit.init();
    }


}
