package org.apache.torque.test;

import java.io.Serializable;
import java.sql.Connection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.apache.torque.TorqueException;
import org.apache.torque.map.TableMap;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.BooleanKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.om.ColumnAccessByName;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.util.Transaction;
import org.apache.commons.lang.ObjectUtils;


/**
 * Table to test multi references to a same table
 *
 * This class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:40 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to MultiRefSameTable
 */
public abstract class BaseMultiRefSameTable 
    implements Persistent, Serializable, ColumnAccessByName
{
    /** Serial version */
    private static final long serialVersionUID = 1347503740965L;



    /** Defines the multiRefSameTablePk field. */
    private String multiRefSameTablePk = null;

    /** Defines the anInformation field. */
    private String anInformation = null;

    /** Defines the reference1 field. */
    private String reference1 = null;

    /** Defines the reference2 field. */
    private String reference2 = null;

    /** Defines the reference3 field. */
    private String reference3 = null;

    /** Whether this object was modified after loading or after last save. */
    private boolean modified = true;

    /** 
     * Whether this object was loaded from the database or already saved 
     * (false) or whether it is not yet in the database(true).
     */
    private boolean isNew = true;

    /** Flag which indicates whether this object is currently saving. */
    private boolean saving = false;

    /** 
     * Flag which indicates whether this object is currently loaded
     * from the database. 
     */
    private boolean loading = false;

    /** 
     * Flag which indicates whether this object was deleted from the database.
     * Note that this flags does not always display the current database state,
     * there is no magical connection between this flag and the database.
     */
    private boolean deleted = false;

    /** Defines the aReferencedRelatedByReference1 field. */
    private Referenced aReferencedRelatedByReference1 = null;

    /** Defines the aReferencedRelatedByReference2 field. */
    private Referenced aReferencedRelatedByReference2 = null;

    /** Defines the aReferencedRelatedByReference3 field. */
    private Referenced aReferencedRelatedByReference3 = null;





    /**
     * Get the value of multiRefSameTablePk.
     *
     * @return String
     */
    public String getMultiRefSameTablePk() 
    {
        
        return multiRefSameTablePk;
    }

    /**
     * Set the value of multiRefSameTablePk.
     *
     * @param v new value
     */
    public void setMultiRefSameTablePk(String v)
    {
        if (!ObjectUtils.equals(this.multiRefSameTablePk, v))
        {
            setModified(true);
        }

        this.multiRefSameTablePk = v;


    }
    
    /**
     * Get the value of anInformation.
     *
     * @return String
     */
    public String getAnInformation() 
    {
        
        return anInformation;
    }

    /**
     * Set the value of anInformation.
     *
     * @param v new value
     */
    public void setAnInformation(String v)
    {
        if (!ObjectUtils.equals(this.anInformation, v))
        {
            setModified(true);
        }

        this.anInformation = v;


    }
    
    /**
     * Get the value of reference1.
     *
     * @return String
     */
    public String getReference1() 
    {
        
        return reference1;
    }

    /**
     * Set the value of reference1.
     *
     * @param v new value
     */
    public void setReference1(String v)
    {
        if (!ObjectUtils.equals(this.reference1, v))
        {
            setModified(true);
        }

        this.reference1 = v;
        if (aReferencedRelatedByReference1 != null && !ObjectUtils.equals(aReferencedRelatedByReference1.getReferencedPK(), v))
        {
            aReferencedRelatedByReference1 = null;
        }


    }
    
    /**
     * Get the value of reference2.
     *
     * @return String
     */
    public String getReference2() 
    {
        
        return reference2;
    }

    /**
     * Set the value of reference2.
     *
     * @param v new value
     */
    public void setReference2(String v)
    {
        if (!ObjectUtils.equals(this.reference2, v))
        {
            setModified(true);
        }

        this.reference2 = v;
        if (aReferencedRelatedByReference2 != null && !ObjectUtils.equals(aReferencedRelatedByReference2.getReferencedPK(), v))
        {
            aReferencedRelatedByReference2 = null;
        }


    }
    
    /**
     * Get the value of reference3.
     *
     * @return String
     */
    public String getReference3() 
    {
        
        return reference3;
    }

    /**
     * Set the value of reference3.
     *
     * @param v new value
     */
    public void setReference3(String v)
    {
        if (!ObjectUtils.equals(this.reference3, v))
        {
            setModified(true);
        }

        this.reference3 = v;
        if (aReferencedRelatedByReference3 != null && !ObjectUtils.equals(aReferencedRelatedByReference3.getReferencedPK(), v))
        {
            aReferencedRelatedByReference3 = null;
        }


    }
    

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return true, if the object has never been persisted.
     */
    public boolean isNew()
    {
        return isNew;
    }

    /**
     * Sets whether the object has ever been saved.
     *
     * @param isNew true if the object has never been saved, false otherwise.
     */
    public void setNew(boolean isNew)
    {
        this.isNew = isNew;
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return True if the object has been modified.
     */
    public boolean isModified()
    {
        return modified;
    }

    /**
     * Sets whether the object has been modified.
     *
     * @param modified true if the object has been modified, false otherwise.
     */
    public void setModified(boolean modified)
    {
        this.modified = modified;
    }

    /**
     * Sets the modified state for the object to be false.
     */
    public void resetModified()
    {
        modified = false;
    }


    /**
     * Returns whether this object is currently saving.
     *
     * @return true if this object is currently saving, false otherwise.
     */
    public boolean isSaving()
    {
        return saving;
    }

    /**
     * Sets whether this object is currently saving.
     *
     * @param saving true if this object is currently saving, false otherwise.
     */
    public void setSaving(boolean saving)
    {
        this.saving = saving;
    }


    /**
     * Returns whether this object is currently being loaded from the database.
     *
     * @return true if this object is currently loading, false otherwise.
     */
    public boolean isLoading()
    {
        return loading;
    }

    /**
     * Sets whether this object is currently being loaded from the database.
     *
     * @param loading true if this object is currently loading, false otherwise.
     */
    public void setLoading(boolean loading)
    {
        this.loading = loading;
    }


    /**
     * Returns whether this object was deleted from the database.
     * Note that this getter does not automatically reflect database state,
     * it will be set to true by Torque if doDelete() was called with this 
     * object. Bulk deletes and deletes via primary key do not change
     * this flag. Also, if doDelete() was called on an object which does
     * not exist in the database, the deleted flag is set to true even if
     * it was not deleted.
     *
     * @return true if this object was deleted, false otherwise.
     */
    public boolean isDeleted()
    {
        return deleted;
    }

    /**
     * Sets whether this object was deleted from the database.
     *
     * @param deleted true if this object was deleted, false otherwise.
     */
    public void setDeleted(boolean deleted)
    {
        this.deleted = deleted;
    }


    /**
     * Returns the associated Referenced object.
     * If it was not retrieved before, the object is retrieved from
     * the database
     *
     * @return the associated Referenced object
     * @throws TorqueException when reading from the database fails.
     */
    public Referenced getReferencedRelatedByReference1()
        throws TorqueException
    {
        if (aReferencedRelatedByReference1 == null && !org.apache.commons.lang.ObjectUtils.equals(this.reference1, null))
        {
            aReferencedRelatedByReference1 = org.apache.torque.test.ReferencedPeer.retrieveByPK(SimpleKey.keyFor(this.reference1));
        }
        return aReferencedRelatedByReference1;
    }

    /**
     * Return the associated Referenced object
     * If it was not retrieved before, the object is retrieved from
     * the database using the passed connection
     *
     * @param connection the connection used to retrieve the associated object
     *        from the database, if it was not retrieved before
     * @return the associated Referenced object
     * @throws TorqueException
     */
    public Referenced getReferencedRelatedByReference1(Connection connection)
        throws TorqueException
    {
        if (aReferencedRelatedByReference1 == null && !org.apache.commons.lang.ObjectUtils.equals(this.reference1, null))
        {
            aReferencedRelatedByReference1 = org.apache.torque.test.ReferencedPeer.retrieveByPK(SimpleKey.keyFor(this.reference1), connection);
        }
        return aReferencedRelatedByReference1;
    }


    /**
     * Declares an association between this object and a Referenced object
     *
     * @param v Referenced
     */
    public void setReferencedRelatedByReference1(Referenced v)
    {
        if (v == null)
        {
            setReference1(null);
        }
        else
        {
            setReference1(v.getReferencedPK());
        }
        aReferencedRelatedByReference1 = v;
    }
    /**
     * Provides convenient way to set a relationship based on a
     * ObjectKey, for example
     * <code>bar.setFooKey(foo.getPrimaryKey())</code>
     *
     */
    public void setReferencedRelatedByReference1Key(ObjectKey key) throws TorqueException
    {
       
        setReference1(key.toString());
     }

    /**
     * Returns the associated Referenced object.
     * If it was not retrieved before, the object is retrieved from
     * the database
     *
     * @return the associated Referenced object
     * @throws TorqueException when reading from the database fails.
     */
    public Referenced getReferencedRelatedByReference2()
        throws TorqueException
    {
        if (aReferencedRelatedByReference2 == null && !org.apache.commons.lang.ObjectUtils.equals(this.reference2, null))
        {
            aReferencedRelatedByReference2 = org.apache.torque.test.ReferencedPeer.retrieveByPK(SimpleKey.keyFor(this.reference2));
        }
        return aReferencedRelatedByReference2;
    }

    /**
     * Return the associated Referenced object
     * If it was not retrieved before, the object is retrieved from
     * the database using the passed connection
     *
     * @param connection the connection used to retrieve the associated object
     *        from the database, if it was not retrieved before
     * @return the associated Referenced object
     * @throws TorqueException
     */
    public Referenced getReferencedRelatedByReference2(Connection connection)
        throws TorqueException
    {
        if (aReferencedRelatedByReference2 == null && !org.apache.commons.lang.ObjectUtils.equals(this.reference2, null))
        {
            aReferencedRelatedByReference2 = org.apache.torque.test.ReferencedPeer.retrieveByPK(SimpleKey.keyFor(this.reference2), connection);
        }
        return aReferencedRelatedByReference2;
    }


    /**
     * Declares an association between this object and a Referenced object
     *
     * @param v Referenced
     */
    public void setReferencedRelatedByReference2(Referenced v)
    {
        if (v == null)
        {
            setReference2(null);
        }
        else
        {
            setReference2(v.getReferencedPK());
        }
        aReferencedRelatedByReference2 = v;
    }
    /**
     * Provides convenient way to set a relationship based on a
     * ObjectKey, for example
     * <code>bar.setFooKey(foo.getPrimaryKey())</code>
     *
     */
    public void setReferencedRelatedByReference2Key(ObjectKey key) throws TorqueException
    {
       
        setReference2(key.toString());
     }

    /**
     * Returns the associated Referenced object.
     * If it was not retrieved before, the object is retrieved from
     * the database
     *
     * @return the associated Referenced object
     * @throws TorqueException when reading from the database fails.
     */
    public Referenced getReferencedRelatedByReference3()
        throws TorqueException
    {
        if (aReferencedRelatedByReference3 == null && !org.apache.commons.lang.ObjectUtils.equals(this.reference3, null))
        {
            aReferencedRelatedByReference3 = org.apache.torque.test.ReferencedPeer.retrieveByPK(SimpleKey.keyFor(this.reference3));
        }
        return aReferencedRelatedByReference3;
    }

    /**
     * Return the associated Referenced object
     * If it was not retrieved before, the object is retrieved from
     * the database using the passed connection
     *
     * @param connection the connection used to retrieve the associated object
     *        from the database, if it was not retrieved before
     * @return the associated Referenced object
     * @throws TorqueException
     */
    public Referenced getReferencedRelatedByReference3(Connection connection)
        throws TorqueException
    {
        if (aReferencedRelatedByReference3 == null && !org.apache.commons.lang.ObjectUtils.equals(this.reference3, null))
        {
            aReferencedRelatedByReference3 = org.apache.torque.test.ReferencedPeer.retrieveByPK(SimpleKey.keyFor(this.reference3), connection);
        }
        return aReferencedRelatedByReference3;
    }


    /**
     * Declares an association between this object and a Referenced object
     *
     * @param v Referenced
     */
    public void setReferencedRelatedByReference3(Referenced v)
    {
        if (v == null)
        {
            setReference3(null);
        }
        else
        {
            setReference3(v.getReferencedPK());
        }
        aReferencedRelatedByReference3 = v;
    }
    /**
     * Provides convenient way to set a relationship based on a
     * ObjectKey, for example
     * <code>bar.setFooKey(foo.getPrimaryKey())</code>
     *
     */
    public void setReferencedRelatedByReference3Key(ObjectKey key) throws TorqueException
    {
       
        setReference3(key.toString());
     }






    private static final List<String> FIELD_NAMES;

    static
    {
        List<String> fieldNames
                = new ArrayList<String>();
        fieldNames.add("MultiRefSameTablePk");
        fieldNames.add("AnInformation");
        fieldNames.add("Reference1");
        fieldNames.add("Reference2");
        fieldNames.add("Reference3");
        FIELD_NAMES = Collections.unmodifiableList(fieldNames);
    }

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static List<String> getFieldNames()
    {
        return FIELD_NAMES;
    }

    /**
     * Retrieves a field from the object by field (Java) name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
        if (name.equals("MultiRefSameTablePk"))
        {
            return getMultiRefSameTablePk();
        }
        if (name.equals("AnInformation"))
        {
            return getAnInformation();
        }
        if (name.equals("Reference1"))
        {
            return getReference1();
        }
        if (name.equals("Reference2"))
        {
            return getReference2();
        }
        if (name.equals("Reference3"))
        {
            return getReference3();
        }
        return null;
    }

    /**
     * Set a field in the object by field (Java) name.
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (name.equals("MultiRefSameTablePk"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setMultiRefSameTablePk((String) value);
            return true;
        }
        if (name.equals("AnInformation"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setAnInformation((String) value);
            return true;
        }
        if (name.equals("Reference1"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setReference1((String) value);
            return true;
        }
        if (name.equals("Reference2"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setReference2((String) value);
            return true;
        }
        if (name.equals("Reference3"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setReference3((String) value);
            return true;
        }
        return false;
    }

    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
        if (name.equals(org.apache.torque.test.MultiRefSameTablePeer.MULTI_REF_SAME_TABLE_PK))
        {
            return getMultiRefSameTablePk();
        }
        if (name.equals(org.apache.torque.test.MultiRefSameTablePeer.AN_INFORMATION))
        {
            return getAnInformation();
        }
        if (name.equals(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_1))
        {
            return getReference1();
        }
        if (name.equals(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_2))
        {
            return getReference2();
        }
        if (name.equals(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_3))
        {
            return getReference3();
        }
        return null;
    }

    /**
     * Set field values by Peer Field Name
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPeerName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (org.apache.torque.test.MultiRefSameTablePeer.MULTI_REF_SAME_TABLE_PK.getSqlExpression().equals(name))
        {
            return setByName("MultiRefSameTablePk", value);
        }
        if (org.apache.torque.test.MultiRefSameTablePeer.AN_INFORMATION.getSqlExpression().equals(name))
        {
            return setByName("AnInformation", value);
        }
        if (org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_1.getSqlExpression().equals(name))
        {
            return setByName("Reference1", value);
        }
        if (org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_2.getSqlExpression().equals(name))
        {
            return setByName("Reference2", value);
        }
        if (org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_3.getSqlExpression().equals(name))
        {
            return setByName("Reference3", value);
        }
        return false;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
        if (pos == 0)
        {
            return getMultiRefSameTablePk();
        }
        if (pos == 1)
        {
            return getAnInformation();
        }
        if (pos == 2)
        {
            return getReference1();
        }
        if (pos == 3)
        {
            return getReference2();
        }
        if (pos == 4)
        {
            return getReference3();
        }
        return null;
    }

    /**
     * Set field values by its position (zero based) in the XML schema.
     *
     * @param position The field position
     * @param value field value
     * @return True if value was set, false if not (invalid position / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPosition(int position, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (position == 0)
        {
            return setByName("MultiRefSameTablePk", value);
        }
        if (position == 1)
        {
            return setByName("AnInformation", value);
        }
        if (position == 2)
        {
            return setByName("Reference1", value);
        }
        if (position == 3)
        {
            return setByName("Reference2", value);
        }
        if (position == 4)
        {
            return setByName("Reference3", value);
        }
        return false;
    }



    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save() throws TorqueException
    {
        save(MultiRefSameTablePeer.DATABASE_NAME);
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     * @param dbName the name of the database to which the object
     *        should be saved.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(String dbName) 
            throws TorqueException
    {
        Connection con = null;
        try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally.
     *
     * @param toSave the object to be saved, not null.
     * @param con the connection to use for saving the object, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(Connection con) 
            throws TorqueException
    {
        if (isSaving())
        {
            return;
        }
        try
        {
            setSaving(true);
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    MultiRefSameTablePeer.doInsert((MultiRefSameTable) this, con);
                    setNew(false);
                }
                else
                {
                    MultiRefSameTablePeer.doUpdate((MultiRefSameTable) this, con);
                }
            }

        }
        finally
        {
            setSaving(false);
        }
    }




    /**
     * Set the PrimaryKey using ObjectKey.
     *
     * @param key multiRefSameTablePk ObjectKey
     */
    public void setPrimaryKey(ObjectKey key)
        
    {
        setMultiRefSameTablePk(key.toString());
    }

    /**
     * Set the PrimaryKey using a String.
     *
     * @param key
     */
    public void setPrimaryKey(String key) 
    {
        setMultiRefSameTablePk(key);
    }


    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        return SimpleKey.keyFor(getMultiRefSameTablePk());
    }


    /**
     * Returns an id that differentiates the referenced Referenced object
     * from all other Referenced objects.
     *
     * @return an ObjectKey.
     */
    public ObjectKey getForeignKeyForReferencedRelatedByReference1()
    {
        return SimpleKey.keyFor(getReference1());
    }
    /**
     * Returns an id that differentiates the referenced Referenced object
     * from all other Referenced objects.
     *
     * @return an ObjectKey.
     */
    public ObjectKey getForeignKeyForReferencedRelatedByReference2()
    {
        return SimpleKey.keyFor(getReference2());
    }
    /**
     * Returns an id that differentiates the referenced Referenced object
     * from all other Referenced objects.
     *
     * @return an ObjectKey.
     */
    public ObjectKey getForeignKeyForReferencedRelatedByReference3()
    {
        return SimpleKey.keyFor(getReference3());
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public MultiRefSameTable copy() throws TorqueException
    {
        return copy(true);
    }

    /**
     * Makes a copy of this object using a connection.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     *
     * @param con the database connection to read associated objects.
     */
    public MultiRefSameTable copy(Connection con) throws TorqueException
    {
        return copy(true, con);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     */
    public MultiRefSameTable copy(boolean deepcopy) throws TorqueException
    {
        MultiRefSameTable multiRefSameTable = new MultiRefSameTable();

        return copyInto(multiRefSameTable, deepcopy);
    }

    /**
     * Makes a copy of this object using connection.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @param con the database connection to read associated objects.
     */
    public MultiRefSameTable copy(boolean deepcopy, Connection con) throws TorqueException
    {
        MultiRefSameTable multiRefSameTable = new MultiRefSameTable();

        return copyInto(multiRefSameTable, deepcopy, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     */
    protected MultiRefSameTable copyInto(MultiRefSameTable copyObj) throws TorqueException
    {
        return copyInto(copyObj, true);
    }

    /**
     * Fills the copyObj with the contents of this object using connection.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param con the database connection to read associated objects.
     */
    protected MultiRefSameTable copyInto(MultiRefSameTable copyObj, Connection con) throws TorqueException
    {
        return copyInto(copyObj, true, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     */
    protected MultiRefSameTable copyInto(MultiRefSameTable copyObj, boolean deepcopy) throws TorqueException
    {
        copyObj.setMultiRefSameTablePk((String) null);
        copyObj.setAnInformation(anInformation);
        copyObj.setReference1(reference1);
        copyObj.setReference2(reference2);
        copyObj.setReference3(reference3);

        if (deepcopy)
        {
        }
        return copyObj;
    }
        
    
    /**
     * Fills the copyObj with the contents of this object using connection.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @param con the database connection to read associated objects.
     */
    protected MultiRefSameTable copyInto(MultiRefSameTable copyObj, boolean deepcopy, Connection con) throws TorqueException
    {
        copyObj.setMultiRefSameTablePk((String) null);
        copyObj.setAnInformation(anInformation);
        copyObj.setReference1(reference1);
        copyObj.setReference2(reference2);
        copyObj.setReference3(reference3);

        if (deepcopy)
        {
        }
        return copyObj;
    }

    /** The Peer class */
    private static final org.apache.torque.test.MultiRefSameTablePeer peer
            = new org.apache.torque.test.MultiRefSameTablePeer();

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public org.apache.torque.test.MultiRefSameTablePeer getPeer()
    {
        return peer;
    }

    /**
     * Retrieves the TableMap object related to this Table data without
     * compiler warnings of using getPeer().getTableMap().
     *
     * @return The associated TableMap object.
     */
    public TableMap getTableMap() throws TorqueException
    {
        return org.apache.torque.test.MultiRefSameTablePeer.getTableMap();
    }



    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("MultiRefSameTable:\n");
        str.append("multiRefSameTablePk = ")
           .append(getMultiRefSameTablePk())
           .append("\n");
        str.append("anInformation = ")
           .append(getAnInformation())
           .append("\n");
        str.append("reference1 = ")
           .append(getReference1())
           .append("\n");
        str.append("reference2 = ")
           .append(getReference2())
           .append("\n");
        str.append("reference3 = ")
           .append(getReference3())
           .append("\n");
        return(str.toString());
    }

    /**
     * Compares the primary key of this instance with the key of another.
     *
     * @param toCompare The object to compare to.
     * @return Whether the primary keys are equal and the object have the
     *         same class.
     */
    public boolean equals(Object toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!getClass().equals(toCompare.getClass()))
        {
            return false;
        }
        MultiRefSameTable other = (MultiRefSameTable) toCompare;
        if (getPrimaryKey() == null || other.getPrimaryKey() == null)
        {
            return false;
        }
        return getPrimaryKey().equals(other.getPrimaryKey());
    }

    /**
     * If the primary key is not <code>null</code>, return the hashcode of the
     * primary key.  Otherwise calls <code>Object.hashCode()</code>.
     *
     * @return an <code>int</code> value
     */
    public int hashCode()
    {
        ObjectKey ok = getPrimaryKey();
        if (ok == null)
        {
            return super.hashCode();
        }

        return ok.hashCode();
    }




}
