package org.apache.torque.test;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.torque.NoRowsException;
import org.apache.torque.TooManyRowsException;
import org.apache.torque.Column;
import org.apache.torque.Torque;
import org.apache.torque.TorqueException;
import org.apache.torque.TorqueRuntimeException;
import org.apache.torque.adapter.IDMethod;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.map.DatabaseMap;
import org.apache.torque.map.TableMap;
import org.apache.torque.map.ColumnMap;
import org.apache.torque.map.ForeignKeyMap;
import org.apache.torque.map.InheritanceMap;
import org.apache.torque.om.mapper.RecordMapper;
import org.apache.torque.om.mapper.CompositeMapper;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.util.BasePeer;
import org.apache.torque.util.Transaction;
import org.apache.torque.util.ColumnValues;
import org.apache.torque.util.JdbcTypedValue;



/**
 * Table to test multi references to a same table
 *
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:44 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to MultiRefSameTablePeer
 */
@SuppressWarnings({"unused", "unchecked"})
public abstract class BaseMultiRefSameTablePeer
{
    /** The class log. */
    private static Log log = LogFactory.getLog(BaseMultiRefSameTablePeerImpl.class);
    /** Serial version */
    private static final long serialVersionUID = 1347503744675L;


    /** The default database name for this class. */
    public static final String DATABASE_NAME;

     /** The table name for this class. */
    public static final String TABLE_NAME;

     /** The table map for this class. */
    public static final TableMap TABLE;
    /** The column for the multi_ref_same_table_pk field */
    public static final ColumnMap MULTI_REF_SAME_TABLE_PK;
    /** The column for the an_information field */
    public static final ColumnMap AN_INFORMATION;
    /** The column for the reference_1 field */
    public static final ColumnMap REFERENCE_1;
    /** The column for the reference_2 field */
    public static final ColumnMap REFERENCE_2;
    /** The column for the reference_3 field */
    public static final ColumnMap REFERENCE_3;

    /** number of columns for this peer */
    public static final int numColumns = 5;


    /** The implementation of the peer. */
    private static MultiRefSameTablePeerImpl multiRefSameTablePeerImpl;


    static
    {
        DatabaseMap dbMap = Torque.getOrCreateDatabase("bookstore")
                .getDatabaseMap();
        if (dbMap.getTable("multi_ref_same_table") == null)
        {
            dbMap.addTable("multi_ref_same_table");
        }
        DATABASE_NAME = "bookstore";
        TABLE_NAME = "multi_ref_same_table";

        TABLE = dbMap.getTable("multi_ref_same_table");
        TABLE.setJavaName("MultiRefSameTable");
        TABLE.setOMClass(org.apache.torque.test.MultiRefSameTable.class);
        TABLE.setPeerClass(org.apache.torque.test.MultiRefSameTablePeer.class);
        TABLE.setDescription("Table to test multi references to a same table");
        TABLE.setPrimaryKeyMethod(IDMethod.NO_ID_METHOD);
        TABLE.setPrimaryKeyMethodInfo(IDMethod.ID_BROKER, TABLE.getName());
        TABLE.setPrimaryKeyMethodInfo(IDMethod.SEQUENCE, "$sequenceName");
        TABLE.setPrimaryKeyMethodInfo(IDMethod.AUTO_INCREMENT, "multi_ref_same_table");
        TABLE.setUseInheritance(true);


    // ------------- Column: multi_ref_same_table_pk --------------------
        MULTI_REF_SAME_TABLE_PK = new ColumnMap("multi_ref_same_table_pk", TABLE);
        MULTI_REF_SAME_TABLE_PK.setType("");
        MULTI_REF_SAME_TABLE_PK.setTorqueType("VARCHAR");
        MULTI_REF_SAME_TABLE_PK.setUsePrimitive(false);
        MULTI_REF_SAME_TABLE_PK.setPrimaryKey(true);
        MULTI_REF_SAME_TABLE_PK.setNotNull(true);
        MULTI_REF_SAME_TABLE_PK.setJavaName("MultiRefSameTablePk");
        MULTI_REF_SAME_TABLE_PK.setAutoIncrement(false);
        MULTI_REF_SAME_TABLE_PK.setProtected(false);
        MULTI_REF_SAME_TABLE_PK.setJavaType( "String" );
        MULTI_REF_SAME_TABLE_PK.setSize(12);
        MULTI_REF_SAME_TABLE_PK.setPosition(1);
        TABLE.addColumn(MULTI_REF_SAME_TABLE_PK);
    // ------------- Column: an_information --------------------
        AN_INFORMATION = new ColumnMap("an_information", TABLE);
        AN_INFORMATION.setType("");
        AN_INFORMATION.setTorqueType("VARCHAR");
        AN_INFORMATION.setUsePrimitive(false);
        AN_INFORMATION.setPrimaryKey(false);
        AN_INFORMATION.setNotNull(true);
        AN_INFORMATION.setJavaName("AnInformation");
        AN_INFORMATION.setAutoIncrement(false);
        AN_INFORMATION.setProtected(false);
        AN_INFORMATION.setJavaType( "String" );
        AN_INFORMATION.setSize(128);
        AN_INFORMATION.setPosition(2);
        TABLE.addColumn(AN_INFORMATION);
    // ------------- Column: reference_1 --------------------
        REFERENCE_1 = new ColumnMap("reference_1", TABLE);
        REFERENCE_1.setType("");
        REFERENCE_1.setTorqueType("VARCHAR");
        REFERENCE_1.setUsePrimitive(false);
        REFERENCE_1.setPrimaryKey(false);
        REFERENCE_1.setNotNull(false);
        REFERENCE_1.setJavaName("Reference1");
        REFERENCE_1.setAutoIncrement(false);
        REFERENCE_1.setProtected(false);
        REFERENCE_1.setJavaType( "String" );
        REFERENCE_1.setSize(12);
        REFERENCE_1.setPosition(3);
        TABLE.addColumn(REFERENCE_1);
    // ------------- Column: reference_2 --------------------
        REFERENCE_2 = new ColumnMap("reference_2", TABLE);
        REFERENCE_2.setType("");
        REFERENCE_2.setTorqueType("VARCHAR");
        REFERENCE_2.setUsePrimitive(false);
        REFERENCE_2.setPrimaryKey(false);
        REFERENCE_2.setNotNull(false);
        REFERENCE_2.setJavaName("Reference2");
        REFERENCE_2.setAutoIncrement(false);
        REFERENCE_2.setProtected(false);
        REFERENCE_2.setJavaType( "String" );
        REFERENCE_2.setSize(12);
        REFERENCE_2.setPosition(4);
        TABLE.addColumn(REFERENCE_2);
    // ------------- Column: reference_3 --------------------
        REFERENCE_3 = new ColumnMap("reference_3", TABLE);
        REFERENCE_3.setType("");
        REFERENCE_3.setTorqueType("VARCHAR");
        REFERENCE_3.setUsePrimitive(false);
        REFERENCE_3.setPrimaryKey(false);
        REFERENCE_3.setNotNull(false);
        REFERENCE_3.setJavaName("Reference3");
        REFERENCE_3.setAutoIncrement(false);
        REFERENCE_3.setProtected(false);
        REFERENCE_3.setJavaType( "String" );
        REFERENCE_3.setSize(12);
        REFERENCE_3.setPosition(5);
        TABLE.addColumn(REFERENCE_3);


    // ------------- Foreign keys --------------------
        ForeignKeyMap foreignKeyMap;
        TableMap foreignTable;
        String foreignTableName; 
        foreignTableName = "referenced"; 
        foreignTable = dbMap.getTable(foreignTableName);
        if (foreignTable == null)
        {
            foreignKeyMap = new ForeignKeyMap(TABLE, foreignTableName);
            foreignKeyMap.addColumns(new ForeignKeyMap.ColumnPair(
                foreignKeyMap,
                TABLE.getColumn("reference_1"),
                "referenced_pk"));
        }
        else
        {
            foreignKeyMap = new ForeignKeyMap(TABLE, foreignTable);
            foreignKeyMap.addColumns(new ForeignKeyMap.ColumnPair(
                foreignKeyMap,
                TABLE.getColumn("reference_1"),
                foreignTable.getColumn("referenced_pk")));
        }
        TABLE.addForeignKey(foreignKeyMap);
        foreignTableName = "referenced"; 
        foreignTable = dbMap.getTable(foreignTableName);
        if (foreignTable == null)
        {
            foreignKeyMap = new ForeignKeyMap(TABLE, foreignTableName);
            foreignKeyMap.addColumns(new ForeignKeyMap.ColumnPair(
                foreignKeyMap,
                TABLE.getColumn("reference_2"),
                "referenced_pk"));
        }
        else
        {
            foreignKeyMap = new ForeignKeyMap(TABLE, foreignTable);
            foreignKeyMap.addColumns(new ForeignKeyMap.ColumnPair(
                foreignKeyMap,
                TABLE.getColumn("reference_2"),
                foreignTable.getColumn("referenced_pk")));
        }
        TABLE.addForeignKey(foreignKeyMap);
        foreignTableName = "referenced"; 
        foreignTable = dbMap.getTable(foreignTableName);
        if (foreignTable == null)
        {
            foreignKeyMap = new ForeignKeyMap(TABLE, foreignTableName);
            foreignKeyMap.addColumns(new ForeignKeyMap.ColumnPair(
                foreignKeyMap,
                TABLE.getColumn("reference_3"),
                "referenced_pk"));
        }
        else
        {
            foreignKeyMap = new ForeignKeyMap(TABLE, foreignTable);
            foreignKeyMap.addColumns(new ForeignKeyMap.ColumnPair(
                foreignKeyMap,
                TABLE.getColumn("reference_3"),
                foreignTable.getColumn("referenced_pk")));
        }
        TABLE.addForeignKey(foreignKeyMap);


        initDatabaseMap();
    }

    /**
     * Creates a new instance of the  implementation of the peer.
     *
     * @return the new instance.
     */
    protected static MultiRefSameTablePeerImpl createMultiRefSameTablePeerImpl()
    {
        MultiRefSameTablePeerImpl instance = new MultiRefSameTablePeerImpl();
        return instance;
    }


    /**
     * Returns an instance of the implementation of the peer.
     * If no instance is currently cached, a new instance is created and cached.
     *
     * @return an instance of the implementation of the peer, not null.
     */
    public static MultiRefSameTablePeerImpl getMultiRefSameTablePeerImpl()
    {
        MultiRefSameTablePeerImpl peerImplInstance = multiRefSameTablePeerImpl;
        if (peerImplInstance == null)
        {
            peerImplInstance = MultiRefSameTablePeer.createMultiRefSameTablePeerImpl();
            multiRefSameTablePeerImpl = peerImplInstance;
        }
        return peerImplInstance;
    }



    /**
     * Sets the instance of the implementation of the peer.
     *
     * @param an instance of the implementation of the peer, or null
     *        if a new instance should be created automatically.
     */
    public static void setMultiRefSameTablePeerImpl(MultiRefSameTablePeerImpl peerImplInstance)
    {
        multiRefSameTablePeerImpl = peerImplInstance;
    }


    /**
     * Get the list of objects for a ResultSet.  Please not that your
     * resultset MUST return columns in the right order.  You can use
     * getFieldNames() in BaseObject to get the correct sequence.
     *
     * @param resultSet the ResultSet
     * @return the list of objects
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultiRefSameTable> resultSet2Objects(ResultSet resultSet)
            throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().resultSet2Objects(resultSet);
    }

    /**
     * Add all the columns needed to create a new object.
     *
     * @param criteria object containing the columns to add.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void addSelectColumns(Criteria criteria)
            throws TorqueException
    {
        getMultiRefSameTablePeerImpl().addSelectColumns(criteria);
    }

    /**
     * changes the boolean values in the criteria to the appropriate type,
     * whenever a booleanchar or booleanint column is involved.
     * This enables the user to create criteria using Boolean values
     * for booleanchar or booleanint columns.
     *
     * @param criteria the criteria in which the boolean values
     *        should be corrected.
     *
     * @throws TorqueException if the database map for the criteria cannot be 
               obtained.
     */
    public static void correctBooleans(Criteria criteria) throws TorqueException
    {
        getMultiRefSameTablePeerImpl().correctBooleans(criteria);
    }

    /**
     * Checks all columns in the criteria to see whether
     * booleanchar and booleanint columns are queried with a boolean.
     * If yes, the query values are mapped onto values the database
     * does understand, i.e. 0 and 1 for booleanints and N and Y for
     * booleanchar columns.
     *
     * @param columnValues The value to be checked for booleanint
     *        and booleanchar columns.
     * @throws TorqueException if the database map for the criteria cannot be
     *         retrieved.
     */
    public static void correctBooleans(
            ColumnValues columnValues)
        throws TorqueException
    {
        getMultiRefSameTablePeerImpl().correctBooleans(columnValues);
    }
    
    /**
     * Selects MultiRefSameTable objects from a database.
     *
     * @param criteria object used to create the SELECT statement.
     *
     * @return the list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultiRefSameTable> doSelect(Criteria criteria)
            throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelect(criteria);
    }

    /**
     * Selects MultiRefSameTable objects from a database
     * within a transaction.
     *
     * @param criteria object used to create the SELECT statement.
     * @param connection the connection holding the transaction, not null.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultiRefSameTable> doSelect(
                Criteria criteria,
                Connection connection)
            throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelect(criteria, connection);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                Criteria criteria,
                RecordMapper<T> mapper)
            throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelect(criteria, mapper);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection for selecting records,
     *        not null.
     *
     * @return The results of the query, not null.
     * @throws TorqueException Error performing database query.
     */
    public static <T> List<T> doSelect(
            Criteria criteria,
            RecordMapper<T> mapper,
            Connection connection)
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelect(
                criteria,
                mapper,
                connection);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param query the sql query to execute, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param dbName The name of the database to create the connection for,
     *        or null for the default SDB.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                String query,
                RecordMapper<T> mapper,
                String dbName)
            throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelect(
                query,
                mapper,
                dbName);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param query the SQL Query to execute, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection, not null.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                String query,
                RecordMapper<T> mapper,
                Connection connection)
            throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelect(
                query,
                mapper,
                connection);
    }

    /**
     * Selects MultiRefSameTable objects from the database which have
     * the same content as the passed object.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultiRefSameTable> doSelect(MultiRefSameTable obj)
            throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelect(obj);
    }

    /**
     * Selects at most one MultiRefSameTable object from a database.
     *
     * @param criteria object used to create the SELECT statement.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static MultiRefSameTable doSelectSingleRecord(
                Criteria criteria)
            throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelectSingleRecord(criteria);
    }

    /**
     * Selects at most one MultiRefSameTable object from a database
     * within a transaction.
     *
     * @param criteria object used to create the SELECT statement.
     * @param connection the connection holding the transaction, not null.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static MultiRefSameTable doSelectSingleRecord(
                Criteria criteria,
                Connection connection)
            throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelectSingleRecord(criteria, connection);
    }

    /**
     * Selects at most a single row from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     *
     * @return The selected row, or null if no records was selected.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> T doSelectSingleRecord(
                org.apache.torque.criteria.Criteria criteria,
                RecordMapper<T> mapper)
            throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelectSingleRecord(
                criteria,
                mapper);
    }

    /**
     * Selects at most a single row from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection, not null.
     *
     * @return The selected row, or null if no records was selected.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> T doSelectSingleRecord(
                org.apache.torque.criteria.Criteria criteria,
                RecordMapper<T> mapper,
                Connection connection)
            throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelectSingleRecord(
                criteria,
                mapper,
                connection);
    }

    /**
     * Selects at most one MultiRefSameTable object from the database
     * which has the same content as the passed object.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static MultiRefSameTable doSelectSingleRecord(
                MultiRefSameTable obj)
            throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelectSingleRecord(obj);
    }


    /**
     * Returns a new instance of the Data object class
     */
    public static MultiRefSameTable getDbObjectInstance()
    {
        return getMultiRefSameTablePeerImpl().getDbObjectInstance();
    }


    /**
     * Method to do inserts.
     *
     * @param columnValues the values to insert.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static ObjectKey doInsert(ColumnValues columnValues) 
            throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doInsert(columnValues);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(Criteria) method.
     *
     * @param columnValues the values to insert.
     * @param con the connection to use, not null.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static ObjectKey doInsert(ColumnValues columnValues, Connection con)
            throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doInsert(columnValues, con);
    }
    /**
     * Method to do inserts
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void doInsert(MultiRefSameTable obj)
            throws TorqueException
    {
        getMultiRefSameTablePeerImpl().doInsert(obj);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(MultiRefSameTable) method.  It will take
     * care of the connection details internally.
     *
     * @param obj the data object to insert into the database.
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void doInsert(MultiRefSameTable obj, Connection con)
            throws TorqueException
    {
        getMultiRefSameTablePeerImpl().doInsert(obj, con);
    }

    /**
     * Method to do updates.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(ColumnValues columnValues) throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doUpdate(columnValues);
    }

    /**
     * Method to do updates.  This method is to be used during a transaction,
     * otherwise use the doUpdate(Criteria) method.  It will take care of
     * the connection details internally.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @param con the connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doUpdate(columnValues, con);
    }

    /**
     * Executes an update against the database. The rows to be updated
     * are selected using <code>criteria</code> and updated using the values
     * in <code>updateValues</code>.
     *
     * @param criteria selects which rows of which table should be updated.
     * @param updateValues Which columns to update with which values, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException if updating fails.
     */
    public static int doUpdate(
                Criteria selectCriteria,
                ColumnValues updateValues)
            throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doUpdate(
            selectCriteria,
            updateValues);
    }

    /**
     * Executes an update against the database. The rows to be updated
     * are selected using <code>criteria</code> and updated using the values
     * in <code>updateValues</code>.
     *
     * @param criteria selects which rows of which table should be updated.
     * @param updateValues Which columns to update with which values, not null.
     * @param connection the database connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException if updating fails.
     */
    public static int doUpdate(
                Criteria criteria,
                ColumnValues updateValues,
                Connection connection)
            throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doUpdate(
            criteria,
             updateValues,
              connection);
    }

    /**
     * Updates an MultiRefSameTable in the database.
     * The primary key is used to identify the object to update.
     *
     * @param obj the data object to update in the database.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(MultiRefSameTable obj) throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doUpdate(obj);
    }

    /**
     * Updates a MultiRefSameTable in the database.
     * The primary key is used to identify the object to update.
     * This method is to be used during a transaction,
     * otherwise the doUpdate(MultiRefSameTable) method can be used.
     *
     * @param obj the data object to update in the database.
     * @param con the connection to use, not null.
     
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(MultiRefSameTable obj, Connection con)
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doUpdate(obj, con);
    }

    /**
     * Utility method which executes a given SQL statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the SQL statement to execute.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString)
            throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().executeStatement(statementString);
    }

    /**
     * Utility method which executes a given sql statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the sql statement to execute.
     * @param dbName Name of database to connect to.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString, String dbName)
            throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().executeStatement(statementString, dbName);
    }

    /**
     * Utility method which executes a given sql statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the sql statement to execute.
     * @param con A Connection.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString, Connection con)
            throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().executeStatement(statementString, con);
    }

    /**
     * Deletes rows from a database table.
     *
     * @param criteria defines the rows to be deleted, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
     public static int doDelete(Criteria criteria) throws TorqueException
     {
        return getMultiRefSameTablePeerImpl().doDelete(criteria);
     }

    /**
     * Deletes rows from a table.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
    *
     * @param criteria defines the rows to be deleted, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
     public static int doDelete(Criteria criteria, Connection con)
        throws TorqueException
     {
        return getMultiRefSameTablePeerImpl().doDelete(criteria, con);
     }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     *
     * @param obj the data object to delete in the database, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(MultiRefSameTable obj) throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doDelete(obj);
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param obj the data object to delete in the database, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(MultiRefSameTable obj, Connection con)
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doDelete(obj, con);
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     *
     * @param objects the datas object to delete in the database, not null,
     *        may not contain null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(Collection<MultiRefSameTable> objects)
            throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doDelete(objects);
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param objects the datas object to delete in the database, not null,
     *        may not contain null.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(
            Collection<MultiRefSameTable> objects,
            Connection con)
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doDelete(objects, con);
    }

    /**
     * Deletes a row in the database.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(ObjectKey pk) throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doDelete(pk);
    }

    /**
     * Deletes a row in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(ObjectKey pk, Connection con)
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doDelete(pk, con);
    }

    /** 
     * Build a Criteria object which selects all objects which have a given
     * primary key.
     *
     * @param pk the primary key value to build the criteria from, not null.
     */
    public static Criteria buildCriteria(ObjectKey pk)
    {
        return getMultiRefSameTablePeerImpl().buildCriteria(pk);
    }

    /** 
     * Build a Criteria object which selects all objects which primary keys
     * are contained in the passed collection.
     *
     * @param pks the primary key values to build the criteria from, not null,
     *        may not contain null.
     */
    public static Criteria buildCriteria(Collection<ObjectKey> pks)
    {
        return getMultiRefSameTablePeerImpl().buildCriteria(pks);
    }

    /** 
     * Build a Criteria object which selects all passed objects using their
     * primary key. Objects which do not yet have a primary key are ignored.
     *
     * @param objects the objects to build the criteria from, not null,
     *        may not contain null.
     */
    public static Criteria buildPkCriteria(
            Collection<MultiRefSameTable> objects)
    {
        return getMultiRefSameTablePeerImpl().buildPkCriteria(objects);
    }

    /** 
     * Build a Criteria object from the data object for this peer.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public static Criteria buildCriteria(MultiRefSameTable obj)
    {
        return getMultiRefSameTablePeerImpl().buildCriteria(obj);
    }

    /** 
     * Build a Criteria object from the data object for this peer,
     * skipping all binary columns.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public static Criteria buildSelectCriteria(MultiRefSameTable obj)
    {
        return getMultiRefSameTablePeerImpl().buildSelectCriteria(obj);
    }

    /** 
     * Returns the contents of the object as ColumnValues object
     *
     * @throws TorqueException if the table map cannot be retrieved
     *         (should not happen).
     */
    public static ColumnValues buildColumnValues(MultiRefSameTable multiRefSameTable)
            throws TorqueException
    {
        
        return getMultiRefSameTablePeerImpl().buildColumnValues(multiRefSameTable);
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public static MultiRefSameTable retrieveByPK(String pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return getMultiRefSameTablePeerImpl().retrieveByPK(pk);
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public static MultiRefSameTable retrieveByPK(String pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return getMultiRefSameTablePeerImpl().retrieveByPK(pk, con);
    }
    
    
    

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public static MultiRefSameTable retrieveByPK(ObjectKey pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return getMultiRefSameTablePeerImpl().retrieveByPK(pk);
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public static MultiRefSameTable retrieveByPK(ObjectKey pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return getMultiRefSameTablePeerImpl().retrieveByPK(pk, con);
    }


    /**
     * Retrieve a multiple objects by pk
     *
     * @param pks List of primary keys
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultiRefSameTable> retrieveByPKs(Collection<ObjectKey> pks)
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().retrieveByPKs(pks);
    }

    /**
     * Retrieve multiple objects by pk
     *
     * @param pks List of primary keys
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultiRefSameTable> retrieveByPKs(Collection<ObjectKey> pks, Connection con)
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().retrieveByPKs(pks,con);
    }


    /**
     * Selects a collection of dbObjectClassName objects pre-filled with their
     * Referenced objects.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultiRefSameTable> doSelectJoinReferencedRelatedByReference1(Criteria criteria)
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelectJoinReferencedRelatedByReference1(criteria);
    }

    /**
     * Selects a collection of MultiRefSameTable objects pre-filled with their
     * Referenced objects.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultiRefSameTable> doSelectJoinReferencedRelatedByReference1(
            Criteria criteria, Connection conn)
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelectJoinReferencedRelatedByReference1(criteria, conn);
    }
    /**
     * Selects a collection of dbObjectClassName objects pre-filled with their
     * Referenced objects.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultiRefSameTable> doSelectJoinReferencedRelatedByReference2(Criteria criteria)
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelectJoinReferencedRelatedByReference2(criteria);
    }

    /**
     * Selects a collection of MultiRefSameTable objects pre-filled with their
     * Referenced objects.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultiRefSameTable> doSelectJoinReferencedRelatedByReference2(
            Criteria criteria, Connection conn)
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelectJoinReferencedRelatedByReference2(criteria, conn);
    }
    /**
     * Selects a collection of dbObjectClassName objects pre-filled with their
     * Referenced objects.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultiRefSameTable> doSelectJoinReferencedRelatedByReference3(Criteria criteria)
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelectJoinReferencedRelatedByReference3(criteria);
    }

    /**
     * Selects a collection of MultiRefSameTable objects pre-filled with their
     * Referenced objects.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultiRefSameTable> doSelectJoinReferencedRelatedByReference3(
            Criteria criteria, Connection conn)
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelectJoinReferencedRelatedByReference3(criteria, conn);
    }

    /**
     * selects a collection of MultiRefSameTable objects pre-filled with
     * all related objects.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in MultiRefSameTablePeer.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    protected static List<MultiRefSameTable> doSelectJoinAllExceptReferencedRelatedByReference1(Criteria criteria)
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelectJoinAllExceptReferencedRelatedByReference1(criteria);
    }

    /**
     * selects a collection of MultiRefSameTable objects pre-filled with
     * related objects.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in MultiRefSameTablePeer.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    protected static List<MultiRefSameTable> doSelectJoinAllExceptReferencedRelatedByReference1(Criteria criteria, Connection conn)
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelectJoinAllExceptReferencedRelatedByReference1(criteria, conn);
    }
    /**
     * selects a collection of MultiRefSameTable objects pre-filled with
     * all related objects.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in MultiRefSameTablePeer.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    protected static List<MultiRefSameTable> doSelectJoinAllExceptReferencedRelatedByReference2(Criteria criteria)
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelectJoinAllExceptReferencedRelatedByReference2(criteria);
    }

    /**
     * selects a collection of MultiRefSameTable objects pre-filled with
     * related objects.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in MultiRefSameTablePeer.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    protected static List<MultiRefSameTable> doSelectJoinAllExceptReferencedRelatedByReference2(Criteria criteria, Connection conn)
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelectJoinAllExceptReferencedRelatedByReference2(criteria, conn);
    }
    /**
     * selects a collection of MultiRefSameTable objects pre-filled with
     * all related objects.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in MultiRefSameTablePeer.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    protected static List<MultiRefSameTable> doSelectJoinAllExceptReferencedRelatedByReference3(Criteria criteria)
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelectJoinAllExceptReferencedRelatedByReference3(criteria);
    }

    /**
     * selects a collection of MultiRefSameTable objects pre-filled with
     * related objects.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in MultiRefSameTablePeer.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    protected static List<MultiRefSameTable> doSelectJoinAllExceptReferencedRelatedByReference3(Criteria criteria, Connection conn)
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().doSelectJoinAllExceptReferencedRelatedByReference3(criteria, conn);
    }

    /** 
     * Fills the referenced Referenced objects in the aReferencedRelatedByReference1 fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null, may not contain null.
     *
     * @return all read Referenced objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public static List<Referenced> fillReferencedRelatedByReference1s(
            Collection<MultiRefSameTable> toFill) 
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().fillReferencedRelatedByReference1s(toFill);
    }

    /** 
     * Fills the referenced Referenced objects in the aReferencedRelatedByReference1 fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null, may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read Referenced objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public static List<Referenced> fillReferencedRelatedByReference1s(
            Collection<MultiRefSameTable> toFill,
            Connection connection) 
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().fillReferencedRelatedByReference1s(toFill, connection);
    }
    /** 
     * Fills the referenced Referenced objects in the aReferencedRelatedByReference2 fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null, may not contain null.
     *
     * @return all read Referenced objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public static List<Referenced> fillReferencedRelatedByReference2s(
            Collection<MultiRefSameTable> toFill) 
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().fillReferencedRelatedByReference2s(toFill);
    }

    /** 
     * Fills the referenced Referenced objects in the aReferencedRelatedByReference2 fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null, may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read Referenced objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public static List<Referenced> fillReferencedRelatedByReference2s(
            Collection<MultiRefSameTable> toFill,
            Connection connection) 
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().fillReferencedRelatedByReference2s(toFill, connection);
    }
    /** 
     * Fills the referenced Referenced objects in the aReferencedRelatedByReference3 fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null, may not contain null.
     *
     * @return all read Referenced objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public static List<Referenced> fillReferencedRelatedByReference3s(
            Collection<MultiRefSameTable> toFill) 
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().fillReferencedRelatedByReference3s(toFill);
    }

    /** 
     * Fills the referenced Referenced objects in the aReferencedRelatedByReference3 fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null, may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read Referenced objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public static List<Referenced> fillReferencedRelatedByReference3s(
            Collection<MultiRefSameTable> toFill,
            Connection connection) 
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().fillReferencedRelatedByReference3s(toFill, connection);
    }


    /** 
     * Returns the chunk size for the filler methods.
     *
     * @return the chunk size for the filler methods.
     */
    protected static int getFillerChunkSize()
    {
        return getMultiRefSameTablePeerImpl().getFillerChunkSize();
    }

    /**
     * Returns the TableMap related to this peer.
     *
     * @return the table map, not null.
     *
     * @throws TorqueException if the Peer instance does not hold a Table map.
     */
    public static TableMap getTableMap()
        throws TorqueException
    {
        return getMultiRefSameTablePeerImpl().getTableMap();
    }

    public static void initDatabaseMap()
    {
        BaseBookstoreDatabaseMapInit.init();
    }


}
