package org.apache.torque.test;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.torque.NoRowsException;
import org.apache.torque.TooManyRowsException;
import org.apache.torque.Column;
import org.apache.torque.Torque;
import org.apache.torque.TorqueException;
import org.apache.torque.TorqueRuntimeException;
import org.apache.torque.adapter.IDMethod;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.map.DatabaseMap;
import org.apache.torque.map.TableMap;
import org.apache.torque.map.ColumnMap;
import org.apache.torque.map.ForeignKeyMap;
import org.apache.torque.map.InheritanceMap;
import org.apache.torque.om.mapper.RecordMapper;
import org.apache.torque.om.mapper.CompositeMapper;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.util.BasePeer;
import org.apache.torque.util.Transaction;
import org.apache.torque.util.ColumnValues;
import org.apache.torque.util.JdbcTypedValue;



/**
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:42 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to MultipkSelfReftablePeer
 */
@SuppressWarnings({"unused", "unchecked"})
public abstract class BaseMultipkSelfReftablePeer
{
    /** The class log. */
    private static Log log = LogFactory.getLog(BaseMultipkSelfReftablePeerImpl.class);
    /** Serial version */
    private static final long serialVersionUID = 1347503742604L;


    /** The default database name for this class. */
    public static final String DATABASE_NAME;

     /** The table name for this class. */
    public static final String TABLE_NAME;

     /** The table map for this class. */
    public static final TableMap TABLE;
    /** The column for the COL1 field */
    public static final ColumnMap COL1;
    /** The column for the COL2 field */
    public static final ColumnMap COL2;
    /** The column for the PARENT_COL1 field */
    public static final ColumnMap PARENT_COL1;
    /** The column for the PARENT_COL2 field */
    public static final ColumnMap PARENT_COL2;

    /** number of columns for this peer */
    public static final int numColumns = 4;


    /** The implementation of the peer. */
    private static MultipkSelfReftablePeerImpl multipkSelfReftablePeerImpl;


    static
    {
        DatabaseMap dbMap = Torque.getOrCreateDatabase("bookstore")
                .getDatabaseMap();
        if (dbMap.getTable("MULTIPK_SELF_REFTABLE") == null)
        {
            dbMap.addTable("MULTIPK_SELF_REFTABLE");
        }
        DATABASE_NAME = "bookstore";
        TABLE_NAME = "MULTIPK_SELF_REFTABLE";

        TABLE = dbMap.getTable("MULTIPK_SELF_REFTABLE");
        TABLE.setJavaName("MultipkSelfReftable");
        TABLE.setOMClass(org.apache.torque.test.MultipkSelfReftable.class);
        TABLE.setPeerClass(org.apache.torque.test.MultipkSelfReftablePeer.class);
        TABLE.setPrimaryKeyMethod(IDMethod.NO_ID_METHOD);
        TABLE.setPrimaryKeyMethodInfo(IDMethod.ID_BROKER, TABLE.getName());
        TABLE.setPrimaryKeyMethodInfo(IDMethod.SEQUENCE, "$sequenceName");
        TABLE.setPrimaryKeyMethodInfo(IDMethod.AUTO_INCREMENT, "MULTIPK_SELF_REFTABLE");
        TABLE.setUseInheritance(true);


    // ------------- Column: COL1 --------------------
        COL1 = new ColumnMap("COL1", TABLE);
        COL1.setType(new java.math.BigDecimal((double) 0));
        COL1.setTorqueType("DECIMAL");
        COL1.setUsePrimitive(false);
        COL1.setPrimaryKey(true);
        COL1.setNotNull(true);
        COL1.setJavaName("Col1");
        COL1.setAutoIncrement(false);
        COL1.setProtected(false);
        COL1.setJavaType( "java.math.BigDecimal" );
        COL1.setPosition(1);
        TABLE.addColumn(COL1);
    // ------------- Column: COL2 --------------------
        COL2 = new ColumnMap("COL2", TABLE);
        COL2.setType(new java.math.BigDecimal((double) 0));
        COL2.setTorqueType("DECIMAL");
        COL2.setUsePrimitive(false);
        COL2.setPrimaryKey(true);
        COL2.setNotNull(true);
        COL2.setJavaName("Col2");
        COL2.setAutoIncrement(false);
        COL2.setProtected(false);
        COL2.setJavaType( "java.math.BigDecimal" );
        COL2.setPosition(2);
        TABLE.addColumn(COL2);
    // ------------- Column: PARENT_COL1 --------------------
        PARENT_COL1 = new ColumnMap("PARENT_COL1", TABLE);
        PARENT_COL1.setType(new java.math.BigDecimal((double) 0));
        PARENT_COL1.setTorqueType("DECIMAL");
        PARENT_COL1.setUsePrimitive(false);
        PARENT_COL1.setPrimaryKey(false);
        PARENT_COL1.setNotNull(true);
        PARENT_COL1.setJavaName("ParentCol1");
        PARENT_COL1.setAutoIncrement(false);
        PARENT_COL1.setProtected(false);
        PARENT_COL1.setJavaType( "java.math.BigDecimal" );
        PARENT_COL1.setPosition(3);
        TABLE.addColumn(PARENT_COL1);
    // ------------- Column: PARENT_COL2 --------------------
        PARENT_COL2 = new ColumnMap("PARENT_COL2", TABLE);
        PARENT_COL2.setType(new java.math.BigDecimal((double) 0));
        PARENT_COL2.setTorqueType("DECIMAL");
        PARENT_COL2.setUsePrimitive(false);
        PARENT_COL2.setPrimaryKey(false);
        PARENT_COL2.setNotNull(true);
        PARENT_COL2.setJavaName("ParentCol2");
        PARENT_COL2.setAutoIncrement(false);
        PARENT_COL2.setProtected(false);
        PARENT_COL2.setJavaType( "java.math.BigDecimal" );
        PARENT_COL2.setPosition(4);
        TABLE.addColumn(PARENT_COL2);


    // ------------- Foreign keys --------------------
        ForeignKeyMap foreignKeyMap;
        TableMap foreignTable;
        String foreignTableName; 
        foreignTableName = "MULTIPK_SELF_REFTABLE"; 
        foreignTable = dbMap.getTable(foreignTableName);
        if (foreignTable == null)
        {
            foreignKeyMap = new ForeignKeyMap(TABLE, foreignTableName);
            foreignKeyMap.addColumns(new ForeignKeyMap.ColumnPair(
                foreignKeyMap,
                TABLE.getColumn("PARENT_COL1"),
                "COL1"));
            foreignKeyMap.addColumns(new ForeignKeyMap.ColumnPair(
                foreignKeyMap,
                TABLE.getColumn("PARENT_COL2"),
                "COL2"));
        }
        else
        {
            foreignKeyMap = new ForeignKeyMap(TABLE, foreignTable);
            foreignKeyMap.addColumns(new ForeignKeyMap.ColumnPair(
                foreignKeyMap,
                TABLE.getColumn("PARENT_COL1"),
                foreignTable.getColumn("COL1")));
            foreignKeyMap.addColumns(new ForeignKeyMap.ColumnPair(
                foreignKeyMap,
                TABLE.getColumn("PARENT_COL2"),
                foreignTable.getColumn("COL2")));
        }
        TABLE.addForeignKey(foreignKeyMap);


        initDatabaseMap();
    }

    /**
     * Creates a new instance of the  implementation of the peer.
     *
     * @return the new instance.
     */
    protected static MultipkSelfReftablePeerImpl createMultipkSelfReftablePeerImpl()
    {
        MultipkSelfReftablePeerImpl instance = new MultipkSelfReftablePeerImpl();
        return instance;
    }


    /**
     * Returns an instance of the implementation of the peer.
     * If no instance is currently cached, a new instance is created and cached.
     *
     * @return an instance of the implementation of the peer, not null.
     */
    public static MultipkSelfReftablePeerImpl getMultipkSelfReftablePeerImpl()
    {
        MultipkSelfReftablePeerImpl peerImplInstance = multipkSelfReftablePeerImpl;
        if (peerImplInstance == null)
        {
            peerImplInstance = MultipkSelfReftablePeer.createMultipkSelfReftablePeerImpl();
            multipkSelfReftablePeerImpl = peerImplInstance;
        }
        return peerImplInstance;
    }



    /**
     * Sets the instance of the implementation of the peer.
     *
     * @param an instance of the implementation of the peer, or null
     *        if a new instance should be created automatically.
     */
    public static void setMultipkSelfReftablePeerImpl(MultipkSelfReftablePeerImpl peerImplInstance)
    {
        multipkSelfReftablePeerImpl = peerImplInstance;
    }


    /**
     * Get the list of objects for a ResultSet.  Please not that your
     * resultset MUST return columns in the right order.  You can use
     * getFieldNames() in BaseObject to get the correct sequence.
     *
     * @param resultSet the ResultSet
     * @return the list of objects
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultipkSelfReftable> resultSet2Objects(ResultSet resultSet)
            throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().resultSet2Objects(resultSet);
    }

    /**
     * Add all the columns needed to create a new object.
     *
     * @param criteria object containing the columns to add.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void addSelectColumns(Criteria criteria)
            throws TorqueException
    {
        getMultipkSelfReftablePeerImpl().addSelectColumns(criteria);
    }

    /**
     * changes the boolean values in the criteria to the appropriate type,
     * whenever a booleanchar or booleanint column is involved.
     * This enables the user to create criteria using Boolean values
     * for booleanchar or booleanint columns.
     *
     * @param criteria the criteria in which the boolean values
     *        should be corrected.
     *
     * @throws TorqueException if the database map for the criteria cannot be 
               obtained.
     */
    public static void correctBooleans(Criteria criteria) throws TorqueException
    {
        getMultipkSelfReftablePeerImpl().correctBooleans(criteria);
    }

    /**
     * Checks all columns in the criteria to see whether
     * booleanchar and booleanint columns are queried with a boolean.
     * If yes, the query values are mapped onto values the database
     * does understand, i.e. 0 and 1 for booleanints and N and Y for
     * booleanchar columns.
     *
     * @param columnValues The value to be checked for booleanint
     *        and booleanchar columns.
     * @throws TorqueException if the database map for the criteria cannot be
     *         retrieved.
     */
    public static void correctBooleans(
            ColumnValues columnValues)
        throws TorqueException
    {
        getMultipkSelfReftablePeerImpl().correctBooleans(columnValues);
    }
    
    /**
     * Selects MultipkSelfReftable objects from a database.
     *
     * @param criteria object used to create the SELECT statement.
     *
     * @return the list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultipkSelfReftable> doSelect(Criteria criteria)
            throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doSelect(criteria);
    }

    /**
     * Selects MultipkSelfReftable objects from a database
     * within a transaction.
     *
     * @param criteria object used to create the SELECT statement.
     * @param connection the connection holding the transaction, not null.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultipkSelfReftable> doSelect(
                Criteria criteria,
                Connection connection)
            throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doSelect(criteria, connection);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                Criteria criteria,
                RecordMapper<T> mapper)
            throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doSelect(criteria, mapper);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection for selecting records,
     *        not null.
     *
     * @return The results of the query, not null.
     * @throws TorqueException Error performing database query.
     */
    public static <T> List<T> doSelect(
            Criteria criteria,
            RecordMapper<T> mapper,
            Connection connection)
        throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doSelect(
                criteria,
                mapper,
                connection);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param query the sql query to execute, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param dbName The name of the database to create the connection for,
     *        or null for the default SDB.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                String query,
                RecordMapper<T> mapper,
                String dbName)
            throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doSelect(
                query,
                mapper,
                dbName);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param query the SQL Query to execute, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection, not null.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                String query,
                RecordMapper<T> mapper,
                Connection connection)
            throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doSelect(
                query,
                mapper,
                connection);
    }

    /**
     * Selects MultipkSelfReftable objects from the database which have
     * the same content as the passed object.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultipkSelfReftable> doSelect(MultipkSelfReftable obj)
            throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doSelect(obj);
    }

    /**
     * Selects at most one MultipkSelfReftable object from a database.
     *
     * @param criteria object used to create the SELECT statement.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static MultipkSelfReftable doSelectSingleRecord(
                Criteria criteria)
            throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doSelectSingleRecord(criteria);
    }

    /**
     * Selects at most one MultipkSelfReftable object from a database
     * within a transaction.
     *
     * @param criteria object used to create the SELECT statement.
     * @param connection the connection holding the transaction, not null.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static MultipkSelfReftable doSelectSingleRecord(
                Criteria criteria,
                Connection connection)
            throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doSelectSingleRecord(criteria, connection);
    }

    /**
     * Selects at most a single row from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     *
     * @return The selected row, or null if no records was selected.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> T doSelectSingleRecord(
                org.apache.torque.criteria.Criteria criteria,
                RecordMapper<T> mapper)
            throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doSelectSingleRecord(
                criteria,
                mapper);
    }

    /**
     * Selects at most a single row from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection, not null.
     *
     * @return The selected row, or null if no records was selected.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> T doSelectSingleRecord(
                org.apache.torque.criteria.Criteria criteria,
                RecordMapper<T> mapper,
                Connection connection)
            throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doSelectSingleRecord(
                criteria,
                mapper,
                connection);
    }

    /**
     * Selects at most one MultipkSelfReftable object from the database
     * which has the same content as the passed object.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static MultipkSelfReftable doSelectSingleRecord(
                MultipkSelfReftable obj)
            throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doSelectSingleRecord(obj);
    }


    /**
     * Returns a new instance of the Data object class
     */
    public static MultipkSelfReftable getDbObjectInstance()
    {
        return getMultipkSelfReftablePeerImpl().getDbObjectInstance();
    }


    /**
     * Method to do inserts.
     *
     * @param columnValues the values to insert.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static ObjectKey doInsert(ColumnValues columnValues) 
            throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doInsert(columnValues);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(Criteria) method.
     *
     * @param columnValues the values to insert.
     * @param con the connection to use, not null.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static ObjectKey doInsert(ColumnValues columnValues, Connection con)
            throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doInsert(columnValues, con);
    }
    /**
     * Method to do inserts
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void doInsert(MultipkSelfReftable obj)
            throws TorqueException
    {
        getMultipkSelfReftablePeerImpl().doInsert(obj);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(MultipkSelfReftable) method.  It will take
     * care of the connection details internally.
     *
     * @param obj the data object to insert into the database.
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void doInsert(MultipkSelfReftable obj, Connection con)
            throws TorqueException
    {
        getMultipkSelfReftablePeerImpl().doInsert(obj, con);
    }

    /**
     * Method to do updates.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(ColumnValues columnValues) throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doUpdate(columnValues);
    }

    /**
     * Method to do updates.  This method is to be used during a transaction,
     * otherwise use the doUpdate(Criteria) method.  It will take care of
     * the connection details internally.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @param con the connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doUpdate(columnValues, con);
    }

    /**
     * Executes an update against the database. The rows to be updated
     * are selected using <code>criteria</code> and updated using the values
     * in <code>updateValues</code>.
     *
     * @param criteria selects which rows of which table should be updated.
     * @param updateValues Which columns to update with which values, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException if updating fails.
     */
    public static int doUpdate(
                Criteria selectCriteria,
                ColumnValues updateValues)
            throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doUpdate(
            selectCriteria,
            updateValues);
    }

    /**
     * Executes an update against the database. The rows to be updated
     * are selected using <code>criteria</code> and updated using the values
     * in <code>updateValues</code>.
     *
     * @param criteria selects which rows of which table should be updated.
     * @param updateValues Which columns to update with which values, not null.
     * @param connection the database connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException if updating fails.
     */
    public static int doUpdate(
                Criteria criteria,
                ColumnValues updateValues,
                Connection connection)
            throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doUpdate(
            criteria,
             updateValues,
              connection);
    }

    /**
     * Updates an MultipkSelfReftable in the database.
     * The primary key is used to identify the object to update.
     *
     * @param obj the data object to update in the database.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(MultipkSelfReftable obj) throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doUpdate(obj);
    }

    /**
     * Updates a MultipkSelfReftable in the database.
     * The primary key is used to identify the object to update.
     * This method is to be used during a transaction,
     * otherwise the doUpdate(MultipkSelfReftable) method can be used.
     *
     * @param obj the data object to update in the database.
     * @param con the connection to use, not null.
     
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(MultipkSelfReftable obj, Connection con)
        throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doUpdate(obj, con);
    }

    /**
     * Utility method which executes a given SQL statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the SQL statement to execute.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString)
            throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().executeStatement(statementString);
    }

    /**
     * Utility method which executes a given sql statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the sql statement to execute.
     * @param dbName Name of database to connect to.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString, String dbName)
            throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().executeStatement(statementString, dbName);
    }

    /**
     * Utility method which executes a given sql statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the sql statement to execute.
     * @param con A Connection.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString, Connection con)
            throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().executeStatement(statementString, con);
    }

    /**
     * Deletes rows from a database table.
     *
     * @param criteria defines the rows to be deleted, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
     public static int doDelete(Criteria criteria) throws TorqueException
     {
        return getMultipkSelfReftablePeerImpl().doDelete(criteria);
     }

    /**
     * Deletes rows from a table.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
    *
     * @param criteria defines the rows to be deleted, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
     public static int doDelete(Criteria criteria, Connection con)
        throws TorqueException
     {
        return getMultipkSelfReftablePeerImpl().doDelete(criteria, con);
     }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     *
     * @param obj the data object to delete in the database, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(MultipkSelfReftable obj) throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doDelete(obj);
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param obj the data object to delete in the database, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(MultipkSelfReftable obj, Connection con)
        throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doDelete(obj, con);
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     *
     * @param objects the datas object to delete in the database, not null,
     *        may not contain null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(Collection<MultipkSelfReftable> objects)
            throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doDelete(objects);
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param objects the datas object to delete in the database, not null,
     *        may not contain null.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(
            Collection<MultipkSelfReftable> objects,
            Connection con)
        throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doDelete(objects, con);
    }

    /**
     * Deletes a row in the database.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(ObjectKey pk) throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doDelete(pk);
    }

    /**
     * Deletes a row in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(ObjectKey pk, Connection con)
        throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doDelete(pk, con);
    }

    /** 
     * Build a Criteria object which selects all objects which have a given
     * primary key.
     *
     * @param pk the primary key value to build the criteria from, not null.
     */
    public static Criteria buildCriteria(ObjectKey pk)
    {
        return getMultipkSelfReftablePeerImpl().buildCriteria(pk);
    }

    /** 
     * Build a Criteria object which selects all objects which primary keys
     * are contained in the passed collection.
     *
     * @param pks the primary key values to build the criteria from, not null,
     *        may not contain null.
     */
    public static Criteria buildCriteria(Collection<ObjectKey> pks)
    {
        return getMultipkSelfReftablePeerImpl().buildCriteria(pks);
    }

    /** 
     * Build a Criteria object which selects all passed objects using their
     * primary key. Objects which do not yet have a primary key are ignored.
     *
     * @param objects the objects to build the criteria from, not null,
     *        may not contain null.
     */
    public static Criteria buildPkCriteria(
            Collection<MultipkSelfReftable> objects)
    {
        return getMultipkSelfReftablePeerImpl().buildPkCriteria(objects);
    }

    /** 
     * Build a Criteria object from the data object for this peer.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public static Criteria buildCriteria(MultipkSelfReftable obj)
    {
        return getMultipkSelfReftablePeerImpl().buildCriteria(obj);
    }

    /** 
     * Build a Criteria object from the data object for this peer,
     * skipping all binary columns.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public static Criteria buildSelectCriteria(MultipkSelfReftable obj)
    {
        return getMultipkSelfReftablePeerImpl().buildSelectCriteria(obj);
    }

    /** 
     * Returns the contents of the object as ColumnValues object
     *
     * @throws TorqueException if the table map cannot be retrieved
     *         (should not happen).
     */
    public static ColumnValues buildColumnValues(MultipkSelfReftable multipkSelfReftable)
            throws TorqueException
    {
        
        return getMultipkSelfReftablePeerImpl().buildColumnValues(multipkSelfReftable);
    }

    /**
     * retrieve object using using pk values.
     *
     * @param col1 java.math.BigDecimal
     * @param col2 java.math.BigDecimal
     */
    public static MultipkSelfReftable retrieveByPK(
            java.math.BigDecimal col1,
            java.math.BigDecimal col2)
        throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().retrieveByPK(
                col1,
                col2);
    }

    /**
     * retrieve object using using pk values.
     *
     * @param col1 java.math.BigDecimal
     * @param col2 java.math.BigDecimal
     * @param con Connection
     */
    public static MultipkSelfReftable retrieveByPK(
            java.math.BigDecimal col1,
            java.math.BigDecimal col2,
            Connection con) throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().retrieveByPK(
                col1,
                col2,
                con);
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public static MultipkSelfReftable retrieveByPK(ObjectKey pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return getMultipkSelfReftablePeerImpl().retrieveByPK(pk);
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public static MultipkSelfReftable retrieveByPK(ObjectKey pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return getMultipkSelfReftablePeerImpl().retrieveByPK(pk, con);
    }


    /**
     * Retrieve a multiple objects by pk
     *
     * @param pks List of primary keys
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultipkSelfReftable> retrieveByPKs(Collection<ObjectKey> pks)
        throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().retrieveByPKs(pks);
    }

    /**
     * Retrieve multiple objects by pk
     *
     * @param pks List of primary keys
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultipkSelfReftable> retrieveByPKs(Collection<ObjectKey> pks, Connection con)
        throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().retrieveByPKs(pks,con);
    }


    /**
     * Selects a collection of dbObjectClassName objects pre-filled with their
     * MultipkSelfReftable objects.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultipkSelfReftable> doSelectJoinMultipkSelfReftable(Criteria criteria)
        throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doSelectJoinMultipkSelfReftable(criteria);
    }

    /**
     * Selects a collection of MultipkSelfReftable objects pre-filled with their
     * MultipkSelfReftable objects.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<MultipkSelfReftable> doSelectJoinMultipkSelfReftable(
            Criteria criteria, Connection conn)
        throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().doSelectJoinMultipkSelfReftable(criteria, conn);
    }


    /** 
     * Fills the referenced MultipkSelfReftable objects in the aMultipkSelfReftableRelatedByParentCol1ParentCol2 fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null, may not contain null.
     *
     * @return all read MultipkSelfReftable objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public static List<MultipkSelfReftable> fillMultipkSelfReftableRelatedByParentCol1ParentCol2s(
            Collection<MultipkSelfReftable> toFill) 
        throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().fillMultipkSelfReftableRelatedByParentCol1ParentCol2s(toFill);
    }

    /** 
     * Fills the referenced MultipkSelfReftable objects in the aMultipkSelfReftableRelatedByParentCol1ParentCol2 fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null, may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read MultipkSelfReftable objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public static List<MultipkSelfReftable> fillMultipkSelfReftableRelatedByParentCol1ParentCol2s(
            Collection<MultipkSelfReftable> toFill,
            Connection connection) 
        throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().fillMultipkSelfReftableRelatedByParentCol1ParentCol2s(toFill, connection);
    }

    /** 
     * Fills the referenced MultipkSelfReftable objects in the collMultipkSelfReftables fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null, may not contain null.
     *
     * @return all read List<MultipkSelfReftable> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public static List<MultipkSelfReftable> fillMultipkSelfReftables(
            Collection<MultipkSelfReftable> toFill) 
        throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().fillMultipkSelfReftables(toFill);
    }

    /** 
     * Fills the referenced MultipkSelfReftable objects in the collMultipkSelfReftables fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null, may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read List<MultipkSelfReftable> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public static List<MultipkSelfReftable> fillMultipkSelfReftables(
            Collection<MultipkSelfReftable> toFill,
            Connection connection) 
        throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().fillMultipkSelfReftables(toFill, connection);
    }

    /** 
     * Returns the chunk size for the filler methods.
     *
     * @return the chunk size for the filler methods.
     */
    protected static int getFillerChunkSize()
    {
        return getMultipkSelfReftablePeerImpl().getFillerChunkSize();
    }

    /**
     * Returns the TableMap related to this peer.
     *
     * @return the table map, not null.
     *
     * @throws TorqueException if the Peer instance does not hold a Table map.
     */
    public static TableMap getTableMap()
        throws TorqueException
    {
        return getMultipkSelfReftablePeerImpl().getTableMap();
    }

    public static void initDatabaseMap()
    {
        BaseBookstoreDatabaseMapInit.init();
    }


}
