package org.apache.torque.test;

import java.sql.Blob;
import java.sql.Clob;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.sql.PreparedStatement;
import java.sql.Types;
import java.io.IOException;
import java.io.InputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.Reader;
import java.io.StringReader;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.torque.NoRowsException;
import org.apache.torque.TooManyRowsException;
import org.apache.torque.Torque;
import org.apache.torque.TorqueException;
import org.apache.torque.TorqueRuntimeException;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.criteria.Criterion;
import org.apache.torque.om.mapper.RecordMapper;
import org.apache.torque.om.mapper.CompositeMapper;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.ComboKey;
import org.apache.torque.map.TableMap;
import org.apache.torque.util.BasePeer;
import org.apache.torque.util.Transaction;
import org.apache.torque.util.ColumnValues;
import org.apache.torque.util.JdbcTypedValue;



/**
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:45 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to MultipkSelfReftablePeer
 */

public abstract class BaseMultipkSelfReftablePeerImpl
    extends org.apache.torque.util.BasePeerImpl<MultipkSelfReftable>
{
    /** The class log. */
    private static Log log = LogFactory.getLog(BaseMultipkSelfReftablePeerImpl.class);

    /** Serial version */
    private static final long serialVersionUID = 1347503745391L;



    /**
     * Constructor.
     * The recordMapper, tableMap and databaseName fields are correctly
     * initialized.
     */
    public BaseMultipkSelfReftablePeerImpl()
    {
        this(new MultipkSelfReftableRecordMapper(),
            MultipkSelfReftablePeer.TABLE,
            MultipkSelfReftablePeer.DATABASE_NAME);
    }

    /**
     * Constructor providing the objects to be injected as parameters.
     *
     * @param recordMapper a record mapper to map JDBC result sets to objects
     * @param tableMap the default table map
     * @param databaseName the name of the database
     */
    public BaseMultipkSelfReftablePeerImpl(
            RecordMapper<MultipkSelfReftable> recordMapper, 
            TableMap tableMap,
            String databaseName)
    {
        super(recordMapper, tableMap, databaseName);
    }


    /**
     * Selects MultipkSelfReftable objects from the database which have
     * the same content as the passed object.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<MultipkSelfReftable> doSelect(MultipkSelfReftable obj)
            throws TorqueException
    {
        return doSelect(buildSelectCriteria(obj));
    }

    /**
     * Selects at most one MultipkSelfReftable object from the database
     * which has the same content as the passed object.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public MultipkSelfReftable doSelectSingleRecord(
                MultipkSelfReftable obj)
            throws TorqueException
    {
        List<MultipkSelfReftable> multipkSelfReftableList = doSelect(obj);
        MultipkSelfReftable multipkSelfReftable = null;
        if (multipkSelfReftableList.size() > 1)
        {
            throw new TooManyRowsException("Object " + obj 
                + " matched more than one record");
        }
        if (!multipkSelfReftableList.isEmpty())
        {
            multipkSelfReftable = multipkSelfReftableList.get(0);
        }
        return multipkSelfReftable;
    }

    /**
     * Returns a new instance of the Data object class
     */
    public MultipkSelfReftable getDbObjectInstance()
    {
        return new MultipkSelfReftable();
    }


    /**
     * Method to do inserts.
     *
     * @param columnValues the values to insert.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public ObjectKey doInsert(ColumnValues columnValues) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    MultipkSelfReftablePeer.DATABASE_NAME);
            ObjectKey result = doInsert(columnValues, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(Criteria) method.
     *
     * @param columnValues the values to insert.
     * @param con the connection to use, not null.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public ObjectKey doInsert(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        correctBooleans(columnValues);
        return super.doInsert(columnValues, con);
    }

    /**
     * Method to do inserts
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public void doInsert(MultipkSelfReftable obj) throws TorqueException
    {
        doInsert(buildColumnValues(obj));
        obj.setNew(false);
        obj.setModified(false);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(MultipkSelfReftable) method.  It will take
     * care of the connection details internally.
     *
     * @param obj the data object to insert into the database.
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public void doInsert(MultipkSelfReftable obj, Connection con)
        throws TorqueException
    {
        doInsert(buildColumnValues(obj), con);
        obj.setNew(false);
        obj.setModified(false);
    }

    /**
     * Method to do updates.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(ColumnValues columnValues) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    MultipkSelfReftablePeer.DATABASE_NAME);
            int result = doUpdate(columnValues, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Method to do updates.  This method is to be used during a transaction,
     * otherwise use the doUpdate(Criteria) method.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @param con the connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        Criteria selectCriteria 
                = new Criteria(MultipkSelfReftablePeer.DATABASE_NAME);
        correctBooleans(columnValues);


    
        selectCriteria.where(
                MultipkSelfReftablePeer.COL1,
                columnValues.remove(MultipkSelfReftablePeer.COL1).getValue());

    
        selectCriteria.where(
                MultipkSelfReftablePeer.COL2,
                columnValues.remove(MultipkSelfReftablePeer.COL2).getValue());


        return doUpdate(selectCriteria, columnValues, con);
    }

    /**
     * Updates an MultipkSelfReftable in the database.
     * The primary key is used to identify the object to update.
     *
     * @param obj the data object to update in the database.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(MultipkSelfReftable obj) throws TorqueException
    {
        ColumnValues columnValues = buildColumnValues(obj);
        int result = doUpdate(columnValues);
        obj.setModified(false);
        return result;
    }

    /**
     * Updates a MultipkSelfReftable in the database.
     * The primary key is used to identify the object to update.
     * This method is to be used during a transaction,
     * otherwise the doUpdate(MultipkSelfReftable) method can be used.
     *
     * @param obj the data object to update in the database.
     * @param con the connection to use, not null.
     
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(MultipkSelfReftable obj, Connection con)
        throws TorqueException
    {
        ColumnValues columnValues = buildColumnValues(obj);
        int result = doUpdate(columnValues, con);
        obj.setModified(false);
        return result;
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     *
     * @param obj the data object to delete in the database, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(MultipkSelfReftable obj) throws TorqueException
    {
        int result = doDelete(buildCriteria(obj.getPrimaryKey()));
        obj.setDeleted(true);
        return result;
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     * This method is to be used during a transaction, otherwise use the
     * doDelete(MultipkSelfReftable) method.
     *
     * @param obj the data object to delete in the database, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(MultipkSelfReftable obj, Connection con)
        throws TorqueException
    {
        int result = doDelete(buildCriteria(obj.getPrimaryKey()), con);
        obj.setDeleted(true);
        return result;
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     *
     * @param objects the data object to delete in the database, not null,
     *        may not contain null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(Collection<MultipkSelfReftable> objects)
            throws TorqueException
    {
        int result = doDelete(buildPkCriteria(objects));
        for (MultipkSelfReftable object : objects)
        {
            object.setDeleted(true);
        }
        return result;
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param objects the data objects to delete in the database, not null,
     *        may not contain null.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(
            Collection<MultipkSelfReftable> objects,
            Connection con)
        throws TorqueException
    {
        int result = doDelete(buildPkCriteria(objects), con);
        for (MultipkSelfReftable object : objects)
        {
            object.setDeleted(true);
        }
        return result;
    }

    /**
     * Deletes a row in the database.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(ObjectKey pk) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    MultipkSelfReftablePeer.DATABASE_NAME);
            int deletedRows = doDelete(pk, connection);
            Transaction.commit(connection);
            connection = null;
            return deletedRows;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Deletes a row in the database.
     * This method is to be used during a transaction,
     * otherwise use the doDelete(ObjectKey) method.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(ObjectKey pk, Connection con)
        throws TorqueException
    {
        return doDelete(buildCriteria(pk), con);
    }

    /** 
     * Build a Criteria object which selects all objects which have a given
     * primary key.
     *
     * @param pk the primary key value to build the criteria from, not null.
     */
    public Criteria buildCriteria(ObjectKey pk)
    {
        Criteria criteria = new Criteria();
        SimpleKey[] keys = (SimpleKey[])pk.getValue();
        criteria.and(MultipkSelfReftablePeer.COL1, keys[0]);
        criteria.and(MultipkSelfReftablePeer.COL2, keys[1]);
        return criteria;
     }

    /** 
     * Build a Criteria object which selects all objects which primary keys
     * are contained in the passed collection.
     *
     * @param pks the primary key values to build the criteria from, not null,
     *        may not contain null.
     */
    public Criteria buildCriteria(Collection<ObjectKey> pks)
    {
        Criteria criteria = new Criteria();
        for (ObjectKey pk : pks)
        {
            SimpleKey[] keys = (SimpleKey[])pk.getValue();
                Criterion c0 = new Criterion(
                    MultipkSelfReftablePeer.COL1, keys[0], Criteria.EQUAL);
                Criterion c1 = new Criterion(
                    MultipkSelfReftablePeer.COL2, keys[1], Criteria.EQUAL);
                    c0.and(c1);
            criteria.or(c0);
        }
        return criteria;
     }


    /** 
     * Build a Criteria object which selects all passed objects using their
     * primary key. Objects which do not yet have a primary key are ignored.
     *
     * @param objects the objects to build the criteria from, not null,
     *        may not contain null.
     */
    public Criteria buildPkCriteria(
            Collection<MultipkSelfReftable> objects)
    {
        List<ObjectKey> pks = new ArrayList<ObjectKey>(objects.size());
        for (MultipkSelfReftable object : objects)
        {
            ObjectKey pk = object.getPrimaryKey();
            if (pk != null)
            {
                pks.add(pk);
            }
        }
        return buildCriteria(pks);
    }

    /** 
     * Build a Criteria object from the data object for this peer.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public Criteria buildCriteria(MultipkSelfReftable obj)
    {
        Criteria criteria = new Criteria(MultipkSelfReftablePeer.DATABASE_NAME);
        criteria.and(MultipkSelfReftablePeer.COL1, obj.getCol1());
        criteria.and(MultipkSelfReftablePeer.COL2, obj.getCol2());
        criteria.and(MultipkSelfReftablePeer.PARENT_COL1, obj.getParentCol1());
        criteria.and(MultipkSelfReftablePeer.PARENT_COL2, obj.getParentCol2());
        return criteria;
    }

    /** 
     * Build a Criteria object from the data object for this peer,
     * skipping all binary columns.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public Criteria buildSelectCriteria(MultipkSelfReftable obj)
    {
        Criteria criteria = new Criteria(MultipkSelfReftablePeer.DATABASE_NAME);
        criteria.and(MultipkSelfReftablePeer.COL1, obj.getCol1());
        criteria.and(MultipkSelfReftablePeer.COL2, obj.getCol2());
        criteria.and(MultipkSelfReftablePeer.PARENT_COL1, obj.getParentCol1());
        criteria.and(MultipkSelfReftablePeer.PARENT_COL2, obj.getParentCol2());
        return criteria;
    }

    /** 
     * Returns the contents of the object as ColumnValues object.
     * Primary key columns which are generated on insertion are not
     * added to the returned object if they still have their initial
     * value. Also, columns which have the useDatabaseDefaultValue
     * flag set to true are also not added to the returned object
     * if they still have their initial value.
     *
     * @throws TorqueException if the table map cannot be retrieved
     *         (should not happen).
     */
    public ColumnValues buildColumnValues(MultipkSelfReftable multipkSelfReftable)
            throws TorqueException
    {
        ColumnValues columnValues = new ColumnValues();
        columnValues.put(
                MultipkSelfReftablePeer.COL1,
                new JdbcTypedValue(
                    multipkSelfReftable.getCol1(),
                    3));
        columnValues.put(
                MultipkSelfReftablePeer.COL2,
                new JdbcTypedValue(
                    multipkSelfReftable.getCol2(),
                    3));
        columnValues.put(
                MultipkSelfReftablePeer.PARENT_COL1,
                new JdbcTypedValue(
                    multipkSelfReftable.getParentCol1(),
                    3));
        columnValues.put(
                MultipkSelfReftablePeer.PARENT_COL2,
                new JdbcTypedValue(
                    multipkSelfReftable.getParentCol2(),
                    3));
        return columnValues;
    }

    /**
     * retrieve object using using pk values.
     *
     * @param col1 java.math.BigDecimal
     * @param col2 java.math.BigDecimal
     */
    public MultipkSelfReftable retrieveByPK(
            java.math.BigDecimal col1,
            java.math.BigDecimal col2)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(MultipkSelfReftablePeer.DATABASE_NAME);
            MultipkSelfReftable result = retrieveByPK(
               col1,
               col2,
               connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * retrieve object using using pk values.
     *
     * @param col1 java.math.BigDecimal
     * @param col2 java.math.BigDecimal
     * @param con Connection
     */
    public MultipkSelfReftable retrieveByPK(
            java.math.BigDecimal col1,
            java.math.BigDecimal col2,
            Connection con) throws TorqueException
    {

        Criteria criteria = new Criteria();
        criteria.and(MultipkSelfReftablePeer.COL1, col1);
        criteria.and(MultipkSelfReftablePeer.COL2, col2);
        List<MultipkSelfReftable> v = doSelect(criteria, con);
        if (v.size() == 1)
        {
            return v.get(0);
        }
        else
        {
            throw new TorqueException("Failed to select one and only one row.");
        }
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public MultipkSelfReftable retrieveByPK(ObjectKey pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(MultipkSelfReftablePeer.DATABASE_NAME);
            MultipkSelfReftable result = retrieveByPK(pk, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public MultipkSelfReftable retrieveByPK(ObjectKey pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        Criteria criteria = buildCriteria(pk);
        List<MultipkSelfReftable> v = doSelect(criteria, con);
        if (v.size() == 0)
        {
            throw new NoRowsException("Failed to select a row.");
        }
        else if (v.size() > 1)
        {
            throw new TooManyRowsException("Failed to select only one row.");
        }
        else
        {
            return (MultipkSelfReftable)v.get(0);
        }
    }


    /**
     * Retrieve a multiple objects by pk
     *
     * @param pks List of primary keys
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<MultipkSelfReftable> retrieveByPKs(Collection<ObjectKey> pks)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(MultipkSelfReftablePeer.DATABASE_NAME);
            List<MultipkSelfReftable> result = retrieveByPKs(pks, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Retrieve multiple objects by pk
     *
     * @param pks List of primary keys
     * @param dbcon the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<MultipkSelfReftable> retrieveByPKs(
                Collection<ObjectKey> pks,
                Connection dbcon)
            throws TorqueException
    {
        if (pks == null || pks.size() == 0)
        {
            return new ArrayList<MultipkSelfReftable>();
        }
        Criteria criteria = buildCriteria(pks);
        List<MultipkSelfReftable> result = doSelect(criteria, dbcon);
        return result;
    }


    /**
     * Selects a collection of dbObjectClassName objects pre-filled with their
     * MultipkSelfReftable objects.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<MultipkSelfReftable> doSelectJoinMultipkSelfReftable(Criteria criteria)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    MultipkSelfReftablePeer.DATABASE_NAME);
            List<MultipkSelfReftable> result
                    = MultipkSelfReftablePeer.doSelectJoinMultipkSelfReftable(criteria, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Selects a collection of MultipkSelfReftable objects pre-filled with their
     * MultipkSelfReftable objects.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<MultipkSelfReftable> doSelectJoinMultipkSelfReftable(
            Criteria criteria, Connection conn)
        throws TorqueException
    {
        setDbName(criteria);

        addSelectColumns(criteria);
        org.apache.torque.test.MultipkSelfReftablePeer.addSelectColumns(criteria);

        CompositeMapper compositeMapper = new CompositeMapper();
        compositeMapper.addMapper(
                new MultipkSelfReftableRecordMapper(),
                0);
        compositeMapper.addMapper(
                new MultipkSelfReftableRecordMapper(),
                MultipkSelfReftablePeer.numColumns);
        criteria.addJoin(MultipkSelfReftablePeer.PARENT_COL1,
            org.apache.torque.test.MultipkSelfReftablePeer.COL1);
        criteria.addJoin(MultipkSelfReftablePeer.PARENT_COL2,
            org.apache.torque.test.MultipkSelfReftablePeer.COL2);

        correctBooleans(criteria);

        List<MultipkSelfReftable> result = new ArrayList<MultipkSelfReftable>();
        List<List<Object>> rawResult = doSelect(
                criteria, compositeMapper, conn);
        for (List<Object> rawResultRow : rawResult)
        {
            MultipkSelfReftable obj1 = (MultipkSelfReftable) rawResultRow.get(0);
            MultipkSelfReftable obj2 = (MultipkSelfReftable) rawResultRow.get(1);

            boolean newObject = true;
            for (int j = 0; j < result.size(); j++)
            {
                MultipkSelfReftable temp_obj1 = result.get(j);
                org.apache.torque.test.MultipkSelfReftable temp_obj2 = temp_obj1.getMultipkSelfReftableRelatedByParentCol1ParentCol2();
                if (temp_obj2.getPrimaryKey().equals(obj2.getPrimaryKey()))
                {
                    newObject = false;
                    temp_obj2.addMultipkSelfReftable(obj1);
                    break;
                }
            }
            if (newObject)
            {
                obj2.initMultipkSelfReftables();
                obj2.addMultipkSelfReftable(obj1);
            }
            result.add(obj1);
        }
        return result;
    }


    /** 
     * Fills the referenced MultipkSelfReftable objects in the aMultipkSelfReftableRelatedByParentCol1ParentCol2 fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     *
     * @return all read MultipkSelfReftable objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<MultipkSelfReftable> fillMultipkSelfReftableRelatedByParentCol1ParentCol2s(
            Collection<MultipkSelfReftable> toFill) 
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    MultipkSelfReftablePeer.DATABASE_NAME);
            List<MultipkSelfReftable> result = fillMultipkSelfReftableRelatedByParentCol1ParentCol2s(toFill, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /** 
     * Fills the referenced MultipkSelfReftable objects in the aMultipkSelfReftableRelatedByParentCol1ParentCol2 fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read MultipkSelfReftable objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<MultipkSelfReftable> fillMultipkSelfReftableRelatedByParentCol1ParentCol2s(
            Collection<MultipkSelfReftable> toFill,
            Connection connection) 
        throws TorqueException
    {
        Set<ObjectKey> foreignKeySet = new HashSet<ObjectKey>();
        for (MultipkSelfReftable currentMultipkSelfReftable : toFill)
        {
            ObjectKey foreignKey = currentMultipkSelfReftable.getForeignKeyForMultipkSelfReftableRelatedByParentCol1ParentCol2();
            if (foreignKey != null)
            {
                foreignKeySet.add(foreignKey);
            }
        }

        int fillerChunkSize = getFillerChunkSize();
        Iterator<ObjectKey> foreignKeyIt = foreignKeySet.iterator();
        List<ObjectKey> foreignKeyListChunk
                = new ArrayList<ObjectKey>(fillerChunkSize);;
        Map<ObjectKey, MultipkSelfReftable> referencedKeyToMultipkSelfReftableMap 
                = new HashMap<ObjectKey, MultipkSelfReftable>();
        while (foreignKeyIt.hasNext())
        {
            ObjectKey currentKey = foreignKeyIt.next();
            foreignKeyListChunk.add(currentKey);
            if (foreignKeyListChunk.size() < fillerChunkSize 
                && foreignKeyIt.hasNext())
            {
                continue;
            }

            List<MultipkSelfReftable> referencedMultipkSelfReftableList
                 = MultipkSelfReftablePeer.retrieveByPKs(
                     foreignKeyListChunk,
                     connection);

            for (MultipkSelfReftable referencedObject : referencedMultipkSelfReftableList)
            {
                referencedKeyToMultipkSelfReftableMap.put(
                        referencedObject.getPrimaryKey(),
                        referencedObject);
            }
            foreignKeyListChunk.clear();
        }

        List<MultipkSelfReftable> result = new ArrayList<MultipkSelfReftable>();
        for (MultipkSelfReftable objectToFill : toFill)
        {
            ObjectKey foreignKey = objectToFill.getForeignKeyForMultipkSelfReftableRelatedByParentCol1ParentCol2();
            if (foreignKey == null || foreignKey.getValue() == null)
            {
                continue;
            }
            MultipkSelfReftable referenced = referencedKeyToMultipkSelfReftableMap.get(
                    foreignKey);
            if (referenced == null)
            {
                throw new NoRowsException("No result found for key " 
                    + foreignKey + " in table MULTIPK_SELF_REFTABLE");
            }
            // copy the referenced object for the case that more than one
            // toFill object references the same object; in this case
            // every toFillObject should have its own instance of the referenced
            // object to remain consistent with the other Torque reference
            // treatment
            MultipkSelfReftable referencedCopy = referenced.copy(false);
            // copy does not set primary key
            referencedCopy.setPrimaryKey(referenced.getPrimaryKey());
            objectToFill.setMultipkSelfReftableRelatedByParentCol1ParentCol2(referencedCopy);
            result.add(referencedCopy);
        }
        return result;
    }

    /** 
     * Fills the referenced MultipkSelfReftable objects in the collMultipkSelfReftables fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     *
     * @return all read List<MultipkSelfReftable> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<MultipkSelfReftable> fillMultipkSelfReftables(
            Collection<MultipkSelfReftable> toFill)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    MultipkSelfReftablePeer.DATABASE_NAME);
            List<MultipkSelfReftable> result = fillMultipkSelfReftables(toFill, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /** 
     * Fills the referenced MultipkSelfReftable objects in the collMultipkSelfReftables fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read List<MultipkSelfReftable> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<MultipkSelfReftable> fillMultipkSelfReftables(
            Collection<MultipkSelfReftable> toFill,
            Connection connection)
        throws TorqueException
    {
        Set<ObjectKey> localKeySet = new HashSet<ObjectKey>();
        for (MultipkSelfReftable currentMultipkSelfReftable : toFill)
        {
            ObjectKey localKey = currentMultipkSelfReftable.getPrimaryKey();
            localKeySet.add(localKey);
        }

        int fillerChunkSize = getFillerChunkSize();
        Iterator<ObjectKey> localKeyIt = localKeySet.iterator();
        List<ObjectKey> localKeyListChunk
                = new ArrayList<ObjectKey>(fillerChunkSize);
        Map<ObjectKey, List<MultipkSelfReftable>> fkToMultipkSelfReftableMap
                = new HashMap<ObjectKey, List<MultipkSelfReftable>>();
        while (localKeyIt.hasNext())
        {
            ObjectKey currentKey = localKeyIt.next();
            localKeyListChunk.add(currentKey);
            if (localKeyListChunk.size() < fillerChunkSize
                && localKeyIt.hasNext())
            {
                continue;
            }

            Criteria criteria = new Criteria();
            for (ObjectKey localKey : localKeyListChunk)
            {
                SimpleKey[] keys = (SimpleKey[]) localKey.getValue();
                    Criterion c0 = new Criterion(
                        MultipkSelfReftablePeer.PARENT_COL1, keys[0], Criteria.EQUAL);
                    Criterion c1 = new Criterion(
                        MultipkSelfReftablePeer.PARENT_COL2, keys[1], Criteria.EQUAL);
                        c0.and(c1);
                criteria.or(c0);
            }
            List<MultipkSelfReftable> referencedMultipkSelfReftableList
                 = MultipkSelfReftablePeer.doSelect(
                     criteria,
                     connection);
            for (MultipkSelfReftable referencedObject : referencedMultipkSelfReftableList)
            {
                ObjectKey foreignKey = referencedObject.getForeignKeyForMultipkSelfReftableRelatedByParentCol1ParentCol2();
                List<MultipkSelfReftable> objectsWithForeignKey 
                    = fkToMultipkSelfReftableMap.get(foreignKey);
                if (objectsWithForeignKey == null)
                {
                    objectsWithForeignKey = new ArrayList<MultipkSelfReftable>();
                    fkToMultipkSelfReftableMap.put(
                        foreignKey,
                        objectsWithForeignKey);
                }
                objectsWithForeignKey.add(referencedObject);
            }
            localKeyListChunk.clear();
        }

        List<MultipkSelfReftable> result = new ArrayList<MultipkSelfReftable>();
        for (MultipkSelfReftable objectToFill : toFill)
        {
            objectToFill.initMultipkSelfReftables();
            objectToFill.getMultipkSelfReftables().clear();
            ObjectKey localKey = objectToFill.getPrimaryKey();
            List<MultipkSelfReftable> referencingList
                = fkToMultipkSelfReftableMap.get(localKey);
            if (referencingList == null)
            {
                continue;
            }
            for (MultipkSelfReftable referencing : referencingList)
            {
                // copy the referencing object for the case that more than one
                // toFill object references the same object; in this case
                // every toFillObject should have its own instance 
                // of the referencing object to remain consistent
                // with other Torque referencing object treatment
                MultipkSelfReftable referencingCopy = referencing.copy(false);
                // copy does not set primary key
                referencingCopy.setPrimaryKey(referencing.getPrimaryKey());
                objectToFill.addMultipkSelfReftable(referencingCopy);
                result.add(referencingCopy);
            }
        }
        return result;
    }

    /** 
     * Returns the chunk size for the filler methods.
     *
     * @return the chunk size for the filler methods.
     */
    protected int getFillerChunkSize()
    {
        return 999;
    }


}
