package org.apache.torque.test;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.apache.torque.TorqueException;
import org.apache.torque.om.mapper.RecordMapper;

import org.apache.torque.test.NotUsedBeforeMapInitPeer;
    
/**
 * Maps ResultSet rows into NotUsedBeforeMapInit objects.
 *
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:47 CEST 2012]
 *
 */
public class BaseNotUsedBeforeMapInitRecordMapper implements RecordMapper<NotUsedBeforeMapInit>
{
    /**
     * Constructs the object from the current row in the resultSet.
     *
     * @param resultSet the resultSet to operate on, already pointing
     *        to the correct row. Not null.
     * @param a possible offset in the rows to be considered
     *        (if previous rows contain other objects).
     *
     * @return the mapped object, not null.
     *
     * @throws TorqueException when reading fields from the RecordSet fails.
     */
    public NotUsedBeforeMapInit processRow(ResultSet resultSet, int offset)
            throws TorqueException
    {
            String classKey =
                getClassName(resultSet, offset + 5);
            NotUsedBeforeMapInit notUsedBeforeMapInit;
            if (NotUsedBeforeMapInitPeer.CLASSKEY_B.equals(classKey))
            {
                notUsedBeforeMapInit = new MapInheritanceChildB();
            }
            else if (NotUsedBeforeMapInitPeer.CLASSKEY_C.equals(classKey))
            {
                notUsedBeforeMapInit = new MapInheritanceChildC();
            }
            else if (NotUsedBeforeMapInitPeer.CLASSKEY_D.equals(classKey))
            {
                notUsedBeforeMapInit = new MapInheritanceChildD();
            }
            else
            {
                notUsedBeforeMapInit = new NotUsedBeforeMapInit();
            }

        try 
        {
            notUsedBeforeMapInit.setLoading(true);
            notUsedBeforeMapInit.setId(
                    getId(resultSet, offset + 1));
            notUsedBeforeMapInit.setOne(
                    getOne(resultSet, offset + 2));
            notUsedBeforeMapInit.setTwo(
                    getTwo(resultSet, offset + 3));
            notUsedBeforeMapInit.setThree(
                    getThree(resultSet, offset + 4));
            notUsedBeforeMapInit.setClassName(
                    getClassName(resultSet, offset + 5));
            notUsedBeforeMapInit.setNew(false);
            notUsedBeforeMapInit.setModified(false);
        }
        finally
        {
            notUsedBeforeMapInit.setLoading(false);
        }
        return notUsedBeforeMapInit;
    }

        /**
         * Reads the value of the <code>columnIndex</code>'th column
         * in the <code>resultSet</code> so that it can be used to set
         * the field id in NotUsedBeforeMapInit.
         *
         * @param dbObject the database object to fill, not null.
         * @param resultSet the ResultSet to read from, not null.
         * @param columnIndex the index in the resultSet which should be read.
         *
         * @return the content of the column.
         *
         * @throws SQLException if a problem occurs when reading
         *         from the resultSet.
         */
        protected int getId(
                    ResultSet resultSet,
                    int columnIndex)
                throws TorqueException
        {
            try
            {
                return resultSet.getInt(columnIndex);
            }
            catch (SQLException e)
            {
                throw new TorqueException(e);
            }
        }

        /**
         * Reads the value of the <code>columnIndex</code>'th column
         * in the <code>resultSet</code> so that it can be used to set
         * the field one in NotUsedBeforeMapInit.
         *
         * @param dbObject the database object to fill, not null.
         * @param resultSet the ResultSet to read from, not null.
         * @param columnIndex the index in the resultSet which should be read.
         *
         * @return the content of the column.
         *
         * @throws SQLException if a problem occurs when reading
         *         from the resultSet.
         */
        protected String getOne(
                    ResultSet resultSet,
                    int columnIndex)
                throws TorqueException
        {
            try
            {
                return resultSet.getString(columnIndex);
            }
            catch (SQLException e)
            {
                throw new TorqueException(e);
            }
        }

        /**
         * Reads the value of the <code>columnIndex</code>'th column
         * in the <code>resultSet</code> so that it can be used to set
         * the field two in NotUsedBeforeMapInit.
         *
         * @param dbObject the database object to fill, not null.
         * @param resultSet the ResultSet to read from, not null.
         * @param columnIndex the index in the resultSet which should be read.
         *
         * @return the content of the column.
         *
         * @throws SQLException if a problem occurs when reading
         *         from the resultSet.
         */
        protected String getTwo(
                    ResultSet resultSet,
                    int columnIndex)
                throws TorqueException
        {
            try
            {
                return resultSet.getString(columnIndex);
            }
            catch (SQLException e)
            {
                throw new TorqueException(e);
            }
        }

        /**
         * Reads the value of the <code>columnIndex</code>'th column
         * in the <code>resultSet</code> so that it can be used to set
         * the field three in NotUsedBeforeMapInit.
         *
         * @param dbObject the database object to fill, not null.
         * @param resultSet the ResultSet to read from, not null.
         * @param columnIndex the index in the resultSet which should be read.
         *
         * @return the content of the column.
         *
         * @throws SQLException if a problem occurs when reading
         *         from the resultSet.
         */
        protected int getThree(
                    ResultSet resultSet,
                    int columnIndex)
                throws TorqueException
        {
            try
            {
                return resultSet.getInt(columnIndex);
            }
            catch (SQLException e)
            {
                throw new TorqueException(e);
            }
        }

        /**
         * Reads the value of the <code>columnIndex</code>'th column
         * in the <code>resultSet</code> so that it can be used to set
         * the field className in NotUsedBeforeMapInit.
         *
         * @param dbObject the database object to fill, not null.
         * @param resultSet the ResultSet to read from, not null.
         * @param columnIndex the index in the resultSet which should be read.
         *
         * @return the content of the column.
         *
         * @throws SQLException if a problem occurs when reading
         *         from the resultSet.
         */
        protected String getClassName(
                    ResultSet resultSet,
                    int columnIndex)
                throws TorqueException
        {
            try
            {
                return resultSet.getString(columnIndex);
            }
            catch (SQLException e)
            {
                throw new TorqueException(e);
            }
        }


}
