package org.apache.torque.test;

import java.io.Serializable;
import java.sql.Connection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.apache.torque.TorqueException;
import org.apache.torque.map.TableMap;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.BooleanKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.om.ColumnAccessByName;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.util.Transaction;
import org.apache.commons.lang.ObjectUtils;


/**
 * table containing null values to test datadump
 *
 * This class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:38 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to NullValueTable
 */
public abstract class BaseNullValueTable 
    implements Persistent, Serializable, ColumnAccessByName
{
    /** Serial version */
    private static final long serialVersionUID = 1347503738097L;



    /** Defines the nullValueTableId field. */
    private int nullValueTableId = 0;

    /** Defines the number1 field. */
    private int number1 = 0;

    /** Defines the number2 field. */
    private int number2 = 0;

    /** Defines the number3 field. */
    private int number3 = 0;

    /** Defines the text1 field. */
    private String text1 = null;

    /** Defines the text2 field. */
    private String text2 = null;

    /** Defines the numberObj1 field. */
    private Integer numberObj1 = null;

    /** Defines the numberObj2 field. */
    private Integer numberObj2 = null;

    /** Whether this object was modified after loading or after last save. */
    private boolean modified = true;

    /** 
     * Whether this object was loaded from the database or already saved 
     * (false) or whether it is not yet in the database(true).
     */
    private boolean isNew = true;

    /** Flag which indicates whether this object is currently saving. */
    private boolean saving = false;

    /** 
     * Flag which indicates whether this object is currently loaded
     * from the database. 
     */
    private boolean loading = false;

    /** 
     * Flag which indicates whether this object was deleted from the database.
     * Note that this flags does not always display the current database state,
     * there is no magical connection between this flag and the database.
     */
    private boolean deleted = false;





    /**
     * Get the value of nullValueTableId.
     *
     * @return int
     */
    public int getNullValueTableId() 
    {
        
        return nullValueTableId;
    }

    /**
     * Set the value of nullValueTableId.
     *
     * @param v new value
     */
    public void setNullValueTableId(int v)
    {
        if (this.nullValueTableId != v)
        {
            setModified(true);
        }

        this.nullValueTableId = v;


    }
    
    /**
     * Get the value of number1.
     *
     * @return int
     */
    public int getNumber1() 
    {
        
        return number1;
    }

    /**
     * Set the value of number1.
     *
     * @param v new value
     */
    public void setNumber1(int v)
    {
        if (this.number1 != v)
        {
            setModified(true);
        }

        this.number1 = v;


    }
    
    /**
     * Get the value of number2.
     *
     * @return int
     */
    public int getNumber2() 
    {
        
        return number2;
    }

    /**
     * Set the value of number2.
     *
     * @param v new value
     */
    public void setNumber2(int v)
    {
        if (this.number2 != v)
        {
            setModified(true);
        }

        this.number2 = v;


    }
    
    /**
     * Get the value of number3.
     *
     * @return int
     */
    public int getNumber3() 
    {
        
        return number3;
    }

    /**
     * Set the value of number3.
     *
     * @param v new value
     */
    public void setNumber3(int v)
    {
        if (this.number3 != v)
        {
            setModified(true);
        }

        this.number3 = v;


    }
    
    /**
     * Get the value of text1.
     *
     * @return String
     */
    public String getText1() 
    {
        
        return text1;
    }

    /**
     * Set the value of text1.
     *
     * @param v new value
     */
    public void setText1(String v)
    {
        if (!ObjectUtils.equals(this.text1, v))
        {
            setModified(true);
        }

        this.text1 = v;


    }
    
    /**
     * Get the value of text2.
     *
     * @return String
     */
    public String getText2() 
    {
        
        return text2;
    }

    /**
     * Set the value of text2.
     *
     * @param v new value
     */
    public void setText2(String v)
    {
        if (!ObjectUtils.equals(this.text2, v))
        {
            setModified(true);
        }

        this.text2 = v;


    }
    
    /**
     * Get the value of numberObj1.
     *
     * @return Integer
     */
    public Integer getNumberObj1() 
    {
        
        return numberObj1;
    }

    /**
     * Set the value of numberObj1.
     *
     * @param v new value
     */
    public void setNumberObj1(Integer v)
    {
        if (!ObjectUtils.equals(this.numberObj1, v))
        {
            setModified(true);
        }

        this.numberObj1 = v;


    }
    
    /**
     * Get the value of numberObj2.
     *
     * @return Integer
     */
    public Integer getNumberObj2() 
    {
        
        return numberObj2;
    }

    /**
     * Set the value of numberObj2.
     *
     * @param v new value
     */
    public void setNumberObj2(Integer v)
    {
        if (!ObjectUtils.equals(this.numberObj2, v))
        {
            setModified(true);
        }

        this.numberObj2 = v;


    }
    

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return true, if the object has never been persisted.
     */
    public boolean isNew()
    {
        return isNew;
    }

    /**
     * Sets whether the object has ever been saved.
     *
     * @param isNew true if the object has never been saved, false otherwise.
     */
    public void setNew(boolean isNew)
    {
        this.isNew = isNew;
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return True if the object has been modified.
     */
    public boolean isModified()
    {
        return modified;
    }

    /**
     * Sets whether the object has been modified.
     *
     * @param modified true if the object has been modified, false otherwise.
     */
    public void setModified(boolean modified)
    {
        this.modified = modified;
    }

    /**
     * Sets the modified state for the object to be false.
     */
    public void resetModified()
    {
        modified = false;
    }


    /**
     * Returns whether this object is currently saving.
     *
     * @return true if this object is currently saving, false otherwise.
     */
    public boolean isSaving()
    {
        return saving;
    }

    /**
     * Sets whether this object is currently saving.
     *
     * @param saving true if this object is currently saving, false otherwise.
     */
    public void setSaving(boolean saving)
    {
        this.saving = saving;
    }


    /**
     * Returns whether this object is currently being loaded from the database.
     *
     * @return true if this object is currently loading, false otherwise.
     */
    public boolean isLoading()
    {
        return loading;
    }

    /**
     * Sets whether this object is currently being loaded from the database.
     *
     * @param loading true if this object is currently loading, false otherwise.
     */
    public void setLoading(boolean loading)
    {
        this.loading = loading;
    }


    /**
     * Returns whether this object was deleted from the database.
     * Note that this getter does not automatically reflect database state,
     * it will be set to true by Torque if doDelete() was called with this 
     * object. Bulk deletes and deletes via primary key do not change
     * this flag. Also, if doDelete() was called on an object which does
     * not exist in the database, the deleted flag is set to true even if
     * it was not deleted.
     *
     * @return true if this object was deleted, false otherwise.
     */
    public boolean isDeleted()
    {
        return deleted;
    }

    /**
     * Sets whether this object was deleted from the database.
     *
     * @param deleted true if this object was deleted, false otherwise.
     */
    public void setDeleted(boolean deleted)
    {
        this.deleted = deleted;
    }







    private static final List<String> FIELD_NAMES;

    static
    {
        List<String> fieldNames
                = new ArrayList<String>();
        fieldNames.add("NullValueTableId");
        fieldNames.add("Number1");
        fieldNames.add("Number2");
        fieldNames.add("Number3");
        fieldNames.add("Text1");
        fieldNames.add("Text2");
        fieldNames.add("NumberObj1");
        fieldNames.add("NumberObj2");
        FIELD_NAMES = Collections.unmodifiableList(fieldNames);
    }

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static List<String> getFieldNames()
    {
        return FIELD_NAMES;
    }

    /**
     * Retrieves a field from the object by field (Java) name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
        if (name.equals("NullValueTableId"))
        {
            return new Integer(getNullValueTableId());
        }
        if (name.equals("Number1"))
        {
            return new Integer(getNumber1());
        }
        if (name.equals("Number2"))
        {
            return new Integer(getNumber2());
        }
        if (name.equals("Number3"))
        {
            return new Integer(getNumber3());
        }
        if (name.equals("Text1"))
        {
            return getText1();
        }
        if (name.equals("Text2"))
        {
            return getText2();
        }
        if (name.equals("NumberObj1"))
        {
            return getNumberObj1();
        }
        if (name.equals("NumberObj2"))
        {
            return getNumberObj2();
        }
        return null;
    }

    /**
     * Set a field in the object by field (Java) name.
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (name.equals("NullValueTableId"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setNullValueTableId(((Integer) value).intValue());
            return true;
        }
        if (name.equals("Number1"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setNumber1(((Integer) value).intValue());
            return true;
        }
        if (name.equals("Number2"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setNumber2(((Integer) value).intValue());
            return true;
        }
        if (name.equals("Number3"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setNumber3(((Integer) value).intValue());
            return true;
        }
        if (name.equals("Text1"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setText1((String) value);
            return true;
        }
        if (name.equals("Text2"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setText2((String) value);
            return true;
        }
        if (name.equals("NumberObj1"))
        {
            // Object fields can be null
            if (value != null && ! Integer.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setNumberObj1((Integer) value);
            return true;
        }
        if (name.equals("NumberObj2"))
        {
            // Object fields can be null
            if (value != null && ! Integer.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setNumberObj2((Integer) value);
            return true;
        }
        return false;
    }

    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
        if (name.equals(org.apache.torque.test.NullValueTablePeer.NULL_VALUE_TABLE_ID))
        {
            return new Integer(getNullValueTableId());
        }
        if (name.equals(org.apache.torque.test.NullValueTablePeer.NUMBER1))
        {
            return new Integer(getNumber1());
        }
        if (name.equals(org.apache.torque.test.NullValueTablePeer.NUMBER2))
        {
            return new Integer(getNumber2());
        }
        if (name.equals(org.apache.torque.test.NullValueTablePeer.NUMBER3))
        {
            return new Integer(getNumber3());
        }
        if (name.equals(org.apache.torque.test.NullValueTablePeer.TEXT1))
        {
            return getText1();
        }
        if (name.equals(org.apache.torque.test.NullValueTablePeer.TEXT2))
        {
            return getText2();
        }
        if (name.equals(org.apache.torque.test.NullValueTablePeer.NUMBER_OBJ1))
        {
            return getNumberObj1();
        }
        if (name.equals(org.apache.torque.test.NullValueTablePeer.NUMBER_OBJ2))
        {
            return getNumberObj2();
        }
        return null;
    }

    /**
     * Set field values by Peer Field Name
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPeerName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (org.apache.torque.test.NullValueTablePeer.NULL_VALUE_TABLE_ID.getSqlExpression().equals(name))
        {
            return setByName("NullValueTableId", value);
        }
        if (org.apache.torque.test.NullValueTablePeer.NUMBER1.getSqlExpression().equals(name))
        {
            return setByName("Number1", value);
        }
        if (org.apache.torque.test.NullValueTablePeer.NUMBER2.getSqlExpression().equals(name))
        {
            return setByName("Number2", value);
        }
        if (org.apache.torque.test.NullValueTablePeer.NUMBER3.getSqlExpression().equals(name))
        {
            return setByName("Number3", value);
        }
        if (org.apache.torque.test.NullValueTablePeer.TEXT1.getSqlExpression().equals(name))
        {
            return setByName("Text1", value);
        }
        if (org.apache.torque.test.NullValueTablePeer.TEXT2.getSqlExpression().equals(name))
        {
            return setByName("Text2", value);
        }
        if (org.apache.torque.test.NullValueTablePeer.NUMBER_OBJ1.getSqlExpression().equals(name))
        {
            return setByName("NumberObj1", value);
        }
        if (org.apache.torque.test.NullValueTablePeer.NUMBER_OBJ2.getSqlExpression().equals(name))
        {
            return setByName("NumberObj2", value);
        }
        return false;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
        if (pos == 0)
        {
            return new Integer(getNullValueTableId());
        }
        if (pos == 1)
        {
            return new Integer(getNumber1());
        }
        if (pos == 2)
        {
            return new Integer(getNumber2());
        }
        if (pos == 3)
        {
            return new Integer(getNumber3());
        }
        if (pos == 4)
        {
            return getText1();
        }
        if (pos == 5)
        {
            return getText2();
        }
        if (pos == 6)
        {
            return getNumberObj1();
        }
        if (pos == 7)
        {
            return getNumberObj2();
        }
        return null;
    }

    /**
     * Set field values by its position (zero based) in the XML schema.
     *
     * @param position The field position
     * @param value field value
     * @return True if value was set, false if not (invalid position / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPosition(int position, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (position == 0)
        {
            return setByName("NullValueTableId", value);
        }
        if (position == 1)
        {
            return setByName("Number1", value);
        }
        if (position == 2)
        {
            return setByName("Number2", value);
        }
        if (position == 3)
        {
            return setByName("Number3", value);
        }
        if (position == 4)
        {
            return setByName("Text1", value);
        }
        if (position == 5)
        {
            return setByName("Text2", value);
        }
        if (position == 6)
        {
            return setByName("NumberObj1", value);
        }
        if (position == 7)
        {
            return setByName("NumberObj2", value);
        }
        return false;
    }



    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save() throws TorqueException
    {
        save(NullValueTablePeer.DATABASE_NAME);
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     * @param dbName the name of the database to which the object
     *        should be saved.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(String dbName) 
            throws TorqueException
    {
        Connection con = null;
        try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally.
     *
     * @param toSave the object to be saved, not null.
     * @param con the connection to use for saving the object, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(Connection con) 
            throws TorqueException
    {
        if (isSaving())
        {
            return;
        }
        try
        {
            setSaving(true);
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    NullValueTablePeer.doInsert((NullValueTable) this, con);
                    setNew(false);
                }
                else
                {
                    NullValueTablePeer.doUpdate((NullValueTable) this, con);
                }
            }

        }
        finally
        {
            setSaving(false);
        }
    }




    /**
     * Set the PrimaryKey using ObjectKey.
     *
     * @param key nullValueTableId ObjectKey
     */
    public void setPrimaryKey(ObjectKey key)
        
    {
        setNullValueTableId(((NumberKey) key).intValue());
    }

    /**
     * Set the PrimaryKey using a String.
     *
     * @param key
     */
    public void setPrimaryKey(String key) 
    {
        setNullValueTableId(Integer.parseInt(key));
    }


    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        return SimpleKey.keyFor(getNullValueTableId());
    }



    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public NullValueTable copy() throws TorqueException
    {
        return copy(true);
    }

    /**
     * Makes a copy of this object using a connection.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     *
     * @param con the database connection to read associated objects.
     */
    public NullValueTable copy(Connection con) throws TorqueException
    {
        return copy(true, con);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     */
    public NullValueTable copy(boolean deepcopy) throws TorqueException
    {
        NullValueTable nullValueTable = new NullValueTable();

        return copyInto(nullValueTable, deepcopy);
    }

    /**
     * Makes a copy of this object using connection.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @param con the database connection to read associated objects.
     */
    public NullValueTable copy(boolean deepcopy, Connection con) throws TorqueException
    {
        NullValueTable nullValueTable = new NullValueTable();

        return copyInto(nullValueTable, deepcopy, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     */
    protected NullValueTable copyInto(NullValueTable copyObj) throws TorqueException
    {
        return copyInto(copyObj, true);
    }

    /**
     * Fills the copyObj with the contents of this object using connection.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param con the database connection to read associated objects.
     */
    protected NullValueTable copyInto(NullValueTable copyObj, Connection con) throws TorqueException
    {
        return copyInto(copyObj, true, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     */
    protected NullValueTable copyInto(NullValueTable copyObj, boolean deepcopy) throws TorqueException
    {
        copyObj.setNullValueTableId(0);
        copyObj.setNumber1(number1);
        copyObj.setNumber2(number2);
        copyObj.setNumber3(number3);
        copyObj.setText1(text1);
        copyObj.setText2(text2);
        copyObj.setNumberObj1(numberObj1);
        copyObj.setNumberObj2(numberObj2);

        if (deepcopy)
        {
        }
        return copyObj;
    }
        
    
    /**
     * Fills the copyObj with the contents of this object using connection.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @param con the database connection to read associated objects.
     */
    protected NullValueTable copyInto(NullValueTable copyObj, boolean deepcopy, Connection con) throws TorqueException
    {
        copyObj.setNullValueTableId(0);
        copyObj.setNumber1(number1);
        copyObj.setNumber2(number2);
        copyObj.setNumber3(number3);
        copyObj.setText1(text1);
        copyObj.setText2(text2);
        copyObj.setNumberObj1(numberObj1);
        copyObj.setNumberObj2(numberObj2);

        if (deepcopy)
        {
        }
        return copyObj;
    }

    /** The Peer class */
    private static final org.apache.torque.test.NullValueTablePeer peer
            = new org.apache.torque.test.NullValueTablePeer();

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public org.apache.torque.test.NullValueTablePeer getPeer()
    {
        return peer;
    }

    /**
     * Retrieves the TableMap object related to this Table data without
     * compiler warnings of using getPeer().getTableMap().
     *
     * @return The associated TableMap object.
     */
    public TableMap getTableMap() throws TorqueException
    {
        return org.apache.torque.test.NullValueTablePeer.getTableMap();
    }



    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("NullValueTable:\n");
        str.append("nullValueTableId = ")
           .append(getNullValueTableId())
           .append("\n");
        str.append("number1 = ")
           .append(getNumber1())
           .append("\n");
        str.append("number2 = ")
           .append(getNumber2())
           .append("\n");
        str.append("number3 = ")
           .append(getNumber3())
           .append("\n");
        str.append("text1 = ")
           .append(getText1())
           .append("\n");
        str.append("text2 = ")
           .append(getText2())
           .append("\n");
        str.append("numberObj1 = ")
           .append(getNumberObj1())
           .append("\n");
        str.append("numberObj2 = ")
           .append(getNumberObj2())
           .append("\n");
        return(str.toString());
    }

    /**
     * Compares the primary key of this instance with the key of another.
     *
     * @param toCompare The object to compare to.
     * @return Whether the primary keys are equal and the object have the
     *         same class.
     */
    public boolean equals(Object toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!getClass().equals(toCompare.getClass()))
        {
            return false;
        }
        NullValueTable other = (NullValueTable) toCompare;
        if (getPrimaryKey() == null || other.getPrimaryKey() == null)
        {
            return false;
        }
        return getPrimaryKey().equals(other.getPrimaryKey());
    }

    /**
     * If the primary key is not <code>null</code>, return the hashcode of the
     * primary key.  Otherwise calls <code>Object.hashCode()</code>.
     *
     * @return an <code>int</code> value
     */
    public int hashCode()
    {
        ObjectKey ok = getPrimaryKey();
        if (ok == null)
        {
            return super.hashCode();
        }

        return ok.hashCode();
    }




}
