package org.apache.torque.test;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.torque.NoRowsException;
import org.apache.torque.TooManyRowsException;
import org.apache.torque.Column;
import org.apache.torque.Torque;
import org.apache.torque.TorqueException;
import org.apache.torque.TorqueRuntimeException;
import org.apache.torque.adapter.IDMethod;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.map.DatabaseMap;
import org.apache.torque.map.TableMap;
import org.apache.torque.map.ColumnMap;
import org.apache.torque.map.ForeignKeyMap;
import org.apache.torque.map.InheritanceMap;
import org.apache.torque.om.mapper.RecordMapper;
import org.apache.torque.om.mapper.CompositeMapper;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.util.BasePeer;
import org.apache.torque.util.Transaction;
import org.apache.torque.util.ColumnValues;
import org.apache.torque.util.JdbcTypedValue;



/**
 * table containing null values to test datadump
 *
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:42 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to NullValueTablePeer
 */
@SuppressWarnings({"unused", "unchecked"})
public abstract class BaseNullValueTablePeer
{
    /** The class log. */
    private static Log log = LogFactory.getLog(BaseNullValueTablePeerImpl.class);
    /** Serial version */
    private static final long serialVersionUID = 1347503742426L;


    /** The default database name for this class. */
    public static final String DATABASE_NAME;

     /** The table name for this class. */
    public static final String TABLE_NAME;

     /** The table map for this class. */
    public static final TableMap TABLE;
    /** The column for the NULL_VALUE_TABLE_ID field */
    public static final ColumnMap NULL_VALUE_TABLE_ID;
    /** The column for the number1 field */
    public static final ColumnMap NUMBER1;
    /** The column for the number2 field */
    public static final ColumnMap NUMBER2;
    /** The column for the number3 field */
    public static final ColumnMap NUMBER3;
    /** The column for the text1 field */
    public static final ColumnMap TEXT1;
    /** The column for the text2 field */
    public static final ColumnMap TEXT2;
    /** The column for the number_obj1 field */
    public static final ColumnMap NUMBER_OBJ1;
    /** The column for the number_obj2 field */
    public static final ColumnMap NUMBER_OBJ2;

    /** number of columns for this peer */
    public static final int numColumns = 8;


    /** The implementation of the peer. */
    private static NullValueTablePeerImpl nullValueTablePeerImpl;


    static
    {
        DatabaseMap dbMap = Torque.getOrCreateDatabase("bookstore")
                .getDatabaseMap();
        if (dbMap.getTable("NULL_VALUE_TABLE") == null)
        {
            dbMap.addTable("NULL_VALUE_TABLE");
        }
        DATABASE_NAME = "bookstore";
        TABLE_NAME = "NULL_VALUE_TABLE";

        TABLE = dbMap.getTable("NULL_VALUE_TABLE");
        TABLE.setJavaName("NullValueTable");
        TABLE.setOMClass(org.apache.torque.test.NullValueTable.class);
        TABLE.setPeerClass(org.apache.torque.test.NullValueTablePeer.class);
        TABLE.setDescription("table containing null values to test datadump");
        TABLE.setPrimaryKeyMethod(IDMethod.NATIVE);
        TABLE.setPrimaryKeyMethodInfo(IDMethod.ID_BROKER, TABLE.getName());
        TABLE.setPrimaryKeyMethodInfo(IDMethod.SEQUENCE, "NULL_VALUE_TABLE_SEQ");
        TABLE.setPrimaryKeyMethodInfo(IDMethod.AUTO_INCREMENT, "NULL_VALUE_TABLE");
        TABLE.setUseInheritance(true);


    // ------------- Column: NULL_VALUE_TABLE_ID --------------------
        NULL_VALUE_TABLE_ID = new ColumnMap("NULL_VALUE_TABLE_ID", TABLE);
        NULL_VALUE_TABLE_ID.setType(Integer.valueOf(0));
        NULL_VALUE_TABLE_ID.setTorqueType("INTEGER");
        NULL_VALUE_TABLE_ID.setUsePrimitive(true);
        NULL_VALUE_TABLE_ID.setPrimaryKey(true);
        NULL_VALUE_TABLE_ID.setNotNull(true);
        NULL_VALUE_TABLE_ID.setJavaName("NullValueTableId");
        NULL_VALUE_TABLE_ID.setAutoIncrement(true);
        NULL_VALUE_TABLE_ID.setProtected(false);
        NULL_VALUE_TABLE_ID.setJavaType( "int" );
        NULL_VALUE_TABLE_ID.setPosition(1);
        TABLE.addColumn(NULL_VALUE_TABLE_ID);
    // ------------- Column: number1 --------------------
        NUMBER1 = new ColumnMap("number1", TABLE);
        NUMBER1.setType(Integer.valueOf(0));
        NUMBER1.setTorqueType("INTEGER");
        NUMBER1.setUsePrimitive(true);
        NUMBER1.setPrimaryKey(false);
        NUMBER1.setNotNull(false);
        NUMBER1.setJavaName("Number1");
        NUMBER1.setAutoIncrement(true);
        NUMBER1.setProtected(false);
        NUMBER1.setJavaType( "int" );
        NUMBER1.setPosition(2);
        TABLE.addColumn(NUMBER1);
    // ------------- Column: number2 --------------------
        NUMBER2 = new ColumnMap("number2", TABLE);
        NUMBER2.setType(Integer.valueOf(0));
        NUMBER2.setTorqueType("INTEGER");
        NUMBER2.setUsePrimitive(true);
        NUMBER2.setPrimaryKey(false);
        NUMBER2.setNotNull(false);
        NUMBER2.setJavaName("Number2");
        NUMBER2.setAutoIncrement(true);
        NUMBER2.setProtected(false);
        NUMBER2.setJavaType( "int" );
        NUMBER2.setPosition(3);
        TABLE.addColumn(NUMBER2);
    // ------------- Column: number3 --------------------
        NUMBER3 = new ColumnMap("number3", TABLE);
        NUMBER3.setType(Integer.valueOf(0));
        NUMBER3.setTorqueType("INTEGER");
        NUMBER3.setUsePrimitive(true);
        NUMBER3.setPrimaryKey(false);
        NUMBER3.setNotNull(false);
        NUMBER3.setJavaName("Number3");
        NUMBER3.setAutoIncrement(true);
        NUMBER3.setProtected(false);
        NUMBER3.setJavaType( "int" );
        NUMBER3.setPosition(4);
        TABLE.addColumn(NUMBER3);
    // ------------- Column: text1 --------------------
        TEXT1 = new ColumnMap("text1", TABLE);
        TEXT1.setType("");
        TEXT1.setTorqueType("VARCHAR");
        TEXT1.setUsePrimitive(false);
        TEXT1.setPrimaryKey(false);
        TEXT1.setNotNull(false);
        TEXT1.setJavaName("Text1");
        TEXT1.setAutoIncrement(true);
        TEXT1.setProtected(false);
        TEXT1.setJavaType( "String" );
        TEXT1.setSize(20);
        TEXT1.setPosition(5);
        TABLE.addColumn(TEXT1);
    // ------------- Column: text2 --------------------
        TEXT2 = new ColumnMap("text2", TABLE);
        TEXT2.setType("");
        TEXT2.setTorqueType("VARCHAR");
        TEXT2.setUsePrimitive(false);
        TEXT2.setPrimaryKey(false);
        TEXT2.setNotNull(false);
        TEXT2.setJavaName("Text2");
        TEXT2.setAutoIncrement(true);
        TEXT2.setProtected(false);
        TEXT2.setJavaType( "String" );
        TEXT2.setSize(20);
        TEXT2.setPosition(6);
        TABLE.addColumn(TEXT2);
    // ------------- Column: number_obj1 --------------------
        NUMBER_OBJ1 = new ColumnMap("number_obj1", TABLE);
        NUMBER_OBJ1.setType(Integer.valueOf(0));
        NUMBER_OBJ1.setTorqueType("INTEGER");
        NUMBER_OBJ1.setUsePrimitive(false);
        NUMBER_OBJ1.setPrimaryKey(false);
        NUMBER_OBJ1.setNotNull(false);
        NUMBER_OBJ1.setJavaName("NumberObj1");
        NUMBER_OBJ1.setAutoIncrement(true);
        NUMBER_OBJ1.setProtected(false);
        NUMBER_OBJ1.setJavaType( "Integer" );
        NUMBER_OBJ1.setPosition(7);
        TABLE.addColumn(NUMBER_OBJ1);
    // ------------- Column: number_obj2 --------------------
        NUMBER_OBJ2 = new ColumnMap("number_obj2", TABLE);
        NUMBER_OBJ2.setType(Integer.valueOf(0));
        NUMBER_OBJ2.setTorqueType("INTEGER");
        NUMBER_OBJ2.setUsePrimitive(false);
        NUMBER_OBJ2.setPrimaryKey(false);
        NUMBER_OBJ2.setNotNull(false);
        NUMBER_OBJ2.setJavaName("NumberObj2");
        NUMBER_OBJ2.setAutoIncrement(true);
        NUMBER_OBJ2.setProtected(false);
        NUMBER_OBJ2.setJavaType( "Integer" );
        NUMBER_OBJ2.setPosition(8);
        TABLE.addColumn(NUMBER_OBJ2);



        initDatabaseMap();
    }

    /**
     * Creates a new instance of the  implementation of the peer.
     *
     * @return the new instance.
     */
    protected static NullValueTablePeerImpl createNullValueTablePeerImpl()
    {
        NullValueTablePeerImpl instance = new NullValueTablePeerImpl();
        return instance;
    }


    /**
     * Returns an instance of the implementation of the peer.
     * If no instance is currently cached, a new instance is created and cached.
     *
     * @return an instance of the implementation of the peer, not null.
     */
    public static NullValueTablePeerImpl getNullValueTablePeerImpl()
    {
        NullValueTablePeerImpl peerImplInstance = nullValueTablePeerImpl;
        if (peerImplInstance == null)
        {
            peerImplInstance = NullValueTablePeer.createNullValueTablePeerImpl();
            nullValueTablePeerImpl = peerImplInstance;
        }
        return peerImplInstance;
    }



    /**
     * Sets the instance of the implementation of the peer.
     *
     * @param an instance of the implementation of the peer, or null
     *        if a new instance should be created automatically.
     */
    public static void setNullValueTablePeerImpl(NullValueTablePeerImpl peerImplInstance)
    {
        nullValueTablePeerImpl = peerImplInstance;
    }


    /**
     * Get the list of objects for a ResultSet.  Please not that your
     * resultset MUST return columns in the right order.  You can use
     * getFieldNames() in BaseObject to get the correct sequence.
     *
     * @param resultSet the ResultSet
     * @return the list of objects
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<NullValueTable> resultSet2Objects(ResultSet resultSet)
            throws TorqueException
    {
        return getNullValueTablePeerImpl().resultSet2Objects(resultSet);
    }

    /**
     * Add all the columns needed to create a new object.
     *
     * @param criteria object containing the columns to add.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void addSelectColumns(Criteria criteria)
            throws TorqueException
    {
        getNullValueTablePeerImpl().addSelectColumns(criteria);
    }

    /**
     * changes the boolean values in the criteria to the appropriate type,
     * whenever a booleanchar or booleanint column is involved.
     * This enables the user to create criteria using Boolean values
     * for booleanchar or booleanint columns.
     *
     * @param criteria the criteria in which the boolean values
     *        should be corrected.
     *
     * @throws TorqueException if the database map for the criteria cannot be 
               obtained.
     */
    public static void correctBooleans(Criteria criteria) throws TorqueException
    {
        getNullValueTablePeerImpl().correctBooleans(criteria);
    }

    /**
     * Checks all columns in the criteria to see whether
     * booleanchar and booleanint columns are queried with a boolean.
     * If yes, the query values are mapped onto values the database
     * does understand, i.e. 0 and 1 for booleanints and N and Y for
     * booleanchar columns.
     *
     * @param columnValues The value to be checked for booleanint
     *        and booleanchar columns.
     * @throws TorqueException if the database map for the criteria cannot be
     *         retrieved.
     */
    public static void correctBooleans(
            ColumnValues columnValues)
        throws TorqueException
    {
        getNullValueTablePeerImpl().correctBooleans(columnValues);
    }
    
    /**
     * Selects NullValueTable objects from a database.
     *
     * @param criteria object used to create the SELECT statement.
     *
     * @return the list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<NullValueTable> doSelect(Criteria criteria)
            throws TorqueException
    {
        return getNullValueTablePeerImpl().doSelect(criteria);
    }

    /**
     * Selects NullValueTable objects from a database
     * within a transaction.
     *
     * @param criteria object used to create the SELECT statement.
     * @param connection the connection holding the transaction, not null.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<NullValueTable> doSelect(
                Criteria criteria,
                Connection connection)
            throws TorqueException
    {
        return getNullValueTablePeerImpl().doSelect(criteria, connection);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                Criteria criteria,
                RecordMapper<T> mapper)
            throws TorqueException
    {
        return getNullValueTablePeerImpl().doSelect(criteria, mapper);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection for selecting records,
     *        not null.
     *
     * @return The results of the query, not null.
     * @throws TorqueException Error performing database query.
     */
    public static <T> List<T> doSelect(
            Criteria criteria,
            RecordMapper<T> mapper,
            Connection connection)
        throws TorqueException
    {
        return getNullValueTablePeerImpl().doSelect(
                criteria,
                mapper,
                connection);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param query the sql query to execute, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param dbName The name of the database to create the connection for,
     *        or null for the default SDB.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                String query,
                RecordMapper<T> mapper,
                String dbName)
            throws TorqueException
    {
        return getNullValueTablePeerImpl().doSelect(
                query,
                mapper,
                dbName);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param query the SQL Query to execute, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection, not null.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                String query,
                RecordMapper<T> mapper,
                Connection connection)
            throws TorqueException
    {
        return getNullValueTablePeerImpl().doSelect(
                query,
                mapper,
                connection);
    }

    /**
     * Selects NullValueTable objects from the database which have
     * the same content as the passed object.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<NullValueTable> doSelect(NullValueTable obj)
            throws TorqueException
    {
        return getNullValueTablePeerImpl().doSelect(obj);
    }

    /**
     * Selects at most one NullValueTable object from a database.
     *
     * @param criteria object used to create the SELECT statement.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static NullValueTable doSelectSingleRecord(
                Criteria criteria)
            throws TorqueException
    {
        return getNullValueTablePeerImpl().doSelectSingleRecord(criteria);
    }

    /**
     * Selects at most one NullValueTable object from a database
     * within a transaction.
     *
     * @param criteria object used to create the SELECT statement.
     * @param connection the connection holding the transaction, not null.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static NullValueTable doSelectSingleRecord(
                Criteria criteria,
                Connection connection)
            throws TorqueException
    {
        return getNullValueTablePeerImpl().doSelectSingleRecord(criteria, connection);
    }

    /**
     * Selects at most a single row from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     *
     * @return The selected row, or null if no records was selected.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> T doSelectSingleRecord(
                org.apache.torque.criteria.Criteria criteria,
                RecordMapper<T> mapper)
            throws TorqueException
    {
        return getNullValueTablePeerImpl().doSelectSingleRecord(
                criteria,
                mapper);
    }

    /**
     * Selects at most a single row from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection, not null.
     *
     * @return The selected row, or null if no records was selected.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> T doSelectSingleRecord(
                org.apache.torque.criteria.Criteria criteria,
                RecordMapper<T> mapper,
                Connection connection)
            throws TorqueException
    {
        return getNullValueTablePeerImpl().doSelectSingleRecord(
                criteria,
                mapper,
                connection);
    }

    /**
     * Selects at most one NullValueTable object from the database
     * which has the same content as the passed object.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static NullValueTable doSelectSingleRecord(
                NullValueTable obj)
            throws TorqueException
    {
        return getNullValueTablePeerImpl().doSelectSingleRecord(obj);
    }


    /**
     * Returns a new instance of the Data object class
     */
    public static NullValueTable getDbObjectInstance()
    {
        return getNullValueTablePeerImpl().getDbObjectInstance();
    }


    /**
     * Method to do inserts.
     *
     * @param columnValues the values to insert.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static ObjectKey doInsert(ColumnValues columnValues) 
            throws TorqueException
    {
        return getNullValueTablePeerImpl().doInsert(columnValues);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(Criteria) method.
     *
     * @param columnValues the values to insert.
     * @param con the connection to use, not null.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static ObjectKey doInsert(ColumnValues columnValues, Connection con)
            throws TorqueException
    {
        return getNullValueTablePeerImpl().doInsert(columnValues, con);
    }
    /**
     * Method to do inserts
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void doInsert(NullValueTable obj)
            throws TorqueException
    {
        getNullValueTablePeerImpl().doInsert(obj);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(NullValueTable) method.  It will take
     * care of the connection details internally.
     *
     * @param obj the data object to insert into the database.
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void doInsert(NullValueTable obj, Connection con)
            throws TorqueException
    {
        getNullValueTablePeerImpl().doInsert(obj, con);
    }

    /**
     * Method to do updates.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(ColumnValues columnValues) throws TorqueException
    {
        return getNullValueTablePeerImpl().doUpdate(columnValues);
    }

    /**
     * Method to do updates.  This method is to be used during a transaction,
     * otherwise use the doUpdate(Criteria) method.  It will take care of
     * the connection details internally.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @param con the connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        return getNullValueTablePeerImpl().doUpdate(columnValues, con);
    }

    /**
     * Executes an update against the database. The rows to be updated
     * are selected using <code>criteria</code> and updated using the values
     * in <code>updateValues</code>.
     *
     * @param criteria selects which rows of which table should be updated.
     * @param updateValues Which columns to update with which values, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException if updating fails.
     */
    public static int doUpdate(
                Criteria selectCriteria,
                ColumnValues updateValues)
            throws TorqueException
    {
        return getNullValueTablePeerImpl().doUpdate(
            selectCriteria,
            updateValues);
    }

    /**
     * Executes an update against the database. The rows to be updated
     * are selected using <code>criteria</code> and updated using the values
     * in <code>updateValues</code>.
     *
     * @param criteria selects which rows of which table should be updated.
     * @param updateValues Which columns to update with which values, not null.
     * @param connection the database connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException if updating fails.
     */
    public static int doUpdate(
                Criteria criteria,
                ColumnValues updateValues,
                Connection connection)
            throws TorqueException
    {
        return getNullValueTablePeerImpl().doUpdate(
            criteria,
             updateValues,
              connection);
    }

    /**
     * Updates an NullValueTable in the database.
     * The primary key is used to identify the object to update.
     *
     * @param obj the data object to update in the database.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(NullValueTable obj) throws TorqueException
    {
        return getNullValueTablePeerImpl().doUpdate(obj);
    }

    /**
     * Updates a NullValueTable in the database.
     * The primary key is used to identify the object to update.
     * This method is to be used during a transaction,
     * otherwise the doUpdate(NullValueTable) method can be used.
     *
     * @param obj the data object to update in the database.
     * @param con the connection to use, not null.
     
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(NullValueTable obj, Connection con)
        throws TorqueException
    {
        return getNullValueTablePeerImpl().doUpdate(obj, con);
    }

    /**
     * Utility method which executes a given SQL statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the SQL statement to execute.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString)
            throws TorqueException
    {
        return getNullValueTablePeerImpl().executeStatement(statementString);
    }

    /**
     * Utility method which executes a given sql statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the sql statement to execute.
     * @param dbName Name of database to connect to.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString, String dbName)
            throws TorqueException
    {
        return getNullValueTablePeerImpl().executeStatement(statementString, dbName);
    }

    /**
     * Utility method which executes a given sql statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the sql statement to execute.
     * @param con A Connection.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString, Connection con)
            throws TorqueException
    {
        return getNullValueTablePeerImpl().executeStatement(statementString, con);
    }

    /**
     * Deletes rows from a database table.
     *
     * @param criteria defines the rows to be deleted, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
     public static int doDelete(Criteria criteria) throws TorqueException
     {
        return getNullValueTablePeerImpl().doDelete(criteria);
     }

    /**
     * Deletes rows from a table.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
    *
     * @param criteria defines the rows to be deleted, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
     public static int doDelete(Criteria criteria, Connection con)
        throws TorqueException
     {
        return getNullValueTablePeerImpl().doDelete(criteria, con);
     }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     *
     * @param obj the data object to delete in the database, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(NullValueTable obj) throws TorqueException
    {
        return getNullValueTablePeerImpl().doDelete(obj);
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param obj the data object to delete in the database, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(NullValueTable obj, Connection con)
        throws TorqueException
    {
        return getNullValueTablePeerImpl().doDelete(obj, con);
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     *
     * @param objects the datas object to delete in the database, not null,
     *        may not contain null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(Collection<NullValueTable> objects)
            throws TorqueException
    {
        return getNullValueTablePeerImpl().doDelete(objects);
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param objects the datas object to delete in the database, not null,
     *        may not contain null.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(
            Collection<NullValueTable> objects,
            Connection con)
        throws TorqueException
    {
        return getNullValueTablePeerImpl().doDelete(objects, con);
    }

    /**
     * Deletes a row in the database.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(ObjectKey pk) throws TorqueException
    {
        return getNullValueTablePeerImpl().doDelete(pk);
    }

    /**
     * Deletes a row in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(ObjectKey pk, Connection con)
        throws TorqueException
    {
        return getNullValueTablePeerImpl().doDelete(pk, con);
    }

    /** 
     * Build a Criteria object which selects all objects which have a given
     * primary key.
     *
     * @param pk the primary key value to build the criteria from, not null.
     */
    public static Criteria buildCriteria(ObjectKey pk)
    {
        return getNullValueTablePeerImpl().buildCriteria(pk);
    }

    /** 
     * Build a Criteria object which selects all objects which primary keys
     * are contained in the passed collection.
     *
     * @param pks the primary key values to build the criteria from, not null,
     *        may not contain null.
     */
    public static Criteria buildCriteria(Collection<ObjectKey> pks)
    {
        return getNullValueTablePeerImpl().buildCriteria(pks);
    }

    /** 
     * Build a Criteria object which selects all passed objects using their
     * primary key. Objects which do not yet have a primary key are ignored.
     *
     * @param objects the objects to build the criteria from, not null,
     *        may not contain null.
     */
    public static Criteria buildPkCriteria(
            Collection<NullValueTable> objects)
    {
        return getNullValueTablePeerImpl().buildPkCriteria(objects);
    }

    /** 
     * Build a Criteria object from the data object for this peer.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public static Criteria buildCriteria(NullValueTable obj)
    {
        return getNullValueTablePeerImpl().buildCriteria(obj);
    }

    /** 
     * Build a Criteria object from the data object for this peer,
     * skipping all binary columns.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public static Criteria buildSelectCriteria(NullValueTable obj)
    {
        return getNullValueTablePeerImpl().buildSelectCriteria(obj);
    }

    /** 
     * Returns the contents of the object as ColumnValues object
     *
     * @throws TorqueException if the table map cannot be retrieved
     *         (should not happen).
     */
    public static ColumnValues buildColumnValues(NullValueTable nullValueTable)
            throws TorqueException
    {
        
        return getNullValueTablePeerImpl().buildColumnValues(nullValueTable);
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public static NullValueTable retrieveByPK(int pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return getNullValueTablePeerImpl().retrieveByPK(pk);
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public static NullValueTable retrieveByPK(int pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return getNullValueTablePeerImpl().retrieveByPK(pk, con);
    }
    
    
    

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public static NullValueTable retrieveByPK(ObjectKey pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return getNullValueTablePeerImpl().retrieveByPK(pk);
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public static NullValueTable retrieveByPK(ObjectKey pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return getNullValueTablePeerImpl().retrieveByPK(pk, con);
    }


    /**
     * Retrieve a multiple objects by pk
     *
     * @param pks List of primary keys
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<NullValueTable> retrieveByPKs(Collection<ObjectKey> pks)
        throws TorqueException
    {
        return getNullValueTablePeerImpl().retrieveByPKs(pks);
    }

    /**
     * Retrieve multiple objects by pk
     *
     * @param pks List of primary keys
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<NullValueTable> retrieveByPKs(Collection<ObjectKey> pks, Connection con)
        throws TorqueException
    {
        return getNullValueTablePeerImpl().retrieveByPKs(pks,con);
    }






    /** 
     * Returns the chunk size for the filler methods.
     *
     * @return the chunk size for the filler methods.
     */
    protected static int getFillerChunkSize()
    {
        return getNullValueTablePeerImpl().getFillerChunkSize();
    }

    /**
     * Returns the TableMap related to this peer.
     *
     * @return the table map, not null.
     *
     * @throws TorqueException if the Peer instance does not hold a Table map.
     */
    public static TableMap getTableMap()
        throws TorqueException
    {
        return getNullValueTablePeerImpl().getTableMap();
    }

    public static void initDatabaseMap()
    {
        BaseBookstoreDatabaseMapInit.init();
    }


}
