package org.apache.torque.test;

import java.io.Serializable;
import java.sql.Connection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.apache.torque.TorqueException;
import org.apache.torque.map.TableMap;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.BooleanKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.om.ColumnAccessByName;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.util.Transaction;
import org.apache.commons.lang.ObjectUtils;


/**
 * table with a object integer pk
 *
 * This class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:39 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to OIntegerPk
 */
public abstract class BaseOIntegerPk 
    implements Persistent, Serializable, ColumnAccessByName
{
    /** Serial version */
    private static final long serialVersionUID = 1347503739089L;



    /** Defines the id field. */
    private Integer id = null;

    /** Defines the integerColumn field. */
    private Integer integerColumn = null;

    /** Defines the name field. */
    private String name = null;

    /** Whether this object was modified after loading or after last save. */
    private boolean modified = true;

    /** 
     * Whether this object was loaded from the database or already saved 
     * (false) or whether it is not yet in the database(true).
     */
    private boolean isNew = true;

    /** Flag which indicates whether this object is currently saving. */
    private boolean saving = false;

    /** 
     * Flag which indicates whether this object is currently loaded
     * from the database. 
     */
    private boolean loading = false;

    /** 
     * Flag which indicates whether this object was deleted from the database.
     * Note that this flags does not always display the current database state,
     * there is no magical connection between this flag and the database.
     */
    private boolean deleted = false;



    /** Defines the collNullableOIntegerFks field. */
    protected List<NullableOIntegerFk> collNullableOIntegerFks = null;

    /** Defines the collRequiredOIntegerFks field. */
    protected List<RequiredOIntegerFk> collRequiredOIntegerFks = null;

    /** Defines the collOIntegerFkWithDefaults field. */
    protected List<OIntegerFkWithDefault> collOIntegerFkWithDefaults = null;

    /** Defines the collNonPkOIntegerFks field. */
    protected List<NonPkOIntegerFk> collNonPkOIntegerFks = null;

    /** Defines the collPIntegerFkToOPks field. */
    protected List<PIntegerFkToOPk> collPIntegerFkToOPks = null;



    /**
     * Get the value of id.
     *
     * @return Integer
     */
    public Integer getId() 
    {
        
        return id;
    }

    /**
     * Set the value of id.
     *
     * @param v new value
     */
    public void setId(Integer v)
    {
        if (!ObjectUtils.equals(this.id, v))
        {
            setModified(true);
        }

        this.id = v;

        // update associated objects in collNullableOIntegerFks 
        if (collNullableOIntegerFks != null)
        {
            for (int i = 0; i < collNullableOIntegerFks.size(); i++)
            {
                ((NullableOIntegerFk) collNullableOIntegerFks.get(i))
                        .setFk(v);
            }
        }
        // update associated objects in collRequiredOIntegerFks 
        if (collRequiredOIntegerFks != null)
        {
            for (int i = 0; i < collRequiredOIntegerFks.size(); i++)
            {
                ((RequiredOIntegerFk) collRequiredOIntegerFks.get(i))
                        .setFk(v);
            }
        }
        // update associated objects in collOIntegerFkWithDefaults 
        if (collOIntegerFkWithDefaults != null)
        {
            for (int i = 0; i < collOIntegerFkWithDefaults.size(); i++)
            {
                ((OIntegerFkWithDefault) collOIntegerFkWithDefaults.get(i))
                        .setFk(v);
            }
        }
        // update associated objects in collPIntegerFkToOPks 
        if (collPIntegerFkToOPks != null)
        {
            for (int i = 0; i < collPIntegerFkToOPks.size(); i++)
            {
                ((PIntegerFkToOPk) collPIntegerFkToOPks.get(i))
                        .setFk(v);
            }
        }

    }
    
    /**
     * Get the value of integerColumn.
     *
     * @return Integer
     */
    public Integer getIntegerColumn() 
    {
        
        return integerColumn;
    }

    /**
     * Set the value of integerColumn.
     *
     * @param v new value
     */
    public void setIntegerColumn(Integer v)
    {
        if (!ObjectUtils.equals(this.integerColumn, v))
        {
            setModified(true);
        }

        this.integerColumn = v;

        // update associated objects in collNonPkOIntegerFks 
        if (collNonPkOIntegerFks != null)
        {
            for (int i = 0; i < collNonPkOIntegerFks.size(); i++)
            {
                ((NonPkOIntegerFk) collNonPkOIntegerFks.get(i))
                        .setFk(v);
            }
        }

    }
    
    /**
     * Get the value of name.
     *
     * @return String
     */
    public String getName() 
    {
        
        return name;
    }

    /**
     * Set the value of name.
     *
     * @param v new value
     */
    public void setName(String v)
    {
        if (!ObjectUtils.equals(this.name, v))
        {
            setModified(true);
        }

        this.name = v;


    }
    

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return true, if the object has never been persisted.
     */
    public boolean isNew()
    {
        return isNew;
    }

    /**
     * Sets whether the object has ever been saved.
     *
     * @param isNew true if the object has never been saved, false otherwise.
     */
    public void setNew(boolean isNew)
    {
        this.isNew = isNew;
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return True if the object has been modified.
     */
    public boolean isModified()
    {
        return modified;
    }

    /**
     * Sets whether the object has been modified.
     *
     * @param modified true if the object has been modified, false otherwise.
     */
    public void setModified(boolean modified)
    {
        this.modified = modified;
    }

    /**
     * Sets the modified state for the object to be false.
     */
    public void resetModified()
    {
        modified = false;
    }


    /**
     * Returns whether this object is currently saving.
     *
     * @return true if this object is currently saving, false otherwise.
     */
    public boolean isSaving()
    {
        return saving;
    }

    /**
     * Sets whether this object is currently saving.
     *
     * @param saving true if this object is currently saving, false otherwise.
     */
    public void setSaving(boolean saving)
    {
        this.saving = saving;
    }


    /**
     * Returns whether this object is currently being loaded from the database.
     *
     * @return true if this object is currently loading, false otherwise.
     */
    public boolean isLoading()
    {
        return loading;
    }

    /**
     * Sets whether this object is currently being loaded from the database.
     *
     * @param loading true if this object is currently loading, false otherwise.
     */
    public void setLoading(boolean loading)
    {
        this.loading = loading;
    }


    /**
     * Returns whether this object was deleted from the database.
     * Note that this getter does not automatically reflect database state,
     * it will be set to true by Torque if doDelete() was called with this 
     * object. Bulk deletes and deletes via primary key do not change
     * this flag. Also, if doDelete() was called on an object which does
     * not exist in the database, the deleted flag is set to true even if
     * it was not deleted.
     *
     * @return true if this object was deleted, false otherwise.
     */
    public boolean isDeleted()
    {
        return deleted;
    }

    /**
     * Sets whether this object was deleted from the database.
     *
     * @param deleted true if this object was deleted, false otherwise.
     */
    public void setDeleted(boolean deleted)
    {
        this.deleted = deleted;
    }




    /**
     * Initializes the cache collNullableOIntegerFks for referenced objects. 
     */
    public void initNullableOIntegerFks()
    {
        if (collNullableOIntegerFks == null)
        {
            collNullableOIntegerFks = new ArrayList<NullableOIntegerFk>();
        }
    }

    /**
     * Checks whether the cache collNullableOIntegerFks for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isNullableOIntegerFksInitialized()
    {
        return (collNullableOIntegerFks != null);
    }


    /**
     * Method called to associate a NullableOIntegerFk object to this object
     * through the collNullableOIntegerFks foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addNullableOIntegerFk(NullableOIntegerFk toAdd)
        throws TorqueException
    {
        toAdd.setOIntegerPk((OIntegerPk) this);
        getNullableOIntegerFks().add(toAdd);
    }

    /**
     * Method called to associate a NullableOIntegerFk object to this object
     * through the collNullableOIntegerFks foreign key attribute using connection.
     *
     * @param l NullableOIntegerFk
     * @throws TorqueException
     */
    public void addNullableOIntegerFk(NullableOIntegerFk l, Connection con) throws TorqueException
    {
        getNullableOIntegerFks(con).add(l);
        l.setOIntegerPk((OIntegerPk) this);
    }
    
    /**
     * The criteria used to select the current contents of collNullableOIntegerFks
     */
    private Criteria lastNullableOIntegerFkCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getNullableOIntegerFks(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<NullableOIntegerFk> getNullableOIntegerFks()
        throws TorqueException
    {
        if (collNullableOIntegerFks == null)
        {
            collNullableOIntegerFks = getNullableOIntegerFks(new Criteria());
        }
        return collNullableOIntegerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseOIntegerPk has previously
     * been saved, it will retrieve related collNullableOIntegerFks from storage.
     * If this BaseOIntegerPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<NullableOIntegerFk> getNullableOIntegerFks(Criteria criteria) throws TorqueException
    {
        if (collNullableOIntegerFks == null)
        {
            if (isNew())
            {
               initNullableOIntegerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.NullableOIntegerFkPeer.FK, getId() );
                collNullableOIntegerFks = org.apache.torque.test.NullableOIntegerFkPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.NullableOIntegerFkPeer.FK, getId() );
                if (lastNullableOIntegerFkCriteria == null 
                        || !lastNullableOIntegerFkCriteria.equals(criteria))
                {
                    collNullableOIntegerFks = org.apache.torque.test.NullableOIntegerFkPeer.doSelect(criteria);
                }
            }
        }
        lastNullableOIntegerFkCriteria = criteria;

        return collNullableOIntegerFks;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getNullableOIntegerFks(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<NullableOIntegerFk> getNullableOIntegerFks(Connection con) throws TorqueException
    {
        if (collNullableOIntegerFks == null)
        {
            collNullableOIntegerFks = getNullableOIntegerFks(new Criteria(), con);
        }
        return collNullableOIntegerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseOIntegerPk has previously
     * been saved, it will retrieve the related NullableOIntegerFk Objects 
     * from storage.
     * If this BaseOIntegerPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<NullableOIntegerFk> getNullableOIntegerFks(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collNullableOIntegerFks == null)
        {
            if (isNew())
            {
               initNullableOIntegerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.NullableOIntegerFkPeer.FK, getId());
                collNullableOIntegerFks = org.apache.torque.test.NullableOIntegerFkPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.NullableOIntegerFkPeer.FK, getId());
                if (!lastNullableOIntegerFkCriteria.equals(criteria))
                {
                    collNullableOIntegerFks = org.apache.torque.test.NullableOIntegerFkPeer.doSelect(criteria, con);
                }
            }
        }
        lastNullableOIntegerFkCriteria = criteria;

        return collNullableOIntegerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseOIntegerPk is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<NullableOIntegerFk> getNullableOIntegerFksJoinOIntegerPk(Criteria criteria) throws TorqueException
    {
        return getNullableOIntegerFksJoinOIntegerPk(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseOIntegerPk is new, it will return
     * an empty collection; or if this BaseOIntegerPk has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<NullableOIntegerFk> getNullableOIntegerFksJoinOIntegerPk(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collNullableOIntegerFks == null)
        {
            if (isNew())
            {
                initNullableOIntegerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.NullableOIntegerFkPeer.FK, getId() );
                collNullableOIntegerFks = org.apache.torque.test.NullableOIntegerFkPeer.doSelectJoinOIntegerPk(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.NullableOIntegerFkPeer.FK, getId() );
            if (!lastNullableOIntegerFkCriteria.equals(criteria))
            {
                collNullableOIntegerFks = org.apache.torque.test.NullableOIntegerFkPeer.doSelectJoinOIntegerPk(criteria, connection);
            }
        }
        lastNullableOIntegerFkCriteria = criteria;

        return collNullableOIntegerFks;
    }

    /**
     * Initializes the cache collRequiredOIntegerFks for referenced objects. 
     */
    public void initRequiredOIntegerFks()
    {
        if (collRequiredOIntegerFks == null)
        {
            collRequiredOIntegerFks = new ArrayList<RequiredOIntegerFk>();
        }
    }

    /**
     * Checks whether the cache collRequiredOIntegerFks for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isRequiredOIntegerFksInitialized()
    {
        return (collRequiredOIntegerFks != null);
    }


    /**
     * Method called to associate a RequiredOIntegerFk object to this object
     * through the collRequiredOIntegerFks foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addRequiredOIntegerFk(RequiredOIntegerFk toAdd)
        throws TorqueException
    {
        toAdd.setOIntegerPk((OIntegerPk) this);
        getRequiredOIntegerFks().add(toAdd);
    }

    /**
     * Method called to associate a RequiredOIntegerFk object to this object
     * through the collRequiredOIntegerFks foreign key attribute using connection.
     *
     * @param l RequiredOIntegerFk
     * @throws TorqueException
     */
    public void addRequiredOIntegerFk(RequiredOIntegerFk l, Connection con) throws TorqueException
    {
        getRequiredOIntegerFks(con).add(l);
        l.setOIntegerPk((OIntegerPk) this);
    }
    
    /**
     * The criteria used to select the current contents of collRequiredOIntegerFks
     */
    private Criteria lastRequiredOIntegerFkCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getRequiredOIntegerFks(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<RequiredOIntegerFk> getRequiredOIntegerFks()
        throws TorqueException
    {
        if (collRequiredOIntegerFks == null)
        {
            collRequiredOIntegerFks = getRequiredOIntegerFks(new Criteria());
        }
        return collRequiredOIntegerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseOIntegerPk has previously
     * been saved, it will retrieve related collRequiredOIntegerFks from storage.
     * If this BaseOIntegerPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<RequiredOIntegerFk> getRequiredOIntegerFks(Criteria criteria) throws TorqueException
    {
        if (collRequiredOIntegerFks == null)
        {
            if (isNew())
            {
               initRequiredOIntegerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.RequiredOIntegerFkPeer.FK, getId() );
                collRequiredOIntegerFks = org.apache.torque.test.RequiredOIntegerFkPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.RequiredOIntegerFkPeer.FK, getId() );
                if (lastRequiredOIntegerFkCriteria == null 
                        || !lastRequiredOIntegerFkCriteria.equals(criteria))
                {
                    collRequiredOIntegerFks = org.apache.torque.test.RequiredOIntegerFkPeer.doSelect(criteria);
                }
            }
        }
        lastRequiredOIntegerFkCriteria = criteria;

        return collRequiredOIntegerFks;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getRequiredOIntegerFks(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<RequiredOIntegerFk> getRequiredOIntegerFks(Connection con) throws TorqueException
    {
        if (collRequiredOIntegerFks == null)
        {
            collRequiredOIntegerFks = getRequiredOIntegerFks(new Criteria(), con);
        }
        return collRequiredOIntegerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseOIntegerPk has previously
     * been saved, it will retrieve the related RequiredOIntegerFk Objects 
     * from storage.
     * If this BaseOIntegerPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<RequiredOIntegerFk> getRequiredOIntegerFks(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collRequiredOIntegerFks == null)
        {
            if (isNew())
            {
               initRequiredOIntegerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.RequiredOIntegerFkPeer.FK, getId());
                collRequiredOIntegerFks = org.apache.torque.test.RequiredOIntegerFkPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.RequiredOIntegerFkPeer.FK, getId());
                if (!lastRequiredOIntegerFkCriteria.equals(criteria))
                {
                    collRequiredOIntegerFks = org.apache.torque.test.RequiredOIntegerFkPeer.doSelect(criteria, con);
                }
            }
        }
        lastRequiredOIntegerFkCriteria = criteria;

        return collRequiredOIntegerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseOIntegerPk is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<RequiredOIntegerFk> getRequiredOIntegerFksJoinOIntegerPk(Criteria criteria) throws TorqueException
    {
        return getRequiredOIntegerFksJoinOIntegerPk(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseOIntegerPk is new, it will return
     * an empty collection; or if this BaseOIntegerPk has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<RequiredOIntegerFk> getRequiredOIntegerFksJoinOIntegerPk(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collRequiredOIntegerFks == null)
        {
            if (isNew())
            {
                initRequiredOIntegerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.RequiredOIntegerFkPeer.FK, getId() );
                collRequiredOIntegerFks = org.apache.torque.test.RequiredOIntegerFkPeer.doSelectJoinOIntegerPk(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.RequiredOIntegerFkPeer.FK, getId() );
            if (!lastRequiredOIntegerFkCriteria.equals(criteria))
            {
                collRequiredOIntegerFks = org.apache.torque.test.RequiredOIntegerFkPeer.doSelectJoinOIntegerPk(criteria, connection);
            }
        }
        lastRequiredOIntegerFkCriteria = criteria;

        return collRequiredOIntegerFks;
    }

    /**
     * Initializes the cache collOIntegerFkWithDefaults for referenced objects. 
     */
    public void initOIntegerFkWithDefaults()
    {
        if (collOIntegerFkWithDefaults == null)
        {
            collOIntegerFkWithDefaults = new ArrayList<OIntegerFkWithDefault>();
        }
    }

    /**
     * Checks whether the cache collOIntegerFkWithDefaults for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isOIntegerFkWithDefaultsInitialized()
    {
        return (collOIntegerFkWithDefaults != null);
    }


    /**
     * Method called to associate a OIntegerFkWithDefault object to this object
     * through the collOIntegerFkWithDefaults foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addOIntegerFkWithDefault(OIntegerFkWithDefault toAdd)
        throws TorqueException
    {
        toAdd.setOIntegerPk((OIntegerPk) this);
        getOIntegerFkWithDefaults().add(toAdd);
    }

    /**
     * Method called to associate a OIntegerFkWithDefault object to this object
     * through the collOIntegerFkWithDefaults foreign key attribute using connection.
     *
     * @param l OIntegerFkWithDefault
     * @throws TorqueException
     */
    public void addOIntegerFkWithDefault(OIntegerFkWithDefault l, Connection con) throws TorqueException
    {
        getOIntegerFkWithDefaults(con).add(l);
        l.setOIntegerPk((OIntegerPk) this);
    }
    
    /**
     * The criteria used to select the current contents of collOIntegerFkWithDefaults
     */
    private Criteria lastOIntegerFkWithDefaultCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getOIntegerFkWithDefaults(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<OIntegerFkWithDefault> getOIntegerFkWithDefaults()
        throws TorqueException
    {
        if (collOIntegerFkWithDefaults == null)
        {
            collOIntegerFkWithDefaults = getOIntegerFkWithDefaults(new Criteria());
        }
        return collOIntegerFkWithDefaults;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseOIntegerPk has previously
     * been saved, it will retrieve related collOIntegerFkWithDefaults from storage.
     * If this BaseOIntegerPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<OIntegerFkWithDefault> getOIntegerFkWithDefaults(Criteria criteria) throws TorqueException
    {
        if (collOIntegerFkWithDefaults == null)
        {
            if (isNew())
            {
               initOIntegerFkWithDefaults();
            }
            else
            {
                criteria.and(org.apache.torque.test.OIntegerFkWithDefaultPeer.FK, getId() );
                collOIntegerFkWithDefaults = org.apache.torque.test.OIntegerFkWithDefaultPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.OIntegerFkWithDefaultPeer.FK, getId() );
                if (lastOIntegerFkWithDefaultCriteria == null 
                        || !lastOIntegerFkWithDefaultCriteria.equals(criteria))
                {
                    collOIntegerFkWithDefaults = org.apache.torque.test.OIntegerFkWithDefaultPeer.doSelect(criteria);
                }
            }
        }
        lastOIntegerFkWithDefaultCriteria = criteria;

        return collOIntegerFkWithDefaults;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getOIntegerFkWithDefaults(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<OIntegerFkWithDefault> getOIntegerFkWithDefaults(Connection con) throws TorqueException
    {
        if (collOIntegerFkWithDefaults == null)
        {
            collOIntegerFkWithDefaults = getOIntegerFkWithDefaults(new Criteria(), con);
        }
        return collOIntegerFkWithDefaults;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseOIntegerPk has previously
     * been saved, it will retrieve the related OIntegerFkWithDefault Objects 
     * from storage.
     * If this BaseOIntegerPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<OIntegerFkWithDefault> getOIntegerFkWithDefaults(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collOIntegerFkWithDefaults == null)
        {
            if (isNew())
            {
               initOIntegerFkWithDefaults();
            }
            else
            {
                criteria.and(org.apache.torque.test.OIntegerFkWithDefaultPeer.FK, getId());
                collOIntegerFkWithDefaults = org.apache.torque.test.OIntegerFkWithDefaultPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.OIntegerFkWithDefaultPeer.FK, getId());
                if (!lastOIntegerFkWithDefaultCriteria.equals(criteria))
                {
                    collOIntegerFkWithDefaults = org.apache.torque.test.OIntegerFkWithDefaultPeer.doSelect(criteria, con);
                }
            }
        }
        lastOIntegerFkWithDefaultCriteria = criteria;

        return collOIntegerFkWithDefaults;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseOIntegerPk is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<OIntegerFkWithDefault> getOIntegerFkWithDefaultsJoinOIntegerPk(Criteria criteria) throws TorqueException
    {
        return getOIntegerFkWithDefaultsJoinOIntegerPk(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseOIntegerPk is new, it will return
     * an empty collection; or if this BaseOIntegerPk has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<OIntegerFkWithDefault> getOIntegerFkWithDefaultsJoinOIntegerPk(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collOIntegerFkWithDefaults == null)
        {
            if (isNew())
            {
                initOIntegerFkWithDefaults();
            }
            else
            {
                criteria.and(org.apache.torque.test.OIntegerFkWithDefaultPeer.FK, getId() );
                collOIntegerFkWithDefaults = org.apache.torque.test.OIntegerFkWithDefaultPeer.doSelectJoinOIntegerPk(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.OIntegerFkWithDefaultPeer.FK, getId() );
            if (!lastOIntegerFkWithDefaultCriteria.equals(criteria))
            {
                collOIntegerFkWithDefaults = org.apache.torque.test.OIntegerFkWithDefaultPeer.doSelectJoinOIntegerPk(criteria, connection);
            }
        }
        lastOIntegerFkWithDefaultCriteria = criteria;

        return collOIntegerFkWithDefaults;
    }

    /**
     * Initializes the cache collNonPkOIntegerFks for referenced objects. 
     */
    public void initNonPkOIntegerFks()
    {
        if (collNonPkOIntegerFks == null)
        {
            collNonPkOIntegerFks = new ArrayList<NonPkOIntegerFk>();
        }
    }

    /**
     * Checks whether the cache collNonPkOIntegerFks for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isNonPkOIntegerFksInitialized()
    {
        return (collNonPkOIntegerFks != null);
    }


    /**
     * Method called to associate a NonPkOIntegerFk object to this object
     * through the collNonPkOIntegerFks foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addNonPkOIntegerFk(NonPkOIntegerFk toAdd)
        throws TorqueException
    {
        toAdd.setOIntegerPk((OIntegerPk) this);
        getNonPkOIntegerFks().add(toAdd);
    }

    /**
     * Method called to associate a NonPkOIntegerFk object to this object
     * through the collNonPkOIntegerFks foreign key attribute using connection.
     *
     * @param l NonPkOIntegerFk
     * @throws TorqueException
     */
    public void addNonPkOIntegerFk(NonPkOIntegerFk l, Connection con) throws TorqueException
    {
        getNonPkOIntegerFks(con).add(l);
        l.setOIntegerPk((OIntegerPk) this);
    }
    
    /**
     * The criteria used to select the current contents of collNonPkOIntegerFks
     */
    private Criteria lastNonPkOIntegerFkCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getNonPkOIntegerFks(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<NonPkOIntegerFk> getNonPkOIntegerFks()
        throws TorqueException
    {
        if (collNonPkOIntegerFks == null)
        {
            collNonPkOIntegerFks = getNonPkOIntegerFks(new Criteria());
        }
        return collNonPkOIntegerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseOIntegerPk has previously
     * been saved, it will retrieve related collNonPkOIntegerFks from storage.
     * If this BaseOIntegerPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<NonPkOIntegerFk> getNonPkOIntegerFks(Criteria criteria) throws TorqueException
    {
        if (collNonPkOIntegerFks == null)
        {
            if (isNew())
            {
               initNonPkOIntegerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.NonPkOIntegerFkPeer.FK, getIntegerColumn() );
                collNonPkOIntegerFks = org.apache.torque.test.NonPkOIntegerFkPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.NonPkOIntegerFkPeer.FK, getIntegerColumn() );
                if (lastNonPkOIntegerFkCriteria == null 
                        || !lastNonPkOIntegerFkCriteria.equals(criteria))
                {
                    collNonPkOIntegerFks = org.apache.torque.test.NonPkOIntegerFkPeer.doSelect(criteria);
                }
            }
        }
        lastNonPkOIntegerFkCriteria = criteria;

        return collNonPkOIntegerFks;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getNonPkOIntegerFks(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<NonPkOIntegerFk> getNonPkOIntegerFks(Connection con) throws TorqueException
    {
        if (collNonPkOIntegerFks == null)
        {
            collNonPkOIntegerFks = getNonPkOIntegerFks(new Criteria(), con);
        }
        return collNonPkOIntegerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseOIntegerPk has previously
     * been saved, it will retrieve the related NonPkOIntegerFk Objects 
     * from storage.
     * If this BaseOIntegerPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<NonPkOIntegerFk> getNonPkOIntegerFks(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collNonPkOIntegerFks == null)
        {
            if (isNew())
            {
               initNonPkOIntegerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.NonPkOIntegerFkPeer.FK, getIntegerColumn());
                collNonPkOIntegerFks = org.apache.torque.test.NonPkOIntegerFkPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.NonPkOIntegerFkPeer.FK, getIntegerColumn());
                if (!lastNonPkOIntegerFkCriteria.equals(criteria))
                {
                    collNonPkOIntegerFks = org.apache.torque.test.NonPkOIntegerFkPeer.doSelect(criteria, con);
                }
            }
        }
        lastNonPkOIntegerFkCriteria = criteria;

        return collNonPkOIntegerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseOIntegerPk is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<NonPkOIntegerFk> getNonPkOIntegerFksJoinOIntegerPk(Criteria criteria) throws TorqueException
    {
        return getNonPkOIntegerFksJoinOIntegerPk(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseOIntegerPk is new, it will return
     * an empty collection; or if this BaseOIntegerPk has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<NonPkOIntegerFk> getNonPkOIntegerFksJoinOIntegerPk(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collNonPkOIntegerFks == null)
        {
            if (isNew())
            {
                initNonPkOIntegerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.NonPkOIntegerFkPeer.FK, getIntegerColumn() );
                collNonPkOIntegerFks = org.apache.torque.test.NonPkOIntegerFkPeer.doSelectJoinOIntegerPk(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.NonPkOIntegerFkPeer.FK, getIntegerColumn() );
            if (!lastNonPkOIntegerFkCriteria.equals(criteria))
            {
                collNonPkOIntegerFks = org.apache.torque.test.NonPkOIntegerFkPeer.doSelectJoinOIntegerPk(criteria, connection);
            }
        }
        lastNonPkOIntegerFkCriteria = criteria;

        return collNonPkOIntegerFks;
    }

    /**
     * Initializes the cache collPIntegerFkToOPks for referenced objects. 
     */
    public void initPIntegerFkToOPks()
    {
        if (collPIntegerFkToOPks == null)
        {
            collPIntegerFkToOPks = new ArrayList<PIntegerFkToOPk>();
        }
    }

    /**
     * Checks whether the cache collPIntegerFkToOPks for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isPIntegerFkToOPksInitialized()
    {
        return (collPIntegerFkToOPks != null);
    }


    /**
     * Method called to associate a PIntegerFkToOPk object to this object
     * through the collPIntegerFkToOPks foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addPIntegerFkToOPk(PIntegerFkToOPk toAdd)
        throws TorqueException
    {
        toAdd.setOIntegerPk((OIntegerPk) this);
        getPIntegerFkToOPks().add(toAdd);
    }

    /**
     * Method called to associate a PIntegerFkToOPk object to this object
     * through the collPIntegerFkToOPks foreign key attribute using connection.
     *
     * @param l PIntegerFkToOPk
     * @throws TorqueException
     */
    public void addPIntegerFkToOPk(PIntegerFkToOPk l, Connection con) throws TorqueException
    {
        getPIntegerFkToOPks(con).add(l);
        l.setOIntegerPk((OIntegerPk) this);
    }
    
    /**
     * The criteria used to select the current contents of collPIntegerFkToOPks
     */
    private Criteria lastPIntegerFkToOPkCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getPIntegerFkToOPks(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<PIntegerFkToOPk> getPIntegerFkToOPks()
        throws TorqueException
    {
        if (collPIntegerFkToOPks == null)
        {
            collPIntegerFkToOPks = getPIntegerFkToOPks(new Criteria());
        }
        return collPIntegerFkToOPks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseOIntegerPk has previously
     * been saved, it will retrieve related collPIntegerFkToOPks from storage.
     * If this BaseOIntegerPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<PIntegerFkToOPk> getPIntegerFkToOPks(Criteria criteria) throws TorqueException
    {
        if (collPIntegerFkToOPks == null)
        {
            if (isNew())
            {
               initPIntegerFkToOPks();
            }
            else
            {
                criteria.and(org.apache.torque.test.PIntegerFkToOPkPeer.FK, getId() );
                collPIntegerFkToOPks = org.apache.torque.test.PIntegerFkToOPkPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.PIntegerFkToOPkPeer.FK, getId() );
                if (lastPIntegerFkToOPkCriteria == null 
                        || !lastPIntegerFkToOPkCriteria.equals(criteria))
                {
                    collPIntegerFkToOPks = org.apache.torque.test.PIntegerFkToOPkPeer.doSelect(criteria);
                }
            }
        }
        lastPIntegerFkToOPkCriteria = criteria;

        return collPIntegerFkToOPks;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getPIntegerFkToOPks(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<PIntegerFkToOPk> getPIntegerFkToOPks(Connection con) throws TorqueException
    {
        if (collPIntegerFkToOPks == null)
        {
            collPIntegerFkToOPks = getPIntegerFkToOPks(new Criteria(), con);
        }
        return collPIntegerFkToOPks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseOIntegerPk has previously
     * been saved, it will retrieve the related PIntegerFkToOPk Objects 
     * from storage.
     * If this BaseOIntegerPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<PIntegerFkToOPk> getPIntegerFkToOPks(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collPIntegerFkToOPks == null)
        {
            if (isNew())
            {
               initPIntegerFkToOPks();
            }
            else
            {
                criteria.and(org.apache.torque.test.PIntegerFkToOPkPeer.FK, getId());
                collPIntegerFkToOPks = org.apache.torque.test.PIntegerFkToOPkPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.PIntegerFkToOPkPeer.FK, getId());
                if (!lastPIntegerFkToOPkCriteria.equals(criteria))
                {
                    collPIntegerFkToOPks = org.apache.torque.test.PIntegerFkToOPkPeer.doSelect(criteria, con);
                }
            }
        }
        lastPIntegerFkToOPkCriteria = criteria;

        return collPIntegerFkToOPks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseOIntegerPk is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<PIntegerFkToOPk> getPIntegerFkToOPksJoinOIntegerPk(Criteria criteria) throws TorqueException
    {
        return getPIntegerFkToOPksJoinOIntegerPk(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseOIntegerPk is new, it will return
     * an empty collection; or if this BaseOIntegerPk has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<PIntegerFkToOPk> getPIntegerFkToOPksJoinOIntegerPk(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collPIntegerFkToOPks == null)
        {
            if (isNew())
            {
                initPIntegerFkToOPks();
            }
            else
            {
                criteria.and(org.apache.torque.test.PIntegerFkToOPkPeer.FK, getId() );
                collPIntegerFkToOPks = org.apache.torque.test.PIntegerFkToOPkPeer.doSelectJoinOIntegerPk(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.PIntegerFkToOPkPeer.FK, getId() );
            if (!lastPIntegerFkToOPkCriteria.equals(criteria))
            {
                collPIntegerFkToOPks = org.apache.torque.test.PIntegerFkToOPkPeer.doSelectJoinOIntegerPk(criteria, connection);
            }
        }
        lastPIntegerFkToOPkCriteria = criteria;

        return collPIntegerFkToOPks;
    }




    private static final List<String> FIELD_NAMES;

    static
    {
        List<String> fieldNames
                = new ArrayList<String>();
        fieldNames.add("Id");
        fieldNames.add("IntegerColumn");
        fieldNames.add("Name");
        FIELD_NAMES = Collections.unmodifiableList(fieldNames);
    }

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static List<String> getFieldNames()
    {
        return FIELD_NAMES;
    }

    /**
     * Retrieves a field from the object by field (Java) name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
        if (name.equals("Id"))
        {
            return getId();
        }
        if (name.equals("IntegerColumn"))
        {
            return getIntegerColumn();
        }
        if (name.equals("Name"))
        {
            return getName();
        }
        return null;
    }

    /**
     * Set a field in the object by field (Java) name.
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (name.equals("Id"))
        {
            // Object fields can be null
            if (value != null && ! Integer.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setId((Integer) value);
            return true;
        }
        if (name.equals("IntegerColumn"))
        {
            // Object fields can be null
            if (value != null && ! Integer.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setIntegerColumn((Integer) value);
            return true;
        }
        if (name.equals("Name"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setName((String) value);
            return true;
        }
        return false;
    }

    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
        if (name.equals(org.apache.torque.test.OIntegerPkPeer.ID))
        {
            return getId();
        }
        if (name.equals(org.apache.torque.test.OIntegerPkPeer.INTEGER_COLUMN))
        {
            return getIntegerColumn();
        }
        if (name.equals(org.apache.torque.test.OIntegerPkPeer.NAME))
        {
            return getName();
        }
        return null;
    }

    /**
     * Set field values by Peer Field Name
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPeerName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (org.apache.torque.test.OIntegerPkPeer.ID.getSqlExpression().equals(name))
        {
            return setByName("Id", value);
        }
        if (org.apache.torque.test.OIntegerPkPeer.INTEGER_COLUMN.getSqlExpression().equals(name))
        {
            return setByName("IntegerColumn", value);
        }
        if (org.apache.torque.test.OIntegerPkPeer.NAME.getSqlExpression().equals(name))
        {
            return setByName("Name", value);
        }
        return false;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
        if (pos == 0)
        {
            return getId();
        }
        if (pos == 1)
        {
            return getIntegerColumn();
        }
        if (pos == 2)
        {
            return getName();
        }
        return null;
    }

    /**
     * Set field values by its position (zero based) in the XML schema.
     *
     * @param position The field position
     * @param value field value
     * @return True if value was set, false if not (invalid position / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPosition(int position, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (position == 0)
        {
            return setByName("Id", value);
        }
        if (position == 1)
        {
            return setByName("IntegerColumn", value);
        }
        if (position == 2)
        {
            return setByName("Name", value);
        }
        return false;
    }



    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save() throws TorqueException
    {
        save(OIntegerPkPeer.DATABASE_NAME);
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     * @param dbName the name of the database to which the object
     *        should be saved.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(String dbName) 
            throws TorqueException
    {
        Connection con = null;
        try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally.
     *
     * @param toSave the object to be saved, not null.
     * @param con the connection to use for saving the object, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(Connection con) 
            throws TorqueException
    {
        if (isSaving())
        {
            return;
        }
        try
        {
            setSaving(true);
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    OIntegerPkPeer.doInsert((OIntegerPk) this, con);
                    setNew(false);
                }
                else
                {
                    OIntegerPkPeer.doUpdate((OIntegerPk) this, con);
                }
            }

            if (isNullableOIntegerFksInitialized())
            {
                for (NullableOIntegerFk collNullableOIntegerFks : getNullableOIntegerFks())
                {
                    collNullableOIntegerFks.save(con);
                }
            }
            if (isRequiredOIntegerFksInitialized())
            {
                for (RequiredOIntegerFk collRequiredOIntegerFks : getRequiredOIntegerFks())
                {
                    collRequiredOIntegerFks.save(con);
                }
            }
            if (isOIntegerFkWithDefaultsInitialized())
            {
                for (OIntegerFkWithDefault collOIntegerFkWithDefaults : getOIntegerFkWithDefaults())
                {
                    collOIntegerFkWithDefaults.save(con);
                }
            }
            if (isNonPkOIntegerFksInitialized())
            {
                for (NonPkOIntegerFk collNonPkOIntegerFks : getNonPkOIntegerFks())
                {
                    collNonPkOIntegerFks.save(con);
                }
            }
            if (isPIntegerFkToOPksInitialized())
            {
                for (PIntegerFkToOPk collPIntegerFkToOPks : getPIntegerFkToOPks())
                {
                    collPIntegerFkToOPks.save(con);
                }
            }
        }
        finally
        {
            setSaving(false);
        }
    }




    /**
     * Set the PrimaryKey using ObjectKey.
     *
     * @param key id ObjectKey
     */
    public void setPrimaryKey(ObjectKey key)
        
    {
        setId(Integer.valueOf(((NumberKey) key).intValue()));
    }

    /**
     * Set the PrimaryKey using a String.
     *
     * @param key
     */
    public void setPrimaryKey(String key) 
    {
        setId(new Integer(key));
    }


    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        return SimpleKey.keyFor(getId());
    }



    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public OIntegerPk copy() throws TorqueException
    {
        return copy(true);
    }

    /**
     * Makes a copy of this object using a connection.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     *
     * @param con the database connection to read associated objects.
     */
    public OIntegerPk copy(Connection con) throws TorqueException
    {
        return copy(true, con);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     */
    public OIntegerPk copy(boolean deepcopy) throws TorqueException
    {
        OIntegerPk oIntegerPk = new OIntegerPk();

        return copyInto(oIntegerPk, deepcopy);
    }

    /**
     * Makes a copy of this object using connection.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @param con the database connection to read associated objects.
     */
    public OIntegerPk copy(boolean deepcopy, Connection con) throws TorqueException
    {
        OIntegerPk oIntegerPk = new OIntegerPk();

        return copyInto(oIntegerPk, deepcopy, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     */
    protected OIntegerPk copyInto(OIntegerPk copyObj) throws TorqueException
    {
        return copyInto(copyObj, true);
    }

    /**
     * Fills the copyObj with the contents of this object using connection.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param con the database connection to read associated objects.
     */
    protected OIntegerPk copyInto(OIntegerPk copyObj, Connection con) throws TorqueException
    {
        return copyInto(copyObj, true, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     */
    protected OIntegerPk copyInto(OIntegerPk copyObj, boolean deepcopy) throws TorqueException
    {
        copyObj.setId((Integer) null);
        copyObj.setIntegerColumn(integerColumn);
        copyObj.setName(name);

        if (deepcopy)
        {
            if (collNullableOIntegerFks != null)
            {
                for (int i = 0; i < collNullableOIntegerFks.size(); i++)
                {
                    NullableOIntegerFk obj = collNullableOIntegerFks.get(i);
                    copyObj.addNullableOIntegerFk(obj.copy());
                }
            }
            else
            {
                copyObj.collNullableOIntegerFks = null;
            }
            if (collRequiredOIntegerFks != null)
            {
                for (int i = 0; i < collRequiredOIntegerFks.size(); i++)
                {
                    RequiredOIntegerFk obj = collRequiredOIntegerFks.get(i);
                    copyObj.addRequiredOIntegerFk(obj.copy());
                }
            }
            else
            {
                copyObj.collRequiredOIntegerFks = null;
            }
            if (collOIntegerFkWithDefaults != null)
            {
                for (int i = 0; i < collOIntegerFkWithDefaults.size(); i++)
                {
                    OIntegerFkWithDefault obj = collOIntegerFkWithDefaults.get(i);
                    copyObj.addOIntegerFkWithDefault(obj.copy());
                }
            }
            else
            {
                copyObj.collOIntegerFkWithDefaults = null;
            }
            if (collNonPkOIntegerFks != null)
            {
                for (int i = 0; i < collNonPkOIntegerFks.size(); i++)
                {
                    NonPkOIntegerFk obj = collNonPkOIntegerFks.get(i);
                    copyObj.addNonPkOIntegerFk(obj.copy());
                }
            }
            else
            {
                copyObj.collNonPkOIntegerFks = null;
            }
            if (collPIntegerFkToOPks != null)
            {
                for (int i = 0; i < collPIntegerFkToOPks.size(); i++)
                {
                    PIntegerFkToOPk obj = collPIntegerFkToOPks.get(i);
                    copyObj.addPIntegerFkToOPk(obj.copy());
                }
            }
            else
            {
                copyObj.collPIntegerFkToOPks = null;
            }
        }
        return copyObj;
    }
        
    
    /**
     * Fills the copyObj with the contents of this object using connection.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @param con the database connection to read associated objects.
     */
    protected OIntegerPk copyInto(OIntegerPk copyObj, boolean deepcopy, Connection con) throws TorqueException
    {
        copyObj.setId((Integer) null);
        copyObj.setIntegerColumn(integerColumn);
        copyObj.setName(name);

        if (deepcopy)
        {
            for (NullableOIntegerFk obj : getNullableOIntegerFks(con))
            {
                copyObj.addNullableOIntegerFk(obj.copy());
            }
            for (RequiredOIntegerFk obj : getRequiredOIntegerFks(con))
            {
                copyObj.addRequiredOIntegerFk(obj.copy());
            }
            for (OIntegerFkWithDefault obj : getOIntegerFkWithDefaults(con))
            {
                copyObj.addOIntegerFkWithDefault(obj.copy());
            }
            for (NonPkOIntegerFk obj : getNonPkOIntegerFks(con))
            {
                copyObj.addNonPkOIntegerFk(obj.copy());
            }
            for (PIntegerFkToOPk obj : getPIntegerFkToOPks(con))
            {
                copyObj.addPIntegerFkToOPk(obj.copy());
            }
        }
        return copyObj;
    }

    /** The Peer class */
    private static final org.apache.torque.test.OIntegerPkPeer peer
            = new org.apache.torque.test.OIntegerPkPeer();

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public org.apache.torque.test.OIntegerPkPeer getPeer()
    {
        return peer;
    }

    /**
     * Retrieves the TableMap object related to this Table data without
     * compiler warnings of using getPeer().getTableMap().
     *
     * @return The associated TableMap object.
     */
    public TableMap getTableMap() throws TorqueException
    {
        return org.apache.torque.test.OIntegerPkPeer.getTableMap();
    }



    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("OIntegerPk:\n");
        str.append("id = ")
           .append(getId())
           .append("\n");
        str.append("integerColumn = ")
           .append(getIntegerColumn())
           .append("\n");
        str.append("name = ")
           .append(getName())
           .append("\n");
        return(str.toString());
    }

    /**
     * Compares the primary key of this instance with the key of another.
     *
     * @param toCompare The object to compare to.
     * @return Whether the primary keys are equal and the object have the
     *         same class.
     */
    public boolean equals(Object toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!getClass().equals(toCompare.getClass()))
        {
            return false;
        }
        OIntegerPk other = (OIntegerPk) toCompare;
        if (getPrimaryKey() == null || other.getPrimaryKey() == null)
        {
            return false;
        }
        return getPrimaryKey().equals(other.getPrimaryKey());
    }

    /**
     * If the primary key is not <code>null</code>, return the hashcode of the
     * primary key.  Otherwise calls <code>Object.hashCode()</code>.
     *
     * @return an <code>int</code> value
     */
    public int hashCode()
    {
        ObjectKey ok = getPrimaryKey();
        if (ok == null)
        {
            return super.hashCode();
        }

        return ok.hashCode();
    }




}
