package org.apache.torque.test;

import java.sql.Blob;
import java.sql.Clob;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.sql.PreparedStatement;
import java.sql.Types;
import java.io.IOException;
import java.io.InputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.Reader;
import java.io.StringReader;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.torque.NoRowsException;
import org.apache.torque.TooManyRowsException;
import org.apache.torque.Torque;
import org.apache.torque.TorqueException;
import org.apache.torque.TorqueRuntimeException;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.criteria.Criterion;
import org.apache.torque.om.mapper.RecordMapper;
import org.apache.torque.om.mapper.CompositeMapper;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.ComboKey;
import org.apache.torque.map.TableMap;
import org.apache.torque.util.BasePeer;
import org.apache.torque.util.Transaction;
import org.apache.torque.util.ColumnValues;
import org.apache.torque.util.JdbcTypedValue;



/**
 * table with a object integer pk
 *
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:45 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to OIntegerPkPeer
 */

public abstract class BaseOIntegerPkPeerImpl
    extends org.apache.torque.util.BasePeerImpl<OIntegerPk>
{
    /** The class log. */
    private static Log log = LogFactory.getLog(BaseOIntegerPkPeerImpl.class);

    /** Serial version */
    private static final long serialVersionUID = 1347503745712L;



    /**
     * Constructor.
     * The recordMapper, tableMap and databaseName fields are correctly
     * initialized.
     */
    public BaseOIntegerPkPeerImpl()
    {
        this(new OIntegerPkRecordMapper(),
            OIntegerPkPeer.TABLE,
            OIntegerPkPeer.DATABASE_NAME);
    }

    /**
     * Constructor providing the objects to be injected as parameters.
     *
     * @param recordMapper a record mapper to map JDBC result sets to objects
     * @param tableMap the default table map
     * @param databaseName the name of the database
     */
    public BaseOIntegerPkPeerImpl(
            RecordMapper<OIntegerPk> recordMapper, 
            TableMap tableMap,
            String databaseName)
    {
        super(recordMapper, tableMap, databaseName);
    }


    /**
     * Selects OIntegerPk objects from the database which have
     * the same content as the passed object.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<OIntegerPk> doSelect(OIntegerPk obj)
            throws TorqueException
    {
        return doSelect(buildSelectCriteria(obj));
    }

    /**
     * Selects at most one OIntegerPk object from the database
     * which has the same content as the passed object.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public OIntegerPk doSelectSingleRecord(
                OIntegerPk obj)
            throws TorqueException
    {
        List<OIntegerPk> oIntegerPkList = doSelect(obj);
        OIntegerPk oIntegerPk = null;
        if (oIntegerPkList.size() > 1)
        {
            throw new TooManyRowsException("Object " + obj 
                + " matched more than one record");
        }
        if (!oIntegerPkList.isEmpty())
        {
            oIntegerPk = oIntegerPkList.get(0);
        }
        return oIntegerPk;
    }

    /**
     * Returns a new instance of the Data object class
     */
    public OIntegerPk getDbObjectInstance()
    {
        return new OIntegerPk();
    }


    /**
     * Method to do inserts.
     *
     * @param columnValues the values to insert.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public ObjectKey doInsert(ColumnValues columnValues) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    OIntegerPkPeer.DATABASE_NAME);
            ObjectKey result = doInsert(columnValues, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(Criteria) method.
     *
     * @param columnValues the values to insert.
     * @param con the connection to use, not null.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public ObjectKey doInsert(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        correctBooleans(columnValues);
        return super.doInsert(columnValues, con);
    }

    /**
     * Method to do inserts
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public void doInsert(OIntegerPk obj) throws TorqueException
    {
        obj.setPrimaryKey(doInsert(buildColumnValues(obj)));
        obj.setNew(false);
        obj.setModified(false);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(OIntegerPk) method.  It will take
     * care of the connection details internally.
     *
     * @param obj the data object to insert into the database.
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public void doInsert(OIntegerPk obj, Connection con)
        throws TorqueException
    {
        ObjectKey primaryKey = doInsert(buildColumnValues(obj), con);
        if (primaryKey != null)
        {
            obj.setPrimaryKey(primaryKey);
        }
        obj.setNew(false);
        obj.setModified(false);
    }

    /**
     * Method to do updates.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(ColumnValues columnValues) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    OIntegerPkPeer.DATABASE_NAME);
            int result = doUpdate(columnValues, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Method to do updates.  This method is to be used during a transaction,
     * otherwise use the doUpdate(Criteria) method.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @param con the connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        Criteria selectCriteria 
                = new Criteria(OIntegerPkPeer.DATABASE_NAME);
        correctBooleans(columnValues);


    
        selectCriteria.where(
                OIntegerPkPeer.ID,
                columnValues.remove(OIntegerPkPeer.ID).getValue());


        return doUpdate(selectCriteria, columnValues, con);
    }

    /**
     * Updates an OIntegerPk in the database.
     * The primary key is used to identify the object to update.
     *
     * @param obj the data object to update in the database.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(OIntegerPk obj) throws TorqueException
    {
        ColumnValues columnValues = buildColumnValues(obj);
        int result = doUpdate(columnValues);
        obj.setModified(false);
        return result;
    }

    /**
     * Updates a OIntegerPk in the database.
     * The primary key is used to identify the object to update.
     * This method is to be used during a transaction,
     * otherwise the doUpdate(OIntegerPk) method can be used.
     *
     * @param obj the data object to update in the database.
     * @param con the connection to use, not null.
     
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(OIntegerPk obj, Connection con)
        throws TorqueException
    {
        ColumnValues columnValues = buildColumnValues(obj);
        int result = doUpdate(columnValues, con);
        obj.setModified(false);
        return result;
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     *
     * @param obj the data object to delete in the database, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(OIntegerPk obj) throws TorqueException
    {
        int result = doDelete(buildCriteria(obj.getPrimaryKey()));
        obj.setDeleted(true);
        return result;
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     * This method is to be used during a transaction, otherwise use the
     * doDelete(OIntegerPk) method.
     *
     * @param obj the data object to delete in the database, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(OIntegerPk obj, Connection con)
        throws TorqueException
    {
        int result = doDelete(buildCriteria(obj.getPrimaryKey()), con);
        obj.setDeleted(true);
        return result;
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     *
     * @param objects the data object to delete in the database, not null,
     *        may not contain null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(Collection<OIntegerPk> objects)
            throws TorqueException
    {
        int result = doDelete(buildPkCriteria(objects));
        for (OIntegerPk object : objects)
        {
            object.setDeleted(true);
        }
        return result;
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param objects the data objects to delete in the database, not null,
     *        may not contain null.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(
            Collection<OIntegerPk> objects,
            Connection con)
        throws TorqueException
    {
        int result = doDelete(buildPkCriteria(objects), con);
        for (OIntegerPk object : objects)
        {
            object.setDeleted(true);
        }
        return result;
    }

    /**
     * Deletes a row in the database.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(ObjectKey pk) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    OIntegerPkPeer.DATABASE_NAME);
            int deletedRows = doDelete(pk, connection);
            Transaction.commit(connection);
            connection = null;
            return deletedRows;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Deletes a row in the database.
     * This method is to be used during a transaction,
     * otherwise use the doDelete(ObjectKey) method.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(ObjectKey pk, Connection con)
        throws TorqueException
    {
        return doDelete(buildCriteria(pk), con);
    }

    /** 
     * Build a Criteria object which selects all objects which have a given
     * primary key.
     *
     * @param pk the primary key value to build the criteria from, not null.
     */
    public Criteria buildCriteria(ObjectKey pk)
    {
        Criteria criteria = new Criteria();
        criteria.and(OIntegerPkPeer.ID, pk);
        return criteria;
     }

    /** 
     * Build a Criteria object which selects all objects which primary keys
     * are contained in the passed collection.
     *
     * @param pks the primary key values to build the criteria from, not null,
     *        may not contain null.
     */
    public Criteria buildCriteria(Collection<ObjectKey> pks)
    {
        Criteria criteria = new Criteria();
        criteria.andIn(OIntegerPkPeer.ID, pks);
        return criteria;
     }


    /** 
     * Build a Criteria object which selects all passed objects using their
     * primary key. Objects which do not yet have a primary key are ignored.
     *
     * @param objects the objects to build the criteria from, not null,
     *        may not contain null.
     */
    public Criteria buildPkCriteria(
            Collection<OIntegerPk> objects)
    {
        List<ObjectKey> pks = new ArrayList<ObjectKey>(objects.size());
        for (OIntegerPk object : objects)
        {
            ObjectKey pk = object.getPrimaryKey();
            if (pk != null)
            {
                pks.add(pk);
            }
        }
        return buildCriteria(pks);
    }

    /** 
     * Build a Criteria object from the data object for this peer.
     * The primary key columns are only added if the object is not new.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public Criteria buildCriteria(OIntegerPk obj)
    {
        Criteria criteria = new Criteria(OIntegerPkPeer.DATABASE_NAME);
        if (!obj.isNew())
        {
            criteria.and(OIntegerPkPeer.ID, obj.getId());
        }
        criteria.and(OIntegerPkPeer.INTEGER_COLUMN, obj.getIntegerColumn());
        criteria.and(OIntegerPkPeer.NAME, obj.getName());
        return criteria;
    }

    /** 
     * Build a Criteria object from the data object for this peer,
     * skipping all binary columns.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public Criteria buildSelectCriteria(OIntegerPk obj)
    {
        Criteria criteria = new Criteria(OIntegerPkPeer.DATABASE_NAME);
        if (!obj.isNew())
        {
            criteria.and(OIntegerPkPeer.ID, obj.getId());
        }
        criteria.and(OIntegerPkPeer.INTEGER_COLUMN, obj.getIntegerColumn());
        criteria.and(OIntegerPkPeer.NAME, obj.getName());
        return criteria;
    }

    /** 
     * Returns the contents of the object as ColumnValues object.
     * Primary key columns which are generated on insertion are not
     * added to the returned object if they still have their initial
     * value. Also, columns which have the useDatabaseDefaultValue
     * flag set to true are also not added to the returned object
     * if they still have their initial value.
     *
     * @throws TorqueException if the table map cannot be retrieved
     *         (should not happen).
     */
    public ColumnValues buildColumnValues(OIntegerPk oIntegerPk)
            throws TorqueException
    {
        ColumnValues columnValues = new ColumnValues();
        if (!oIntegerPk.isNew() 
            || oIntegerPk.getId() != null)
        {
            columnValues.put(
                    OIntegerPkPeer.ID,
                    new JdbcTypedValue(
                        oIntegerPk.getId(),
                        4));
        }
        columnValues.put(
                OIntegerPkPeer.INTEGER_COLUMN,
                new JdbcTypedValue(
                    oIntegerPk.getIntegerColumn(),
                    4));
        columnValues.put(
                OIntegerPkPeer.NAME,
                new JdbcTypedValue(
                    oIntegerPk.getName(),
                    12));
        return columnValues;
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public OIntegerPk retrieveByPK(Integer pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return retrieveByPK(SimpleKey.keyFor(pk));
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public OIntegerPk retrieveByPK(Integer pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return retrieveByPK(SimpleKey.keyFor(pk), con);
    }
    
    
    

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public OIntegerPk retrieveByPK(ObjectKey pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(OIntegerPkPeer.DATABASE_NAME);
            OIntegerPk result = retrieveByPK(pk, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public OIntegerPk retrieveByPK(ObjectKey pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        Criteria criteria = buildCriteria(pk);
        List<OIntegerPk> v = doSelect(criteria, con);
        if (v.size() == 0)
        {
            throw new NoRowsException("Failed to select a row.");
        }
        else if (v.size() > 1)
        {
            throw new TooManyRowsException("Failed to select only one row.");
        }
        else
        {
            return (OIntegerPk)v.get(0);
        }
    }


    /**
     * Retrieve a multiple objects by pk
     *
     * @param pks List of primary keys
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<OIntegerPk> retrieveByPKs(Collection<ObjectKey> pks)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(OIntegerPkPeer.DATABASE_NAME);
            List<OIntegerPk> result = retrieveByPKs(pks, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Retrieve multiple objects by pk
     *
     * @param pks List of primary keys
     * @param dbcon the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<OIntegerPk> retrieveByPKs(
                Collection<ObjectKey> pks,
                Connection dbcon)
            throws TorqueException
    {
        if (pks == null || pks.size() == 0)
        {
            return new ArrayList<OIntegerPk>();
        }
        Criteria criteria = buildCriteria(pks);
        List<OIntegerPk> result = doSelect(criteria, dbcon);
        return result;
    }





    /** 
     * Fills the referenced NullableOIntegerFk objects in the collNullableOIntegerFks fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     *
     * @return all read List<NullableOIntegerFk> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<NullableOIntegerFk> fillNullableOIntegerFks(
            Collection<OIntegerPk> toFill)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    OIntegerPkPeer.DATABASE_NAME);
            List<NullableOIntegerFk> result = fillNullableOIntegerFks(toFill, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /** 
     * Fills the referenced NullableOIntegerFk objects in the collNullableOIntegerFks fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read List<NullableOIntegerFk> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<NullableOIntegerFk> fillNullableOIntegerFks(
            Collection<OIntegerPk> toFill,
            Connection connection)
        throws TorqueException
    {
        Set<ObjectKey> localKeySet = new HashSet<ObjectKey>();
        for (OIntegerPk currentOIntegerPk : toFill)
        {
            ObjectKey localKey = currentOIntegerPk.getPrimaryKey();
            localKeySet.add(localKey);
        }

        int fillerChunkSize = getFillerChunkSize();
        Iterator<ObjectKey> localKeyIt = localKeySet.iterator();
        List<ObjectKey> localKeyListChunk
                = new ArrayList<ObjectKey>(fillerChunkSize);
        Map<ObjectKey, List<NullableOIntegerFk>> fkToNullableOIntegerFkMap
                = new HashMap<ObjectKey, List<NullableOIntegerFk>>();
        while (localKeyIt.hasNext())
        {
            ObjectKey currentKey = localKeyIt.next();
            localKeyListChunk.add(currentKey);
            if (localKeyListChunk.size() < fillerChunkSize
                && localKeyIt.hasNext())
            {
                continue;
            }

            Criteria criteria = new Criteria();
            criteria.andIn(NullableOIntegerFkPeer.FK, localKeyListChunk);
            List<NullableOIntegerFk> referencedNullableOIntegerFkList
                 = NullableOIntegerFkPeer.doSelect(
                     criteria,
                     connection);
            for (NullableOIntegerFk referencedObject : referencedNullableOIntegerFkList)
            {
                ObjectKey foreignKey = referencedObject.getForeignKeyForOIntegerPk();
                List<NullableOIntegerFk> objectsWithForeignKey 
                    = fkToNullableOIntegerFkMap.get(foreignKey);
                if (objectsWithForeignKey == null)
                {
                    objectsWithForeignKey = new ArrayList<NullableOIntegerFk>();
                    fkToNullableOIntegerFkMap.put(
                        foreignKey,
                        objectsWithForeignKey);
                }
                objectsWithForeignKey.add(referencedObject);
            }
            localKeyListChunk.clear();
        }

        List<NullableOIntegerFk> result = new ArrayList<NullableOIntegerFk>();
        for (OIntegerPk objectToFill : toFill)
        {
            objectToFill.initNullableOIntegerFks();
            objectToFill.getNullableOIntegerFks().clear();
            ObjectKey localKey = objectToFill.getPrimaryKey();
            List<NullableOIntegerFk> referencingList
                = fkToNullableOIntegerFkMap.get(localKey);
            if (referencingList == null)
            {
                continue;
            }
            for (NullableOIntegerFk referencing : referencingList)
            {
                // copy the referencing object for the case that more than one
                // toFill object references the same object; in this case
                // every toFillObject should have its own instance 
                // of the referencing object to remain consistent
                // with other Torque referencing object treatment
                NullableOIntegerFk referencingCopy = referencing.copy(false);
                // copy does not set primary key
                referencingCopy.setPrimaryKey(referencing.getPrimaryKey());
                objectToFill.addNullableOIntegerFk(referencingCopy);
                result.add(referencingCopy);
            }
        }
        return result;
    }
    /** 
     * Fills the referenced RequiredOIntegerFk objects in the collRequiredOIntegerFks fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     *
     * @return all read List<RequiredOIntegerFk> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<RequiredOIntegerFk> fillRequiredOIntegerFks(
            Collection<OIntegerPk> toFill)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    OIntegerPkPeer.DATABASE_NAME);
            List<RequiredOIntegerFk> result = fillRequiredOIntegerFks(toFill, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /** 
     * Fills the referenced RequiredOIntegerFk objects in the collRequiredOIntegerFks fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read List<RequiredOIntegerFk> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<RequiredOIntegerFk> fillRequiredOIntegerFks(
            Collection<OIntegerPk> toFill,
            Connection connection)
        throws TorqueException
    {
        Set<ObjectKey> localKeySet = new HashSet<ObjectKey>();
        for (OIntegerPk currentOIntegerPk : toFill)
        {
            ObjectKey localKey = currentOIntegerPk.getPrimaryKey();
            localKeySet.add(localKey);
        }

        int fillerChunkSize = getFillerChunkSize();
        Iterator<ObjectKey> localKeyIt = localKeySet.iterator();
        List<ObjectKey> localKeyListChunk
                = new ArrayList<ObjectKey>(fillerChunkSize);
        Map<ObjectKey, List<RequiredOIntegerFk>> fkToRequiredOIntegerFkMap
                = new HashMap<ObjectKey, List<RequiredOIntegerFk>>();
        while (localKeyIt.hasNext())
        {
            ObjectKey currentKey = localKeyIt.next();
            localKeyListChunk.add(currentKey);
            if (localKeyListChunk.size() < fillerChunkSize
                && localKeyIt.hasNext())
            {
                continue;
            }

            Criteria criteria = new Criteria();
            criteria.andIn(RequiredOIntegerFkPeer.FK, localKeyListChunk);
            List<RequiredOIntegerFk> referencedRequiredOIntegerFkList
                 = RequiredOIntegerFkPeer.doSelect(
                     criteria,
                     connection);
            for (RequiredOIntegerFk referencedObject : referencedRequiredOIntegerFkList)
            {
                ObjectKey foreignKey = referencedObject.getForeignKeyForOIntegerPk();
                List<RequiredOIntegerFk> objectsWithForeignKey 
                    = fkToRequiredOIntegerFkMap.get(foreignKey);
                if (objectsWithForeignKey == null)
                {
                    objectsWithForeignKey = new ArrayList<RequiredOIntegerFk>();
                    fkToRequiredOIntegerFkMap.put(
                        foreignKey,
                        objectsWithForeignKey);
                }
                objectsWithForeignKey.add(referencedObject);
            }
            localKeyListChunk.clear();
        }

        List<RequiredOIntegerFk> result = new ArrayList<RequiredOIntegerFk>();
        for (OIntegerPk objectToFill : toFill)
        {
            objectToFill.initRequiredOIntegerFks();
            objectToFill.getRequiredOIntegerFks().clear();
            ObjectKey localKey = objectToFill.getPrimaryKey();
            List<RequiredOIntegerFk> referencingList
                = fkToRequiredOIntegerFkMap.get(localKey);
            if (referencingList == null)
            {
                continue;
            }
            for (RequiredOIntegerFk referencing : referencingList)
            {
                // copy the referencing object for the case that more than one
                // toFill object references the same object; in this case
                // every toFillObject should have its own instance 
                // of the referencing object to remain consistent
                // with other Torque referencing object treatment
                RequiredOIntegerFk referencingCopy = referencing.copy(false);
                // copy does not set primary key
                referencingCopy.setPrimaryKey(referencing.getPrimaryKey());
                objectToFill.addRequiredOIntegerFk(referencingCopy);
                result.add(referencingCopy);
            }
        }
        return result;
    }
    /** 
     * Fills the referenced OIntegerFkWithDefault objects in the collOIntegerFkWithDefaults fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     *
     * @return all read List<OIntegerFkWithDefault> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<OIntegerFkWithDefault> fillOIntegerFkWithDefaults(
            Collection<OIntegerPk> toFill)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    OIntegerPkPeer.DATABASE_NAME);
            List<OIntegerFkWithDefault> result = fillOIntegerFkWithDefaults(toFill, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /** 
     * Fills the referenced OIntegerFkWithDefault objects in the collOIntegerFkWithDefaults fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read List<OIntegerFkWithDefault> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<OIntegerFkWithDefault> fillOIntegerFkWithDefaults(
            Collection<OIntegerPk> toFill,
            Connection connection)
        throws TorqueException
    {
        Set<ObjectKey> localKeySet = new HashSet<ObjectKey>();
        for (OIntegerPk currentOIntegerPk : toFill)
        {
            ObjectKey localKey = currentOIntegerPk.getPrimaryKey();
            localKeySet.add(localKey);
        }

        int fillerChunkSize = getFillerChunkSize();
        Iterator<ObjectKey> localKeyIt = localKeySet.iterator();
        List<ObjectKey> localKeyListChunk
                = new ArrayList<ObjectKey>(fillerChunkSize);
        Map<ObjectKey, List<OIntegerFkWithDefault>> fkToOIntegerFkWithDefaultMap
                = new HashMap<ObjectKey, List<OIntegerFkWithDefault>>();
        while (localKeyIt.hasNext())
        {
            ObjectKey currentKey = localKeyIt.next();
            localKeyListChunk.add(currentKey);
            if (localKeyListChunk.size() < fillerChunkSize
                && localKeyIt.hasNext())
            {
                continue;
            }

            Criteria criteria = new Criteria();
            criteria.andIn(OIntegerFkWithDefaultPeer.FK, localKeyListChunk);
            List<OIntegerFkWithDefault> referencedOIntegerFkWithDefaultList
                 = OIntegerFkWithDefaultPeer.doSelect(
                     criteria,
                     connection);
            for (OIntegerFkWithDefault referencedObject : referencedOIntegerFkWithDefaultList)
            {
                ObjectKey foreignKey = referencedObject.getForeignKeyForOIntegerPk();
                List<OIntegerFkWithDefault> objectsWithForeignKey 
                    = fkToOIntegerFkWithDefaultMap.get(foreignKey);
                if (objectsWithForeignKey == null)
                {
                    objectsWithForeignKey = new ArrayList<OIntegerFkWithDefault>();
                    fkToOIntegerFkWithDefaultMap.put(
                        foreignKey,
                        objectsWithForeignKey);
                }
                objectsWithForeignKey.add(referencedObject);
            }
            localKeyListChunk.clear();
        }

        List<OIntegerFkWithDefault> result = new ArrayList<OIntegerFkWithDefault>();
        for (OIntegerPk objectToFill : toFill)
        {
            objectToFill.initOIntegerFkWithDefaults();
            objectToFill.getOIntegerFkWithDefaults().clear();
            ObjectKey localKey = objectToFill.getPrimaryKey();
            List<OIntegerFkWithDefault> referencingList
                = fkToOIntegerFkWithDefaultMap.get(localKey);
            if (referencingList == null)
            {
                continue;
            }
            for (OIntegerFkWithDefault referencing : referencingList)
            {
                // copy the referencing object for the case that more than one
                // toFill object references the same object; in this case
                // every toFillObject should have its own instance 
                // of the referencing object to remain consistent
                // with other Torque referencing object treatment
                OIntegerFkWithDefault referencingCopy = referencing.copy(false);
                // copy does not set primary key
                referencingCopy.setPrimaryKey(referencing.getPrimaryKey());
                objectToFill.addOIntegerFkWithDefault(referencingCopy);
                result.add(referencingCopy);
            }
        }
        return result;
    }
    /** 
     * Fills the referenced NonPkOIntegerFk objects in the collNonPkOIntegerFks fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     *
     * @return all read List<NonPkOIntegerFk> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<NonPkOIntegerFk> fillNonPkOIntegerFks(
            Collection<OIntegerPk> toFill)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    OIntegerPkPeer.DATABASE_NAME);
            List<NonPkOIntegerFk> result = fillNonPkOIntegerFks(toFill, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /** 
     * Fills the referenced NonPkOIntegerFk objects in the collNonPkOIntegerFks fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read List<NonPkOIntegerFk> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<NonPkOIntegerFk> fillNonPkOIntegerFks(
            Collection<OIntegerPk> toFill,
            Connection connection)
        throws TorqueException
    {
        Set<ObjectKey> localKeySet = new HashSet<ObjectKey>();
        for (OIntegerPk currentOIntegerPk : toFill)
        {
            ObjectKey localKey = SimpleKey.keyFor(currentOIntegerPk.getIntegerColumn());
            localKeySet.add(localKey);
        }

        int fillerChunkSize = getFillerChunkSize();
        Iterator<ObjectKey> localKeyIt = localKeySet.iterator();
        List<ObjectKey> localKeyListChunk
                = new ArrayList<ObjectKey>(fillerChunkSize);
        Map<ObjectKey, List<NonPkOIntegerFk>> fkToNonPkOIntegerFkMap
                = new HashMap<ObjectKey, List<NonPkOIntegerFk>>();
        while (localKeyIt.hasNext())
        {
            ObjectKey currentKey = localKeyIt.next();
            localKeyListChunk.add(currentKey);
            if (localKeyListChunk.size() < fillerChunkSize
                && localKeyIt.hasNext())
            {
                continue;
            }

            Criteria criteria = new Criteria();
            criteria.andIn(NonPkOIntegerFkPeer.FK, localKeyListChunk);
            List<NonPkOIntegerFk> referencedNonPkOIntegerFkList
                 = NonPkOIntegerFkPeer.doSelect(
                     criteria,
                     connection);
            for (NonPkOIntegerFk referencedObject : referencedNonPkOIntegerFkList)
            {
                ObjectKey foreignKey = referencedObject.getForeignKeyForOIntegerPk();
                List<NonPkOIntegerFk> objectsWithForeignKey 
                    = fkToNonPkOIntegerFkMap.get(foreignKey);
                if (objectsWithForeignKey == null)
                {
                    objectsWithForeignKey = new ArrayList<NonPkOIntegerFk>();
                    fkToNonPkOIntegerFkMap.put(
                        foreignKey,
                        objectsWithForeignKey);
                }
                objectsWithForeignKey.add(referencedObject);
            }
            localKeyListChunk.clear();
        }

        List<NonPkOIntegerFk> result = new ArrayList<NonPkOIntegerFk>();
        for (OIntegerPk objectToFill : toFill)
        {
            objectToFill.initNonPkOIntegerFks();
            objectToFill.getNonPkOIntegerFks().clear();
            ObjectKey localKey = SimpleKey.keyFor(objectToFill.getIntegerColumn());
            List<NonPkOIntegerFk> referencingList
                = fkToNonPkOIntegerFkMap.get(localKey);
            if (referencingList == null)
            {
                continue;
            }
            for (NonPkOIntegerFk referencing : referencingList)
            {
                // copy the referencing object for the case that more than one
                // toFill object references the same object; in this case
                // every toFillObject should have its own instance 
                // of the referencing object to remain consistent
                // with other Torque referencing object treatment
                NonPkOIntegerFk referencingCopy = referencing.copy(false);
                // copy does not set primary key
                referencingCopy.setPrimaryKey(referencing.getPrimaryKey());
                objectToFill.addNonPkOIntegerFk(referencingCopy);
                result.add(referencingCopy);
            }
        }
        return result;
    }
    /** 
     * Fills the referenced PIntegerFkToOPk objects in the collPIntegerFkToOPks fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     *
     * @return all read List<PIntegerFkToOPk> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<PIntegerFkToOPk> fillPIntegerFkToOPks(
            Collection<OIntegerPk> toFill)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    OIntegerPkPeer.DATABASE_NAME);
            List<PIntegerFkToOPk> result = fillPIntegerFkToOPks(toFill, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /** 
     * Fills the referenced PIntegerFkToOPk objects in the collPIntegerFkToOPks fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read List<PIntegerFkToOPk> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<PIntegerFkToOPk> fillPIntegerFkToOPks(
            Collection<OIntegerPk> toFill,
            Connection connection)
        throws TorqueException
    {
        Set<ObjectKey> localKeySet = new HashSet<ObjectKey>();
        for (OIntegerPk currentOIntegerPk : toFill)
        {
            ObjectKey localKey = currentOIntegerPk.getPrimaryKey();
            localKeySet.add(localKey);
        }

        int fillerChunkSize = getFillerChunkSize();
        Iterator<ObjectKey> localKeyIt = localKeySet.iterator();
        List<ObjectKey> localKeyListChunk
                = new ArrayList<ObjectKey>(fillerChunkSize);
        Map<ObjectKey, List<PIntegerFkToOPk>> fkToPIntegerFkToOPkMap
                = new HashMap<ObjectKey, List<PIntegerFkToOPk>>();
        while (localKeyIt.hasNext())
        {
            ObjectKey currentKey = localKeyIt.next();
            localKeyListChunk.add(currentKey);
            if (localKeyListChunk.size() < fillerChunkSize
                && localKeyIt.hasNext())
            {
                continue;
            }

            Criteria criteria = new Criteria();
            criteria.andIn(PIntegerFkToOPkPeer.FK, localKeyListChunk);
            List<PIntegerFkToOPk> referencedPIntegerFkToOPkList
                 = PIntegerFkToOPkPeer.doSelect(
                     criteria,
                     connection);
            for (PIntegerFkToOPk referencedObject : referencedPIntegerFkToOPkList)
            {
                ObjectKey foreignKey = referencedObject.getForeignKeyForOIntegerPk();
                List<PIntegerFkToOPk> objectsWithForeignKey 
                    = fkToPIntegerFkToOPkMap.get(foreignKey);
                if (objectsWithForeignKey == null)
                {
                    objectsWithForeignKey = new ArrayList<PIntegerFkToOPk>();
                    fkToPIntegerFkToOPkMap.put(
                        foreignKey,
                        objectsWithForeignKey);
                }
                objectsWithForeignKey.add(referencedObject);
            }
            localKeyListChunk.clear();
        }

        List<PIntegerFkToOPk> result = new ArrayList<PIntegerFkToOPk>();
        for (OIntegerPk objectToFill : toFill)
        {
            objectToFill.initPIntegerFkToOPks();
            objectToFill.getPIntegerFkToOPks().clear();
            ObjectKey localKey = objectToFill.getPrimaryKey();
            List<PIntegerFkToOPk> referencingList
                = fkToPIntegerFkToOPkMap.get(localKey);
            if (referencingList == null)
            {
                continue;
            }
            for (PIntegerFkToOPk referencing : referencingList)
            {
                // copy the referencing object for the case that more than one
                // toFill object references the same object; in this case
                // every toFillObject should have its own instance 
                // of the referencing object to remain consistent
                // with other Torque referencing object treatment
                PIntegerFkToOPk referencingCopy = referencing.copy(false);
                // copy does not set primary key
                referencingCopy.setPrimaryKey(referencing.getPrimaryKey());
                objectToFill.addPIntegerFkToOPk(referencingCopy);
                result.add(referencingCopy);
            }
        }
        return result;
    }

    /** 
     * Returns the chunk size for the filler methods.
     *
     * @return the chunk size for the filler methods.
     */
    protected int getFillerChunkSize()
    {
        return 999;
    }


}
