package org.apache.torque.test;

import java.io.Serializable;
import java.sql.Connection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.apache.torque.TorqueException;
import org.apache.torque.map.TableMap;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.BooleanKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.om.ColumnAccessByName;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.util.Transaction;
import org.apache.commons.lang.ObjectUtils;


/**
 * table with a primitive int pk
 *
 * This class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:38 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to PIntegerPk
 */
public abstract class BasePIntegerPk 
    implements Persistent, Serializable, ColumnAccessByName
{
    /** Serial version */
    private static final long serialVersionUID = 1347503738835L;



    /** Defines the id field. */
    private int id = 0;

    /** Defines the integerColumn field. */
    private int integerColumn = 0;

    /** Defines the name field. */
    private String name = null;

    /** Whether this object was modified after loading or after last save. */
    private boolean modified = true;

    /** 
     * Whether this object was loaded from the database or already saved 
     * (false) or whether it is not yet in the database(true).
     */
    private boolean isNew = true;

    /** Flag which indicates whether this object is currently saving. */
    private boolean saving = false;

    /** 
     * Flag which indicates whether this object is currently loaded
     * from the database. 
     */
    private boolean loading = false;

    /** 
     * Flag which indicates whether this object was deleted from the database.
     * Note that this flags does not always display the current database state,
     * there is no magical connection between this flag and the database.
     */
    private boolean deleted = false;



    /** Defines the collNullablePIntegerFks field. */
    protected List<NullablePIntegerFk> collNullablePIntegerFks = null;

    /** Defines the collRequiredPIntegerFks field. */
    protected List<RequiredPIntegerFk> collRequiredPIntegerFks = null;

    /** Defines the collPIntegerFkWithDefaults field. */
    protected List<PIntegerFkWithDefault> collPIntegerFkWithDefaults = null;

    /** Defines the collNonPkPIntegerFks field. */
    protected List<NonPkPIntegerFk> collNonPkPIntegerFks = null;

    /** Defines the collOIntegerFkToPPks field. */
    protected List<OIntegerFkToPPk> collOIntegerFkToPPks = null;



    /**
     * Get the value of id.
     *
     * @return int
     */
    public int getId() 
    {
        
        return id;
    }

    /**
     * Set the value of id.
     *
     * @param v new value
     */
    public void setId(int v)
    {
        if (this.id != v)
        {
            setModified(true);
        }

        this.id = v;

        // update associated objects in collNullablePIntegerFks 
        if (collNullablePIntegerFks != null)
        {
            for (int i = 0; i < collNullablePIntegerFks.size(); i++)
            {
                ((NullablePIntegerFk) collNullablePIntegerFks.get(i))
                        .setFk(v);
            }
        }
        // update associated objects in collRequiredPIntegerFks 
        if (collRequiredPIntegerFks != null)
        {
            for (int i = 0; i < collRequiredPIntegerFks.size(); i++)
            {
                ((RequiredPIntegerFk) collRequiredPIntegerFks.get(i))
                        .setFk(v);
            }
        }
        // update associated objects in collPIntegerFkWithDefaults 
        if (collPIntegerFkWithDefaults != null)
        {
            for (int i = 0; i < collPIntegerFkWithDefaults.size(); i++)
            {
                ((PIntegerFkWithDefault) collPIntegerFkWithDefaults.get(i))
                        .setFk(v);
            }
        }
        // update associated objects in collOIntegerFkToPPks 
        if (collOIntegerFkToPPks != null)
        {
            for (int i = 0; i < collOIntegerFkToPPks.size(); i++)
            {
                ((OIntegerFkToPPk) collOIntegerFkToPPks.get(i))
                        .setFk(v);
            }
        }

    }
    
    /**
     * Get the value of integerColumn.
     *
     * @return int
     */
    public int getIntegerColumn() 
    {
        
        return integerColumn;
    }

    /**
     * Set the value of integerColumn.
     *
     * @param v new value
     */
    public void setIntegerColumn(int v)
    {
        if (this.integerColumn != v)
        {
            setModified(true);
        }

        this.integerColumn = v;

        // update associated objects in collNonPkPIntegerFks 
        if (collNonPkPIntegerFks != null)
        {
            for (int i = 0; i < collNonPkPIntegerFks.size(); i++)
            {
                ((NonPkPIntegerFk) collNonPkPIntegerFks.get(i))
                        .setFk(v);
            }
        }

    }
    
    /**
     * Get the value of name.
     *
     * @return String
     */
    public String getName() 
    {
        
        return name;
    }

    /**
     * Set the value of name.
     *
     * @param v new value
     */
    public void setName(String v)
    {
        if (!ObjectUtils.equals(this.name, v))
        {
            setModified(true);
        }

        this.name = v;


    }
    

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return true, if the object has never been persisted.
     */
    public boolean isNew()
    {
        return isNew;
    }

    /**
     * Sets whether the object has ever been saved.
     *
     * @param isNew true if the object has never been saved, false otherwise.
     */
    public void setNew(boolean isNew)
    {
        this.isNew = isNew;
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return True if the object has been modified.
     */
    public boolean isModified()
    {
        return modified;
    }

    /**
     * Sets whether the object has been modified.
     *
     * @param modified true if the object has been modified, false otherwise.
     */
    public void setModified(boolean modified)
    {
        this.modified = modified;
    }

    /**
     * Sets the modified state for the object to be false.
     */
    public void resetModified()
    {
        modified = false;
    }


    /**
     * Returns whether this object is currently saving.
     *
     * @return true if this object is currently saving, false otherwise.
     */
    public boolean isSaving()
    {
        return saving;
    }

    /**
     * Sets whether this object is currently saving.
     *
     * @param saving true if this object is currently saving, false otherwise.
     */
    public void setSaving(boolean saving)
    {
        this.saving = saving;
    }


    /**
     * Returns whether this object is currently being loaded from the database.
     *
     * @return true if this object is currently loading, false otherwise.
     */
    public boolean isLoading()
    {
        return loading;
    }

    /**
     * Sets whether this object is currently being loaded from the database.
     *
     * @param loading true if this object is currently loading, false otherwise.
     */
    public void setLoading(boolean loading)
    {
        this.loading = loading;
    }


    /**
     * Returns whether this object was deleted from the database.
     * Note that this getter does not automatically reflect database state,
     * it will be set to true by Torque if doDelete() was called with this 
     * object. Bulk deletes and deletes via primary key do not change
     * this flag. Also, if doDelete() was called on an object which does
     * not exist in the database, the deleted flag is set to true even if
     * it was not deleted.
     *
     * @return true if this object was deleted, false otherwise.
     */
    public boolean isDeleted()
    {
        return deleted;
    }

    /**
     * Sets whether this object was deleted from the database.
     *
     * @param deleted true if this object was deleted, false otherwise.
     */
    public void setDeleted(boolean deleted)
    {
        this.deleted = deleted;
    }




    /**
     * Initializes the cache collNullablePIntegerFks for referenced objects. 
     */
    public void initNullablePIntegerFks()
    {
        if (collNullablePIntegerFks == null)
        {
            collNullablePIntegerFks = new ArrayList<NullablePIntegerFk>();
        }
    }

    /**
     * Checks whether the cache collNullablePIntegerFks for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isNullablePIntegerFksInitialized()
    {
        return (collNullablePIntegerFks != null);
    }


    /**
     * Method called to associate a NullablePIntegerFk object to this object
     * through the collNullablePIntegerFks foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addNullablePIntegerFk(NullablePIntegerFk toAdd)
        throws TorqueException
    {
        toAdd.setPIntegerPk((PIntegerPk) this);
        getNullablePIntegerFks().add(toAdd);
    }

    /**
     * Method called to associate a NullablePIntegerFk object to this object
     * through the collNullablePIntegerFks foreign key attribute using connection.
     *
     * @param l NullablePIntegerFk
     * @throws TorqueException
     */
    public void addNullablePIntegerFk(NullablePIntegerFk l, Connection con) throws TorqueException
    {
        getNullablePIntegerFks(con).add(l);
        l.setPIntegerPk((PIntegerPk) this);
    }
    
    /**
     * The criteria used to select the current contents of collNullablePIntegerFks
     */
    private Criteria lastNullablePIntegerFkCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getNullablePIntegerFks(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<NullablePIntegerFk> getNullablePIntegerFks()
        throws TorqueException
    {
        if (collNullablePIntegerFks == null)
        {
            collNullablePIntegerFks = getNullablePIntegerFks(new Criteria());
        }
        return collNullablePIntegerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BasePIntegerPk has previously
     * been saved, it will retrieve related collNullablePIntegerFks from storage.
     * If this BasePIntegerPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<NullablePIntegerFk> getNullablePIntegerFks(Criteria criteria) throws TorqueException
    {
        if (collNullablePIntegerFks == null)
        {
            if (isNew())
            {
               initNullablePIntegerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.NullablePIntegerFkPeer.FK, getId() );
                collNullablePIntegerFks = org.apache.torque.test.NullablePIntegerFkPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.NullablePIntegerFkPeer.FK, getId() );
                if (lastNullablePIntegerFkCriteria == null 
                        || !lastNullablePIntegerFkCriteria.equals(criteria))
                {
                    collNullablePIntegerFks = org.apache.torque.test.NullablePIntegerFkPeer.doSelect(criteria);
                }
            }
        }
        lastNullablePIntegerFkCriteria = criteria;

        return collNullablePIntegerFks;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getNullablePIntegerFks(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<NullablePIntegerFk> getNullablePIntegerFks(Connection con) throws TorqueException
    {
        if (collNullablePIntegerFks == null)
        {
            collNullablePIntegerFks = getNullablePIntegerFks(new Criteria(), con);
        }
        return collNullablePIntegerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BasePIntegerPk has previously
     * been saved, it will retrieve the related NullablePIntegerFk Objects 
     * from storage.
     * If this BasePIntegerPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<NullablePIntegerFk> getNullablePIntegerFks(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collNullablePIntegerFks == null)
        {
            if (isNew())
            {
               initNullablePIntegerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.NullablePIntegerFkPeer.FK, getId());
                collNullablePIntegerFks = org.apache.torque.test.NullablePIntegerFkPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.NullablePIntegerFkPeer.FK, getId());
                if (!lastNullablePIntegerFkCriteria.equals(criteria))
                {
                    collNullablePIntegerFks = org.apache.torque.test.NullablePIntegerFkPeer.doSelect(criteria, con);
                }
            }
        }
        lastNullablePIntegerFkCriteria = criteria;

        return collNullablePIntegerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BasePIntegerPk is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<NullablePIntegerFk> getNullablePIntegerFksJoinPIntegerPk(Criteria criteria) throws TorqueException
    {
        return getNullablePIntegerFksJoinPIntegerPk(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BasePIntegerPk is new, it will return
     * an empty collection; or if this BasePIntegerPk has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<NullablePIntegerFk> getNullablePIntegerFksJoinPIntegerPk(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collNullablePIntegerFks == null)
        {
            if (isNew())
            {
                initNullablePIntegerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.NullablePIntegerFkPeer.FK, getId() );
                collNullablePIntegerFks = org.apache.torque.test.NullablePIntegerFkPeer.doSelectJoinPIntegerPk(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.NullablePIntegerFkPeer.FK, getId() );
            if (!lastNullablePIntegerFkCriteria.equals(criteria))
            {
                collNullablePIntegerFks = org.apache.torque.test.NullablePIntegerFkPeer.doSelectJoinPIntegerPk(criteria, connection);
            }
        }
        lastNullablePIntegerFkCriteria = criteria;

        return collNullablePIntegerFks;
    }

    /**
     * Initializes the cache collRequiredPIntegerFks for referenced objects. 
     */
    public void initRequiredPIntegerFks()
    {
        if (collRequiredPIntegerFks == null)
        {
            collRequiredPIntegerFks = new ArrayList<RequiredPIntegerFk>();
        }
    }

    /**
     * Checks whether the cache collRequiredPIntegerFks for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isRequiredPIntegerFksInitialized()
    {
        return (collRequiredPIntegerFks != null);
    }


    /**
     * Method called to associate a RequiredPIntegerFk object to this object
     * through the collRequiredPIntegerFks foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addRequiredPIntegerFk(RequiredPIntegerFk toAdd)
        throws TorqueException
    {
        toAdd.setPIntegerPk((PIntegerPk) this);
        getRequiredPIntegerFks().add(toAdd);
    }

    /**
     * Method called to associate a RequiredPIntegerFk object to this object
     * through the collRequiredPIntegerFks foreign key attribute using connection.
     *
     * @param l RequiredPIntegerFk
     * @throws TorqueException
     */
    public void addRequiredPIntegerFk(RequiredPIntegerFk l, Connection con) throws TorqueException
    {
        getRequiredPIntegerFks(con).add(l);
        l.setPIntegerPk((PIntegerPk) this);
    }
    
    /**
     * The criteria used to select the current contents of collRequiredPIntegerFks
     */
    private Criteria lastRequiredPIntegerFkCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getRequiredPIntegerFks(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<RequiredPIntegerFk> getRequiredPIntegerFks()
        throws TorqueException
    {
        if (collRequiredPIntegerFks == null)
        {
            collRequiredPIntegerFks = getRequiredPIntegerFks(new Criteria());
        }
        return collRequiredPIntegerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BasePIntegerPk has previously
     * been saved, it will retrieve related collRequiredPIntegerFks from storage.
     * If this BasePIntegerPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<RequiredPIntegerFk> getRequiredPIntegerFks(Criteria criteria) throws TorqueException
    {
        if (collRequiredPIntegerFks == null)
        {
            if (isNew())
            {
               initRequiredPIntegerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.RequiredPIntegerFkPeer.FK, getId() );
                collRequiredPIntegerFks = org.apache.torque.test.RequiredPIntegerFkPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.RequiredPIntegerFkPeer.FK, getId() );
                if (lastRequiredPIntegerFkCriteria == null 
                        || !lastRequiredPIntegerFkCriteria.equals(criteria))
                {
                    collRequiredPIntegerFks = org.apache.torque.test.RequiredPIntegerFkPeer.doSelect(criteria);
                }
            }
        }
        lastRequiredPIntegerFkCriteria = criteria;

        return collRequiredPIntegerFks;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getRequiredPIntegerFks(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<RequiredPIntegerFk> getRequiredPIntegerFks(Connection con) throws TorqueException
    {
        if (collRequiredPIntegerFks == null)
        {
            collRequiredPIntegerFks = getRequiredPIntegerFks(new Criteria(), con);
        }
        return collRequiredPIntegerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BasePIntegerPk has previously
     * been saved, it will retrieve the related RequiredPIntegerFk Objects 
     * from storage.
     * If this BasePIntegerPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<RequiredPIntegerFk> getRequiredPIntegerFks(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collRequiredPIntegerFks == null)
        {
            if (isNew())
            {
               initRequiredPIntegerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.RequiredPIntegerFkPeer.FK, getId());
                collRequiredPIntegerFks = org.apache.torque.test.RequiredPIntegerFkPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.RequiredPIntegerFkPeer.FK, getId());
                if (!lastRequiredPIntegerFkCriteria.equals(criteria))
                {
                    collRequiredPIntegerFks = org.apache.torque.test.RequiredPIntegerFkPeer.doSelect(criteria, con);
                }
            }
        }
        lastRequiredPIntegerFkCriteria = criteria;

        return collRequiredPIntegerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BasePIntegerPk is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<RequiredPIntegerFk> getRequiredPIntegerFksJoinPIntegerPk(Criteria criteria) throws TorqueException
    {
        return getRequiredPIntegerFksJoinPIntegerPk(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BasePIntegerPk is new, it will return
     * an empty collection; or if this BasePIntegerPk has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<RequiredPIntegerFk> getRequiredPIntegerFksJoinPIntegerPk(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collRequiredPIntegerFks == null)
        {
            if (isNew())
            {
                initRequiredPIntegerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.RequiredPIntegerFkPeer.FK, getId() );
                collRequiredPIntegerFks = org.apache.torque.test.RequiredPIntegerFkPeer.doSelectJoinPIntegerPk(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.RequiredPIntegerFkPeer.FK, getId() );
            if (!lastRequiredPIntegerFkCriteria.equals(criteria))
            {
                collRequiredPIntegerFks = org.apache.torque.test.RequiredPIntegerFkPeer.doSelectJoinPIntegerPk(criteria, connection);
            }
        }
        lastRequiredPIntegerFkCriteria = criteria;

        return collRequiredPIntegerFks;
    }

    /**
     * Initializes the cache collPIntegerFkWithDefaults for referenced objects. 
     */
    public void initPIntegerFkWithDefaults()
    {
        if (collPIntegerFkWithDefaults == null)
        {
            collPIntegerFkWithDefaults = new ArrayList<PIntegerFkWithDefault>();
        }
    }

    /**
     * Checks whether the cache collPIntegerFkWithDefaults for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isPIntegerFkWithDefaultsInitialized()
    {
        return (collPIntegerFkWithDefaults != null);
    }


    /**
     * Method called to associate a PIntegerFkWithDefault object to this object
     * through the collPIntegerFkWithDefaults foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addPIntegerFkWithDefault(PIntegerFkWithDefault toAdd)
        throws TorqueException
    {
        toAdd.setPIntegerPk((PIntegerPk) this);
        getPIntegerFkWithDefaults().add(toAdd);
    }

    /**
     * Method called to associate a PIntegerFkWithDefault object to this object
     * through the collPIntegerFkWithDefaults foreign key attribute using connection.
     *
     * @param l PIntegerFkWithDefault
     * @throws TorqueException
     */
    public void addPIntegerFkWithDefault(PIntegerFkWithDefault l, Connection con) throws TorqueException
    {
        getPIntegerFkWithDefaults(con).add(l);
        l.setPIntegerPk((PIntegerPk) this);
    }
    
    /**
     * The criteria used to select the current contents of collPIntegerFkWithDefaults
     */
    private Criteria lastPIntegerFkWithDefaultCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getPIntegerFkWithDefaults(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<PIntegerFkWithDefault> getPIntegerFkWithDefaults()
        throws TorqueException
    {
        if (collPIntegerFkWithDefaults == null)
        {
            collPIntegerFkWithDefaults = getPIntegerFkWithDefaults(new Criteria());
        }
        return collPIntegerFkWithDefaults;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BasePIntegerPk has previously
     * been saved, it will retrieve related collPIntegerFkWithDefaults from storage.
     * If this BasePIntegerPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<PIntegerFkWithDefault> getPIntegerFkWithDefaults(Criteria criteria) throws TorqueException
    {
        if (collPIntegerFkWithDefaults == null)
        {
            if (isNew())
            {
               initPIntegerFkWithDefaults();
            }
            else
            {
                criteria.and(org.apache.torque.test.PIntegerFkWithDefaultPeer.FK, getId() );
                collPIntegerFkWithDefaults = org.apache.torque.test.PIntegerFkWithDefaultPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.PIntegerFkWithDefaultPeer.FK, getId() );
                if (lastPIntegerFkWithDefaultCriteria == null 
                        || !lastPIntegerFkWithDefaultCriteria.equals(criteria))
                {
                    collPIntegerFkWithDefaults = org.apache.torque.test.PIntegerFkWithDefaultPeer.doSelect(criteria);
                }
            }
        }
        lastPIntegerFkWithDefaultCriteria = criteria;

        return collPIntegerFkWithDefaults;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getPIntegerFkWithDefaults(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<PIntegerFkWithDefault> getPIntegerFkWithDefaults(Connection con) throws TorqueException
    {
        if (collPIntegerFkWithDefaults == null)
        {
            collPIntegerFkWithDefaults = getPIntegerFkWithDefaults(new Criteria(), con);
        }
        return collPIntegerFkWithDefaults;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BasePIntegerPk has previously
     * been saved, it will retrieve the related PIntegerFkWithDefault Objects 
     * from storage.
     * If this BasePIntegerPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<PIntegerFkWithDefault> getPIntegerFkWithDefaults(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collPIntegerFkWithDefaults == null)
        {
            if (isNew())
            {
               initPIntegerFkWithDefaults();
            }
            else
            {
                criteria.and(org.apache.torque.test.PIntegerFkWithDefaultPeer.FK, getId());
                collPIntegerFkWithDefaults = org.apache.torque.test.PIntegerFkWithDefaultPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.PIntegerFkWithDefaultPeer.FK, getId());
                if (!lastPIntegerFkWithDefaultCriteria.equals(criteria))
                {
                    collPIntegerFkWithDefaults = org.apache.torque.test.PIntegerFkWithDefaultPeer.doSelect(criteria, con);
                }
            }
        }
        lastPIntegerFkWithDefaultCriteria = criteria;

        return collPIntegerFkWithDefaults;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BasePIntegerPk is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<PIntegerFkWithDefault> getPIntegerFkWithDefaultsJoinPIntegerPk(Criteria criteria) throws TorqueException
    {
        return getPIntegerFkWithDefaultsJoinPIntegerPk(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BasePIntegerPk is new, it will return
     * an empty collection; or if this BasePIntegerPk has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<PIntegerFkWithDefault> getPIntegerFkWithDefaultsJoinPIntegerPk(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collPIntegerFkWithDefaults == null)
        {
            if (isNew())
            {
                initPIntegerFkWithDefaults();
            }
            else
            {
                criteria.and(org.apache.torque.test.PIntegerFkWithDefaultPeer.FK, getId() );
                collPIntegerFkWithDefaults = org.apache.torque.test.PIntegerFkWithDefaultPeer.doSelectJoinPIntegerPk(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.PIntegerFkWithDefaultPeer.FK, getId() );
            if (!lastPIntegerFkWithDefaultCriteria.equals(criteria))
            {
                collPIntegerFkWithDefaults = org.apache.torque.test.PIntegerFkWithDefaultPeer.doSelectJoinPIntegerPk(criteria, connection);
            }
        }
        lastPIntegerFkWithDefaultCriteria = criteria;

        return collPIntegerFkWithDefaults;
    }

    /**
     * Initializes the cache collNonPkPIntegerFks for referenced objects. 
     */
    public void initNonPkPIntegerFks()
    {
        if (collNonPkPIntegerFks == null)
        {
            collNonPkPIntegerFks = new ArrayList<NonPkPIntegerFk>();
        }
    }

    /**
     * Checks whether the cache collNonPkPIntegerFks for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isNonPkPIntegerFksInitialized()
    {
        return (collNonPkPIntegerFks != null);
    }


    /**
     * Method called to associate a NonPkPIntegerFk object to this object
     * through the collNonPkPIntegerFks foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addNonPkPIntegerFk(NonPkPIntegerFk toAdd)
        throws TorqueException
    {
        toAdd.setPIntegerPk((PIntegerPk) this);
        getNonPkPIntegerFks().add(toAdd);
    }

    /**
     * Method called to associate a NonPkPIntegerFk object to this object
     * through the collNonPkPIntegerFks foreign key attribute using connection.
     *
     * @param l NonPkPIntegerFk
     * @throws TorqueException
     */
    public void addNonPkPIntegerFk(NonPkPIntegerFk l, Connection con) throws TorqueException
    {
        getNonPkPIntegerFks(con).add(l);
        l.setPIntegerPk((PIntegerPk) this);
    }
    
    /**
     * The criteria used to select the current contents of collNonPkPIntegerFks
     */
    private Criteria lastNonPkPIntegerFkCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getNonPkPIntegerFks(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<NonPkPIntegerFk> getNonPkPIntegerFks()
        throws TorqueException
    {
        if (collNonPkPIntegerFks == null)
        {
            collNonPkPIntegerFks = getNonPkPIntegerFks(new Criteria());
        }
        return collNonPkPIntegerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BasePIntegerPk has previously
     * been saved, it will retrieve related collNonPkPIntegerFks from storage.
     * If this BasePIntegerPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<NonPkPIntegerFk> getNonPkPIntegerFks(Criteria criteria) throws TorqueException
    {
        if (collNonPkPIntegerFks == null)
        {
            if (isNew())
            {
               initNonPkPIntegerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.NonPkPIntegerFkPeer.FK, getIntegerColumn() );
                collNonPkPIntegerFks = org.apache.torque.test.NonPkPIntegerFkPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.NonPkPIntegerFkPeer.FK, getIntegerColumn() );
                if (lastNonPkPIntegerFkCriteria == null 
                        || !lastNonPkPIntegerFkCriteria.equals(criteria))
                {
                    collNonPkPIntegerFks = org.apache.torque.test.NonPkPIntegerFkPeer.doSelect(criteria);
                }
            }
        }
        lastNonPkPIntegerFkCriteria = criteria;

        return collNonPkPIntegerFks;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getNonPkPIntegerFks(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<NonPkPIntegerFk> getNonPkPIntegerFks(Connection con) throws TorqueException
    {
        if (collNonPkPIntegerFks == null)
        {
            collNonPkPIntegerFks = getNonPkPIntegerFks(new Criteria(), con);
        }
        return collNonPkPIntegerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BasePIntegerPk has previously
     * been saved, it will retrieve the related NonPkPIntegerFk Objects 
     * from storage.
     * If this BasePIntegerPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<NonPkPIntegerFk> getNonPkPIntegerFks(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collNonPkPIntegerFks == null)
        {
            if (isNew())
            {
               initNonPkPIntegerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.NonPkPIntegerFkPeer.FK, getIntegerColumn());
                collNonPkPIntegerFks = org.apache.torque.test.NonPkPIntegerFkPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.NonPkPIntegerFkPeer.FK, getIntegerColumn());
                if (!lastNonPkPIntegerFkCriteria.equals(criteria))
                {
                    collNonPkPIntegerFks = org.apache.torque.test.NonPkPIntegerFkPeer.doSelect(criteria, con);
                }
            }
        }
        lastNonPkPIntegerFkCriteria = criteria;

        return collNonPkPIntegerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BasePIntegerPk is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<NonPkPIntegerFk> getNonPkPIntegerFksJoinPIntegerPk(Criteria criteria) throws TorqueException
    {
        return getNonPkPIntegerFksJoinPIntegerPk(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BasePIntegerPk is new, it will return
     * an empty collection; or if this BasePIntegerPk has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<NonPkPIntegerFk> getNonPkPIntegerFksJoinPIntegerPk(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collNonPkPIntegerFks == null)
        {
            if (isNew())
            {
                initNonPkPIntegerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.NonPkPIntegerFkPeer.FK, getIntegerColumn() );
                collNonPkPIntegerFks = org.apache.torque.test.NonPkPIntegerFkPeer.doSelectJoinPIntegerPk(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.NonPkPIntegerFkPeer.FK, getIntegerColumn() );
            if (!lastNonPkPIntegerFkCriteria.equals(criteria))
            {
                collNonPkPIntegerFks = org.apache.torque.test.NonPkPIntegerFkPeer.doSelectJoinPIntegerPk(criteria, connection);
            }
        }
        lastNonPkPIntegerFkCriteria = criteria;

        return collNonPkPIntegerFks;
    }

    /**
     * Initializes the cache collOIntegerFkToPPks for referenced objects. 
     */
    public void initOIntegerFkToPPks()
    {
        if (collOIntegerFkToPPks == null)
        {
            collOIntegerFkToPPks = new ArrayList<OIntegerFkToPPk>();
        }
    }

    /**
     * Checks whether the cache collOIntegerFkToPPks for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isOIntegerFkToPPksInitialized()
    {
        return (collOIntegerFkToPPks != null);
    }


    /**
     * Method called to associate a OIntegerFkToPPk object to this object
     * through the collOIntegerFkToPPks foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addOIntegerFkToPPk(OIntegerFkToPPk toAdd)
        throws TorqueException
    {
        toAdd.setPIntegerPk((PIntegerPk) this);
        getOIntegerFkToPPks().add(toAdd);
    }

    /**
     * Method called to associate a OIntegerFkToPPk object to this object
     * through the collOIntegerFkToPPks foreign key attribute using connection.
     *
     * @param l OIntegerFkToPPk
     * @throws TorqueException
     */
    public void addOIntegerFkToPPk(OIntegerFkToPPk l, Connection con) throws TorqueException
    {
        getOIntegerFkToPPks(con).add(l);
        l.setPIntegerPk((PIntegerPk) this);
    }
    
    /**
     * The criteria used to select the current contents of collOIntegerFkToPPks
     */
    private Criteria lastOIntegerFkToPPkCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getOIntegerFkToPPks(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<OIntegerFkToPPk> getOIntegerFkToPPks()
        throws TorqueException
    {
        if (collOIntegerFkToPPks == null)
        {
            collOIntegerFkToPPks = getOIntegerFkToPPks(new Criteria());
        }
        return collOIntegerFkToPPks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BasePIntegerPk has previously
     * been saved, it will retrieve related collOIntegerFkToPPks from storage.
     * If this BasePIntegerPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<OIntegerFkToPPk> getOIntegerFkToPPks(Criteria criteria) throws TorqueException
    {
        if (collOIntegerFkToPPks == null)
        {
            if (isNew())
            {
               initOIntegerFkToPPks();
            }
            else
            {
                criteria.and(org.apache.torque.test.OIntegerFkToPPkPeer.FK, getId() );
                collOIntegerFkToPPks = org.apache.torque.test.OIntegerFkToPPkPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.OIntegerFkToPPkPeer.FK, getId() );
                if (lastOIntegerFkToPPkCriteria == null 
                        || !lastOIntegerFkToPPkCriteria.equals(criteria))
                {
                    collOIntegerFkToPPks = org.apache.torque.test.OIntegerFkToPPkPeer.doSelect(criteria);
                }
            }
        }
        lastOIntegerFkToPPkCriteria = criteria;

        return collOIntegerFkToPPks;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getOIntegerFkToPPks(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<OIntegerFkToPPk> getOIntegerFkToPPks(Connection con) throws TorqueException
    {
        if (collOIntegerFkToPPks == null)
        {
            collOIntegerFkToPPks = getOIntegerFkToPPks(new Criteria(), con);
        }
        return collOIntegerFkToPPks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BasePIntegerPk has previously
     * been saved, it will retrieve the related OIntegerFkToPPk Objects 
     * from storage.
     * If this BasePIntegerPk is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<OIntegerFkToPPk> getOIntegerFkToPPks(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collOIntegerFkToPPks == null)
        {
            if (isNew())
            {
               initOIntegerFkToPPks();
            }
            else
            {
                criteria.and(org.apache.torque.test.OIntegerFkToPPkPeer.FK, getId());
                collOIntegerFkToPPks = org.apache.torque.test.OIntegerFkToPPkPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.OIntegerFkToPPkPeer.FK, getId());
                if (!lastOIntegerFkToPPkCriteria.equals(criteria))
                {
                    collOIntegerFkToPPks = org.apache.torque.test.OIntegerFkToPPkPeer.doSelect(criteria, con);
                }
            }
        }
        lastOIntegerFkToPPkCriteria = criteria;

        return collOIntegerFkToPPks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BasePIntegerPk is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<OIntegerFkToPPk> getOIntegerFkToPPksJoinPIntegerPk(Criteria criteria) throws TorqueException
    {
        return getOIntegerFkToPPksJoinPIntegerPk(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BasePIntegerPk is new, it will return
     * an empty collection; or if this BasePIntegerPk has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<OIntegerFkToPPk> getOIntegerFkToPPksJoinPIntegerPk(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collOIntegerFkToPPks == null)
        {
            if (isNew())
            {
                initOIntegerFkToPPks();
            }
            else
            {
                criteria.and(org.apache.torque.test.OIntegerFkToPPkPeer.FK, getId() );
                collOIntegerFkToPPks = org.apache.torque.test.OIntegerFkToPPkPeer.doSelectJoinPIntegerPk(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.OIntegerFkToPPkPeer.FK, getId() );
            if (!lastOIntegerFkToPPkCriteria.equals(criteria))
            {
                collOIntegerFkToPPks = org.apache.torque.test.OIntegerFkToPPkPeer.doSelectJoinPIntegerPk(criteria, connection);
            }
        }
        lastOIntegerFkToPPkCriteria = criteria;

        return collOIntegerFkToPPks;
    }




    private static final List<String> FIELD_NAMES;

    static
    {
        List<String> fieldNames
                = new ArrayList<String>();
        fieldNames.add("Id");
        fieldNames.add("IntegerColumn");
        fieldNames.add("Name");
        FIELD_NAMES = Collections.unmodifiableList(fieldNames);
    }

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static List<String> getFieldNames()
    {
        return FIELD_NAMES;
    }

    /**
     * Retrieves a field from the object by field (Java) name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
        if (name.equals("Id"))
        {
            return new Integer(getId());
        }
        if (name.equals("IntegerColumn"))
        {
            return new Integer(getIntegerColumn());
        }
        if (name.equals("Name"))
        {
            return getName();
        }
        return null;
    }

    /**
     * Set a field in the object by field (Java) name.
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (name.equals("Id"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setId(((Integer) value).intValue());
            return true;
        }
        if (name.equals("IntegerColumn"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setIntegerColumn(((Integer) value).intValue());
            return true;
        }
        if (name.equals("Name"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setName((String) value);
            return true;
        }
        return false;
    }

    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
        if (name.equals(org.apache.torque.test.PIntegerPkPeer.ID))
        {
            return new Integer(getId());
        }
        if (name.equals(org.apache.torque.test.PIntegerPkPeer.INTEGER_COLUMN))
        {
            return new Integer(getIntegerColumn());
        }
        if (name.equals(org.apache.torque.test.PIntegerPkPeer.NAME))
        {
            return getName();
        }
        return null;
    }

    /**
     * Set field values by Peer Field Name
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPeerName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (org.apache.torque.test.PIntegerPkPeer.ID.getSqlExpression().equals(name))
        {
            return setByName("Id", value);
        }
        if (org.apache.torque.test.PIntegerPkPeer.INTEGER_COLUMN.getSqlExpression().equals(name))
        {
            return setByName("IntegerColumn", value);
        }
        if (org.apache.torque.test.PIntegerPkPeer.NAME.getSqlExpression().equals(name))
        {
            return setByName("Name", value);
        }
        return false;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
        if (pos == 0)
        {
            return new Integer(getId());
        }
        if (pos == 1)
        {
            return new Integer(getIntegerColumn());
        }
        if (pos == 2)
        {
            return getName();
        }
        return null;
    }

    /**
     * Set field values by its position (zero based) in the XML schema.
     *
     * @param position The field position
     * @param value field value
     * @return True if value was set, false if not (invalid position / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPosition(int position, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (position == 0)
        {
            return setByName("Id", value);
        }
        if (position == 1)
        {
            return setByName("IntegerColumn", value);
        }
        if (position == 2)
        {
            return setByName("Name", value);
        }
        return false;
    }



    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save() throws TorqueException
    {
        save(PIntegerPkPeer.DATABASE_NAME);
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     * @param dbName the name of the database to which the object
     *        should be saved.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(String dbName) 
            throws TorqueException
    {
        Connection con = null;
        try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally.
     *
     * @param toSave the object to be saved, not null.
     * @param con the connection to use for saving the object, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(Connection con) 
            throws TorqueException
    {
        if (isSaving())
        {
            return;
        }
        try
        {
            setSaving(true);
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    PIntegerPkPeer.doInsert((PIntegerPk) this, con);
                    setNew(false);
                }
                else
                {
                    PIntegerPkPeer.doUpdate((PIntegerPk) this, con);
                }
            }

            if (isNullablePIntegerFksInitialized())
            {
                for (NullablePIntegerFk collNullablePIntegerFks : getNullablePIntegerFks())
                {
                    collNullablePIntegerFks.save(con);
                }
            }
            if (isRequiredPIntegerFksInitialized())
            {
                for (RequiredPIntegerFk collRequiredPIntegerFks : getRequiredPIntegerFks())
                {
                    collRequiredPIntegerFks.save(con);
                }
            }
            if (isPIntegerFkWithDefaultsInitialized())
            {
                for (PIntegerFkWithDefault collPIntegerFkWithDefaults : getPIntegerFkWithDefaults())
                {
                    collPIntegerFkWithDefaults.save(con);
                }
            }
            if (isNonPkPIntegerFksInitialized())
            {
                for (NonPkPIntegerFk collNonPkPIntegerFks : getNonPkPIntegerFks())
                {
                    collNonPkPIntegerFks.save(con);
                }
            }
            if (isOIntegerFkToPPksInitialized())
            {
                for (OIntegerFkToPPk collOIntegerFkToPPks : getOIntegerFkToPPks())
                {
                    collOIntegerFkToPPks.save(con);
                }
            }
        }
        finally
        {
            setSaving(false);
        }
    }




    /**
     * Set the PrimaryKey using ObjectKey.
     *
     * @param key id ObjectKey
     */
    public void setPrimaryKey(ObjectKey key)
        
    {
        setId(((NumberKey) key).intValue());
    }

    /**
     * Set the PrimaryKey using a String.
     *
     * @param key
     */
    public void setPrimaryKey(String key) 
    {
        setId(Integer.parseInt(key));
    }


    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        return SimpleKey.keyFor(getId());
    }



    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public PIntegerPk copy() throws TorqueException
    {
        return copy(true);
    }

    /**
     * Makes a copy of this object using a connection.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     *
     * @param con the database connection to read associated objects.
     */
    public PIntegerPk copy(Connection con) throws TorqueException
    {
        return copy(true, con);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     */
    public PIntegerPk copy(boolean deepcopy) throws TorqueException
    {
        PIntegerPk pIntegerPk = new PIntegerPk();

        return copyInto(pIntegerPk, deepcopy);
    }

    /**
     * Makes a copy of this object using connection.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @param con the database connection to read associated objects.
     */
    public PIntegerPk copy(boolean deepcopy, Connection con) throws TorqueException
    {
        PIntegerPk pIntegerPk = new PIntegerPk();

        return copyInto(pIntegerPk, deepcopy, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     */
    protected PIntegerPk copyInto(PIntegerPk copyObj) throws TorqueException
    {
        return copyInto(copyObj, true);
    }

    /**
     * Fills the copyObj with the contents of this object using connection.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param con the database connection to read associated objects.
     */
    protected PIntegerPk copyInto(PIntegerPk copyObj, Connection con) throws TorqueException
    {
        return copyInto(copyObj, true, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     */
    protected PIntegerPk copyInto(PIntegerPk copyObj, boolean deepcopy) throws TorqueException
    {
        copyObj.setId(0);
        copyObj.setIntegerColumn(integerColumn);
        copyObj.setName(name);

        if (deepcopy)
        {
            if (collNullablePIntegerFks != null)
            {
                for (int i = 0; i < collNullablePIntegerFks.size(); i++)
                {
                    NullablePIntegerFk obj = collNullablePIntegerFks.get(i);
                    copyObj.addNullablePIntegerFk(obj.copy());
                }
            }
            else
            {
                copyObj.collNullablePIntegerFks = null;
            }
            if (collRequiredPIntegerFks != null)
            {
                for (int i = 0; i < collRequiredPIntegerFks.size(); i++)
                {
                    RequiredPIntegerFk obj = collRequiredPIntegerFks.get(i);
                    copyObj.addRequiredPIntegerFk(obj.copy());
                }
            }
            else
            {
                copyObj.collRequiredPIntegerFks = null;
            }
            if (collPIntegerFkWithDefaults != null)
            {
                for (int i = 0; i < collPIntegerFkWithDefaults.size(); i++)
                {
                    PIntegerFkWithDefault obj = collPIntegerFkWithDefaults.get(i);
                    copyObj.addPIntegerFkWithDefault(obj.copy());
                }
            }
            else
            {
                copyObj.collPIntegerFkWithDefaults = null;
            }
            if (collNonPkPIntegerFks != null)
            {
                for (int i = 0; i < collNonPkPIntegerFks.size(); i++)
                {
                    NonPkPIntegerFk obj = collNonPkPIntegerFks.get(i);
                    copyObj.addNonPkPIntegerFk(obj.copy());
                }
            }
            else
            {
                copyObj.collNonPkPIntegerFks = null;
            }
            if (collOIntegerFkToPPks != null)
            {
                for (int i = 0; i < collOIntegerFkToPPks.size(); i++)
                {
                    OIntegerFkToPPk obj = collOIntegerFkToPPks.get(i);
                    copyObj.addOIntegerFkToPPk(obj.copy());
                }
            }
            else
            {
                copyObj.collOIntegerFkToPPks = null;
            }
        }
        return copyObj;
    }
        
    
    /**
     * Fills the copyObj with the contents of this object using connection.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @param con the database connection to read associated objects.
     */
    protected PIntegerPk copyInto(PIntegerPk copyObj, boolean deepcopy, Connection con) throws TorqueException
    {
        copyObj.setId(0);
        copyObj.setIntegerColumn(integerColumn);
        copyObj.setName(name);

        if (deepcopy)
        {
            for (NullablePIntegerFk obj : getNullablePIntegerFks(con))
            {
                copyObj.addNullablePIntegerFk(obj.copy());
            }
            for (RequiredPIntegerFk obj : getRequiredPIntegerFks(con))
            {
                copyObj.addRequiredPIntegerFk(obj.copy());
            }
            for (PIntegerFkWithDefault obj : getPIntegerFkWithDefaults(con))
            {
                copyObj.addPIntegerFkWithDefault(obj.copy());
            }
            for (NonPkPIntegerFk obj : getNonPkPIntegerFks(con))
            {
                copyObj.addNonPkPIntegerFk(obj.copy());
            }
            for (OIntegerFkToPPk obj : getOIntegerFkToPPks(con))
            {
                copyObj.addOIntegerFkToPPk(obj.copy());
            }
        }
        return copyObj;
    }

    /** The Peer class */
    private static final org.apache.torque.test.PIntegerPkPeer peer
            = new org.apache.torque.test.PIntegerPkPeer();

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public org.apache.torque.test.PIntegerPkPeer getPeer()
    {
        return peer;
    }

    /**
     * Retrieves the TableMap object related to this Table data without
     * compiler warnings of using getPeer().getTableMap().
     *
     * @return The associated TableMap object.
     */
    public TableMap getTableMap() throws TorqueException
    {
        return org.apache.torque.test.PIntegerPkPeer.getTableMap();
    }



    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("PIntegerPk:\n");
        str.append("id = ")
           .append(getId())
           .append("\n");
        str.append("integerColumn = ")
           .append(getIntegerColumn())
           .append("\n");
        str.append("name = ")
           .append(getName())
           .append("\n");
        return(str.toString());
    }

    /**
     * Compares the primary key of this instance with the key of another.
     *
     * @param toCompare The object to compare to.
     * @return Whether the primary keys are equal and the object have the
     *         same class.
     */
    public boolean equals(Object toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!getClass().equals(toCompare.getClass()))
        {
            return false;
        }
        PIntegerPk other = (PIntegerPk) toCompare;
        if (getPrimaryKey() == null || other.getPrimaryKey() == null)
        {
            return false;
        }
        return getPrimaryKey().equals(other.getPrimaryKey());
    }

    /**
     * If the primary key is not <code>null</code>, return the hashcode of the
     * primary key.  Otherwise calls <code>Object.hashCode()</code>.
     *
     * @return an <code>int</code> value
     */
    public int hashCode()
    {
        ObjectKey ok = getPrimaryKey();
        if (ok == null)
        {
            return super.hashCode();
        }

        return ok.hashCode();
    }




}
