package org.apache.torque.test;

import java.sql.Blob;
import java.sql.Clob;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.sql.PreparedStatement;
import java.sql.Types;
import java.io.IOException;
import java.io.InputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.Reader;
import java.io.StringReader;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.torque.NoRowsException;
import org.apache.torque.TooManyRowsException;
import org.apache.torque.Torque;
import org.apache.torque.TorqueException;
import org.apache.torque.TorqueRuntimeException;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.criteria.Criterion;
import org.apache.torque.om.mapper.RecordMapper;
import org.apache.torque.om.mapper.CompositeMapper;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.ComboKey;
import org.apache.torque.map.TableMap;
import org.apache.torque.util.BasePeer;
import org.apache.torque.util.Transaction;
import org.apache.torque.util.ColumnValues;
import org.apache.torque.util.JdbcTypedValue;



/**
 * table with a primitive int pk
 *
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:45 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to PIntegerPkPeer
 */

public abstract class BasePIntegerPkPeerImpl
    extends org.apache.torque.util.BasePeerImpl<PIntegerPk>
{
    /** The class log. */
    private static Log log = LogFactory.getLog(BasePIntegerPkPeerImpl.class);

    /** Serial version */
    private static final long serialVersionUID = 1347503745584L;



    /**
     * Constructor.
     * The recordMapper, tableMap and databaseName fields are correctly
     * initialized.
     */
    public BasePIntegerPkPeerImpl()
    {
        this(new PIntegerPkRecordMapper(),
            PIntegerPkPeer.TABLE,
            PIntegerPkPeer.DATABASE_NAME);
    }

    /**
     * Constructor providing the objects to be injected as parameters.
     *
     * @param recordMapper a record mapper to map JDBC result sets to objects
     * @param tableMap the default table map
     * @param databaseName the name of the database
     */
    public BasePIntegerPkPeerImpl(
            RecordMapper<PIntegerPk> recordMapper, 
            TableMap tableMap,
            String databaseName)
    {
        super(recordMapper, tableMap, databaseName);
    }


    /**
     * Selects PIntegerPk objects from the database which have
     * the same content as the passed object.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<PIntegerPk> doSelect(PIntegerPk obj)
            throws TorqueException
    {
        return doSelect(buildSelectCriteria(obj));
    }

    /**
     * Selects at most one PIntegerPk object from the database
     * which has the same content as the passed object.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public PIntegerPk doSelectSingleRecord(
                PIntegerPk obj)
            throws TorqueException
    {
        List<PIntegerPk> pIntegerPkList = doSelect(obj);
        PIntegerPk pIntegerPk = null;
        if (pIntegerPkList.size() > 1)
        {
            throw new TooManyRowsException("Object " + obj 
                + " matched more than one record");
        }
        if (!pIntegerPkList.isEmpty())
        {
            pIntegerPk = pIntegerPkList.get(0);
        }
        return pIntegerPk;
    }

    /**
     * Returns a new instance of the Data object class
     */
    public PIntegerPk getDbObjectInstance()
    {
        return new PIntegerPk();
    }


    /**
     * Method to do inserts.
     *
     * @param columnValues the values to insert.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public ObjectKey doInsert(ColumnValues columnValues) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    PIntegerPkPeer.DATABASE_NAME);
            ObjectKey result = doInsert(columnValues, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(Criteria) method.
     *
     * @param columnValues the values to insert.
     * @param con the connection to use, not null.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public ObjectKey doInsert(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        correctBooleans(columnValues);
        return super.doInsert(columnValues, con);
    }

    /**
     * Method to do inserts
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public void doInsert(PIntegerPk obj) throws TorqueException
    {
        obj.setPrimaryKey(doInsert(buildColumnValues(obj)));
        obj.setNew(false);
        obj.setModified(false);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(PIntegerPk) method.  It will take
     * care of the connection details internally.
     *
     * @param obj the data object to insert into the database.
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public void doInsert(PIntegerPk obj, Connection con)
        throws TorqueException
    {
        ObjectKey primaryKey = doInsert(buildColumnValues(obj), con);
        if (primaryKey != null)
        {
            obj.setPrimaryKey(primaryKey);
        }
        obj.setNew(false);
        obj.setModified(false);
    }

    /**
     * Method to do updates.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(ColumnValues columnValues) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    PIntegerPkPeer.DATABASE_NAME);
            int result = doUpdate(columnValues, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Method to do updates.  This method is to be used during a transaction,
     * otherwise use the doUpdate(Criteria) method.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @param con the connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        Criteria selectCriteria 
                = new Criteria(PIntegerPkPeer.DATABASE_NAME);
        correctBooleans(columnValues);


    
        selectCriteria.where(
                PIntegerPkPeer.ID,
                columnValues.remove(PIntegerPkPeer.ID).getValue());


        return doUpdate(selectCriteria, columnValues, con);
    }

    /**
     * Updates an PIntegerPk in the database.
     * The primary key is used to identify the object to update.
     *
     * @param obj the data object to update in the database.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(PIntegerPk obj) throws TorqueException
    {
        ColumnValues columnValues = buildColumnValues(obj);
        int result = doUpdate(columnValues);
        obj.setModified(false);
        return result;
    }

    /**
     * Updates a PIntegerPk in the database.
     * The primary key is used to identify the object to update.
     * This method is to be used during a transaction,
     * otherwise the doUpdate(PIntegerPk) method can be used.
     *
     * @param obj the data object to update in the database.
     * @param con the connection to use, not null.
     
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(PIntegerPk obj, Connection con)
        throws TorqueException
    {
        ColumnValues columnValues = buildColumnValues(obj);
        int result = doUpdate(columnValues, con);
        obj.setModified(false);
        return result;
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     *
     * @param obj the data object to delete in the database, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(PIntegerPk obj) throws TorqueException
    {
        int result = doDelete(buildCriteria(obj.getPrimaryKey()));
        obj.setDeleted(true);
        return result;
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     * This method is to be used during a transaction, otherwise use the
     * doDelete(PIntegerPk) method.
     *
     * @param obj the data object to delete in the database, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(PIntegerPk obj, Connection con)
        throws TorqueException
    {
        int result = doDelete(buildCriteria(obj.getPrimaryKey()), con);
        obj.setDeleted(true);
        return result;
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     *
     * @param objects the data object to delete in the database, not null,
     *        may not contain null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(Collection<PIntegerPk> objects)
            throws TorqueException
    {
        int result = doDelete(buildPkCriteria(objects));
        for (PIntegerPk object : objects)
        {
            object.setDeleted(true);
        }
        return result;
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param objects the data objects to delete in the database, not null,
     *        may not contain null.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(
            Collection<PIntegerPk> objects,
            Connection con)
        throws TorqueException
    {
        int result = doDelete(buildPkCriteria(objects), con);
        for (PIntegerPk object : objects)
        {
            object.setDeleted(true);
        }
        return result;
    }

    /**
     * Deletes a row in the database.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(ObjectKey pk) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    PIntegerPkPeer.DATABASE_NAME);
            int deletedRows = doDelete(pk, connection);
            Transaction.commit(connection);
            connection = null;
            return deletedRows;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Deletes a row in the database.
     * This method is to be used during a transaction,
     * otherwise use the doDelete(ObjectKey) method.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(ObjectKey pk, Connection con)
        throws TorqueException
    {
        return doDelete(buildCriteria(pk), con);
    }

    /** 
     * Build a Criteria object which selects all objects which have a given
     * primary key.
     *
     * @param pk the primary key value to build the criteria from, not null.
     */
    public Criteria buildCriteria(ObjectKey pk)
    {
        Criteria criteria = new Criteria();
        criteria.and(PIntegerPkPeer.ID, pk);
        return criteria;
     }

    /** 
     * Build a Criteria object which selects all objects which primary keys
     * are contained in the passed collection.
     *
     * @param pks the primary key values to build the criteria from, not null,
     *        may not contain null.
     */
    public Criteria buildCriteria(Collection<ObjectKey> pks)
    {
        Criteria criteria = new Criteria();
        criteria.andIn(PIntegerPkPeer.ID, pks);
        return criteria;
     }


    /** 
     * Build a Criteria object which selects all passed objects using their
     * primary key. Objects which do not yet have a primary key are ignored.
     *
     * @param objects the objects to build the criteria from, not null,
     *        may not contain null.
     */
    public Criteria buildPkCriteria(
            Collection<PIntegerPk> objects)
    {
        List<ObjectKey> pks = new ArrayList<ObjectKey>(objects.size());
        for (PIntegerPk object : objects)
        {
            ObjectKey pk = object.getPrimaryKey();
            if (pk != null)
            {
                pks.add(pk);
            }
        }
        return buildCriteria(pks);
    }

    /** 
     * Build a Criteria object from the data object for this peer.
     * The primary key columns are only added if the object is not new.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public Criteria buildCriteria(PIntegerPk obj)
    {
        Criteria criteria = new Criteria(PIntegerPkPeer.DATABASE_NAME);
        if (!obj.isNew())
        {
            criteria.and(PIntegerPkPeer.ID, obj.getId());
        }
        criteria.and(PIntegerPkPeer.INTEGER_COLUMN, obj.getIntegerColumn());
        criteria.and(PIntegerPkPeer.NAME, obj.getName());
        return criteria;
    }

    /** 
     * Build a Criteria object from the data object for this peer,
     * skipping all binary columns.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public Criteria buildSelectCriteria(PIntegerPk obj)
    {
        Criteria criteria = new Criteria(PIntegerPkPeer.DATABASE_NAME);
        if (!obj.isNew())
        {
            criteria.and(PIntegerPkPeer.ID, obj.getId());
        }
        criteria.and(PIntegerPkPeer.INTEGER_COLUMN, obj.getIntegerColumn());
        criteria.and(PIntegerPkPeer.NAME, obj.getName());
        return criteria;
    }

    /** 
     * Returns the contents of the object as ColumnValues object.
     * Primary key columns which are generated on insertion are not
     * added to the returned object if they still have their initial
     * value. Also, columns which have the useDatabaseDefaultValue
     * flag set to true are also not added to the returned object
     * if they still have their initial value.
     *
     * @throws TorqueException if the table map cannot be retrieved
     *         (should not happen).
     */
    public ColumnValues buildColumnValues(PIntegerPk pIntegerPk)
            throws TorqueException
    {
        ColumnValues columnValues = new ColumnValues();
        if (!pIntegerPk.isNew() 
            || pIntegerPk.getId() != 0)
        {
            columnValues.put(
                    PIntegerPkPeer.ID,
                    new JdbcTypedValue(
                        pIntegerPk.getId(),
                        4));
        }
        columnValues.put(
                PIntegerPkPeer.INTEGER_COLUMN,
                new JdbcTypedValue(
                    pIntegerPk.getIntegerColumn(),
                    4));
        columnValues.put(
                PIntegerPkPeer.NAME,
                new JdbcTypedValue(
                    pIntegerPk.getName(),
                    12));
        return columnValues;
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public PIntegerPk retrieveByPK(int pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return retrieveByPK(SimpleKey.keyFor(pk));
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public PIntegerPk retrieveByPK(int pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return retrieveByPK(SimpleKey.keyFor(pk), con);
    }
    
    
    

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public PIntegerPk retrieveByPK(ObjectKey pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(PIntegerPkPeer.DATABASE_NAME);
            PIntegerPk result = retrieveByPK(pk, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public PIntegerPk retrieveByPK(ObjectKey pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        Criteria criteria = buildCriteria(pk);
        List<PIntegerPk> v = doSelect(criteria, con);
        if (v.size() == 0)
        {
            throw new NoRowsException("Failed to select a row.");
        }
        else if (v.size() > 1)
        {
            throw new TooManyRowsException("Failed to select only one row.");
        }
        else
        {
            return (PIntegerPk)v.get(0);
        }
    }


    /**
     * Retrieve a multiple objects by pk
     *
     * @param pks List of primary keys
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<PIntegerPk> retrieveByPKs(Collection<ObjectKey> pks)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(PIntegerPkPeer.DATABASE_NAME);
            List<PIntegerPk> result = retrieveByPKs(pks, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Retrieve multiple objects by pk
     *
     * @param pks List of primary keys
     * @param dbcon the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<PIntegerPk> retrieveByPKs(
                Collection<ObjectKey> pks,
                Connection dbcon)
            throws TorqueException
    {
        if (pks == null || pks.size() == 0)
        {
            return new ArrayList<PIntegerPk>();
        }
        Criteria criteria = buildCriteria(pks);
        List<PIntegerPk> result = doSelect(criteria, dbcon);
        return result;
    }





    /** 
     * Fills the referenced NullablePIntegerFk objects in the collNullablePIntegerFks fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     *
     * @return all read List<NullablePIntegerFk> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<NullablePIntegerFk> fillNullablePIntegerFks(
            Collection<PIntegerPk> toFill)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    PIntegerPkPeer.DATABASE_NAME);
            List<NullablePIntegerFk> result = fillNullablePIntegerFks(toFill, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /** 
     * Fills the referenced NullablePIntegerFk objects in the collNullablePIntegerFks fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read List<NullablePIntegerFk> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<NullablePIntegerFk> fillNullablePIntegerFks(
            Collection<PIntegerPk> toFill,
            Connection connection)
        throws TorqueException
    {
        Set<ObjectKey> localKeySet = new HashSet<ObjectKey>();
        for (PIntegerPk currentPIntegerPk : toFill)
        {
            ObjectKey localKey = currentPIntegerPk.getPrimaryKey();
            localKeySet.add(localKey);
        }

        int fillerChunkSize = getFillerChunkSize();
        Iterator<ObjectKey> localKeyIt = localKeySet.iterator();
        List<ObjectKey> localKeyListChunk
                = new ArrayList<ObjectKey>(fillerChunkSize);
        Map<ObjectKey, List<NullablePIntegerFk>> fkToNullablePIntegerFkMap
                = new HashMap<ObjectKey, List<NullablePIntegerFk>>();
        while (localKeyIt.hasNext())
        {
            ObjectKey currentKey = localKeyIt.next();
            localKeyListChunk.add(currentKey);
            if (localKeyListChunk.size() < fillerChunkSize
                && localKeyIt.hasNext())
            {
                continue;
            }

            Criteria criteria = new Criteria();
            criteria.andIn(NullablePIntegerFkPeer.FK, localKeyListChunk);
            List<NullablePIntegerFk> referencedNullablePIntegerFkList
                 = NullablePIntegerFkPeer.doSelect(
                     criteria,
                     connection);
            for (NullablePIntegerFk referencedObject : referencedNullablePIntegerFkList)
            {
                ObjectKey foreignKey = referencedObject.getForeignKeyForPIntegerPk();
                List<NullablePIntegerFk> objectsWithForeignKey 
                    = fkToNullablePIntegerFkMap.get(foreignKey);
                if (objectsWithForeignKey == null)
                {
                    objectsWithForeignKey = new ArrayList<NullablePIntegerFk>();
                    fkToNullablePIntegerFkMap.put(
                        foreignKey,
                        objectsWithForeignKey);
                }
                objectsWithForeignKey.add(referencedObject);
            }
            localKeyListChunk.clear();
        }

        List<NullablePIntegerFk> result = new ArrayList<NullablePIntegerFk>();
        for (PIntegerPk objectToFill : toFill)
        {
            objectToFill.initNullablePIntegerFks();
            objectToFill.getNullablePIntegerFks().clear();
            ObjectKey localKey = objectToFill.getPrimaryKey();
            List<NullablePIntegerFk> referencingList
                = fkToNullablePIntegerFkMap.get(localKey);
            if (referencingList == null)
            {
                continue;
            }
            for (NullablePIntegerFk referencing : referencingList)
            {
                // copy the referencing object for the case that more than one
                // toFill object references the same object; in this case
                // every toFillObject should have its own instance 
                // of the referencing object to remain consistent
                // with other Torque referencing object treatment
                NullablePIntegerFk referencingCopy = referencing.copy(false);
                // copy does not set primary key
                referencingCopy.setPrimaryKey(referencing.getPrimaryKey());
                objectToFill.addNullablePIntegerFk(referencingCopy);
                result.add(referencingCopy);
            }
        }
        return result;
    }
    /** 
     * Fills the referenced RequiredPIntegerFk objects in the collRequiredPIntegerFks fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     *
     * @return all read List<RequiredPIntegerFk> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<RequiredPIntegerFk> fillRequiredPIntegerFks(
            Collection<PIntegerPk> toFill)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    PIntegerPkPeer.DATABASE_NAME);
            List<RequiredPIntegerFk> result = fillRequiredPIntegerFks(toFill, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /** 
     * Fills the referenced RequiredPIntegerFk objects in the collRequiredPIntegerFks fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read List<RequiredPIntegerFk> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<RequiredPIntegerFk> fillRequiredPIntegerFks(
            Collection<PIntegerPk> toFill,
            Connection connection)
        throws TorqueException
    {
        Set<ObjectKey> localKeySet = new HashSet<ObjectKey>();
        for (PIntegerPk currentPIntegerPk : toFill)
        {
            ObjectKey localKey = currentPIntegerPk.getPrimaryKey();
            localKeySet.add(localKey);
        }

        int fillerChunkSize = getFillerChunkSize();
        Iterator<ObjectKey> localKeyIt = localKeySet.iterator();
        List<ObjectKey> localKeyListChunk
                = new ArrayList<ObjectKey>(fillerChunkSize);
        Map<ObjectKey, List<RequiredPIntegerFk>> fkToRequiredPIntegerFkMap
                = new HashMap<ObjectKey, List<RequiredPIntegerFk>>();
        while (localKeyIt.hasNext())
        {
            ObjectKey currentKey = localKeyIt.next();
            localKeyListChunk.add(currentKey);
            if (localKeyListChunk.size() < fillerChunkSize
                && localKeyIt.hasNext())
            {
                continue;
            }

            Criteria criteria = new Criteria();
            criteria.andIn(RequiredPIntegerFkPeer.FK, localKeyListChunk);
            List<RequiredPIntegerFk> referencedRequiredPIntegerFkList
                 = RequiredPIntegerFkPeer.doSelect(
                     criteria,
                     connection);
            for (RequiredPIntegerFk referencedObject : referencedRequiredPIntegerFkList)
            {
                ObjectKey foreignKey = referencedObject.getForeignKeyForPIntegerPk();
                List<RequiredPIntegerFk> objectsWithForeignKey 
                    = fkToRequiredPIntegerFkMap.get(foreignKey);
                if (objectsWithForeignKey == null)
                {
                    objectsWithForeignKey = new ArrayList<RequiredPIntegerFk>();
                    fkToRequiredPIntegerFkMap.put(
                        foreignKey,
                        objectsWithForeignKey);
                }
                objectsWithForeignKey.add(referencedObject);
            }
            localKeyListChunk.clear();
        }

        List<RequiredPIntegerFk> result = new ArrayList<RequiredPIntegerFk>();
        for (PIntegerPk objectToFill : toFill)
        {
            objectToFill.initRequiredPIntegerFks();
            objectToFill.getRequiredPIntegerFks().clear();
            ObjectKey localKey = objectToFill.getPrimaryKey();
            List<RequiredPIntegerFk> referencingList
                = fkToRequiredPIntegerFkMap.get(localKey);
            if (referencingList == null)
            {
                continue;
            }
            for (RequiredPIntegerFk referencing : referencingList)
            {
                // copy the referencing object for the case that more than one
                // toFill object references the same object; in this case
                // every toFillObject should have its own instance 
                // of the referencing object to remain consistent
                // with other Torque referencing object treatment
                RequiredPIntegerFk referencingCopy = referencing.copy(false);
                // copy does not set primary key
                referencingCopy.setPrimaryKey(referencing.getPrimaryKey());
                objectToFill.addRequiredPIntegerFk(referencingCopy);
                result.add(referencingCopy);
            }
        }
        return result;
    }
    /** 
     * Fills the referenced PIntegerFkWithDefault objects in the collPIntegerFkWithDefaults fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     *
     * @return all read List<PIntegerFkWithDefault> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<PIntegerFkWithDefault> fillPIntegerFkWithDefaults(
            Collection<PIntegerPk> toFill)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    PIntegerPkPeer.DATABASE_NAME);
            List<PIntegerFkWithDefault> result = fillPIntegerFkWithDefaults(toFill, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /** 
     * Fills the referenced PIntegerFkWithDefault objects in the collPIntegerFkWithDefaults fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read List<PIntegerFkWithDefault> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<PIntegerFkWithDefault> fillPIntegerFkWithDefaults(
            Collection<PIntegerPk> toFill,
            Connection connection)
        throws TorqueException
    {
        Set<ObjectKey> localKeySet = new HashSet<ObjectKey>();
        for (PIntegerPk currentPIntegerPk : toFill)
        {
            ObjectKey localKey = currentPIntegerPk.getPrimaryKey();
            localKeySet.add(localKey);
        }

        int fillerChunkSize = getFillerChunkSize();
        Iterator<ObjectKey> localKeyIt = localKeySet.iterator();
        List<ObjectKey> localKeyListChunk
                = new ArrayList<ObjectKey>(fillerChunkSize);
        Map<ObjectKey, List<PIntegerFkWithDefault>> fkToPIntegerFkWithDefaultMap
                = new HashMap<ObjectKey, List<PIntegerFkWithDefault>>();
        while (localKeyIt.hasNext())
        {
            ObjectKey currentKey = localKeyIt.next();
            localKeyListChunk.add(currentKey);
            if (localKeyListChunk.size() < fillerChunkSize
                && localKeyIt.hasNext())
            {
                continue;
            }

            Criteria criteria = new Criteria();
            criteria.andIn(PIntegerFkWithDefaultPeer.FK, localKeyListChunk);
            List<PIntegerFkWithDefault> referencedPIntegerFkWithDefaultList
                 = PIntegerFkWithDefaultPeer.doSelect(
                     criteria,
                     connection);
            for (PIntegerFkWithDefault referencedObject : referencedPIntegerFkWithDefaultList)
            {
                ObjectKey foreignKey = referencedObject.getForeignKeyForPIntegerPk();
                List<PIntegerFkWithDefault> objectsWithForeignKey 
                    = fkToPIntegerFkWithDefaultMap.get(foreignKey);
                if (objectsWithForeignKey == null)
                {
                    objectsWithForeignKey = new ArrayList<PIntegerFkWithDefault>();
                    fkToPIntegerFkWithDefaultMap.put(
                        foreignKey,
                        objectsWithForeignKey);
                }
                objectsWithForeignKey.add(referencedObject);
            }
            localKeyListChunk.clear();
        }

        List<PIntegerFkWithDefault> result = new ArrayList<PIntegerFkWithDefault>();
        for (PIntegerPk objectToFill : toFill)
        {
            objectToFill.initPIntegerFkWithDefaults();
            objectToFill.getPIntegerFkWithDefaults().clear();
            ObjectKey localKey = objectToFill.getPrimaryKey();
            List<PIntegerFkWithDefault> referencingList
                = fkToPIntegerFkWithDefaultMap.get(localKey);
            if (referencingList == null)
            {
                continue;
            }
            for (PIntegerFkWithDefault referencing : referencingList)
            {
                // copy the referencing object for the case that more than one
                // toFill object references the same object; in this case
                // every toFillObject should have its own instance 
                // of the referencing object to remain consistent
                // with other Torque referencing object treatment
                PIntegerFkWithDefault referencingCopy = referencing.copy(false);
                // copy does not set primary key
                referencingCopy.setPrimaryKey(referencing.getPrimaryKey());
                objectToFill.addPIntegerFkWithDefault(referencingCopy);
                result.add(referencingCopy);
            }
        }
        return result;
    }
    /** 
     * Fills the referenced NonPkPIntegerFk objects in the collNonPkPIntegerFks fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     *
     * @return all read List<NonPkPIntegerFk> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<NonPkPIntegerFk> fillNonPkPIntegerFks(
            Collection<PIntegerPk> toFill)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    PIntegerPkPeer.DATABASE_NAME);
            List<NonPkPIntegerFk> result = fillNonPkPIntegerFks(toFill, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /** 
     * Fills the referenced NonPkPIntegerFk objects in the collNonPkPIntegerFks fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read List<NonPkPIntegerFk> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<NonPkPIntegerFk> fillNonPkPIntegerFks(
            Collection<PIntegerPk> toFill,
            Connection connection)
        throws TorqueException
    {
        Set<ObjectKey> localKeySet = new HashSet<ObjectKey>();
        for (PIntegerPk currentPIntegerPk : toFill)
        {
            ObjectKey localKey = SimpleKey.keyFor(currentPIntegerPk.getIntegerColumn());
            localKeySet.add(localKey);
        }

        int fillerChunkSize = getFillerChunkSize();
        Iterator<ObjectKey> localKeyIt = localKeySet.iterator();
        List<ObjectKey> localKeyListChunk
                = new ArrayList<ObjectKey>(fillerChunkSize);
        Map<ObjectKey, List<NonPkPIntegerFk>> fkToNonPkPIntegerFkMap
                = new HashMap<ObjectKey, List<NonPkPIntegerFk>>();
        while (localKeyIt.hasNext())
        {
            ObjectKey currentKey = localKeyIt.next();
            localKeyListChunk.add(currentKey);
            if (localKeyListChunk.size() < fillerChunkSize
                && localKeyIt.hasNext())
            {
                continue;
            }

            Criteria criteria = new Criteria();
            criteria.andIn(NonPkPIntegerFkPeer.FK, localKeyListChunk);
            List<NonPkPIntegerFk> referencedNonPkPIntegerFkList
                 = NonPkPIntegerFkPeer.doSelect(
                     criteria,
                     connection);
            for (NonPkPIntegerFk referencedObject : referencedNonPkPIntegerFkList)
            {
                ObjectKey foreignKey = referencedObject.getForeignKeyForPIntegerPk();
                List<NonPkPIntegerFk> objectsWithForeignKey 
                    = fkToNonPkPIntegerFkMap.get(foreignKey);
                if (objectsWithForeignKey == null)
                {
                    objectsWithForeignKey = new ArrayList<NonPkPIntegerFk>();
                    fkToNonPkPIntegerFkMap.put(
                        foreignKey,
                        objectsWithForeignKey);
                }
                objectsWithForeignKey.add(referencedObject);
            }
            localKeyListChunk.clear();
        }

        List<NonPkPIntegerFk> result = new ArrayList<NonPkPIntegerFk>();
        for (PIntegerPk objectToFill : toFill)
        {
            objectToFill.initNonPkPIntegerFks();
            objectToFill.getNonPkPIntegerFks().clear();
            ObjectKey localKey = SimpleKey.keyFor(objectToFill.getIntegerColumn());
            List<NonPkPIntegerFk> referencingList
                = fkToNonPkPIntegerFkMap.get(localKey);
            if (referencingList == null)
            {
                continue;
            }
            for (NonPkPIntegerFk referencing : referencingList)
            {
                // copy the referencing object for the case that more than one
                // toFill object references the same object; in this case
                // every toFillObject should have its own instance 
                // of the referencing object to remain consistent
                // with other Torque referencing object treatment
                NonPkPIntegerFk referencingCopy = referencing.copy(false);
                // copy does not set primary key
                referencingCopy.setPrimaryKey(referencing.getPrimaryKey());
                objectToFill.addNonPkPIntegerFk(referencingCopy);
                result.add(referencingCopy);
            }
        }
        return result;
    }
    /** 
     * Fills the referenced OIntegerFkToPPk objects in the collOIntegerFkToPPks fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     *
     * @return all read List<OIntegerFkToPPk> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<OIntegerFkToPPk> fillOIntegerFkToPPks(
            Collection<PIntegerPk> toFill)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    PIntegerPkPeer.DATABASE_NAME);
            List<OIntegerFkToPPk> result = fillOIntegerFkToPPks(toFill, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /** 
     * Fills the referenced OIntegerFkToPPk objects in the collOIntegerFkToPPks fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read List<OIntegerFkToPPk> objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<OIntegerFkToPPk> fillOIntegerFkToPPks(
            Collection<PIntegerPk> toFill,
            Connection connection)
        throws TorqueException
    {
        Set<ObjectKey> localKeySet = new HashSet<ObjectKey>();
        for (PIntegerPk currentPIntegerPk : toFill)
        {
            ObjectKey localKey = currentPIntegerPk.getPrimaryKey();
            localKeySet.add(localKey);
        }

        int fillerChunkSize = getFillerChunkSize();
        Iterator<ObjectKey> localKeyIt = localKeySet.iterator();
        List<ObjectKey> localKeyListChunk
                = new ArrayList<ObjectKey>(fillerChunkSize);
        Map<ObjectKey, List<OIntegerFkToPPk>> fkToOIntegerFkToPPkMap
                = new HashMap<ObjectKey, List<OIntegerFkToPPk>>();
        while (localKeyIt.hasNext())
        {
            ObjectKey currentKey = localKeyIt.next();
            localKeyListChunk.add(currentKey);
            if (localKeyListChunk.size() < fillerChunkSize
                && localKeyIt.hasNext())
            {
                continue;
            }

            Criteria criteria = new Criteria();
            criteria.andIn(OIntegerFkToPPkPeer.FK, localKeyListChunk);
            List<OIntegerFkToPPk> referencedOIntegerFkToPPkList
                 = OIntegerFkToPPkPeer.doSelect(
                     criteria,
                     connection);
            for (OIntegerFkToPPk referencedObject : referencedOIntegerFkToPPkList)
            {
                ObjectKey foreignKey = referencedObject.getForeignKeyForPIntegerPk();
                List<OIntegerFkToPPk> objectsWithForeignKey 
                    = fkToOIntegerFkToPPkMap.get(foreignKey);
                if (objectsWithForeignKey == null)
                {
                    objectsWithForeignKey = new ArrayList<OIntegerFkToPPk>();
                    fkToOIntegerFkToPPkMap.put(
                        foreignKey,
                        objectsWithForeignKey);
                }
                objectsWithForeignKey.add(referencedObject);
            }
            localKeyListChunk.clear();
        }

        List<OIntegerFkToPPk> result = new ArrayList<OIntegerFkToPPk>();
        for (PIntegerPk objectToFill : toFill)
        {
            objectToFill.initOIntegerFkToPPks();
            objectToFill.getOIntegerFkToPPks().clear();
            ObjectKey localKey = objectToFill.getPrimaryKey();
            List<OIntegerFkToPPk> referencingList
                = fkToOIntegerFkToPPkMap.get(localKey);
            if (referencingList == null)
            {
                continue;
            }
            for (OIntegerFkToPPk referencing : referencingList)
            {
                // copy the referencing object for the case that more than one
                // toFill object references the same object; in this case
                // every toFillObject should have its own instance 
                // of the referencing object to remain consistent
                // with other Torque referencing object treatment
                OIntegerFkToPPk referencingCopy = referencing.copy(false);
                // copy does not set primary key
                referencingCopy.setPrimaryKey(referencing.getPrimaryKey());
                objectToFill.addOIntegerFkToPPk(referencingCopy);
                result.add(referencingCopy);
            }
        }
        return result;
    }

    /** 
     * Returns the chunk size for the filler methods.
     *
     * @return the chunk size for the filler methods.
     */
    protected int getFillerChunkSize()
    {
        return 999;
    }


}
