package org.apache.torque.test;

import java.io.Serializable;
import java.sql.Connection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.apache.torque.TorqueException;
import org.apache.torque.map.TableMap;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.BooleanKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.om.ColumnAccessByName;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.util.Transaction;
import org.apache.commons.lang.ObjectUtils;


/**
 * r_ab table
 *
 * This class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:38 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to RAb
 */
public abstract class BaseRAb 
    implements Persistent, Serializable, ColumnAccessByName
{
    /** Serial version */
    private static final long serialVersionUID = 1347503738240L;



    /** Defines the aId field. */
    private int aId = 0;

    /** Defines the bId field. */
    private int bId = 0;

    /** Defines the name field. */
    private String name = null;

    /** Whether this object was modified after loading or after last save. */
    private boolean modified = true;

    /** 
     * Whether this object was loaded from the database or already saved 
     * (false) or whether it is not yet in the database(true).
     */
    private boolean isNew = true;

    /** Flag which indicates whether this object is currently saving. */
    private boolean saving = false;

    /** 
     * Flag which indicates whether this object is currently loaded
     * from the database. 
     */
    private boolean loading = false;

    /** 
     * Flag which indicates whether this object was deleted from the database.
     * Note that this flags does not always display the current database state,
     * there is no magical connection between this flag and the database.
     */
    private boolean deleted = false;

    /** Defines the aA field. */
    private A aA = null;

    /** Defines the aB field. */
    private B aB = null;



    /** Defines the collCs field. */
    protected List<C> collCs = null;

    /** Defines the collDs field. */
    protected List<D> collDs = null;



    /**
     * Get the value of aId.
     *
     * @return int
     */
    public int getAId() 
    {
        
        return aId;
    }

    /**
     * Set the value of aId.
     *
     * @param v new value
     */
    public void setAId(int v)
    {
        if (this.aId != v)
        {
            setModified(true);
        }

        this.aId = v;
        if (aA != null && aA.getAId() != v)
        {
            aA = null;
        }

        // update associated objects in collCs 
        if (collCs != null)
        {
            for (int i = 0; i < collCs.size(); i++)
            {
                ((C) collCs.get(i))
                        .setAId(v);
            }
        }
        // update associated objects in collDs 
        if (collDs != null)
        {
            for (int i = 0; i < collDs.size(); i++)
            {
                ((D) collDs.get(i))
                        .setAId(v);
            }
        }

    }
    
    /**
     * Get the value of bId.
     *
     * @return int
     */
    public int getBId() 
    {
        
        return bId;
    }

    /**
     * Set the value of bId.
     *
     * @param v new value
     */
    public void setBId(int v)
    {
        if (this.bId != v)
        {
            setModified(true);
        }

        this.bId = v;
        if (aB != null && aB.getBId() != v)
        {
            aB = null;
        }

        // update associated objects in collCs 
        if (collCs != null)
        {
            for (int i = 0; i < collCs.size(); i++)
            {
                ((C) collCs.get(i))
                        .setBId(v);
            }
        }
        // update associated objects in collDs 
        if (collDs != null)
        {
            for (int i = 0; i < collDs.size(); i++)
            {
                ((D) collDs.get(i))
                        .setBId(v);
            }
        }

    }
    
    /**
     * Get the value of name.
     *
     * @return String
     */
    public String getName() 
    {
        
        return name;
    }

    /**
     * Set the value of name.
     *
     * @param v new value
     */
    public void setName(String v)
    {
        if (!ObjectUtils.equals(this.name, v))
        {
            setModified(true);
        }

        this.name = v;


    }
    

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return true, if the object has never been persisted.
     */
    public boolean isNew()
    {
        return isNew;
    }

    /**
     * Sets whether the object has ever been saved.
     *
     * @param isNew true if the object has never been saved, false otherwise.
     */
    public void setNew(boolean isNew)
    {
        this.isNew = isNew;
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return True if the object has been modified.
     */
    public boolean isModified()
    {
        return modified;
    }

    /**
     * Sets whether the object has been modified.
     *
     * @param modified true if the object has been modified, false otherwise.
     */
    public void setModified(boolean modified)
    {
        this.modified = modified;
    }

    /**
     * Sets the modified state for the object to be false.
     */
    public void resetModified()
    {
        modified = false;
    }


    /**
     * Returns whether this object is currently saving.
     *
     * @return true if this object is currently saving, false otherwise.
     */
    public boolean isSaving()
    {
        return saving;
    }

    /**
     * Sets whether this object is currently saving.
     *
     * @param saving true if this object is currently saving, false otherwise.
     */
    public void setSaving(boolean saving)
    {
        this.saving = saving;
    }


    /**
     * Returns whether this object is currently being loaded from the database.
     *
     * @return true if this object is currently loading, false otherwise.
     */
    public boolean isLoading()
    {
        return loading;
    }

    /**
     * Sets whether this object is currently being loaded from the database.
     *
     * @param loading true if this object is currently loading, false otherwise.
     */
    public void setLoading(boolean loading)
    {
        this.loading = loading;
    }


    /**
     * Returns whether this object was deleted from the database.
     * Note that this getter does not automatically reflect database state,
     * it will be set to true by Torque if doDelete() was called with this 
     * object. Bulk deletes and deletes via primary key do not change
     * this flag. Also, if doDelete() was called on an object which does
     * not exist in the database, the deleted flag is set to true even if
     * it was not deleted.
     *
     * @return true if this object was deleted, false otherwise.
     */
    public boolean isDeleted()
    {
        return deleted;
    }

    /**
     * Sets whether this object was deleted from the database.
     *
     * @param deleted true if this object was deleted, false otherwise.
     */
    public void setDeleted(boolean deleted)
    {
        this.deleted = deleted;
    }


    /**
     * Returns the associated A object.
     * If it was not retrieved before, the object is retrieved from
     * the database
     *
     * @return the associated A object
     * @throws TorqueException when reading from the database fails.
     */
    public A getA()
        throws TorqueException
    {
        if (aA == null && this.aId != 0)
        {
            aA = org.apache.torque.test.APeer.retrieveByPK(SimpleKey.keyFor(this.aId));
        }
        return aA;
    }

    /**
     * Return the associated A object
     * If it was not retrieved before, the object is retrieved from
     * the database using the passed connection
     *
     * @param connection the connection used to retrieve the associated object
     *        from the database, if it was not retrieved before
     * @return the associated A object
     * @throws TorqueException
     */
    public A getA(Connection connection)
        throws TorqueException
    {
        if (aA == null && this.aId != 0)
        {
            aA = org.apache.torque.test.APeer.retrieveByPK(SimpleKey.keyFor(this.aId), connection);
        }
        return aA;
    }


    /**
     * Declares an association between this object and a A object
     *
     * @param v A
     */
    public void setA(A v)
    {
        if (v == null)
        {
            setAId(0);
        }
        else
        {
            setAId(v.getAId());
        }
        aA = v;
    }
    /**
     * Provides convenient way to set a relationship based on a
     * ObjectKey, for example
     * <code>bar.setFooKey(foo.getPrimaryKey())</code>
     *
     */
    public void setAKey(ObjectKey key) throws TorqueException
    {
       
        setAId(((NumberKey) key).intValue());
     }

    /**
     * Returns the associated B object.
     * If it was not retrieved before, the object is retrieved from
     * the database
     *
     * @return the associated B object
     * @throws TorqueException when reading from the database fails.
     */
    public B getB()
        throws TorqueException
    {
        if (aB == null && this.bId != 0)
        {
            aB = org.apache.torque.test.BPeer.retrieveByPK(SimpleKey.keyFor(this.bId));
        }
        return aB;
    }

    /**
     * Return the associated B object
     * If it was not retrieved before, the object is retrieved from
     * the database using the passed connection
     *
     * @param connection the connection used to retrieve the associated object
     *        from the database, if it was not retrieved before
     * @return the associated B object
     * @throws TorqueException
     */
    public B getB(Connection connection)
        throws TorqueException
    {
        if (aB == null && this.bId != 0)
        {
            aB = org.apache.torque.test.BPeer.retrieveByPK(SimpleKey.keyFor(this.bId), connection);
        }
        return aB;
    }


    /**
     * Declares an association between this object and a B object
     *
     * @param v B
     */
    public void setB(B v)
    {
        if (v == null)
        {
            setBId(0);
        }
        else
        {
            setBId(v.getBId());
        }
        aB = v;
    }
    /**
     * Provides convenient way to set a relationship based on a
     * ObjectKey, for example
     * <code>bar.setFooKey(foo.getPrimaryKey())</code>
     *
     */
    public void setBKey(ObjectKey key) throws TorqueException
    {
       
        setBId(((NumberKey) key).intValue());
     }



    /**
     * Initializes the cache collCs for referenced objects. 
     */
    public void initCs()
    {
        if (collCs == null)
        {
            collCs = new ArrayList<C>();
        }
    }

    /**
     * Checks whether the cache collCs for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isCsInitialized()
    {
        return (collCs != null);
    }


    /**
     * Method called to associate a C object to this object
     * through the collCs foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addC(C toAdd)
        throws TorqueException
    {
        toAdd.setRAb((RAb) this);
        getCs().add(toAdd);
    }

    /**
     * Method called to associate a C object to this object
     * through the collCs foreign key attribute using connection.
     *
     * @param l C
     * @throws TorqueException
     */
    public void addC(C l, Connection con) throws TorqueException
    {
        getCs(con).add(l);
        l.setRAb((RAb) this);
    }
    
    /**
     * The criteria used to select the current contents of collCs
     */
    private Criteria lastCCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getCs(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<C> getCs()
        throws TorqueException
    {
        if (collCs == null)
        {
            collCs = getCs(new Criteria());
        }
        return collCs;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseRAb has previously
     * been saved, it will retrieve related collCs from storage.
     * If this BaseRAb is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<C> getCs(Criteria criteria) throws TorqueException
    {
        if (collCs == null)
        {
            if (isNew())
            {
               initCs();
            }
            else
            {
                criteria.and(org.apache.torque.test.CPeer.A_ID, getAId() );
                criteria.and(org.apache.torque.test.CPeer.B_ID, getBId() );
                collCs = org.apache.torque.test.CPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.CPeer.A_ID, getAId() );
                criteria.and(org.apache.torque.test.CPeer.B_ID, getBId() );
                if (lastCCriteria == null 
                        || !lastCCriteria.equals(criteria))
                {
                    collCs = org.apache.torque.test.CPeer.doSelect(criteria);
                }
            }
        }
        lastCCriteria = criteria;

        return collCs;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getCs(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<C> getCs(Connection con) throws TorqueException
    {
        if (collCs == null)
        {
            collCs = getCs(new Criteria(), con);
        }
        return collCs;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseRAb has previously
     * been saved, it will retrieve the related C Objects 
     * from storage.
     * If this BaseRAb is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<C> getCs(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collCs == null)
        {
            if (isNew())
            {
               initCs();
            }
            else
            {
                criteria.and(org.apache.torque.test.CPeer.A_ID, getAId());
                criteria.and(org.apache.torque.test.CPeer.B_ID, getBId());
                collCs = org.apache.torque.test.CPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.CPeer.A_ID, getAId());
                criteria.and(org.apache.torque.test.CPeer.B_ID, getBId());
                if (!lastCCriteria.equals(criteria))
                {
                    collCs = org.apache.torque.test.CPeer.doSelect(criteria, con);
                }
            }
        }
        lastCCriteria = criteria;

        return collCs;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseRAb is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<C> getCsJoinRAb(Criteria criteria) throws TorqueException
    {
        return getCsJoinRAb(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseRAb is new, it will return
     * an empty collection; or if this BaseRAb has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<C> getCsJoinRAb(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collCs == null)
        {
            if (isNew())
            {
                initCs();
            }
            else
            {
                criteria.and(org.apache.torque.test.CPeer.A_ID, getAId() );
                criteria.and(org.apache.torque.test.CPeer.B_ID, getBId() );
                collCs = org.apache.torque.test.CPeer.doSelectJoinRAb(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.CPeer.A_ID, getAId() );
            criteria.and(org.apache.torque.test.CPeer.B_ID, getBId() );
            if (!lastCCriteria.equals(criteria))
            {
                collCs = org.apache.torque.test.CPeer.doSelectJoinRAb(criteria, connection);
            }
        }
        lastCCriteria = criteria;

        return collCs;
    }

    /**
     * Initializes the cache collDs for referenced objects. 
     */
    public void initDs()
    {
        if (collDs == null)
        {
            collDs = new ArrayList<D>();
        }
    }

    /**
     * Checks whether the cache collDs for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isDsInitialized()
    {
        return (collDs != null);
    }


    /**
     * Method called to associate a D object to this object
     * through the collDs foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addD(D toAdd)
        throws TorqueException
    {
        toAdd.setRAb((RAb) this);
        getDs().add(toAdd);
    }

    /**
     * Method called to associate a D object to this object
     * through the collDs foreign key attribute using connection.
     *
     * @param l D
     * @throws TorqueException
     */
    public void addD(D l, Connection con) throws TorqueException
    {
        getDs(con).add(l);
        l.setRAb((RAb) this);
    }
    
    /**
     * The criteria used to select the current contents of collDs
     */
    private Criteria lastDCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getDs(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<D> getDs()
        throws TorqueException
    {
        if (collDs == null)
        {
            collDs = getDs(new Criteria());
        }
        return collDs;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseRAb has previously
     * been saved, it will retrieve related collDs from storage.
     * If this BaseRAb is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<D> getDs(Criteria criteria) throws TorqueException
    {
        if (collDs == null)
        {
            if (isNew())
            {
               initDs();
            }
            else
            {
                criteria.and(org.apache.torque.test.DPeer.A_ID, getAId() );
                criteria.and(org.apache.torque.test.DPeer.B_ID, getBId() );
                collDs = org.apache.torque.test.DPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.DPeer.A_ID, getAId() );
                criteria.and(org.apache.torque.test.DPeer.B_ID, getBId() );
                if (lastDCriteria == null 
                        || !lastDCriteria.equals(criteria))
                {
                    collDs = org.apache.torque.test.DPeer.doSelect(criteria);
                }
            }
        }
        lastDCriteria = criteria;

        return collDs;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getDs(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<D> getDs(Connection con) throws TorqueException
    {
        if (collDs == null)
        {
            collDs = getDs(new Criteria(), con);
        }
        return collDs;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseRAb has previously
     * been saved, it will retrieve the related D Objects 
     * from storage.
     * If this BaseRAb is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<D> getDs(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collDs == null)
        {
            if (isNew())
            {
               initDs();
            }
            else
            {
                criteria.and(org.apache.torque.test.DPeer.A_ID, getAId());
                criteria.and(org.apache.torque.test.DPeer.B_ID, getBId());
                collDs = org.apache.torque.test.DPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.DPeer.A_ID, getAId());
                criteria.and(org.apache.torque.test.DPeer.B_ID, getBId());
                if (!lastDCriteria.equals(criteria))
                {
                    collDs = org.apache.torque.test.DPeer.doSelect(criteria, con);
                }
            }
        }
        lastDCriteria = criteria;

        return collDs;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseRAb is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<D> getDsJoinRAb(Criteria criteria) throws TorqueException
    {
        return getDsJoinRAb(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseRAb is new, it will return
     * an empty collection; or if this BaseRAb has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<D> getDsJoinRAb(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collDs == null)
        {
            if (isNew())
            {
                initDs();
            }
            else
            {
                criteria.and(org.apache.torque.test.DPeer.A_ID, getAId() );
                criteria.and(org.apache.torque.test.DPeer.B_ID, getBId() );
                collDs = org.apache.torque.test.DPeer.doSelectJoinRAb(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.DPeer.A_ID, getAId() );
            criteria.and(org.apache.torque.test.DPeer.B_ID, getBId() );
            if (!lastDCriteria.equals(criteria))
            {
                collDs = org.apache.torque.test.DPeer.doSelectJoinRAb(criteria, connection);
            }
        }
        lastDCriteria = criteria;

        return collDs;
    }




    private static final List<String> FIELD_NAMES;

    static
    {
        List<String> fieldNames
                = new ArrayList<String>();
        fieldNames.add("AId");
        fieldNames.add("BId");
        fieldNames.add("Name");
        FIELD_NAMES = Collections.unmodifiableList(fieldNames);
    }

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static List<String> getFieldNames()
    {
        return FIELD_NAMES;
    }

    /**
     * Retrieves a field from the object by field (Java) name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
        if (name.equals("AId"))
        {
            return new Integer(getAId());
        }
        if (name.equals("BId"))
        {
            return new Integer(getBId());
        }
        if (name.equals("Name"))
        {
            return getName();
        }
        return null;
    }

    /**
     * Set a field in the object by field (Java) name.
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (name.equals("AId"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setAId(((Integer) value).intValue());
            return true;
        }
        if (name.equals("BId"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setBId(((Integer) value).intValue());
            return true;
        }
        if (name.equals("Name"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setName((String) value);
            return true;
        }
        return false;
    }

    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
        if (name.equals(org.apache.torque.test.RAbPeer.A_ID))
        {
            return new Integer(getAId());
        }
        if (name.equals(org.apache.torque.test.RAbPeer.B_ID))
        {
            return new Integer(getBId());
        }
        if (name.equals(org.apache.torque.test.RAbPeer.NAME))
        {
            return getName();
        }
        return null;
    }

    /**
     * Set field values by Peer Field Name
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPeerName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (org.apache.torque.test.RAbPeer.A_ID.getSqlExpression().equals(name))
        {
            return setByName("AId", value);
        }
        if (org.apache.torque.test.RAbPeer.B_ID.getSqlExpression().equals(name))
        {
            return setByName("BId", value);
        }
        if (org.apache.torque.test.RAbPeer.NAME.getSqlExpression().equals(name))
        {
            return setByName("Name", value);
        }
        return false;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
        if (pos == 0)
        {
            return new Integer(getAId());
        }
        if (pos == 1)
        {
            return new Integer(getBId());
        }
        if (pos == 2)
        {
            return getName();
        }
        return null;
    }

    /**
     * Set field values by its position (zero based) in the XML schema.
     *
     * @param position The field position
     * @param value field value
     * @return True if value was set, false if not (invalid position / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPosition(int position, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (position == 0)
        {
            return setByName("AId", value);
        }
        if (position == 1)
        {
            return setByName("BId", value);
        }
        if (position == 2)
        {
            return setByName("Name", value);
        }
        return false;
    }



    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save() throws TorqueException
    {
        save(RAbPeer.DATABASE_NAME);
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     * @param dbName the name of the database to which the object
     *        should be saved.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(String dbName) 
            throws TorqueException
    {
        Connection con = null;
        try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally.
     *
     * @param toSave the object to be saved, not null.
     * @param con the connection to use for saving the object, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(Connection con) 
            throws TorqueException
    {
        if (isSaving())
        {
            return;
        }
        try
        {
            setSaving(true);
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    RAbPeer.doInsert((RAb) this, con);
                    setNew(false);
                }
                else
                {
                    RAbPeer.doUpdate((RAb) this, con);
                }
            }

            if (isCsInitialized())
            {
                for (C collCs : getCs())
                {
                    collCs.save(con);
                }
            }
            if (isDsInitialized())
            {
                for (D collDs : getDs())
                {
                    collDs.save(con);
                }
            }
        }
        finally
        {
            setSaving(false);
        }
    }





    private final SimpleKey[] pks = new SimpleKey[2];
    private final ComboKey comboPK = new ComboKey(pks);

    /**
     * Set the PrimaryKey with an ObjectKey
     *
     * @param key
     */
    public void setPrimaryKey(ObjectKey key) throws TorqueException
    {
        SimpleKey[] keys = (SimpleKey[]) key.getValue();
        setAId(((NumberKey) keys[0]).intValue());
        setBId(((NumberKey) keys[1]).intValue());
    }

    /**
     * Set the PrimaryKey using SimpleKeys.
     *
     * @param int aId
     * @param int bId
     */
    public void setPrimaryKey(int aId, int bId)
        
    {
        setAId(aId);
        setBId(bId);
    }

    /**
     * Set the PrimaryKey using a String.
     */
    public void setPrimaryKey(String key) throws TorqueException
    {
        setPrimaryKey(new ComboKey(key));
    }

    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        SimpleKey[] pks = new SimpleKey[2];
        pks[0] = SimpleKey.keyFor(getAId());
        pks[1] = SimpleKey.keyFor(getBId());
        return new ComboKey(pks);
    }


    /**
     * Returns an id that differentiates the referenced A object
     * from all other A objects.
     *
     * @return an ObjectKey.
     */
    public ObjectKey getForeignKeyForA()
    {
        int foreignKey = getAId();
        if (foreignKey == 0)
        {
            return SimpleKey.keyFor((Number) null);
        }
        return SimpleKey.keyFor(foreignKey);
    }
    /**
     * Returns an id that differentiates the referenced B object
     * from all other B objects.
     *
     * @return an ObjectKey.
     */
    public ObjectKey getForeignKeyForB()
    {
        int foreignKey = getBId();
        if (foreignKey == 0)
        {
            return SimpleKey.keyFor((Number) null);
        }
        return SimpleKey.keyFor(foreignKey);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public RAb copy() throws TorqueException
    {
        return copy(true);
    }

    /**
     * Makes a copy of this object using a connection.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     *
     * @param con the database connection to read associated objects.
     */
    public RAb copy(Connection con) throws TorqueException
    {
        return copy(true, con);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     */
    public RAb copy(boolean deepcopy) throws TorqueException
    {
        RAb rAb = new RAb();

        return copyInto(rAb, deepcopy);
    }

    /**
     * Makes a copy of this object using connection.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @param con the database connection to read associated objects.
     */
    public RAb copy(boolean deepcopy, Connection con) throws TorqueException
    {
        RAb rAb = new RAb();

        return copyInto(rAb, deepcopy, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     */
    protected RAb copyInto(RAb copyObj) throws TorqueException
    {
        return copyInto(copyObj, true);
    }

    /**
     * Fills the copyObj with the contents of this object using connection.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param con the database connection to read associated objects.
     */
    protected RAb copyInto(RAb copyObj, Connection con) throws TorqueException
    {
        return copyInto(copyObj, true, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     */
    protected RAb copyInto(RAb copyObj, boolean deepcopy) throws TorqueException
    {
        copyObj.setAId(0);
        copyObj.setBId(0);
        copyObj.setName(name);

        if (deepcopy)
        {
            if (collCs != null)
            {
                for (int i = 0; i < collCs.size(); i++)
                {
                    C obj = collCs.get(i);
                    copyObj.addC(obj.copy());
                }
            }
            else
            {
                copyObj.collCs = null;
            }
            if (collDs != null)
            {
                for (int i = 0; i < collDs.size(); i++)
                {
                    D obj = collDs.get(i);
                    copyObj.addD(obj.copy());
                }
            }
            else
            {
                copyObj.collDs = null;
            }
        }
        return copyObj;
    }
        
    
    /**
     * Fills the copyObj with the contents of this object using connection.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @param con the database connection to read associated objects.
     */
    protected RAb copyInto(RAb copyObj, boolean deepcopy, Connection con) throws TorqueException
    {
        copyObj.setAId(0);
        copyObj.setBId(0);
        copyObj.setName(name);

        if (deepcopy)
        {
            for (C obj : getCs(con))
            {
                copyObj.addC(obj.copy());
            }
            for (D obj : getDs(con))
            {
                copyObj.addD(obj.copy());
            }
        }
        return copyObj;
    }

    /** The Peer class */
    private static final org.apache.torque.test.RAbPeer peer
            = new org.apache.torque.test.RAbPeer();

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public org.apache.torque.test.RAbPeer getPeer()
    {
        return peer;
    }

    /**
     * Retrieves the TableMap object related to this Table data without
     * compiler warnings of using getPeer().getTableMap().
     *
     * @return The associated TableMap object.
     */
    public TableMap getTableMap() throws TorqueException
    {
        return org.apache.torque.test.RAbPeer.getTableMap();
    }



    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("RAb:\n");
        str.append("aId = ")
           .append(getAId())
           .append("\n");
        str.append("bId = ")
           .append(getBId())
           .append("\n");
        str.append("name = ")
           .append(getName())
           .append("\n");
        return(str.toString());
    }

    /**
     * Compares the primary key of this instance with the key of another.
     *
     * @param toCompare The object to compare to.
     * @return Whether the primary keys are equal and the object have the
     *         same class.
     */
    public boolean equals(Object toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!getClass().equals(toCompare.getClass()))
        {
            return false;
        }
        RAb other = (RAb) toCompare;
        if (getPrimaryKey() == null || other.getPrimaryKey() == null)
        {
            return false;
        }
        return getPrimaryKey().equals(other.getPrimaryKey());
    }

    /**
     * If the primary key is not <code>null</code>, return the hashcode of the
     * primary key.  Otherwise calls <code>Object.hashCode()</code>.
     *
     * @return an <code>int</code> value
     */
    public int hashCode()
    {
        ObjectKey ok = getPrimaryKey();
        if (ok == null)
        {
            return super.hashCode();
        }

        return ok.hashCode();
    }




}
