package org.apache.torque.test;

import java.io.Serializable;
import java.sql.Connection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.apache.torque.TorqueException;
import org.apache.torque.map.TableMap;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.BooleanKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.om.ColumnAccessByName;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.util.Transaction;
import org.apache.commons.lang.ObjectUtils;


/**
 * This class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:40 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to ReferenceToIncluded
 */
public abstract class BaseReferenceToIncluded 
    implements Persistent, Serializable, ColumnAccessByName
{
    /** Serial version */
    private static final long serialVersionUID = 1347503740246L;



    /** Defines the id field. */
    private int id = 0;

    /** Defines the includedId field. */
    private int includedId = 0;

    /** Defines the includedFromIncludedId field. */
    private int includedFromIncludedId = 0;

    /** Whether this object was modified after loading or after last save. */
    private boolean modified = true;

    /** 
     * Whether this object was loaded from the database or already saved 
     * (false) or whether it is not yet in the database(true).
     */
    private boolean isNew = true;

    /** Flag which indicates whether this object is currently saving. */
    private boolean saving = false;

    /** 
     * Flag which indicates whether this object is currently loaded
     * from the database. 
     */
    private boolean loading = false;

    /** 
     * Flag which indicates whether this object was deleted from the database.
     * Note that this flags does not always display the current database state,
     * there is no magical connection between this flag and the database.
     */
    private boolean deleted = false;

    /** Defines the aIncluded field. */
    private Included aIncluded = null;

    /** Defines the aIncludedFromIncluded field. */
    private IncludedFromIncluded aIncludedFromIncluded = null;



    /** Defines the collIncludeds field. */
    protected List<Included> collIncludeds = null;

    /** Defines the collIncludedFromIncludeds field. */
    protected List<IncludedFromIncluded> collIncludedFromIncludeds = null;



    /**
     * Get the value of id.
     *
     * @return int
     */
    public int getId() 
    {
        
        return id;
    }

    /**
     * Set the value of id.
     *
     * @param v new value
     */
    public void setId(int v)
    {
        if (this.id != v)
        {
            setModified(true);
        }

        this.id = v;

        // update associated objects in collIncludeds 
        if (collIncludeds != null)
        {
            for (int i = 0; i < collIncludeds.size(); i++)
            {
                ((Included) collIncludeds.get(i))
                        .setReferenceToIncludedId(v);
            }
        }
        // update associated objects in collIncludedFromIncludeds 
        if (collIncludedFromIncludeds != null)
        {
            for (int i = 0; i < collIncludedFromIncludeds.size(); i++)
            {
                ((IncludedFromIncluded) collIncludedFromIncludeds.get(i))
                        .setReferenceToIncludedId(v);
            }
        }

    }
    
    /**
     * Get the value of includedId.
     *
     * @return int
     */
    public int getIncludedId() 
    {
        
        return includedId;
    }

    /**
     * Set the value of includedId.
     *
     * @param v new value
     */
    public void setIncludedId(int v)
    {
        if (this.includedId != v)
        {
            setModified(true);
        }

        this.includedId = v;
        if (aIncluded != null && aIncluded.getId() != v)
        {
            aIncluded = null;
        }


    }
    
    /**
     * Get the value of includedFromIncludedId.
     *
     * @return int
     */
    public int getIncludedFromIncludedId() 
    {
        
        return includedFromIncludedId;
    }

    /**
     * Set the value of includedFromIncludedId.
     *
     * @param v new value
     */
    public void setIncludedFromIncludedId(int v)
    {
        if (this.includedFromIncludedId != v)
        {
            setModified(true);
        }

        this.includedFromIncludedId = v;
        if (aIncludedFromIncluded != null && aIncludedFromIncluded.getId() != v)
        {
            aIncludedFromIncluded = null;
        }


    }
    

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return true, if the object has never been persisted.
     */
    public boolean isNew()
    {
        return isNew;
    }

    /**
     * Sets whether the object has ever been saved.
     *
     * @param isNew true if the object has never been saved, false otherwise.
     */
    public void setNew(boolean isNew)
    {
        this.isNew = isNew;
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return True if the object has been modified.
     */
    public boolean isModified()
    {
        return modified;
    }

    /**
     * Sets whether the object has been modified.
     *
     * @param modified true if the object has been modified, false otherwise.
     */
    public void setModified(boolean modified)
    {
        this.modified = modified;
    }

    /**
     * Sets the modified state for the object to be false.
     */
    public void resetModified()
    {
        modified = false;
    }


    /**
     * Returns whether this object is currently saving.
     *
     * @return true if this object is currently saving, false otherwise.
     */
    public boolean isSaving()
    {
        return saving;
    }

    /**
     * Sets whether this object is currently saving.
     *
     * @param saving true if this object is currently saving, false otherwise.
     */
    public void setSaving(boolean saving)
    {
        this.saving = saving;
    }


    /**
     * Returns whether this object is currently being loaded from the database.
     *
     * @return true if this object is currently loading, false otherwise.
     */
    public boolean isLoading()
    {
        return loading;
    }

    /**
     * Sets whether this object is currently being loaded from the database.
     *
     * @param loading true if this object is currently loading, false otherwise.
     */
    public void setLoading(boolean loading)
    {
        this.loading = loading;
    }


    /**
     * Returns whether this object was deleted from the database.
     * Note that this getter does not automatically reflect database state,
     * it will be set to true by Torque if doDelete() was called with this 
     * object. Bulk deletes and deletes via primary key do not change
     * this flag. Also, if doDelete() was called on an object which does
     * not exist in the database, the deleted flag is set to true even if
     * it was not deleted.
     *
     * @return true if this object was deleted, false otherwise.
     */
    public boolean isDeleted()
    {
        return deleted;
    }

    /**
     * Sets whether this object was deleted from the database.
     *
     * @param deleted true if this object was deleted, false otherwise.
     */
    public void setDeleted(boolean deleted)
    {
        this.deleted = deleted;
    }


    /**
     * Returns the associated Included object.
     * If it was not retrieved before, the object is retrieved from
     * the database
     *
     * @return the associated Included object
     * @throws TorqueException when reading from the database fails.
     */
    public Included getIncluded()
        throws TorqueException
    {
        if (aIncluded == null && this.includedId != 0)
        {
            aIncluded = org.apache.torque.test.IncludedPeer.retrieveByPK(SimpleKey.keyFor(this.includedId));
        }
        return aIncluded;
    }

    /**
     * Return the associated Included object
     * If it was not retrieved before, the object is retrieved from
     * the database using the passed connection
     *
     * @param connection the connection used to retrieve the associated object
     *        from the database, if it was not retrieved before
     * @return the associated Included object
     * @throws TorqueException
     */
    public Included getIncluded(Connection connection)
        throws TorqueException
    {
        if (aIncluded == null && this.includedId != 0)
        {
            aIncluded = org.apache.torque.test.IncludedPeer.retrieveByPK(SimpleKey.keyFor(this.includedId), connection);
        }
        return aIncluded;
    }


    /**
     * Declares an association between this object and a Included object
     *
     * @param v Included
     */
    public void setIncluded(Included v)
    {
        if (v == null)
        {
            setIncludedId(0);
        }
        else
        {
            setIncludedId(v.getId());
        }
        aIncluded = v;
    }
    /**
     * Provides convenient way to set a relationship based on a
     * ObjectKey, for example
     * <code>bar.setFooKey(foo.getPrimaryKey())</code>
     *
     */
    public void setIncludedKey(ObjectKey key) throws TorqueException
    {
       
        setIncludedId(((NumberKey) key).intValue());
     }

    /**
     * Returns the associated IncludedFromIncluded object.
     * If it was not retrieved before, the object is retrieved from
     * the database
     *
     * @return the associated IncludedFromIncluded object
     * @throws TorqueException when reading from the database fails.
     */
    public IncludedFromIncluded getIncludedFromIncluded()
        throws TorqueException
    {
        if (aIncludedFromIncluded == null && this.includedFromIncludedId != 0)
        {
            aIncludedFromIncluded = org.apache.torque.test.IncludedFromIncludedPeer.retrieveByPK(SimpleKey.keyFor(this.includedFromIncludedId));
        }
        return aIncludedFromIncluded;
    }

    /**
     * Return the associated IncludedFromIncluded object
     * If it was not retrieved before, the object is retrieved from
     * the database using the passed connection
     *
     * @param connection the connection used to retrieve the associated object
     *        from the database, if it was not retrieved before
     * @return the associated IncludedFromIncluded object
     * @throws TorqueException
     */
    public IncludedFromIncluded getIncludedFromIncluded(Connection connection)
        throws TorqueException
    {
        if (aIncludedFromIncluded == null && this.includedFromIncludedId != 0)
        {
            aIncludedFromIncluded = org.apache.torque.test.IncludedFromIncludedPeer.retrieveByPK(SimpleKey.keyFor(this.includedFromIncludedId), connection);
        }
        return aIncludedFromIncluded;
    }


    /**
     * Declares an association between this object and a IncludedFromIncluded object
     *
     * @param v IncludedFromIncluded
     */
    public void setIncludedFromIncluded(IncludedFromIncluded v)
    {
        if (v == null)
        {
            setIncludedFromIncludedId(0);
        }
        else
        {
            setIncludedFromIncludedId(v.getId());
        }
        aIncludedFromIncluded = v;
    }
    /**
     * Provides convenient way to set a relationship based on a
     * ObjectKey, for example
     * <code>bar.setFooKey(foo.getPrimaryKey())</code>
     *
     */
    public void setIncludedFromIncludedKey(ObjectKey key) throws TorqueException
    {
       
        setIncludedFromIncludedId(((NumberKey) key).intValue());
     }



    /**
     * Initializes the cache collIncludeds for referenced objects. 
     */
    public void initIncludeds()
    {
        if (collIncludeds == null)
        {
            collIncludeds = new ArrayList<Included>();
        }
    }

    /**
     * Checks whether the cache collIncludeds for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isIncludedsInitialized()
    {
        return (collIncludeds != null);
    }


    /**
     * Method called to associate a Included object to this object
     * through the collIncludeds foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addIncluded(Included toAdd)
        throws TorqueException
    {
        toAdd.setReferenceToIncluded((ReferenceToIncluded) this);
        getIncludeds().add(toAdd);
    }

    /**
     * Method called to associate a Included object to this object
     * through the collIncludeds foreign key attribute using connection.
     *
     * @param l Included
     * @throws TorqueException
     */
    public void addIncluded(Included l, Connection con) throws TorqueException
    {
        getIncludeds(con).add(l);
        l.setReferenceToIncluded((ReferenceToIncluded) this);
    }
    
    /**
     * The criteria used to select the current contents of collIncludeds
     */
    private Criteria lastIncludedCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getIncludeds(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<Included> getIncludeds()
        throws TorqueException
    {
        if (collIncludeds == null)
        {
            collIncludeds = getIncludeds(new Criteria());
        }
        return collIncludeds;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseReferenceToIncluded has previously
     * been saved, it will retrieve related collIncludeds from storage.
     * If this BaseReferenceToIncluded is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<Included> getIncludeds(Criteria criteria) throws TorqueException
    {
        if (collIncludeds == null)
        {
            if (isNew())
            {
               initIncludeds();
            }
            else
            {
                criteria.and(org.apache.torque.test.IncludedPeer.REFERENCE_TO_INCLUDED_ID, getId() );
                collIncludeds = org.apache.torque.test.IncludedPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.IncludedPeer.REFERENCE_TO_INCLUDED_ID, getId() );
                if (lastIncludedCriteria == null 
                        || !lastIncludedCriteria.equals(criteria))
                {
                    collIncludeds = org.apache.torque.test.IncludedPeer.doSelect(criteria);
                }
            }
        }
        lastIncludedCriteria = criteria;

        return collIncludeds;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getIncludeds(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<Included> getIncludeds(Connection con) throws TorqueException
    {
        if (collIncludeds == null)
        {
            collIncludeds = getIncludeds(new Criteria(), con);
        }
        return collIncludeds;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseReferenceToIncluded has previously
     * been saved, it will retrieve the related Included Objects 
     * from storage.
     * If this BaseReferenceToIncluded is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<Included> getIncludeds(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collIncludeds == null)
        {
            if (isNew())
            {
               initIncludeds();
            }
            else
            {
                criteria.and(org.apache.torque.test.IncludedPeer.REFERENCE_TO_INCLUDED_ID, getId());
                collIncludeds = org.apache.torque.test.IncludedPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.IncludedPeer.REFERENCE_TO_INCLUDED_ID, getId());
                if (!lastIncludedCriteria.equals(criteria))
                {
                    collIncludeds = org.apache.torque.test.IncludedPeer.doSelect(criteria, con);
                }
            }
        }
        lastIncludedCriteria = criteria;

        return collIncludeds;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseReferenceToIncluded is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<Included> getIncludedsJoinReferenceToIncluded(Criteria criteria) throws TorqueException
    {
        return getIncludedsJoinReferenceToIncluded(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseReferenceToIncluded is new, it will return
     * an empty collection; or if this BaseReferenceToIncluded has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<Included> getIncludedsJoinReferenceToIncluded(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collIncludeds == null)
        {
            if (isNew())
            {
                initIncludeds();
            }
            else
            {
                criteria.and(org.apache.torque.test.IncludedPeer.REFERENCE_TO_INCLUDED_ID, getId() );
                collIncludeds = org.apache.torque.test.IncludedPeer.doSelectJoinReferenceToIncluded(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.IncludedPeer.REFERENCE_TO_INCLUDED_ID, getId() );
            if (!lastIncludedCriteria.equals(criteria))
            {
                collIncludeds = org.apache.torque.test.IncludedPeer.doSelectJoinReferenceToIncluded(criteria, connection);
            }
        }
        lastIncludedCriteria = criteria;

        return collIncludeds;
    }

    /**
     * Initializes the cache collIncludedFromIncludeds for referenced objects. 
     */
    public void initIncludedFromIncludeds()
    {
        if (collIncludedFromIncludeds == null)
        {
            collIncludedFromIncludeds = new ArrayList<IncludedFromIncluded>();
        }
    }

    /**
     * Checks whether the cache collIncludedFromIncludeds for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isIncludedFromIncludedsInitialized()
    {
        return (collIncludedFromIncludeds != null);
    }


    /**
     * Method called to associate a IncludedFromIncluded object to this object
     * through the collIncludedFromIncludeds foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addIncludedFromIncluded(IncludedFromIncluded toAdd)
        throws TorqueException
    {
        toAdd.setReferenceToIncluded((ReferenceToIncluded) this);
        getIncludedFromIncludeds().add(toAdd);
    }

    /**
     * Method called to associate a IncludedFromIncluded object to this object
     * through the collIncludedFromIncludeds foreign key attribute using connection.
     *
     * @param l IncludedFromIncluded
     * @throws TorqueException
     */
    public void addIncludedFromIncluded(IncludedFromIncluded l, Connection con) throws TorqueException
    {
        getIncludedFromIncludeds(con).add(l);
        l.setReferenceToIncluded((ReferenceToIncluded) this);
    }
    
    /**
     * The criteria used to select the current contents of collIncludedFromIncludeds
     */
    private Criteria lastIncludedFromIncludedCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getIncludedFromIncludeds(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<IncludedFromIncluded> getIncludedFromIncludeds()
        throws TorqueException
    {
        if (collIncludedFromIncludeds == null)
        {
            collIncludedFromIncludeds = getIncludedFromIncludeds(new Criteria());
        }
        return collIncludedFromIncludeds;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseReferenceToIncluded has previously
     * been saved, it will retrieve related collIncludedFromIncludeds from storage.
     * If this BaseReferenceToIncluded is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<IncludedFromIncluded> getIncludedFromIncludeds(Criteria criteria) throws TorqueException
    {
        if (collIncludedFromIncludeds == null)
        {
            if (isNew())
            {
               initIncludedFromIncludeds();
            }
            else
            {
                criteria.and(org.apache.torque.test.IncludedFromIncludedPeer.REFERENCE_TO_INCLUDED_ID, getId() );
                collIncludedFromIncludeds = org.apache.torque.test.IncludedFromIncludedPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.IncludedFromIncludedPeer.REFERENCE_TO_INCLUDED_ID, getId() );
                if (lastIncludedFromIncludedCriteria == null 
                        || !lastIncludedFromIncludedCriteria.equals(criteria))
                {
                    collIncludedFromIncludeds = org.apache.torque.test.IncludedFromIncludedPeer.doSelect(criteria);
                }
            }
        }
        lastIncludedFromIncludedCriteria = criteria;

        return collIncludedFromIncludeds;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getIncludedFromIncludeds(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<IncludedFromIncluded> getIncludedFromIncludeds(Connection con) throws TorqueException
    {
        if (collIncludedFromIncludeds == null)
        {
            collIncludedFromIncludeds = getIncludedFromIncludeds(new Criteria(), con);
        }
        return collIncludedFromIncludeds;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseReferenceToIncluded has previously
     * been saved, it will retrieve the related IncludedFromIncluded Objects 
     * from storage.
     * If this BaseReferenceToIncluded is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<IncludedFromIncluded> getIncludedFromIncludeds(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collIncludedFromIncludeds == null)
        {
            if (isNew())
            {
               initIncludedFromIncludeds();
            }
            else
            {
                criteria.and(org.apache.torque.test.IncludedFromIncludedPeer.REFERENCE_TO_INCLUDED_ID, getId());
                collIncludedFromIncludeds = org.apache.torque.test.IncludedFromIncludedPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.IncludedFromIncludedPeer.REFERENCE_TO_INCLUDED_ID, getId());
                if (!lastIncludedFromIncludedCriteria.equals(criteria))
                {
                    collIncludedFromIncludeds = org.apache.torque.test.IncludedFromIncludedPeer.doSelect(criteria, con);
                }
            }
        }
        lastIncludedFromIncludedCriteria = criteria;

        return collIncludedFromIncludeds;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseReferenceToIncluded is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<IncludedFromIncluded> getIncludedFromIncludedsJoinReferenceToIncluded(Criteria criteria) throws TorqueException
    {
        return getIncludedFromIncludedsJoinReferenceToIncluded(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseReferenceToIncluded is new, it will return
     * an empty collection; or if this BaseReferenceToIncluded has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<IncludedFromIncluded> getIncludedFromIncludedsJoinReferenceToIncluded(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collIncludedFromIncludeds == null)
        {
            if (isNew())
            {
                initIncludedFromIncludeds();
            }
            else
            {
                criteria.and(org.apache.torque.test.IncludedFromIncludedPeer.REFERENCE_TO_INCLUDED_ID, getId() );
                collIncludedFromIncludeds = org.apache.torque.test.IncludedFromIncludedPeer.doSelectJoinReferenceToIncluded(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.IncludedFromIncludedPeer.REFERENCE_TO_INCLUDED_ID, getId() );
            if (!lastIncludedFromIncludedCriteria.equals(criteria))
            {
                collIncludedFromIncludeds = org.apache.torque.test.IncludedFromIncludedPeer.doSelectJoinReferenceToIncluded(criteria, connection);
            }
        }
        lastIncludedFromIncludedCriteria = criteria;

        return collIncludedFromIncludeds;
    }




    private static final List<String> FIELD_NAMES;

    static
    {
        List<String> fieldNames
                = new ArrayList<String>();
        fieldNames.add("Id");
        fieldNames.add("IncludedId");
        fieldNames.add("IncludedFromIncludedId");
        FIELD_NAMES = Collections.unmodifiableList(fieldNames);
    }

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static List<String> getFieldNames()
    {
        return FIELD_NAMES;
    }

    /**
     * Retrieves a field from the object by field (Java) name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
        if (name.equals("Id"))
        {
            return new Integer(getId());
        }
        if (name.equals("IncludedId"))
        {
            return new Integer(getIncludedId());
        }
        if (name.equals("IncludedFromIncludedId"))
        {
            return new Integer(getIncludedFromIncludedId());
        }
        return null;
    }

    /**
     * Set a field in the object by field (Java) name.
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (name.equals("Id"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setId(((Integer) value).intValue());
            return true;
        }
        if (name.equals("IncludedId"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setIncludedId(((Integer) value).intValue());
            return true;
        }
        if (name.equals("IncludedFromIncludedId"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setIncludedFromIncludedId(((Integer) value).intValue());
            return true;
        }
        return false;
    }

    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
        if (name.equals(org.apache.torque.test.ReferenceToIncludedPeer.ID))
        {
            return new Integer(getId());
        }
        if (name.equals(org.apache.torque.test.ReferenceToIncludedPeer.INCLUDED_ID))
        {
            return new Integer(getIncludedId());
        }
        if (name.equals(org.apache.torque.test.ReferenceToIncludedPeer.INCLUDED_FROM_INCLUDED_ID))
        {
            return new Integer(getIncludedFromIncludedId());
        }
        return null;
    }

    /**
     * Set field values by Peer Field Name
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPeerName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (org.apache.torque.test.ReferenceToIncludedPeer.ID.getSqlExpression().equals(name))
        {
            return setByName("Id", value);
        }
        if (org.apache.torque.test.ReferenceToIncludedPeer.INCLUDED_ID.getSqlExpression().equals(name))
        {
            return setByName("IncludedId", value);
        }
        if (org.apache.torque.test.ReferenceToIncludedPeer.INCLUDED_FROM_INCLUDED_ID.getSqlExpression().equals(name))
        {
            return setByName("IncludedFromIncludedId", value);
        }
        return false;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
        if (pos == 0)
        {
            return new Integer(getId());
        }
        if (pos == 1)
        {
            return new Integer(getIncludedId());
        }
        if (pos == 2)
        {
            return new Integer(getIncludedFromIncludedId());
        }
        return null;
    }

    /**
     * Set field values by its position (zero based) in the XML schema.
     *
     * @param position The field position
     * @param value field value
     * @return True if value was set, false if not (invalid position / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPosition(int position, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (position == 0)
        {
            return setByName("Id", value);
        }
        if (position == 1)
        {
            return setByName("IncludedId", value);
        }
        if (position == 2)
        {
            return setByName("IncludedFromIncludedId", value);
        }
        return false;
    }



    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save() throws TorqueException
    {
        save(ReferenceToIncludedPeer.DATABASE_NAME);
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     * @param dbName the name of the database to which the object
     *        should be saved.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(String dbName) 
            throws TorqueException
    {
        Connection con = null;
        try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally.
     *
     * @param toSave the object to be saved, not null.
     * @param con the connection to use for saving the object, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(Connection con) 
            throws TorqueException
    {
        if (isSaving())
        {
            return;
        }
        try
        {
            setSaving(true);
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    ReferenceToIncludedPeer.doInsert((ReferenceToIncluded) this, con);
                    setNew(false);
                }
                else
                {
                    ReferenceToIncludedPeer.doUpdate((ReferenceToIncluded) this, con);
                }
            }

            if (isIncludedsInitialized())
            {
                for (Included collIncludeds : getIncludeds())
                {
                    collIncludeds.save(con);
                }
            }
            if (isIncludedFromIncludedsInitialized())
            {
                for (IncludedFromIncluded collIncludedFromIncludeds : getIncludedFromIncludeds())
                {
                    collIncludedFromIncludeds.save(con);
                }
            }
        }
        finally
        {
            setSaving(false);
        }
    }




    /**
     * Set the PrimaryKey using ObjectKey.
     *
     * @param key id ObjectKey
     */
    public void setPrimaryKey(ObjectKey key)
        
    {
        setId(((NumberKey) key).intValue());
    }

    /**
     * Set the PrimaryKey using a String.
     *
     * @param key
     */
    public void setPrimaryKey(String key) 
    {
        setId(Integer.parseInt(key));
    }


    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        return SimpleKey.keyFor(getId());
    }


    /**
     * Returns an id that differentiates the referenced Included object
     * from all other Included objects.
     *
     * @return an ObjectKey.
     */
    public ObjectKey getForeignKeyForIncluded()
    {
        int foreignKey = getIncludedId();
        if (foreignKey == 0)
        {
            return SimpleKey.keyFor((Number) null);
        }
        return SimpleKey.keyFor(foreignKey);
    }
    /**
     * Returns an id that differentiates the referenced IncludedFromIncluded object
     * from all other IncludedFromIncluded objects.
     *
     * @return an ObjectKey.
     */
    public ObjectKey getForeignKeyForIncludedFromIncluded()
    {
        int foreignKey = getIncludedFromIncludedId();
        if (foreignKey == 0)
        {
            return SimpleKey.keyFor((Number) null);
        }
        return SimpleKey.keyFor(foreignKey);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public ReferenceToIncluded copy() throws TorqueException
    {
        return copy(true);
    }

    /**
     * Makes a copy of this object using a connection.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     *
     * @param con the database connection to read associated objects.
     */
    public ReferenceToIncluded copy(Connection con) throws TorqueException
    {
        return copy(true, con);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     */
    public ReferenceToIncluded copy(boolean deepcopy) throws TorqueException
    {
        ReferenceToIncluded referenceToIncluded = new ReferenceToIncluded();

        return copyInto(referenceToIncluded, deepcopy);
    }

    /**
     * Makes a copy of this object using connection.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @param con the database connection to read associated objects.
     */
    public ReferenceToIncluded copy(boolean deepcopy, Connection con) throws TorqueException
    {
        ReferenceToIncluded referenceToIncluded = new ReferenceToIncluded();

        return copyInto(referenceToIncluded, deepcopy, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     */
    protected ReferenceToIncluded copyInto(ReferenceToIncluded copyObj) throws TorqueException
    {
        return copyInto(copyObj, true);
    }

    /**
     * Fills the copyObj with the contents of this object using connection.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param con the database connection to read associated objects.
     */
    protected ReferenceToIncluded copyInto(ReferenceToIncluded copyObj, Connection con) throws TorqueException
    {
        return copyInto(copyObj, true, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     */
    protected ReferenceToIncluded copyInto(ReferenceToIncluded copyObj, boolean deepcopy) throws TorqueException
    {
        copyObj.setId(0);
        copyObj.setIncludedId(includedId);
        copyObj.setIncludedFromIncludedId(includedFromIncludedId);

        if (deepcopy)
        {
            if (collIncludeds != null)
            {
                for (int i = 0; i < collIncludeds.size(); i++)
                {
                    Included obj = collIncludeds.get(i);
                    copyObj.addIncluded(obj.copy());
                }
            }
            else
            {
                copyObj.collIncludeds = null;
            }
            if (collIncludedFromIncludeds != null)
            {
                for (int i = 0; i < collIncludedFromIncludeds.size(); i++)
                {
                    IncludedFromIncluded obj = collIncludedFromIncludeds.get(i);
                    copyObj.addIncludedFromIncluded(obj.copy());
                }
            }
            else
            {
                copyObj.collIncludedFromIncludeds = null;
            }
        }
        return copyObj;
    }
        
    
    /**
     * Fills the copyObj with the contents of this object using connection.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @param con the database connection to read associated objects.
     */
    protected ReferenceToIncluded copyInto(ReferenceToIncluded copyObj, boolean deepcopy, Connection con) throws TorqueException
    {
        copyObj.setId(0);
        copyObj.setIncludedId(includedId);
        copyObj.setIncludedFromIncludedId(includedFromIncludedId);

        if (deepcopy)
        {
            for (Included obj : getIncludeds(con))
            {
                copyObj.addIncluded(obj.copy());
            }
            for (IncludedFromIncluded obj : getIncludedFromIncludeds(con))
            {
                copyObj.addIncludedFromIncluded(obj.copy());
            }
        }
        return copyObj;
    }

    /** The Peer class */
    private static final org.apache.torque.test.ReferenceToIncludedPeer peer
            = new org.apache.torque.test.ReferenceToIncludedPeer();

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public org.apache.torque.test.ReferenceToIncludedPeer getPeer()
    {
        return peer;
    }

    /**
     * Retrieves the TableMap object related to this Table data without
     * compiler warnings of using getPeer().getTableMap().
     *
     * @return The associated TableMap object.
     */
    public TableMap getTableMap() throws TorqueException
    {
        return org.apache.torque.test.ReferenceToIncludedPeer.getTableMap();
    }



    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("ReferenceToIncluded:\n");
        str.append("id = ")
           .append(getId())
           .append("\n");
        str.append("includedId = ")
           .append(getIncludedId())
           .append("\n");
        str.append("includedFromIncludedId = ")
           .append(getIncludedFromIncludedId())
           .append("\n");
        return(str.toString());
    }

    /**
     * Compares the primary key of this instance with the key of another.
     *
     * @param toCompare The object to compare to.
     * @return Whether the primary keys are equal and the object have the
     *         same class.
     */
    public boolean equals(Object toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!getClass().equals(toCompare.getClass()))
        {
            return false;
        }
        ReferenceToIncluded other = (ReferenceToIncluded) toCompare;
        if (getPrimaryKey() == null || other.getPrimaryKey() == null)
        {
            return false;
        }
        return getPrimaryKey().equals(other.getPrimaryKey());
    }

    /**
     * If the primary key is not <code>null</code>, return the hashcode of the
     * primary key.  Otherwise calls <code>Object.hashCode()</code>.
     *
     * @return an <code>int</code> value
     */
    public int hashCode()
    {
        ObjectKey ok = getPrimaryKey();
        if (ok == null)
        {
            return super.hashCode();
        }

        return ok.hashCode();
    }




}
