package org.apache.torque.test;

import java.io.Serializable;
import java.sql.Connection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.apache.torque.TorqueException;
import org.apache.torque.map.TableMap;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.BooleanKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.om.ColumnAccessByName;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.util.Transaction;
import org.apache.commons.lang.ObjectUtils;


/**
 * Table referenced by several columns of an other table
 *
 * This class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:40 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Referenced
 */
public abstract class BaseReferenced 
    implements Persistent, Serializable, ColumnAccessByName
{
    /** Serial version */
    private static final long serialVersionUID = 1347503740921L;



    /** Defines the referencedPK field. */
    private String referencedPK = null;

    /** Defines the otherInformation field. */
    private String otherInformation = null;

    /** Whether this object was modified after loading or after last save. */
    private boolean modified = true;

    /** 
     * Whether this object was loaded from the database or already saved 
     * (false) or whether it is not yet in the database(true).
     */
    private boolean isNew = true;

    /** Flag which indicates whether this object is currently saving. */
    private boolean saving = false;

    /** 
     * Flag which indicates whether this object is currently loaded
     * from the database. 
     */
    private boolean loading = false;

    /** 
     * Flag which indicates whether this object was deleted from the database.
     * Note that this flags does not always display the current database state,
     * there is no magical connection between this flag and the database.
     */
    private boolean deleted = false;



    /** Defines the collMultiRefSameTablesRelatedByReference1 field. */
    protected List<MultiRefSameTable> collMultiRefSameTablesRelatedByReference1 = null;

    /** Defines the collMultiRefSameTablesRelatedByReference2 field. */
    protected List<MultiRefSameTable> collMultiRefSameTablesRelatedByReference2 = null;

    /** Defines the collMultiRefSameTablesRelatedByReference3 field. */
    protected List<MultiRefSameTable> collMultiRefSameTablesRelatedByReference3 = null;



    /**
     * Get the value of referencedPK.
     *
     * @return String
     */
    public String getReferencedPK() 
    {
        
        return referencedPK;
    }

    /**
     * Set the value of referencedPK.
     *
     * @param v new value
     */
    public void setReferencedPK(String v)
    {
        if (!ObjectUtils.equals(this.referencedPK, v))
        {
            setModified(true);
        }

        this.referencedPK = v;

        // update associated objects in collMultiRefSameTablesRelatedByReference1 
        if (collMultiRefSameTablesRelatedByReference1 != null)
        {
            for (int i = 0; i < collMultiRefSameTablesRelatedByReference1.size(); i++)
            {
                ((MultiRefSameTable) collMultiRefSameTablesRelatedByReference1.get(i))
                        .setReference1(v);
            }
        }
        // update associated objects in collMultiRefSameTablesRelatedByReference2 
        if (collMultiRefSameTablesRelatedByReference2 != null)
        {
            for (int i = 0; i < collMultiRefSameTablesRelatedByReference2.size(); i++)
            {
                ((MultiRefSameTable) collMultiRefSameTablesRelatedByReference2.get(i))
                        .setReference2(v);
            }
        }
        // update associated objects in collMultiRefSameTablesRelatedByReference3 
        if (collMultiRefSameTablesRelatedByReference3 != null)
        {
            for (int i = 0; i < collMultiRefSameTablesRelatedByReference3.size(); i++)
            {
                ((MultiRefSameTable) collMultiRefSameTablesRelatedByReference3.get(i))
                        .setReference3(v);
            }
        }

    }
    
    /**
     * Get the value of otherInformation.
     *
     * @return String
     */
    public String getOtherInformation() 
    {
        
        return otherInformation;
    }

    /**
     * Set the value of otherInformation.
     *
     * @param v new value
     */
    public void setOtherInformation(String v)
    {
        if (!ObjectUtils.equals(this.otherInformation, v))
        {
            setModified(true);
        }

        this.otherInformation = v;


    }
    

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return true, if the object has never been persisted.
     */
    public boolean isNew()
    {
        return isNew;
    }

    /**
     * Sets whether the object has ever been saved.
     *
     * @param isNew true if the object has never been saved, false otherwise.
     */
    public void setNew(boolean isNew)
    {
        this.isNew = isNew;
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return True if the object has been modified.
     */
    public boolean isModified()
    {
        return modified;
    }

    /**
     * Sets whether the object has been modified.
     *
     * @param modified true if the object has been modified, false otherwise.
     */
    public void setModified(boolean modified)
    {
        this.modified = modified;
    }

    /**
     * Sets the modified state for the object to be false.
     */
    public void resetModified()
    {
        modified = false;
    }


    /**
     * Returns whether this object is currently saving.
     *
     * @return true if this object is currently saving, false otherwise.
     */
    public boolean isSaving()
    {
        return saving;
    }

    /**
     * Sets whether this object is currently saving.
     *
     * @param saving true if this object is currently saving, false otherwise.
     */
    public void setSaving(boolean saving)
    {
        this.saving = saving;
    }


    /**
     * Returns whether this object is currently being loaded from the database.
     *
     * @return true if this object is currently loading, false otherwise.
     */
    public boolean isLoading()
    {
        return loading;
    }

    /**
     * Sets whether this object is currently being loaded from the database.
     *
     * @param loading true if this object is currently loading, false otherwise.
     */
    public void setLoading(boolean loading)
    {
        this.loading = loading;
    }


    /**
     * Returns whether this object was deleted from the database.
     * Note that this getter does not automatically reflect database state,
     * it will be set to true by Torque if doDelete() was called with this 
     * object. Bulk deletes and deletes via primary key do not change
     * this flag. Also, if doDelete() was called on an object which does
     * not exist in the database, the deleted flag is set to true even if
     * it was not deleted.
     *
     * @return true if this object was deleted, false otherwise.
     */
    public boolean isDeleted()
    {
        return deleted;
    }

    /**
     * Sets whether this object was deleted from the database.
     *
     * @param deleted true if this object was deleted, false otherwise.
     */
    public void setDeleted(boolean deleted)
    {
        this.deleted = deleted;
    }




    /**
     * Initializes the cache collMultiRefSameTablesRelatedByReference1 for referenced objects. 
     */
    public void initMultiRefSameTableRelatedByReference1s()
    {
        if (collMultiRefSameTablesRelatedByReference1 == null)
        {
            collMultiRefSameTablesRelatedByReference1 = new ArrayList<MultiRefSameTable>();
        }
    }

    /**
     * Checks whether the cache collMultiRefSameTablesRelatedByReference1 for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isMultiRefSameTableRelatedByReference1sInitialized()
    {
        return (collMultiRefSameTablesRelatedByReference1 != null);
    }


    /**
     * Method called to associate a MultiRefSameTable object to this object
     * through the collMultiRefSameTablesRelatedByReference1 foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addMultiRefSameTableRelatedByReference1(MultiRefSameTable toAdd)
        throws TorqueException
    {
        toAdd.setReferencedRelatedByReference1((Referenced) this);
        getMultiRefSameTableRelatedByReference1s().add(toAdd);
    }

    /**
     * Method called to associate a MultiRefSameTable object to this object
     * through the collMultiRefSameTablesRelatedByReference1 foreign key attribute using connection.
     *
     * @param l MultiRefSameTable
     * @throws TorqueException
     */
    public void addMultiRefSameTableRelatedByReference1(MultiRefSameTable l, Connection con) throws TorqueException
    {
        getMultiRefSameTableRelatedByReference1s(con).add(l);
        l.setReferencedRelatedByReference1((Referenced) this);
    }
    
    /**
     * The criteria used to select the current contents of collMultiRefSameTablesRelatedByReference1
     */
    private Criteria lastMultiRefSameTableRelatedByReference1Criteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getMultiRefSameTableRelatedByReference1s(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<MultiRefSameTable> getMultiRefSameTableRelatedByReference1s()
        throws TorqueException
    {
        if (collMultiRefSameTablesRelatedByReference1 == null)
        {
            collMultiRefSameTablesRelatedByReference1 = getMultiRefSameTableRelatedByReference1s(new Criteria());
        }
        return collMultiRefSameTablesRelatedByReference1;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseReferenced has previously
     * been saved, it will retrieve related collMultiRefSameTablesRelatedByReference1 from storage.
     * If this BaseReferenced is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<MultiRefSameTable> getMultiRefSameTableRelatedByReference1s(Criteria criteria) throws TorqueException
    {
        if (collMultiRefSameTablesRelatedByReference1 == null)
        {
            if (isNew())
            {
               initMultiRefSameTableRelatedByReference1s();
            }
            else
            {
                criteria.and(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_1, getReferencedPK() );
                collMultiRefSameTablesRelatedByReference1 = org.apache.torque.test.MultiRefSameTablePeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_1, getReferencedPK() );
                if (lastMultiRefSameTableRelatedByReference1Criteria == null 
                        || !lastMultiRefSameTableRelatedByReference1Criteria.equals(criteria))
                {
                    collMultiRefSameTablesRelatedByReference1 = org.apache.torque.test.MultiRefSameTablePeer.doSelect(criteria);
                }
            }
        }
        lastMultiRefSameTableRelatedByReference1Criteria = criteria;

        return collMultiRefSameTablesRelatedByReference1;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getMultiRefSameTableRelatedByReference1s(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<MultiRefSameTable> getMultiRefSameTableRelatedByReference1s(Connection con) throws TorqueException
    {
        if (collMultiRefSameTablesRelatedByReference1 == null)
        {
            collMultiRefSameTablesRelatedByReference1 = getMultiRefSameTableRelatedByReference1s(new Criteria(), con);
        }
        return collMultiRefSameTablesRelatedByReference1;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseReferenced has previously
     * been saved, it will retrieve the related MultiRefSameTable Objects 
     * from storage.
     * If this BaseReferenced is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<MultiRefSameTable> getMultiRefSameTableRelatedByReference1s(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collMultiRefSameTablesRelatedByReference1 == null)
        {
            if (isNew())
            {
               initMultiRefSameTableRelatedByReference1s();
            }
            else
            {
                criteria.and(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_1, getReferencedPK());
                collMultiRefSameTablesRelatedByReference1 = org.apache.torque.test.MultiRefSameTablePeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_1, getReferencedPK());
                if (!lastMultiRefSameTableRelatedByReference1Criteria.equals(criteria))
                {
                    collMultiRefSameTablesRelatedByReference1 = org.apache.torque.test.MultiRefSameTablePeer.doSelect(criteria, con);
                }
            }
        }
        lastMultiRefSameTableRelatedByReference1Criteria = criteria;

        return collMultiRefSameTablesRelatedByReference1;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseReferenced is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<MultiRefSameTable> getMultiRefSameTableRelatedByReference1sJoinReferenced(Criteria criteria) throws TorqueException
    {
        return getMultiRefSameTableRelatedByReference1sJoinReferenced(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseReferenced is new, it will return
     * an empty collection; or if this BaseReferenced has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<MultiRefSameTable> getMultiRefSameTableRelatedByReference1sJoinReferenced(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collMultiRefSameTablesRelatedByReference1 == null)
        {
            if (isNew())
            {
                initMultiRefSameTableRelatedByReference1s();
            }
            else
            {
                criteria.and(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_1, getReferencedPK() );
                collMultiRefSameTablesRelatedByReference1 = org.apache.torque.test.MultiRefSameTablePeer.doSelectJoinReferencedRelatedByReference1(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_1, getReferencedPK() );
            if (!lastMultiRefSameTableRelatedByReference1Criteria.equals(criteria))
            {
                collMultiRefSameTablesRelatedByReference1 = org.apache.torque.test.MultiRefSameTablePeer.doSelectJoinReferencedRelatedByReference1(criteria, connection);
            }
        }
        lastMultiRefSameTableRelatedByReference1Criteria = criteria;

        return collMultiRefSameTablesRelatedByReference1;
    }

    /**
     * Initializes the cache collMultiRefSameTablesRelatedByReference2 for referenced objects. 
     */
    public void initMultiRefSameTableRelatedByReference2s()
    {
        if (collMultiRefSameTablesRelatedByReference2 == null)
        {
            collMultiRefSameTablesRelatedByReference2 = new ArrayList<MultiRefSameTable>();
        }
    }

    /**
     * Checks whether the cache collMultiRefSameTablesRelatedByReference2 for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isMultiRefSameTableRelatedByReference2sInitialized()
    {
        return (collMultiRefSameTablesRelatedByReference2 != null);
    }


    /**
     * Method called to associate a MultiRefSameTable object to this object
     * through the collMultiRefSameTablesRelatedByReference2 foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addMultiRefSameTableRelatedByReference2(MultiRefSameTable toAdd)
        throws TorqueException
    {
        toAdd.setReferencedRelatedByReference2((Referenced) this);
        getMultiRefSameTableRelatedByReference2s().add(toAdd);
    }

    /**
     * Method called to associate a MultiRefSameTable object to this object
     * through the collMultiRefSameTablesRelatedByReference2 foreign key attribute using connection.
     *
     * @param l MultiRefSameTable
     * @throws TorqueException
     */
    public void addMultiRefSameTableRelatedByReference2(MultiRefSameTable l, Connection con) throws TorqueException
    {
        getMultiRefSameTableRelatedByReference2s(con).add(l);
        l.setReferencedRelatedByReference2((Referenced) this);
    }
    
    /**
     * The criteria used to select the current contents of collMultiRefSameTablesRelatedByReference2
     */
    private Criteria lastMultiRefSameTableRelatedByReference2Criteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getMultiRefSameTableRelatedByReference2s(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<MultiRefSameTable> getMultiRefSameTableRelatedByReference2s()
        throws TorqueException
    {
        if (collMultiRefSameTablesRelatedByReference2 == null)
        {
            collMultiRefSameTablesRelatedByReference2 = getMultiRefSameTableRelatedByReference2s(new Criteria());
        }
        return collMultiRefSameTablesRelatedByReference2;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseReferenced has previously
     * been saved, it will retrieve related collMultiRefSameTablesRelatedByReference2 from storage.
     * If this BaseReferenced is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<MultiRefSameTable> getMultiRefSameTableRelatedByReference2s(Criteria criteria) throws TorqueException
    {
        if (collMultiRefSameTablesRelatedByReference2 == null)
        {
            if (isNew())
            {
               initMultiRefSameTableRelatedByReference2s();
            }
            else
            {
                criteria.and(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_2, getReferencedPK() );
                collMultiRefSameTablesRelatedByReference2 = org.apache.torque.test.MultiRefSameTablePeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_2, getReferencedPK() );
                if (lastMultiRefSameTableRelatedByReference2Criteria == null 
                        || !lastMultiRefSameTableRelatedByReference2Criteria.equals(criteria))
                {
                    collMultiRefSameTablesRelatedByReference2 = org.apache.torque.test.MultiRefSameTablePeer.doSelect(criteria);
                }
            }
        }
        lastMultiRefSameTableRelatedByReference2Criteria = criteria;

        return collMultiRefSameTablesRelatedByReference2;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getMultiRefSameTableRelatedByReference2s(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<MultiRefSameTable> getMultiRefSameTableRelatedByReference2s(Connection con) throws TorqueException
    {
        if (collMultiRefSameTablesRelatedByReference2 == null)
        {
            collMultiRefSameTablesRelatedByReference2 = getMultiRefSameTableRelatedByReference2s(new Criteria(), con);
        }
        return collMultiRefSameTablesRelatedByReference2;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseReferenced has previously
     * been saved, it will retrieve the related MultiRefSameTable Objects 
     * from storage.
     * If this BaseReferenced is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<MultiRefSameTable> getMultiRefSameTableRelatedByReference2s(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collMultiRefSameTablesRelatedByReference2 == null)
        {
            if (isNew())
            {
               initMultiRefSameTableRelatedByReference2s();
            }
            else
            {
                criteria.and(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_2, getReferencedPK());
                collMultiRefSameTablesRelatedByReference2 = org.apache.torque.test.MultiRefSameTablePeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_2, getReferencedPK());
                if (!lastMultiRefSameTableRelatedByReference2Criteria.equals(criteria))
                {
                    collMultiRefSameTablesRelatedByReference2 = org.apache.torque.test.MultiRefSameTablePeer.doSelect(criteria, con);
                }
            }
        }
        lastMultiRefSameTableRelatedByReference2Criteria = criteria;

        return collMultiRefSameTablesRelatedByReference2;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseReferenced is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<MultiRefSameTable> getMultiRefSameTableRelatedByReference2sJoinReferenced(Criteria criteria) throws TorqueException
    {
        return getMultiRefSameTableRelatedByReference2sJoinReferenced(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseReferenced is new, it will return
     * an empty collection; or if this BaseReferenced has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<MultiRefSameTable> getMultiRefSameTableRelatedByReference2sJoinReferenced(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collMultiRefSameTablesRelatedByReference2 == null)
        {
            if (isNew())
            {
                initMultiRefSameTableRelatedByReference2s();
            }
            else
            {
                criteria.and(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_2, getReferencedPK() );
                collMultiRefSameTablesRelatedByReference2 = org.apache.torque.test.MultiRefSameTablePeer.doSelectJoinReferencedRelatedByReference2(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_2, getReferencedPK() );
            if (!lastMultiRefSameTableRelatedByReference2Criteria.equals(criteria))
            {
                collMultiRefSameTablesRelatedByReference2 = org.apache.torque.test.MultiRefSameTablePeer.doSelectJoinReferencedRelatedByReference2(criteria, connection);
            }
        }
        lastMultiRefSameTableRelatedByReference2Criteria = criteria;

        return collMultiRefSameTablesRelatedByReference2;
    }

    /**
     * Initializes the cache collMultiRefSameTablesRelatedByReference3 for referenced objects. 
     */
    public void initMultiRefSameTableRelatedByReference3s()
    {
        if (collMultiRefSameTablesRelatedByReference3 == null)
        {
            collMultiRefSameTablesRelatedByReference3 = new ArrayList<MultiRefSameTable>();
        }
    }

    /**
     * Checks whether the cache collMultiRefSameTablesRelatedByReference3 for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isMultiRefSameTableRelatedByReference3sInitialized()
    {
        return (collMultiRefSameTablesRelatedByReference3 != null);
    }


    /**
     * Method called to associate a MultiRefSameTable object to this object
     * through the collMultiRefSameTablesRelatedByReference3 foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addMultiRefSameTableRelatedByReference3(MultiRefSameTable toAdd)
        throws TorqueException
    {
        toAdd.setReferencedRelatedByReference3((Referenced) this);
        getMultiRefSameTableRelatedByReference3s().add(toAdd);
    }

    /**
     * Method called to associate a MultiRefSameTable object to this object
     * through the collMultiRefSameTablesRelatedByReference3 foreign key attribute using connection.
     *
     * @param l MultiRefSameTable
     * @throws TorqueException
     */
    public void addMultiRefSameTableRelatedByReference3(MultiRefSameTable l, Connection con) throws TorqueException
    {
        getMultiRefSameTableRelatedByReference3s(con).add(l);
        l.setReferencedRelatedByReference3((Referenced) this);
    }
    
    /**
     * The criteria used to select the current contents of collMultiRefSameTablesRelatedByReference3
     */
    private Criteria lastMultiRefSameTableRelatedByReference3Criteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getMultiRefSameTableRelatedByReference3s(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<MultiRefSameTable> getMultiRefSameTableRelatedByReference3s()
        throws TorqueException
    {
        if (collMultiRefSameTablesRelatedByReference3 == null)
        {
            collMultiRefSameTablesRelatedByReference3 = getMultiRefSameTableRelatedByReference3s(new Criteria());
        }
        return collMultiRefSameTablesRelatedByReference3;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseReferenced has previously
     * been saved, it will retrieve related collMultiRefSameTablesRelatedByReference3 from storage.
     * If this BaseReferenced is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<MultiRefSameTable> getMultiRefSameTableRelatedByReference3s(Criteria criteria) throws TorqueException
    {
        if (collMultiRefSameTablesRelatedByReference3 == null)
        {
            if (isNew())
            {
               initMultiRefSameTableRelatedByReference3s();
            }
            else
            {
                criteria.and(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_3, getReferencedPK() );
                collMultiRefSameTablesRelatedByReference3 = org.apache.torque.test.MultiRefSameTablePeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_3, getReferencedPK() );
                if (lastMultiRefSameTableRelatedByReference3Criteria == null 
                        || !lastMultiRefSameTableRelatedByReference3Criteria.equals(criteria))
                {
                    collMultiRefSameTablesRelatedByReference3 = org.apache.torque.test.MultiRefSameTablePeer.doSelect(criteria);
                }
            }
        }
        lastMultiRefSameTableRelatedByReference3Criteria = criteria;

        return collMultiRefSameTablesRelatedByReference3;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getMultiRefSameTableRelatedByReference3s(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<MultiRefSameTable> getMultiRefSameTableRelatedByReference3s(Connection con) throws TorqueException
    {
        if (collMultiRefSameTablesRelatedByReference3 == null)
        {
            collMultiRefSameTablesRelatedByReference3 = getMultiRefSameTableRelatedByReference3s(new Criteria(), con);
        }
        return collMultiRefSameTablesRelatedByReference3;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseReferenced has previously
     * been saved, it will retrieve the related MultiRefSameTable Objects 
     * from storage.
     * If this BaseReferenced is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<MultiRefSameTable> getMultiRefSameTableRelatedByReference3s(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collMultiRefSameTablesRelatedByReference3 == null)
        {
            if (isNew())
            {
               initMultiRefSameTableRelatedByReference3s();
            }
            else
            {
                criteria.and(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_3, getReferencedPK());
                collMultiRefSameTablesRelatedByReference3 = org.apache.torque.test.MultiRefSameTablePeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_3, getReferencedPK());
                if (!lastMultiRefSameTableRelatedByReference3Criteria.equals(criteria))
                {
                    collMultiRefSameTablesRelatedByReference3 = org.apache.torque.test.MultiRefSameTablePeer.doSelect(criteria, con);
                }
            }
        }
        lastMultiRefSameTableRelatedByReference3Criteria = criteria;

        return collMultiRefSameTablesRelatedByReference3;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseReferenced is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<MultiRefSameTable> getMultiRefSameTableRelatedByReference3sJoinReferenced(Criteria criteria) throws TorqueException
    {
        return getMultiRefSameTableRelatedByReference3sJoinReferenced(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseReferenced is new, it will return
     * an empty collection; or if this BaseReferenced has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<MultiRefSameTable> getMultiRefSameTableRelatedByReference3sJoinReferenced(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collMultiRefSameTablesRelatedByReference3 == null)
        {
            if (isNew())
            {
                initMultiRefSameTableRelatedByReference3s();
            }
            else
            {
                criteria.and(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_3, getReferencedPK() );
                collMultiRefSameTablesRelatedByReference3 = org.apache.torque.test.MultiRefSameTablePeer.doSelectJoinReferencedRelatedByReference3(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.MultiRefSameTablePeer.REFERENCE_3, getReferencedPK() );
            if (!lastMultiRefSameTableRelatedByReference3Criteria.equals(criteria))
            {
                collMultiRefSameTablesRelatedByReference3 = org.apache.torque.test.MultiRefSameTablePeer.doSelectJoinReferencedRelatedByReference3(criteria, connection);
            }
        }
        lastMultiRefSameTableRelatedByReference3Criteria = criteria;

        return collMultiRefSameTablesRelatedByReference3;
    }




    private static final List<String> FIELD_NAMES;

    static
    {
        List<String> fieldNames
                = new ArrayList<String>();
        fieldNames.add("referencedPK");
        fieldNames.add("otherInformation");
        FIELD_NAMES = Collections.unmodifiableList(fieldNames);
    }

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static List<String> getFieldNames()
    {
        return FIELD_NAMES;
    }

    /**
     * Retrieves a field from the object by field (Java) name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
        if (name.equals("referencedPK"))
        {
            return getReferencedPK();
        }
        if (name.equals("otherInformation"))
        {
            return getOtherInformation();
        }
        return null;
    }

    /**
     * Set a field in the object by field (Java) name.
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (name.equals("referencedPK"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setReferencedPK((String) value);
            return true;
        }
        if (name.equals("otherInformation"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOtherInformation((String) value);
            return true;
        }
        return false;
    }

    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
        if (name.equals(org.apache.torque.test.ReferencedPeer.REFERENCED_PK))
        {
            return getReferencedPK();
        }
        if (name.equals(org.apache.torque.test.ReferencedPeer.OTHER_INFORMATION))
        {
            return getOtherInformation();
        }
        return null;
    }

    /**
     * Set field values by Peer Field Name
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPeerName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (org.apache.torque.test.ReferencedPeer.REFERENCED_PK.getSqlExpression().equals(name))
        {
            return setByName("referencedPK", value);
        }
        if (org.apache.torque.test.ReferencedPeer.OTHER_INFORMATION.getSqlExpression().equals(name))
        {
            return setByName("otherInformation", value);
        }
        return false;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
        if (pos == 0)
        {
            return getReferencedPK();
        }
        if (pos == 1)
        {
            return getOtherInformation();
        }
        return null;
    }

    /**
     * Set field values by its position (zero based) in the XML schema.
     *
     * @param position The field position
     * @param value field value
     * @return True if value was set, false if not (invalid position / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPosition(int position, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (position == 0)
        {
            return setByName("referencedPK", value);
        }
        if (position == 1)
        {
            return setByName("otherInformation", value);
        }
        return false;
    }



    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save() throws TorqueException
    {
        save(ReferencedPeer.DATABASE_NAME);
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     * @param dbName the name of the database to which the object
     *        should be saved.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(String dbName) 
            throws TorqueException
    {
        Connection con = null;
        try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally.
     *
     * @param toSave the object to be saved, not null.
     * @param con the connection to use for saving the object, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(Connection con) 
            throws TorqueException
    {
        if (isSaving())
        {
            return;
        }
        try
        {
            setSaving(true);
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    ReferencedPeer.doInsert((Referenced) this, con);
                    setNew(false);
                }
                else
                {
                    ReferencedPeer.doUpdate((Referenced) this, con);
                }
            }

            if (isMultiRefSameTableRelatedByReference1sInitialized())
            {
                for (MultiRefSameTable collMultiRefSameTablesRelatedByReference1 : getMultiRefSameTableRelatedByReference1s())
                {
                    collMultiRefSameTablesRelatedByReference1.save(con);
                }
            }
            if (isMultiRefSameTableRelatedByReference2sInitialized())
            {
                for (MultiRefSameTable collMultiRefSameTablesRelatedByReference2 : getMultiRefSameTableRelatedByReference2s())
                {
                    collMultiRefSameTablesRelatedByReference2.save(con);
                }
            }
            if (isMultiRefSameTableRelatedByReference3sInitialized())
            {
                for (MultiRefSameTable collMultiRefSameTablesRelatedByReference3 : getMultiRefSameTableRelatedByReference3s())
                {
                    collMultiRefSameTablesRelatedByReference3.save(con);
                }
            }
        }
        finally
        {
            setSaving(false);
        }
    }




    /**
     * Set the PrimaryKey using ObjectKey.
     *
     * @param key referencedPK ObjectKey
     */
    public void setPrimaryKey(ObjectKey key)
        
    {
        setReferencedPK(key.toString());
    }

    /**
     * Set the PrimaryKey using a String.
     *
     * @param key
     */
    public void setPrimaryKey(String key) 
    {
        setReferencedPK(key);
    }


    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        return SimpleKey.keyFor(getReferencedPK());
    }



    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public Referenced copy() throws TorqueException
    {
        return copy(true);
    }

    /**
     * Makes a copy of this object using a connection.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     *
     * @param con the database connection to read associated objects.
     */
    public Referenced copy(Connection con) throws TorqueException
    {
        return copy(true, con);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     */
    public Referenced copy(boolean deepcopy) throws TorqueException
    {
        Referenced referenced = new Referenced();

        return copyInto(referenced, deepcopy);
    }

    /**
     * Makes a copy of this object using connection.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @param con the database connection to read associated objects.
     */
    public Referenced copy(boolean deepcopy, Connection con) throws TorqueException
    {
        Referenced referenced = new Referenced();

        return copyInto(referenced, deepcopy, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     */
    protected Referenced copyInto(Referenced copyObj) throws TorqueException
    {
        return copyInto(copyObj, true);
    }

    /**
     * Fills the copyObj with the contents of this object using connection.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param con the database connection to read associated objects.
     */
    protected Referenced copyInto(Referenced copyObj, Connection con) throws TorqueException
    {
        return copyInto(copyObj, true, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     */
    protected Referenced copyInto(Referenced copyObj, boolean deepcopy) throws TorqueException
    {
        copyObj.setReferencedPK((String) null);
        copyObj.setOtherInformation(otherInformation);

        if (deepcopy)
        {
            if (collMultiRefSameTablesRelatedByReference1 != null)
            {
                for (int i = 0; i < collMultiRefSameTablesRelatedByReference1.size(); i++)
                {
                    MultiRefSameTable obj = collMultiRefSameTablesRelatedByReference1.get(i);
                    copyObj.addMultiRefSameTableRelatedByReference1(obj.copy());
                }
            }
            else
            {
                copyObj.collMultiRefSameTablesRelatedByReference1 = null;
            }
            if (collMultiRefSameTablesRelatedByReference2 != null)
            {
                for (int i = 0; i < collMultiRefSameTablesRelatedByReference2.size(); i++)
                {
                    MultiRefSameTable obj = collMultiRefSameTablesRelatedByReference2.get(i);
                    copyObj.addMultiRefSameTableRelatedByReference2(obj.copy());
                }
            }
            else
            {
                copyObj.collMultiRefSameTablesRelatedByReference2 = null;
            }
            if (collMultiRefSameTablesRelatedByReference3 != null)
            {
                for (int i = 0; i < collMultiRefSameTablesRelatedByReference3.size(); i++)
                {
                    MultiRefSameTable obj = collMultiRefSameTablesRelatedByReference3.get(i);
                    copyObj.addMultiRefSameTableRelatedByReference3(obj.copy());
                }
            }
            else
            {
                copyObj.collMultiRefSameTablesRelatedByReference3 = null;
            }
        }
        return copyObj;
    }
        
    
    /**
     * Fills the copyObj with the contents of this object using connection.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @param con the database connection to read associated objects.
     */
    protected Referenced copyInto(Referenced copyObj, boolean deepcopy, Connection con) throws TorqueException
    {
        copyObj.setReferencedPK((String) null);
        copyObj.setOtherInformation(otherInformation);

        if (deepcopy)
        {
            for (MultiRefSameTable obj : getMultiRefSameTableRelatedByReference1s(con))
            {
                copyObj.addMultiRefSameTableRelatedByReference1(obj.copy());
            }
            for (MultiRefSameTable obj : getMultiRefSameTableRelatedByReference2s(con))
            {
                copyObj.addMultiRefSameTableRelatedByReference2(obj.copy());
            }
            for (MultiRefSameTable obj : getMultiRefSameTableRelatedByReference3s(con))
            {
                copyObj.addMultiRefSameTableRelatedByReference3(obj.copy());
            }
        }
        return copyObj;
    }

    /** The Peer class */
    private static final org.apache.torque.test.ReferencedPeer peer
            = new org.apache.torque.test.ReferencedPeer();

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public org.apache.torque.test.ReferencedPeer getPeer()
    {
        return peer;
    }

    /**
     * Retrieves the TableMap object related to this Table data without
     * compiler warnings of using getPeer().getTableMap().
     *
     * @return The associated TableMap object.
     */
    public TableMap getTableMap() throws TorqueException
    {
        return org.apache.torque.test.ReferencedPeer.getTableMap();
    }



    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("Referenced:\n");
        str.append("referencedPK = ")
           .append(getReferencedPK())
           .append("\n");
        str.append("otherInformation = ")
           .append(getOtherInformation())
           .append("\n");
        return(str.toString());
    }

    /**
     * Compares the primary key of this instance with the key of another.
     *
     * @param toCompare The object to compare to.
     * @return Whether the primary keys are equal and the object have the
     *         same class.
     */
    public boolean equals(Object toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!getClass().equals(toCompare.getClass()))
        {
            return false;
        }
        Referenced other = (Referenced) toCompare;
        if (getPrimaryKey() == null || other.getPrimaryKey() == null)
        {
            return false;
        }
        return getPrimaryKey().equals(other.getPrimaryKey());
    }

    /**
     * If the primary key is not <code>null</code>, return the hashcode of the
     * primary key.  Otherwise calls <code>Object.hashCode()</code>.
     *
     * @return an <code>int</code> value
     */
    public int hashCode()
    {
        ObjectKey ok = getPrimaryKey();
        if (ok == null)
        {
            return super.hashCode();
        }

        return ok.hashCode();
    }




}
