package org.apache.torque.test;

import java.sql.Blob;
import java.sql.Clob;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.sql.PreparedStatement;
import java.sql.Types;
import java.io.IOException;
import java.io.InputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.Reader;
import java.io.StringReader;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.torque.NoRowsException;
import org.apache.torque.TooManyRowsException;
import org.apache.torque.Torque;
import org.apache.torque.TorqueException;
import org.apache.torque.TorqueRuntimeException;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.criteria.Criterion;
import org.apache.torque.om.mapper.RecordMapper;
import org.apache.torque.om.mapper.CompositeMapper;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.ComboKey;
import org.apache.torque.map.TableMap;
import org.apache.torque.util.BasePeer;
import org.apache.torque.util.Transaction;
import org.apache.torque.util.ColumnValues;
import org.apache.torque.util.JdbcTypedValue;



/**
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:46 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to SaveMethodInObjectFkPeer
 */

public abstract class BaseSaveMethodInObjectFkPeerImpl
    extends org.apache.torque.util.BasePeerImpl<SaveMethodInObjectFk>
{
    /** The class log. */
    private static Log log = LogFactory.getLog(BaseSaveMethodInObjectFkPeerImpl.class);

    /** Serial version */
    private static final long serialVersionUID = 1347503746235L;



    /**
     * Constructor.
     * The recordMapper, tableMap and databaseName fields are correctly
     * initialized.
     */
    public BaseSaveMethodInObjectFkPeerImpl()
    {
        this(new SaveMethodInObjectFkRecordMapper(),
            SaveMethodInObjectFkPeer.TABLE,
            SaveMethodInObjectFkPeer.DATABASE_NAME);
    }

    /**
     * Constructor providing the objects to be injected as parameters.
     *
     * @param recordMapper a record mapper to map JDBC result sets to objects
     * @param tableMap the default table map
     * @param databaseName the name of the database
     */
    public BaseSaveMethodInObjectFkPeerImpl(
            RecordMapper<SaveMethodInObjectFk> recordMapper, 
            TableMap tableMap,
            String databaseName)
    {
        super(recordMapper, tableMap, databaseName);
    }


    /**
     * Selects SaveMethodInObjectFk objects from the database which have
     * the same content as the passed object.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<SaveMethodInObjectFk> doSelect(SaveMethodInObjectFk obj)
            throws TorqueException
    {
        return doSelect(buildSelectCriteria(obj));
    }

    /**
     * Selects at most one SaveMethodInObjectFk object from the database
     * which has the same content as the passed object.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public SaveMethodInObjectFk doSelectSingleRecord(
                SaveMethodInObjectFk obj)
            throws TorqueException
    {
        List<SaveMethodInObjectFk> saveMethodInObjectFkList = doSelect(obj);
        SaveMethodInObjectFk saveMethodInObjectFk = null;
        if (saveMethodInObjectFkList.size() > 1)
        {
            throw new TooManyRowsException("Object " + obj 
                + " matched more than one record");
        }
        if (!saveMethodInObjectFkList.isEmpty())
        {
            saveMethodInObjectFk = saveMethodInObjectFkList.get(0);
        }
        return saveMethodInObjectFk;
    }

    /**
     * Returns a new instance of the Data object class
     */
    public SaveMethodInObjectFk getDbObjectInstance()
    {
        return new SaveMethodInObjectFk();
    }


    /**
     * Method to do inserts.
     *
     * @param columnValues the values to insert.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public ObjectKey doInsert(ColumnValues columnValues) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    SaveMethodInObjectFkPeer.DATABASE_NAME);
            ObjectKey result = doInsert(columnValues, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(Criteria) method.
     *
     * @param columnValues the values to insert.
     * @param con the connection to use, not null.
     *
     * @return the primary key of the inserted row.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public ObjectKey doInsert(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        correctBooleans(columnValues);
        return super.doInsert(columnValues, con);
    }

    /**
     * Method to do inserts
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public void doInsert(SaveMethodInObjectFk obj) throws TorqueException
    {
        obj.setPrimaryKey(doInsert(buildColumnValues(obj)));
        obj.setNew(false);
        obj.setModified(false);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(SaveMethodInObjectFk) method.  It will take
     * care of the connection details internally.
     *
     * @param obj the data object to insert into the database.
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public void doInsert(SaveMethodInObjectFk obj, Connection con)
        throws TorqueException
    {
        ObjectKey primaryKey = doInsert(buildColumnValues(obj), con);
        if (primaryKey != null)
        {
            obj.setPrimaryKey(primaryKey);
        }
        obj.setNew(false);
        obj.setModified(false);
    }

    /**
     * Method to do updates.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(ColumnValues columnValues) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    SaveMethodInObjectFkPeer.DATABASE_NAME);
            int result = doUpdate(columnValues, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Method to do updates.  This method is to be used during a transaction,
     * otherwise use the doUpdate(Criteria) method.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @param con the connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        Criteria selectCriteria 
                = new Criteria(SaveMethodInObjectFkPeer.DATABASE_NAME);
        correctBooleans(columnValues);


    
        selectCriteria.where(
                SaveMethodInObjectFkPeer.ID,
                columnValues.remove(SaveMethodInObjectFkPeer.ID).getValue());


        return doUpdate(selectCriteria, columnValues, con);
    }

    /**
     * Updates an SaveMethodInObjectFk in the database.
     * The primary key is used to identify the object to update.
     *
     * @param obj the data object to update in the database.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(SaveMethodInObjectFk obj) throws TorqueException
    {
        ColumnValues columnValues = buildColumnValues(obj);
        int result = doUpdate(columnValues);
        obj.setModified(false);
        return result;
    }

    /**
     * Updates a SaveMethodInObjectFk in the database.
     * The primary key is used to identify the object to update.
     * This method is to be used during a transaction,
     * otherwise the doUpdate(SaveMethodInObjectFk) method can be used.
     *
     * @param obj the data object to update in the database.
     * @param con the connection to use, not null.
     
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doUpdate(SaveMethodInObjectFk obj, Connection con)
        throws TorqueException
    {
        ColumnValues columnValues = buildColumnValues(obj);
        int result = doUpdate(columnValues, con);
        obj.setModified(false);
        return result;
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     *
     * @param obj the data object to delete in the database, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(SaveMethodInObjectFk obj) throws TorqueException
    {
        int result = doDelete(buildCriteria(obj.getPrimaryKey()));
        obj.setDeleted(true);
        return result;
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     * This method is to be used during a transaction, otherwise use the
     * doDelete(SaveMethodInObjectFk) method.
     *
     * @param obj the data object to delete in the database, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(SaveMethodInObjectFk obj, Connection con)
        throws TorqueException
    {
        int result = doDelete(buildCriteria(obj.getPrimaryKey()), con);
        obj.setDeleted(true);
        return result;
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     *
     * @param objects the data object to delete in the database, not null,
     *        may not contain null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(Collection<SaveMethodInObjectFk> objects)
            throws TorqueException
    {
        int result = doDelete(buildPkCriteria(objects));
        for (SaveMethodInObjectFk object : objects)
        {
            object.setDeleted(true);
        }
        return result;
    }

    /**
     * Deletes data objects, i.e. rows in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param objects the data objects to delete in the database, not null,
     *        may not contain null.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(
            Collection<SaveMethodInObjectFk> objects,
            Connection con)
        throws TorqueException
    {
        int result = doDelete(buildPkCriteria(objects), con);
        for (SaveMethodInObjectFk object : objects)
        {
            object.setDeleted(true);
        }
        return result;
    }

    /**
     * Deletes a row in the database.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(ObjectKey pk) throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    SaveMethodInObjectFkPeer.DATABASE_NAME);
            int deletedRows = doDelete(pk, connection);
            Transaction.commit(connection);
            connection = null;
            return deletedRows;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Deletes a row in the database.
     * This method is to be used during a transaction,
     * otherwise use the doDelete(ObjectKey) method.
     *
     * @param pk the ObjectKey that identifies the row to delete.
     * @param con the connection to use for deleting, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public int doDelete(ObjectKey pk, Connection con)
        throws TorqueException
    {
        return doDelete(buildCriteria(pk), con);
    }

    /** 
     * Build a Criteria object which selects all objects which have a given
     * primary key.
     *
     * @param pk the primary key value to build the criteria from, not null.
     */
    public Criteria buildCriteria(ObjectKey pk)
    {
        Criteria criteria = new Criteria();
        criteria.and(SaveMethodInObjectFkPeer.ID, pk);
        return criteria;
     }

    /** 
     * Build a Criteria object which selects all objects which primary keys
     * are contained in the passed collection.
     *
     * @param pks the primary key values to build the criteria from, not null,
     *        may not contain null.
     */
    public Criteria buildCriteria(Collection<ObjectKey> pks)
    {
        Criteria criteria = new Criteria();
        criteria.andIn(SaveMethodInObjectFkPeer.ID, pks);
        return criteria;
     }


    /** 
     * Build a Criteria object which selects all passed objects using their
     * primary key. Objects which do not yet have a primary key are ignored.
     *
     * @param objects the objects to build the criteria from, not null,
     *        may not contain null.
     */
    public Criteria buildPkCriteria(
            Collection<SaveMethodInObjectFk> objects)
    {
        List<ObjectKey> pks = new ArrayList<ObjectKey>(objects.size());
        for (SaveMethodInObjectFk object : objects)
        {
            ObjectKey pk = object.getPrimaryKey();
            if (pk != null)
            {
                pks.add(pk);
            }
        }
        return buildCriteria(pks);
    }

    /** 
     * Build a Criteria object from the data object for this peer.
     * The primary key columns are only added if the object is not new.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public Criteria buildCriteria(SaveMethodInObjectFk obj)
    {
        Criteria criteria = new Criteria(SaveMethodInObjectFkPeer.DATABASE_NAME);
        if (!obj.isNew())
        {
            criteria.and(SaveMethodInObjectFkPeer.ID, obj.getId());
        }
        criteria.and(SaveMethodInObjectFkPeer.SAVE_METHOD_IN_PEER_ID, obj.getSaveMethodInPeerId());
        criteria.and(SaveMethodInObjectFkPeer.PAYLOAD, obj.getPayload());
        return criteria;
    }

    /** 
     * Build a Criteria object from the data object for this peer,
     * skipping all binary columns.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public Criteria buildSelectCriteria(SaveMethodInObjectFk obj)
    {
        Criteria criteria = new Criteria(SaveMethodInObjectFkPeer.DATABASE_NAME);
        if (!obj.isNew())
        {
            criteria.and(SaveMethodInObjectFkPeer.ID, obj.getId());
        }
        criteria.and(SaveMethodInObjectFkPeer.SAVE_METHOD_IN_PEER_ID, obj.getSaveMethodInPeerId());
        criteria.and(SaveMethodInObjectFkPeer.PAYLOAD, obj.getPayload());
        return criteria;
    }

    /** 
     * Returns the contents of the object as ColumnValues object.
     * Primary key columns which are generated on insertion are not
     * added to the returned object if they still have their initial
     * value. Also, columns which have the useDatabaseDefaultValue
     * flag set to true are also not added to the returned object
     * if they still have their initial value.
     *
     * @throws TorqueException if the table map cannot be retrieved
     *         (should not happen).
     */
    public ColumnValues buildColumnValues(SaveMethodInObjectFk saveMethodInObjectFk)
            throws TorqueException
    {
        ColumnValues columnValues = new ColumnValues();
        if (!saveMethodInObjectFk.isNew() 
            || saveMethodInObjectFk.getId() != null)
        {
            columnValues.put(
                    SaveMethodInObjectFkPeer.ID,
                    new JdbcTypedValue(
                        saveMethodInObjectFk.getId(),
                        4));
        }
        columnValues.put(
                SaveMethodInObjectFkPeer.SAVE_METHOD_IN_PEER_ID,
                new JdbcTypedValue(
                    saveMethodInObjectFk.getSaveMethodInPeerId(),
                    4));
        columnValues.put(
                SaveMethodInObjectFkPeer.PAYLOAD,
                new JdbcTypedValue(
                    saveMethodInObjectFk.getPayload(),
                    12));
        return columnValues;
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public SaveMethodInObjectFk retrieveByPK(Integer pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return retrieveByPK(SimpleKey.keyFor(pk));
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public SaveMethodInObjectFk retrieveByPK(Integer pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        return retrieveByPK(SimpleKey.keyFor(pk), con);
    }
    
    
    

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public SaveMethodInObjectFk retrieveByPK(ObjectKey pk)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(SaveMethodInObjectFkPeer.DATABASE_NAME);
            SaveMethodInObjectFk result = retrieveByPK(pk, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Retrieve a single object by pk
     *
     * @param pk the primary key
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     * @throws NoRowsException Primary key was not found in database.
     * @throws TooManyRowsException Primary key was not found in database.
     */
    public SaveMethodInObjectFk retrieveByPK(ObjectKey pk, Connection con)
        throws TorqueException, NoRowsException, TooManyRowsException
    {
        Criteria criteria = buildCriteria(pk);
        List<SaveMethodInObjectFk> v = doSelect(criteria, con);
        if (v.size() == 0)
        {
            throw new NoRowsException("Failed to select a row.");
        }
        else if (v.size() > 1)
        {
            throw new TooManyRowsException("Failed to select only one row.");
        }
        else
        {
            return (SaveMethodInObjectFk)v.get(0);
        }
    }


    /**
     * Retrieve a multiple objects by pk
     *
     * @param pks List of primary keys
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<SaveMethodInObjectFk> retrieveByPKs(Collection<ObjectKey> pks)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(SaveMethodInObjectFkPeer.DATABASE_NAME);
            List<SaveMethodInObjectFk> result = retrieveByPKs(pks, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Retrieve multiple objects by pk
     *
     * @param pks List of primary keys
     * @param dbcon the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<SaveMethodInObjectFk> retrieveByPKs(
                Collection<ObjectKey> pks,
                Connection dbcon)
            throws TorqueException
    {
        if (pks == null || pks.size() == 0)
        {
            return new ArrayList<SaveMethodInObjectFk>();
        }
        Criteria criteria = buildCriteria(pks);
        List<SaveMethodInObjectFk> result = doSelect(criteria, dbcon);
        return result;
    }


    /**
     * Selects a collection of dbObjectClassName objects pre-filled with their
     * SaveMethodInPeer objects.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<SaveMethodInObjectFk> doSelectJoinSaveMethodInPeer(Criteria criteria)
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    SaveMethodInObjectFkPeer.DATABASE_NAME);
            List<SaveMethodInObjectFk> result
                    = SaveMethodInObjectFkPeer.doSelectJoinSaveMethodInPeer(criteria, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /**
     * Selects a collection of SaveMethodInObjectFk objects pre-filled with their
     * SaveMethodInPeer objects.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public List<SaveMethodInObjectFk> doSelectJoinSaveMethodInPeer(
            Criteria criteria, Connection conn)
        throws TorqueException
    {
        setDbName(criteria);

        addSelectColumns(criteria);
        org.apache.torque.test.SaveMethodInPeerPeer.addSelectColumns(criteria);

        CompositeMapper compositeMapper = new CompositeMapper();
        compositeMapper.addMapper(
                new SaveMethodInObjectFkRecordMapper(),
                0);
        compositeMapper.addMapper(
                new SaveMethodInPeerRecordMapper(),
                SaveMethodInObjectFkPeer.numColumns);
        criteria.addJoin(SaveMethodInObjectFkPeer.SAVE_METHOD_IN_PEER_ID,
            org.apache.torque.test.SaveMethodInPeerPeer.ID);

        correctBooleans(criteria);

        List<SaveMethodInObjectFk> result = new ArrayList<SaveMethodInObjectFk>();
        List<List<Object>> rawResult = doSelect(
                criteria, compositeMapper, conn);
        for (List<Object> rawResultRow : rawResult)
        {
            SaveMethodInObjectFk obj1 = (SaveMethodInObjectFk) rawResultRow.get(0);
            SaveMethodInPeer obj2 = (SaveMethodInPeer) rawResultRow.get(1);

            boolean newObject = true;
            for (int j = 0; j < result.size(); j++)
            {
                SaveMethodInObjectFk temp_obj1 = result.get(j);
                org.apache.torque.test.SaveMethodInPeer temp_obj2 = temp_obj1.getSaveMethodInPeer();
                if (temp_obj2.getPrimaryKey().equals(obj2.getPrimaryKey()))
                {
                    newObject = false;
                    temp_obj2.addSaveMethodInObjectFk(obj1);
                    break;
                }
            }
            if (newObject)
            {
                obj2.initSaveMethodInObjectFks();
                obj2.addSaveMethodInObjectFk(obj1);
            }
            result.add(obj1);
        }
        return result;
    }


    /** 
     * Fills the referenced SaveMethodInPeer objects in the aSaveMethodInPeer fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     *
     * @return all read SaveMethodInPeer objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<SaveMethodInPeer> fillSaveMethodInPeers(
            Collection<SaveMethodInObjectFk> toFill) 
        throws TorqueException
    {
        Connection connection = null;
        try
        {
            connection = Transaction.begin(
                    SaveMethodInObjectFkPeer.DATABASE_NAME);
            List<SaveMethodInPeer> result = fillSaveMethodInPeers(toFill, connection);
            Transaction.commit(connection);
            connection = null;
            return result;
        }
        finally
        {
            if (connection != null)
            {
                Transaction.safeRollback(connection);
            }
        }
    }

    /** 
     * Fills the referenced SaveMethodInPeer objects in the aSaveMethodInPeer fields
     * of the objects in <code>toFill</code> by reading the database.
     *
     * @param toFill Contains the objects to fill, not null,
     *        may not contain null.
     * @param connection the database connection to use, not null.
     *
     * @return all read SaveMethodInPeer objects.
     *
     * @throws TorqueException if an error querying the database occurs.
     * @throws NullPointerException if toFill is null or contains null elements.
     */
    public List<SaveMethodInPeer> fillSaveMethodInPeers(
            Collection<SaveMethodInObjectFk> toFill,
            Connection connection) 
        throws TorqueException
    {
        Set<ObjectKey> foreignKeySet = new HashSet<ObjectKey>();
        for (SaveMethodInObjectFk currentSaveMethodInObjectFk : toFill)
        {
            ObjectKey foreignKey = currentSaveMethodInObjectFk.getForeignKeyForSaveMethodInPeer();
            if (foreignKey != null)
            {
                foreignKeySet.add(foreignKey);
            }
        }

        int fillerChunkSize = getFillerChunkSize();
        Iterator<ObjectKey> foreignKeyIt = foreignKeySet.iterator();
        List<ObjectKey> foreignKeyListChunk
                = new ArrayList<ObjectKey>(fillerChunkSize);;
        Map<ObjectKey, SaveMethodInPeer> referencedKeyToSaveMethodInPeerMap 
                = new HashMap<ObjectKey, SaveMethodInPeer>();
        while (foreignKeyIt.hasNext())
        {
            ObjectKey currentKey = foreignKeyIt.next();
            foreignKeyListChunk.add(currentKey);
            if (foreignKeyListChunk.size() < fillerChunkSize 
                && foreignKeyIt.hasNext())
            {
                continue;
            }

            List<SaveMethodInPeer> referencedSaveMethodInPeerList
                 = SaveMethodInPeerPeer.retrieveByPKs(
                     foreignKeyListChunk,
                     connection);

            for (SaveMethodInPeer referencedObject : referencedSaveMethodInPeerList)
            {
                referencedKeyToSaveMethodInPeerMap.put(
                        referencedObject.getPrimaryKey(),
                        referencedObject);
            }
            foreignKeyListChunk.clear();
        }

        List<SaveMethodInPeer> result = new ArrayList<SaveMethodInPeer>();
        for (SaveMethodInObjectFk objectToFill : toFill)
        {
            ObjectKey foreignKey = objectToFill.getForeignKeyForSaveMethodInPeer();
            if (foreignKey == null || foreignKey.getValue() == null)
            {
                continue;
            }
            SaveMethodInPeer referenced = referencedKeyToSaveMethodInPeerMap.get(
                    foreignKey);
            if (referenced == null)
            {
                throw new NoRowsException("No result found for key " 
                    + foreignKey + " in table save_method_in_peer");
            }
            // copy the referenced object for the case that more than one
            // toFill object references the same object; in this case
            // every toFillObject should have its own instance of the referenced
            // object to remain consistent with the other Torque reference
            // treatment
            SaveMethodInPeer referencedCopy = referenced.copy(false);
            // copy does not set primary key
            referencedCopy.setPrimaryKey(referenced.getPrimaryKey());
            objectToFill.setSaveMethodInPeer(referencedCopy);
            result.add(referencedCopy);
        }
        return result;
    }


    /** 
     * Returns the chunk size for the filler methods.
     *
     * @return the chunk size for the filler methods.
     */
    protected int getFillerChunkSize()
    {
        return 999;
    }


}
