package org.apache.torque.test;

import java.io.Serializable;
import java.sql.Connection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.apache.torque.TorqueException;
import org.apache.torque.map.TableMap;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.BooleanKey;
import org.apache.torque.om.ColumnAccessByName;
import org.apache.torque.criteria.Criteria;
import org.apache.commons.lang.ObjectUtils;


/**
 * This class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:39 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to SaveMethodInPeer
 */
public abstract class BaseSaveMethodInPeer 
    implements Serializable, ColumnAccessByName
{
    /** Serial version */
    private static final long serialVersionUID = 1347503739961L;



    /** Defines the id field. */
    private Integer id = null;

    /** Defines the payload field. */
    private String payload = null;

    /** Whether this object was modified after loading or after last save. */
    private boolean modified = true;

    /** 
     * Whether this object was loaded from the database or already saved 
     * (false) or whether it is not yet in the database(true).
     */
    private boolean isNew = true;

    /** Flag which indicates whether this object is currently saving. */
    private boolean saving = false;

    /** 
     * Flag which indicates whether this object is currently loaded
     * from the database. 
     */
    private boolean loading = false;

    /** 
     * Flag which indicates whether this object was deleted from the database.
     * Note that this flags does not always display the current database state,
     * there is no magical connection between this flag and the database.
     */
    private boolean deleted = false;



    /** Defines the collSaveMethodInPeerFks field. */
    protected List<SaveMethodInPeerFk> collSaveMethodInPeerFks = null;

    /** Defines the collSaveMethodInObjectFks field. */
    protected List<SaveMethodInObjectFk> collSaveMethodInObjectFks = null;



    /**
     * Get the value of id.
     *
     * @return Integer
     */
    public Integer getId() 
    {
        
        return id;
    }

    /**
     * Set the value of id.
     *
     * @param v new value
     */
    public void setId(Integer v)
    {
        if (!ObjectUtils.equals(this.id, v))
        {
            setModified(true);
        }

        this.id = v;

        // update associated objects in collSaveMethodInPeerFks 
        if (collSaveMethodInPeerFks != null)
        {
            for (int i = 0; i < collSaveMethodInPeerFks.size(); i++)
            {
                ((SaveMethodInPeerFk) collSaveMethodInPeerFks.get(i))
                        .setSaveMethodInPeerId(v);
            }
        }
        // update associated objects in collSaveMethodInObjectFks 
        if (collSaveMethodInObjectFks != null)
        {
            for (int i = 0; i < collSaveMethodInObjectFks.size(); i++)
            {
                ((SaveMethodInObjectFk) collSaveMethodInObjectFks.get(i))
                        .setSaveMethodInPeerId(v);
            }
        }

    }
    
    /**
     * Get the value of payload.
     *
     * @return String
     */
    public String getPayload() 
    {
        
        return payload;
    }

    /**
     * Set the value of payload.
     *
     * @param v new value
     */
    public void setPayload(String v)
    {
        if (!ObjectUtils.equals(this.payload, v))
        {
            setModified(true);
        }

        this.payload = v;


    }
    

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return true, if the object has never been persisted.
     */
    public boolean isNew()
    {
        return isNew;
    }

    /**
     * Sets whether the object has ever been saved.
     *
     * @param isNew true if the object has never been saved, false otherwise.
     */
    public void setNew(boolean isNew)
    {
        this.isNew = isNew;
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return True if the object has been modified.
     */
    public boolean isModified()
    {
        return modified;
    }

    /**
     * Sets whether the object has been modified.
     *
     * @param modified true if the object has been modified, false otherwise.
     */
    public void setModified(boolean modified)
    {
        this.modified = modified;
    }

    /**
     * Sets the modified state for the object to be false.
     */
    public void resetModified()
    {
        modified = false;
    }


    /**
     * Returns whether this object is currently saving.
     *
     * @return true if this object is currently saving, false otherwise.
     */
    public boolean isSaving()
    {
        return saving;
    }

    /**
     * Sets whether this object is currently saving.
     *
     * @param saving true if this object is currently saving, false otherwise.
     */
    public void setSaving(boolean saving)
    {
        this.saving = saving;
    }


    /**
     * Returns whether this object is currently being loaded from the database.
     *
     * @return true if this object is currently loading, false otherwise.
     */
    public boolean isLoading()
    {
        return loading;
    }

    /**
     * Sets whether this object is currently being loaded from the database.
     *
     * @param loading true if this object is currently loading, false otherwise.
     */
    public void setLoading(boolean loading)
    {
        this.loading = loading;
    }


    /**
     * Returns whether this object was deleted from the database.
     * Note that this getter does not automatically reflect database state,
     * it will be set to true by Torque if doDelete() was called with this 
     * object. Bulk deletes and deletes via primary key do not change
     * this flag. Also, if doDelete() was called on an object which does
     * not exist in the database, the deleted flag is set to true even if
     * it was not deleted.
     *
     * @return true if this object was deleted, false otherwise.
     */
    public boolean isDeleted()
    {
        return deleted;
    }

    /**
     * Sets whether this object was deleted from the database.
     *
     * @param deleted true if this object was deleted, false otherwise.
     */
    public void setDeleted(boolean deleted)
    {
        this.deleted = deleted;
    }




    /**
     * Initializes the cache collSaveMethodInPeerFks for referenced objects. 
     */
    public void initSaveMethodInPeerFks()
    {
        if (collSaveMethodInPeerFks == null)
        {
            collSaveMethodInPeerFks = new ArrayList<SaveMethodInPeerFk>();
        }
    }

    /**
     * Checks whether the cache collSaveMethodInPeerFks for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isSaveMethodInPeerFksInitialized()
    {
        return (collSaveMethodInPeerFks != null);
    }


    /**
     * Method called to associate a SaveMethodInPeerFk object to this object
     * through the collSaveMethodInPeerFks foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addSaveMethodInPeerFk(SaveMethodInPeerFk toAdd)
        throws TorqueException
    {
        toAdd.setSaveMethodInPeer((SaveMethodInPeer) this);
        getSaveMethodInPeerFks().add(toAdd);
    }

    /**
     * Method called to associate a SaveMethodInPeerFk object to this object
     * through the collSaveMethodInPeerFks foreign key attribute using connection.
     *
     * @param l SaveMethodInPeerFk
     * @throws TorqueException
     */
    public void addSaveMethodInPeerFk(SaveMethodInPeerFk l, Connection con) throws TorqueException
    {
        getSaveMethodInPeerFks(con).add(l);
        l.setSaveMethodInPeer((SaveMethodInPeer) this);
    }
    
    /**
     * The criteria used to select the current contents of collSaveMethodInPeerFks
     */
    private Criteria lastSaveMethodInPeerFkCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getSaveMethodInPeerFks(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<SaveMethodInPeerFk> getSaveMethodInPeerFks()
        throws TorqueException
    {
        if (collSaveMethodInPeerFks == null)
        {
            collSaveMethodInPeerFks = getSaveMethodInPeerFks(new Criteria());
        }
        return collSaveMethodInPeerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseSaveMethodInPeer has previously
     * been saved, it will retrieve related collSaveMethodInPeerFks from storage.
     * If this BaseSaveMethodInPeer is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<SaveMethodInPeerFk> getSaveMethodInPeerFks(Criteria criteria) throws TorqueException
    {
        if (collSaveMethodInPeerFks == null)
        {
            if (isNew())
            {
               initSaveMethodInPeerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.SaveMethodInPeerFkPeer.SAVE_METHOD_IN_PEER_ID, getId() );
                collSaveMethodInPeerFks = org.apache.torque.test.SaveMethodInPeerFkPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.SaveMethodInPeerFkPeer.SAVE_METHOD_IN_PEER_ID, getId() );
                if (lastSaveMethodInPeerFkCriteria == null 
                        || !lastSaveMethodInPeerFkCriteria.equals(criteria))
                {
                    collSaveMethodInPeerFks = org.apache.torque.test.SaveMethodInPeerFkPeer.doSelect(criteria);
                }
            }
        }
        lastSaveMethodInPeerFkCriteria = criteria;

        return collSaveMethodInPeerFks;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getSaveMethodInPeerFks(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<SaveMethodInPeerFk> getSaveMethodInPeerFks(Connection con) throws TorqueException
    {
        if (collSaveMethodInPeerFks == null)
        {
            collSaveMethodInPeerFks = getSaveMethodInPeerFks(new Criteria(), con);
        }
        return collSaveMethodInPeerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseSaveMethodInPeer has previously
     * been saved, it will retrieve the related SaveMethodInPeerFk Objects 
     * from storage.
     * If this BaseSaveMethodInPeer is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<SaveMethodInPeerFk> getSaveMethodInPeerFks(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collSaveMethodInPeerFks == null)
        {
            if (isNew())
            {
               initSaveMethodInPeerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.SaveMethodInPeerFkPeer.SAVE_METHOD_IN_PEER_ID, getId());
                collSaveMethodInPeerFks = org.apache.torque.test.SaveMethodInPeerFkPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.SaveMethodInPeerFkPeer.SAVE_METHOD_IN_PEER_ID, getId());
                if (!lastSaveMethodInPeerFkCriteria.equals(criteria))
                {
                    collSaveMethodInPeerFks = org.apache.torque.test.SaveMethodInPeerFkPeer.doSelect(criteria, con);
                }
            }
        }
        lastSaveMethodInPeerFkCriteria = criteria;

        return collSaveMethodInPeerFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseSaveMethodInPeer is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<SaveMethodInPeerFk> getSaveMethodInPeerFksJoinSaveMethodInPeer(Criteria criteria) throws TorqueException
    {
        return getSaveMethodInPeerFksJoinSaveMethodInPeer(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseSaveMethodInPeer is new, it will return
     * an empty collection; or if this BaseSaveMethodInPeer has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<SaveMethodInPeerFk> getSaveMethodInPeerFksJoinSaveMethodInPeer(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collSaveMethodInPeerFks == null)
        {
            if (isNew())
            {
                initSaveMethodInPeerFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.SaveMethodInPeerFkPeer.SAVE_METHOD_IN_PEER_ID, getId() );
                collSaveMethodInPeerFks = org.apache.torque.test.SaveMethodInPeerFkPeer.doSelectJoinSaveMethodInPeer(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.SaveMethodInPeerFkPeer.SAVE_METHOD_IN_PEER_ID, getId() );
            if (!lastSaveMethodInPeerFkCriteria.equals(criteria))
            {
                collSaveMethodInPeerFks = org.apache.torque.test.SaveMethodInPeerFkPeer.doSelectJoinSaveMethodInPeer(criteria, connection);
            }
        }
        lastSaveMethodInPeerFkCriteria = criteria;

        return collSaveMethodInPeerFks;
    }

    /**
     * Initializes the cache collSaveMethodInObjectFks for referenced objects. 
     */
    public void initSaveMethodInObjectFks()
    {
        if (collSaveMethodInObjectFks == null)
        {
            collSaveMethodInObjectFks = new ArrayList<SaveMethodInObjectFk>();
        }
    }

    /**
     * Checks whether the cache collSaveMethodInObjectFks for referenced objects has either been
     * loaded from the database or has been manually initialized.
     */
    public boolean isSaveMethodInObjectFksInitialized()
    {
        return (collSaveMethodInObjectFks != null);
    }


    /**
     * Method called to associate a SaveMethodInObjectFk object to this object
     * through the collSaveMethodInObjectFks foreign key attribute.
     * If the associated objects were not retrieved before
     * and this object is not new, the associated objects are retrieved
     * from the database before adding the <code>toAdd</code> object.
     *
     * @param toAdd the object to add to the associated objects, not null.
     *
     * @throws TorqueException if retrieval of the associated objects fails.
     * @throws NullPointerException if toAdd is null.
     */
    public void addSaveMethodInObjectFk(SaveMethodInObjectFk toAdd)
        throws TorqueException
    {
        toAdd.setSaveMethodInPeer((SaveMethodInPeer) this);
        getSaveMethodInObjectFks().add(toAdd);
    }

    /**
     * Method called to associate a SaveMethodInObjectFk object to this object
     * through the collSaveMethodInObjectFks foreign key attribute using connection.
     *
     * @param l SaveMethodInObjectFk
     * @throws TorqueException
     */
    public void addSaveMethodInObjectFk(SaveMethodInObjectFk l, Connection con) throws TorqueException
    {
        getSaveMethodInObjectFks(con).add(l);
        l.setSaveMethodInPeer((SaveMethodInPeer) this);
    }
    
    /**
     * The criteria used to select the current contents of collSaveMethodInObjectFks
     */
    private Criteria lastSaveMethodInObjectFkCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getSaveMethodInObjectFks(new Criteria())
     *
     * @return the collection of associated objects
     * @throws TorqueException
     */
    public List<SaveMethodInObjectFk> getSaveMethodInObjectFks()
        throws TorqueException
    {
        if (collSaveMethodInObjectFks == null)
        {
            collSaveMethodInObjectFks = getSaveMethodInObjectFks(new Criteria());
        }
        return collSaveMethodInObjectFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseSaveMethodInPeer has previously
     * been saved, it will retrieve related collSaveMethodInObjectFks from storage.
     * If this BaseSaveMethodInPeer is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List<SaveMethodInObjectFk> getSaveMethodInObjectFks(Criteria criteria) throws TorqueException
    {
        if (collSaveMethodInObjectFks == null)
        {
            if (isNew())
            {
               initSaveMethodInObjectFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.SaveMethodInObjectFkPeer.SAVE_METHOD_IN_PEER_ID, getId() );
                collSaveMethodInObjectFks = org.apache.torque.test.SaveMethodInObjectFkPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.SaveMethodInObjectFkPeer.SAVE_METHOD_IN_PEER_ID, getId() );
                if (lastSaveMethodInObjectFkCriteria == null 
                        || !lastSaveMethodInObjectFkCriteria.equals(criteria))
                {
                    collSaveMethodInObjectFks = org.apache.torque.test.SaveMethodInObjectFkPeer.doSelect(criteria);
                }
            }
        }
        lastSaveMethodInObjectFkCriteria = criteria;

        return collSaveMethodInObjectFks;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getSaveMethodInObjectFks(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<SaveMethodInObjectFk> getSaveMethodInObjectFks(Connection con) throws TorqueException
    {
        if (collSaveMethodInObjectFks == null)
        {
            collSaveMethodInObjectFks = getSaveMethodInObjectFks(new Criteria(), con);
        }
        return collSaveMethodInObjectFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseSaveMethodInPeer has previously
     * been saved, it will retrieve the related SaveMethodInObjectFk Objects 
     * from storage.
     * If this BaseSaveMethodInPeer is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List<SaveMethodInObjectFk> getSaveMethodInObjectFks(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collSaveMethodInObjectFks == null)
        {
            if (isNew())
            {
               initSaveMethodInObjectFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.SaveMethodInObjectFkPeer.SAVE_METHOD_IN_PEER_ID, getId());
                collSaveMethodInObjectFks = org.apache.torque.test.SaveMethodInObjectFkPeer.doSelect(criteria, con);
            }
        }
        else
        {
             // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                criteria.and(org.apache.torque.test.SaveMethodInObjectFkPeer.SAVE_METHOD_IN_PEER_ID, getId());
                if (!lastSaveMethodInObjectFkCriteria.equals(criteria))
                {
                    collSaveMethodInObjectFks = org.apache.torque.test.SaveMethodInObjectFkPeer.doSelect(criteria, con);
                }
            }
        }
        lastSaveMethodInObjectFkCriteria = criteria;

        return collSaveMethodInObjectFks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseSaveMethodInPeer is new, it will return
     * an empty collection; or if this thisObjectClassName has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<SaveMethodInObjectFk> getSaveMethodInObjectFksJoinSaveMethodInPeer(Criteria criteria) throws TorqueException
    {
        return getSaveMethodInObjectFksJoinSaveMethodInPeer(criteria, null);
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this BaseSaveMethodInPeer is new, it will return
     * an empty collection; or if this BaseSaveMethodInPeer has previously
     * been saved, it will retrieve the related objects from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can change the access modifier to public
     * by overriding this method in the child class.
     */
    protected List<SaveMethodInObjectFk> getSaveMethodInObjectFksJoinSaveMethodInPeer(Criteria criteria, Connection connection)
        throws TorqueException
    {
        if (collSaveMethodInObjectFks == null)
        {
            if (isNew())
            {
                initSaveMethodInObjectFks();
            }
            else
            {
                criteria.and(org.apache.torque.test.SaveMethodInObjectFkPeer.SAVE_METHOD_IN_PEER_ID, getId() );
                collSaveMethodInObjectFks = org.apache.torque.test.SaveMethodInObjectFkPeer.doSelectJoinSaveMethodInPeer(criteria, connection);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            criteria.and(org.apache.torque.test.SaveMethodInObjectFkPeer.SAVE_METHOD_IN_PEER_ID, getId() );
            if (!lastSaveMethodInObjectFkCriteria.equals(criteria))
            {
                collSaveMethodInObjectFks = org.apache.torque.test.SaveMethodInObjectFkPeer.doSelectJoinSaveMethodInPeer(criteria, connection);
            }
        }
        lastSaveMethodInObjectFkCriteria = criteria;

        return collSaveMethodInObjectFks;
    }




    private static final List<String> FIELD_NAMES;

    static
    {
        List<String> fieldNames
                = new ArrayList<String>();
        fieldNames.add("Id");
        fieldNames.add("Payload");
        FIELD_NAMES = Collections.unmodifiableList(fieldNames);
    }

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static List<String> getFieldNames()
    {
        return FIELD_NAMES;
    }

    /**
     * Retrieves a field from the object by field (Java) name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
        if (name.equals("Id"))
        {
            return getId();
        }
        if (name.equals("Payload"))
        {
            return getPayload();
        }
        return null;
    }

    /**
     * Set a field in the object by field (Java) name.
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (name.equals("Id"))
        {
            // Object fields can be null
            if (value != null && ! Integer.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setId((Integer) value);
            return true;
        }
        if (name.equals("Payload"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPayload((String) value);
            return true;
        }
        return false;
    }

    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
        if (name.equals(org.apache.torque.test.SaveMethodInPeerPeer.ID))
        {
            return getId();
        }
        if (name.equals(org.apache.torque.test.SaveMethodInPeerPeer.PAYLOAD))
        {
            return getPayload();
        }
        return null;
    }

    /**
     * Set field values by Peer Field Name
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPeerName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (org.apache.torque.test.SaveMethodInPeerPeer.ID.getSqlExpression().equals(name))
        {
            return setByName("Id", value);
        }
        if (org.apache.torque.test.SaveMethodInPeerPeer.PAYLOAD.getSqlExpression().equals(name))
        {
            return setByName("Payload", value);
        }
        return false;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
        if (pos == 0)
        {
            return getId();
        }
        if (pos == 1)
        {
            return getPayload();
        }
        return null;
    }

    /**
     * Set field values by its position (zero based) in the XML schema.
     *
     * @param position The field position
     * @param value field value
     * @return True if value was set, false if not (invalid position / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPosition(int position, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (position == 0)
        {
            return setByName("Id", value);
        }
        if (position == 1)
        {
            return setByName("Payload", value);
        }
        return false;
    }




    /**
     * Set the PrimaryKey using ObjectKey.
     *
     * @param key id ObjectKey
     */
    public void setPrimaryKey(ObjectKey key)
        
    {
        setId(Integer.valueOf(((NumberKey) key).intValue()));
    }

    /**
     * Set the PrimaryKey using a String.
     *
     * @param key
     */
    public void setPrimaryKey(String key) 
    {
        setId(new Integer(key));
    }


    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        return SimpleKey.keyFor(getId());
    }



    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public SaveMethodInPeer copy() throws TorqueException
    {
        return copy(true);
    }

    /**
     * Makes a copy of this object using a connection.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     *
     * @param con the database connection to read associated objects.
     */
    public SaveMethodInPeer copy(Connection con) throws TorqueException
    {
        return copy(true, con);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     */
    public SaveMethodInPeer copy(boolean deepcopy) throws TorqueException
    {
        SaveMethodInPeer saveMethodInPeer = new SaveMethodInPeer();

        return copyInto(saveMethodInPeer, deepcopy);
    }

    /**
     * Makes a copy of this object using connection.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @param con the database connection to read associated objects.
     */
    public SaveMethodInPeer copy(boolean deepcopy, Connection con) throws TorqueException
    {
        SaveMethodInPeer saveMethodInPeer = new SaveMethodInPeer();

        return copyInto(saveMethodInPeer, deepcopy, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     */
    protected SaveMethodInPeer copyInto(SaveMethodInPeer copyObj) throws TorqueException
    {
        return copyInto(copyObj, true);
    }

    /**
     * Fills the copyObj with the contents of this object using connection.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param con the database connection to read associated objects.
     */
    protected SaveMethodInPeer copyInto(SaveMethodInPeer copyObj, Connection con) throws TorqueException
    {
        return copyInto(copyObj, true, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     */
    protected SaveMethodInPeer copyInto(SaveMethodInPeer copyObj, boolean deepcopy) throws TorqueException
    {
        copyObj.setId((Integer) null);
        copyObj.setPayload(payload);

        if (deepcopy)
        {
            if (collSaveMethodInPeerFks != null)
            {
                for (int i = 0; i < collSaveMethodInPeerFks.size(); i++)
                {
                    SaveMethodInPeerFk obj = collSaveMethodInPeerFks.get(i);
                    copyObj.addSaveMethodInPeerFk(obj.copy());
                }
            }
            else
            {
                copyObj.collSaveMethodInPeerFks = null;
            }
            if (collSaveMethodInObjectFks != null)
            {
                for (int i = 0; i < collSaveMethodInObjectFks.size(); i++)
                {
                    SaveMethodInObjectFk obj = collSaveMethodInObjectFks.get(i);
                    copyObj.addSaveMethodInObjectFk(obj.copy());
                }
            }
            else
            {
                copyObj.collSaveMethodInObjectFks = null;
            }
        }
        return copyObj;
    }
        
    
    /**
     * Fills the copyObj with the contents of this object using connection.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @param con the database connection to read associated objects.
     */
    protected SaveMethodInPeer copyInto(SaveMethodInPeer copyObj, boolean deepcopy, Connection con) throws TorqueException
    {
        copyObj.setId((Integer) null);
        copyObj.setPayload(payload);

        if (deepcopy)
        {
            for (SaveMethodInPeerFk obj : getSaveMethodInPeerFks(con))
            {
                copyObj.addSaveMethodInPeerFk(obj.copy());
            }
            for (SaveMethodInObjectFk obj : getSaveMethodInObjectFks(con))
            {
                copyObj.addSaveMethodInObjectFk(obj.copy());
            }
        }
        return copyObj;
    }

    /** The Peer class */
    private static final org.apache.torque.test.SaveMethodInPeerPeer peer
            = new org.apache.torque.test.SaveMethodInPeerPeer();

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public org.apache.torque.test.SaveMethodInPeerPeer getPeer()
    {
        return peer;
    }

    /**
     * Retrieves the TableMap object related to this Table data without
     * compiler warnings of using getPeer().getTableMap().
     *
     * @return The associated TableMap object.
     */
    public TableMap getTableMap() throws TorqueException
    {
        return org.apache.torque.test.SaveMethodInPeerPeer.getTableMap();
    }



    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("SaveMethodInPeer:\n");
        str.append("id = ")
           .append(getId())
           .append("\n");
        str.append("payload = ")
           .append(getPayload())
           .append("\n");
        return(str.toString());
    }

    /**
     * Compares the primary key of this instance with the key of another.
     *
     * @param toCompare The object to compare to.
     * @return Whether the primary keys are equal and the object have the
     *         same class.
     */
    public boolean equals(Object toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!getClass().equals(toCompare.getClass()))
        {
            return false;
        }
        SaveMethodInPeer other = (SaveMethodInPeer) toCompare;
        if (getPrimaryKey() == null || other.getPrimaryKey() == null)
        {
            return false;
        }
        return getPrimaryKey().equals(other.getPrimaryKey());
    }

    /**
     * If the primary key is not <code>null</code>, return the hashcode of the
     * primary key.  Otherwise calls <code>Object.hashCode()</code>.
     *
     * @return an <code>int</code> value
     */
    public int hashCode()
    {
        ObjectKey ok = getPrimaryKey();
        if (ok == null)
        {
            return super.hashCode();
        }

        return ok.hashCode();
    }




}
