package org.apache.torque.test;

import java.io.Serializable;
import java.sql.Connection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.apache.torque.TorqueException;
import org.apache.torque.map.TableMap;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.BooleanKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.om.ColumnAccessByName;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.util.Transaction;
import org.apache.commons.lang.ObjectUtils;


/**
 * used to test the handling for all supported types
 *
 * This class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:41 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to TypesObject
 */
public abstract class BaseTypesObject 
    implements Persistent, Serializable, ColumnAccessByName
{
    /** Serial version */
    private static final long serialVersionUID = 1347503741018L;



    /** Defines the oBit field. */
    private Boolean oBit = null;

    /** Defines the oTinyint field. */
    private Byte oTinyint = null;

    /** Defines the oSmallint field. */
    private Short oSmallint = null;

    /** Defines the oBigint field. */
    private Long oBigint = null;

    /** Defines the oFloat field. */
    private Double oFloat = null;

    /** Defines the oReal field. */
    private Float oReal = null;

    /** Defines the oNumeric field. */
    private java.math.BigDecimal oNumeric = null;

    /** Defines the oDecimal field. */
    private java.math.BigDecimal oDecimal = null;

    /** Defines the oChar field. */
    private String oChar = null;

    /** Defines the oVarchar field. */
    private String oVarchar = null;

    /** Defines the oLongvarchar field. */
    private String oLongvarchar = null;

    /** Defines the oDate field. */
    private java.util.Date oDate = null;

    /** Defines the oTime field. */
    private java.util.Date oTime = null;

    /** Defines the oInteger field. */
    private Integer oInteger = null;

    /** Defines the oTimestamp field. */
    private java.util.Date oTimestamp = null;

    /** Defines the oBinary field. */
    private byte[] oBinary = null;

    /** Defines the oVarbinary field. */
    private byte[] oVarbinary = null;

    /** Defines the oLongvarbinary field. */
    private byte[] oLongvarbinary = null;

    /** Defines the oBlob field. */
    private byte[] oBlob = null;

    /** Defines the oClob field. */
    private String oClob = null;

    /** Defines the oBooleanint field. */
    private Boolean oBooleanint = null;

    /** Defines the oBooleanchar field. */
    private Boolean oBooleanchar = null;

    /** Defines the oDouble field. */
    private Double oDouble = null;

    /** Whether this object was modified after loading or after last save. */
    private boolean modified = true;

    /** 
     * Whether this object was loaded from the database or already saved 
     * (false) or whether it is not yet in the database(true).
     */
    private boolean isNew = true;

    /** Flag which indicates whether this object is currently saving. */
    private boolean saving = false;

    /** 
     * Flag which indicates whether this object is currently loaded
     * from the database. 
     */
    private boolean loading = false;

    /** 
     * Flag which indicates whether this object was deleted from the database.
     * Note that this flags does not always display the current database state,
     * there is no magical connection between this flag and the database.
     */
    private boolean deleted = false;





    /**
     * Get the value of oBit.
     *
     * @return Boolean
     */
    public Boolean getOBit() 
    {
        
        return oBit;
    }

    /**
     * Set the value of oBit.
     *
     * @param v new value
     */
    public void setOBit(Boolean v)
    {
        if (!ObjectUtils.equals(this.oBit, v))
        {
            setModified(true);
        }

        this.oBit = v;


    }
    
    /**
     * Get the value of oTinyint.
     *
     * @return Byte
     */
    public Byte getOTinyint() 
    {
        
        return oTinyint;
    }

    /**
     * Set the value of oTinyint.
     *
     * @param v new value
     */
    public void setOTinyint(Byte v)
    {
        if (!ObjectUtils.equals(this.oTinyint, v))
        {
            setModified(true);
        }

        this.oTinyint = v;


    }
    
    /**
     * Get the value of oSmallint.
     *
     * @return Short
     */
    public Short getOSmallint() 
    {
        
        return oSmallint;
    }

    /**
     * Set the value of oSmallint.
     *
     * @param v new value
     */
    public void setOSmallint(Short v)
    {
        if (!ObjectUtils.equals(this.oSmallint, v))
        {
            setModified(true);
        }

        this.oSmallint = v;


    }
    
    /**
     * Get the value of oBigint.
     *
     * @return Long
     */
    public Long getOBigint() 
    {
        
        return oBigint;
    }

    /**
     * Set the value of oBigint.
     *
     * @param v new value
     */
    public void setOBigint(Long v)
    {
        if (!ObjectUtils.equals(this.oBigint, v))
        {
            setModified(true);
        }

        this.oBigint = v;


    }
    
    /**
     * Get the value of oFloat.
     *
     * @return Double
     */
    public Double getOFloat() 
    {
        
        return oFloat;
    }

    /**
     * Set the value of oFloat.
     *
     * @param v new value
     */
    public void setOFloat(Double v)
    {
        if (!ObjectUtils.equals(this.oFloat, v))
        {
            setModified(true);
        }

        this.oFloat = v;


    }
    
    /**
     * Get the value of oReal.
     *
     * @return Float
     */
    public Float getOReal() 
    {
        
        return oReal;
    }

    /**
     * Set the value of oReal.
     *
     * @param v new value
     */
    public void setOReal(Float v)
    {
        if (!ObjectUtils.equals(this.oReal, v))
        {
            setModified(true);
        }

        this.oReal = v;


    }
    
    /**
     * Get the value of oNumeric.
     *
     * @return java.math.BigDecimal
     */
    public java.math.BigDecimal getONumeric() 
    {
        
        return oNumeric;
    }

    /**
     * Set the value of oNumeric.
     *
     * @param v new value
     */
    public void setONumeric(java.math.BigDecimal v)
    {
        if (!ObjectUtils.equals(this.oNumeric, v))
        {
            setModified(true);
        }

        this.oNumeric = v;


    }
    
    /**
     * Get the value of oDecimal.
     *
     * @return java.math.BigDecimal
     */
    public java.math.BigDecimal getODecimal() 
    {
        
        return oDecimal;
    }

    /**
     * Set the value of oDecimal.
     *
     * @param v new value
     */
    public void setODecimal(java.math.BigDecimal v)
    {
        if (!ObjectUtils.equals(this.oDecimal, v))
        {
            setModified(true);
        }

        this.oDecimal = v;


    }
    
    /**
     * Get the value of oChar.
     *
     * @return String
     */
    public String getOChar() 
    {
        
        return oChar;
    }

    /**
     * Set the value of oChar.
     *
     * @param v new value
     */
    public void setOChar(String v)
    {
        if (!ObjectUtils.equals(this.oChar, v))
        {
            setModified(true);
        }

        this.oChar = v;


    }
    
    /**
     * Get the value of oVarchar.
     *
     * @return String
     */
    public String getOVarchar() 
    {
        
        return oVarchar;
    }

    /**
     * Set the value of oVarchar.
     *
     * @param v new value
     */
    public void setOVarchar(String v)
    {
        if (!ObjectUtils.equals(this.oVarchar, v))
        {
            setModified(true);
        }

        this.oVarchar = v;


    }
    
    /**
     * Get the value of oLongvarchar.
     *
     * @return String
     */
    public String getOLongvarchar() 
    {
        
        return oLongvarchar;
    }

    /**
     * Set the value of oLongvarchar.
     *
     * @param v new value
     */
    public void setOLongvarchar(String v)
    {
        if (!ObjectUtils.equals(this.oLongvarchar, v))
        {
            setModified(true);
        }

        this.oLongvarchar = v;


    }
    
    /**
     * Get the value of oDate.
     *
     * @return java.util.Date
     */
    public java.util.Date getODate() 
    {
        
        return oDate;
    }

    /**
     * Set the value of oDate.
     *
     * @param v new value
     */
    public void setODate(java.util.Date v)
    {
        if (!ObjectUtils.equals(this.oDate, v))
        {
            setModified(true);
        }

        this.oDate = v;


    }
    
    /**
     * Get the value of oTime.
     *
     * @return java.util.Date
     */
    public java.util.Date getOTime() 
    {
        
        return oTime;
    }

    /**
     * Set the value of oTime.
     *
     * @param v new value
     */
    public void setOTime(java.util.Date v)
    {
        if (!ObjectUtils.equals(this.oTime, v))
        {
            setModified(true);
        }

        this.oTime = v;


    }
    
    /**
     * Get the value of oInteger.
     *
     * @return Integer
     */
    public Integer getOInteger() 
    {
        
        return oInteger;
    }

    /**
     * Set the value of oInteger.
     *
     * @param v new value
     */
    public void setOInteger(Integer v)
    {
        if (!ObjectUtils.equals(this.oInteger, v))
        {
            setModified(true);
        }

        this.oInteger = v;


    }
    
    /**
     * Get the value of oTimestamp.
     *
     * @return java.util.Date
     */
    public java.util.Date getOTimestamp() 
    {
        
        return oTimestamp;
    }

    /**
     * Set the value of oTimestamp.
     *
     * @param v new value
     */
    public void setOTimestamp(java.util.Date v)
    {
        if (!ObjectUtils.equals(this.oTimestamp, v))
        {
            setModified(true);
        }

        this.oTimestamp = v;


    }
    
    /**
     * Get the value of oBinary.
     *
     * @return byte[]
     */
    public byte[] getOBinary() 
    {
        
        return oBinary;
    }

    /**
     * Set the value of oBinary.
     *
     * @param v new value
     */
    public void setOBinary(byte[] v)
    {
        if (!ObjectUtils.equals(this.oBinary, v))
        {
            setModified(true);
        }

        this.oBinary = v;


    }
    
    /**
     * Get the value of oVarbinary.
     *
     * @return byte[]
     */
    public byte[] getOVarbinary() 
    {
        
        return oVarbinary;
    }

    /**
     * Set the value of oVarbinary.
     *
     * @param v new value
     */
    public void setOVarbinary(byte[] v)
    {
        if (!ObjectUtils.equals(this.oVarbinary, v))
        {
            setModified(true);
        }

        this.oVarbinary = v;


    }
    
    /**
     * Get the value of oLongvarbinary.
     *
     * @return byte[]
     */
    public byte[] getOLongvarbinary() 
    {
        
        return oLongvarbinary;
    }

    /**
     * Set the value of oLongvarbinary.
     *
     * @param v new value
     */
    public void setOLongvarbinary(byte[] v)
    {
        if (!ObjectUtils.equals(this.oLongvarbinary, v))
        {
            setModified(true);
        }

        this.oLongvarbinary = v;


    }
    
    /**
     * Get the value of oBlob.
     *
     * @return byte[]
     */
    public byte[] getOBlob() 
    {
        
        return oBlob;
    }

    /**
     * Set the value of oBlob.
     *
     * @param v new value
     */
    public void setOBlob(byte[] v)
    {
        if (!ObjectUtils.equals(this.oBlob, v))
        {
            setModified(true);
        }

        this.oBlob = v;


    }
    
    /**
     * Get the value of oClob.
     *
     * @return String
     */
    public String getOClob() 
    {
        
        return oClob;
    }

    /**
     * Set the value of oClob.
     *
     * @param v new value
     */
    public void setOClob(String v)
    {
        if (!ObjectUtils.equals(this.oClob, v))
        {
            setModified(true);
        }

        this.oClob = v;


    }
    
    /**
     * Get the value of oBooleanint.
     *
     * @return Boolean
     */
    public Boolean getOBooleanint() 
    {
        
        return oBooleanint;
    }

    /**
     * Set the value of oBooleanint.
     *
     * @param v new value
     */
    public void setOBooleanint(Boolean v)
    {
        if (!ObjectUtils.equals(this.oBooleanint, v))
        {
            setModified(true);
        }

        this.oBooleanint = v;


    }
    
    /**
     * Get the value of oBooleanchar.
     *
     * @return Boolean
     */
    public Boolean getOBooleanchar() 
    {
        
        return oBooleanchar;
    }

    /**
     * Set the value of oBooleanchar.
     *
     * @param v new value
     */
    public void setOBooleanchar(Boolean v)
    {
        if (!ObjectUtils.equals(this.oBooleanchar, v))
        {
            setModified(true);
        }

        this.oBooleanchar = v;


    }
    
    /**
     * Get the value of oDouble.
     *
     * @return Double
     */
    public Double getODouble() 
    {
        
        return oDouble;
    }

    /**
     * Set the value of oDouble.
     *
     * @param v new value
     */
    public void setODouble(Double v)
    {
        if (!ObjectUtils.equals(this.oDouble, v))
        {
            setModified(true);
        }

        this.oDouble = v;


    }
    

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return true, if the object has never been persisted.
     */
    public boolean isNew()
    {
        return isNew;
    }

    /**
     * Sets whether the object has ever been saved.
     *
     * @param isNew true if the object has never been saved, false otherwise.
     */
    public void setNew(boolean isNew)
    {
        this.isNew = isNew;
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return True if the object has been modified.
     */
    public boolean isModified()
    {
        return modified;
    }

    /**
     * Sets whether the object has been modified.
     *
     * @param modified true if the object has been modified, false otherwise.
     */
    public void setModified(boolean modified)
    {
        this.modified = modified;
    }

    /**
     * Sets the modified state for the object to be false.
     */
    public void resetModified()
    {
        modified = false;
    }


    /**
     * Returns whether this object is currently saving.
     *
     * @return true if this object is currently saving, false otherwise.
     */
    public boolean isSaving()
    {
        return saving;
    }

    /**
     * Sets whether this object is currently saving.
     *
     * @param saving true if this object is currently saving, false otherwise.
     */
    public void setSaving(boolean saving)
    {
        this.saving = saving;
    }


    /**
     * Returns whether this object is currently being loaded from the database.
     *
     * @return true if this object is currently loading, false otherwise.
     */
    public boolean isLoading()
    {
        return loading;
    }

    /**
     * Sets whether this object is currently being loaded from the database.
     *
     * @param loading true if this object is currently loading, false otherwise.
     */
    public void setLoading(boolean loading)
    {
        this.loading = loading;
    }


    /**
     * Returns whether this object was deleted from the database.
     * Note that this getter does not automatically reflect database state,
     * it will be set to true by Torque if doDelete() was called with this 
     * object. Bulk deletes and deletes via primary key do not change
     * this flag. Also, if doDelete() was called on an object which does
     * not exist in the database, the deleted flag is set to true even if
     * it was not deleted.
     *
     * @return true if this object was deleted, false otherwise.
     */
    public boolean isDeleted()
    {
        return deleted;
    }

    /**
     * Sets whether this object was deleted from the database.
     *
     * @param deleted true if this object was deleted, false otherwise.
     */
    public void setDeleted(boolean deleted)
    {
        this.deleted = deleted;
    }







    private static final List<String> FIELD_NAMES;

    static
    {
        List<String> fieldNames
                = new ArrayList<String>();
        fieldNames.add("OBit");
        fieldNames.add("OTinyint");
        fieldNames.add("OSmallint");
        fieldNames.add("OBigint");
        fieldNames.add("OFloat");
        fieldNames.add("OReal");
        fieldNames.add("ONumeric");
        fieldNames.add("ODecimal");
        fieldNames.add("OChar");
        fieldNames.add("OVarchar");
        fieldNames.add("OLongvarchar");
        fieldNames.add("ODate");
        fieldNames.add("OTime");
        fieldNames.add("OInteger");
        fieldNames.add("OTimestamp");
        fieldNames.add("OBinary");
        fieldNames.add("OVarbinary");
        fieldNames.add("OLongvarbinary");
        fieldNames.add("OBlob");
        fieldNames.add("OClob");
        fieldNames.add("OBooleanint");
        fieldNames.add("OBooleanchar");
        fieldNames.add("ODouble");
        FIELD_NAMES = Collections.unmodifiableList(fieldNames);
    }

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static List<String> getFieldNames()
    {
        return FIELD_NAMES;
    }

    /**
     * Retrieves a field from the object by field (Java) name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
        if (name.equals("OBit"))
        {
            return getOBit();
        }
        if (name.equals("OTinyint"))
        {
            return getOTinyint();
        }
        if (name.equals("OSmallint"))
        {
            return getOSmallint();
        }
        if (name.equals("OBigint"))
        {
            return getOBigint();
        }
        if (name.equals("OFloat"))
        {
            return getOFloat();
        }
        if (name.equals("OReal"))
        {
            return getOReal();
        }
        if (name.equals("ONumeric"))
        {
            return getONumeric();
        }
        if (name.equals("ODecimal"))
        {
            return getODecimal();
        }
        if (name.equals("OChar"))
        {
            return getOChar();
        }
        if (name.equals("OVarchar"))
        {
            return getOVarchar();
        }
        if (name.equals("OLongvarchar"))
        {
            return getOLongvarchar();
        }
        if (name.equals("ODate"))
        {
            return getODate();
        }
        if (name.equals("OTime"))
        {
            return getOTime();
        }
        if (name.equals("OInteger"))
        {
            return getOInteger();
        }
        if (name.equals("OTimestamp"))
        {
            return getOTimestamp();
        }
        if (name.equals("OBinary"))
        {
            return getOBinary();
        }
        if (name.equals("OVarbinary"))
        {
            return getOVarbinary();
        }
        if (name.equals("OLongvarbinary"))
        {
            return getOLongvarbinary();
        }
        if (name.equals("OBlob"))
        {
            return getOBlob();
        }
        if (name.equals("OClob"))
        {
            return getOClob();
        }
        if (name.equals("OBooleanint"))
        {
            return getOBooleanint();
        }
        if (name.equals("OBooleanchar"))
        {
            return getOBooleanchar();
        }
        if (name.equals("ODouble"))
        {
            return getODouble();
        }
        return null;
    }

    /**
     * Set a field in the object by field (Java) name.
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (name.equals("OBit"))
        {
            // Object fields can be null
            if (value != null && ! Boolean.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOBit((Boolean) value);
            return true;
        }
        if (name.equals("OTinyint"))
        {
            // Object fields can be null
            if (value != null && ! Byte.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOTinyint((Byte) value);
            return true;
        }
        if (name.equals("OSmallint"))
        {
            // Object fields can be null
            if (value != null && ! Short.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOSmallint((Short) value);
            return true;
        }
        if (name.equals("OBigint"))
        {
            // Object fields can be null
            if (value != null && ! Long.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOBigint((Long) value);
            return true;
        }
        if (name.equals("OFloat"))
        {
            // Object fields can be null
            if (value != null && ! Double.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOFloat((Double) value);
            return true;
        }
        if (name.equals("OReal"))
        {
            // Object fields can be null
            if (value != null && ! Float.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOReal((Float) value);
            return true;
        }
        if (name.equals("ONumeric"))
        {
            // Object fields can be null
            if (value != null && ! java.math.BigDecimal.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setONumeric((java.math.BigDecimal) value);
            return true;
        }
        if (name.equals("ODecimal"))
        {
            // Object fields can be null
            if (value != null && ! java.math.BigDecimal.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setODecimal((java.math.BigDecimal) value);
            return true;
        }
        if (name.equals("OChar"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOChar((String) value);
            return true;
        }
        if (name.equals("OVarchar"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOVarchar((String) value);
            return true;
        }
        if (name.equals("OLongvarchar"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOLongvarchar((String) value);
            return true;
        }
        if (name.equals("ODate"))
        {
            // Object fields can be null
            if (value != null && ! java.util.Date.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setODate((java.util.Date) value);
            return true;
        }
        if (name.equals("OTime"))
        {
            // Object fields can be null
            if (value != null && ! java.util.Date.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOTime((java.util.Date) value);
            return true;
        }
        if (name.equals("OInteger"))
        {
            // Object fields can be null
            if (value != null && ! Integer.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOInteger((Integer) value);
            return true;
        }
        if (name.equals("OTimestamp"))
        {
            // Object fields can be null
            if (value != null && ! java.util.Date.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOTimestamp((java.util.Date) value);
            return true;
        }
        if (name.equals("OBinary"))
        {
            // Object fields can be null
            if (value != null && ! byte[].class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOBinary((byte[]) value);
            return true;
        }
        if (name.equals("OVarbinary"))
        {
            // Object fields can be null
            if (value != null && ! byte[].class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOVarbinary((byte[]) value);
            return true;
        }
        if (name.equals("OLongvarbinary"))
        {
            // Object fields can be null
            if (value != null && ! byte[].class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOLongvarbinary((byte[]) value);
            return true;
        }
        if (name.equals("OBlob"))
        {
            // Object fields can be null
            if (value != null && ! byte[].class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOBlob((byte[]) value);
            return true;
        }
        if (name.equals("OClob"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOClob((String) value);
            return true;
        }
        if (name.equals("OBooleanint"))
        {
            // Object fields can be null
            if (value != null && ! Boolean.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOBooleanint((Boolean) value);
            return true;
        }
        if (name.equals("OBooleanchar"))
        {
            // Object fields can be null
            if (value != null && ! Boolean.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setOBooleanchar((Boolean) value);
            return true;
        }
        if (name.equals("ODouble"))
        {
            // Object fields can be null
            if (value != null && ! Double.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setODouble((Double) value);
            return true;
        }
        return false;
    }

    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_BIT))
        {
            return getOBit();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_TINYINT))
        {
            return getOTinyint();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_SMALLINT))
        {
            return getOSmallint();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_BIGINT))
        {
            return getOBigint();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_FLOAT))
        {
            return getOFloat();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_REAL))
        {
            return getOReal();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_NUMERIC))
        {
            return getONumeric();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_DECIMAL))
        {
            return getODecimal();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_CHAR))
        {
            return getOChar();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_VARCHAR))
        {
            return getOVarchar();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_LONGVARCHAR))
        {
            return getOLongvarchar();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_DATE))
        {
            return getODate();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_TIME))
        {
            return getOTime();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_INTEGER))
        {
            return getOInteger();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_TIMESTAMP))
        {
            return getOTimestamp();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_BINARY))
        {
            return getOBinary();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_VARBINARY))
        {
            return getOVarbinary();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_LONGVARBINARY))
        {
            return getOLongvarbinary();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_BLOB))
        {
            return getOBlob();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_CLOB))
        {
            return getOClob();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_BOOLEANINT))
        {
            return getOBooleanint();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_BOOLEANCHAR))
        {
            return getOBooleanchar();
        }
        if (name.equals(org.apache.torque.test.TypesObjectPeer.O_DOUBLE))
        {
            return getODouble();
        }
        return null;
    }

    /**
     * Set field values by Peer Field Name
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPeerName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (org.apache.torque.test.TypesObjectPeer.O_BIT.getSqlExpression().equals(name))
        {
            return setByName("OBit", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_TINYINT.getSqlExpression().equals(name))
        {
            return setByName("OTinyint", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_SMALLINT.getSqlExpression().equals(name))
        {
            return setByName("OSmallint", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_BIGINT.getSqlExpression().equals(name))
        {
            return setByName("OBigint", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_FLOAT.getSqlExpression().equals(name))
        {
            return setByName("OFloat", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_REAL.getSqlExpression().equals(name))
        {
            return setByName("OReal", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_NUMERIC.getSqlExpression().equals(name))
        {
            return setByName("ONumeric", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_DECIMAL.getSqlExpression().equals(name))
        {
            return setByName("ODecimal", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_CHAR.getSqlExpression().equals(name))
        {
            return setByName("OChar", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_VARCHAR.getSqlExpression().equals(name))
        {
            return setByName("OVarchar", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_LONGVARCHAR.getSqlExpression().equals(name))
        {
            return setByName("OLongvarchar", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_DATE.getSqlExpression().equals(name))
        {
            return setByName("ODate", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_TIME.getSqlExpression().equals(name))
        {
            return setByName("OTime", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_INTEGER.getSqlExpression().equals(name))
        {
            return setByName("OInteger", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_TIMESTAMP.getSqlExpression().equals(name))
        {
            return setByName("OTimestamp", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_BINARY.getSqlExpression().equals(name))
        {
            return setByName("OBinary", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_VARBINARY.getSqlExpression().equals(name))
        {
            return setByName("OVarbinary", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_LONGVARBINARY.getSqlExpression().equals(name))
        {
            return setByName("OLongvarbinary", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_BLOB.getSqlExpression().equals(name))
        {
            return setByName("OBlob", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_CLOB.getSqlExpression().equals(name))
        {
            return setByName("OClob", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_BOOLEANINT.getSqlExpression().equals(name))
        {
            return setByName("OBooleanint", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_BOOLEANCHAR.getSqlExpression().equals(name))
        {
            return setByName("OBooleanchar", value);
        }
        if (org.apache.torque.test.TypesObjectPeer.O_DOUBLE.getSqlExpression().equals(name))
        {
            return setByName("ODouble", value);
        }
        return false;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
        if (pos == 0)
        {
            return getOBit();
        }
        if (pos == 1)
        {
            return getOTinyint();
        }
        if (pos == 2)
        {
            return getOSmallint();
        }
        if (pos == 3)
        {
            return getOBigint();
        }
        if (pos == 4)
        {
            return getOFloat();
        }
        if (pos == 5)
        {
            return getOReal();
        }
        if (pos == 6)
        {
            return getONumeric();
        }
        if (pos == 7)
        {
            return getODecimal();
        }
        if (pos == 8)
        {
            return getOChar();
        }
        if (pos == 9)
        {
            return getOVarchar();
        }
        if (pos == 10)
        {
            return getOLongvarchar();
        }
        if (pos == 11)
        {
            return getODate();
        }
        if (pos == 12)
        {
            return getOTime();
        }
        if (pos == 13)
        {
            return getOInteger();
        }
        if (pos == 14)
        {
            return getOTimestamp();
        }
        if (pos == 15)
        {
            return getOBinary();
        }
        if (pos == 16)
        {
            return getOVarbinary();
        }
        if (pos == 17)
        {
            return getOLongvarbinary();
        }
        if (pos == 18)
        {
            return getOBlob();
        }
        if (pos == 19)
        {
            return getOClob();
        }
        if (pos == 20)
        {
            return getOBooleanint();
        }
        if (pos == 21)
        {
            return getOBooleanchar();
        }
        if (pos == 22)
        {
            return getODouble();
        }
        return null;
    }

    /**
     * Set field values by its position (zero based) in the XML schema.
     *
     * @param position The field position
     * @param value field value
     * @return True if value was set, false if not (invalid position / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPosition(int position, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (position == 0)
        {
            return setByName("OBit", value);
        }
        if (position == 1)
        {
            return setByName("OTinyint", value);
        }
        if (position == 2)
        {
            return setByName("OSmallint", value);
        }
        if (position == 3)
        {
            return setByName("OBigint", value);
        }
        if (position == 4)
        {
            return setByName("OFloat", value);
        }
        if (position == 5)
        {
            return setByName("OReal", value);
        }
        if (position == 6)
        {
            return setByName("ONumeric", value);
        }
        if (position == 7)
        {
            return setByName("ODecimal", value);
        }
        if (position == 8)
        {
            return setByName("OChar", value);
        }
        if (position == 9)
        {
            return setByName("OVarchar", value);
        }
        if (position == 10)
        {
            return setByName("OLongvarchar", value);
        }
        if (position == 11)
        {
            return setByName("ODate", value);
        }
        if (position == 12)
        {
            return setByName("OTime", value);
        }
        if (position == 13)
        {
            return setByName("OInteger", value);
        }
        if (position == 14)
        {
            return setByName("OTimestamp", value);
        }
        if (position == 15)
        {
            return setByName("OBinary", value);
        }
        if (position == 16)
        {
            return setByName("OVarbinary", value);
        }
        if (position == 17)
        {
            return setByName("OLongvarbinary", value);
        }
        if (position == 18)
        {
            return setByName("OBlob", value);
        }
        if (position == 19)
        {
            return setByName("OClob", value);
        }
        if (position == 20)
        {
            return setByName("OBooleanint", value);
        }
        if (position == 21)
        {
            return setByName("OBooleanchar", value);
        }
        if (position == 22)
        {
            return setByName("ODouble", value);
        }
        return false;
    }



    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save() throws TorqueException
    {
        save(TypesObjectPeer.DATABASE_NAME);
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     * @param dbName the name of the database to which the object
     *        should be saved.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(String dbName) 
            throws TorqueException
    {
        Connection con = null;
        try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally.
     *
     * @param toSave the object to be saved, not null.
     * @param con the connection to use for saving the object, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(Connection con) 
            throws TorqueException
    {
        if (isSaving())
        {
            return;
        }
        try
        {
            setSaving(true);
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    TypesObjectPeer.doInsert((TypesObject) this, con);
                    setNew(false);
                }
                else
                {
                    TypesObjectPeer.doUpdate((TypesObject) this, con);
                }
            }

        }
        finally
        {
            setSaving(false);
        }
    }




    
    /**
     * Set the PrimaryKey with an ObjectKey
     *
     * @param key the primary key to set.
     *
     * @throws NoSuchOperationException always.
     */
    public void setPrimaryKey(ObjectKey key) throws TorqueException
    {
        throw new UnsupportedOperationException(
                "This table has no primary key");
    }

    /**
     * Set the PrimaryKey using a String.
     *
     * @param key the primary key to set.
     *
     * @throws NoSuchOperationException always.
     */
    public void setPrimaryKey(String key) throws TorqueException
    {
        throw new UnsupportedOperationException(
                "This table has no primary key");
    }

    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        return null;
    }



    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public TypesObject copy() throws TorqueException
    {
        return copy(true);
    }

    /**
     * Makes a copy of this object using a connection.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     *
     * @param con the database connection to read associated objects.
     */
    public TypesObject copy(Connection con) throws TorqueException
    {
        return copy(true, con);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     */
    public TypesObject copy(boolean deepcopy) throws TorqueException
    {
        TypesObject typesObject = new TypesObject();

        return copyInto(typesObject, deepcopy);
    }

    /**
     * Makes a copy of this object using connection.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @param con the database connection to read associated objects.
     */
    public TypesObject copy(boolean deepcopy, Connection con) throws TorqueException
    {
        TypesObject typesObject = new TypesObject();

        return copyInto(typesObject, deepcopy, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     */
    protected TypesObject copyInto(TypesObject copyObj) throws TorqueException
    {
        return copyInto(copyObj, true);
    }

    /**
     * Fills the copyObj with the contents of this object using connection.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param con the database connection to read associated objects.
     */
    protected TypesObject copyInto(TypesObject copyObj, Connection con) throws TorqueException
    {
        return copyInto(copyObj, true, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     */
    protected TypesObject copyInto(TypesObject copyObj, boolean deepcopy) throws TorqueException
    {
        copyObj.setOBit(oBit);
        copyObj.setOTinyint(oTinyint);
        copyObj.setOSmallint(oSmallint);
        copyObj.setOBigint(oBigint);
        copyObj.setOFloat(oFloat);
        copyObj.setOReal(oReal);
        copyObj.setONumeric(oNumeric);
        copyObj.setODecimal(oDecimal);
        copyObj.setOChar(oChar);
        copyObj.setOVarchar(oVarchar);
        copyObj.setOLongvarchar(oLongvarchar);
        copyObj.setODate(oDate);
        copyObj.setOTime(oTime);
        copyObj.setOInteger(oInteger);
        copyObj.setOTimestamp(oTimestamp);
        copyObj.setOBinary(oBinary);
        copyObj.setOVarbinary(oVarbinary);
        copyObj.setOLongvarbinary(oLongvarbinary);
        copyObj.setOBlob(oBlob);
        copyObj.setOClob(oClob);
        copyObj.setOBooleanint(oBooleanint);
        copyObj.setOBooleanchar(oBooleanchar);
        copyObj.setODouble(oDouble);

        if (deepcopy)
        {
        }
        return copyObj;
    }
        
    
    /**
     * Fills the copyObj with the contents of this object using connection.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @param con the database connection to read associated objects.
     */
    protected TypesObject copyInto(TypesObject copyObj, boolean deepcopy, Connection con) throws TorqueException
    {
        copyObj.setOBit(oBit);
        copyObj.setOTinyint(oTinyint);
        copyObj.setOSmallint(oSmallint);
        copyObj.setOBigint(oBigint);
        copyObj.setOFloat(oFloat);
        copyObj.setOReal(oReal);
        copyObj.setONumeric(oNumeric);
        copyObj.setODecimal(oDecimal);
        copyObj.setOChar(oChar);
        copyObj.setOVarchar(oVarchar);
        copyObj.setOLongvarchar(oLongvarchar);
        copyObj.setODate(oDate);
        copyObj.setOTime(oTime);
        copyObj.setOInteger(oInteger);
        copyObj.setOTimestamp(oTimestamp);
        copyObj.setOBinary(oBinary);
        copyObj.setOVarbinary(oVarbinary);
        copyObj.setOLongvarbinary(oLongvarbinary);
        copyObj.setOBlob(oBlob);
        copyObj.setOClob(oClob);
        copyObj.setOBooleanint(oBooleanint);
        copyObj.setOBooleanchar(oBooleanchar);
        copyObj.setODouble(oDouble);

        if (deepcopy)
        {
        }
        return copyObj;
    }

    /** The Peer class */
    private static final org.apache.torque.test.TypesObjectPeer peer
            = new org.apache.torque.test.TypesObjectPeer();

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public org.apache.torque.test.TypesObjectPeer getPeer()
    {
        return peer;
    }

    /**
     * Retrieves the TableMap object related to this Table data without
     * compiler warnings of using getPeer().getTableMap().
     *
     * @return The associated TableMap object.
     */
    public TableMap getTableMap() throws TorqueException
    {
        return org.apache.torque.test.TypesObjectPeer.getTableMap();
    }



    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("TypesObject:\n");
        str.append("oBit = ")
           .append(getOBit())
           .append("\n");
        str.append("oTinyint = ")
           .append(getOTinyint())
           .append("\n");
        str.append("oSmallint = ")
           .append(getOSmallint())
           .append("\n");
        str.append("oBigint = ")
           .append(getOBigint())
           .append("\n");
        str.append("oFloat = ")
           .append(getOFloat())
           .append("\n");
        str.append("oReal = ")
           .append(getOReal())
           .append("\n");
        str.append("oNumeric = ")
           .append(getONumeric())
           .append("\n");
        str.append("oDecimal = ")
           .append(getODecimal())
           .append("\n");
        str.append("oChar = ")
           .append(getOChar())
           .append("\n");
        str.append("oVarchar = ")
           .append(getOVarchar())
           .append("\n");
        str.append("oLongvarchar = ")
           .append(getOLongvarchar())
           .append("\n");
        str.append("oDate = ")
           .append(getODate())
           .append("\n");
        str.append("oTime = ")
           .append(getOTime())
           .append("\n");
        str.append("oInteger = ")
           .append(getOInteger())
           .append("\n");
        str.append("oTimestamp = ")
           .append(getOTimestamp())
           .append("\n");
        str.append("oBinary = ")
           .append("<binary>")
           .append("\n");
        str.append("oVarbinary = ")
           .append("<binary>")
           .append("\n");
        str.append("oLongvarbinary = ")
           .append("<binary>")
           .append("\n");
        str.append("oBlob = ")
           .append("<binary>")
           .append("\n");
        str.append("oClob = ")
           .append(getOClob())
           .append("\n");
        str.append("oBooleanint = ")
           .append(getOBooleanint())
           .append("\n");
        str.append("oBooleanchar = ")
           .append(getOBooleanchar())
           .append("\n");
        str.append("oDouble = ")
           .append(getODouble())
           .append("\n");
        return(str.toString());
    }

    /**
     * Compares the primary key of this instance with the key of another.
     *
     * @param toCompare The object to compare to.
     * @return Whether the primary keys are equal and the object have the
     *         same class.
     */
    public boolean equals(Object toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!getClass().equals(toCompare.getClass()))
        {
            return false;
        }
        TypesObject other = (TypesObject) toCompare;
        if (getPrimaryKey() == null || other.getPrimaryKey() == null)
        {
            return false;
        }
        return getPrimaryKey().equals(other.getPrimaryKey());
    }

    /**
     * If the primary key is not <code>null</code>, return the hashcode of the
     * primary key.  Otherwise calls <code>Object.hashCode()</code>.
     *
     * @return an <code>int</code> value
     */
    public int hashCode()
    {
        ObjectKey ok = getPrimaryKey();
        if (ok == null)
        {
            return super.hashCode();
        }

        return ok.hashCode();
    }




}
