package org.apache.torque.test;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.torque.NoRowsException;
import org.apache.torque.TooManyRowsException;
import org.apache.torque.Column;
import org.apache.torque.Torque;
import org.apache.torque.TorqueException;
import org.apache.torque.TorqueRuntimeException;
import org.apache.torque.adapter.IDMethod;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.map.DatabaseMap;
import org.apache.torque.map.TableMap;
import org.apache.torque.map.ColumnMap;
import org.apache.torque.map.ForeignKeyMap;
import org.apache.torque.map.InheritanceMap;
import org.apache.torque.om.mapper.RecordMapper;
import org.apache.torque.om.mapper.CompositeMapper;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.util.BasePeer;
import org.apache.torque.util.Transaction;
import org.apache.torque.util.ColumnValues;
import org.apache.torque.util.JdbcTypedValue;



/**
 * used to test the handling for all supported types
 *
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:44 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to TypesObjectPeer
 */
@SuppressWarnings({"unused", "unchecked"})
public abstract class BaseTypesObjectPeer
{
    /** The class log. */
    private static Log log = LogFactory.getLog(BaseTypesObjectPeerImpl.class);
    /** Serial version */
    private static final long serialVersionUID = 1347503744706L;


    /** The default database name for this class. */
    public static final String DATABASE_NAME;

     /** The table name for this class. */
    public static final String TABLE_NAME;

     /** The table map for this class. */
    public static final TableMap TABLE;
    /** The column for the o_bit field */
    public static final ColumnMap O_BIT;
    /** The column for the o_tinyint field */
    public static final ColumnMap O_TINYINT;
    /** The column for the o_smallint field */
    public static final ColumnMap O_SMALLINT;
    /** The column for the o_bigint field */
    public static final ColumnMap O_BIGINT;
    /** The column for the o_float field */
    public static final ColumnMap O_FLOAT;
    /** The column for the o_real field */
    public static final ColumnMap O_REAL;
    /** The column for the o_numeric field */
    public static final ColumnMap O_NUMERIC;
    /** The column for the o_decimal field */
    public static final ColumnMap O_DECIMAL;
    /** The column for the o_char field */
    public static final ColumnMap O_CHAR;
    /** The column for the o_varchar field */
    public static final ColumnMap O_VARCHAR;
    /** The column for the o_longvarchar field */
    public static final ColumnMap O_LONGVARCHAR;
    /** The column for the o_date field */
    public static final ColumnMap O_DATE;
    /** The column for the o_time field */
    public static final ColumnMap O_TIME;
    /** The column for the o_integer field */
    public static final ColumnMap O_INTEGER;
    /** The column for the o_timestamp field */
    public static final ColumnMap O_TIMESTAMP;
    /** The column for the o_binary field */
    public static final ColumnMap O_BINARY;
    /** The column for the o_varbinary field */
    public static final ColumnMap O_VARBINARY;
    /** The column for the o_longvarbinary field */
    public static final ColumnMap O_LONGVARBINARY;
    /** The column for the o_blob field */
    public static final ColumnMap O_BLOB;
    /** The column for the o_clob field */
    public static final ColumnMap O_CLOB;
    /** The column for the o_booleanint field */
    public static final ColumnMap O_BOOLEANINT;
    /** The column for the o_booleanchar field */
    public static final ColumnMap O_BOOLEANCHAR;
    /** The column for the o_double field */
    public static final ColumnMap O_DOUBLE;

    /** number of columns for this peer */
    public static final int numColumns = 23;


    /** The implementation of the peer. */
    private static TypesObjectPeerImpl typesObjectPeerImpl;


    static
    {
        DatabaseMap dbMap = Torque.getOrCreateDatabase("bookstore")
                .getDatabaseMap();
        if (dbMap.getTable("types_object") == null)
        {
            dbMap.addTable("types_object");
        }
        DATABASE_NAME = "bookstore";
        TABLE_NAME = "types_object";

        TABLE = dbMap.getTable("types_object");
        TABLE.setJavaName("TypesObject");
        TABLE.setOMClass(org.apache.torque.test.TypesObject.class);
        TABLE.setPeerClass(org.apache.torque.test.TypesObjectPeer.class);
        TABLE.setDescription("used to test the handling for all supported types");
        TABLE.setPrimaryKeyMethod(IDMethod.NATIVE);
        TABLE.setPrimaryKeyMethodInfo(IDMethod.ID_BROKER, TABLE.getName());
        TABLE.setPrimaryKeyMethodInfo(IDMethod.SEQUENCE, "types_object_SEQ");
        TABLE.setPrimaryKeyMethodInfo(IDMethod.AUTO_INCREMENT, "types_object");
        TABLE.setUseInheritance(true);


    // ------------- Column: o_bit --------------------
        O_BIT = new ColumnMap("o_bit", TABLE);
        O_BIT.setType(new Boolean(true));
        O_BIT.setTorqueType("BIT");
        O_BIT.setUsePrimitive(false);
        O_BIT.setPrimaryKey(false);
        O_BIT.setNotNull(false);
        O_BIT.setJavaName("OBit");
        O_BIT.setAutoIncrement(true);
        O_BIT.setProtected(false);
        O_BIT.setJavaType( "Boolean" );
        O_BIT.setPosition(1);
        TABLE.addColumn(O_BIT);
    // ------------- Column: o_tinyint --------------------
        O_TINYINT = new ColumnMap("o_tinyint", TABLE);
        O_TINYINT.setType(Byte.valueOf((byte) 0));
        O_TINYINT.setTorqueType("TINYINT");
        O_TINYINT.setUsePrimitive(false);
        O_TINYINT.setPrimaryKey(false);
        O_TINYINT.setNotNull(false);
        O_TINYINT.setJavaName("OTinyint");
        O_TINYINT.setAutoIncrement(true);
        O_TINYINT.setProtected(false);
        O_TINYINT.setJavaType( "Byte" );
        O_TINYINT.setPosition(2);
        TABLE.addColumn(O_TINYINT);
    // ------------- Column: o_smallint --------------------
        O_SMALLINT = new ColumnMap("o_smallint", TABLE);
        O_SMALLINT.setType(Short.valueOf((short) 0));
        O_SMALLINT.setTorqueType("SMALLINT");
        O_SMALLINT.setUsePrimitive(false);
        O_SMALLINT.setPrimaryKey(false);
        O_SMALLINT.setNotNull(false);
        O_SMALLINT.setJavaName("OSmallint");
        O_SMALLINT.setAutoIncrement(true);
        O_SMALLINT.setProtected(false);
        O_SMALLINT.setJavaType( "Short" );
        O_SMALLINT.setPosition(3);
        TABLE.addColumn(O_SMALLINT);
    // ------------- Column: o_bigint --------------------
        O_BIGINT = new ColumnMap("o_bigint", TABLE);
        O_BIGINT.setType(Long.valueOf(0));
        O_BIGINT.setTorqueType("BIGINT");
        O_BIGINT.setUsePrimitive(false);
        O_BIGINT.setPrimaryKey(false);
        O_BIGINT.setNotNull(false);
        O_BIGINT.setJavaName("OBigint");
        O_BIGINT.setAutoIncrement(true);
        O_BIGINT.setProtected(false);
        O_BIGINT.setJavaType( "Long" );
        O_BIGINT.setPosition(4);
        TABLE.addColumn(O_BIGINT);
    // ------------- Column: o_float --------------------
        O_FLOAT = new ColumnMap("o_float", TABLE);
        O_FLOAT.setType(new Double(0));
        O_FLOAT.setTorqueType("FLOAT");
        O_FLOAT.setUsePrimitive(false);
        O_FLOAT.setPrimaryKey(false);
        O_FLOAT.setNotNull(false);
        O_FLOAT.setJavaName("OFloat");
        O_FLOAT.setAutoIncrement(true);
        O_FLOAT.setProtected(false);
        O_FLOAT.setJavaType( "Double" );
        O_FLOAT.setPosition(5);
        TABLE.addColumn(O_FLOAT);
    // ------------- Column: o_real --------------------
        O_REAL = new ColumnMap("o_real", TABLE);
        O_REAL.setType(new Float(0));
        O_REAL.setTorqueType("REAL");
        O_REAL.setUsePrimitive(false);
        O_REAL.setPrimaryKey(false);
        O_REAL.setNotNull(false);
        O_REAL.setJavaName("OReal");
        O_REAL.setAutoIncrement(true);
        O_REAL.setProtected(false);
        O_REAL.setJavaType( "Float" );
        O_REAL.setPosition(6);
        TABLE.addColumn(O_REAL);
    // ------------- Column: o_numeric --------------------
        O_NUMERIC = new ColumnMap("o_numeric", TABLE);
        O_NUMERIC.setType(new java.math.BigDecimal((double) 0));
        O_NUMERIC.setTorqueType("NUMERIC");
        O_NUMERIC.setUsePrimitive(false);
        O_NUMERIC.setPrimaryKey(false);
        O_NUMERIC.setNotNull(false);
        O_NUMERIC.setJavaName("ONumeric");
        O_NUMERIC.setAutoIncrement(true);
        O_NUMERIC.setProtected(false);
        O_NUMERIC.setJavaType( "java.math.BigDecimal" );
        O_NUMERIC.setPosition(7);
        TABLE.addColumn(O_NUMERIC);
    // ------------- Column: o_decimal --------------------
        O_DECIMAL = new ColumnMap("o_decimal", TABLE);
        O_DECIMAL.setType(new java.math.BigDecimal((double) 0));
        O_DECIMAL.setTorqueType("DECIMAL");
        O_DECIMAL.setUsePrimitive(false);
        O_DECIMAL.setPrimaryKey(false);
        O_DECIMAL.setNotNull(false);
        O_DECIMAL.setJavaName("ODecimal");
        O_DECIMAL.setAutoIncrement(true);
        O_DECIMAL.setProtected(false);
        O_DECIMAL.setJavaType( "java.math.BigDecimal" );
        O_DECIMAL.setPosition(8);
        TABLE.addColumn(O_DECIMAL);
    // ------------- Column: o_char --------------------
        O_CHAR = new ColumnMap("o_char", TABLE);
        O_CHAR.setType("");
        O_CHAR.setTorqueType("CHAR");
        O_CHAR.setUsePrimitive(false);
        O_CHAR.setPrimaryKey(false);
        O_CHAR.setNotNull(false);
        O_CHAR.setJavaName("OChar");
        O_CHAR.setAutoIncrement(true);
        O_CHAR.setProtected(false);
        O_CHAR.setJavaType( "String" );
        O_CHAR.setPosition(9);
        TABLE.addColumn(O_CHAR);
    // ------------- Column: o_varchar --------------------
        O_VARCHAR = new ColumnMap("o_varchar", TABLE);
        O_VARCHAR.setType("");
        O_VARCHAR.setTorqueType("VARCHAR");
        O_VARCHAR.setUsePrimitive(false);
        O_VARCHAR.setPrimaryKey(false);
        O_VARCHAR.setNotNull(false);
        O_VARCHAR.setJavaName("OVarchar");
        O_VARCHAR.setAutoIncrement(true);
        O_VARCHAR.setProtected(false);
        O_VARCHAR.setJavaType( "String" );
        O_VARCHAR.setSize(255);
        O_VARCHAR.setPosition(10);
        TABLE.addColumn(O_VARCHAR);
    // ------------- Column: o_longvarchar --------------------
        O_LONGVARCHAR = new ColumnMap("o_longvarchar", TABLE);
        O_LONGVARCHAR.setType("");
        O_LONGVARCHAR.setTorqueType("LONGVARCHAR");
        O_LONGVARCHAR.setUsePrimitive(false);
        O_LONGVARCHAR.setPrimaryKey(false);
        O_LONGVARCHAR.setNotNull(false);
        O_LONGVARCHAR.setJavaName("OLongvarchar");
        O_LONGVARCHAR.setAutoIncrement(true);
        O_LONGVARCHAR.setProtected(false);
        O_LONGVARCHAR.setJavaType( "String" );
        O_LONGVARCHAR.setPosition(11);
        TABLE.addColumn(O_LONGVARCHAR);
    // ------------- Column: o_date --------------------
        O_DATE = new ColumnMap("o_date", TABLE);
        O_DATE.setType(new Date());
        O_DATE.setTorqueType("DATE");
        O_DATE.setUsePrimitive(false);
        O_DATE.setPrimaryKey(false);
        O_DATE.setNotNull(false);
        O_DATE.setJavaName("ODate");
        O_DATE.setAutoIncrement(true);
        O_DATE.setProtected(false);
        O_DATE.setJavaType( "java.util.Date" );
        O_DATE.setPosition(12);
        TABLE.addColumn(O_DATE);
    // ------------- Column: o_time --------------------
        O_TIME = new ColumnMap("o_time", TABLE);
        O_TIME.setType(new Date());
        O_TIME.setTorqueType("TIME");
        O_TIME.setUsePrimitive(false);
        O_TIME.setPrimaryKey(false);
        O_TIME.setNotNull(false);
        O_TIME.setJavaName("OTime");
        O_TIME.setAutoIncrement(true);
        O_TIME.setProtected(false);
        O_TIME.setJavaType( "java.util.Date" );
        O_TIME.setPosition(13);
        TABLE.addColumn(O_TIME);
    // ------------- Column: o_integer --------------------
        O_INTEGER = new ColumnMap("o_integer", TABLE);
        O_INTEGER.setType(Integer.valueOf(0));
        O_INTEGER.setTorqueType("INTEGER");
        O_INTEGER.setUsePrimitive(false);
        O_INTEGER.setPrimaryKey(false);
        O_INTEGER.setNotNull(false);
        O_INTEGER.setJavaName("OInteger");
        O_INTEGER.setAutoIncrement(true);
        O_INTEGER.setProtected(false);
        O_INTEGER.setJavaType( "Integer" );
        O_INTEGER.setPosition(14);
        TABLE.addColumn(O_INTEGER);
    // ------------- Column: o_timestamp --------------------
        O_TIMESTAMP = new ColumnMap("o_timestamp", TABLE);
        O_TIMESTAMP.setType(new Date());
        O_TIMESTAMP.setTorqueType("TIMESTAMP");
        O_TIMESTAMP.setUsePrimitive(false);
        O_TIMESTAMP.setPrimaryKey(false);
        O_TIMESTAMP.setNotNull(false);
        O_TIMESTAMP.setJavaName("OTimestamp");
        O_TIMESTAMP.setAutoIncrement(true);
        O_TIMESTAMP.setProtected(false);
        O_TIMESTAMP.setJavaType( "java.util.Date" );
        O_TIMESTAMP.setPosition(15);
        TABLE.addColumn(O_TIMESTAMP);
    // ------------- Column: o_binary --------------------
        O_BINARY = new ColumnMap("o_binary", TABLE);
        O_BINARY.setType(new Object());
        O_BINARY.setTorqueType("BINARY");
        O_BINARY.setUsePrimitive(false);
        O_BINARY.setPrimaryKey(false);
        O_BINARY.setNotNull(false);
        O_BINARY.setJavaName("OBinary");
        O_BINARY.setAutoIncrement(true);
        O_BINARY.setProtected(false);
        O_BINARY.setJavaType( "byte[]" );
        O_BINARY.setPosition(16);
        TABLE.addColumn(O_BINARY);
    // ------------- Column: o_varbinary --------------------
        O_VARBINARY = new ColumnMap("o_varbinary", TABLE);
        O_VARBINARY.setType(new Object());
        O_VARBINARY.setTorqueType("VARBINARY");
        O_VARBINARY.setUsePrimitive(false);
        O_VARBINARY.setPrimaryKey(false);
        O_VARBINARY.setNotNull(false);
        O_VARBINARY.setJavaName("OVarbinary");
        O_VARBINARY.setAutoIncrement(true);
        O_VARBINARY.setProtected(false);
        O_VARBINARY.setJavaType( "byte[]" );
        O_VARBINARY.setPosition(17);
        TABLE.addColumn(O_VARBINARY);
    // ------------- Column: o_longvarbinary --------------------
        O_LONGVARBINARY = new ColumnMap("o_longvarbinary", TABLE);
        O_LONGVARBINARY.setType(new Object());
        O_LONGVARBINARY.setTorqueType("LONGVARBINARY");
        O_LONGVARBINARY.setUsePrimitive(false);
        O_LONGVARBINARY.setPrimaryKey(false);
        O_LONGVARBINARY.setNotNull(false);
        O_LONGVARBINARY.setJavaName("OLongvarbinary");
        O_LONGVARBINARY.setAutoIncrement(true);
        O_LONGVARBINARY.setProtected(false);
        O_LONGVARBINARY.setJavaType( "byte[]" );
        O_LONGVARBINARY.setPosition(18);
        TABLE.addColumn(O_LONGVARBINARY);
    // ------------- Column: o_blob --------------------
        O_BLOB = new ColumnMap("o_blob", TABLE);
        O_BLOB.setType(new Object());
        O_BLOB.setTorqueType("BLOB");
        O_BLOB.setUsePrimitive(false);
        O_BLOB.setPrimaryKey(false);
        O_BLOB.setNotNull(false);
        O_BLOB.setJavaName("OBlob");
        O_BLOB.setAutoIncrement(true);
        O_BLOB.setProtected(false);
        O_BLOB.setJavaType( "byte[]" );
        O_BLOB.setPosition(19);
        TABLE.addColumn(O_BLOB);
    // ------------- Column: o_clob --------------------
        O_CLOB = new ColumnMap("o_clob", TABLE);
        O_CLOB.setType("");
        O_CLOB.setTorqueType("CLOB");
        O_CLOB.setUsePrimitive(false);
        O_CLOB.setPrimaryKey(false);
        O_CLOB.setNotNull(false);
        O_CLOB.setJavaName("OClob");
        O_CLOB.setAutoIncrement(true);
        O_CLOB.setProtected(false);
        O_CLOB.setJavaType( "String" );
        O_CLOB.setPosition(20);
        TABLE.addColumn(O_CLOB);
    // ------------- Column: o_booleanint --------------------
        O_BOOLEANINT = new ColumnMap("o_booleanint", TABLE);
        O_BOOLEANINT.setType(new Integer(0));
        O_BOOLEANINT.setTorqueType("BOOLEANINT");
        O_BOOLEANINT.setUsePrimitive(false);
        O_BOOLEANINT.setPrimaryKey(false);
        O_BOOLEANINT.setNotNull(false);
        O_BOOLEANINT.setJavaName("OBooleanint");
        O_BOOLEANINT.setAutoIncrement(true);
        O_BOOLEANINT.setProtected(false);
        O_BOOLEANINT.setJavaType( "Boolean" );
        O_BOOLEANINT.setPosition(21);
        TABLE.addColumn(O_BOOLEANINT);
    // ------------- Column: o_booleanchar --------------------
        O_BOOLEANCHAR = new ColumnMap("o_booleanchar", TABLE);
        O_BOOLEANCHAR.setType("");
        O_BOOLEANCHAR.setTorqueType("BOOLEANCHAR");
        O_BOOLEANCHAR.setUsePrimitive(false);
        O_BOOLEANCHAR.setPrimaryKey(false);
        O_BOOLEANCHAR.setNotNull(false);
        O_BOOLEANCHAR.setJavaName("OBooleanchar");
        O_BOOLEANCHAR.setAutoIncrement(true);
        O_BOOLEANCHAR.setProtected(false);
        O_BOOLEANCHAR.setJavaType( "Boolean" );
        O_BOOLEANCHAR.setPosition(22);
        TABLE.addColumn(O_BOOLEANCHAR);
    // ------------- Column: o_double --------------------
        O_DOUBLE = new ColumnMap("o_double", TABLE);
        O_DOUBLE.setType(new Double(0));
        O_DOUBLE.setTorqueType("DOUBLE");
        O_DOUBLE.setUsePrimitive(false);
        O_DOUBLE.setPrimaryKey(false);
        O_DOUBLE.setNotNull(false);
        O_DOUBLE.setJavaName("ODouble");
        O_DOUBLE.setAutoIncrement(true);
        O_DOUBLE.setProtected(false);
        O_DOUBLE.setJavaType( "Double" );
        O_DOUBLE.setPosition(23);
        TABLE.addColumn(O_DOUBLE);



        initDatabaseMap();
    }

    /**
     * Creates a new instance of the  implementation of the peer.
     *
     * @return the new instance.
     */
    protected static TypesObjectPeerImpl createTypesObjectPeerImpl()
    {
        TypesObjectPeerImpl instance = new TypesObjectPeerImpl();
        return instance;
    }


    /**
     * Returns an instance of the implementation of the peer.
     * If no instance is currently cached, a new instance is created and cached.
     *
     * @return an instance of the implementation of the peer, not null.
     */
    public static TypesObjectPeerImpl getTypesObjectPeerImpl()
    {
        TypesObjectPeerImpl peerImplInstance = typesObjectPeerImpl;
        if (peerImplInstance == null)
        {
            peerImplInstance = TypesObjectPeer.createTypesObjectPeerImpl();
            typesObjectPeerImpl = peerImplInstance;
        }
        return peerImplInstance;
    }



    /**
     * Sets the instance of the implementation of the peer.
     *
     * @param an instance of the implementation of the peer, or null
     *        if a new instance should be created automatically.
     */
    public static void setTypesObjectPeerImpl(TypesObjectPeerImpl peerImplInstance)
    {
        typesObjectPeerImpl = peerImplInstance;
    }


    /**
     * Get the list of objects for a ResultSet.  Please not that your
     * resultset MUST return columns in the right order.  You can use
     * getFieldNames() in BaseObject to get the correct sequence.
     *
     * @param resultSet the ResultSet
     * @return the list of objects
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<TypesObject> resultSet2Objects(ResultSet resultSet)
            throws TorqueException
    {
        return getTypesObjectPeerImpl().resultSet2Objects(resultSet);
    }

    /**
     * Add all the columns needed to create a new object.
     *
     * @param criteria object containing the columns to add.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void addSelectColumns(Criteria criteria)
            throws TorqueException
    {
        getTypesObjectPeerImpl().addSelectColumns(criteria);
    }

    /**
     * changes the boolean values in the criteria to the appropriate type,
     * whenever a booleanchar or booleanint column is involved.
     * This enables the user to create criteria using Boolean values
     * for booleanchar or booleanint columns.
     *
     * @param criteria the criteria in which the boolean values
     *        should be corrected.
     *
     * @throws TorqueException if the database map for the criteria cannot be 
               obtained.
     */
    public static void correctBooleans(Criteria criteria) throws TorqueException
    {
        getTypesObjectPeerImpl().correctBooleans(criteria);
    }

    /**
     * Checks all columns in the criteria to see whether
     * booleanchar and booleanint columns are queried with a boolean.
     * If yes, the query values are mapped onto values the database
     * does understand, i.e. 0 and 1 for booleanints and N and Y for
     * booleanchar columns.
     *
     * @param columnValues The value to be checked for booleanint
     *        and booleanchar columns.
     * @throws TorqueException if the database map for the criteria cannot be
     *         retrieved.
     */
    public static void correctBooleans(
            ColumnValues columnValues)
        throws TorqueException
    {
        getTypesObjectPeerImpl().correctBooleans(columnValues);
    }
    
    /**
     * Selects TypesObject objects from a database.
     *
     * @param criteria object used to create the SELECT statement.
     *
     * @return the list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<TypesObject> doSelect(Criteria criteria)
            throws TorqueException
    {
        return getTypesObjectPeerImpl().doSelect(criteria);
    }

    /**
     * Selects TypesObject objects from a database
     * within a transaction.
     *
     * @param criteria object used to create the SELECT statement.
     * @param connection the connection holding the transaction, not null.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<TypesObject> doSelect(
                Criteria criteria,
                Connection connection)
            throws TorqueException
    {
        return getTypesObjectPeerImpl().doSelect(criteria, connection);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                Criteria criteria,
                RecordMapper<T> mapper)
            throws TorqueException
    {
        return getTypesObjectPeerImpl().doSelect(criteria, mapper);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection for selecting records,
     *        not null.
     *
     * @return The results of the query, not null.
     * @throws TorqueException Error performing database query.
     */
    public static <T> List<T> doSelect(
            Criteria criteria,
            RecordMapper<T> mapper,
            Connection connection)
        throws TorqueException
    {
        return getTypesObjectPeerImpl().doSelect(
                criteria,
                mapper,
                connection);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param query the sql query to execute, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param dbName The name of the database to create the connection for,
     *        or null for the default SDB.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                String query,
                RecordMapper<T> mapper,
                String dbName)
            throws TorqueException
    {
        return getTypesObjectPeerImpl().doSelect(
                query,
                mapper,
                dbName);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param query the SQL Query to execute, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection, not null.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                String query,
                RecordMapper<T> mapper,
                Connection connection)
            throws TorqueException
    {
        return getTypesObjectPeerImpl().doSelect(
                query,
                mapper,
                connection);
    }

    /**
     * Selects TypesObject objects from the database which have
     * the same content as the passed object.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<TypesObject> doSelect(TypesObject obj)
            throws TorqueException
    {
        return getTypesObjectPeerImpl().doSelect(obj);
    }

    /**
     * Selects at most one TypesObject object from a database.
     *
     * @param criteria object used to create the SELECT statement.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static TypesObject doSelectSingleRecord(
                Criteria criteria)
            throws TorqueException
    {
        return getTypesObjectPeerImpl().doSelectSingleRecord(criteria);
    }

    /**
     * Selects at most one TypesObject object from a database
     * within a transaction.
     *
     * @param criteria object used to create the SELECT statement.
     * @param connection the connection holding the transaction, not null.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static TypesObject doSelectSingleRecord(
                Criteria criteria,
                Connection connection)
            throws TorqueException
    {
        return getTypesObjectPeerImpl().doSelectSingleRecord(criteria, connection);
    }

    /**
     * Selects at most a single row from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     *
     * @return The selected row, or null if no records was selected.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> T doSelectSingleRecord(
                org.apache.torque.criteria.Criteria criteria,
                RecordMapper<T> mapper)
            throws TorqueException
    {
        return getTypesObjectPeerImpl().doSelectSingleRecord(
                criteria,
                mapper);
    }

    /**
     * Selects at most a single row from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection, not null.
     *
     * @return The selected row, or null if no records was selected.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> T doSelectSingleRecord(
                org.apache.torque.criteria.Criteria criteria,
                RecordMapper<T> mapper,
                Connection connection)
            throws TorqueException
    {
        return getTypesObjectPeerImpl().doSelectSingleRecord(
                criteria,
                mapper,
                connection);
    }

    /**
     * Selects at most one TypesObject object from the database
     * which has the same content as the passed object.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static TypesObject doSelectSingleRecord(
                TypesObject obj)
            throws TorqueException
    {
        return getTypesObjectPeerImpl().doSelectSingleRecord(obj);
    }


    /**
     * Returns a new instance of the Data object class
     */
    public static TypesObject getDbObjectInstance()
    {
        return getTypesObjectPeerImpl().getDbObjectInstance();
    }


    /**
     * Method to do inserts.
     *
     * @param columnValues the values to insert.
     *
     * @return always null (because the table does not have a primary key).
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static ObjectKey doInsert(ColumnValues columnValues) 
            throws TorqueException
    {
        return getTypesObjectPeerImpl().doInsert(columnValues);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(Criteria) method.
     *
     * @param columnValues the values to insert.
     * @param con the connection to use, not null.
     *
     * @return always null (because the table does not have a primary key).
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static ObjectKey doInsert(ColumnValues columnValues, Connection con)
            throws TorqueException
    {
        return getTypesObjectPeerImpl().doInsert(columnValues, con);
    }
    /**
     * Method to do inserts
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void doInsert(TypesObject obj)
            throws TorqueException
    {
        getTypesObjectPeerImpl().doInsert(obj);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(TypesObject) method.  It will take
     * care of the connection details internally.
     *
     * @param obj the data object to insert into the database.
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void doInsert(TypesObject obj, Connection con)
            throws TorqueException
    {
        getTypesObjectPeerImpl().doInsert(obj, con);
    }

    /**
     * Method to do updates.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(ColumnValues columnValues) throws TorqueException
    {
        return getTypesObjectPeerImpl().doUpdate(columnValues);
    }

    /**
     * Method to do updates.  This method is to be used during a transaction,
     * otherwise use the doUpdate(Criteria) method.  It will take care of
     * the connection details internally.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @param con the connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        return getTypesObjectPeerImpl().doUpdate(columnValues, con);
    }

    /**
     * Executes an update against the database. The rows to be updated
     * are selected using <code>criteria</code> and updated using the values
     * in <code>updateValues</code>.
     *
     * @param criteria selects which rows of which table should be updated.
     * @param updateValues Which columns to update with which values, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException if updating fails.
     */
    public static int doUpdate(
                Criteria selectCriteria,
                ColumnValues updateValues)
            throws TorqueException
    {
        return getTypesObjectPeerImpl().doUpdate(
            selectCriteria,
            updateValues);
    }

    /**
     * Executes an update against the database. The rows to be updated
     * are selected using <code>criteria</code> and updated using the values
     * in <code>updateValues</code>.
     *
     * @param criteria selects which rows of which table should be updated.
     * @param updateValues Which columns to update with which values, not null.
     * @param connection the database connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException if updating fails.
     */
    public static int doUpdate(
                Criteria criteria,
                ColumnValues updateValues,
                Connection connection)
            throws TorqueException
    {
        return getTypesObjectPeerImpl().doUpdate(
            criteria,
             updateValues,
              connection);
    }

    /**
     * Updates an TypesObject in the database.
     * The primary key is used to identify the object to update.
     *
     * @param obj the data object to update in the database.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(TypesObject obj) throws TorqueException
    {
        return getTypesObjectPeerImpl().doUpdate(obj);
    }

    /**
     * Updates a TypesObject in the database.
     * The primary key is used to identify the object to update.
     * This method is to be used during a transaction,
     * otherwise the doUpdate(TypesObject) method can be used.
     *
     * @param obj the data object to update in the database.
     * @param con the connection to use, not null.
     
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(TypesObject obj, Connection con)
        throws TorqueException
    {
        return getTypesObjectPeerImpl().doUpdate(obj, con);
    }

    /**
     * Utility method which executes a given SQL statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the SQL statement to execute.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString)
            throws TorqueException
    {
        return getTypesObjectPeerImpl().executeStatement(statementString);
    }

    /**
     * Utility method which executes a given sql statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the sql statement to execute.
     * @param dbName Name of database to connect to.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString, String dbName)
            throws TorqueException
    {
        return getTypesObjectPeerImpl().executeStatement(statementString, dbName);
    }

    /**
     * Utility method which executes a given sql statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the sql statement to execute.
     * @param con A Connection.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString, Connection con)
            throws TorqueException
    {
        return getTypesObjectPeerImpl().executeStatement(statementString, con);
    }

    /**
     * Deletes rows from a database table.
     *
     * @param criteria defines the rows to be deleted, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
     public static int doDelete(Criteria criteria) throws TorqueException
     {
        return getTypesObjectPeerImpl().doDelete(criteria);
     }

    /**
     * Deletes rows from a table.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
    *
     * @param criteria defines the rows to be deleted, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
     public static int doDelete(Criteria criteria, Connection con)
        throws TorqueException
     {
        return getTypesObjectPeerImpl().doDelete(criteria, con);
     }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     *
     * @param obj the data object to delete in the database, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(TypesObject obj) throws TorqueException
    {
        return getTypesObjectPeerImpl().doDelete(obj);
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param obj the data object to delete in the database, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(TypesObject obj, Connection con)
        throws TorqueException
    {
        return getTypesObjectPeerImpl().doDelete(obj, con);
    }


    /** 
     * Build a Criteria object from the data object for this peer.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public static Criteria buildCriteria(TypesObject obj)
    {
        return getTypesObjectPeerImpl().buildCriteria(obj);
    }

    /** 
     * Build a Criteria object from the data object for this peer,
     * skipping all binary columns.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public static Criteria buildSelectCriteria(TypesObject obj)
    {
        return getTypesObjectPeerImpl().buildSelectCriteria(obj);
    }

    /** 
     * Returns the contents of the object as ColumnValues object
     *
     * @throws TorqueException if the table map cannot be retrieved
     *         (should not happen).
     */
    public static ColumnValues buildColumnValues(TypesObject typesObject)
            throws TorqueException
    {
        
        return getTypesObjectPeerImpl().buildColumnValues(typesObject);
    }







    /** 
     * Returns the chunk size for the filler methods.
     *
     * @return the chunk size for the filler methods.
     */
    protected static int getFillerChunkSize()
    {
        return getTypesObjectPeerImpl().getFillerChunkSize();
    }

    /**
     * Returns the TableMap related to this peer.
     *
     * @return the table map, not null.
     *
     * @throws TorqueException if the Peer instance does not hold a Table map.
     */
    public static TableMap getTableMap()
        throws TorqueException
    {
        return getTypesObjectPeerImpl().getTableMap();
    }

    public static void initDatabaseMap()
    {
        BaseBookstoreDatabaseMapInit.init();
    }


}
