package org.apache.torque.test;

import java.io.Serializable;
import java.sql.Connection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.apache.torque.TorqueException;
import org.apache.torque.map.TableMap;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.BooleanKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.om.ColumnAccessByName;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.util.Transaction;
import org.apache.commons.lang.ObjectUtils;


/**
 * used to test the handling for all supported types
 *
 * This class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:41 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to TypesPrimitive
 */
public abstract class BaseTypesPrimitive 
    implements Persistent, Serializable, ColumnAccessByName
{
    /** Serial version */
    private static final long serialVersionUID = 1347503741107L;



    /** Defines the pBit field. */
    private boolean pBit = false;

    /** Defines the pTinyint field. */
    private byte pTinyint = (byte) 0;

    /** Defines the pSmallint field. */
    private short pSmallint = (short) 0;

    /** Defines the pBigint field. */
    private long pBigint = 0L;

    /** Defines the pFloat field. */
    private double pFloat = 0;

    /** Defines the pReal field. */
    private float pReal = 0;

    /** Defines the pNumeric field. */
    private java.math.BigDecimal pNumeric = null;

    /** Defines the pDecimal field. */
    private java.math.BigDecimal pDecimal = null;

    /** Defines the pChar field. */
    private String pChar = null;

    /** Defines the pVarchar field. */
    private String pVarchar = null;

    /** Defines the pLongvarchar field. */
    private String pLongvarchar = null;

    /** Defines the pDate field. */
    private java.util.Date pDate = null;

    /** Defines the pTime field. */
    private java.util.Date pTime = null;

    /** Defines the pInteger field. */
    private int pInteger = 0;

    /** Defines the pTimestamp field. */
    private java.util.Date pTimestamp = null;

    /** Defines the pBinary field. */
    private byte[] pBinary = null;

    /** Defines the pVarbinary field. */
    private byte[] pVarbinary = null;

    /** Defines the pLongvarbinary field. */
    private byte[] pLongvarbinary = null;

    /** Defines the pBlob field. */
    private byte[] pBlob = null;

    /** Defines the pClob field. */
    private String pClob = null;

    /** Defines the pBooleanint field. */
    private boolean pBooleanint = false;

    /** Defines the pBooleanchar field. */
    private boolean pBooleanchar = false;

    /** Defines the pDouble field. */
    private double pDouble = 0;

    /** Whether this object was modified after loading or after last save. */
    private boolean modified = true;

    /** 
     * Whether this object was loaded from the database or already saved 
     * (false) or whether it is not yet in the database(true).
     */
    private boolean isNew = true;

    /** Flag which indicates whether this object is currently saving. */
    private boolean saving = false;

    /** 
     * Flag which indicates whether this object is currently loaded
     * from the database. 
     */
    private boolean loading = false;

    /** 
     * Flag which indicates whether this object was deleted from the database.
     * Note that this flags does not always display the current database state,
     * there is no magical connection between this flag and the database.
     */
    private boolean deleted = false;





    /**
     * Get the value of pBit.
     *
     * @return boolean
     */
    public boolean getPBit() 
    {
        
        return pBit;
    }

    /**
     * Set the value of pBit.
     *
     * @param v new value
     */
    public void setPBit(boolean v)
    {
        if (this.pBit != v)
        {
            setModified(true);
        }

        this.pBit = v;


    }
    
    /**
     * Get the value of pTinyint.
     *
     * @return byte
     */
    public byte getPTinyint() 
    {
        
        return pTinyint;
    }

    /**
     * Set the value of pTinyint.
     *
     * @param v new value
     */
    public void setPTinyint(byte v)
    {
        if (this.pTinyint != v)
        {
            setModified(true);
        }

        this.pTinyint = v;


    }
    
    /**
     * Get the value of pSmallint.
     *
     * @return short
     */
    public short getPSmallint() 
    {
        
        return pSmallint;
    }

    /**
     * Set the value of pSmallint.
     *
     * @param v new value
     */
    public void setPSmallint(short v)
    {
        if (this.pSmallint != v)
        {
            setModified(true);
        }

        this.pSmallint = v;


    }
    
    /**
     * Get the value of pBigint.
     *
     * @return long
     */
    public long getPBigint() 
    {
        
        return pBigint;
    }

    /**
     * Set the value of pBigint.
     *
     * @param v new value
     */
    public void setPBigint(long v)
    {
        if (this.pBigint != v)
        {
            setModified(true);
        }

        this.pBigint = v;


    }
    
    /**
     * Get the value of pFloat.
     *
     * @return double
     */
    public double getPFloat() 
    {
        
        return pFloat;
    }

    /**
     * Set the value of pFloat.
     *
     * @param v new value
     */
    public void setPFloat(double v)
    {
        if (this.pFloat != v)
        {
            setModified(true);
        }

        this.pFloat = v;


    }
    
    /**
     * Get the value of pReal.
     *
     * @return float
     */
    public float getPReal() 
    {
        
        return pReal;
    }

    /**
     * Set the value of pReal.
     *
     * @param v new value
     */
    public void setPReal(float v)
    {
        if (this.pReal != v)
        {
            setModified(true);
        }

        this.pReal = v;


    }
    
    /**
     * Get the value of pNumeric.
     *
     * @return java.math.BigDecimal
     */
    public java.math.BigDecimal getPNumeric() 
    {
        
        return pNumeric;
    }

    /**
     * Set the value of pNumeric.
     *
     * @param v new value
     */
    public void setPNumeric(java.math.BigDecimal v)
    {
        if (!ObjectUtils.equals(this.pNumeric, v))
        {
            setModified(true);
        }

        this.pNumeric = v;


    }
    
    /**
     * Get the value of pDecimal.
     *
     * @return java.math.BigDecimal
     */
    public java.math.BigDecimal getPDecimal() 
    {
        
        return pDecimal;
    }

    /**
     * Set the value of pDecimal.
     *
     * @param v new value
     */
    public void setPDecimal(java.math.BigDecimal v)
    {
        if (!ObjectUtils.equals(this.pDecimal, v))
        {
            setModified(true);
        }

        this.pDecimal = v;


    }
    
    /**
     * Get the value of pChar.
     *
     * @return String
     */
    public String getPChar() 
    {
        
        return pChar;
    }

    /**
     * Set the value of pChar.
     *
     * @param v new value
     */
    public void setPChar(String v)
    {
        if (!ObjectUtils.equals(this.pChar, v))
        {
            setModified(true);
        }

        this.pChar = v;


    }
    
    /**
     * Get the value of pVarchar.
     *
     * @return String
     */
    public String getPVarchar() 
    {
        
        return pVarchar;
    }

    /**
     * Set the value of pVarchar.
     *
     * @param v new value
     */
    public void setPVarchar(String v)
    {
        if (!ObjectUtils.equals(this.pVarchar, v))
        {
            setModified(true);
        }

        this.pVarchar = v;


    }
    
    /**
     * Get the value of pLongvarchar.
     *
     * @return String
     */
    public String getPLongvarchar() 
    {
        
        return pLongvarchar;
    }

    /**
     * Set the value of pLongvarchar.
     *
     * @param v new value
     */
    public void setPLongvarchar(String v)
    {
        if (!ObjectUtils.equals(this.pLongvarchar, v))
        {
            setModified(true);
        }

        this.pLongvarchar = v;


    }
    
    /**
     * Get the value of pDate.
     *
     * @return java.util.Date
     */
    public java.util.Date getPDate() 
    {
        
        return pDate;
    }

    /**
     * Set the value of pDate.
     *
     * @param v new value
     */
    public void setPDate(java.util.Date v)
    {
        if (!ObjectUtils.equals(this.pDate, v))
        {
            setModified(true);
        }

        this.pDate = v;


    }
    
    /**
     * Get the value of pTime.
     *
     * @return java.util.Date
     */
    public java.util.Date getPTime() 
    {
        
        return pTime;
    }

    /**
     * Set the value of pTime.
     *
     * @param v new value
     */
    public void setPTime(java.util.Date v)
    {
        if (!ObjectUtils.equals(this.pTime, v))
        {
            setModified(true);
        }

        this.pTime = v;


    }
    
    /**
     * Get the value of pInteger.
     *
     * @return int
     */
    public int getPInteger() 
    {
        
        return pInteger;
    }

    /**
     * Set the value of pInteger.
     *
     * @param v new value
     */
    public void setPInteger(int v)
    {
        if (this.pInteger != v)
        {
            setModified(true);
        }

        this.pInteger = v;


    }
    
    /**
     * Get the value of pTimestamp.
     *
     * @return java.util.Date
     */
    public java.util.Date getPTimestamp() 
    {
        
        return pTimestamp;
    }

    /**
     * Set the value of pTimestamp.
     *
     * @param v new value
     */
    public void setPTimestamp(java.util.Date v)
    {
        if (!ObjectUtils.equals(this.pTimestamp, v))
        {
            setModified(true);
        }

        this.pTimestamp = v;


    }
    
    /**
     * Get the value of pBinary.
     *
     * @return byte[]
     */
    public byte[] getPBinary() 
    {
        
        return pBinary;
    }

    /**
     * Set the value of pBinary.
     *
     * @param v new value
     */
    public void setPBinary(byte[] v)
    {
        if (!ObjectUtils.equals(this.pBinary, v))
        {
            setModified(true);
        }

        this.pBinary = v;


    }
    
    /**
     * Get the value of pVarbinary.
     *
     * @return byte[]
     */
    public byte[] getPVarbinary() 
    {
        
        return pVarbinary;
    }

    /**
     * Set the value of pVarbinary.
     *
     * @param v new value
     */
    public void setPVarbinary(byte[] v)
    {
        if (!ObjectUtils.equals(this.pVarbinary, v))
        {
            setModified(true);
        }

        this.pVarbinary = v;


    }
    
    /**
     * Get the value of pLongvarbinary.
     *
     * @return byte[]
     */
    public byte[] getPLongvarbinary() 
    {
        
        return pLongvarbinary;
    }

    /**
     * Set the value of pLongvarbinary.
     *
     * @param v new value
     */
    public void setPLongvarbinary(byte[] v)
    {
        if (!ObjectUtils.equals(this.pLongvarbinary, v))
        {
            setModified(true);
        }

        this.pLongvarbinary = v;


    }
    
    /**
     * Get the value of pBlob.
     *
     * @return byte[]
     */
    public byte[] getPBlob() 
    {
        
        return pBlob;
    }

    /**
     * Set the value of pBlob.
     *
     * @param v new value
     */
    public void setPBlob(byte[] v)
    {
        if (!ObjectUtils.equals(this.pBlob, v))
        {
            setModified(true);
        }

        this.pBlob = v;


    }
    
    /**
     * Get the value of pClob.
     *
     * @return String
     */
    public String getPClob() 
    {
        
        return pClob;
    }

    /**
     * Set the value of pClob.
     *
     * @param v new value
     */
    public void setPClob(String v)
    {
        if (!ObjectUtils.equals(this.pClob, v))
        {
            setModified(true);
        }

        this.pClob = v;


    }
    
    /**
     * Get the value of pBooleanint.
     *
     * @return boolean
     */
    public boolean getPBooleanint() 
    {
        
        return pBooleanint;
    }

    /**
     * Set the value of pBooleanint.
     *
     * @param v new value
     */
    public void setPBooleanint(boolean v)
    {
        if (this.pBooleanint != v)
        {
            setModified(true);
        }

        this.pBooleanint = v;


    }
    
    /**
     * Get the value of pBooleanchar.
     *
     * @return boolean
     */
    public boolean getPBooleanchar() 
    {
        
        return pBooleanchar;
    }

    /**
     * Set the value of pBooleanchar.
     *
     * @param v new value
     */
    public void setPBooleanchar(boolean v)
    {
        if (this.pBooleanchar != v)
        {
            setModified(true);
        }

        this.pBooleanchar = v;


    }
    
    /**
     * Get the value of pDouble.
     *
     * @return double
     */
    public double getPDouble() 
    {
        
        return pDouble;
    }

    /**
     * Set the value of pDouble.
     *
     * @param v new value
     */
    public void setPDouble(double v)
    {
        if (this.pDouble != v)
        {
            setModified(true);
        }

        this.pDouble = v;


    }
    

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return true, if the object has never been persisted.
     */
    public boolean isNew()
    {
        return isNew;
    }

    /**
     * Sets whether the object has ever been saved.
     *
     * @param isNew true if the object has never been saved, false otherwise.
     */
    public void setNew(boolean isNew)
    {
        this.isNew = isNew;
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return True if the object has been modified.
     */
    public boolean isModified()
    {
        return modified;
    }

    /**
     * Sets whether the object has been modified.
     *
     * @param modified true if the object has been modified, false otherwise.
     */
    public void setModified(boolean modified)
    {
        this.modified = modified;
    }

    /**
     * Sets the modified state for the object to be false.
     */
    public void resetModified()
    {
        modified = false;
    }


    /**
     * Returns whether this object is currently saving.
     *
     * @return true if this object is currently saving, false otherwise.
     */
    public boolean isSaving()
    {
        return saving;
    }

    /**
     * Sets whether this object is currently saving.
     *
     * @param saving true if this object is currently saving, false otherwise.
     */
    public void setSaving(boolean saving)
    {
        this.saving = saving;
    }


    /**
     * Returns whether this object is currently being loaded from the database.
     *
     * @return true if this object is currently loading, false otherwise.
     */
    public boolean isLoading()
    {
        return loading;
    }

    /**
     * Sets whether this object is currently being loaded from the database.
     *
     * @param loading true if this object is currently loading, false otherwise.
     */
    public void setLoading(boolean loading)
    {
        this.loading = loading;
    }


    /**
     * Returns whether this object was deleted from the database.
     * Note that this getter does not automatically reflect database state,
     * it will be set to true by Torque if doDelete() was called with this 
     * object. Bulk deletes and deletes via primary key do not change
     * this flag. Also, if doDelete() was called on an object which does
     * not exist in the database, the deleted flag is set to true even if
     * it was not deleted.
     *
     * @return true if this object was deleted, false otherwise.
     */
    public boolean isDeleted()
    {
        return deleted;
    }

    /**
     * Sets whether this object was deleted from the database.
     *
     * @param deleted true if this object was deleted, false otherwise.
     */
    public void setDeleted(boolean deleted)
    {
        this.deleted = deleted;
    }







    private static final List<String> FIELD_NAMES;

    static
    {
        List<String> fieldNames
                = new ArrayList<String>();
        fieldNames.add("PBit");
        fieldNames.add("PTinyint");
        fieldNames.add("PSmallint");
        fieldNames.add("PBigint");
        fieldNames.add("PFloat");
        fieldNames.add("PReal");
        fieldNames.add("PNumeric");
        fieldNames.add("PDecimal");
        fieldNames.add("PChar");
        fieldNames.add("PVarchar");
        fieldNames.add("PLongvarchar");
        fieldNames.add("PDate");
        fieldNames.add("PTime");
        fieldNames.add("PInteger");
        fieldNames.add("PTimestamp");
        fieldNames.add("PBinary");
        fieldNames.add("PVarbinary");
        fieldNames.add("PLongvarbinary");
        fieldNames.add("PBlob");
        fieldNames.add("PClob");
        fieldNames.add("PBooleanint");
        fieldNames.add("PBooleanchar");
        fieldNames.add("PDouble");
        FIELD_NAMES = Collections.unmodifiableList(fieldNames);
    }

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static List<String> getFieldNames()
    {
        return FIELD_NAMES;
    }

    /**
     * Retrieves a field from the object by field (Java) name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
        if (name.equals("PBit"))
        {
            return new Boolean(getPBit());
        }
        if (name.equals("PTinyint"))
        {
            return new Byte(getPTinyint());
        }
        if (name.equals("PSmallint"))
        {
            return new Short(getPSmallint());
        }
        if (name.equals("PBigint"))
        {
            return new Long(getPBigint());
        }
        if (name.equals("PFloat"))
        {
            return new Double(getPFloat());
        }
        if (name.equals("PReal"))
        {
            return new Float(getPReal());
        }
        if (name.equals("PNumeric"))
        {
            return getPNumeric();
        }
        if (name.equals("PDecimal"))
        {
            return getPDecimal();
        }
        if (name.equals("PChar"))
        {
            return getPChar();
        }
        if (name.equals("PVarchar"))
        {
            return getPVarchar();
        }
        if (name.equals("PLongvarchar"))
        {
            return getPLongvarchar();
        }
        if (name.equals("PDate"))
        {
            return getPDate();
        }
        if (name.equals("PTime"))
        {
            return getPTime();
        }
        if (name.equals("PInteger"))
        {
            return new Integer(getPInteger());
        }
        if (name.equals("PTimestamp"))
        {
            return getPTimestamp();
        }
        if (name.equals("PBinary"))
        {
            return getPBinary();
        }
        if (name.equals("PVarbinary"))
        {
            return getPVarbinary();
        }
        if (name.equals("PLongvarbinary"))
        {
            return getPLongvarbinary();
        }
        if (name.equals("PBlob"))
        {
            return getPBlob();
        }
        if (name.equals("PClob"))
        {
            return getPClob();
        }
        if (name.equals("PBooleanint"))
        {
            return new Boolean(getPBooleanint());
        }
        if (name.equals("PBooleanchar"))
        {
            return new Boolean(getPBooleanchar());
        }
        if (name.equals("PDouble"))
        {
            return new Double(getPDouble());
        }
        return null;
    }

    /**
     * Set a field in the object by field (Java) name.
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (name.equals("PBit"))
        {
            if (value == null || ! (Boolean.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not a Boolean object.");
            }
            setPBit(((Boolean)value).booleanValue());
            return true;
        }
        if (name.equals("PTinyint"))
        {
            if (value == null || ! (Byte.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not a Byte object.");
            }
            setPTinyint(((Byte) value).byteValue());
            return true;
        }
        if (name.equals("PSmallint"))
        {
            if (value == null || ! (Short.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not a Short object.");
            }
            setPSmallint(((Short)value).shortValue());
            return true;
        }
        if (name.equals("PBigint"))
        {
            if (value == null || ! (Long.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not a Long object.");
            }
            setPBigint(((Long) value).longValue());
            return true;
        }
        if (name.equals("PFloat"))
        {
            if (value == null || ! (Double.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not a Double object.");
            }
            setPFloat(((Double) value).doubleValue());
            return true;
        }
        if (name.equals("PReal"))
        {
            if (value == null || ! (Float.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not a Float object.");
            }
            setPReal(((Float) value).floatValue());
            return true;
        }
        if (name.equals("PNumeric"))
        {
            // Object fields can be null
            if (value != null && ! java.math.BigDecimal.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPNumeric((java.math.BigDecimal) value);
            return true;
        }
        if (name.equals("PDecimal"))
        {
            // Object fields can be null
            if (value != null && ! java.math.BigDecimal.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPDecimal((java.math.BigDecimal) value);
            return true;
        }
        if (name.equals("PChar"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPChar((String) value);
            return true;
        }
        if (name.equals("PVarchar"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPVarchar((String) value);
            return true;
        }
        if (name.equals("PLongvarchar"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPLongvarchar((String) value);
            return true;
        }
        if (name.equals("PDate"))
        {
            // Object fields can be null
            if (value != null && ! java.util.Date.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPDate((java.util.Date) value);
            return true;
        }
        if (name.equals("PTime"))
        {
            // Object fields can be null
            if (value != null && ! java.util.Date.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPTime((java.util.Date) value);
            return true;
        }
        if (name.equals("PInteger"))
        {
            if (value == null || ! (Integer.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not an Integer object.");
            }
            setPInteger(((Integer) value).intValue());
            return true;
        }
        if (name.equals("PTimestamp"))
        {
            // Object fields can be null
            if (value != null && ! java.util.Date.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPTimestamp((java.util.Date) value);
            return true;
        }
        if (name.equals("PBinary"))
        {
            // Object fields can be null
            if (value != null && ! byte[].class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPBinary((byte[]) value);
            return true;
        }
        if (name.equals("PVarbinary"))
        {
            // Object fields can be null
            if (value != null && ! byte[].class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPVarbinary((byte[]) value);
            return true;
        }
        if (name.equals("PLongvarbinary"))
        {
            // Object fields can be null
            if (value != null && ! byte[].class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPLongvarbinary((byte[]) value);
            return true;
        }
        if (name.equals("PBlob"))
        {
            // Object fields can be null
            if (value != null && ! byte[].class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPBlob((byte[]) value);
            return true;
        }
        if (name.equals("PClob"))
        {
            // Object fields can be null
            if (value != null && ! String.class.isInstance(value))
            {
                throw new IllegalArgumentException("Invalid type of object specified for value in setByName");
            }
            setPClob((String) value);
            return true;
        }
        if (name.equals("PBooleanint"))
        {
            if (value == null || ! (Boolean.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not a Boolean object.");
            }
            setPBooleanint(((Boolean)value).booleanValue());
            return true;
        }
        if (name.equals("PBooleanchar"))
        {
            if (value == null || ! (Boolean.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not a Boolean object.");
            }
            setPBooleanchar(((Boolean)value).booleanValue());
            return true;
        }
        if (name.equals("PDouble"))
        {
            if (value == null || ! (Double.class.isInstance(value)))
            {
                throw new IllegalArgumentException("setByName: value parameter was null or not a Double object.");
            }
            setPDouble(((Double) value).doubleValue());
            return true;
        }
        return false;
    }

    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_BIT))
        {
            return new Boolean(getPBit());
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_TINYINT))
        {
            return new Byte(getPTinyint());
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_SMALLINT))
        {
            return new Short(getPSmallint());
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_BIGINT))
        {
            return new Long(getPBigint());
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_FLOAT))
        {
            return new Double(getPFloat());
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_REAL))
        {
            return new Float(getPReal());
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_NUMERIC))
        {
            return getPNumeric();
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_DECIMAL))
        {
            return getPDecimal();
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_CHAR))
        {
            return getPChar();
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_VARCHAR))
        {
            return getPVarchar();
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_LONGVARCHAR))
        {
            return getPLongvarchar();
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_DATE))
        {
            return getPDate();
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_TIME))
        {
            return getPTime();
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_INTEGER))
        {
            return new Integer(getPInteger());
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_TIMESTAMP))
        {
            return getPTimestamp();
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_BINARY))
        {
            return getPBinary();
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_VARBINARY))
        {
            return getPVarbinary();
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_LONGVARBINARY))
        {
            return getPLongvarbinary();
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_BLOB))
        {
            return getPBlob();
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_CLOB))
        {
            return getPClob();
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_BOOLEANINT))
        {
            return new Boolean(getPBooleanint());
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_BOOLEANCHAR))
        {
            return new Boolean(getPBooleanchar());
        }
        if (name.equals(org.apache.torque.test.TypesPrimitivePeer.P_DOUBLE))
        {
            return new Double(getPDouble());
        }
        return null;
    }

    /**
     * Set field values by Peer Field Name
     *
     * @param name field name
     * @param value field value
     * @return True if value was set, false if not (invalid name / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPeerName(String name, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (org.apache.torque.test.TypesPrimitivePeer.P_BIT.getSqlExpression().equals(name))
        {
            return setByName("PBit", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_TINYINT.getSqlExpression().equals(name))
        {
            return setByName("PTinyint", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_SMALLINT.getSqlExpression().equals(name))
        {
            return setByName("PSmallint", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_BIGINT.getSqlExpression().equals(name))
        {
            return setByName("PBigint", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_FLOAT.getSqlExpression().equals(name))
        {
            return setByName("PFloat", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_REAL.getSqlExpression().equals(name))
        {
            return setByName("PReal", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_NUMERIC.getSqlExpression().equals(name))
        {
            return setByName("PNumeric", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_DECIMAL.getSqlExpression().equals(name))
        {
            return setByName("PDecimal", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_CHAR.getSqlExpression().equals(name))
        {
            return setByName("PChar", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_VARCHAR.getSqlExpression().equals(name))
        {
            return setByName("PVarchar", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_LONGVARCHAR.getSqlExpression().equals(name))
        {
            return setByName("PLongvarchar", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_DATE.getSqlExpression().equals(name))
        {
            return setByName("PDate", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_TIME.getSqlExpression().equals(name))
        {
            return setByName("PTime", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_INTEGER.getSqlExpression().equals(name))
        {
            return setByName("PInteger", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_TIMESTAMP.getSqlExpression().equals(name))
        {
            return setByName("PTimestamp", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_BINARY.getSqlExpression().equals(name))
        {
            return setByName("PBinary", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_VARBINARY.getSqlExpression().equals(name))
        {
            return setByName("PVarbinary", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_LONGVARBINARY.getSqlExpression().equals(name))
        {
            return setByName("PLongvarbinary", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_BLOB.getSqlExpression().equals(name))
        {
            return setByName("PBlob", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_CLOB.getSqlExpression().equals(name))
        {
            return setByName("PClob", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_BOOLEANINT.getSqlExpression().equals(name))
        {
            return setByName("PBooleanint", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_BOOLEANCHAR.getSqlExpression().equals(name))
        {
            return setByName("PBooleanchar", value);
        }
        if (org.apache.torque.test.TypesPrimitivePeer.P_DOUBLE.getSqlExpression().equals(name))
        {
            return setByName("PDouble", value);
        }
        return false;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
        if (pos == 0)
        {
            return new Boolean(getPBit());
        }
        if (pos == 1)
        {
            return new Byte(getPTinyint());
        }
        if (pos == 2)
        {
            return new Short(getPSmallint());
        }
        if (pos == 3)
        {
            return new Long(getPBigint());
        }
        if (pos == 4)
        {
            return new Double(getPFloat());
        }
        if (pos == 5)
        {
            return new Float(getPReal());
        }
        if (pos == 6)
        {
            return getPNumeric();
        }
        if (pos == 7)
        {
            return getPDecimal();
        }
        if (pos == 8)
        {
            return getPChar();
        }
        if (pos == 9)
        {
            return getPVarchar();
        }
        if (pos == 10)
        {
            return getPLongvarchar();
        }
        if (pos == 11)
        {
            return getPDate();
        }
        if (pos == 12)
        {
            return getPTime();
        }
        if (pos == 13)
        {
            return new Integer(getPInteger());
        }
        if (pos == 14)
        {
            return getPTimestamp();
        }
        if (pos == 15)
        {
            return getPBinary();
        }
        if (pos == 16)
        {
            return getPVarbinary();
        }
        if (pos == 17)
        {
            return getPLongvarbinary();
        }
        if (pos == 18)
        {
            return getPBlob();
        }
        if (pos == 19)
        {
            return getPClob();
        }
        if (pos == 20)
        {
            return new Boolean(getPBooleanint());
        }
        if (pos == 21)
        {
            return new Boolean(getPBooleanchar());
        }
        if (pos == 22)
        {
            return new Double(getPDouble());
        }
        return null;
    }

    /**
     * Set field values by its position (zero based) in the XML schema.
     *
     * @param position The field position
     * @param value field value
     * @return True if value was set, false if not (invalid position / protected field).
     * @throws IllegalArgumentException if object type of value does not match field object type.
     * @throws TorqueException If a problem occurs with the set[Field] method.
     */
    public boolean setByPosition(int position, Object value)
        throws TorqueException, IllegalArgumentException
    {
        if (position == 0)
        {
            return setByName("PBit", value);
        }
        if (position == 1)
        {
            return setByName("PTinyint", value);
        }
        if (position == 2)
        {
            return setByName("PSmallint", value);
        }
        if (position == 3)
        {
            return setByName("PBigint", value);
        }
        if (position == 4)
        {
            return setByName("PFloat", value);
        }
        if (position == 5)
        {
            return setByName("PReal", value);
        }
        if (position == 6)
        {
            return setByName("PNumeric", value);
        }
        if (position == 7)
        {
            return setByName("PDecimal", value);
        }
        if (position == 8)
        {
            return setByName("PChar", value);
        }
        if (position == 9)
        {
            return setByName("PVarchar", value);
        }
        if (position == 10)
        {
            return setByName("PLongvarchar", value);
        }
        if (position == 11)
        {
            return setByName("PDate", value);
        }
        if (position == 12)
        {
            return setByName("PTime", value);
        }
        if (position == 13)
        {
            return setByName("PInteger", value);
        }
        if (position == 14)
        {
            return setByName("PTimestamp", value);
        }
        if (position == 15)
        {
            return setByName("PBinary", value);
        }
        if (position == 16)
        {
            return setByName("PVarbinary", value);
        }
        if (position == 17)
        {
            return setByName("PLongvarbinary", value);
        }
        if (position == 18)
        {
            return setByName("PBlob", value);
        }
        if (position == 19)
        {
            return setByName("PClob", value);
        }
        if (position == 20)
        {
            return setByName("PBooleanint", value);
        }
        if (position == 21)
        {
            return setByName("PBooleanchar", value);
        }
        if (position == 22)
        {
            return setByName("PDouble", value);
        }
        return false;
    }



    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save() throws TorqueException
    {
        save(TypesPrimitivePeer.DATABASE_NAME);
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.
     *
     * @param toSave the object to be saved, not null.
     * @param dbName the name of the database to which the object
     *        should be saved.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(String dbName) 
            throws TorqueException
    {
        Connection con = null;
        try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }
    }

    /**
     * Stores an object in the database.  If the object is new,
     * it is inserted; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally.
     *
     * @param toSave the object to be saved, not null.
     * @param con the connection to use for saving the object, not null.
     *
     * @throws TorqueException if an error occurs during saving.
     */
    public void save(Connection con) 
            throws TorqueException
    {
        if (isSaving())
        {
            return;
        }
        try
        {
            setSaving(true);
            // If this object has been modified, then save it to the database.
            if (isModified())
            {
                if (isNew())
                {
                    TypesPrimitivePeer.doInsert((TypesPrimitive) this, con);
                    setNew(false);
                }
                else
                {
                    TypesPrimitivePeer.doUpdate((TypesPrimitive) this, con);
                }
            }

        }
        finally
        {
            setSaving(false);
        }
    }




    
    /**
     * Set the PrimaryKey with an ObjectKey
     *
     * @param key the primary key to set.
     *
     * @throws NoSuchOperationException always.
     */
    public void setPrimaryKey(ObjectKey key) throws TorqueException
    {
        throw new UnsupportedOperationException(
                "This table has no primary key");
    }

    /**
     * Set the PrimaryKey using a String.
     *
     * @param key the primary key to set.
     *
     * @throws NoSuchOperationException always.
     */
    public void setPrimaryKey(String key) throws TorqueException
    {
        throw new UnsupportedOperationException(
                "This table has no primary key");
    }

    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        return null;
    }



    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public TypesPrimitive copy() throws TorqueException
    {
        return copy(true);
    }

    /**
     * Makes a copy of this object using a connection.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     *
     * @param con the database connection to read associated objects.
     */
    public TypesPrimitive copy(Connection con) throws TorqueException
    {
        return copy(true, con);
    }

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     */
    public TypesPrimitive copy(boolean deepcopy) throws TorqueException
    {
        TypesPrimitive typesPrimitive = new TypesPrimitive();

        return copyInto(typesPrimitive, deepcopy);
    }

    /**
     * Makes a copy of this object using connection.
     * It creates a new object filling in the simple attributes.
     * If the parameter deepcopy is true, it then fills all the
     * association collections and sets the related objects to
     * isNew=true.
     *
     * @param deepcopy whether to copy the associated objects.
     * @param con the database connection to read associated objects.
     */
    public TypesPrimitive copy(boolean deepcopy, Connection con) throws TorqueException
    {
        TypesPrimitive typesPrimitive = new TypesPrimitive();

        return copyInto(typesPrimitive, deepcopy, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     */
    protected TypesPrimitive copyInto(TypesPrimitive copyObj) throws TorqueException
    {
        return copyInto(copyObj, true);
    }

    /**
     * Fills the copyObj with the contents of this object using connection.
     * The associated objects are also copied and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param con the database connection to read associated objects.
     */
    protected TypesPrimitive copyInto(TypesPrimitive copyObj, Connection con) throws TorqueException
    {
        return copyInto(copyObj, true, con);
    }
  
    /**
     * Fills the copyObj with the contents of this object.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     */
    protected TypesPrimitive copyInto(TypesPrimitive copyObj, boolean deepcopy) throws TorqueException
    {
        copyObj.setPBit(pBit);
        copyObj.setPTinyint(pTinyint);
        copyObj.setPSmallint(pSmallint);
        copyObj.setPBigint(pBigint);
        copyObj.setPFloat(pFloat);
        copyObj.setPReal(pReal);
        copyObj.setPNumeric(pNumeric);
        copyObj.setPDecimal(pDecimal);
        copyObj.setPChar(pChar);
        copyObj.setPVarchar(pVarchar);
        copyObj.setPLongvarchar(pLongvarchar);
        copyObj.setPDate(pDate);
        copyObj.setPTime(pTime);
        copyObj.setPInteger(pInteger);
        copyObj.setPTimestamp(pTimestamp);
        copyObj.setPBinary(pBinary);
        copyObj.setPVarbinary(pVarbinary);
        copyObj.setPLongvarbinary(pLongvarbinary);
        copyObj.setPBlob(pBlob);
        copyObj.setPClob(pClob);
        copyObj.setPBooleanint(pBooleanint);
        copyObj.setPBooleanchar(pBooleanchar);
        copyObj.setPDouble(pDouble);

        if (deepcopy)
        {
        }
        return copyObj;
    }
        
    
    /**
     * Fills the copyObj with the contents of this object using connection.
     * If deepcopy is true, The associated objects are also copied
     * and treated as new objects.
     *
     * @param copyObj the object to fill.
     * @param deepcopy whether the associated objects should be copied.
     * @param con the database connection to read associated objects.
     */
    protected TypesPrimitive copyInto(TypesPrimitive copyObj, boolean deepcopy, Connection con) throws TorqueException
    {
        copyObj.setPBit(pBit);
        copyObj.setPTinyint(pTinyint);
        copyObj.setPSmallint(pSmallint);
        copyObj.setPBigint(pBigint);
        copyObj.setPFloat(pFloat);
        copyObj.setPReal(pReal);
        copyObj.setPNumeric(pNumeric);
        copyObj.setPDecimal(pDecimal);
        copyObj.setPChar(pChar);
        copyObj.setPVarchar(pVarchar);
        copyObj.setPLongvarchar(pLongvarchar);
        copyObj.setPDate(pDate);
        copyObj.setPTime(pTime);
        copyObj.setPInteger(pInteger);
        copyObj.setPTimestamp(pTimestamp);
        copyObj.setPBinary(pBinary);
        copyObj.setPVarbinary(pVarbinary);
        copyObj.setPLongvarbinary(pLongvarbinary);
        copyObj.setPBlob(pBlob);
        copyObj.setPClob(pClob);
        copyObj.setPBooleanint(pBooleanint);
        copyObj.setPBooleanchar(pBooleanchar);
        copyObj.setPDouble(pDouble);

        if (deepcopy)
        {
        }
        return copyObj;
    }

    /** The Peer class */
    private static final org.apache.torque.test.TypesPrimitivePeer peer
            = new org.apache.torque.test.TypesPrimitivePeer();

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public org.apache.torque.test.TypesPrimitivePeer getPeer()
    {
        return peer;
    }

    /**
     * Retrieves the TableMap object related to this Table data without
     * compiler warnings of using getPeer().getTableMap().
     *
     * @return The associated TableMap object.
     */
    public TableMap getTableMap() throws TorqueException
    {
        return org.apache.torque.test.TypesPrimitivePeer.getTableMap();
    }



    public String toString()
    {
        StringBuffer str = new StringBuffer();
        str.append("TypesPrimitive:\n");
        str.append("pBit = ")
           .append(getPBit())
           .append("\n");
        str.append("pTinyint = ")
           .append(getPTinyint())
           .append("\n");
        str.append("pSmallint = ")
           .append(getPSmallint())
           .append("\n");
        str.append("pBigint = ")
           .append(getPBigint())
           .append("\n");
        str.append("pFloat = ")
           .append(getPFloat())
           .append("\n");
        str.append("pReal = ")
           .append(getPReal())
           .append("\n");
        str.append("pNumeric = ")
           .append(getPNumeric())
           .append("\n");
        str.append("pDecimal = ")
           .append(getPDecimal())
           .append("\n");
        str.append("pChar = ")
           .append(getPChar())
           .append("\n");
        str.append("pVarchar = ")
           .append(getPVarchar())
           .append("\n");
        str.append("pLongvarchar = ")
           .append(getPLongvarchar())
           .append("\n");
        str.append("pDate = ")
           .append(getPDate())
           .append("\n");
        str.append("pTime = ")
           .append(getPTime())
           .append("\n");
        str.append("pInteger = ")
           .append(getPInteger())
           .append("\n");
        str.append("pTimestamp = ")
           .append(getPTimestamp())
           .append("\n");
        str.append("pBinary = ")
           .append("<binary>")
           .append("\n");
        str.append("pVarbinary = ")
           .append("<binary>")
           .append("\n");
        str.append("pLongvarbinary = ")
           .append("<binary>")
           .append("\n");
        str.append("pBlob = ")
           .append("<binary>")
           .append("\n");
        str.append("pClob = ")
           .append(getPClob())
           .append("\n");
        str.append("pBooleanint = ")
           .append(getPBooleanint())
           .append("\n");
        str.append("pBooleanchar = ")
           .append(getPBooleanchar())
           .append("\n");
        str.append("pDouble = ")
           .append(getPDouble())
           .append("\n");
        return(str.toString());
    }

    /**
     * Compares the primary key of this instance with the key of another.
     *
     * @param toCompare The object to compare to.
     * @return Whether the primary keys are equal and the object have the
     *         same class.
     */
    public boolean equals(Object toCompare)
    {
        if (toCompare == null)
        {
            return false;
        }
        if (this == toCompare)
        {
            return true;
        }
        if (!getClass().equals(toCompare.getClass()))
        {
            return false;
        }
        TypesPrimitive other = (TypesPrimitive) toCompare;
        if (getPrimaryKey() == null || other.getPrimaryKey() == null)
        {
            return false;
        }
        return getPrimaryKey().equals(other.getPrimaryKey());
    }

    /**
     * If the primary key is not <code>null</code>, return the hashcode of the
     * primary key.  Otherwise calls <code>Object.hashCode()</code>.
     *
     * @return an <code>int</code> value
     */
    public int hashCode()
    {
        ObjectKey ok = getPrimaryKey();
        if (ok == null)
        {
            return super.hashCode();
        }

        return ok.hashCode();
    }




}
