package org.apache.torque.test;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.torque.NoRowsException;
import org.apache.torque.TooManyRowsException;
import org.apache.torque.Column;
import org.apache.torque.Torque;
import org.apache.torque.TorqueException;
import org.apache.torque.TorqueRuntimeException;
import org.apache.torque.adapter.IDMethod;
import org.apache.torque.criteria.Criteria;
import org.apache.torque.map.DatabaseMap;
import org.apache.torque.map.TableMap;
import org.apache.torque.map.ColumnMap;
import org.apache.torque.map.ForeignKeyMap;
import org.apache.torque.map.InheritanceMap;
import org.apache.torque.om.mapper.RecordMapper;
import org.apache.torque.om.mapper.CompositeMapper;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.util.BasePeer;
import org.apache.torque.util.Transaction;
import org.apache.torque.util.ColumnValues;
import org.apache.torque.util.JdbcTypedValue;



/**
 * used to test the handling for all supported types
 *
 * The skeleton for this class was autogenerated by Torque on:
 *
 * [Thu Sep 13 04:35:44 CEST 2012]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to TypesPrimitivePeer
 */
@SuppressWarnings({"unused", "unchecked"})
public abstract class BaseTypesPrimitivePeer
{
    /** The class log. */
    private static Log log = LogFactory.getLog(BaseTypesPrimitivePeerImpl.class);
    /** Serial version */
    private static final long serialVersionUID = 1347503744755L;


    /** The default database name for this class. */
    public static final String DATABASE_NAME;

     /** The table name for this class. */
    public static final String TABLE_NAME;

     /** The table map for this class. */
    public static final TableMap TABLE;
    /** The column for the p_bit field */
    public static final ColumnMap P_BIT;
    /** The column for the p_tinyint field */
    public static final ColumnMap P_TINYINT;
    /** The column for the p_smallint field */
    public static final ColumnMap P_SMALLINT;
    /** The column for the p_bigint field */
    public static final ColumnMap P_BIGINT;
    /** The column for the p_float field */
    public static final ColumnMap P_FLOAT;
    /** The column for the p_real field */
    public static final ColumnMap P_REAL;
    /** The column for the p_numeric field */
    public static final ColumnMap P_NUMERIC;
    /** The column for the p_decimal field */
    public static final ColumnMap P_DECIMAL;
    /** The column for the p_char field */
    public static final ColumnMap P_CHAR;
    /** The column for the p_varchar field */
    public static final ColumnMap P_VARCHAR;
    /** The column for the p_longvarchar field */
    public static final ColumnMap P_LONGVARCHAR;
    /** The column for the p_date field */
    public static final ColumnMap P_DATE;
    /** The column for the p_time field */
    public static final ColumnMap P_TIME;
    /** The column for the p_integer field */
    public static final ColumnMap P_INTEGER;
    /** The column for the p_timestamp field */
    public static final ColumnMap P_TIMESTAMP;
    /** The column for the p_binary field */
    public static final ColumnMap P_BINARY;
    /** The column for the p_varbinary field */
    public static final ColumnMap P_VARBINARY;
    /** The column for the p_longvarbinary field */
    public static final ColumnMap P_LONGVARBINARY;
    /** The column for the p_blob field */
    public static final ColumnMap P_BLOB;
    /** The column for the p_clob field */
    public static final ColumnMap P_CLOB;
    /** The column for the p_booleanint field */
    public static final ColumnMap P_BOOLEANINT;
    /** The column for the p_booleanchar field */
    public static final ColumnMap P_BOOLEANCHAR;
    /** The column for the p_double field */
    public static final ColumnMap P_DOUBLE;

    /** number of columns for this peer */
    public static final int numColumns = 23;


    /** The implementation of the peer. */
    private static TypesPrimitivePeerImpl typesPrimitivePeerImpl;


    static
    {
        DatabaseMap dbMap = Torque.getOrCreateDatabase("bookstore")
                .getDatabaseMap();
        if (dbMap.getTable("types_primitive") == null)
        {
            dbMap.addTable("types_primitive");
        }
        DATABASE_NAME = "bookstore";
        TABLE_NAME = "types_primitive";

        TABLE = dbMap.getTable("types_primitive");
        TABLE.setJavaName("TypesPrimitive");
        TABLE.setOMClass(org.apache.torque.test.TypesPrimitive.class);
        TABLE.setPeerClass(org.apache.torque.test.TypesPrimitivePeer.class);
        TABLE.setDescription("used to test the handling for all supported types");
        TABLE.setPrimaryKeyMethod(IDMethod.NATIVE);
        TABLE.setPrimaryKeyMethodInfo(IDMethod.ID_BROKER, TABLE.getName());
        TABLE.setPrimaryKeyMethodInfo(IDMethod.SEQUENCE, "types_primitive_SEQ");
        TABLE.setPrimaryKeyMethodInfo(IDMethod.AUTO_INCREMENT, "types_primitive");
        TABLE.setUseInheritance(true);


    // ------------- Column: p_bit --------------------
        P_BIT = new ColumnMap("p_bit", TABLE);
        P_BIT.setType(new Boolean(true));
        P_BIT.setTorqueType("BIT");
        P_BIT.setUsePrimitive(true);
        P_BIT.setPrimaryKey(false);
        P_BIT.setNotNull(false);
        P_BIT.setJavaName("PBit");
        P_BIT.setAutoIncrement(true);
        P_BIT.setProtected(false);
        P_BIT.setJavaType( "boolean" );
        P_BIT.setPosition(1);
        TABLE.addColumn(P_BIT);
    // ------------- Column: p_tinyint --------------------
        P_TINYINT = new ColumnMap("p_tinyint", TABLE);
        P_TINYINT.setType(Byte.valueOf((byte) 0));
        P_TINYINT.setTorqueType("TINYINT");
        P_TINYINT.setUsePrimitive(true);
        P_TINYINT.setPrimaryKey(false);
        P_TINYINT.setNotNull(false);
        P_TINYINT.setJavaName("PTinyint");
        P_TINYINT.setAutoIncrement(true);
        P_TINYINT.setProtected(false);
        P_TINYINT.setJavaType( "byte" );
        P_TINYINT.setPosition(2);
        TABLE.addColumn(P_TINYINT);
    // ------------- Column: p_smallint --------------------
        P_SMALLINT = new ColumnMap("p_smallint", TABLE);
        P_SMALLINT.setType(Short.valueOf((short) 0));
        P_SMALLINT.setTorqueType("SMALLINT");
        P_SMALLINT.setUsePrimitive(true);
        P_SMALLINT.setPrimaryKey(false);
        P_SMALLINT.setNotNull(false);
        P_SMALLINT.setJavaName("PSmallint");
        P_SMALLINT.setAutoIncrement(true);
        P_SMALLINT.setProtected(false);
        P_SMALLINT.setJavaType( "short" );
        P_SMALLINT.setPosition(3);
        TABLE.addColumn(P_SMALLINT);
    // ------------- Column: p_bigint --------------------
        P_BIGINT = new ColumnMap("p_bigint", TABLE);
        P_BIGINT.setType(Long.valueOf(0));
        P_BIGINT.setTorqueType("BIGINT");
        P_BIGINT.setUsePrimitive(true);
        P_BIGINT.setPrimaryKey(false);
        P_BIGINT.setNotNull(false);
        P_BIGINT.setJavaName("PBigint");
        P_BIGINT.setAutoIncrement(true);
        P_BIGINT.setProtected(false);
        P_BIGINT.setJavaType( "long" );
        P_BIGINT.setPosition(4);
        TABLE.addColumn(P_BIGINT);
    // ------------- Column: p_float --------------------
        P_FLOAT = new ColumnMap("p_float", TABLE);
        P_FLOAT.setType(new Double(0));
        P_FLOAT.setTorqueType("FLOAT");
        P_FLOAT.setUsePrimitive(true);
        P_FLOAT.setPrimaryKey(false);
        P_FLOAT.setNotNull(false);
        P_FLOAT.setJavaName("PFloat");
        P_FLOAT.setAutoIncrement(true);
        P_FLOAT.setProtected(false);
        P_FLOAT.setJavaType( "double" );
        P_FLOAT.setPosition(5);
        TABLE.addColumn(P_FLOAT);
    // ------------- Column: p_real --------------------
        P_REAL = new ColumnMap("p_real", TABLE);
        P_REAL.setType(new Float(0));
        P_REAL.setTorqueType("REAL");
        P_REAL.setUsePrimitive(true);
        P_REAL.setPrimaryKey(false);
        P_REAL.setNotNull(false);
        P_REAL.setJavaName("PReal");
        P_REAL.setAutoIncrement(true);
        P_REAL.setProtected(false);
        P_REAL.setJavaType( "float" );
        P_REAL.setPosition(6);
        TABLE.addColumn(P_REAL);
    // ------------- Column: p_numeric --------------------
        P_NUMERIC = new ColumnMap("p_numeric", TABLE);
        P_NUMERIC.setType(new java.math.BigDecimal((double) 0));
        P_NUMERIC.setTorqueType("NUMERIC");
        P_NUMERIC.setUsePrimitive(false);
        P_NUMERIC.setPrimaryKey(false);
        P_NUMERIC.setNotNull(false);
        P_NUMERIC.setJavaName("PNumeric");
        P_NUMERIC.setAutoIncrement(true);
        P_NUMERIC.setProtected(false);
        P_NUMERIC.setJavaType( "java.math.BigDecimal" );
        P_NUMERIC.setPosition(7);
        TABLE.addColumn(P_NUMERIC);
    // ------------- Column: p_decimal --------------------
        P_DECIMAL = new ColumnMap("p_decimal", TABLE);
        P_DECIMAL.setType(new java.math.BigDecimal((double) 0));
        P_DECIMAL.setTorqueType("DECIMAL");
        P_DECIMAL.setUsePrimitive(false);
        P_DECIMAL.setPrimaryKey(false);
        P_DECIMAL.setNotNull(false);
        P_DECIMAL.setJavaName("PDecimal");
        P_DECIMAL.setAutoIncrement(true);
        P_DECIMAL.setProtected(false);
        P_DECIMAL.setJavaType( "java.math.BigDecimal" );
        P_DECIMAL.setPosition(8);
        TABLE.addColumn(P_DECIMAL);
    // ------------- Column: p_char --------------------
        P_CHAR = new ColumnMap("p_char", TABLE);
        P_CHAR.setType("");
        P_CHAR.setTorqueType("CHAR");
        P_CHAR.setUsePrimitive(false);
        P_CHAR.setPrimaryKey(false);
        P_CHAR.setNotNull(false);
        P_CHAR.setJavaName("PChar");
        P_CHAR.setAutoIncrement(true);
        P_CHAR.setProtected(false);
        P_CHAR.setJavaType( "String" );
        P_CHAR.setPosition(9);
        TABLE.addColumn(P_CHAR);
    // ------------- Column: p_varchar --------------------
        P_VARCHAR = new ColumnMap("p_varchar", TABLE);
        P_VARCHAR.setType("");
        P_VARCHAR.setTorqueType("VARCHAR");
        P_VARCHAR.setUsePrimitive(false);
        P_VARCHAR.setPrimaryKey(false);
        P_VARCHAR.setNotNull(false);
        P_VARCHAR.setJavaName("PVarchar");
        P_VARCHAR.setAutoIncrement(true);
        P_VARCHAR.setProtected(false);
        P_VARCHAR.setJavaType( "String" );
        P_VARCHAR.setSize(255);
        P_VARCHAR.setPosition(10);
        TABLE.addColumn(P_VARCHAR);
    // ------------- Column: p_longvarchar --------------------
        P_LONGVARCHAR = new ColumnMap("p_longvarchar", TABLE);
        P_LONGVARCHAR.setType("");
        P_LONGVARCHAR.setTorqueType("LONGVARCHAR");
        P_LONGVARCHAR.setUsePrimitive(false);
        P_LONGVARCHAR.setPrimaryKey(false);
        P_LONGVARCHAR.setNotNull(false);
        P_LONGVARCHAR.setJavaName("PLongvarchar");
        P_LONGVARCHAR.setAutoIncrement(true);
        P_LONGVARCHAR.setProtected(false);
        P_LONGVARCHAR.setJavaType( "String" );
        P_LONGVARCHAR.setPosition(11);
        TABLE.addColumn(P_LONGVARCHAR);
    // ------------- Column: p_date --------------------
        P_DATE = new ColumnMap("p_date", TABLE);
        P_DATE.setType(new Date());
        P_DATE.setTorqueType("DATE");
        P_DATE.setUsePrimitive(false);
        P_DATE.setPrimaryKey(false);
        P_DATE.setNotNull(false);
        P_DATE.setJavaName("PDate");
        P_DATE.setAutoIncrement(true);
        P_DATE.setProtected(false);
        P_DATE.setJavaType( "java.util.Date" );
        P_DATE.setPosition(12);
        TABLE.addColumn(P_DATE);
    // ------------- Column: p_time --------------------
        P_TIME = new ColumnMap("p_time", TABLE);
        P_TIME.setType(new Date());
        P_TIME.setTorqueType("TIME");
        P_TIME.setUsePrimitive(false);
        P_TIME.setPrimaryKey(false);
        P_TIME.setNotNull(false);
        P_TIME.setJavaName("PTime");
        P_TIME.setAutoIncrement(true);
        P_TIME.setProtected(false);
        P_TIME.setJavaType( "java.util.Date" );
        P_TIME.setPosition(13);
        TABLE.addColumn(P_TIME);
    // ------------- Column: p_integer --------------------
        P_INTEGER = new ColumnMap("p_integer", TABLE);
        P_INTEGER.setType(Integer.valueOf(0));
        P_INTEGER.setTorqueType("INTEGER");
        P_INTEGER.setUsePrimitive(true);
        P_INTEGER.setPrimaryKey(false);
        P_INTEGER.setNotNull(false);
        P_INTEGER.setJavaName("PInteger");
        P_INTEGER.setAutoIncrement(true);
        P_INTEGER.setProtected(false);
        P_INTEGER.setJavaType( "int" );
        P_INTEGER.setPosition(14);
        TABLE.addColumn(P_INTEGER);
    // ------------- Column: p_timestamp --------------------
        P_TIMESTAMP = new ColumnMap("p_timestamp", TABLE);
        P_TIMESTAMP.setType(new Date());
        P_TIMESTAMP.setTorqueType("TIMESTAMP");
        P_TIMESTAMP.setUsePrimitive(false);
        P_TIMESTAMP.setPrimaryKey(false);
        P_TIMESTAMP.setNotNull(false);
        P_TIMESTAMP.setJavaName("PTimestamp");
        P_TIMESTAMP.setAutoIncrement(true);
        P_TIMESTAMP.setProtected(false);
        P_TIMESTAMP.setJavaType( "java.util.Date" );
        P_TIMESTAMP.setPosition(15);
        TABLE.addColumn(P_TIMESTAMP);
    // ------------- Column: p_binary --------------------
        P_BINARY = new ColumnMap("p_binary", TABLE);
        P_BINARY.setType(new Object());
        P_BINARY.setTorqueType("BINARY");
        P_BINARY.setUsePrimitive(false);
        P_BINARY.setPrimaryKey(false);
        P_BINARY.setNotNull(false);
        P_BINARY.setJavaName("PBinary");
        P_BINARY.setAutoIncrement(true);
        P_BINARY.setProtected(false);
        P_BINARY.setJavaType( "byte[]" );
        P_BINARY.setPosition(16);
        TABLE.addColumn(P_BINARY);
    // ------------- Column: p_varbinary --------------------
        P_VARBINARY = new ColumnMap("p_varbinary", TABLE);
        P_VARBINARY.setType(new Object());
        P_VARBINARY.setTorqueType("VARBINARY");
        P_VARBINARY.setUsePrimitive(false);
        P_VARBINARY.setPrimaryKey(false);
        P_VARBINARY.setNotNull(false);
        P_VARBINARY.setJavaName("PVarbinary");
        P_VARBINARY.setAutoIncrement(true);
        P_VARBINARY.setProtected(false);
        P_VARBINARY.setJavaType( "byte[]" );
        P_VARBINARY.setPosition(17);
        TABLE.addColumn(P_VARBINARY);
    // ------------- Column: p_longvarbinary --------------------
        P_LONGVARBINARY = new ColumnMap("p_longvarbinary", TABLE);
        P_LONGVARBINARY.setType(new Object());
        P_LONGVARBINARY.setTorqueType("LONGVARBINARY");
        P_LONGVARBINARY.setUsePrimitive(false);
        P_LONGVARBINARY.setPrimaryKey(false);
        P_LONGVARBINARY.setNotNull(false);
        P_LONGVARBINARY.setJavaName("PLongvarbinary");
        P_LONGVARBINARY.setAutoIncrement(true);
        P_LONGVARBINARY.setProtected(false);
        P_LONGVARBINARY.setJavaType( "byte[]" );
        P_LONGVARBINARY.setPosition(18);
        TABLE.addColumn(P_LONGVARBINARY);
    // ------------- Column: p_blob --------------------
        P_BLOB = new ColumnMap("p_blob", TABLE);
        P_BLOB.setType(new Object());
        P_BLOB.setTorqueType("BLOB");
        P_BLOB.setUsePrimitive(false);
        P_BLOB.setPrimaryKey(false);
        P_BLOB.setNotNull(false);
        P_BLOB.setJavaName("PBlob");
        P_BLOB.setAutoIncrement(true);
        P_BLOB.setProtected(false);
        P_BLOB.setJavaType( "byte[]" );
        P_BLOB.setPosition(19);
        TABLE.addColumn(P_BLOB);
    // ------------- Column: p_clob --------------------
        P_CLOB = new ColumnMap("p_clob", TABLE);
        P_CLOB.setType("");
        P_CLOB.setTorqueType("CLOB");
        P_CLOB.setUsePrimitive(false);
        P_CLOB.setPrimaryKey(false);
        P_CLOB.setNotNull(false);
        P_CLOB.setJavaName("PClob");
        P_CLOB.setAutoIncrement(true);
        P_CLOB.setProtected(false);
        P_CLOB.setJavaType( "String" );
        P_CLOB.setPosition(20);
        TABLE.addColumn(P_CLOB);
    // ------------- Column: p_booleanint --------------------
        P_BOOLEANINT = new ColumnMap("p_booleanint", TABLE);
        P_BOOLEANINT.setType(new Integer(0));
        P_BOOLEANINT.setTorqueType("BOOLEANINT");
        P_BOOLEANINT.setUsePrimitive(true);
        P_BOOLEANINT.setPrimaryKey(false);
        P_BOOLEANINT.setNotNull(false);
        P_BOOLEANINT.setJavaName("PBooleanint");
        P_BOOLEANINT.setAutoIncrement(true);
        P_BOOLEANINT.setProtected(false);
        P_BOOLEANINT.setJavaType( "boolean" );
        P_BOOLEANINT.setPosition(21);
        TABLE.addColumn(P_BOOLEANINT);
    // ------------- Column: p_booleanchar --------------------
        P_BOOLEANCHAR = new ColumnMap("p_booleanchar", TABLE);
        P_BOOLEANCHAR.setType("");
        P_BOOLEANCHAR.setTorqueType("BOOLEANCHAR");
        P_BOOLEANCHAR.setUsePrimitive(true);
        P_BOOLEANCHAR.setPrimaryKey(false);
        P_BOOLEANCHAR.setNotNull(false);
        P_BOOLEANCHAR.setJavaName("PBooleanchar");
        P_BOOLEANCHAR.setAutoIncrement(true);
        P_BOOLEANCHAR.setProtected(false);
        P_BOOLEANCHAR.setJavaType( "boolean" );
        P_BOOLEANCHAR.setPosition(22);
        TABLE.addColumn(P_BOOLEANCHAR);
    // ------------- Column: p_double --------------------
        P_DOUBLE = new ColumnMap("p_double", TABLE);
        P_DOUBLE.setType(new Double(0));
        P_DOUBLE.setTorqueType("DOUBLE");
        P_DOUBLE.setUsePrimitive(true);
        P_DOUBLE.setPrimaryKey(false);
        P_DOUBLE.setNotNull(false);
        P_DOUBLE.setJavaName("PDouble");
        P_DOUBLE.setAutoIncrement(true);
        P_DOUBLE.setProtected(false);
        P_DOUBLE.setJavaType( "double" );
        P_DOUBLE.setPosition(23);
        TABLE.addColumn(P_DOUBLE);



        initDatabaseMap();
    }

    /**
     * Creates a new instance of the  implementation of the peer.
     *
     * @return the new instance.
     */
    protected static TypesPrimitivePeerImpl createTypesPrimitivePeerImpl()
    {
        TypesPrimitivePeerImpl instance = new TypesPrimitivePeerImpl();
        return instance;
    }


    /**
     * Returns an instance of the implementation of the peer.
     * If no instance is currently cached, a new instance is created and cached.
     *
     * @return an instance of the implementation of the peer, not null.
     */
    public static TypesPrimitivePeerImpl getTypesPrimitivePeerImpl()
    {
        TypesPrimitivePeerImpl peerImplInstance = typesPrimitivePeerImpl;
        if (peerImplInstance == null)
        {
            peerImplInstance = TypesPrimitivePeer.createTypesPrimitivePeerImpl();
            typesPrimitivePeerImpl = peerImplInstance;
        }
        return peerImplInstance;
    }



    /**
     * Sets the instance of the implementation of the peer.
     *
     * @param an instance of the implementation of the peer, or null
     *        if a new instance should be created automatically.
     */
    public static void setTypesPrimitivePeerImpl(TypesPrimitivePeerImpl peerImplInstance)
    {
        typesPrimitivePeerImpl = peerImplInstance;
    }


    /**
     * Get the list of objects for a ResultSet.  Please not that your
     * resultset MUST return columns in the right order.  You can use
     * getFieldNames() in BaseObject to get the correct sequence.
     *
     * @param resultSet the ResultSet
     * @return the list of objects
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<TypesPrimitive> resultSet2Objects(ResultSet resultSet)
            throws TorqueException
    {
        return getTypesPrimitivePeerImpl().resultSet2Objects(resultSet);
    }

    /**
     * Add all the columns needed to create a new object.
     *
     * @param criteria object containing the columns to add.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void addSelectColumns(Criteria criteria)
            throws TorqueException
    {
        getTypesPrimitivePeerImpl().addSelectColumns(criteria);
    }

    /**
     * changes the boolean values in the criteria to the appropriate type,
     * whenever a booleanchar or booleanint column is involved.
     * This enables the user to create criteria using Boolean values
     * for booleanchar or booleanint columns.
     *
     * @param criteria the criteria in which the boolean values
     *        should be corrected.
     *
     * @throws TorqueException if the database map for the criteria cannot be 
               obtained.
     */
    public static void correctBooleans(Criteria criteria) throws TorqueException
    {
        getTypesPrimitivePeerImpl().correctBooleans(criteria);
    }

    /**
     * Checks all columns in the criteria to see whether
     * booleanchar and booleanint columns are queried with a boolean.
     * If yes, the query values are mapped onto values the database
     * does understand, i.e. 0 and 1 for booleanints and N and Y for
     * booleanchar columns.
     *
     * @param columnValues The value to be checked for booleanint
     *        and booleanchar columns.
     * @throws TorqueException if the database map for the criteria cannot be
     *         retrieved.
     */
    public static void correctBooleans(
            ColumnValues columnValues)
        throws TorqueException
    {
        getTypesPrimitivePeerImpl().correctBooleans(columnValues);
    }
    
    /**
     * Selects TypesPrimitive objects from a database.
     *
     * @param criteria object used to create the SELECT statement.
     *
     * @return the list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<TypesPrimitive> doSelect(Criteria criteria)
            throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doSelect(criteria);
    }

    /**
     * Selects TypesPrimitive objects from a database
     * within a transaction.
     *
     * @param criteria object used to create the SELECT statement.
     * @param connection the connection holding the transaction, not null.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<TypesPrimitive> doSelect(
                Criteria criteria,
                Connection connection)
            throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doSelect(criteria, connection);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                Criteria criteria,
                RecordMapper<T> mapper)
            throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doSelect(criteria, mapper);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection for selecting records,
     *        not null.
     *
     * @return The results of the query, not null.
     * @throws TorqueException Error performing database query.
     */
    public static <T> List<T> doSelect(
            Criteria criteria,
            RecordMapper<T> mapper,
            Connection connection)
        throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doSelect(
                criteria,
                mapper,
                connection);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param query the sql query to execute, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param dbName The name of the database to create the connection for,
     *        or null for the default SDB.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                String query,
                RecordMapper<T> mapper,
                String dbName)
            throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doSelect(
                query,
                mapper,
                dbName);
    }

    /**
     * Selects rows from a database an maps them to objects.
     *
     * @param query the SQL Query to execute, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection, not null.
     *
     * @return The results of the query, not null.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> List<T> doSelect(
                String query,
                RecordMapper<T> mapper,
                Connection connection)
            throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doSelect(
                query,
                mapper,
                connection);
    }

    /**
     * Selects TypesPrimitive objects from the database which have
     * the same content as the passed object.
     *
     * @return The list of selected objects, not null.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static List<TypesPrimitive> doSelect(TypesPrimitive obj)
            throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doSelect(obj);
    }

    /**
     * Selects at most one TypesPrimitive object from a database.
     *
     * @param criteria object used to create the SELECT statement.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static TypesPrimitive doSelectSingleRecord(
                Criteria criteria)
            throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doSelectSingleRecord(criteria);
    }

    /**
     * Selects at most one TypesPrimitive object from a database
     * within a transaction.
     *
     * @param criteria object used to create the SELECT statement.
     * @param connection the connection holding the transaction, not null.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static TypesPrimitive doSelectSingleRecord(
                Criteria criteria,
                Connection connection)
            throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doSelectSingleRecord(criteria, connection);
    }

    /**
     * Selects at most a single row from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     *
     * @return The selected row, or null if no records was selected.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> T doSelectSingleRecord(
                org.apache.torque.criteria.Criteria criteria,
                RecordMapper<T> mapper)
            throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doSelectSingleRecord(
                criteria,
                mapper);
    }

    /**
     * Selects at most a single row from a database an maps them to objects.
     *
     * @param criteria A Criteria specifying the records to select, not null.
     * @param mapper The mapper creating the objects from the resultSet,
     *        not null.
     * @param connection the database connection, not null.
     *
     * @return The selected row, or null if no records was selected.
     *
     * @throws TorqueException if querying the database fails.
     */
    public static <T> T doSelectSingleRecord(
                org.apache.torque.criteria.Criteria criteria,
                RecordMapper<T> mapper,
                Connection connection)
            throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doSelectSingleRecord(
                criteria,
                mapper,
                connection);
    }

    /**
     * Selects at most one TypesPrimitive object from the database
     * which has the same content as the passed object.
     *
     * @return the selected Object, or null if no object was selected.
     *
     * @throws TorqueException If more than one record is selected or if
     *         an error occurs when processing the query.
     */
    public static TypesPrimitive doSelectSingleRecord(
                TypesPrimitive obj)
            throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doSelectSingleRecord(obj);
    }


    /**
     * Returns a new instance of the Data object class
     */
    public static TypesPrimitive getDbObjectInstance()
    {
        return getTypesPrimitivePeerImpl().getDbObjectInstance();
    }


    /**
     * Method to do inserts.
     *
     * @param columnValues the values to insert.
     *
     * @return always null (because the table does not have a primary key).
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static ObjectKey doInsert(ColumnValues columnValues) 
            throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doInsert(columnValues);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(Criteria) method.
     *
     * @param columnValues the values to insert.
     * @param con the connection to use, not null.
     *
     * @return always null (because the table does not have a primary key).
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static ObjectKey doInsert(ColumnValues columnValues, Connection con)
            throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doInsert(columnValues, con);
    }
    /**
     * Method to do inserts
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void doInsert(TypesPrimitive obj)
            throws TorqueException
    {
        getTypesPrimitivePeerImpl().doInsert(obj);
    }

    /**
     * Method to do inserts.  This method is to be used during a transaction,
     * otherwise use the doInsert(TypesPrimitive) method.  It will take
     * care of the connection details internally.
     *
     * @param obj the data object to insert into the database.
     * @param con the connection to use
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static void doInsert(TypesPrimitive obj, Connection con)
            throws TorqueException
    {
        getTypesPrimitivePeerImpl().doInsert(obj, con);
    }

    /**
     * Method to do updates.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(ColumnValues columnValues) throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doUpdate(columnValues);
    }

    /**
     * Method to do updates.  This method is to be used during a transaction,
     * otherwise use the doUpdate(Criteria) method.  It will take care of
     * the connection details internally.
     *
     * @param columnValues the values to update plus the primary key
     *        identifying the row to update.
     * @param con the connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(ColumnValues columnValues, Connection con)
        throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doUpdate(columnValues, con);
    }

    /**
     * Executes an update against the database. The rows to be updated
     * are selected using <code>criteria</code> and updated using the values
     * in <code>updateValues</code>.
     *
     * @param criteria selects which rows of which table should be updated.
     * @param updateValues Which columns to update with which values, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException if updating fails.
     */
    public static int doUpdate(
                Criteria selectCriteria,
                ColumnValues updateValues)
            throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doUpdate(
            selectCriteria,
            updateValues);
    }

    /**
     * Executes an update against the database. The rows to be updated
     * are selected using <code>criteria</code> and updated using the values
     * in <code>updateValues</code>.
     *
     * @param criteria selects which rows of which table should be updated.
     * @param updateValues Which columns to update with which values, not null.
     * @param connection the database connection to use, not null.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException if updating fails.
     */
    public static int doUpdate(
                Criteria criteria,
                ColumnValues updateValues,
                Connection connection)
            throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doUpdate(
            criteria,
             updateValues,
              connection);
    }

    /**
     * Updates an TypesPrimitive in the database.
     * The primary key is used to identify the object to update.
     *
     * @param obj the data object to update in the database.
     *
     * @return the number of affected rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(TypesPrimitive obj) throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doUpdate(obj);
    }

    /**
     * Updates a TypesPrimitive in the database.
     * The primary key is used to identify the object to update.
     * This method is to be used during a transaction,
     * otherwise the doUpdate(TypesPrimitive) method can be used.
     *
     * @param obj the data object to update in the database.
     * @param con the connection to use, not null.
     
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doUpdate(TypesPrimitive obj, Connection con)
        throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doUpdate(obj, con);
    }

    /**
     * Utility method which executes a given SQL statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the SQL statement to execute.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString)
            throws TorqueException
    {
        return getTypesPrimitivePeerImpl().executeStatement(statementString);
    }

    /**
     * Utility method which executes a given sql statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the sql statement to execute.
     * @param dbName Name of database to connect to.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString, String dbName)
            throws TorqueException
    {
        return getTypesPrimitivePeerImpl().executeStatement(statementString, dbName);
    }

    /**
     * Utility method which executes a given sql statement.  This
     * method should be used for update, insert, and delete
     * statements.
     *
     * @param statementString A String with the sql statement to execute.
     * @param con A Connection.
     * @return The number of rows affected.
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int executeStatement(String statementString, Connection con)
            throws TorqueException
    {
        return getTypesPrimitivePeerImpl().executeStatement(statementString, con);
    }

    /**
     * Deletes rows from a database table.
     *
     * @param criteria defines the rows to be deleted, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
     public static int doDelete(Criteria criteria) throws TorqueException
     {
        return getTypesPrimitivePeerImpl().doDelete(criteria);
     }

    /**
     * Deletes rows from a table.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
    *
     * @param criteria defines the rows to be deleted, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
     public static int doDelete(Criteria criteria, Connection con)
        throws TorqueException
     {
        return getTypesPrimitivePeerImpl().doDelete(criteria, con);
     }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     *
     * @param obj the data object to delete in the database, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(TypesPrimitive obj) throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doDelete(obj);
    }

    /**
     * Deletes a data object, i.e. a row in a table, in the database.
     * This method uses the passed connection to delete the rows;
     * if a transaction is open in the connection, the deletion happens inside
     * this transaction.
     *
     * @param obj the data object to delete in the database, not null.
     * @param con the connection to use, not null.
     *
     * @return the number of deleted rows.
     *
     * @throws TorqueException Any exceptions caught during processing will be
     *         rethrown wrapped into a TorqueException.
     */
    public static int doDelete(TypesPrimitive obj, Connection con)
        throws TorqueException
    {
        return getTypesPrimitivePeerImpl().doDelete(obj, con);
    }


    /** 
     * Build a Criteria object from the data object for this peer.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public static Criteria buildCriteria(TypesPrimitive obj)
    {
        return getTypesPrimitivePeerImpl().buildCriteria(obj);
    }

    /** 
     * Build a Criteria object from the data object for this peer,
     * skipping all binary columns.
     *
     * @param obj the object to build the criteria from, not null.
     */
    public static Criteria buildSelectCriteria(TypesPrimitive obj)
    {
        return getTypesPrimitivePeerImpl().buildSelectCriteria(obj);
    }

    /** 
     * Returns the contents of the object as ColumnValues object
     *
     * @throws TorqueException if the table map cannot be retrieved
     *         (should not happen).
     */
    public static ColumnValues buildColumnValues(TypesPrimitive typesPrimitive)
            throws TorqueException
    {
        
        return getTypesPrimitivePeerImpl().buildColumnValues(typesPrimitive);
    }







    /** 
     * Returns the chunk size for the filler methods.
     *
     * @return the chunk size for the filler methods.
     */
    protected static int getFillerChunkSize()
    {
        return getTypesPrimitivePeerImpl().getFillerChunkSize();
    }

    /**
     * Returns the TableMap related to this peer.
     *
     * @return the table map, not null.
     *
     * @throws TorqueException if the Peer instance does not hold a Table map.
     */
    public static TableMap getTableMap()
        throws TorqueException
    {
        return getTypesPrimitivePeerImpl().getTableMap();
    }

    public static void initDatabaseMap()
    {
        BaseBookstoreDatabaseMapInit.init();
    }


}
